subroutine map_polar(line,comm,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  !     Support for command
  !   MAP_POLAR NameBegin NameEnd /COMPUTE Threshold
  !     [/BACKGROUND Type Min Max] [/STEP Step Xfirst Yfirst]
  !
  ! Withe /COMPUTE, derive 
  !   1) Polarized fraction
  !   2) Polarization angle
  ! from I,Q,U (and V ?) polarization images
  !
  ! Without, display the polarization maps as controlled by the options
  !   /BACKGROUND and /STEP
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line, comm
  logical, intent(inout) :: error  
  !
  ! Global or remanent
  real, parameter :: pi=acos(-1.0)
  integer, parameter :: o_back=1
  integer, parameter :: o_compute=2
  integer, parameter :: o_step=3
  character(len=*), parameter :: rname='MAP_POLAR'
  !
  character(len=filename_length) :: query
  character(len=filename_length), save :: stokes=' '  ! Begin of name
  character(len=32), save :: ctype='.lmv-clean'       ! End of name
  real, save :: threshold=10              ! 10 sigma detection level
  integer, save :: step=0, ibeg=1, jbeg=1 ! /STEP option
  real, save :: scale(2)=[0.,0.]          ! /BACK scale values 
  character(len=1) :: cback='I' !         ! /BACK Image
  logical, save :: defined=.false.
  character(len=24), save :: chead
  !
  ! Local
  character(len=128) :: chain
  integer :: n, nx, ny, ic, ier
  type(gildas) :: hi, hu, hq, hf, ha, htmp
  real(8), allocatable :: ap(:,:)    ! 4 columns array for ARROWS
  real :: seuil, pnoise, p2, pa
  integer :: ip, ix, iy, jy, nk, kstep
  real(8) :: rstep
  integer(kind=index_length) :: dim(2)
  logical :: err
  !---------------------------------------------------------------------
  err = .false.
  !
  ic = 1 ! So far, only 1st channel
  ! Code:
  query =  ' '
  call sic_ch(line,0,1,query,n,.false.,error)
  if (error) return
  call sic_ch(line,0,2,ctype,n,.false.,error)
  if (error) return  
  !
  if (defined) then
    call sic_delvariable('POLAR_BACK',.false.,error)
    call sic_delvariable('POLAR_VECTOR',.false.,error)
    call sic_delvariable('POLAR_HEAD',.false.,error)
    error = .false.
    defined = .false.
  endif
  !
  if (sic_present(o_compute,0)) then
    if (sic_present(0,1)) stokes = query
    !
    ! Compute the Polarization Fraction and Angle
    call sic_r4(line,o_compute,2,threshold,.false.,error)
    if (error) return
    !
    call gildas_null(hi)
    call gildas_null(hu)
    call gildas_null(hq)
    call gildas_null(hf)
    call gildas_null(ha)
    !
    hi%file = trim(stokes)//'-I'//ctype
    hu%file = trim(stokes)//'-U'//ctype
    hq%file = trim(stokes)//'-Q'//ctype
    !
    call gdf_read_header(hi,error)
    if (error) return
    call gdf_read_header(hu,error)
    if (error) return
    call gdf_read_header(hq,error)
    if (error) return
    if (hi%gil%ndim.ne.3) then
      call gdf_trim_header(hi,3,error)
      if (error) return
      call gdf_trim_header(hu,3,error)
      if (error) return
      call gdf_trim_header(hq,3,error)
      if (error) return
    endif
    !
    call gdf_copy_header(hi,hf,error)
    if (error) return
    call gdf_copy_header(hi,ha,error)
    if (error) return
    hf%file = trim(stokes)//'-P'//ctype
    ha%file = trim(stokes)//'-A'//ctype
    !
    call gdf_allocate(hi,error)
    if (error) return
    call gdf_allocate(hu,error)
    if (error) return
    call gdf_allocate(hq,error)
    if (error) return
    call gdf_allocate(hf,error)
    if (error) return
    call gdf_allocate(ha,error)
    if (error) return
    !
    call gdf_read_data(hi,hi%r3d,error)
    if (error) err = .true.
    call gdf_read_data(hu,hu%r3d,error)
    if (error) err = .true.
    call gdf_read_data(hq,hq%r3d,error)
    if (error) err = .true.
    !
    ! The images are loaded now
    call gdf_close_image(hi,error)
    call gdf_close_image(hu,error)
    call gdf_close_image(hq,error)
    !
    ! But some may have been missed
    if (err) then
      error = .true.
      return
    endif
    !
    seuil = threshold*max(hi%gil%rms,hi%gil%noise)
    !
    pnoise = max(hu%gil%noise,hu%gil%rms) * max(hq%gil%noise,hq%gil%rms) 
    pnoise = 2.0*pnoise  ! Sum of sigma^2 
    !
    do ip=1,hi%gil%dim(3)
      do iy=1,hi%gil%dim(2)    
        do ix=1,hi%gil%dim(1)
          if (hi%r3d(ix,iy,ip).gt.seuil) then
            ! Get the fractional polarization
            !
            ! Low S/N involves finding the maximum of the Rice distribution, which includes
            ! a Gaussian and a 1st order Bessel function (See Vaillancourt 2006, Eq.6,
            !   https://arxiv.org/pdf/astro-ph/0603110.pdf)
            !
            ! Lower confidence intervals are bound to 0 at the 68, 95 and 99 % levels (1,2,3 sigma) for 
            ! p2/pnoise < 1.7, 2.4 and 3.0 respectively. 
            ! 
            ! Upper confidence interval at 95 to 99 % is obtained by simply using p2+2*pnoise
            ! 
            p2 = hu%r3d(ix,iy,ip)**2 + hq%r3d(ix,iy,ip)**2
            if (p2.lt.pnoise) then
              ! At low S/N, the polarisation is Zero. The maximum likelihood method
              ! yields this for p2/pnoise < sqrt(2)
              ! We use this only below 1 sigma, because it provides continuity with the de-biased limit.
              hf%r3d(ix,iy,ip) = 0
              ha%r3d(ix,iy,ip) = -2.*pi
            else
              ! At higher S/N (above 3 sigma), a simple de-biasing is acceptable. 
              ! Above 4 sigma, it yields an almost Gaussian noise.
              !
              ! We use this debiasing above 1 sigma, because it provides continuity with the previous case.
              p2 = sqrt(p2-pnoise)          ! De-bias the polarized intensity, high S/N approximation
              hf%r3d(ix,iy,ip) = p2/hi%r3d(ix,iy,ip)  ! Go to fraction
              !
              ! Polarization angle is atan(U/Q)/2 in the [0,pi[ domain
              ! see Hull & Plambeck 2015, DOI:10.1142/S2251171715500051
              pa = atan2(hu%r3d(ix,iy,ip),hq%r3d(ix,iy,ip)) 
              if (pa.lt.0) pa = pa+2*pi
              ha%r3d(ix,iy,ip) = 0.5*pa 
              !
              ! The error term is pnoise/(2*p2) on this angle, and could be stored elsewhere...
            endif
          else
            hf%r3d(ix,iy,ip) = 0
            ha%r3d(ix,iy,ip) = -2.*pi
          endif
        enddo
      enddo
    enddo
    !
    hf%r3d = 100.0*hf%r3d
    hf%gil%bval = 0.
    hf%gil%eval = 0.
    hf%char%unit= 'Percent'
    call cube_minmax('FRACTION',hf,error)
    !
    ha%gil%bval = -2.*pi
    ha%gil%eval = 0.1*pi
    call cube_minmax('ANGLE',ha,error)
    !
    call gdf_write_image(hf,hf%r3d,error)
    if (error) return
    ha%char%unit= 'ANGLE'
    call gdf_write_image(ha,ha%r3d,error)
    !
    step = 0
    ibeg = 1
    jbeg = 1 ! /STEP option
    cback ='I' !         ! /BACK Image
    scale = 0
    call map_message(seve%i,rname,"Display control parameters reset to Default")
  else if (query(1:2).eq.'? ') then
    !
    write(*,*) "  --- Current MAP_POLAR behaviour control values ---"
    write(*,'(A)')   "  Data files      "//trim(stokes)//'-?'//trim(ctype)
    write(*,'(A,I0,A,I0,1X,I0)')   "  Pixel step ",step," Start ",ibeg,jbeg
    if (cback.eq.'I') then
      write(*,'(A)') "  Displayed image : Total Intensity       (I)"
    else if (cback.eq.'P') then
      write(*,'(A)') "  Displayed image : Polarized Intensity   (P)"
    else if (cback.eq.'F') then
      write(*,'(A)') "  Displayed image : Polarization Fraction (F) in %"
    endif
    write(*,*)  " Color scale range ",scale
  else
    if (sic_present(0,1)) stokes = query
    !
    ! Display  the results
    call gildas_null(hf)
    call gildas_null(ha)
    hi%file = trim(stokes)//'-I'//ctype
    hf%file = trim(stokes)//'-P'//ctype
    ha%file = trim(stokes)//'-A'//ctype
    !
    call gdf_read_header(hi,error)
    if (error) return
    call gdf_read_header(hf,error)
    if (error) return
    call gdf_read_header(ha,error)
    if (error) return
    if (hi%gil%ndim.ne.3) then
      call gdf_trim_header(hi,3,error)
      if (error) return
      call gdf_trim_header(hf,3,error)
      if (error) return
      call gdf_trim_header(ha,3,error)
      if (error) return
    endif
    !
    ! /STEP option
    if (sic_present(o_step,0)) then
      call sic_i4(line,o_step,1,step,.false.,error)
      if (error) return
      call sic_i4(line,o_step,2,ibeg,.false.,error)
      if (error) return
      call sic_i4(line,o_step,3,jbeg,.false.,error)
      if (error) return
    endif
    !
    if (step.eq.0) then
      ! A bit less than 1 beam size 
      rstep = sqrt(abs(hi%gil%majo*hi%gil%mino/hi%gil%inc(1)/hi%gil%inc(2)))/1.4 
      kstep = nint(rstep)
    else
      kstep = step
    endif
    write(chain,'(A,I0)') "@ p_show_polar ",kstep
    !
    ! /BACK option
    if (sic_present(o_back,0)) then
      !  [/BACKGROUND Type Min Max]
      call sic_ke(line,o_back,1,cback,n,.false.,error)
      if (error) return
      call sic_r4(line,o_back,2,scale(1),.false.,error)
      if (error) return
      call sic_r4(line,o_back,3,scale(2),.false.,error)
      if (error) return
    endif
    n = len_trim(chain)+1
    write(chain(n:),'(1X,1PG15.7,1X,1PG15.7)') scale(1),scale(2)
    !
    ! Data and intermediate arrays
    call gdf_allocate(hi,error)
    if (error) return
    call gdf_allocate(hf,error)
    if (error) return
    call gdf_allocate(ha,error)
    if (error) return
    !
    call gdf_read_data(hi,hi%r3d,error)
    if (error) err = .true.
    call gdf_read_data(hf,hf%r3d,error)
    if (error) err = .true.
    call gdf_read_data(ha,ha%r3d,error)
    if (error) err = .true.
    call gdf_close_image(hi,error)
    call gdf_close_image(hf,error)
    call gdf_close_image(ha,error)
    if (err) then
      error = .true.
      return
    endif
    !
    ic = 1 ! Channel to be specified later
    nx = ha%gil%dim(1)
    ny = ha%gil%dim(2)
    nk = 0
    do jy = jbeg,ny,kstep
      do ix = ibeg,nx,kstep
        if (hf%r3d(ix,jy,ic).ne.0) then
          nk = nk+1
        endif
      enddo
    enddo
    allocate(ap(nk,4),stat=ier)
    !
    nk = 0
    do jy = jbeg,ny,kstep
      do ix = ibeg,nx,kstep
        if (hf%r3d(ix,jy,ic).ne.0) then
          nk = nk+1
          ap(nk,1) = (ix-hi%gil%ref(1))*hi%gil%inc(1)+hi%gil%val(1)
          ap(nk,2) = (jy-hi%gil%ref(2))*hi%gil%inc(2)+hi%gil%val(2)
          ap(nk,3) = hf%r3d(ix,jy,ic)*hi%r3d(ix,jy,ic)
          ap(nk,4) = ha%r3d(ix,jy,ic)
        endif
      enddo
    enddo
    !
    call gildas_null(htmp)
    select case (cback)
    case('I') 
      call gdf_copy_header(hi,htmp,error)
      htmp%r2d => hi%r3d(:,:,ic)
      chead = "Total Intensity"
    case('F') 
      call gdf_copy_header(hf,htmp,error)
      htmp%r2d => hf%r3d(:,:,ic)
      chead = "Polar Fraction %"
    case('P')
      call gdf_copy_header(hi,htmp,error)
      allocate(htmp%r2d(nx,ny),stat=ier)
      htmp%r2d = hi%r3d(:,:,ic)*hf%r3d(:,:,ic)/100
      chead = "Polar Intensity"
    case default
      error = .true.
      return
    end select
    htmp%gil%ndim = 2
    htmp%loca%addr = locwrd(htmp%r2d)
    call gdf_get_extrema (htmp,error)
    call sic_mapgildas('POLAR_BACK',htmp,error,htmp%r2d)
    !
    dim = [nk,4]
    call sic_def_dble('POLAR_VECTOR',ap,2,dim,.true.,error)
    defined = .true.
    call sic_def_char('POLAR_HEAD',chead,.true.,error)
    !
    call exec_program(chain)
    !
  endif
  !
  error = .false.
end subroutine map_polar

module mod_kepler
  use image_def
  type(gildas), save, target :: hvelo
  type(gildas), save, target :: hkpv
  !
  integer, parameter :: o_hfs=1
  integer, parameter :: o_mask=2
  integer, parameter :: o_reset=3
  integer, parameter :: o_funct=4
  integer, parameter :: o_vdisk=5
  integer, parameter :: o_widget=6
  !
  integer :: kep_nchan=0
  integer :: kep_nrad=0
  !
  logical :: kepler_setup=.true.
  logical :: kepler_usevdisk=.false.
  real(8) :: kepler_x0 = 0.
  real(8) :: kepler_y0 = 0.
  real(8) :: kepler_rota = 0.
  real(8) :: kepler_incli= 30.
  real(8) :: kepler_vmass= 2.5
  real(8) :: kepler_vdisk= 0.
  real(8) :: kepler_rint=50.
  real(8) :: kepler_rmin=50.
  real(8) :: kepler_rout=500.
  real(8) :: kepler_rmax=800.
  real(8) :: kepler_dist=150.
  real(8) :: kepler_step=50.
  real(8) :: kepler_theta=60.
  real(8) :: kepler_azimut(2)=[0d0,360d0]
  !
  real(8), allocatable :: kep_spectrum(:,:)
  real(8), allocatable :: kep_profile(:,:)
  real(4), allocatable, save, target :: kep_spectra(:,:)
  !
  logical :: kepler_usefunc=.false.
  character(len=256) :: kepler_func,kepler_expr
  character(len=32) :: kepler_variable
end module mod_kepler
!
subroutine kepler_comm(line,comm,quiet,error)
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, only : sub_readhead, map_message
  use clean_default
  use clean_arrays
  use gbl_message
  use mod_kepler
  use iso_c_binding
!-----------------------------------------------------------------------
! @ private
! IMAGER
!
!   Support for command
!   KEPLER [?|DataCube|SHOW Arg] [/VSYSTEM Value] [/RESET [Script]
!     [/VELOCITY R function(R)] [/MASK [File]] [/HFS [File.hfs]]
!     [/WIDGET]
!
! Input parameters
!     KEPLER_X0   KEPLER_Y0     Center of disk (arcsec)
!     KEPLER_ROTA KEPLER_INCLI  Orientation, Inclination in °
!     KEPLER_VMASS              Rotation velocity at 100 au (km/s)
!     KEPLER_VDISK              Disk velocity (km/s)
!     KEPLER_DIST               Distance (pc)
!     KEPLER_ROUT               Outer radius (au) for the Spectrum
!     KEPLER_RINT               Inner radius (au) ...
!     KEPLER_RMIN               Minimum radius (au) for the profile
!     KEPLER_RMAX               Maximum radius (au) for the profile
!     KEPLER_STEP               Radial sampling (au)
!     KEPLER_THETA              Maximum angle from major axis in °
!     KEPLER_AZIMUT[2]          Valid Azimut range (°)
! Input data
!     CLEAN Image (by default) or specified data cube
! Output data
!     Integrated spectral line profile, with error bars
!     Radial profile at line center
!     Radius-Velocity diagram ("teardrop" plot)
!
! Open issues:
!     Should the profile be radially weighted ?
!     How ?
!-----------------------------------------------------------------------
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: comm
  logical, intent(inout) :: quiet
  logical, intent(out) :: error
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='KEPLER'
  !
  character(len=filename_length), save :: dtype='CLEAN'
  character(len=filename_length) :: stype, csetup, name
  character(len=8) :: utype
  character(len=32) :: topic 
  character(len=64) :: chain
  integer :: ns, nc, n1, n2, nt, i
  character(len=1), parameter :: question_mark='?'
  !
  type(gildas) :: hmap
  real, allocatable :: data(:,:,:)
  logical :: is_image, rdonly, lexist, lerr
  logical :: do_reset, do_mask, do_some, do_funct, do_vdisk, do_hfs
  type(c_ptr) :: cptr
  real(4), pointer :: r3ptr(:,:,:)
  integer :: ier,n
  type (sic_descriptor_t) :: desc
  logical :: found
  real :: hfs_tau
  !
  error = .false.
  do_vdisk = sic_present(o_vdisk,0)
  do_reset = sic_present(o_reset,0)
  do_mask  = sic_present(o_mask,0)
  do_funct = sic_present(o_funct,0)
  do_hfs = sic_present(o_hfs,0)
  do_some = do_mask.or.do_funct.or.do_vdisk
  !
  quiet = .true.
  if (kepler_setup) then
    call kepler_init(error)
    if (error) then
      call map_message(seve%e,rname,'Initialisation error, remove all KEPLER* variables')
      return
    endif
  endif
  !
  ! /WIDGET option
  if (sic_present(o_widget,0)) then
    do i=1,o_widget-1 
      if (sic_narg(i).ge.0) error = .true.
    enddo
    if (error) then
      call map_message(seve%e,rname,'No other option allowed with /WIDGET')
    endif
    if (sic_narg(0).ne.0) then
      call map_message(seve%e,rname,'No argument allowed with /WIDGET option')
      error = .true.
    endif
    if (error) return
    !
    call exec_program('@ d_kepler')
    call exec_program('@ x_kepler')
    return
  endif
  !
  ! Normal command
  if (sic_narg(0).eq.0) stype = dtype
  if (sic_present(o_reset,1)) then
    call sic_ch(line,0,1,stype,ns,.false.,error)
    if (error) return
    call sic_ch(line,o_reset,1,name,nc,.true.,error)
    if (error) return
    lexist = sic_findfile(name,csetup,' ','.ima')
    if (lexist) then
      call exec_program('@ '//trim(csetup))  
    else
      call map_message(seve%e,rname,'No such file '//trim(csetup))
      error = .true.
      return 
    endif
  else if (sic_narg(0).ge.1) then
    call sic_ch(line,0,1,stype,ns,.true.,error)
    if (error) return  
  endif
  !
  if (sic_narg(0).eq.1) then
    utype = stype
    call sic_upper(utype)
    if ((utype.eq.question_mark).or.(utype.eq.'INIT')) then
      if (do_some.or.do_hfs) then
        call map_message(seve%e,rname,'Option not allowed with KEPLER ?')
        error = .true.
        return
      endif
      if (utype.eq.'?') call exec_program('@ i_kepler') 
      ! Initialise KEPLER_SHOW variables
      call exec_program('@ d_kepler')
      if (.not.do_reset) return
    endif
    !
  else if (sic_narg(0).eq.2) then
    if (stype.eq.question_mark) then
      call sic_ch(line,0,2,topic,nt,.true.,error)
      chain = 'HELP  KEPLER '//topic
      call exec_program(chain)
      return        
    endif
    !
    call sic_ke(line,0,1,utype,ns,.true.,error)
    if (utype.eq.'SHOW') then
      if (do_some) then
        call map_message(seve%e,rname,'Option not allowed with KEPLER SHOW')
        error = .true.
        return
      endif
      ! KEPLER SHOW Arg
      call sic_ke(line,0,2,stype,ns,.true.,error)
      if (error) return 
      !
      ! /HFS or not ?
      call sic_descriptor('HFS',desc,found)
      if (do_hfs) then
        if (sic_present(o_hfs,1)) then
          call sic_ch(line,o_hfs,1,name,ns,.true.,error)  
          if (error) return
          MappingError = .true.
          if (sic_narg(o_hfs).eq.1) then      
            call exec_program('@ kepler_hfs '//name(1:ns))
          else
            call sic_r4(line,o_hfs,2,hfs_tau,.true.,error)
            if (error) return
            write(chain,*) hfs_tau
            call exec_program('@ kepler_hfs '//name(1:ns)//trim(chain))
          endif
          if (MappingError) then
            error = .true.
            return
          endif
          MappingError = .true. ! We will again call a script
        else if (.not.found) then
          call map_message(seve%e,rname,'No Hyperfine structure defined, see HELP KEPLER /HFS')
          error = .true.
          return
        endif
      else if (found) then
        call sic_delvariable('HFS',.true.,error)
      endif
      !
      if (stype.eq.'VELO') then
        call exec_program('SHOW KEPLER_VELO')
      else
        call exec_program('SHOW KEPLER '//stype(1:ns)) 
      endif
      return
    else
      call sic_ch(line,0,1,topic,nt,.true.,error)
      stype = ' '
      call sic_ch(line,0,2,stype,nt,.true.,error)
      if (stype.eq.question_mark) then
        chain = 'HELP  KEPLER '//topic
        call exec_program(chain)
      else
        call map_message(seve%e,rname,'Invalid syntax, expected KEPLER SHOW Something or KEPLER SomeThing ?')
        error = .true.
      endif
      ! Initialise KEPLER_SHOW variables
      call exec_program('@ d_kepler')
      return
    endif
  else if (do_hfs) then
    call map_message(seve%e,rname,'Option /HFS only valid with KEPLER SHOW Something')
    error = .true.
    return  
  endif
  !
  error = .false.
  if (kep_nchan.ne.0) then
    ! Delete in Reverse order - Otherwise there is a bug: KEPLER_SPECTRUM inherit a (wrong) header
    call sic_delvariable ('KEPLER_VELO',.false.,error)
    call sic_delvariable ('KEPLER_PV',.false.,error)
    call sic_delvariable ('KEPLER_PROFILE',.false.,error)
    call sic_delvariable ('KEPLER_SPECTRUM',.false.,error)
    deallocate(kep_profile,kep_spectrum,kep_spectra,hvelo%r2d) 
    kep_nchan = 0
    kep_nrad = 0
  endif
  call gildas_null(hvelo)
  error = .false.
  if (do_reset) return
  !
  quiet = .false.
  !
  ! Attempt to define the velocity function
  !
  if (do_funct) then
    !
    ! Get arguments first
    call sic_ke(line,o_funct,1,kepler_func,n1,.true.,error)
    if (error) return
    kepler_func = 'KEPLER_LAW('//kepler_func(1:n1)//')'
    n1 = n1+12
    call sic_ke(line,o_funct,2,kepler_expr,n2,.true.,error)
    !
    ! The function below is PRIVATE unfortunately
    ! call sic_del_expr('KEPLER_LAW',10,error)
    if (kepler_usefunc) then
      ! DELETE is not in "sic°_libr" cases yet
      name = 'DELETE /FUNCTION KEPLER_LAW'
      call exec_command(name,error) 
      error = .false. ! Ignore previous error if any
    endif
    !
    ! The function below is PRIVATE unfortunately
    ! sic_def_expr (kepler_func,n1,kepler_expr,n2,error)
    call sic_libr('DEFINE FUNCTION '//kepler_func(1:n1)//' '//kepler_expr(1:n2),error)
    if (error) return
    kepler_usefunc = .true.
    call map_message(seve%w,rname,'Using rotation law ' &
      & //kepler_func(1:n1)//' = '//kepler_expr(1:n2),3)
  else
    if (kepler_usefunc) then
      name = 'DELETE /FUNCTION KEPLER_LAW'
      call exec_command(name,error) 
      error = .false. ! Ignore previous error if any
    endif
    kepler_usefunc = .false.
  endif
  !
  ! Read the Image / Data file header
  dtype = stype
  call gildas_null(hmap)
  is_image = .false.
  rdonly =  .not.do_mask  !! .true.
  call sub_readhead(rname,stype,hmap,is_image,error,rdonly,fmt_r4)
  if (error) return
  !
  ! Verify shape conformance
  if ((hmap%gil%ndim.ne.3).or.(hmap%gil%faxi.ne.3)) then
    call map_message(seve%e,rname,trim(stype)//' is not a LMV cube')
    error = .true.
    return
  endif
  !
  if (do_mask) then
    Print *,'Allocating MASK'
    ! Allocate the Mask as needed here
    if (sic_present(o_mask,1)) then
      allocate(data(hmap%gil%dim(1),hmap%gil%dim(2),hmap%gil%dim(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Data cube allocation error')
        error = .true.
        return
      endif 
      ! There is some logic error in case of MASK and IMAGE
      call sic_ch(line,o_mask,1,name,n,.true.,error)
      if (error) return
      call kepler_mask(line,hmap,data,error)
      call sic_parse_file(name,' ','.msk',hmap%file)    
      call gdf_write_image(hmap,data,lerr)
    else
      call sic_delvariable ('MASK',.false.,error)
      if (allocated(dmask)) deallocate(dmask)
      call gdf_copy_header(hmap,hmask,error)
      if (error) return
      allocate(dmask(hmap%gil%dim(1),hmap%gil%dim(2),hmap%gil%dim(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Data cube allocation error')
        error = .true.
        return
      endif 
      call kepler_mask(line,hmask,dmask,error)
      call sic_mapgildas ('MASK',hmask,error,dmask)
    endif
  else if (is_image) then
    Kepler_Variable = stype
  else if (.not.is_image) then 
    Kepler_Variable = 'FILE'
    ! Read the data file if specified
    allocate(data(hmap%gil%dim(1),hmap%gil%dim(2),hmap%gil%dim(3)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Data cube allocation error')
      error = .true.
      return
    endif
    !!Print *,'Reading HMAP data '
    call gdf_read_data(hmap,data,error)
    call gdf_close_image(hmap,lerr)
    if (error) then
      call map_message(seve%e,rname,'Data cube read error')
      error = .true.      
      return
    endif
  endif
  !
  ! Do the job
  if (.not.do_mask) then
    !!Print *,'Calling KEPLER_COMPUTE ',hmap%loca%addr, is_image
    if (is_image) then
      call adtoad(hmap%loca%addr,cptr,1)
      call c_f_pointer(cptr,r3ptr,hmap%gil%dim(1:3))
      call kepler_compute(line,hmap,r3ptr,error)
    else
      call kepler_compute(line,hmap,data,error)
    endif
  endif
  !!Print *,'Done KEPLER_COMPUTE or KEPLER_MASK ',is_image
  !
  if (kepler_usefunc) then
    !!Print *,'Deleting KEPLER_CURRENT'
    call sic_delvariable('KEPLER_CURRENT',.false.,lerr)
    call sic_delvariable('KEPLER_VPROJ',.false.,lerr)
    !!Print *,'Deleted KEPLER_VPROJ'
  endif
  ! Initialise KEPLER_SHOW variables
  call exec_program('@ d_kepler')
end subroutine kepler_comm

subroutine kepler_compute(line,hmap,data,error)
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, except_this => kepler_compute
  use clean_arrays
  use gbl_message
  use mod_kepler
  !$ use omp_lib
!-----------------------------------------------------------------------
! @ private
! IMAGER
!
!   Support for command
!   KEPLER [Arg] [/VSYSTEM Value] [/VELOCITY R function(R)]
!
! Output data
!     Integrated spectral line profile, with error bars
!     Radial profile at line center
!     Spectral profiles as a function of radius, with error bars
!
!-----------------------------------------------------------------------
  character(len=*), intent(in) :: line ! Command line
  type(gildas), intent(inout) :: hmap
  real, intent(in) :: data(hmap%gil%dim(1),hmap%gil%dim(2),hmap%gil%dim(3))
  logical, intent(out) :: error
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='KEPLER'
  !
  real(8) :: cospa, sinpa, cosi, sini
  real(8) :: offx, offy, offmax, offmin, sec
  real(8) :: xoff, yoff, roff, x0, y0
  real(8) :: xinc, xval, xref
  real(8) :: yinc, yval, yref
  real :: bval, rstep
  integer(kind=index_length) :: np, xdim, ydim, ic1, icn
  real, allocatable :: x(:,:), y(:,:), s(:,:), t(:), r(:), v(:)
  integer, allocatable :: n(:,:), m(:)
  real, allocatable :: rwork(:,:)
  integer, allocatable :: iwork(:,:)
  logical :: blanked
  integer :: ix, jy, iv, kv, is, ie, ier, istep, nstep, mstep, fstep, lstep
  integer :: nx, ny, nv, iloc(1)
  real :: radius, theta, thetamax, vproj, vsini, theta_min, theta_max
  real :: jyperk, beam_area, factor, z, circum
  integer(kind=address_length) :: dim(7)
  logical :: strict
  integer :: je, js
  character(len=80) :: chain
  !
  integer :: ithread, nthread
  real, allocatable :: ss(:,:,:)
  integer, allocatable :: nn(:,:,:)
  !
  sec = pi/180/3600   ! Second to Radian
  !
  if (sic_present(o_vdisk,0)) then
    call sic_r8(line,o_vdisk,1,kepler_vdisk,.false.,error)
    kepler_usevdisk = .true.
  else
    kepler_usevdisk = .false.
  endif
  if (kepler_usefunc) then
    call sic_def_real('Kepler_Vproj',vproj,0,dim,.false.,error)
    call sic_def_real('Kepler_Current',radius,0,dim,.false.,error)
  endif
  !
  ! Do yo keep the spectrum if you have a full coverage (STRICT=YES)
  ! or only a partial coverage of the total velocity extent in the
  ! Radius - Velocity diagram ?
  !   The default is "lousy", i.e. partial coverage is allowed,
  strict = .false.
  call sic_get_logi('KEPLER_STRICT',strict,error)
  !
  call gdf_copy_header(hmap,hvelo,error)
  if (error) return
  hvelo%gil%ndim = 2
  hvelo%gil%dim(3) = 1
  hvelo%gil%convert(:,3) = 1.
  hvelo%char%unit = 'km/s'
  !
  thetamax = kepler_theta*pi/180
  !
  theta_min = kepler_azimut(1)
  theta_max = kepler_azimut(2)
  !
  cospa = cos(pi*kepler_rota/180)
  sinpa = sin(pi*kepler_rota/180)
  sini = sin(kepler_incli*pi/180)
  cosi = cos(kepler_incli*pi/180)
  !
  vsini = kepler_vmass * sini
  !
  ! Compute the Radial Sampling size
  rstep = (kepler_rout-kepler_rmin)/kepler_step
  nstep = int(rstep)
  if (real(nstep).ne.rstep) nstep = nstep+1
  !
  ! Rmax is by default Rout + 5 Steps
  kepler_rmax = 0
  call sic_get_dble('KEPLER_RMAX',kepler_rmax,error)
  if (kepler_rmax.le.kepler_rout) kepler_rmax = kepler_rmin+(nstep+5)*kepler_step
  mstep =   nint((kepler_rmax-kepler_rmin)/kepler_step)
  !
  offmin = kepler_rmin/kepler_dist*sec
  offmax = (kepler_rmin + mstep*kepler_step)/kepler_dist*sec 
  !!Print *,'NSTEP ',nstep,kepler_step,kepler_rint,kepler_rout,kepler_rmax
  !!Print *,'Offmin ',offmin, offmin/sec*kepler_dist
  !
  yinc = hmap%gil%inc(3)
  yref = hmap%gil%ref(3)
  yval = hmap%gil%val(3)
  !
  xref = yref
  xinc = yinc
  xdim = hmap%gil%dim(3)
  ydim = xdim
  ic1 = 1
  icn = hmap%gil%dim(3)
  np = 1
  !
  allocate (x(1,xdim),y(1,ydim),s(xdim,mstep),n(xdim,mstep),t(xdim), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  allocate (r(mstep), m(xdim), v(xdim), iwork(2,xdim), rwork(4,xdim), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  !
  ! Radial sampling
  !!Print *,'XDIM ',xdim,' MSTEP ',mstep
  do is=1,mstep
    r(is) = kepler_rmin + kepler_step*(is-0.5)
  enddo
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  nv = hmap%gil%dim(3) 
  !!Print *,'NX,NY,NV ',nx,ny,nv 
  !
  allocate(hvelo%r2d(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  !
  bval = -1000.0
  hvelo%r2d = bval
  hvelo%gil%bval = bval
  hvelo%gil%eval = 0.
  hvelo%gil%blan_words = 2
  !
  x0 = kepler_x0 * sec
  y0 = kepler_y0 * sec
  !
  if (kepler_step.lt.(0.59*abs(hmap%gil%inc(1))*kepler_dist/sec)) then
    write(chain,'(A,I0,A,I0,A)') 'KEPLER_STEP (',nint(kepler_step), &
    ') smaller than Pixel size (',nint(abs(hmap%gil%inc(1))*kepler_dist/sec),')'
    call map_message(seve%w,rname,chain,3)
  endif 
  !
  ! Step A)   Compute 2D distribution and Radial profile
  !
  ! Note: Loop can NOT be parallel when Kepler_Usefunc is set
  ! because of call to SIC_LIBR which is not thread-safe.
  nthread = 1
  !$ if (.not.kepler_usefunc) nthread = omp_get_max_threads()
  Print *,'NTHREAD ',nthread
  allocate (ss(xdim,mstep,nthread),nn(xdim,mstep,nthread))
  s = 0
  n = 1
  ss = 0.
  nn = 0 ! Can't be one
  !
  !$OMP PARALLEL IF(.not.kepler_usefunc) DEFAULT(none) &
  !$OMP & SHARED(hmap,data,x0,y0,nx,ny,nv,cospa,sinpa,mstep) &
  !$OMP & SHARED(hvelo,theta_min,theta_max,thetamax, np,ic1,icn) & 
  !$OMP & SHARED(xdim,xref,xinc, ydim,yref,yval,yinc, bval, blanked) &
  !$OMP & SHARED(kepler_usefunc,kepler_dist,kepler_rout,kepler_rmin,kepler_vdisk,kepler_step) &
  !$OMP & SHARED(sec,vsini,cosi,sini,offmax,offmin) &
  !$OMP & PRIVATE(ix,jy,offx,offy,xoff,yoff,roff,theta,radius,vproj) &
  !$OMP & PRIVATE(iv,kv,istep,error, x,y, iwork, rwork, xval) & 
  !$OMP & SHARED(Ss,Nn,S,N,nthread) PRIVATE(ithread)                  ! S and N are Reduction arrays
  !
  ithread = 1
  !$ ithread = omp_get_thread_num()+1
  !$OMP DO COLLAPSE(2)
  do jy=1,ny
    do ix=1,nx
      !
      offy = (jy-hmap%gil%ref(2))*hmap%gil%inc(2) + hmap%gil%val(2) - y0
      if (abs(offy).gt.offmax) cycle
      offx = (ix-hmap%gil%ref(1))*hmap%gil%inc(1) + hmap%gil%val(1) - x0
      if (abs(offx).gt.offmax) cycle
      !
      ! Apply rotation Matrix and Deproject Y axis
      xoff = offx*cospa-offy*sinpa
      yoff = (offx*sinpa+offy*cospa) /cosi
      roff = sqrt(xoff**2+yoff**2)         ! Radial distance in radians
      if (roff.gt.offmax) cycle            !
      if (roff.lt.offmin) cycle
      !
      ! Apply Kepler Shift
      radius = roff*kepler_dist/sec        ! Radial distance in au
      if (radius.eq.0) cycle               ! Undefined velocity
      !
      ! Angle range
      theta = abs(atan(yoff/xoff))         ! Absolute polar angle      
      if (theta.gt.thetamax) cycle         ! Out of range: ignore
      !
      theta = atan2(yoff,xoff)             ! Polar angle - 90°
      vproj = vsini/sqrt(radius/100)*cos(theta) ! Line of sight velocity offset
      if (kepler_usefunc) then
        ! Get rotation velocity
        call sic_libr('LET Kepler_Vproj Kepler_Law(Kepler_Current)',error)
        ! Apply projection effect
        vproj = vproj*cos(theta)*sini
      endif
      !
      ! Bring to 0 360° determination
      theta = theta+pi/2.d0                ! Polar angle itself
      theta = mod(theta+2d0*pi,2d0*pi)*180.d0/pi
      ! Azimuth range
      if (theta_min.lt.theta_max) then        
        if (theta.lt.theta_min .or. theta.gt.theta_max) cycle
      else 
        if (theta.le.theta_min .and. theta.ge.theta_max) cycle 
      endif
      !
      hvelo%r2d(ix,jy) = -vproj            ! Remember the velocity
      !
      ! Subtract this velocity to that of the spectrum...
      xval = yval - vproj
      !! !!Print *,'Velocities ',xval,yval,vproj
      !
      ! Interpolate the values
      y(1,:) = data(ix,jy,:)  ! Input array
      x(1,:) = 0.0            ! Output array
      blanked = .false.     
      call all_inter (np,ic1,icn,x,xdim,xinc,xref,xval, &
        & y,ydim,yinc,yref,yval,bval,blanked,iwork,rwork)
      !
      ! Add them to the appropriate radial range
      istep = nint((radius-kepler_rmin)/kepler_step + 0.5)
      if (istep.ge.1 .and. istep.le.mstep) then
        !! !!Print *,'Adding ',ix,jy,' at ',istep, radius
        !
        if (nthread.eq.1) then
          do kv = 1,ydim 
            if (x(1,kv).ne.bval .and. s(kv,istep).ne.bval) then
              s(kv,istep) = s(kv,istep) + x(1,kv)
              n(kv,istep) = n(kv,istep) + 1
            else
              s(kv,istep) = bval
              n(kv,istep) = 0
            endif
          enddo
        else
          do kv = 1,ydim 
            if (x(1,kv).ne.bval) then
              ss(kv,istep,ithread) = ss(kv,istep,ithread) + x(1,kv)
              nn(kv,istep,ithread) = nn(kv,istep,ithread) + 1
            else
              s(kv,istep) = bval
              n(kv,istep) = 0
            endif
          enddo
        endif
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  if (nthread.eq.1) then
    where (n.gt.1) 
      s = s/(n-1)
    else where
      s = bval
    end where
  else
    do ithread=1,nthread
      s(:,:) = s(:,:) + ss(:,:,ithread)
      where(n.ne.0) n = n + nn(:,:,ithread)
    enddo
    !
    ! Normalize to get the Mean Brightness for each radius
    where (n.ne.0) 
      s = s/n
    else where
      s = bval
    end where
  endif
  !
  t = 0
  call get_jyperk(hmap,beam_area,jyperk)
  !
  ! Convert mean "brightness" to integrated flux
  !
  ! If we want to get the flux, we shall multiply by the area
  !   of each radius, including the Azimuth range,
  !   or extrapolated to the whole disk 
  !
  !! For circles
  !! circum = min(2*pi,(theta_max-theta_min)*pi/180d0)
  !! circum = 2*pi* min(1.0,(2*thetamax/pi)) 
  !! circum = 2*pi
  !
  ! For an ellipse,
  ! Approximate ellipse length, with some precision
  !   circum = pi*(1.+cosi)*(3-sqrt(4.-((1.-cosi)/(1.+cosi))**2)
  ! but even first order will do it given all other uncertainties
  circum = pi*(1.+cosi)
  ! The radius will be accounted for later.
  ! That gives the flux for the whole disk 
  factor = circum * kepler_step     ! in au^2 
  factor = factor / kepler_dist**2    
  factor = factor * sec**2          ! Get it in Steradian
  !
  ! Actually, to get the flux, we should divide by the beam area
  factor = factor / beam_area       ! Divide by the beam area
  ! 
  !   Velocity Axis
  do kv=1,ydim
    v(kv) = (kv-yref)*yinc+yval
  enddo
  !
  ! Integrated spectrum (From Kepler_Rint to Kepler_Rout) 
  fstep = nint((kepler_rint-kepler_rmin)/kepler_step)
  lstep = nint((kepler_rout-kepler_rmin)/kepler_step) 
  if (STRICT) then
    m = 1
    do istep = fstep,lstep  
      !
      if (any(n(:,istep).gt.1)) then
        do kv = 1,nv
          if (n(kv,istep).gt.1 .and. m(kv).ne.0) then
            t(kv) = t(kv) + s(kv,istep) * factor * r(istep)
          else 
            t(kv) = bval
            m(kv) = 0
          endif
        enddo
      endif
    enddo  
  else
    m = 0
    do istep = fstep,lstep  
      !
      do kv = 1,nv
        if (n(kv,istep).gt.1) then
!!          Print *,'Istep ',istep,' KV ',kv,' S ',s(kv,istep),' R ',r(istep)
          t(kv) = t(kv) + s(kv,istep) * factor * r(istep)
          m(kv) = 1
        endif
      enddo
    enddo  
    where (m.eq.0) t = bval
  endif
  !
  ! OK got them. Extract the significant part of the spectrum
  ! Patch for Blank and Zeros (?)
  is = 0
  ie = ydim
  do kv=1,ydim
    if (is.eq.0) then
      if ((t(kv).ne.bval).and.(t(kv).ne.0)) is = kv
    else if (ie.eq.ydim) then
      if ((t(kv).eq.bval).or.(t(kv).eq.0)) then
        ie = kv-1
        exit
      endif
    endif
  enddo
  !
  ! Compute the rms noise
  !!Print *,'IS IE ',is,ie
  call kepler_rms(t,ie,is,z)
  !!Print *,'Done KEPLER_RMS'
  !
  ! Allow extended display range (or not)
  js = is
  je = ie
  if (.not.STRICT) then
    is = 1
    ie = ydim
  endif
  !
  ! Take the peak velocity
  if (kepler_usevdisk) then
    iv = nint((kepler_vdisk-yval)/yinc + yref)
  else
    iloc = maxloc(t)
    iv = iloc(1)
  endif
  !
  kep_nrad = mstep  ! Full PV diagram and Profile 
  kep_nchan = ie-is+1
  allocate(kep_spectrum(kep_nchan,3),kep_profile(kep_nrad,3), &
    & kep_spectra(kep_nchan,kep_nrad),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  kep_spectrum(:,1) = v(is:ie)
  kep_spectrum(:,2) = t(is:ie)
  kep_spectrum(:,3) = z
  !
  ! Get the radial profile from this channel - The problem
  ! is that we have no information on line width there...
  ! Let us get the brightness at line center, in K 
  !
  ! Line width can be derived from a model - They should be the same
  ! for all lines of the same object observed at the same angular
  ! resolution - They can also be derived from a fit to the line profiles.
  !
  kep_spectra = bval
  do istep=1,mstep  ! Whole range
    !
    kep_profile(istep,1) = r(istep)
    if (s(iv,istep).ne.bval) then
      ! This may be just a refinement over the previous (js,je) pair
      if (.not.STRICT) then
        do kv=1,ydim
          if (s(kv,istep).ne.bval) then
            js = kv
            exit
          endif
        enddo
        do kv=ydim,1,-1
          if (s(kv,istep).ne.bval) then
            je = kv
            exit
          endif
        enddo
      endif
      !
      call kepler_rms(s(:,istep),je,js,z)
      kep_profile(istep,2) = s(iv,istep)/jyperk
      kep_profile(istep,3) = z/jyperk
    else
      kep_profile(istep,2) = bval
      kep_profile(istep,3) = 0 
    endif 
    where (s(is:ie,istep).ne.bval)
      kep_spectra(:,istep) = s(is:ie,istep)/jyperk 
    end where
  enddo
  !!Print *,'Done KEPLER_PROFILE ',mstep
  !
  error = .false.
  dim(1:2) = [kep_nchan,3]
  call sic_def_dble('KEPLER_SPECTRUM',kep_spectrum,2,dim,.true.,error)
  !!sline = 'HEADER KEPLER_SPECTRUM'
  !!call exec_command(sline,error)
  dim(1:2) = [kep_nrad,3]  
  call sic_def_dble('KEPLER_PROFILE',kep_profile,2,dim,.true.,error)
  !
  ! We want KEPLER_PV to be a full 2-D data set,
  call gildas_null(hkpv)
  call gdf_copy_header(hmap,hkpv,error)
  if (error) return
  !!Print *,'Setting KEPLER_PV ',kep_nchan, kep_nrad
  !
  hkpv%gil%ndim = 2
  hkpv%gil%dim = 1
  hkpv%gil%dim(1) = kep_nchan
  hkpv%gil%dim(2) = kep_nrad
  hkpv%gil%convert(:,1) = [yref-dble(is),yval,yinc]
  hkpv%gil%convert(:,2) = [0.5d0,dble(kepler_rmin),dble(kepler_step)]
  hkpv%gil%faxi = 1
  hkpv%char%syst = ' '
  hkpv%char%code(1) = 'VELOCITY'
  hkpv%char%code(2) = 'RADIUS'
  hkpv%char%unit = 'K'
  hkpv%gil%bval = bval
  hkpv%gil%eval = 0
  hkpv%gil%blan_words = 2
  hkpv%gil%ptyp = p_none
  hkpv%gil%voff = yval
  hkpv%gil%vres = yinc
  hkpv%gil%fres = -yinc/299792.458d0*hkpv%gil%freq
  hkpv%loca%size = kep_nchan*kep_nrad
  hkpv%loca%addr = locwrd(kep_spectra)
  hkpv%r2d => kep_spectra
  call gdf_get_extrema (hkpv,error)
  if (error) return
  call sic_mapgildas('KEPLER_PV',hkpv,error,kep_spectra) 
  !!Print *,'Done KEPLER_PV'
  !
  ! Velocity field
  hvelo%loca%size = nx*ny
  hvelo%loca%addr = locwrd(hvelo%r2d)
  call gdf_get_extrema (hvelo,error)
  if (error) return
  call sic_mapgildas('KEPLER_VELO',hvelo,error,hvelo%r2d)
  !
  !!Print *,'Done KEPLER_VELO ',error
  error = .false.
end subroutine kepler_compute
!
subroutine kepler_rms(t,ie,is,z)
  !---------------------------------------------------------------------
  ! @ private
  ! IMAGER
  !
  !   Support for command
  !   KEPLER [Arg] [/VSYSTEM Value] [/VELOCITY R function(R)]
  !
  ! Estimate noise in the spectrum
  !---------------------------------------------------------------------
  real(4), intent(in) :: t(*)     ! Input data array
  integer, intent(in) :: ie,is    ! Range to be considered
  real(4), intent(out) :: z       ! RMS value
  !
  integer k,kv
  real :: z1,z2
  !
  ! Assume line is in the middle of selected range
  k = 0
  z1 = 0
  do kv=is,(3*is+ie)/4
    k = k+1
    z1 = z1+t(kv)**2
  enddo
  z1 = sqrt(z1/(k-1))
  k = 0
  z2 = 0
  do kv=(3*ie+is)/4,ie
    k = k+1
    z2 = z2+t(kv)**2
  enddo
  z2 = sqrt(z2/(k-1))
  !
  ! Take RMS as mean or lowest value of both parts of the spectrum
  if (abs(z2-z1).lt.0.5*sqrt(z1*z2)) then
    z = sqrt(z1*z2)
  else
    !!Print *,'Warning, secondary peak... ',z1,sqrt(z1*z2),z2
    z = min(z1,z2)
    !
    ! A second pass with filtering improves the stuff then
    k = 0
    z2 = 0
    do kv=is,ie
      if (abs(t(kv)).gt.2.5*z) cycle ! 2.5 sigma, since Sigma is rather biased by Line...
      z2 = z2+t(kv)**2
      k = k+1
    enddo
    if (k.gt.1) z = sqrt(z2/(k-1))
    !!Print *,'Final rms ',z,k
  endif
end subroutine kepler_rms
!
subroutine kepler_init(error)
  use mod_kepler
  use gkernel_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! IMAGER
  !
  !   Support for command KEPLER
  !
  ! Initialize all variables
  !---------------------------------------------------------------------
  logical, intent(out) :: error
  !
  integer(8) :: dim(1)
  !
  error = .false.
  !
  if (.not.kepler_setup) return
  !
  kepler_x0 = 0
  kepler_y0 = 0
  kepler_rota = 0
  kepler_incli = 30.
  kepler_vmass = 3.
  kepler_rint = 50.
  kepler_rmin = 0.
  kepler_rout = 500.
  kepler_step = 50.
  kepler_dist = 150.
  kepler_theta = 60.
  kepler_azimut = [0.,360.]
  kepler_vdisk = 6.0 
  kepler_usevdisk = .false.
  kepler_variable = 'CLEAN'
  !
  call sic_def_dble('KEPLER_X0',kepler_x0,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_Y0',kepler_y0,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_ROTA',kepler_rota,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_INCLI',kepler_incli,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_VMASS',kepler_vmass,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_RINT',kepler_rint,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_RMIN',kepler_rmin,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_ROUT',kepler_rout,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_DIST',kepler_dist,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_STEP',kepler_step,0,dim,.false.,error) 
  if (error) return
  call sic_def_dble('KEPLER_THETA',kepler_theta,0,dim,.false.,error) 
  if (error) return
  dim(1) = 2
  call sic_def_dble('KEPLER_AZIMUT',kepler_azimut,1,dim,.false.,error) 
  if (error) return
  call sic_def_logi('KEPLER_USEVDISK',kepler_usevdisk,.false.,error)
  if (error) return
  call sic_def_dble('KEPLER_VDISK',kepler_vdisk,0,dim,.false.,error) 
  if (error) return
  !
  call sic_def_char('KEPVARIABLE',kepler_variable,.false.,error)
  kepler_setup = .false.
  !
end subroutine kepler_init
!
subroutine kepler_mask(line,hmap,data,error)
  !$ use omp_lib
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, except_this => kepler_mask
  use clean_arrays
  use gbl_message
  use mod_kepler
!-----------------------------------------------------------------------
! @ private
! IMAGER
!
!   Support for command
!   KEPLER /MASK File [Threshold] [/VELOCITY R Function(R) ] [/VSYSTEM Value]
!
! Create a Mask for further use (Deconvolution, Flux computation)
!
! Output data
!     Keplerian Mask for deconvolution
!
!-----------------------------------------------------------------------
  character(len=*), intent(in) :: line ! Command line
  type(gildas), intent(inout) :: hmap
  real, intent(inout) :: data(hmap%gil%dim(1),hmap%gil%dim(2),hmap%gil%dim(3))
  logical, intent(out) :: error
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='KEPLER'
  !
  real(8) :: elapsed_s, elapsed_e, elapsed
  real(8) :: cospa, sinpa, cosi, sini
  real(8) :: offx, offy, offmax, offmin, sec
  real(8) :: xoff, yoff, roff, x0, y0
  real(8) :: yinc, yval, yref
  integer :: ix, jy, iv, ier
  integer :: nx, ny, nv !, iloc(1)
  real :: radius, theta, thetamax, vproj, vsini, theta_min, theta_max
  integer(kind=address_length) :: dim(2)
  !
  real :: vlocal, dvlocal, beam, filling, pa, fact, rxinc, ryinc
  complex, allocatable :: ft(:,:)
  real, allocatable :: wfft(:)
  integer :: ndim, fdim(2)
  real :: threshold
  character(len=80) :: chain
  !
  threshold = 0.
  call sic_r4(line,o_mask,2,threshold,.false.,error)
  if (threshold.lt.0. .or. threshold.gt.1.) then
    call map_message(seve%e,rname,'Threshold must be in range [0,1]')
    error = .true.
    return
  endif
  !
  sec = pi/180/3600   ! Second to Radian
  beam = sqrt(hmap%gil%majo*hmap%gil%mino) ! Beam in Radians
  !
  if (sic_present(o_vdisk,0)) then
    call sic_r8(line,o_vdisk,1,kepler_vdisk,.false.,error)
    kepler_usevdisk = .true.
  else
    kepler_usevdisk = .false.
  endif
  if (kepler_usefunc) then
    call sic_def_real('Kepler_Vproj',vproj,0,dim,.false.,error)
    call sic_def_real('Kepler_Current',radius,0,dim,.false.,error)
  endif
  !
  thetamax = kepler_theta*pi/180
  !
  theta_min = kepler_azimut(1)
  theta_max = kepler_azimut(2)
  !
  cospa = cos(pi*kepler_rota/180)
  sinpa = sin(pi*kepler_rota/180)
  sini = sin(kepler_incli*pi/180)
  cosi = cos(kepler_incli*pi/180)
  !
  vsini = kepler_vmass * sini
  !
  yinc = hmap%gil%inc(3)
  yref = hmap%gil%ref(3)
  yval = hmap%gil%val(3)
  !
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  nv = hmap%gil%dim(3) 
  !
  x0 = kepler_x0 * sec
  y0 = kepler_y0 * sec
  beam = beam*kepler_dist/sec ! Beam in AU
  !
  offmax = kepler_rout/kepler_dist*sec
  offmin = 0.0 !!  kepler_rint/kepler_dist*sec
  data = 0.0 
  !$ elapsed_s = omp_get_wtime()
  !
  ! Note: Loop can NOT be parallel because of call to SIC_LIBR which is
  ! not thread-safe.
  !$OMP PARALLEL IF(.not.kepler_usefunc) DEFAULT(none) &
  !$OMP & SHARED(hmap,data,x0,y0,nx,ny,nv,cospa,sinpa,beam) &
  !$OMP & SHARED(kepler_usefunc,kepler_dist,kepler_rout,kepler_vdisk) &
  !$OMP & SHARED(sec,vsini,cosi,sini,offmax,offmin,yref,yinc,yval) &
  !$OMP & PRIVATE(ix,jy,offx,offy,xoff,yoff,roff,theta,radius,vproj,filling) &
  !$OMP & PRIVATE(iv,dvlocal,vlocal, error)
  !$OMP DO COLLAPSE(2)
  do jy=1,ny
    do ix=1,nx
      offy = (jy-hmap%gil%ref(2))*hmap%gil%inc(2) + hmap%gil%val(2) - y0
      if (abs(offy).gt.offmax) cycle
      !
      offx = (ix-hmap%gil%ref(1))*hmap%gil%inc(1) + hmap%gil%val(1) - x0
      if (abs(offx).gt.offmax) cycle
      !
      ! Apply rotation Matrix and Deproject Y axis
      xoff = offx*cospa-offy*sinpa
      yoff = (offx*sinpa+offy*cospa) /cosi
      !
      ! Apply Kepler Shift
      roff = sqrt(xoff**2+yoff**2)         ! Radial distance in radians
      radius = roff*kepler_dist/sec        ! Radial distance in au
      if (radius.le.0.0) cycle             ! Undefined velocity
      !
!!      theta = abs(atan(yoff/xoff))         ! Absolute polar angle      
!!      if (theta.gt.thetamax) cycle         ! Out of range: ignore
      !
      theta = atan2(yoff,xoff)             ! Polar angle - 90°
      vproj = vsini/sqrt(radius/100)*cos(theta) ! Line of sight velocity offset
      if (kepler_usefunc) then
        ! Get rotation velocity
        call sic_libr('LET Kepler_Vproj Kepler_Law(Kepler_Current)',error)
        ! Apply projection effect
        vproj = vproj*cos(theta)*sini
      endif
      !
      ! Radial range
      if (roff.gt.offmax) cycle            !
      if (roff.lt.offmin) then
        !!Print *,'Radius ',radius,' roff ',roff,' < offmin '
        cycle
      endif
      !
      if (radius.gt.beam) then
        filling = 1.0
      else
        filling = (radius/beam)**2  ! Attempt to get filling factor
      endif
      !
      dvlocal = sqrt((1.0-filling)*vproj**2 + 0.3**2) ! Attempt to  account for dilution ?
      !
      ! Compute the brightness, with 1/sqrt(r) dependency
      do iv=1,nv
        !
        vlocal = (iv-yref)*yinc + yval - kepler_vdisk
        data(ix,jy,iv) = filling * sqrt(kepler_rout/radius) * exp(-((vlocal-vproj)/dvlocal)**2)
      enddo
      !
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  elapsed_s = elapsed_e
  write(chain,'(a,a,f9.2,a)') 'Finished raw mask','  - Elapsed time ',elapsed,' sec'
  call map_message(seve%i,'KEPLER',chain)
  !
  ! Convolve by FT
  allocate (wfft(2*max(nx,ny)),ft(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !! !!Print *,'Smoothing by Clean beam ',180/pi*3600*hmap%gil%majo,180/pi*3600*hmap%gil%mino
  pa = hmap%gil%pang * 180 / pi
  rxinc = hmap%gil%inc(1)
  ryinc = hmap%gil%inc(2)
  ndim = 2
  fdim(1) = nx
  fdim(2) = ny
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & SHARED(data, rxinc, ryinc, pa, ndim, fdim, nx, ny, nv, hmap) &
  !$OMP & PRIVATE(ft, wfft, fact, iv)
  !$OMP DO
  do iv=1,nv
    ft(:,:) = cmplx(data(:,:,iv))
    call fourt(ft,fdim,ndim,-1,0,wfft)
    !
    ! Beam Area = PI * BMAJ * BMIN / (4 * LOG(2) ) for flux density
    ! normalisation
    fact = hmap%gil%majo*hmap%gil%mino*pi/(4.0*log(2.0))   &
         &    /abs(rxinc*ryinc)/(nx*ny)
    call mulgau(ft,nx,ny,   &
         &    hmap%gil%majo,hmap%gil%mino,pa,   &
         &    fact,rxinc,ryinc,-1)
    call fourt(ft,fdim,ndim,1,1,wfft)
    !
    ! Extract Real part
    data(:,:,iv)  = real(ft)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  deallocate (wfft,ft)
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  elapsed_s = elapsed_e
  write(chain,'(a,a,f9.2,a)') 'Finished smmothing mask','  - Elapsed time ',elapsed,' sec'
  call map_message(seve%i,'KEPLER',chain)
  !
  ! Normalize if needed
  if (threshold.gt.0) then
    threshold  = maxval(data)*threshold
    !!Print *,'Threshold ',threshold,maxval(data)
    where (data.lt.threshold) 
      data = 0.
    else where
      data = 1.
    end where
    hmap%gil%rmax = 1.0
    hmap%gil%rmin = 0.0
  endif
  !
end subroutine kepler_mask
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_putheader
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_header_array_types
  use cubetools_spatial_types
  use cubetools_spectral_prog_types
  use cubetools_spectral_frame_types
  use cubetools_spectral_velocity_types
  use cubetools_spectral_redshift_types
  use cubetools_spectral_line_types
  use cubetools_spectral_freq_types
  use cubetools_spectral_wave_types
  use cubetools_axset_types
  use cubetools_noise_types
  use cubetools_observatory_types
  use cubeedit_messaging
  !
  public :: putheader_comm_t,putheader_user_t
  private
  !
  type :: putheader_comm_t
     type(spatial_source_opt_t)     :: source        
     type(spafra_opt_t)             :: spafra  
     type(spapro_type_opt_t)        :: ptype
     type(spapro_center_opt_t)      :: pcenter
     type(spapro_angle_opt_t)       :: pangle
     type(beam_opt_t)               :: beam          
     type(option_t),      pointer   :: unit          
     type(noise_opt_t)              :: noise
     type(option_t),      pointer   :: axis
     type(keywordlist_comm_t), pointer   :: ax_kind
     type(observatory_opt_t)        :: obs
     type(spectral_velocity_comm_t) :: velo
     type(spectral_redshift_comm_t) :: reds
     type(spectral_line_comm_t)     :: line
     type(spectral_freq_comm_t)     :: freq
     type(spectral_wave_comm_t)     :: wave
     type(spectral_frame_comm_t)    :: spefra
     type(option_t),      pointer   :: axnames
   contains
     procedure, public :: register => cubeedit_putheader_register
     procedure, public :: parse    => cubeedit_putheader_parse
     procedure, public :: main     => cubeedit_putheader_main
  end type putheader_comm_t
  !
  type putheader_user_t
     type(spatial_source_user_t)    :: source
     type(spafra_user_t)            :: spafra
     type(spapro_type_user_t)       :: ptype
     type(spapro_center_user_t)     :: pcenter
     type(spapro_angle_user_t)      :: pangle
     type(beam_user_t)              :: beam
     type(axset_axis_user_t)        :: axis
     type(array_unit_user_t)        :: unit
     type(noise_user_t)             :: noise
     type(axset_axnames_user_t)     :: axnames
     type(observatory_user_t)       :: obs
     type(spectral_velocity_user_t) :: velo
     type(spectral_redshift_user_t) :: reds
     type(spectral_line_user_t)     :: line
     type(spectral_freq_user_t)     :: freq
     type(spectral_wave_user_t)     :: wave
     type(spectral_frame_user_t)    :: spefra
  end type putheader_user_t
  !
contains
  !
  subroutine cubeedit_putheader_register(comm,error)
    !----------------------------------------------------------------------
    ! Register options related to header edition
    !----------------------------------------------------------------------
    class(putheader_comm_t), intent(inout) :: comm
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PUT>HEADER>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call comm%source%register(&
         'Put a new source name',&
         error)
    if (error) return
    !
    call comm%spafra%register(&
         'Put new Spatial frame information',&
         error)
    if (error) return
    !
    call comm%ptype%register(&
         'PTYPE',&
         'Put a new projection type',&
         error)
    if (error) return
    call comm%pcenter%register(&
         'PCENTER',&
         'Put a new projection center',&
         error)
    if (error) return
    call comm%pangle%register(&
         'PANGLE',&
         'Put a new projection angle',&
         error)
    if (error) return
    !
    call comm%beam%register(&
         'Put a new beam',&
         error)
    if (error) return
    !
    !----------------------------------------------------------------------
    !
    call cubetools_array_unit_register(&
         'UNIT',&
         'Put a new unit for the cube',&
         comm%unit,error)
    if (error) return
    !
    call comm%noise%register(&
         'Put new noise values',&
         error)
    if (error) return
    !
    call cubetools_axset_axis_register(&
         'AXIS',&
         'Put a new axis description for one of the current axes',&
         comm%axis,comm%ax_kind,error)
    if (error) return
    !
    call cubetools_axset_axnames_register(&
         'AXNAMES',&
         'Put new names on cube''s axes',&
         comm%axnames,error)
    if (error) return
    !
    !----------------------------------------------------------------------
    !
    call comm%obs%register(&
         'Put new observatory information',&
         error)
    if (error) return
    !
    !----------------------------------------------------------------------
    !
    call comm%line%register(&
         'Put a new line name',&
         error)
    if (error) return
    !
    call comm%velo%register(&
         'VELOCITY',&
         'Put new systemic velocity information',&
         error)
    if (error) return
    !
    call comm%reds%register(&
         'REDSHIFT',&
         'Put new systemic redshift information',&
         error)
    if (error) return
    !
    call comm%freq%register(&
         'FREQUENCY',&
         'Put new rest frequency information',&
         error)
    if (error) return
    call comm%wave%register(&
         'WAVELENGTH',&
         'Put new rest wavelength information',&
         error)
    if (error) return
    !
    call comm%spefra%register(&
         'Put new spectral frame information',&
         error)
    if (error) return
  end subroutine cubeedit_putheader_register
  !
  subroutine cubeedit_putheader_parse(comm,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for header part of command PUT
    !-------------------------------------------------------------------
    class(putheader_comm_t), intent(in)    :: comm
    character(len=*),        intent(in)    :: line
    type(putheader_user_t),  intent(out)   :: user
    logical,                 intent(inout) :: error
    !
    logical :: dofreq,dovelo,dowave,doreds
    character(len=*), parameter :: rname='PUT>HEADER>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call comm%velo%comm%present(line,dovelo,error)
    if (error) return
    call comm%reds%comm%present(line,doreds,error)
    if (error) return
    if (dovelo.and.doreds) then
       call cubeedit_message(seve%e,rname,'Cannot change systemic velocity and redshift at the same time')
       error = .true.
       return
    endif
    call comm%freq%comm%present(line,dofreq,error)
    if (error) return
    call comm%wave%comm%present(line,dowave,error)
    if (error) return
    if (dofreq.and.dowave) then
       call cubeedit_message(seve%e,rname,'Cannot change rest frequency and wavelength at the same time')
       error = .true.
       return
    endif
    !
    call comm%source%parse(line,user%source,error)
    if (error) return
    call comm%spafra%parse(line,user%spafra,error)
    if (error) return
    call comm%ptype%parse(line,user%ptype,error)
    if (error) return
    call comm%pcenter%parse(line,user%pcenter,error)
    if (error) return
    call comm%pangle%parse(line,user%pangle,error)
    if (error) return
    call comm%beam%parse(line,user%beam,error)
    if (error) return
    !
    call cubetools_array_unit_parse(line,comm%unit,user%unit,error)
    if (error) return
    call comm%noise%parse(line,user%noise,error)
    if (error) return
    call cubetools_axset_axis_parse(line,comm%axis,user%axis,error)
    if (error) return
    call cubetools_axset_axnames_parse(line,comm%axnames,user%axnames,error)
    if (error) return
    !
    call comm%obs%parse(line,user%obs,error)
    if (error) return
    !
    call comm%velo%parse(line,user%velo,error)
    if (error) return
    call comm%reds%parse(line,user%reds,error)
    if (error) return  
    call comm%line%parse(line,user%line,error)
    if (error) return
    call comm%freq%parse(line,user%freq,error)
    if (error) return
    call comm%wave%parse(line,user%wave,error)
    if (error) return
    call comm%spefra%parse(line,user%spefra,error)
    if (error) return
  end subroutine cubeedit_putheader_parse
  !
  subroutine cubeedit_putheader_main(comm,user,cube,error)
    use cube_types
    !-------------------------------------------------------------------
    ! Main routine for header part of command PUT
    !-------------------------------------------------------------------
    class(putheader_comm_t), intent(in)    :: comm
    type(putheader_user_t),  intent(in)    :: user
    type(cube_t),            intent(inout) :: cube
    logical,                 intent(inout) :: error
    !
    character(len=*), parameter :: rname='PUT>HEADER>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call comm%source%user2prog(user%source,cube%head%spa%source,error)
    if (error) return
    call comm%spafra%user2prog(user%spafra,cube%head%spa%fra,error)
    if (error) return
    call comm%ptype%user2prog(user%ptype,cube%head%spa%pro,error)
    if (error) return
    call comm%pcenter%user2prog(cube%head%spa%fra,user%pcenter,cube%head%spa%pro,error)
    if (error) return
    call comm%pangle%user2prog(user%pangle,cube%head%spa%pro,error)
    if (error) return
    call comm%beam%user2prog(user%beam,cube%head%spa%bea,error)
    if (error) return
    !
    call cubetools_array_unit_user2prog(user%unit,cube%head%arr%unit,error)
    if (error) return
    call comm%noise%user2prog(user%noise,cube%head%arr%noi,error)
    if (error) return
    call cubetools_axset_axis_user2prog(user%axis,cube%head%set,error)
    if (error) return
    call cubetools_axset_axnames_user2prog(user%axnames,cube%head%set,error)
    if (error) return
    !
    call comm%obs%user2prog(user%obs,cube%head%obs,error)
    if (error) return
    !
    call user%velo%toprog(comm%velo,cube%head%spe,error)
    if (error) return
    call user%reds%toprog(comm%reds,cube%head%spe,error)
    if (error) return
    call user%line%toprog(cube%head%spe,error)
    if (error) return
    call user%freq%toprog(cube%head%spe,error)
    if (error) return
    call user%wave%toprog(cube%head%spe,error)
    if (error) return
    call user%spefra%toprog(comm%spefra,cube%head%spe,error)
    if (error) return
  end subroutine cubeedit_putheader_main
end module cubeedit_putheader
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sg_map(task,line,do_cct,error)
  !$ use omp_lib
  use gkernel_interfaces
  use imager_interfaces, except_this=>sg_map
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !
  !     Support for commands
  !       UV_RESTORE  [/SPEED FFT | PRECISION | Number]
  !       UV_MAP
  !       UV_SELF
  ! and   MX (eventually, not coded yet)
  !
  ! Compute a map from a CLIC UV Sorted Table  by Gridding and Fast Fourier
  ! Transform, using adequate virtual memory space for optimisation. Also
  ! allows removal of Clean Components in the UV data and restoration of
  ! the clean image.
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean components
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !     a beam image or cube
  !     a LMV cube  (dirty or clean)
  !
  ! To be implemented
  !     Optionally, a Residual UV table
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task ! Caller (MX or UV_MAP or UV_RESTORE)
  character(len=*), intent(inout) :: line ! Command line
  logical, intent(in) :: do_cct        ! Remove Clean Components before
  logical, intent(out) :: error  
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer, parameter :: o_speed = 2   ! For UV_RESTORE
  integer, parameter :: o_copy = 1    ! For UV_RESTORE
  integer, parameter :: o_range= 3    ! For UV_MAP
  integer, parameter :: code_fft=1, code_auto=0, code_precis=-1
  !
  ! Toggling number of visibilities to switch method
  real(4), save :: noper_slow_max=2E8 ! Empirical value
  integer :: code_speed=code_auto
  !
  real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
  !! real, allocatable :: res_uv(:,:)
  real(8) newabs(3)
  real(4) rmega,uvmax,uvmin,uvma
  integer wcol,mcol(2),rcol,sblock
  integer ier
  logical one, sorted, shift, needed
  character(len=message_length) :: chain
  character(len=32) :: acomm
  character(len=12) :: string
  real cpu0, cpu1
  real(8) :: freq
  integer nx,ny,nu,nv,nc,nb,mx,my,mthread
  !
  real(4) :: noper
  character(len=4) :: key
  integer :: nk
  logical :: do_slow
  logical :: do_copy, goon
  logical :: LIKE_MOSAIC=.false.
  !
  integer, allocatable, target :: smic(:)     ! Number of clean components per channel
  real, allocatable, target :: sccou(:,:,:)  ! Transpose, compressed Clean Component List
  integer :: maxic, icmax(2), fcol, lcol
  !
  ! Code
  call imager_tree('SG_MAP in restore_many.f90')
  !
  ! Print *,'DO_WEIG at start ',do_weig
  !
  ! Decode command line
  call map_query (line,task,themap,goon,error)  
  if (error.or..not.goon) return ! Syntax error, or missing information
  !
  ! Guess speed automatically
  code_speed = code_auto
  !
  if (task.eq.'UV_SELF') then
    do_copy = .false.
  else
    if (sic_present(o_speed,0)) then
      call sic_ke(line,o_speed,1,key,nk,.true.,error)
      select case (key)
      case ('AUTO')
        code_speed = code_auto
      case ('FFT')
        code_speed = code_fft
      case ('PREC')
        code_speed = code_precis
      case default
        call sic_r4(line,o_speed,1,noper_slow_max,.true.,error)
        if (error) return
        code_speed = code_auto
      end select
    endif
    do_copy = sic_present(o_copy,0) 
  endif
  !
  error = .false.
  !
  if (do_cct) then
    !!Print *,'UVMAP_MCOL ',uvmap_mcol,' SAVE_MCOL ',saved_mcol
    !
    ! Subtract all Clean Components
    if (.not.associated(duv)) then
      call map_message(seve%e,task,'No UV data loaded')
      error = .true.
    endif
    if (.not.allocated(dcct)) then
      call map_message(seve%e,task,'No CCT data available')
      error = .true.
    endif
    if (error) return
  endif
  !
  call map_prepare(task,huv,themap,error)
  if (error) return
  !
  one = .true.
  wcol = 0 
  !
  string = " "
  if (sic_present(o_range,0)) then
    ! Define the number of output channels
    call uvmap_cols(task,line,huv,mcol,wcol,error)
    uvmap_mcol = mcol
    uvmap_wcol = wcol
    string = "Imaging"
  else if (do_cct) then
    mcol = uvmap_mcol
    wcol = uvmap_wcol
    string = "Restoring"
  else
    call uvmap_cols(task,line,huv,mcol,wcol,error)
    uvmap_mcol = mcol
    uvmap_wcol = wcol
  endif
  !
  if (string.ne." ") then
    write(chain,'(A,I0,A,I0,A)') trim(string)//" channel range [",mcol(1),",",mcol(2),"]"
    call map_message(seve%i,task,chain)
  endif
  !
  call map_center(line,task,huv,shift,newabs,error)
  if (error) return
  !
  call gag_cpu(cpu0)
  needed = themap%uniform(2).ne.0 ! Need sorting ?
  needed = .false.  !! Test
  call uv_sort (huv,duv,error,sorted,shift,newabs,uvmax,uvmin,needed)
  if (error) return
  if (.not.sorted) then
    ! Redefine SIC variables (mandatory)
    call map_uvgildas('UV',huv,error,duv)
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished sorting ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! At this stage, we should reset MAP_CENTER
  acomm = 'LET MAP_CENTER " "'
  call exec_command(acomm,error)
  !
  call map_parameters(task,themap,huv,freq,uvmax,uvmin,error)
  if (error) return
  uvma = uvmax/(freq*f_to_k)
  !
  themap%xycell = themap%xycell*pi/180.0/3600.0
  !
  ! Get work space, ideally before mapping first image, for
  ! memory contiguity reasons.
  !
  nx = themap%size(1)
  ny = themap%size(2)
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi ! not %dim(2)
  !
  ! Define beam characteristics
  call define_beams(task,themap%beam,nx,ny,huv,mcol,nb,error)
  if (error) return  
  !
  nc = mcol(2)-mcol(1)+1
  if (do_cct .and. nc.ne.hcct%gil%dim(2)) then
    write(chain,'(A,I0,A,I0)') 'Mismatched number of channels between HUV ',nc,' and CCT ',hcct%gil%dim(2)
    call map_message(seve%e,task,chain)
    error = .true.
    return
  endif
  !
  ! Check if Weights have changed by MCOL choice
  !!PRINT *,'DO_WEIG before ',do_weig
  if (any(saved_mcol.ne.mcol) .or. nb.gt.1) do_weig = .true.
  if (saved_wcol.ne.wcol) do_weig = .true.
  !!PRINT *,'DO_WEIG just after ',do_weig,' nb ',nb
  saved_mcol = mcol
  saved_wcol = wcol
  !
  if (method%method.eq.'MX') do_weig = .true. ! Test
  if (do_weig) then
    call map_message(seve%i,task,'Computing weights ')
    if (allocated(g_weight)) deallocate(g_weight)
    if (allocated(g_v)) deallocate(g_v)
    allocate(g_weight(nv),g_v(nv),stat=ier)
    if (ier.ne.0) goto 98
  else
    call map_message(seve%i,task,'Re-using weight space')
  endif
  !
  !
  ! In fast mode, an intermediate Large FFT is used
  ! The maximum number of threads thus plays a role here.
  !
  if (do_cct) then
    hcct%r3d => dcct
    !
    ! Compress all CCTs first
    maxic = hcct%gil%dim(3)
    allocate (sccou(3,maxic,hcct%gil%dim(2)), smic(hcct%gil%dim(2)), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Compressed CCT allocation error')
      error = .true.
      return
    endif
    !
    ! Find out Clean size per Channel
    ! This was probably inconsistent before ?...
    fcol = 1     !  min(mcol(1),mcol(2))
    lcol = nc    !  max(mcol(1),mcol(2))
    call uv_clean_sizes(hcct,hcct%r3d,smic,fcol,lcol) 
    !
    ! Compress Clean Components
    call uv_squeeze_clean(nc,hcct%r3d,sccou, smic,fcol,lcol)
    icmax(2) = maxval(smic)   ! This should be smaller than MAXIC then
    icmax(1) = sum(smic)/nc
    write(chain,'(A,I0,1X,I0,A,I0,A)') 'Clean sizes:  Max [',icmax(1),icmax(2),' < ',maxic,'] '
    call map_message(seve%i,task,chain)
    !
    select case (code_speed)
    case (code_fft)
      call map_message(seve%i,task,'Using "fast" FFT-based subtraction mode')
      do_slow = .false.
    case (code_precis)
      do_slow = .true.
      call map_message(seve%i,task,'Using "slow" Sin/Cos visibility based subtraction mode')
    case (code_auto)
      ! Automatic guess
      ! That does not include the number of channels, 
      ! but only the Number of visibilities times the number of Clean Components 
      !
      ! A better guess would be by testing the average per block instead of the 
      ! overal Max number here ?
      noper = huv%gil%nvisi*icmax(2)
      !! Print *,'NOPER ',noper,' Max ',noper_slow_max,' Ratio ',real(noper_slow_max)/real(noper)
      if (noper.lt.noper_slow_max) then
        call map_message(seve%i,task,'Selecting precise mode because of small number of visibilities')
        do_slow = .true.
      else
        call map_message(seve%i,task,'Selecting FFT-based subtraction mode')
        do_slow = .false.
      endif
    end select
  endif
  !
  rmega = sys_ramsize/4      ! Do not overload Memory 
  rmega = max(4096.0,rmega)  !! Assume you can at least take 4GByte of memory
  ier = sic_ramlog('SPACE_IMAGER',rmega)
  ! This is stupidly conservative, as in the end, we shall use
  ! a much smaller number of outer threads ??...
  mthread = 1
  !$ mthread = omp_get_max_threads()
  rmega = rmega/min(mthread,8) ! Trial ...
  !
  ! Re-adjust the block size according to Memory requirements of the method
  if (do_cct.and..not.do_slow) then
    mx = max(nx,min(4*nx,4096))
    my = max(ny,min(4*ny,4096))
  else
    mx = nx
    my = ny
  endif
  sblock = max(int((1024.0*rmega*1024.0)/8.0/mx/my),1)
  write(chain,*) 'RMEGA ',rmega,' SBLOCK ',sblock,' DO_CCT ',do_cct,do_slow,' MX MY ',mx,my
  call map_message(seve%d,task,chain)
  !
  ! New Beam place
  if (allocated(dbeam)) then
    call sic_delvariable ('BEAM',.false.,error)
    deallocate(dbeam)
  endif
  call gildas_null(hbeam)
  !
  ! Process sorted UV Table according to the number of beams produced
  !
  hbeam%gil%ndim = 3
  hbeam%gil%dim(1:4)=[nx,ny,nb,1]
  if (nb.gt.1) then
    if (LIKE_MOSAIC) then
      allocate(hbeam%r3d(nx,ny,nb),dbeam(nx,ny,1,nb),stat=ier)
    else
      allocate(dbeam(nx,ny,nb,1),stat=ier)
      hbeam%r3d => dbeam(:,:,:,1)
    endif
    rcol = 0
  else
    allocate(dbeam(nx,ny,1,1),stat=ier)
    hbeam%r3d => dbeam(:,:,:,1)
    rcol = (mcol(2)+mcol(1))/2
  endif
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error on DBEAM')
    error =.true.
    return
  endif
  !
  if (do_cct) then
    ! UV_RESTORE case
    call map_message(seve%d,task,'DO_CCT is set')
    !
    ! New residual image
    if (allocated(dresid)) then
      call sic_delvariable ('RESIDUAL',.false.,error)
      deallocate(dresid)
    endif
    allocate(dresid(nx,ny,nc),stat=ier)
    !
    call gildas_null(hresid)
    hresid%gil%ndim = 3
    hresid%gil%dim(1:3) = (/nx,ny,nc/)
    hresid%r3d => dresid
    !
    if (allocated(dclean)) then
      call sic_delvariable ('CLEAN',.false.,error)
      deallocate(dclean)
    endif
    allocate(dclean(nx,ny,nc),stat=ier)
    hclean%r3d => dclean

    call uvmap_and_restore (task,themap,   &
       &    huv, hbeam, hresid,   &
       &    nx,ny,nu,nv, duv,   &
       &    g_weight, g_v, do_weig,  &
       &    rcol,wcol,mcol,sblock,cpu0,error,uvma, &
       &    method, do_cct, hcct, hclean, do_slow, do_copy, &
       &    sccou, smic)
       !
    save_data(code_save_clean) = .true.
    save_data(code_save_resid) = .true.
    if (error) return ! Make sure nothing happens in case of failure...
    !!PRINT *,'DO_WEIG after ',do_weig
    !
    ! Specify clean beam parameters
    hclean%gil%reso_words = 3
    hclean%gil%majo = method%major
    hclean%gil%mino = method%minor
    hclean%gil%posa = pi*method%angle/180.0
    ! Specify clean beam parameters
    hbeam%gil%reso_words = 3
    hbeam%gil%majo = method%major
    hbeam%gil%mino = method%minor
    hbeam%gil%posa = pi*method%angle/180.0
    !
    ! Get extrema
    hclean%loca%size = nx*ny
    hclean%loca%size= hclean%loca%size*nc
    hclean%gil%ndim = 3
    hclean%gil%dim(1:3) = (/nx,ny,nc/)
    !
    ! Nullify Filtered channels and Compute Clean extrema 
    call cube_flag_extrema(huv%gil%nchan,'CLEAN',mcol,hclean)
    !
    call sic_mapgildas ('CLEAN',hclean,error,dclean)
    call sic_mapgildas ('RESIDUAL',hresid,error,dresid)
    !
  else
    allocate (sccou(3,1,1), smic(1), stat=ier)
    !
    ! New dirty image
    if (allocated(ddirty)) then
      call sic_delvariable ('DIRTY',.false.,error)
      deallocate(ddirty)
    endif
    allocate(ddirty(nx,ny,nc),stat=ier)
    !
    call gildas_null(hdirty)
    hdirty%gil%ndim = 3
    hdirty%gil%dim(1:3) = (/nx,ny,nc/)
    hdirty%r3d => ddirty
    call sic_mapgildas('DIRTY',hdirty,error,ddirty)
    !
    call uvmap_and_restore (task,themap,   &
       &    huv, hbeam, hdirty,   &
       &    nx,ny,nu,nv, duv,   &
       &    g_weight, g_v, do_weig,  &
       &    rcol,wcol,mcol,sblock,cpu0,error,uvma, &
       &    method, do_cct, hcct, hclean, do_slow, do_copy, &
       &    sccou, smic)
    !!PRINT *,'DO_WEIG after ',do_weig
    !
    call cube_flag_extrema(huv%gil%nchan,'DIRTY',mcol,hdirty)
    !
    save_data(code_save_beam) = .true.
    save_data(code_save_dirty) = .true.
    !
    if (error) return ! Make sure nothing happens in case of failure...
    !
    call new_dirty_beam
    !
    ! Define Min Max  - Duplication from uvmap_and_restore
    !
    ! Is this still used anywhere ?
    d_max = hdirty%gil%rmax
    if (hdirty%gil%rmin.eq.0) then
       d_min = -0.03*hdirty%gil%rmax
    else
       d_min = hdirty%gil%rmin
    endif
  endif
  !
  if (LIKE_MOSAIC) THEN
    ! Re-shape the beam, and reset the 4-D pointer,
    ! but show it as a 3-D array in SIC
    if (nb.gt.1) then
      dbeam(:,:,:,:) = reshape(hbeam%r3d,[nx,ny,1,nb])
      deallocate(hbeam%r3d)
    endif
    !
    hbeam%r4d => dbeam
    hbeam%gil%dim(1:4)=[nx,ny,1,nb]
    hbeam%gil%ndim = 4
    !
    ! Transpose the header appropriately
    hbeam%gil%convert(:,4) = hbeam%gil%convert(:,3)
    hbeam%gil%faxi = 4
    hbeam%char%code(4) = 'VELOCITY' ! Frequency would be better...
    hbeam%gil%convert(:,3) = 1.d0
    hbeam%char%code(3) = 'FIELD'    ! Pseudo-mosaic
    hbeam%gil%ndim = 4
    call sic_mapgildas('BEAM',hbeam,error,dbeam)
  ELSE
    hbeam%r4d => dbeam
    hbeam%char%code(4) = 'FIELD'
    hbeam%gil%ndim = 3
    hbeam%gil%convert(:,4) = 1.d0
    call sic_mapgildas('BEAM',hbeam,error,dbeam(:,:,:,1))
  ENDIF
  !
  !
  if (task.ne.'MX') goto 99
  !
  ! There could be code for MX at this level...
  !
99 continue
  if (allocated(w_mapu)) deallocate(w_mapu)
  if (allocated(w_mapv)) deallocate(w_mapv)
  if (allocated(w_grid)) deallocate(w_grid)
  !!PRINT *,'DO_WEIG at end ',do_weig
  return
  !
98 call map_message(seve%e,task,'Memory allocation failure')
  error = .true.
  return
  !
102 format(a,f9.2)
  !
end subroutine sg_map
!
subroutine uvmap_and_restore (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,r_weight, w_v, do_weig,    &
     &    rcol,wcol,mcol,sblock,cpu0,error,uvmax, &
     &    method, do_cct,hcct,hclean,do_slow,do_copy,sccou,smic)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uvmap_and_restore
  use clean_def
  use clean_default
  use clean_beams
  use image_def
  use gbl_message
  use omp_control
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   a different beam per channel.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  ! (optionally) a list of Clean components
  !
  ! Output :
  ! a beam image
  ! a DIRTY or RESIDUAL and CLEAN cube
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Calling Task name
  type (uvmap_par), intent(inout) :: map  ! Mapping parameters
  type (gildas), intent(inout) :: huv     ! UV data set
  type (gildas), intent(inout) :: hbeam   ! Dirty beam data set
  type (gildas), intent(inout) :: hdirty  ! Dirty image data set
  integer, intent(in) :: nx               ! X size
  integer, intent(in) :: ny               ! Y size
  integer, intent(in) :: nu               ! Size of a visibility
  integer, intent(in) :: nv               ! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)
  real, intent(inout), target :: r_weight(nv)    ! Weight of visibilities
  real, intent(inout) :: w_v(nv)          ! V values
  logical, intent(inout) :: do_weig
  !
  real, intent(inout) :: cpu0            ! CPU
  real, intent(inout) :: uvmax           ! Maximum baseline
  integer, intent(inout) :: sblock       ! Blocking factor
  integer, intent(inout) :: rcol         ! Reference frequency channel
  integer, intent(inout) :: wcol         ! Weight channel
  integer, intent(inout) :: mcol(2)      ! First and last channel
  logical, intent(inout) :: error
  logical, intent(in) :: do_cct
  type (clean_par), intent(inout) :: method ! Cleaning Method
  type (gildas), intent(inout) :: hcct      ! Clean component data set
  type (gildas), intent(inout) :: hclean    ! Clean image data set
  logical, intent(in) :: do_slow
  logical, intent(in) :: do_copy
  real, intent(in), target :: sccou(:,:,:)  ! Transpose, compressed Clean Component List
  integer, intent(in), target :: smic(:)    ! Number of clean components per channel
  !
  ! Global variables:
  !
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=pi/180d0/3600d0
  !
  type (gridding) :: conv
  character(len=32) :: cname
  !
  integer :: nchan    ! Number of channels
  integer :: ndata    ! Size of data
  integer :: nbeam    ! Number of beams
  integer :: schunk   ! Number of channels per chunk
  integer :: nblock   ! Number of blocks/chunks ( = nbeam if nbeam.gt.1)
  integer :: ier, icmax
  real(kind=8) :: freq
  integer ctypx,ctypy
  integer lcol,fcol
  real wall,wprt,cpu1
  real xparm(10),yparm(10)
  real(8) :: vref,voff,vinc
  integer ndim, nn(2), lx, ly, kz1
  integer kz,iz,ic,kc,kb,jc,lc
  character(len=message_length) :: chain
  character(len=80) :: meslock
  !
  real :: rms, null_taper(4), wold
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:),  w_grid(:,:), walls(:)
  real, allocatable :: w_weight(:)
  real, allocatable :: beam(:,:)
  real, allocatable :: w_mapu(:), w_mapv(:)
  real, allocatable :: local_wfft(:)
  real uvcell(2)
  real support(2)
  real(8) local_freq
  !
  integer :: ithread, inner_threads, outer_threads, kthread
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  real :: jvm_factor
  real :: toto
  logical :: local_error, abort
  logical :: compute_weight
  !
  integer :: maxic, icc, no, niter
  integer, pointer :: pmic(:)        ! Number of clean components per channel
  real, pointer :: pccou(:,:,:)      ! Transpose, compressed Clean Component List
  real, allocatable :: ouv(:,:)      ! Residual Visibilities
  type (cct_par), allocatable :: p_cct(:)
  type(clean_par) :: my_method
  real :: my_major, my_minor, my_angle
  integer :: ix_min,ix_max,iy_min,iy_max
  real :: bmin,bmax
  character(len=12) :: fname
  integer :: grid_code
  logical :: omp_nested
  !
  logical :: cct_compress = .true.
  integer :: scct
  character(len=20) cspeed
  !
  !
  call imager_tree('UVMAP_AND_RESTORE in restore_many.f90')
  !
  if (do_slow) then
    cspeed = 'Slow Precise'
  else
    cspeed = 'Fast FFT    '    
  endif
  grid_code = 0
  call sic_get_inte('MAP_GRID_CODE',grid_code,error)
  call sic_get_logi('CCT_COMPRESS',cct_compress,error)
  jvm_factor = 1.0
  if (do_cct) then
    call sic_get_real('BEAM_JVM',jvm_factor,error)
    if (abs(jvm_factor-1).gt.0.01) then
      write(chain,'(A,F6.2)')  'Dirty beam scaling factor (JvM factor) ',jvm_factor
      call map_message(seve%i,rname,chain,3)
    endif
  endif
  !
  ! Code:
  elapsed_s = 0
  elapsed_e = 0
  error = .false.
  ndata = nx*ny
  nchan = huv%gil%nchan
  nbeam = hbeam%gil%dim(3)
  !
  schunk = map%beam
  null_taper = 0
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  !
  ! Select the channels
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nchan))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nchan
  else
    mcol(2) = max(1,min(mcol(2),nchan))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nchan)
  nchan = lcol-fcol+1
  !
  ! The Threading must be set here, once NCHAN is defined
  if (schunk.ne.1 .and. nbeam.gt.1) then
    write(chain,'(a,i6,a)') 'Processing one beam for ',schunk,' channels'
    call map_message(seve%w,rname,chain)
  endif
  !
  if (nbeam.eq.1) then
    !
    ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
    if ((sblock.gt.0)) then
      nblock = (nchan+sblock-1)/sblock
      kz = mod(nchan,sblock)
      if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
        if (nblock.ne.1) nblock = nblock-1
      endif
      sblock = (nchan+nblock-1)/nblock
      schunk = min(sblock,nchan)
    else
      schunk = nchan
      nblock = 1
    endif
    ! One might be more clever, and use a number of threads that
    ! depend on the Block Size when sufficient memory is available.
    ! A Block size of 128 channels is in general a nice goal.
    ! 4 Threads in general enough, but user customizable through 
    ! SIC Variable OMP_MAP%OUTER_GOAL, accessible by ompget_outer_goal()
    !$ outer_threads = min(omp_get_max_threads(),ompget_outer_goal()) 
    if (nblock.lt.outer_threads) then ! Split in more Blocks if possible
      nblock = min(outer_threads,nchan)
      sblock = (nchan+nblock-1)/nblock
      write(chain,'(A,I6,A,I8,A)') 'Reset ',nblock,' blocks of ',&
        & sblock,' channels for Threading'
      call map_message(seve%w,rname,chain)
      schunk = sblock
    endif
    !
    ! Maximize Inner thread number (so minimize outer_threads) if possible
    if (outer_threads.gt.nchan) outer_threads = nchan 
    write(chain,'(A,I6,A,I8,A,I0,A)') 'Using ',nblock,' blocks of ',&
        & schunk,' channels'
    call map_message(seve%w,rname,chain)    
  else
    nblock = nbeam  ! For the Nesting of OMP parallel codes
  endif
  !
  ! Compute observing sky frequency for U,V cell size
  if (rcol.eq.0) then
    freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
  else
    freq = gdf_uv_frequency(huv, dble(rcol) )
  endif
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Process sorted UV Table according to the type of beam produced
  !
  allocate (w_w(nv),w_weight(nv),walls(nbeam),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Weight arrays')
    error = .true.
    return
  endif
  w_v(:) = uvdata(2,1:nv)
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%w,rname,chain,3)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  !
  ! Get FFTs and beam work spaces
  allocate (tfgrid(schunk+1,lx,ly),ftbeam(nx,ny),beam(nx,ny),&
    & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)), &
    & w_xgrid(nx),w_ygrid(ny),w_grid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate TF arrays')
    error = .true.
    return
  endif
  !
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  !
  ! Prepare grid correction,
  call grdtab (ny, conv%vbuff, conv%vbias, w_ygrid)
  call grdtab (nx, conv%ubuff, conv%ubias, w_xgrid)
  !
  ! Make beam, not normalized
  call uvmap_headers(huv,nx,ny,nbeam,schunk,map,mcol,hbeam,hdirty,error)  
  !
  if (do_cct) then
    call gdf_copy_header(hdirty,hclean,error)
    maxic = hcct%gil%dim(3) ! or maxic = maxval(smic)
    no = 7+3*schunk
    if (cct_compress) then
      ! Compress all CCTs first
      scct = hcct%gil%dim(2)
      allocate (ouv(no,huv%gil%dim(2)), p_cct(maxic), stat=ier)
    else
      ! Perform per-block compression        
      scct = schunk
      allocate (ouv(no,huv%gil%dim(2)), p_cct(maxic), stat=ier)
    endif
  else
    no = 7+3*schunk
    allocate (ouv(no,huv%gil%dim(2)), stat=ier)
    maxic = 0
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV data allocation error')
    error = .true.
    return
  endif
  !
  cname = rname
  !
  error = .false.
  !
  ! This is a non-Parallel Section, set Outer Thread Nesting to (1)
  ! and inner to (Max)
  !$ elapsed_s = omp_get_wtime()
  !$ kthread = 1      
  !$ inner_threads = omp_get_max_threads()
  !$ call ompset_thread_nesting(rname, kthread, inner_threads, omp_nested)
  !
  ! Print *,'WCOL ',wcol,' RCOL ',rcol,' FREQ '
  ! Loop over blocks
  wold = 0.
!  read(5,*) wall
  if (do_weig.and.nbeam.eq.1) then
    do ic = fcol,lcol,schunk   
      wall = 0.    ! Initialize, this is mandatory
      !
      lc = min(lcol,ic+schunk-1) ! Bug correction 09-06-2016
      !
      if (sic_ctrlc()) then
        write(*,*) ' '
        write(chain,'(A,I0,A)') 'Abort request received'
        call map_message(seve%w,rname,chain,3)
        exit 
      endif
      if (abort) cycle
      !
      ! The weight channel choice depends on BEAM_STEP
      jc = min(lcol,ic+schunk/2)            ! The default weight channel here in auto mode...
      if (nbeam.eq.nchan) jc = lc           ! If One Beam per Channel
      if (nbeam.eq.1) jc = wcol             ! Reset the default weight channel
      !!Print *,'NBEAM ',nbeam,'; NCHAN',nchan,'; LC',lc,'; JC',jc,'; Wcol',wcol
      if (ic.le.wcol .and. ic+schunk.gt.wcol) then
        continue
      else
        cycle !! compute_weight = .false.
      endif
      !
      kz = min(schunk,lcol-ic+1)            ! The number of channels
      !! Print *,'IC ',ic,' JC ',jc,'MCOL ',fcol,lcol,' Schunk ',schunk
      !Print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', Schunk ',schunk
      !
      kb = (ic-fcol)/schunk+1
      if (kb.gt.nbeam .or. kb.lt.1) then
        !
        ! *** Actually, this is perfectly acceptable in the One Beam, Many Chunks case
        if (nbeam.gt.1) Print *,'Programming error, expected 0 < ',kb,' < ',nbeam+1
        kb = nbeam
      endif
      !
      w_w(:) = uvdata(7+3*jc,:)
      !
      wold = sump(nv,w_w)
      !
      ! Search for a non empty weight channel
      if ((wold.eq.0).and.(nbeam.ne.nchan))  then
        do kc=ic,min(ic+schunk,lcol) ! not  ,huv%gil%nchan)
          if (kc.ne.jc) then
            w_w(:) = uvdata(7+3*kc,:)
            wold = sump(nv,w_w)
            if (wold.ne.0) then
              jc = kc
              exit
            endif
          endif
        enddo
      endif
      !
      if (wold.eq.0) then
        write(chain,'(A,I0,A,I0)') 'Channel ',jc, ' has zero weight from ',lc
        hbeam%r3d(:,:,kb) = 0
        hdirty%r3d(:,:,kb) = 0
        walls(kb) = 0.0
        if (nbeam.eq.1) then
          call map_message(seve%e,rname,chain)
          error = .true.
        else
          call map_message(seve%w,rname,chain)
        endif
        cycle
      else
        wall = 1e-3/sqrt(wold)
        write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
        call prnoise('UV_MAP',trim(chain),wall,rms)
        walls(kb) = wall
        !! Print *,'Ithread ',ithread,' Wold ',wold,kb,' Walls(kb) ',kb,compute_weight
      endif
      !
      local_error = .false.
      call doweig (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,    &            ! U, V pointers
         &    jc,     &            ! Weight channel
         &    map%uniform(1),   &  ! Uniform UV cell size
         &    w_weight,   &        ! Weight array
         &    map%uniform(2),   &  ! Fraction of weight
         &    w_v,              &  ! V values
         &    local_error,      &
         &    grid_code)           ! Gridding method (for tests)
      if (local_error)  then
        error = .true.
        exit
      endif
      !
      ! Should also plug the TAPER here, rather than in DOFFT later  !
      call dotape (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,   &             ! U, V pointers
         &    map%taper,  &        ! Taper
         &    w_weight)            ! Weight array
      !
      ! Re-normalize the weights and re-count the noise
      wall = sump(nv,w_weight)
      if (wall.ne.wold) then
        call scawei (nv,w_weight,w_w,wall)
        wprt = 1E-3/sqrt(wall)
        write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
        call prnoise('UV_MAP',trim(chain),wprt,rms)
      endif
      !
      ! Declare the weight ready
      r_weight = w_weight
    enddo
    ! Ok, we got the weights now...
    do_weig = .false.
  else if (.not.do_weig) then
    wold = sump(nv,r_weight)
    !    
  endif
  !
  if (nbeam.gt.1) then
    ! Set outer to NBeam, Inner to what is left
    !$ inner_threads = omp_get_max_threads()
    !$ outer_threads = min(inner_threads,nbeam)
    !$ call ompset_thread_nesting(rname, outer_threads, inner_threads, omp_nested)
    !$ call omp_set_num_threads(outer_threads)
  else
    !$ inner_threads = omp_get_max_threads()
    !$ if (do_cct) then
    !$   call ompset_thread_nesting(rname, outer_threads, inner_threads, omp_nested)
    !$ else
    !$   outer_threads = inner_threads 
    !$   call ompset_thread_nesting(rname, outer_threads, inner_threads, omp_nested)
    !$ endif
  endif
!  Print *,'Nbeam ',nbeam,'DO_WEIG',do_weig
!  read(5,*) wall
  ! Loop over blocks
  !
  ! !$OMP PARALLEL if (.not.cct_compress) DEFAULT(none) &      ! For UV_MAP first
  !$OMP PARALLEL if (nblock.gt.1) NUM_THREADS(min(nblock,inner_threads)) DEFAULT(none) &      ! For UV_MAP first
  !$OMP PRIVATE(tfgrid,ftbeam,beam,w_weight,w_w) &
  !$OMP PRIVATE(w_mapu,w_mapv,w_grid) &
  !$OMP PRIVATE(local_wfft,chain) &
  !$OMP PRIVATE(local_freq,support,wall,rms,uvcell,local_error) &
  !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1, toto, jc,lc, cname) &
  !$OMP SHARED(walls,schunk,nbeam) &
  !$OMP SHARED(nu,nv,nx,ny,nchan,ndata,fcol,lcol,lx,ly, outer_threads) &
  !$OMP SHARED(map,null_taper,error) &
  !$OMP SHARED(conv,freq,do_weig, r_weight) &
  !$OMP SHARED(nn,ndim,huv,hbeam,hdirty,rname,meslock) &
  !$OMP SHARED(w_xgrid,w_ygrid,w_v,uvdata) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread) &
  !$OMP SHARED(maxic,hcct,hclean,no,do_cct,do_slow,method,do_copy) & ! For RESTORE
  !$OMP PRIVATE(pmic,pccou) & 
  !$OMP SHARED(smic,sccou,cct_compress) & 
  !$OMP PRIVATE(niter,ouv,p_cct,ier) &
  !$OMP PRIVATE(ix_min,ix_max,iy_min,iy_max,bmin,bmax,icmax) &
  !$OMP PRIVATE(my_method,fname,compute_weight) SHARED(my_major, my_minor, my_angle) &
  !$OMP SHARED(omp_debug) & 
  !$OMP SHARED(rcol, wold, wcol, grid_code, abort, jvm_factor, cspeed) &
  !$OMP SHARED(beam_defined, beam_fitted, beams_param)
  kz = 1 ! test for bug below
  !
  ! Print *,'KZ ',kz,' NChan ',nchan,' ndata ',ndata
  my_method = method
  my_method%method = 'RESTORE'
  !
  abort = .false.
  if (.not.cct_compress) then
    allocate(pccou(3,maxic,schunk), pmic(schunk), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Cannot allocate CCT arrays')
      abort = .true.
    endif    
  endif 
  !
  !$OMP DO SCHEDULE(STATIC) 
  do ic = fcol,lcol,schunk   
    wall = 0    ! Initialize, this is mandatory
    !
    lc = min(lcol,ic+schunk-1) ! Last channel in chunk 
    !
    ithread = 1
    !$ ithread = omp_get_thread_num()+1
    !!$ if (ithread.eq.1) Print *,'Nbeam ',nbeam,'DO_WEIG',do_weig, ' NumThreads ',omp_get_num_threads()
    !$ elapsed_s = omp_get_wtime()
    !$ write(cname,'(A,A,I0,A)') trim(rname),'(',ic,')' 
    !
    if (sic_ctrlc()) then
      write(*,*) ' '
      write(chain,'(A,I0,A)') 'Abort request received by thread ',ithread
      call map_message(seve%w,rname,chain,3)
      abort = .true.
    endif
    if (abort) cycle
    !
    ! The weight channel choice depends on BEAM_STEP
    jc = min(lcol,ic+schunk/2)            ! The default weight channel here in auto mode...
    if (nbeam.eq.nchan) jc = lc           ! If One Beam per Channel
    if (nbeam.eq.1) jc = wcol             ! Reset the default weight channel
    !!Print *,'NBEAM ',nbeam,'; NCHAN',nchan,'; LC',lc,'; JC',jc,'; Wcol',wcol
    compute_weight = do_weig
    !
    kz = min(schunk,lcol-ic+1)            ! The number of channels
    !! Print *,'IC ',ic,' JC ',jc,'MCOL ',fcol,lcol,' Schunk ',schunk
    !Print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', Schunk ',schunk
    !
    kb = (ic-fcol)/schunk+1               ! The current beam number
    if (kb.gt.nbeam .or. kb.lt.1) then
      !
      ! *** Actually, this is perfectly acceptable in the One Beam, Many Chunks case
      if (nbeam.gt.1) Print *,'Programming error, expected 0 < ',kb,' < ',nbeam+1
      kb = nbeam
    endif
    !
    ! Load Natural weight array
    w_w(:) = uvdata(7+3*jc,:)
    !
    if (compute_weight) then
      !
      ! Compute the weight for this Chunk
      ! Natural weight first
      wold = sump(nv,w_w)
      !!Print *,'Wold ',wold,jc,ithread
      !
      ! Search for a non empty weight channel
      if ((wold.eq.0).and.(nbeam.ne.nchan))  then
        do kc=ic,min(ic+schunk,lcol) ! not  ,huv%gil%nchan)
          if (kc.ne.jc) then
            w_w(:) = uvdata(7+3*kc,:)
            wold = sump(nv,w_w)
            if (wold.ne.0) then
              jc = kc
              exit
            endif
          endif
        enddo
      endif
      !
      if (wold.eq.0) then
        write(chain,'(A,I0,A,I0)') 'Channel ',jc, ' has zero weight from ',lc
        hbeam%r3d(:,:,kb) = 0
        hdirty%r3d(:,:,kb) = 0
        walls(kb) = 0.0
        if (nbeam.eq.1) then    ! This should no longer happen
          call map_message(seve%e,rname,chain)
          error = .true.
        else
          call map_message(seve%w,rname,chain)
        endif
        cycle
      else
        wall = 1e-3/sqrt(wold)
        !!write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
        !!call prnoise('UV_MAP',trim(chain),wall,rms)
        walls(kb) = wall
  !!      Print *,'Ithread ',ithread,' Wold ',wold,kb,' Walls(kb) ',kb,compute_weight
      endif
      !
      ! Compute the Actual (Robust + Taper) weights from this
      !
      local_error = .false.
      call doweig (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,    &            ! U, V pointers
         &    jc,     &            ! Weight channel
         &    map%uniform(1),   &  ! Uniform UV cell size
         &    w_weight,   &        ! Weight array
         &    map%uniform(2),   &  ! Fraction of weight
         &    w_v,              &  ! V values
         &    local_error,      &
         &    grid_code)           ! Gridding method (for tests)
      if (local_error)  then
        error = .true.
        cycle
      endif
      !
      ! Should also plug the TAPER here, rather than in DOFFT later  !
      call dotape (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,   &             ! U, V pointers
         &    map%taper,  &        ! Taper
         &    w_weight)            ! Weight array
      !
      ! Re-normalize the weights and re-count the noise
      wall = sump(nv,w_weight)
      if (wall.ne.wold) call scawei (nv,w_weight,w_w,wall)
      !
!OLD      ! Declare the weight ready 
!OLD      if (nbeam.eq.1) then
!OLD        if (do_weig) then
!OLD          r_weight = w_weight
!OLD          Print *,'Assigned r_weight ',ithread,' but should not be there...'
!OLD        endif
!OLD      endif
      !
      write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
      walls(kb) = 1e-3/wall
      call prnoise(cname,trim(chain),walls(kb),rms)
      !
    else
      chain = 'Reusing weights'
      !$  write(chain(20:),'(a,i4)') ' - Thread ',ithread
      call map_message(seve%d,cname,chain)
      w_weight(:) = r_weight
      !
      wall = sump(nv,w_weight)
      if (wall.ne.wold) call scawei (nv,w_weight,w_w,wall)
      walls(kb) = 1e-3/sqrt(wall)
    endif
    !
    ! If null weight, move to next channel range
    if (wall.eq.0) then
      write(chain,'(a,i6,a)') 'Plane ',ic,' has zero weight' 
      call map_message(seve%w,cname,chain)
      cycle
    endif
    !
    ! Then compute the Dirty Beam
    if (rcol.eq.0) then
      local_freq = gdf_uv_frequency(huv, dble(ic))
    else
      local_freq = freq
    endif
    uvcell = map%uvcell * (freq / local_freq)
    support = map%support * (freq / local_freq)
    !
    call docoor (lx,-uvcell(1),w_mapu)
    call docoor (ly,uvcell(2),w_mapv)
    !
    ! Optionally remove the Clean components
    icmax = 0
    !
    if (maxic.ne.0) then
      ! Compact the Clean components first if not already done. Beware that if MCOL # 0, the
      ! CCT and Clean images channel range are offset from one another
      if (cct_compress) then
        pmic => smic(ic-fcol+1:lc-fcol+1)
      else
        call uv_clean_sizes(hcct,hcct%r3d,pmic,ic-fcol+1,lc-fcol+1) !! SOMEHOW ICC = IC-FCOL+1 and LCC = LC-FCOL+1 ???
      endif
      icmax = maxval(pmic)
      if (icmax.ne.0) then
        if (cct_compress) then
          freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
          pccou => sccou(:,:,ic-fcol+1:lc-fcol+1)
        else
          call uv_squeeze_clean(nchan,hcct%r3d,pccou, pmic,ic-fcol+1,lc-fcol+1) 
          write(chain,'(A,I0,A,4(I0,1X))') 'Clean sizes:  Max [',icmax,'] ',pmic(1:min(kz,4))
          call map_message(seve%d,cname,chain)        
        endif
        ! From here, OUV will be a (subset) copy of the whole UV data 
        ! and we compute the residuals
        freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
        if (do_slow) then
          call uv_removes_clean(nv,uvdata,ouv,lc-ic+1,pmic,pccou,freq,ic,lc) 
        else
          call uv_removef_clean(hcct,uvdata,ouv,lc-ic+1,pmic,pccou,freq,ic,lc)
        endif
      else
        ! No Clean component to remove: just extract.
        if (do_copy) call uv_extract_clean(uvdata,ouv,lc-ic+1,ic,lc)
        call map_message(seve%w,cname,'No valid Clean Component')
      endif
      !$  elapsed_e = omp_get_wtime()
      !$  elapsed = elapsed_e - elapsed_s
      !$  write(chain,'(a,f9.2,a)') 'Finished '//cspeed//' Clean subtraction ',elapsed
      !$  call map_message(seve%i,cname,chain)
    else if (do_copy) then
      call uv_extract_clean(uvdata,ouv,lc-ic+1,ic,lc)
    endif
    !
    if (.not.do_copy .and. icmax.eq.0) then
      !$ if (omp_debug) Print *,'OMP No copy '
      !
      ! Compute FFTs
      call dofft (nu,nv,          &   ! Size of visibility array
           &    uvdata,           &   ! Visibilities
           &    1,2,              &   ! U, V pointers
           &    ic,               &   ! First channel to map
           &    kz,lx,ly,         &   ! Cube size
           &    tfgrid,           &   ! FFT cube
           &    w_mapu,w_mapv,    &   ! U and V grid coordinates
           &    support,uvcell,null_taper, &  ! Gridding parameters
           &    w_weight,w_v,     &    ! Weight array + V Visibilities
           &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
    else
      !$ if (omp_debug) Print *,'OMP With copy '
      call dofft (no,nv,          &   ! Size of visibility array
           &    ouv,              &   ! Visibilities
           &    1,2,              &   ! U, V pointers
           &    1,                &   ! First channel to map
           &    kz,lx,ly,         &   ! Cube size
           &    tfgrid,           &   ! FFT cube
           &    w_mapu,w_mapv,    &   ! U and V grid coordinates
           &    support,uvcell,null_taper, &  ! Gridding parameters
           &    w_weight,w_v,     &    ! Weight array + V Visibilities
           &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
      !
    endif
    !
! *** May Compute the beam only if needed ***
! *** Currently, the extra cost of the Beam if small, so we re-compute it ***
! ****  in every Block ***
    !
    kz1 = kz+1
    call extracs(kz1,nx,ny,kz1,tfgrid,ftbeam,lx,ly)
    call fourt  (ftbeam, nn,ndim,-1,1,local_wfft)
    beam = 0.0
    call cmtore (ftbeam, beam ,nx,ny)
    call chkfft (beam, nx,ny, error)
    !!   Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
    !!Print *,'NU,NV ',nu,nv
    !!Print *,'IC ',ic
    !!Print *,'KZ,LX,LY ',kz,lx,ly
    !!Print *,'support ',support,' uvcell ',uvcell, ' null_taper ',null_taper
    !!Print *,'conv%ubias,conv%vbias,map%ctype ',conv%ubias,conv%vbias,map%ctype
    !!Print *, ' '
    if (error) then
      Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1),' NO ',no
      Print *,'Local freq ',local_freq
      Print *,'KZ, LX, LY ', kz,lx,ly, ' nx,ny ',nx,ny, ' Schunk ',schunk
      call map_message(seve%e,rname,'Inconsistent pixel size')
      cycle
    endif
    !
    ! Compute grid correction,
    ! Normalization factor is applied to grid correction, for further
    ! use on channel maps.
    !
    ! Make beam, not normalized
    call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,beam)  ! grid correction
    !
    ! Normalize and Free beam
    call docorr (beam,w_grid,nx*ny)
    !
    ! Fit beam if needed
    if (do_cct) then
      !
      ! If the fit has already been done, we can use it
      if (beam_defined) then
!        IFIELD = ?   and       IPLANE = ?
        my_method%major = beam_fitted(1) * sec_to_rad
        my_method%minor = beam_fitted(2) * sec_to_rad
        my_method%angle = beam_fitted(3)   ! Keep it Degree...
        if (ic.eq.fcol) then
          call pribeam(rname,method%major,method%minor,my_method%angle, 1, ic, beam_fitted(4))
          my_major = my_method%major
          my_minor = my_method%minor
          my_angle = my_method%angle
        endif
        call beam_plane(my_method,hbeam,hdirty)
        if (beam_fitted(4)-beams_param(4,my_method%ibeam,1).gt.0.01*beam_fitted(4)) then
          write(chain,'(A,I0,A,F7.3)') 'Beam plane is ',my_method%ibeam,' JVM factor ', &
            & beams_param(4,my_method%ibeam,1)
          call map_message(seve%i,cname,chain)
        endif
      else
        !
        my_method%major = 0
        my_method%minor = 0
        my_method%bzone=[1,1,nx,ny]
        call maxmap(beam,nx,ny,my_method%bzone,   &
            &      bmax,ix_max,iy_max,   &
            &      bmin,ix_min,iy_min)
        my_method%beam0 = [ix_max,iy_max]
        my_method%ibeam = kb
        !$OMP CRITICAL
        if (ic.eq.fcol) then
          fname = rname  ! Print beam
        else
          fname = ' '    ! Do not print beam
        endif
        !
        call beam_unit_conversion(my_method)
        call fibeam (fname,beam,nx,ny,   &
         &    my_method%patch(1),my_method%patch(2),my_method%thresh,   &
         &    my_method%major,my_method%minor,my_method%angle,   &
         &    hbeam%gil%convert,error)
        !
        my_major = my_method%major
        my_minor = my_method%minor
        my_angle = my_method%angle
        ! Print *,'fit results ',my_method%major, my_method%minor, my_method%angle
        !$OMP END CRITICAL
      endif
    endif
    !
    !
! *** End of LOCK in case of One Beam ***
    ! Wait for gridding correction to be computed
!    if (nbeam.eq.1) then
!      !$   if (ic.eq.fcol) then
!      !$     Print *,'Thread ',ithread,' freeing lck_grid'
!      !$     call omp_unset_lock(lck_grid)  ! Release the lock
!      !$   else
!      !$     Print *,'Thread ',ithread,' waiting for lck_grid'
!      !$     call omp_set_lock(lck_grid)    ! Wait for the Lock to be grasped
!      !$     Print *,'Thread ',ithread,' got lck_grid'
!      !$     call omp_unset_lock(lck_grid)  ! and free it immediately
!      !$   endif
!    endif
! *** End of One Beam region ***
    !
    ! Write beam
    hbeam%r3d(:,:,kb) = beam
    !
    ! Now extracts the Image planes...
    do iz=1,kz
      call extracs(kz+1,nx,ny,iz,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
      call cmtore (ftbeam,beam,nx,ny)
      call docorr (beam,w_grid,ndata)
      ! Write the subset
      kc = ic-fcol+iz
      hdirty%r3d(:,:,kc) = beam
      !
      if (do_cct) then
        !
        ! And add the Clean Components
        ! Recover the component list in pixels
        !
        niter = pmic(iz)
        do icc = 1,pmic(iz)
          !
          ! The NINT is required because of rounding errors
          p_cct(icc)%ix = nint( (pccou(1,icc,iz)-hdirty%gil%convert(2,1)) /  &
              &        hdirty%gil%convert(3,1) + hdirty%gil%convert(1,1))
          p_cct(icc)%iy = nint( (pccou(2,icc,iz)-hdirty%gil%convert(2,2)) /  &
              &        hdirty%gil%convert(3,2) + hdirty%gil%convert(1,2))
          p_cct(icc)%value = pccou(3,icc,iz)
        enddo
        !
        ! Compute Clean image and add back residual
        if (niter.gt.0) then
          my_method%n_iter = niter
          call clean_make90(my_method,hclean,hclean%r3d(:,:,kc),p_cct)
          ! There is only 1 field in this case, so only 1 jvm_factor per channel
          hclean%r3d(:,:,kc) = hclean%r3d(:,:,kc) + hdirty%r3d(:,:,kc) * jvm_factor
        else
          hclean%r3d(:,:,kc) = hdirty%r3d(:,:,kc) * jvm_factor
        endif
        if (niter.lt.maxic) p_cct(niter+1)%value = 0 ! Required to signal end-of-list
      endif
      !
    enddo
    !
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End plane ',kc,' Time ',elapsed,' Thread ',ithread
    call map_message(seve%d,cname,chain)
    !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !$  call omp_set_nested(omp_nested)
  !$  call omp_set_num_threads(inner_threads)
  if (abort) then
    call map_message(seve%e,cname,'Abort by user',3)
    error = .true.
  endif
  if (error) return
  !
  if (nbeam.eq.1) do_weig = .false.
  !
  method%major = my_major
  method%minor = my_minor
  method%angle = my_angle
  !
  ! Set the clean Beam value too
  !
  call gag_cpu(cpu1)
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  if (elapsed.eq.0) then
    write(chain,102) 'Finished maps CPU ',cpu1-cpu0
  else
    write(chain,102) 'Finished maps Elapsed ',elapsed,'; CPU ',cpu1-cpu0
  endif
  call map_message(seve%i,rname,chain)
  !
  call cube_minmax('BEAM',hbeam,error)
  !
  wall = maxval(walls(1:nbeam))
  call prnoise(rname,'Expected',wall,rms)
  hdirty%gil%noise = wall
  hclean%gil%noise = wall ! Also for the Restored clean map
  !  !
  ! Delete scratch space
  error = .false.
  if (nbeam.ne.1)  deallocate(w_grid)
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  return
  !
102 format(a,f9.2,a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
end subroutine uvmap_and_restore
!
subroutine uv_removes_clean(nv,duv,ouv,nc,mic,dcct,freq,first,last)
  use image_def
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER   Support for UV_RESTORE
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table.
  !       Semi-Slow version using interpolation from pre-tabulated
  !       Sin/Cos, which could still be optimized
  !-----------------------------------------------------------------
  integer, intent(in) :: nv         ! Number of visibilities
  real, intent(in) :: duv(:,:)      ! UV data set
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: mic(:)     ! Number of Clean Components
  real, intent(out) :: ouv(:,:)     ! Extracted UV data set
  real, intent(in) :: dcct(:,:,:)   ! Clean component
  real(8), intent(in) :: freq       ! Apparent observing frequency
  integer, intent(in) :: first      ! First channel
  integer, intent(in) :: last       ! Last channel
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k=2.d0*pi/299792458.d-6
  integer, external :: ompget_inner_threads
  !
  real(8) :: pidsur            ! 2*pi*D/Lambda
  real(8) :: phase, cp, sp
  real(4) :: rvis, ivis, value
  integer ii, ir, iw
  integer oi, or, ow
  integer ic,iv,jc,kc
  !
  integer :: no, icmax
  integer :: nthread
  !
  pidsur = f_to_k * freq
  !
  no = ubound(mic,1)
  if (no.lt.last-first+1 .or. no.gt.ubound(dcct,3)) then
    Print *,'Remove Clean Slow dimension error ',no,last-first+1,ubound(dcct,3)
  endif
  icmax = maxval(mic)
  if (icmax.gt.ubound(dcct,2))  then
    Print *,'Remove Clean Slow -- too many Clean Comp.',icmax,ubound(dcct,2)
  endif
  !!Print *,'CCT Bounds ',ubound(dcct),' FIRST ',first,' LAST ',last
  !
  ! Remove clean component from UV data set
  !
  !$ nthread = ompget_inner_threads() 
  !$OMP PARALLEL DEFAULT(none) NUM_THREADS(nthread) &
  !$OMP    & SHARED(duv,ouv,dcct)  SHARED(pidsur,nv,first,last,mic) &
  !$OMP    & PRIVATE(iv,jc,ic,kc,ir,ii,iw,or,oi,ow,phase,rvis,ivis,cp,sp) &
  !$OMP    & PRIVATE(value) 
  !
  !$OMP DO SCHEDULE(DYNAMIC,32)
  do iv=1,nv            ! Visibilies
    ouv(1:7,iv) = duv(1:7,iv)
    do jc = first,last  ! Channels
      ir = 5+3*jc
      ii = 6+3*jc
      iw = 7+3*jc
      !
      kc = jc-first+1
      or = 5+3*kc      
      oi = 6+3*kc
      ow = 7+3*kc
      !
      ouv(or,iv) = duv(ir,iv)
      ouv(oi,iv) = duv(ii,iv)
      do ic = 1,mic(kc) ! Clean components
        if (dcct(3,ic,kc).ne.0) then
          value = dcct(3,ic,kc)
          phase = (ouv(1,iv)*dcct(1,ic,kc) + ouv(2,iv)*dcct(2,ic,kc))*pidsur
          cp = cos(phase)
          sp = sin(phase)
          !!call cossin(phase,cp,sp)
          rvis = value*cp
          ivis = value*sp
          ouv(or,iv) = ouv(or,iv) - rvis   ! Subtract
          ouv(oi,iv) = ouv(oi,iv) - ivis
        else if (iv.eq.1) then
          Print *,'Premature end of work for channel ',jc, kc, mic(kc)
          exit ! End of work, jump to next channel
        endif
      enddo             ! Clean components
      ouv(ow,iv) = duv(iw,iv)
    enddo               ! Channels
  enddo                 ! Visibilities
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine uv_removes_clean
!
subroutine uv_squeeze_clean(nc,ccin,ccou, mic, first, last)
  use image_def
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER   Support for UV_RESTORE
  !   Compact the component list by summing up all values at the
  !   same position in a range of channels.
  !   The output list has a transposed order
  !-----------------------------------------------------------------
  integer, intent(in) :: nc         ! Number of channels
  real, intent(in) :: ccin(:,:,:)   ! Initial Clean Component List
  real, intent(out) :: ccou(:,:,:)  ! Resulting list
  integer, intent(inout) :: mic(:)  ! Number of Clean component per channel
  integer, intent(in) :: first      ! First channel
  integer, intent(in) :: last       ! Last channel
  !
  integer :: ii,jj,ic,jc,kc
  integer :: ki    ! Number of different components per channel
  integer :: nin   ! Number of input channels
  logical doit
  integer :: ithread
  !
  ccou = 0
  !
  nin = size(ccin,2)    ! That is the number of channels
  if (nin.eq.1) then
    ki = 0
    do ii=1,mic(1)
      if (ccin(3,1,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,jj,1).eq.ccin(1,1,ii)) then
            if (ccou(2,jj,1).eq.ccin(2,1,ii)) then
              doit = .false.
              ccou(3,jj,1) = ccou(3,jj,1) + ccin(3,1,ii)
              exit
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          ccou(1:3,ki,1) = ccin(1:3,1,ii)
        endif
      endif
    enddo
    mic(1) = ki
    !
    ! Then duplicate 
    do ic=2,last-first+1
      ccou(:,:,ic) = ccou(:,:,1)
    enddo
  else
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(ccin,ccou) &
    !$OMP    & SHARED(first,last, mic, nin) &
    !$OMP    & PRIVATE(ic,jc,kc,ki, ii, doit, ithread)   
    !
    ithread = 1
    !$ ithread = omp_get_thread_num()+1
    !$OMP DO
    do ic=first,last
      jc = ic-first+1
      ki = 0
      do ii=1,mic(jc)
        kc = min(ic,nin)
        if (ccin(3,kc,ii).eq.0) then
          exit
        else
          doit = .true.
          do jj=1,ki
            if (ccou(1,jj,jc).eq.ccin(1,kc,ii)) then
              if (ccou(2,jj,jc).eq.ccin(2,kc,ii)) then
                doit = .false.
                ccou(3,jj,jc) = ccou(3,jj,jc) + ccin(3,kc,ii)
                exit
              endif
            endif
          enddo
          if (doit) then
            ki = ki+1
            ccou(1:3,ki,jc) = ccin(1:3,ic,ii)
          endif
        endif
      enddo
      mic(jc) = ki
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine uv_squeeze_clean
!
subroutine uv_removef_clean(hcct,duv,ouv,nc,mic,dcct,freq,first,last)
  use image_def
  use imager_interfaces, except_this => uv_removef_clean
  use gbl_message
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER   Support for UV_RESTORE
  !     Compute visibilities for a UV data set according to a
  !     set of Clean Components , and remove them from the original
  !     UV table
  !   This version is for tranpose CCT data (3,ncomp,nchannels)
  !   and uses an intermediate FFT for speed
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of Clean Components Table
  integer, intent(in) :: nc         ! Number of channels
  integer, intent(in) :: mic(:)     ! Number of Clean Components
  real, intent(in) :: duv(:,:)      ! Input visibilities
  real, intent(out) :: ouv(:,:)     ! Output visibilities
  real, intent(in) :: dcct(:,:,:)   ! Clean components
  real(8), intent(in) :: freq       ! Apparent observing frequency
  integer, intent(in) :: first      ! First
  integer, intent(in) :: last       ! and last channel
  !
  integer :: nv    ! Number of visibilities
  integer :: mv    ! Size of a visibility
  integer :: nx,ny
  integer :: mx,my
  integer :: kx,ky
  real :: rx,ry,dxy
  real :: value
  complex, allocatable :: cfft(:,:,:)
  real, allocatable :: work(:)
  integer :: iplane,ic,ix,iy,iv,ier, dim(2)
  logical :: error
  real(8) :: xinc, yinc, xref, yref, xval, yval
  real(8), parameter :: pi=3.14159265358979323846d0
  integer :: ithread, mthread, lx,ly
  !
  nv = ubound(duv,2)    ! Number of Visibilities
  !! Print *,'Number of visibilities ',nv,' in removef_clean'
  mv = 7+3*nc
  !
  ! Image size
  mx = (hcct%gil%convert(1,1)-1)*2
  my = (hcct%gil%convert(1,3)-1)*2
  !
  ! Define the image size
  rx = log(float(mx))/log(2.0)
  kx = nint(rx)
  if (kx.lt.rx) kx = kx+1
  nx = 2**kx
  ry = log(float(my))/log(2.0)
  ky = nint(ry)
  if (ky.lt.ry) ky = ky+1
  ny = 2**ky
  kx = max(nx,ny)
  kx = min(4*kx,4096)
  !
  ! If the image is already fine enough, use it "as is"
  !    even if it is not a power of two...
  nx = max(kx,mx)  ! max(kx,nx) for power of two
  ny = max(kx,my)  ! max(kx,ny) for power of two
  !
  ! Get Virtual Memory & compute the FFT
  allocate(cfft(nx,ny,nc),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'UV_RESTORE','uv_removef_clean -- allocation error')
    error = .true.
    return
  endif
  !
  xref = hcct%gil%convert(1,1)
  xval = hcct%gil%convert(2,1)
  xinc = hcct%gil%convert(3,1)
  yref = hcct%gil%convert(1,3)
  yval = hcct%gil%convert(2,3)
  yinc = hcct%gil%convert(3,3)
  dim = [nx,ny]
  !
  !  call fourt_plan(ftbeam,dim,2,1,1)
  ithread = 1
  !
  kx = mx/2+1
  lx = nx/2+1
  ky = my/2+1
  ly = ny/2+1
  !
  ! Oops, must set the number of threads according to number of channels
  ! and available Thread nesting
  mthread = 1
  !$ mthread = ompget_inner_threads()
  mthread = min(nc,mthread)
  !
  !$OMP PARALLEL IF (nc.gt.1) DEFAULT(none) NUM_THREADS(mthread) SHARED(dcct,cfft) &
  !$OMP    & SHARED(nc,mic,nx,ny,mx,my,dim,xinc,yinc,xref,yref,xval,yval) &
  !$OMP    & PRIVATE(iplane,ic,ix,iy,value,ier) PRIVATE(work) &
  !$OMP    & PRIVATE(dxy,ithread) SHARED(kx,lx,ky,ly)
  !
  !$ ithread = omp_get_thread_num()+1
  allocate(work(2*max(nx,ny)),stat=ier)
  !$OMP DO
  do iplane=1,nc
    cfft(:,:,iplane) = 0.0
    do ic=1,mic(iplane)
      if (dcct(3,ic,iplane).eq.0) exit
      !
      value = dcct(3,ic,iplane)
      ! The NINT is required because of rounding errors
      ix = nint( (dcct(1,ic,iplane)-xval) / xinc + xref )
      iy = nint( (dcct(2,ic,iplane)-yval) / yinc + yref )
      cfft(ix-kx+lx,iy-ky+ly,iplane) = cfft(ix-kx+lx,iy-ky+ly,iplane) + & 
        & cmplx(value,0.0)
    enddo
    !
    ! FOURT is now Thread-safe for the non-FFTW version.
    call fourt(cfft(:,:,iplane),dim,2,1,1,work)
    call recent(nx,ny,cfft(:,:,iplane))
  enddo
  !$OMP END DO
  deallocate(work)
  !$OMP END PARALLEL
  !
  ! Extract the visibility subset
  do iv = 1,nv
    ouv(1:7,iv) = duv(1:7,iv)
    ouv(8:mv,iv) = duv(5+3*first:7+3*last,iv)
  enddo
  !
  ! Interpolate and subtract the model visibilities
  call do_smodel(ouv,mv,nv,cfft,nx,ny,nc,freq,xinc,yinc,1.0,mthread)
  !
  deallocate(cfft)
end subroutine uv_removef_clean
!
subroutine cossin(phase,rcos,rsin)
  !-------------------------------------------------------
  ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
  ! using (not yet clever) interpolation from a precise
  ! loop-up table
  !
  ! A solution using Taylor expansion and symmetries
  ! would be faster and more accurate
  !-------------------------------------------------------
  real(8), intent(inout) :: phase
  real(8), intent(out) :: rcos
  real(8), intent(out) :: rsin

!!  integer, intent(inout) :: ier
!!  real(8), intent(in) :: maxerr
!!  real(8), intent(inout) :: themax
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: mcos=2048
  integer, save :: ncos = 0
  real(8), save :: cosine(mcos)
  real(8), save :: sine(mcos)
  real(8), save :: rstep
  real(8) :: rdeg
  integer :: i
  logical :: minus
  !
  ! Use accurate value
  rcos = cos(phase)
  rsin = sin(phase)
  !
  ! Approximate solution below
  if (.TRUE.) return
  !
  if (ncos.eq.0) then
    ncos = mcos
    rstep = 2.01d0*pi/mcos
    do i=1,ncos
      rdeg = (i-1)*rstep
      cosine(i) = cos(rdeg)
      sine(i) = sin(rdeg)
    enddo
  endif
  !
  if (phase.ge.0) then
    minus =.false.
    rdeg = modulo(phase,2.0d0*pi)+0.5d0*rstep
  else
    minus = .true.
    rdeg = modulo(-phase,2.0d0*pi)+0.5d0*rstep
  endif
  rdeg = rdeg/rstep
  i = int(rdeg)
  rdeg = rdeg - i
  i = i+1
  rcos = (1.0-rdeg)*cosine(i) + rdeg*cosine(i+1)
  rsin = (1.0-rdeg)*sine(i) + rdeg*sine(i+1)
  if (minus) rsin = -rsin
end subroutine cossin
!
subroutine uv_extract_clean(duv,ouv,nc,first,last)
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER   Support for UV_MAP  &  UV_RESTORE
  !     Extract a subset of visibilities
  !-----------------------------------------------------------------
  integer, intent(in) :: nc         ! Number of channels
  real, intent(in) :: duv(:,:)      ! Input visbilities
  real, intent(out) :: ouv(:,:)     ! Output visibilities
  integer, intent(in) :: first      ! First channel
  integer, intent(in) :: last       ! Last channel
  !
  integer :: iv, nv
  !
  nv = ubound(duv,2)                ! Number of Visibilities
  !
  do iv=1,nv
    ouv(1:7,iv) = duv(1:7,iv)
    ouv(8:,iv) = duv(5+3*first:7+3*last,iv)
  enddo
end subroutine uv_extract_clean
!
subroutine uv_clean_sizes(hcct,ccin, mic, first, last)
  use image_def
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER   Support for UV_RESTORE
  !   Compute the actual number of components
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  real, intent(in) :: ccin(:,:,:)   ! Clean component table
  integer, intent(out) :: mic(:)    ! Number of iterations per channel
  integer, intent(in) :: first      ! First
  integer, intent(in) :: last       ! and last channel
  ! Local
  integer :: nc
  integer :: ni, ki
  integer :: i,ic,jc, mi
  !
  nc = hcct%gil%dim(2)  ! Number of channels
  ni = hcct%gil%dim(3)  ! Maximum number of Clean Components
  ! 
  !!Print *,'Number of channels in CCT ',nc
  !!Print *,'First & Last ',first,last
  !
  if (nc.eq.1) then
    mi = ni
    do i=1,ni
      if (ccin(3,1,i).eq.0) then
        mi = i-1
        exit
      endif
    enddo
    mic(:) = mi
  else
    !
    mic(:) = ni ! Up to the last one
    do ic=first,last
      jc = ic-first+1
      ki = 0
      do i=1,ni
        if (ccin(3,ic,i).eq.0) then
          mic(jc) = i-1
          exit
        endif
      enddo
    enddo
  endif
end subroutine uv_clean_sizes
!
subroutine do_smodel (visi,nc,nv,a,nx,ny,nf,freq,xinc,yinc,factor,mthread)
  !$ use omp_lib
  !-----------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER   Support for UV_RESTORE
  !
  !     Remove model visibilities from UV data set.
  !     Interpolate from a grid of values obtained by FFT before.
  !-----------------------------------------------------------------
  integer, intent(in) :: nc ! Visibility size
  integer, intent(in) :: nv ! Number of visibilities
  integer, intent(in) :: nx ! X size
  integer, intent(in) :: ny ! Y size
  integer, intent(in) :: nf ! Number of frequencies
  real, intent(inout) :: visi(:,:)    ! Computed visibilities
  real(8), intent(in) :: freq         ! Effective frequency
  real, intent(in)  :: factor         ! Flux factor
  complex, intent(in) ::  a(:,:,:)    ! FFT
  real(8), intent(in) :: xinc,yinc    ! Pixel sizes
  integer, intent(in) :: mthread
  !
  real(8), parameter :: clight=299792458d0
  real(8) :: kwx,kwy,stepx,stepy,lambda,xr,yr
  complex(8) :: aplus,amoin,azero,afin
  integer i,if,ia,ja
  !
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
  !$OMP   SHARED(visi,a, factor,nc,nv,nf,nx,ny,stepx,stepy) &
  !$OMP   PRIVATE(kwx,ia,kwy,ja,xr,yr,aplus,azero,amoin,afin,if) 
  !$OMP DO
  do i = 1, nv
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    ia = int(kwx)
    if (ia.le.1) cycle
    if (ia.ge.nx) cycle
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ja = int(kwy)
    if (ja.le.1) cycle
    if (ja.ge.ny) cycle
    !
    xr = kwx - ia
    yr = kwy - ja
    do if=1,nf
      !
      ! Interpolate (X or Y first, does not matter in this case)
      aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
   &          - 2.d0*a(ia,ja+1,if) )*xr   &
   &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
   &          + a(ia,ja+1,if)
      azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
   &          - 2.d0*a(ia,ja,if) )*xr   &
   &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
   &          + a(ia,ja,if)
      amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
   &          - 2.d0*a(ia,ja-1,if) )*xr   &
   &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
   &          + a(ia,ja-1,if)
      ! Then Y (or X)
      afin = ( (aplus+amoin-2.d0*azero)   &
   &          *yr + aplus-amoin )*yr*0.5d0 + azero
      !
      visi(5+3*if,i) =  visi(5+3*if,i) - real(afin)*factor
      visi(6+3*if,i) =  visi(6+3*if,i) - imag(afin)*factor
    enddo
  enddo
  !$OMP ENDDO
  !$OMP END PARALLEL
end subroutine do_smodel
! 
subroutine cube_flag_extrema(nchan,varname,mcol,hvar)
  use clean_arrays
  ! @ private
  integer, intent(in) :: nchan
  integer, intent(in) :: mcol(2)
  character(len=*), intent(in) :: varname
  type(gildas), intent(inout) :: hvar
  !
  integer :: ic
  logical :: error
  !
  ! 1 channel only means Continuum data
  if (nchan.ne.1) then
    if (any(dchanflag.eq.0)) then
      Print *,'MCOL ',mcol,' Nchan ',nchan
      Print *,'Nullifying Filtered Channels ',dchanflag(mcol(1):mcol(2)) 
      do ic=1,hvar%gil%dim(3)
        if (dchanflag(ic+mcol(1)-1).eq.0) then
          hvar%r3d(:,:,ic) = 0
        endif
      enddo
    endif
  endif
  !
  ! Compute extrema
  error = .false.
  call cube_minmax(varname,hvar,error)
end subroutine cube_flag_extrema

subroutine combine_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! COMBINE Out Code Line Cont /FACTOR  Fl Fc /THRESHOLD  Tl Tc /BLANKING
  !   Combination with automatic reprojection (and later resampling)
  !   to match the two input data cubes
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(inout) :: error
  !
  ! ' COMBINE', '/BLANKING', '/FACTOR', '/THRESHOLD', 
  character(len=*), parameter :: rname='COMBINE'
  character(len=1024) :: chain
  integer :: ia, n, kopt, ier
  logical :: do_insert
  character(len=filename_length) :: namex,namey,namez
  character(len=20) :: code, argum
  integer, parameter :: mcode=10
  character(len=14) :: scode(mcode)
  data scode/'ADD','DIVIDE','MULTIPLY','OPTICAL_DEPTH','INDEX','SUBTRACT','PLUS','MINUS','OVER','TIMES'/ 
  real :: ay, az, c
  !
  do_insert = sic_lire().eq.0
  !
  call sic_ch(line,0,2,argum,n,.true.,error)
  if (error) return
  az = 1.
  ay = 1.
  if (argum.eq.'=') then
    if (sic_present(2,0)) then
      call map_message(seve%e,rname,'Option /FACTOR is incompatible with free syntax')
      error = .true.
      return
    endif
    call sic_ch(line,0,1,namex,n,.true.,error)
    if (error) return
    ! COMBINE  Out = F*In1 Oper G*In2
    !
    call sic_ke(line,0,4,argum,n,.true.,error)
    if (error) return
    select case (argum)
    case ('+') 
      code = 'ADD'
    case ('-')
      code = 'SUBTRACT'
    case ('*') 
      code = 'MULTIPLY'
    case ('|')
      code = 'DIVIDE'
    case default
      call sic_ambigs (rname,argum,code,n,scode,mcode,error)
      if (error) return
    end select
    !
    call sic_ch(line,0,3,namey,n,.true.,error)
    if (error) return
    n = index(namey,'*')
    if (n.ne.0) then
      read(namey(1:n-1),*,iostat=ier) ay
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Invalid 1st factor '//namey(1:n))
        error = .true.
        return
      endif
      namey = namey(n+1:)
    endif
    !
    call sic_ch(line,0,5,namez,n,.true.,error)
    if (error) return
    n = index(namez,'*')
    if (n.ne.0) then
      read(namez(1:n-1),*,iostat=ier) az
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Invalid 2nd factor '//namez(1:n))
        error = .true.
        return
      endif
      namez = namez(n+1:)
    endif
    !
    c = 0
    call sic_r4(line,0,6,c,.false.,error)
    if (error) return
    !
    kopt = len_trim(line)
    if (sic_present(1,0)) kopt = sic_start(1,0)
    if (sic_present(3,0)) kopt = min(kopt,sic_start(3,0))
    chain = line(kopt:)
    !
    ! This will not work if any quote is in the arguments...
    if (c.eq.0) then
      write(line,'(6(A,1X),1PG11.4,1X,1PG11.4,1X,A)') 'COMBINE', trim(namex), trim(code), & 
        & trim(namey), trim(namez), '/FACTOR ',ay,az, trim(chain)
    else
      call sic_ch(line,0,6,argum,n,.false.,error)
      write(line,'(7(A,1X),1PG11.4,1X,1PG11.4,1X,A)') 'COMBINE', trim(namex), trim(code), & 
        & trim(namey), trim(namez), trim(argum), '/FACTOR ',ay,az, trim(chain)
    endif
    !
  else
    ! parse 4 /factor 1 2 /threshold 1 2 /blank 1
    error = .false.
    if ((sic_narg(0).lt.4).or.(sic_narg(0).gt.5)) then
      call map_message(seve%e,rname,'command takes 4 or 5 arguments')
      error = .true.
    endif
  endif
  !
  ! parse 4 5 /factor 1 2 /threshold 1 2 /blank 1
  if (sic_present(1,0).and.sic_narg(1).ne.1) then
    call map_message(seve%e,rname,'/BLANKING takes 1 argument')
    error = .true.
  endif
  if (sic_present(2,0).and.((sic_narg(2).lt.1).or.(sic_narg(2).gt.2))) then
    call map_message(seve%e,rname,'/FACTORS takes 1 or 2 arguments')
    error = .true.
  endif
  if (sic_present(3,0).and.((sic_narg(3).lt.1).or.(sic_narg(3).gt.2))) then
    call map_message(seve%e,rname,'/THRESHOLDS takes 1 or 2 arguments')
    error = .true.
  endif
  if (error) return
  !
  ia = index(line,' ')
  chain = "@ p_combine"//line(ia:)
  call exec_program(chain) 
  !
  if (do_insert) call sic_insert_log(line)
end subroutine combine_comm
!
subroutine map_combine_comm(line,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, only : do_combine, map_message
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !   IMAGER, from Task COMBINE code
  !
  ! MAP_COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANKING Bval
  !     Combine in different ways two input images
  !        (or data cubes)...
  !
  !     Out can be a file name or an existing Image variable. 
  !         The distinction is made by the existence of a "." in the name
  !         If it is a file, it is created like the In1 Variable
  !         If it is an Image variable, it must match the shape of 
  !           the In1 Variable
  !     In1 can be a file name or an existing Image variable.
  !     In2 can be a file name or an existing Image variable.
  !         The rank of In2 must be smaller than that of In1, and
  !         other dimensions must match          
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Input command line
  logical, intent(out) :: error         ! Return error flag
  !
  integer, parameter :: o_blank=1, o_factor=2, o_thre=3
  character(len=*), parameter :: rname='MAP_COMBINE'
  character(len=filename_length) :: namex,namey,namez
  character(len=20) :: code, argum
  integer, parameter :: mcode=10
  character(len=14) :: scode(mcode)
  data scode/'ADD','DIVIDE','MULTIPLY','OPTICAL_DEPTH','INDEX','SUBTRACT','PLUS','MINUS','OVER','TIMES'/ 
  real :: ay,az,ty,tz,b,c
  logical :: do_blank
  integer :: n, ier
  !
  call sic_ch(line,0,1,namex,n,.true.,error)
  if (error) return
  call sic_ch(line,0,2,argum,n,.true.,error)
  if (error) return
  az = 1.
  ay = 1.
  if (argum.eq.'=') then
    if (sic_present(o_factor,0)) then
      call map_message(seve%e,rname,'Option /FACTOR is incompatible with free syntax')
      error = .true.
      return
    endif
    ! COMBINE  Out = F*In1 Oper G*In2
    !
    call sic_ke(line,0,4,argum,n,.true.,error)
    if (error) return
    select case (argum)
    case ('+') 
      code = 'ADD'
    case ('-')
      code = 'SUBTRACT'
    case ('*') 
      code = 'MULTIPLY'
    case ('|')
      code = 'DIVIDE'
    case default    
      call sic_ambigs (rname,argum,code,n,scode,mcode,error)
    end select
    if (error) return
    !
    call sic_ch(line,0,3,namey,n,.true.,error)
    if (error) return
    n = index(namey,'*')
    if (n.ne.0) then
      read(namey(1:n-1),*,iostat=ier) ay
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Invalid 1st factor '//namey(1:n))
        error = .true.
        return
      endif
      namey = namey(n+1:)
    endif
    !
    call sic_ch(line,0,5,namez,n,.true.,error)
    if (error) return
    n = index(namez,'*')
    if (n.ne.0) then
      read(namez(1:n-1),*,iostat=ier) az
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Invalid 2nd factor '//namez(1:n))
        error = .true.
        return
      endif
      namez = namez(n+1:)
    endif
    !
    c = 0
    call sic_r4(line,0,6,c,.false.,error)
    !
  else
    call sic_ch(line,0,2,argum,n,.true.,error)
    if (error) return
    call sic_ambigs (rname,argum,code,n,scode,mcode,error)
    if (error) return
    call sic_ch(line,0,3,namey,n,.true.,error)
    if (error) return
    call sic_ch(line,0,4,namez,n,.true.,error)
    if (error) return
    c = 0
    call sic_r4(line,0,5,c,.false.,error)
    if (error) return
    call sic_r4(line,o_factor,2,az,.false.,error)
    call sic_r4(line,o_factor,1,ay,.false.,error)
  endif
  !
  tz = -huge(1.0)
  ty = tz
  !
  call sic_r4(line,o_thre,2,tz,.false.,error)
  call sic_r4(line,o_thre,1,ty,.false.,error)
  !
  if ((code.eq.'SUBTRACT').or.(code.eq.'MINUS')) then
    code = 'ADD'
    az = -az
  endif
  !
  if (sic_present(o_blank,0)) then
    call sic_r4(line,o_blank,1,b,.true.,error)
    do_blank = .true.
  else
    do_blank = .false.
  endif
  !
  if (do_blank) then
    call do_combine(namex,namey,namez,code,c,ay,ty,az,tz,error,b)
  else
    call do_combine(namex,namey,namez,code,c,ay,ty,az,tz,error)
  endif
end subroutine map_combine_comm
!
subroutine do_combine(namex,namey,namez,code,c,ay,ty,az,tz,error,b)
  use imager_interfaces, only : sub_readhead, map_message
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use iso_c_binding
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !
  !   IMAGER  Support routine for command
  !
  ! COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANK Bval
  !     Combine in different ways two input images
  !        (or data cubes)...
  !
  !     Out can be a file name or an existing Image variable. 
  !         The distinction is made by the existence of a "." in the name
  !         If it is a file, it is created like the In1 Variable
  !         If it is an Image variable, it must match the shape of 
  !           the In1 Variable
  !     In1 can be a file name or an existing Image variable.
  !     In2 can be a file name or an existing Image variable.
  !         The rank of In2 must be smaller than that of In1, and
  !         other dimensions must match          
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: namex ! Output file
  character(len=*), intent(inout) :: namey ! Input file 1
  character(len=*), intent(inout) :: namez ! Input file 2
  character(len=*), intent(inout) :: code  ! Combination code
  real, intent(in) :: c  ! Offset
  real, intent(in) :: ay ! Y Factor
  real, intent(in) :: ty ! Y Threshold
  real, intent(in) :: az ! Z Factor
  real, intent(in) :: tz ! Z Threshold
  logical, intent(out) :: error
  real, intent(in), optional :: b  ! Blanking
  !
  character(len=*), parameter :: rname='MAP_COMBINE'
  !
  type (sic_descriptor_t) :: desc
  type (gildas) :: hx, hy, hz
  type (c_ptr) :: cptr
  real, pointer :: dx(:,:), dy(:,:), dz(:)
  logical :: x_image, y_image, z_image, found, rdonly
  integer i, j, ier
  integer(kind=index_length) :: n, m
  !
  error = .true.
  !
  n = len_trim(namez)
  if (n.eq.0) return
  n = len_trim(namex)
  if (n.eq.0) return
  n = len_trim(namey)
  if (n.eq.0) return
  error = .false.
  !
  z_image = .false.
  call sub_readhead (rname,namez,hz,z_image,error,rdonly,fmt_r4)
  if (error) return
  !
  y_image = .false.
  call sub_readhead (rname,namey,hy,y_image,error,rdonly,fmt_r4)
  if (error) return  
  !
  if (hz%gil%eval.ge.0.0) hz%gil%eval =   &
    max(hz%gil%eval,abs(hz%gil%bval*1e-7))
  if (hy%gil%eval.ge.0.0) hy%gil%eval =   &
    max(hy%gil%eval,abs(hy%gil%bval*1e-7))
  !
  ! Check input dimensions
  m = max(hy%gil%ndim,hz%gil%ndim)
  do i=1,m
    if (hy%gil%dim(i).ne.hz%gil%dim(i)) then
      n = 1
      do j=i,m
        n = n*hz%gil%dim(j)
      enddo
      if (n.ne.1) then
        call map_message(seve%e,rname,'Input images are non coincident')
        error = .true.
        return
      else
        call map_message(seve%i,rname,'Combining a cube with a plane')
      endif
    endif
  enddo
  !
  !
  ! Allocate the arrays if needed. Note that the allocated arrays do 
  ! not conform to the shape of the images: DZ is allocated as a 1-D 
  ! array, DX,DY as 2-D arrays, possibly of second dimension 1.
  !
  n = hz%loca%size
  m = hy%loca%size/hz%loca%size
  !
  ! Get the Z data pointer
  if (z_image) then
    call adtoad(hz%loca%addr,cptr,1)
    call c_f_pointer(cptr,dz,[n])
  else
    allocate(dz(n),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call map_message(seve%i,rname,'Reading '//trim(hz%file))
    call gdf_read_data(hz,dz,error)
    call gdf_close_image(hz,error) ! I do not need it anymore
  endif
  !
  ! Get the Y data pointer
  if (y_image) then
    call adtoad(hy%loca%addr,cptr,1)
    call c_f_pointer(cptr,dy,[n,m])
  else
    allocate(dy(n,m),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call map_message(seve%i,rname,'Reading '//trim(hy%file))
    call gdf_read_data(hy,dy,error)
    call gdf_close_image(hy,error) ! I do not need it anymore
  endif
  !
  ! Now handle the Output 
  call gildas_null(hx)
  if (index(namex,'.').eq.0) then 
    x_image = .true.
    ! This must be an existing SIC Image variable
    rdonly = .false.
    call sub_readhead (rname,namex,hx,x_image,error,rdonly,fmt_r4)
    if (error) return
    !
    ! With a conforming shape with Y slot
    do i=1,max(hx%gil%ndim,hy%gil%ndim) 
      if (hy%gil%dim(i).ne.hx%gil%dim(i)) then
        call map_message(seve%e,rname,'Output SIC variable does not match Input data shape')
        error = .true.
        return
      endif
    enddo
    !
    ! OK, they match 
    call adtoad(hx%loca%addr,cptr,1)    
    call c_f_pointer(cptr,dx,[n,m])
    ! But update the Header locally
    call gdf_copy_header(hy,hx,error)
  else
    x_image = .false.
    ! This is  a file, we must create it
    call gdf_copy_header(hy,hx,error)
    call sic_parsef(namex,hx%file,' ','.gdf')
    hx%gil%extr_words = 0
    hx%gil%blan_words = 2
    allocate(dx(n,m),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
  endif
  !
  ! Update Blanking if specified
  if (present(b)) then
    hx%gil%bval = b
    hx%gil%eval = 0.0
  endif
  !
  ! Do the actual job
  call map_message(seve%i,rname,'Combining data')
  call sub_combine(hx,hy,hz,     & ! Headers
    & n,m,                       & ! Sizes
    & dx,dy,dz,                  & ! Data arrays
    & code,ay,ty,az,tz,c,error)    ! Operation 
  !
  ! Write ouput file
  if (.not.x_image) then
    call map_message(seve%i,rname,'Writing '//trim(hx%file))
    call gdf_write_image(hx,dx,error)
  else
    ! Update the original SIC variable header, including Extrema
    error = .false. 
    hx%loca%addr = locwrd(dx)   ! Define the address
    call gdf_get_extrema (hx,error)
    call sic_descriptor(namex,desc,found)
    call gdf_copy_header(hx,desc%head,error)  
  endif
  !
end subroutine do_combine
!
subroutine sub_combine(hx,hy,hz,n,m,dx,dy,dz,code,ay,ty,az,tz,c,error)
  use gkernel_types
  !----------------------------------------------------------------------
  !
  !   IMAGER  Support routine for command
  !
  ! COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANK Bval
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: code  ! Combination code
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  !
  type(gildas), intent(in) :: hx  ! Output header
  type(gildas), intent(in) :: hy  ! Input Cube header
  type(gildas), intent(in) :: hz  ! Input Cube or Plane header
  !
  real, intent(in) :: dx(n,m)     ! Output data
  real, intent(in) :: dy(n,m)     ! Input data
  real, intent(in) :: dz(n)       ! Input data
  real, intent(in) :: c           ! Offset
  real, intent(in) :: ay          ! Y Factor
  real, intent(in) :: ty          ! Y Threshold
  real, intent(in) :: az          ! Z Factor
  real, intent(in) :: tz          ! Z Threshold
  logical, intent(out) :: error
  !
  select case(code)
  case ('ADD','PLUS') 
    call add002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  case ('DIVIDE','OVER') 
    call div002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  case ('MULTIPLY','TIMES') 
    call mul002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  case ('OPTICAL_DEPTH') 
    call opt002(dz,dy,dx,   &
      n,m,   &
      hz%gil%bval,hz%gil%eval,az,tz,   &
      hy%gil%bval,hy%gil%eval,ay,ty,   &
      hx%gil%bval,c)
  case ('INDEX')
    Print *,'Spectral Index not yet available'
    error = .true.
  case default
    Print *,code//' not available'
    error = .true.
    return
  end select
  !
end subroutine sub_combine
!
subroutine add002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	  Linear combination of input arrays
  !	X = Ay*Y + Az*Z + C
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      ! Plane array
  real :: y(n,m)                    ! Input Cube
  real :: x(n,m)                    ! Output Cube
  real :: bz                        ! Z Blanking value
  real :: ez                        ! Z Tolerance on blanking
  real :: az                        ! Z factor
  real :: tz                        ! Z threshold
  real :: by                        ! Y Blanking value
  real :: ey                        ! Y Tolerance on blanking
  real :: ay                        ! Y factor
  real :: ty                        ! Y Threshold
  real :: bx                        ! X Blanking
  real :: c                         ! Constant Offset
  ! Local
  integer(kind=index_length) :: i,k
  !
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,az,ay,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        x(i,k) = ay*y(i,k) + az*z(i)  +  c
      else
        x(i,k) = bx
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine add002
!
subroutine div002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	  Division of 2 input arrays
  !	X = Ay*Y / Az*Z + C
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      ! Plane array
  real :: y(n,m)                    ! Input Cube
  real :: x(n,m)                    ! Output Cube
  real :: bz                        ! Z Blanking value
  real :: ez                        ! Z Tolerance on blanking
  real :: az                        ! Z factor
  real :: tz                        ! Z threshold
  real :: by                        ! Y Blanking value
  real :: ey                        ! Y Tolerance on blanking
  real :: ay                        ! Y factor
  real :: ty                        ! Y Threshold
  real :: bx                        ! X Blanking
  real :: c                         ! Constant Offset
  ! Local
  integer(kind=index_length) :: i,k
  real :: ayz
  !
  ayz = ay/az
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,ayz,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        x(i,k) = ayz * y(i,k) / z(i)  +  c
      else
        x(i,k) = bx
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine div002
!
subroutine mul002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Multiplication of input arrays
  !	  X = Ay*Y * Az*Z + C
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      ! Plane array
  real :: y(n,m)                    ! Input Cube
  real :: x(n,m)                    ! Output Cube
  real :: bz                        ! Z Blanking value
  real :: ez                        ! Z Tolerance on blanking
  real :: az                        ! Z factor
  real :: tz                        ! Z threshold
  real :: by                        ! Y Blanking value
  real :: ey                        ! Y Tolerance on blanking
  real :: ay                        ! Y factor
  real :: ty                        ! Y Threshold
  real :: bx                        ! X Blanking
  real :: c                         ! Constant Offset
  ! Local
  integer(kind=index_length) :: i,k
  real :: ayz
  !
  ayz = ay*az
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,ayz,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        x(i,k) = ayz * z(i) * y(i,k) +  c
      else
        x(i,k) = bx
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine mul002
!
subroutine opt002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
  !$ use omp_lib
  use gkernel_types
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Optical depth from input arrays
  !	X = - LOG ( Ay*Y / Az*Z + C )
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: n
  integer(kind=index_length), intent(in) :: m
  real :: z(n)                      ! Plane array
  real :: y(n,m)                    ! Input Cube
  real :: x(n,m)                    ! Output Cube
  real :: bz                        ! Z Blanking value
  real :: ez                        ! Z Tolerance on blanking
  real :: az                        ! Z factor
  real :: tz                        ! Z threshold
  real :: by                        ! Y Blanking value
  real :: ey                        ! Y Tolerance on blanking
  real :: ay                        ! Y factor
  real :: ty                        ! Y Threshold
  real :: bx                        ! X Blanking
  real :: c                         ! Constant Offset
  ! Local
  real :: v
  integer(kind=index_length) :: i,k
  real :: ayz
  !
  ayz = ay/az
  !$OMP PARALLEL DEFAULT(none)                    &
  !$OMP SHARED (z,x,y, bz,ez,by,ey,tz,ty,ayz,bx,c) &
  !$OMP SHARED (n,m) PRIVATE (i,k,v)
  !$OMP DO
  do k=1,m
    do i=1,n
      if (abs(z(i)-bz).gt.ez .and. abs(y(i,k)-by).gt.ey   &
     &        .and. z(i).gt.tz .and. y(i,k).gt.ty) then
        v = ayz * y(i,k) / z(i)  +  c
        if (v.gt.0.0) then
          x(i,k) = - log( v )
        else
          x(i,k) = bx
        endif
      else
        x(i,k) = bx
      endif
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine opt002
!
subroutine sub_readhead(rname,namez,hz,z_image,error,rdonly,fmt,type)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !     IMAGER
  !   Return the Header of a GILDAS File or SIC Image variable
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname   ! Caller name
  character(len=*), intent(in) :: namez   ! Name of File or Variable
  type(gildas), intent(out) :: hz         ! GILDAS Header
  logical, intent(inout) :: z_image       ! Is it an image ?
  logical, intent(out) :: error           ! Error flag
  logical, intent(out), optional :: rdonly
  integer, intent(in), optional :: fmt
  character(len=*), intent(in), optional :: type
  !
  logical :: found
  type (sic_descriptor_t) :: desc
  integer :: i
  character(len=16) :: atype
  !
  ! Search if any SIC variable like this one...
  call sic_descriptor(namez,desc,found)
  if (found) then
    if (.not.associated(desc%head)) then
      call map_message(seve%e,rname,  &
        'Variable '//trim(namez)//' does not provide a header')
      found = .false.
    else if (present(fmt)) then
      if (desc%type.ne.fmt) then
        call map_message(seve%e,rname,  &
          'Variable '//trim(namez)//' is of wrong type')
        found = .false.
      endif
    endif
    if (found) then
      if (abs(desc%head%gil%type_gdf) .eq. code_gdf_uvt) then
        call gildas_null(hz,type='UVT')
      else
        call gildas_null(hz)
      endif
      call gdf_copy_header(desc%head,hz,error)
      if (error) return
      hz%loca%addr = desc%addr
      z_image = .true.
      if (present(rdonly)) rdonly = desc%readonly
      hz%loca%size = 1
      do i=1,hz%gil%ndim
        hz%loca%size = hz%loca%size * hz%gil%dim(i)
      enddo
    endif
  endif
  !
  ! If not, fall back on File, unless Image mode is specified
  if (.not.found) then
    if (z_image) then
      call map_message(seve%e,rname, 'No such Variable '//trim(namez))
      error = .true.
      return
    else
      if (present(type)) then
        atype = type
      else
        atype = '.gdf'
      endif
      !
      call sic_parse_file(namez,' ',atype,hz%file)
      call gdf_read_header(hz,error)
      if (error) then
        call map_message(seve%e,rname,'Cannot read input file '//trim(hz%file))
        return
      endif
    endif
  endif
end subroutine sub_readhead

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_load
  use cubetools_parameters
  use cubetools_structure
  use cubetools_userspace
  use cubeadm_cubeid_types
  use cubego_messaging
  use cubeedit_getdata
  use cubeedit_getheader
  !
  public :: load
  private
  !
  type :: load_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(userspace_opt_t)       :: into
     type(getdata_comm_t)        :: data
     type(getheader_comm_t)      :: head
   contains
     procedure, public  :: register => cubego_load_register
     procedure, private :: parse    => cubego_load_parse
     procedure, private :: main     => cubego_load_main 
  end type load_comm_t
  type(load_comm_t) :: load
  !
  type :: load_user_t
     type(userspace_user_t) :: userspace
     type(cubeid_user_t)    :: id
     type(getdata_user_t)   :: data
     type(getheader_user_t) :: head
  end type load_user_t
  !
  character(len=*), parameter :: defname = 'GOLOAD'
  !
contains
  !
  subroutine cubego_load_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(load_user_t) :: user
    character(len=*), parameter :: rname='LOAD>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call load%parse(line,user,error)
    if (error) return
    call load%main(user,error)
    if (error) return
  end subroutine cubego_load_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_load_register(load,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    ! Register GO\LOAD command and its options
    !-------------------------------------------------------------------
    class(load_comm_t), intent(inout) :: load
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    logical, parameter :: noiterator = .false.
    character(len=*), parameter :: comm_abstract = &
         'load information from a cube'
    character(len=*), parameter :: comm_help = &
         'Information loaded onto variables by GO\LOAD is intended as&
         & information. Modifying the values in these variables does&
         & not change the values for these parameters in the original&
         & cube. If option /INTO is not used the information&
         & gotten will be stored in a master structure called '//defname
    character(len=*), parameter :: rname='LOAD>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'LOAD','[cube]',&
         comm_abstract,&
         strg_id,&
         cubego_load_command,&
         load%comm,error)
    if (error) return
    call cubearg%register( &
         'CUBE', &
         'Input cube',  &
         strg_id,&
         code_arg_optional,  &
         [flag_any], &
         code_read, &
         code_access_imaset_or_speset, &
         load%cube, &
         error)
    if (error) return
    !
    call load%into%register(error)
    if (error) return
    call load%head%register(defname,load%into,error)
    if (error) return
    call load%data%register(load%into,access_not_fixed,noiterator,error)
    if (error) return
  end subroutine cubego_load_register
  !
  subroutine cubego_load_parse(load,line,user,error)
    !-------------------------------------------------------------------
    ! Support routine for command LOAD
    !-------------------------------------------------------------------
    class(load_comm_t), intent(in)    :: load
    character(len=*),   intent(in)    :: line
    type(load_user_t),  intent(inout) :: user
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='LOAD>PARSE'
    !
    call load%into%parse(line,user%userspace,error)
    if (error) return
    !
    call cubeadm_cubeid_parse(line,load%comm,user%id,error)
    if (error) return
    call load%head%parse(line,user%userspace,user%head,error)
    if (error) return
    call load%data%parse(line,user%userspace,user%data,error)
    if (error) return
  end subroutine cubego_load_parse
  !
  subroutine cubego_load_main(load,user,error)
    use cube_types
    use cubetuple_format
    use cubeadm_get
    use cubeadm_opened
    !-------------------------------------------------------------------
    ! Support routine for command LOAD
    !-------------------------------------------------------------------
    class(load_comm_t), intent(in)    :: load
    type(load_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(cube_t), pointer :: cube
    class(format_t), pointer :: format
    integer(kind=entr_k) :: ie
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='LOAD>MAIN'
    !
    if (.not.user%head%do .and. .not.user%data%do) then
       call load%head%list(error)
       if (error) return
       call load%data%list(error)
       if (error) return
       return
    endif
    !
    if (user%data%do) then
      ! As of today, data access can only be done on a cube_t
      call cubeadm_get_header(load%cube,user%id,cube,error)
      if (error) return
      format => cube  ! Set if header access is also needed
      ! Do not forget to prepare the internal iterator so that
      ! 'get' image/channel/etc... works properly.
      call cubeadm_datainit_all(iter,error)
      if (error) return
    elseif (user%head%do) then
      ! Header access can be done on any format_t
      call cubeadm_get_fheader(load%cube,user%id,format,error)
      if (error) return
    endif
    !
    if (user%head%do) then
       call load%head%get(user%head,format,defname,user%data%do,error)
       if (error) return
    endif
    if (user%data%do) then
       ie = entr_unk
       call load%data%get(user%data,cube,defname,user%head%do,ie,error)
       if (error) return
    endif
  end subroutine cubego_load_main
end module cubego_load
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubego_browse
  use cubetools_parameters
  use cubetools_structure
  use cubetools_switch_types
  use cubeadm_cubeid_types
  use cubetopology_spapos_types
  use cubego_messaging
  !
  public :: browse
  private
  !
  type :: browse_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: cube
     type(spapos_comm_t)         :: pixel
     type(option_t),     pointer :: catalog
     type(switch_comm_t)         :: interactive
   contains
     procedure, public  :: register => cubego_browse_register
     procedure, private :: parse    => cubego_browse_parse
     procedure, private :: main     => cubego_browse_main
  end type browse_comm_t
  type(browse_comm_t) :: browse
  !
  integer(kind=4), parameter :: icube = 1
  type :: browse_user_t
     type(cubeid_user_t) :: cubeids
     type(spapos_user_t) :: pixel
     character(len=file_l) :: catalog
     type(switch_user_t) :: interactive
   contains
     procedure, private :: toprog => cubego_browse_user_toprog
  end type browse_user_t
  !
  type browse_prog_t
     type(switch_prog_t) :: interactive
   contains
     procedure, private :: act => cubego_browse_prog_act
  end type browse_prog_t
  !
contains
  !
  subroutine cubego_browse_command(line,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(browse_user_t) :: user
    character(len=*),parameter :: rname='BROWSE>COMMAND'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call browse%parse(line,user,error)
    if (error) return
    call browse%main(user,error)
    if (error) return
    ! Force insertion in SIC stack ! *** JP Why?
    if (sic_lire().eq.0) call sic_insert(line)
  end subroutine cubego_browse_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_register(browse,error)
    use cubedag_allflags
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(inout) :: browse
    logical,            intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: comm_abstract = &
         'Interactive browse of a cube spectrum'
    character(len=*), parameter :: comm_help = &
         strg_id
    character(len=*), parameter :: rname='BROWSE>REGISTER'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'BROWSE','[cube]',&
         comm_abstract,&
         comm_help,&
         cubego_browse_command,&
         browse%comm,error)
    if (error) return
    call cubearg%register( &
         'CUBE', &
         'Cube to be viewed',  &
         strg_id,&
         code_arg_optional,  &
         [flag_any], &
         code_read,&  ! Indicative: data access done by procedure
         code_access_imaset_or_speset,&  ! Indicative: data access done by procedure
         browse%cube,&
         error)
    if (error) return
    !
    call browse%pixel%register(&
         'PIXEL',&
         'Define the position of the pixel to be gotten',&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'CATALOG','File',&
         'Supersede the line catalog to be used',&
         strg_id,&
         browse%catalog,error)
    if (error) return
    call stdarg%register( &
         'FILE',  &
         'The line catalog file name', &
         'The file format is an ASCII table with frequencies [GHz] in first&
         & column and line names in second column. Protect the names with single&
         & quotes if needed.',&
         code_arg_mandatory, &
         error)
    if (error) return
    !
    call browse%interactive%register(&
         'INTERACTIVE','the interactive mode',&
         'ON',error)
    if (error) return
  end subroutine cubego_browse_register
  !
  subroutine cubego_browse_parse(comm,line,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(inout) :: comm
    character(len=*),     intent(in)    :: line
    type(browse_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>PARSE'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%pixel%parse(line,user%pixel,error)
    if (error) return
    user%catalog = ''
    call cubetools_getarg(line,comm%catalog,1,user%catalog,.not.mandatory,error)
    if (error) return
    call comm%interactive%parse(line,user%interactive,error)
    if (error) return
  end subroutine cubego_browse_parse
  !
  subroutine cubego_browse_main(comm,user,error)
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(browse_comm_t), intent(in)    :: comm
    type(browse_user_t),  intent(in)    :: user
    logical,            intent(inout) :: error
    !
    type(browse_prog_t) :: prog
    character(len=*), parameter :: rname='BROWSE>MAIN'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%act(error)
    if (error) return
  end subroutine cubego_browse_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_user_toprog(user,comm,prog,error)
    use cubetools_user2prog
    use cubego_buffer
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(browse_user_t), intent(in)    :: user
    type(browse_comm_t),  intent(in)    :: comm    
    type(browse_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>USER>TOPROG'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_user2prog(comm%comm,user%cubeids,cubes,error)
    if (error) return
    call cubes%defstruct(cubego,error)
    if (error) return
    !
    call prog%interactive%init(comm%interactive,error)
    if (error) return
    call user%interactive%toprog(comm%interactive,prog%interactive,error)
    if (error) return
    !
    ! *** JP The two next statements seem to belong to prog more than to user
    call cubego_browse_struct_pixel(user%pixel,error)
    if (error) return
    call cubego_browse_struct_catalog(user%catalog,error)
    if (error) return
    ! *** JP
  end subroutine cubego_browse_user_toprog
  !
  subroutine cubego_browse_struct_pixel(pixel,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    type(spapos_user_t), intent(in)    :: pixel
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>STRUCT>PIXEL'
    character(len=128) :: line
    !
    ! ZZZ This is to be implemented properly!!!
    !
    if (sic_varexist('cubego%pixel')) then
      line = 'sic\delete /var cubego%pixel'
      call exec_command(line,error)
      if (error) return
    endif
    line = 'sic\define structure cubego%pixel /global'
    call exec_command(line,error)
    if (error) return
    line = 'sic\define character*64 cubego%pixel%l cubego%pixel%m /global'
    call exec_command(line,error)
    if (error) return
    line = 'sic\define character*64 cubego%pixel%type cubego%pixel%unit /global'
    call exec_command(line,error)
    if (error) return
    !
    line = 'let cubego%pixel%l '//pixel%x
    call exec_command(line,error)
    if (error) return
    line = 'let cubego%pixel%m '//pixel%y
    call exec_command(line,error)
    if (error) return
    line = 'let cubego%pixel%type '//pixel%type
    call exec_command(line,error)
    if (error) return
    line = 'let cubego%pixel%unit '//pixel%unit
    call exec_command(line,error)
    if (error) return
  end subroutine cubego_browse_struct_pixel
  !
  subroutine cubego_browse_struct_catalog(catalog,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: catalog
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>STRUCT>CATALOG'
    character(len=128) :: line
    !
    ! ZZZ This is to be implemented properly!!!
    !
    if (sic_varexist('cubego%catalog')) then
      line = 'sic\delete /var cubego%catalog'
      call exec_command(line,error)
      if (error) return
    endif
    line = 'sic\define structure cubego%catalog /global'
    call exec_command(line,error)
    if (error) return
    line = 'sic\define character*256 cubego%catalog%file /global'
    call exec_command(line,error)
    if (error) return
    line = 'let cubego%catalog%file "'//trim(catalog)//'"'
    call exec_command(line,error)
    if (error) return
  end subroutine cubego_browse_struct_catalog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubego_browse_prog_act(prog,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(browse_prog_t), intent(in)    :: prog
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='BROWSE>PROG>ACT'
    !
    call cubego_message(goseve%trace,rname,'Welcome')
    !
    call exec_program('@ q-browse.cube')
    if (prog%interactive%act) call exec_program('@ l-ctrl-master-loop')
  end subroutine cubego_browse_prog_act
end module cubego_browse
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
! Things to do outside the deconvolution loop, i.e.
!   once for all channels requiring the same beam.
!
! 1) define the smoothing kernels
!     1 .. ns
!     1 is a delta function
!   The others are (truncated) parabolas. 
!   Cornwell uses in addition Spheroidals, by I do not see the point.
!
! 2) compute the convolved dirty beams
!     D**K(i),  i=2,ns    as K(1) = Delta   NS-1
!  and D**K(j)**K(i), (i=2,ns, j=i,ns)      NS*(NS-1)/2  such kernels
!     the order being 22, 33, 32, 44, 43, 42, etc... 
! 3)  compute the TF of these beams
!
! Things do do in the deconvolution loop
!
! - Only retain CC that falls within the mask for smoothed versions.
!   i.e. do not compute any smooth mask
! - For mosaic, what is removed is not totally obvious. There
!   is a commutation problem between smoothed components and 
!   primary beams. So the idea to deconvolve using the convolve
!   dirty beams may not work completely/exactly.
!
!
subroutine major_msc90 (rname,method,head,   &
     &    dirty,resid,beam,mask,clean,nx,ny,   &
     &    tcc,miter,limit,niter, &
     &    smask, sresid, trans, cdata, sbeam, &
     &    tfbeam, wfft)
! Need to add
!    &    nf, primary, weight)
  use imager_interfaces, except_this=>major_msc90
  use gkernel_interfaces
  use image_def
  use gbl_message
  use clean_def
  !$  use omp_lib
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !     Multi-Resolution CLEAN - with NS (parameter) scales
  !
  !     Algorithm
  !     For each iteration, search at which scale the signal to noise
  !     is largest. Use the strongest S/N to determine the "component"
  !     intensity and shape at this iteration.
  !
  !     Restore the ("infinite" resolution) image from the list of location
  !     types, and intensities of the "components"
  !
  !     The noise level at each scale is computed from the Fourier transform
  !     of the smoothed dirty beams, since the FT is the weight distribution
  !     and the noise level is the inverse square root of the sum of the
  !     weights.
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type (clean_par), intent(inout) :: method
  type (gildas), intent(inout) :: head         ! Unused, but here for consistency...
  integer, intent(in)  :: nx,ny                ! Image size
  integer, intent(in)  :: miter                ! Maximum number of clean components
  integer, intent(out) :: niter                ! Number of found components
  real, intent(in)  :: dirty(nx,ny)            ! Dirty image
  real, intent(inout) :: resid(nx,ny)          ! Residual image (initialized to Dirty image)
  real, intent(in)  :: beam(nx,ny)             ! Dirty beam
  real, intent(inout) :: clean(nx,ny)          ! "CLEAN" image (not convolved yet)
  logical, intent(in)  :: mask(nx,ny)          ! Search area
  real, intent(in)  :: limit                   ! Maximum residual
  real, intent(in)  :: tfbeam(nx,ny)           ! Real Beam TF
  real, intent(inout) :: wfft(*)
  type (cct_par), intent(out) :: tcc(miter)
  !
  ! In call sequence
  real, intent(inout) ::  sbeam(nx,ny,*)          ! Smoothed beams
  real, intent(inout) ::  sresid(nx,ny)           ! Smoothed residuals
  real, intent(inout) ::  trans(nx,ny)            ! Translated beam
  complex, intent(inout) ::  cdata(nx,ny)         ! Work array
  logical, intent(inout) ::  smask(nx,ny)         ! Smoothed mask
  !
  ! Internal fixed size arrays
  integer, parameter :: ms=3
  integer, parameter :: mk=11
  integer nker(ms)             ! Kernel size
  integer  ns                  ! Number of Kernels
  real scale(ms)               ! Noise level for each beam
  real bruit(ms)               ! Residual level for each beam
  real sn(ms)                  ! Signal / Noise
  integer ix(ms),iy(ms)        ! Coordinates of each iteration maximum
  real again(ms)               ! Gain per kernel
  real gains(ms)               ! same after noise correction
  real fluxes(ms)              ! Cumulative flux per kernel
  real loss(ms)                ! Noise degradation factor...
  integer ncase(ms)
  real :: kernel(mk,mk,ms)           ! Smoothing kernels
  !
  ! Local work variables
  integer, parameter :: mcum=10
  integer ncum, ithread
  integer nn(2), ndim, kx,ky
  integer is,i,j, oldis, goodis
  real value, oldcum(mcum), converge, sign
  real maxa,flux,smooth,gain,maxsn,worry
  logical ok, plot, keep, printout, error
  character(len=message_length) :: chain
  character(len=24) :: string
  !
  ! Automatic, may need a bigger stack.
  !
  smooth = method%smooth
  gain = method%gain
  plot = method%pflux
  keep = method%keep
  nker = method%nker
  printout = method%verbose  ! Default behaviour
  again = method%gains
  worry = method%worry
  !
  ! Initialize the kernel
  kernel = 0.0
  ns = 1
  nker(1) = 1
  kernel = 0.0
  kernel(1,1,1) = 1.0
  !
  if (nker(2).gt.0) then
    call init_kernel(kernel(:,:,2),mk,nker(2),smooth)
    ns = 2
    if (nker(3).gt.0) then
      smooth = smooth**2
      call init_kernel(kernel(:,:,3),mk,nker(3),smooth)
      ns = 3
    endif
  endif
  ncase(1:ms) = 0
  fluxes(:) = 0.0
  trans(:,:) = 0.0
  !
  ! Initialize smoothed beams & mask
  call smooth_mask (mask,smask,nx,ny,nker(ns))
  !
  sbeam(:,:,1) = beam
  loss(1) = 1.0
  scale(1) = 1.0
  gains(1) = again(1)
  !
  kx = nx/2+1
  ky = ny/2+1
  do is = 2,ns
    call smooth_kernel (beam,sbeam(:,:,is),nx,ny,mk,nker(is),kernel(:,:,is))
    value = 1.0/sbeam(kx,ky,is)
    loss(is) = sqrt(value)
    scale(is) = value
    sbeam(:,:,is) = sbeam(:,:,is)*value  ! Now normalized
    kernel(:,:,is) = kernel(:,:,is)*value    ! Corresponding Kernel
    gains(is) = again(is)
  enddo
  !
  write(chain,'(A,3(1X,1PG11.4))') 'Scales ',scale
  call map_message(seve%i,rname,chain)
  write(chain,'(A,3(1X,1PG11.4))') 'Noise ',loss
  call map_message(seve%i,rname,chain)
  !
  ! Main clean loop
  niter = 0
  ok = niter.lt.miter
  flux = 0.0
  !
  ! Initialize convergence test
  call amaxmask (resid,mask,nx,ny,ix(1),iy(1))
  if (resid(ix(1),iy(1)).gt.0.0) then
    sign = 1.0
  else
    sign =-1.0
  endif
  ncum = 1
  converge = 0.0
  oldcum = 0.0
  oldis = 0
  goodis = 1   ! To prevent compiler warning only..
  maxsn = 0    ! Also
  !
  do           ! For ever...
    do is = 1,ns
      if (is.eq.1) then
        call amaxmask (resid,mask,nx,ny,ix(1),iy(1))
        bruit(1) = resid(ix(1),iy(1))
      else
        !
        ! Smooth within (smoothed) mask
        call smooth_masked(nx,ny,sresid,resid, &
      &        smask,mk,nker(is),kernel(:,:,is))
!
! or (slower) anywhere
!!        call smooth_kernel(resid,sresid,nx,ny,mk,nker(is),kernel(:,:,is))
        !
        ! Use MASK or SMASK, more or less at will...
        call amaxmask (sresid,mask,nx,ny,ix(is),iy(is))
        bruit(is) = sresid(ix(is),iy(is))
      endif
    enddo
    !
    maxa = -1.0
    do is = 1,ns
      sn(is) = abs(bruit(is)*loss(is))
      if (sn(is).gt.maxa) then
        maxa = sn(is)
        goodis = is
      endif
    enddo
    !
    if (niter.eq.0) maxsn = sn(goodis)
    !
    ! Check criterium
    ok = niter.lt.miter
    ok = ok .and. abs(bruit(1)).ge.limit
    if (.not.ok) exit
    if (sn(goodis).gt.maxsn) then
      ok = .false.  ! Stop if S/N has degraded
      exit
    endif
    maxsn = worry*sn(goodis)+(1.0-worry)*maxsn  ! Propagate S/N estimate
    !
    niter = niter+1
    !
    tcc(niter)%value = gains(goodis)*bruit(goodis)
    tcc(niter)%ix = ix(goodis)
    tcc(niter)%iy = iy(goodis)
    tcc(niter)%type = goodis
    !
    ! Do not Scale component flux : See Note Later
    flux = flux + tcc(niter)%value*scale(goodis)
    !
    oldcum(ncum) = flux
    ncum = ncum+1
    if (ncum.gt.mcum) ncum = 1
    converge = sign * (flux - oldcum(ncum))
    !
    ! Plot the new point
    if (printout.and.goodis.ne.oldis) then
      if (goodis.eq.1) then
        write(chain,101) niter,ix(goodis),iy(goodis),   &
     &            sn(1),sn(2),sn(3),bruit(goodis)*loss(goodis)
      elseif (goodis.eq.2) then
        write(chain,102) niter,ix(goodis),iy(goodis),   &
     &            sn(1),sn(2),sn(3),bruit(goodis)*loss(goodis)
      elseif (goodis.eq.3) then
        write(chain,103) niter,ix(goodis),iy(goodis),   &
     &            sn(1),sn(2),sn(3),bruit(goodis)*loss(goodis)
      endif
      call map_message(seve%r,rname,chain)
      oldis = goodis
    endif
    ncase(goodis) = ncase(goodis)+1
    ! Scale cumulative flux : See Note Later
    fluxes(goodis) = fluxes(goodis) + gains(goodis)*bruit(goodis)*scale(goodis)
    if (plot) then
      is = goodis
      call next_flux90 (niter,flux,is)
    endif
    !
    ! Subtract from residual
    !
    maxa = -again(goodis)*bruit(goodis)
    !
    ! Translate appropriate beam
    kx = ix(goodis)-nx/2-1
    ky = iy(goodis)-ny/2-1
    !
!$    ! Print *,'In parallel ',omp_in_parallel()
!$OMP PARALLEL &
!$OMP  & SHARED(nx,ny,kx,ky,goodis,trans)  PRIVATE(i,j)
!$OMP DO
    do j=max(1,ky+1),min(ny,ny+ky)
      do i=max(1,kx+1),min(nx,nx+kx)
        trans(i,j) = sbeam(i-kx,j-ky,goodis)
      enddo
    enddo
!$OMP END DO
    !
    ! Why not subtract everywhere ?
    !     resid = resid + maxa*trans
!    where (smask)
!      resid = resid + maxa*trans
!    end where
!$OMP DO
    do j=1,ny
      do i=1,nx
        resid(i,j) = resid(i,j) + maxa * trans(i,j)
        trans(i,j) = 0.0
      enddo
    enddo
!$OMP END DO
!$OMP END PARALLEL
    if (.not.keep) ok = ok.and.(converge.ge.0.0)
    if (.not.ok) exit
  enddo
  !
  if (niter.eq.miter) then
    string = 'iteration limit'
  else if (sn(goodis).gt.maxsn) then
    string = 'signal to noise stability'
  else if ((.not.keep).and.converge.lt.0.0) then
    string = 'flux convergence'
  else
    string = 'residual'
  endif
  write(chain,104) 'Stopped by ',trim(string),niter,bruit(1),limit
  call map_message(seve%i,rname,chain)
  do is=1,ns
    write(chain,105) '#',is,' Ncomp ',ncase(is),' Flux ',fluxes(is)
    call map_message(seve%i,rname,chain)
  enddo
  !
  ! Done: RESTORATION Process now
  clean = 0.0
  !
  ! If CCT component flux are not scaled, use the Kernel as they are
  ! If they are scaled,  normalize them to 1 back again...
  !
  ! Here they are NOT scaled
  !
  write(chain,'(A,1PG11.4)') 'Cleaned flux ',flux
  call map_message(seve%i,rname,chain)
  do i=1,niter
    value = tcc(i)%value
    kx = tcc(i)%ix
    ky = tcc(i)%iy
    is = tcc(i)%type
    if (is.eq.1) then
      clean (kx,ky) = clean(kx,ky) + value
    else
      call add_kernel (clean,nx,ny,value,kx,ky,mk,nker(is),kernel(:,:,is))
    endif
  enddo
  !
  ! Final residual
  cdata = cmplx(clean,0.0)
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt(cdata,nn,ndim,-1,1,wfft)
  cdata = cdata*tfbeam            ! Complex by Real multiplication
  call fourt(cdata,nn,ndim,1,1,wfft)
  resid = dirty-real(cdata)
  !
  ! Convolution with clean beam is done outside
  return
  !
  101   format(i6,i4,i4,' [',1pg11.4,'] ',1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4)
  102   format(i6,i4,i4,2x,1pg11.4,' [',1pg11.4,'] ',1pg11.4,'  = ',   &
     &    1pg11.4)
  103   format(i6,i4,i4,2x,1pg11.4,2x,1pg11.4,' [',1pg11.4,'] = ',   &
     &    1pg11.4)
  104   format(a,a,i6,1pg11.4,1x,1pg11.4)
  105   format(a,i1,a,i5,a,1pg11.4)
end subroutine major_multi90
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_list
  use phys_const
  use gkernel_interfaces
  use classic_api
  use toc_types
  use cubedag_parameters
  use cubedag_dag
  use cubedag_find
  use cubedag_history
  use cubedag_messaging
  use cubedag_tuple
  use cubedag_type
  use cubedag_link_type
  use cubedag_node_type
  use cubedag_index_iterator_tool

  integer(kind=4), parameter :: opttoc=1
  integer(kind=4), parameter :: optpage=2
  integer(kind=4), parameter :: optcolumn=3
  integer(kind=4), parameter :: optfile=4
  integer(kind=4), parameter :: optvar=5

  integer(kind=4), parameter :: npublic=44
  integer(kind=4), parameter :: nprivate=2  ! curr_lead,curr_trail
  integer(kind=4), parameter :: ncolumns=npublic+nprivate
  character(len=*), parameter :: columns(npublic) = (/  &
    'ENTRY      ','IDENTIFIER ','PARENTS    ','CHILDREN   ','TWINS      ',  &
    'UNIT       ','SOURCE     ','PROJTYPE   ','L0         ','M0         ',  &
    'PROJANGLE  ','SPALINC    ','SPAMINC    ','LINE       ','SPEFREQVAL ',  &
    'SPEFREQINC ','SPEVELOVAL ','BMAJOR     ','BMINOR     ','BPA        ',  &
    'OBSERVATORY','LOCATION   ','ACCESS     ','ORIGIN     ','FAMILY     ',  &
    'FLAGS      ','CUBEID     ','TYPE       ','VARIABLE   ','SEPARATOR  ',  &
    'HISTORY    ','MEMSIZE    ','DISKSIZE   ','DATASIZE   ','DATATYPE   ',  &
    ! Shorcuts for group of columns
    'DEFAULT    ','BEAM       ','PROJECTION ','GRAPH      ','SPECTRAL   ',  &
    'SPATIAL    ','TUPLE      ','SIZE       ','CURRENT    '/)
  integer(kind=4) :: col_width(ncolumns)
  character(len=6) :: col_hformat(ncolumns)  ! Header format
  character(len=6) :: col_vformat(ncolumns)  ! Value format
  !
  integer(kind=code_k), parameter :: col_none        = 0  ! Nullifier
  integer(kind=code_k), parameter :: col_entry       = 1
  integer(kind=code_k), parameter :: col_id          = 2
  integer(kind=code_k), parameter :: col_parents     = 3
  integer(kind=code_k), parameter :: col_children    = 4
  integer(kind=code_k), parameter :: col_twins       = 5
  integer(kind=code_k), parameter :: col_unit        = 6
  integer(kind=code_k), parameter :: col_source      = 7
  integer(kind=code_k), parameter :: col_ptype       = 8
  integer(kind=code_k), parameter :: col_l0          = 9
  integer(kind=code_k), parameter :: col_m0          = 10
  integer(kind=code_k), parameter :: col_pang        = 11
  integer(kind=code_k), parameter :: col_lres        = 12
  integer(kind=code_k), parameter :: col_mres        = 13
  integer(kind=code_k), parameter :: col_line        = 14
  integer(kind=code_k), parameter :: col_restf       = 15
  integer(kind=code_k), parameter :: col_fres        = 16
  integer(kind=code_k), parameter :: col_vsys        = 17
  integer(kind=code_k), parameter :: col_rmaj        = 18
  integer(kind=code_k), parameter :: col_rmin        = 19
  integer(kind=code_k), parameter :: col_rang        = 20
  integer(kind=code_k), parameter :: col_observatory = 21
  integer(kind=code_k), parameter :: col_location    = 22
  integer(kind=code_k), parameter :: col_access      = 23
  integer(kind=code_k), parameter :: col_origin      = 24
  integer(kind=code_k), parameter :: col_family      = 25
  integer(kind=code_k), parameter :: col_flag        = 26
  integer(kind=code_k), parameter :: col_cubeid      = 27
  integer(kind=code_k), parameter :: col_type        = 28
  integer(kind=code_k), parameter :: col_sicvar      = 29
  integer(kind=code_k), parameter :: col_separ       = 30
  integer(kind=code_k), parameter :: col_history     = 31
  integer(kind=code_k), parameter :: col_memsize     = 32
  integer(kind=code_k), parameter :: col_disksize    = 33
  integer(kind=code_k), parameter :: col_datasize    = 34
  integer(kind=code_k), parameter :: col_datatype    = 35
  ! Aliases
  integer(kind=code_k), parameter :: col_default     = 36
  integer(kind=code_k), parameter :: col_beam        = 37
  integer(kind=code_k), parameter :: col_proj        = 38
  integer(kind=code_k), parameter :: col_graph       = 39
  integer(kind=code_k), parameter :: col_spec        = 40
  integer(kind=code_k), parameter :: col_spat        = 41
  integer(kind=code_k), parameter :: col_tuple       = 42
  integer(kind=code_k), parameter :: col_size        = 43
  integer(kind=code_k), parameter :: col_current     = 44
  ! Private
  integer(kind=code_k), parameter :: col_curr_lead   = 45
  integer(kind=code_k), parameter :: col_curr_trail  = 46
  !
  ! Aliases translation
  integer(kind=code_k), parameter :: col_default_list(9) =  &
    [col_curr_lead,col_id,col_type,col_cubeid,col_observatory, &
     col_source,col_line,col_history,col_curr_trail]
  integer(kind=code_k), parameter :: col_beam_list(3) = &
    [col_rmaj,col_rmin,col_rang]
  integer(kind=code_k), parameter :: col_proj_list(4) = &
    [col_ptype,col_l0,col_m0,col_pang]
  integer(kind=code_k), parameter :: col_graph_list(4) = &
    [col_family,col_parents,col_children,col_twins]
  integer(kind=code_k), parameter :: col_spec_list(4) = &
    [col_line,col_restf,col_fres,col_vsys]
  integer(kind=code_k), parameter :: col_spat_list(5) = &
    [col_source,col_l0,col_m0,col_lres,col_mres]
  integer(kind=code_k), parameter :: col_tuple_list(2) = &
    [col_access,col_location]
  integer(kind=code_k), parameter :: col_size_list(3) = &
    [col_datasize,col_memsize,col_disksize]
  integer(kind=code_k), parameter :: col_curr_list(2) = &
    [col_curr_lead,col_curr_trail]
  !
  ! Support for /TOC option
  ! Identifiers
  integer(kind=4), parameter :: cubedag_toc_key_source=1
  integer(kind=4), parameter :: cubedag_toc_key_line=2
  integer(kind=4), parameter :: cubedag_toc_key_observatory=3
  integer(kind=4), parameter :: cubedag_toc_key_origin=4
  integer(kind=4), parameter :: cubedag_toc_key_family=5
  integer(kind=4), parameter :: cubedag_toc_key_flags=6
  ! Keywords (order matters, see subroutine cubedag_toc_init):
  character(len=*), parameter :: cubedag_list_toc_keys(6) = (/  &
    'SOURCE', 'LINE  ', 'OBSERV', 'ORIGIN', 'FAMILY', 'FLAGS ' /)
  ! CUBE index types, i.e. for fields which needs special decoding (e.g.
  ! gag_date: we won't display the I*4 value, but its translation as a string)
  integer(kind=4), parameter :: cubedag_ptype_null=0
  integer(kind=4), parameter :: cubedag_ptype_origin=1
  type(toc_t), target :: mtoc
  integer(kind=code_k),  target, allocatable :: toc_origin(:)
  character(len=base_l), target, allocatable :: toc_family(:)
  character(len=sour_l), target, allocatable :: toc_source(:)
  character(len=line_l), target, allocatable :: toc_line(:)
  character(len=flag_l), target, allocatable :: toc_flag(:)
  character(len=12),     target, allocatable :: toc_obs(:)
  !
  public :: cubedag_list_command,cubedag_list_optx,cubedag_list_link
  public :: cubedag_list_user_t, columns
  public :: cubedag_list_columns_parse,cubedag_list_columns_set
  public :: cubedag_list_link_widths,cubedag_list_one_custom
  public :: cubedag_list_toc_keys
  private
  !
  type cubedag_list_user_t
     type(find_prog_t)     :: find
     character(len=argu_l) :: ucols(20)
     character(len=argu_l) :: tocvar
     character(len=file_l) :: file
     integer(kind=code_k)  :: index
     integer(kind=4)       :: ncol
     logical               :: dofile
     logical               :: dovar
     logical               :: dopage
     logical               :: dotoc
     integer(kind=4)       :: iopttoc
     character(len=:), pointer :: line  ! Sic can not work with a copy, but with the original chain only
  end type cubedag_list_user_t
  !
contains
  !
  subroutine cubedag_list_command(user,error)
    !---------------------------------------------------------------------
    ! Execution routine for command LIST
    !---------------------------------------------------------------------
    type(cubedag_list_user_t), intent(inout) :: user
    logical,                   intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='LIST'
    character(len=7) :: optname
    integer(kind=4) :: ier,olun
    type(cubedag_link_t) :: optx
    integer(kind=4) :: ukeys(20),custom(20)  ! Up to 20 custom columns
    character(len=filename_length) :: file
    !
    select case (user%index)
    case (code_index_dag)
      optname = 'DAG'
      call user%find%ix2optx(optx,error)
      if (error)  return
    case (code_index_current)
      optname = 'Current'
      call user%find%cx2optx(optx,error)
      if (error)  return
    case default
      call cubedag_message(seve%e,rname,'Default index is not supported')
      error = .true.
      return
    end select
    !
    ! Output to STDOUT or file?
    if (user%dofile) then  ! /FILE
      ier = sic_getlun(olun)
      if (ier.ne.1) then
        call cubedag_message(seve%e,rname,'No logical unit left')
        error = .true.
        return
      endif
      ier = sic_open(olun,user%file,'NEW',.false.)
      if (ier.ne.0) then
        call cubedag_message(seve%e,rname,'Cannot open file '//file)
        error = .true.
        call sic_frelun(olun)
        return
      endif
    else
      olun = stdout
    endif
    !
    if (user%dotoc) then  ! /TOC
      call cubedag_list_toc_comm(optx,user,olun,error)
      if (error)  goto 10
    else
      call cubedag_list_columns_parse(user%ncol,user%ucols,ukeys,error)
      if (error)  goto 10
      call cubedag_list_columns_set(ukeys,custom,error)
      if (error)  goto 10
      call cubedag_list_optx_widths(optx,custom,error)
      if (error)  goto 10
      call cubedag_list_do(optx,optname,custom,olun,user%dopage,error)
      if (error)  goto 10
    endif
    !
  10 continue
    if (olun.ne.stdout) then
      ier = sic_close(olun)
      call sic_frelun(olun)
    endif
  end subroutine cubedag_list_command
  !
  subroutine cubedag_list_optx(optx,optname,error)
    type(cubedag_link_t), intent(in)    :: optx
    character(len=*),     intent(in)    :: optname
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: custom(20)
    !
    call cubedag_list_columns_set([col_default],custom,error)
    if (error)  return
    call cubedag_list_optx_widths(optx,custom,error)
    if (error)  return
    call cubedag_list_do(optx,optname,custom,stdout,.false.,error)
    if (error)  return
  end subroutine cubedag_list_optx
  !
  subroutine cubedag_list_columns_parse(ncol,ucols,ukeys,error)
    use cubetools_disambiguate
    !---------------------------------------------------------------------
    ! Support routine for command:
    !   MLIST /COLUMNS Key1 ... KeyN
    ! Get the custom list of columns (user identifiers)
    !---------------------------------------------------------------------
    integer(kind=4),      intent(in)    :: ncol
    character(len=*),     intent(in)    :: ucols(:)
    integer(kind=code_k), intent(out)   :: ukeys(:)  ! User keys
    logical,              intent(inout) :: error     !
    ! Local
    character(len=*), parameter :: rname='LIST'
    integer(kind=4) :: iarg
    character(len=12) :: key
    !
    ukeys(:) = col_none
    do iarg=1,ncol
      call cubetools_disambiguate_strict(ucols(iarg),columns,ukeys(iarg),key,error)
      if (error)  return
    enddo
  end subroutine cubedag_list_columns_parse
  !
  subroutine cubedag_list_columns_set(ukeys,ckeys,error)
    !---------------------------------------------------------------------
    ! Support routine for command:
    !   MLIST /COLUMNS Key1 ... KeyN
    ! Translate the list of user keys to column keys.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in)    :: ukeys(:)  !
    integer(kind=4), intent(out)   :: ckeys(:)  !
    logical,         intent(inout) :: error     !
    ! Local
    character(len=*), parameter :: rname='LIST'
    integer(kind=4) :: ikey,iout,nnew,itmp
    integer(kind=4) :: new(10)
    integer(kind=4) :: ctmp(size(ckeys))
    !
    ctmp(:) = col_none
    iout=0
    do ikey=1,size(ukeys)
      if (ukeys(ikey).eq.col_none)  exit
      ! Cases are for grouped columns, case default add a single column
      select case (ukeys(ikey))
      case(col_default)
        nnew = size(col_default_list)
        new(1:nnew) = col_default_list(:)
      case(col_beam)
        nnew = size(col_beam_list)
        new(1:nnew) = col_beam_list(:)
      case(col_proj)
        nnew = size(col_proj_list)
        new(1:nnew) = col_proj_list(:)
      case (col_graph)
        nnew = size(col_graph_list)
        new(1:nnew) = col_graph_list(:)
      case (col_spec)
        nnew = size(col_spec_list)
        new(1:nnew) = col_spec_list(:)
      case (col_spat)
        nnew = size(col_spat_list)
        new(1:nnew) = col_spat_list(:)
      case (col_tuple)
        nnew = size(col_tuple_list)
        new(1:nnew) = col_tuple_list(:)
      case (col_size)
        nnew = size(col_size_list)
        new(1:nnew) = col_size_list(:)
      case (col_current)
        nnew = size(col_curr_list)
        new(1:nnew) = col_curr_list(:)
      case default
        nnew = 1
        new(1) = ukeys(ikey)
      end select
      !
      if (iout+nnew.gt.size(ctmp)) then
        call cubedag_message(seve%w,rname,'/COLUMNS list too long, truncated')
        return
      endif
      ctmp(iout+1:iout+nnew) = new(1:nnew)
      iout = iout+nnew
    enddo
    !
    ! Special: move current marker columns at first and last positions
    ckeys(:) = col_none
    ikey = 0
    if (any(ctmp(1:iout).eq.col_curr_lead)) then
      ikey = ikey+1
      ckeys(ikey) = col_curr_lead
    endif
    do itmp=1,iout
      if (ctmp(itmp).eq.col_curr_lead)   cycle
      if (ctmp(itmp).eq.col_curr_trail)  cycle
      ikey = ikey+1
      ckeys(ikey) = ctmp(itmp)
    enddo
    if (any(ctmp(1:iout).eq.col_curr_trail)) then
      ikey = ikey+1
      ckeys(ikey) = col_curr_trail
    endif
  end subroutine cubedag_list_columns_set
  !
  subroutine cubedag_list_optx_widths(optx,custom,error)
    use cubedag_node
    !-------------------------------------------------------------------
    ! Compute the best width for columns supporting adaptative width,
    ! based on the index to be listed.
    ! This version with cubedag_link_t as argument
    !-------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: optx       !
    integer(kind=4),      intent(in)    :: custom(:)  ! Columns to be listed
    logical,              intent(inout) :: error      !
    ! Local
    integer(kind=entr_k) :: ient,maxid
    integer(kind=4) :: maxlfamily,maxlobs,maxlsour,maxlline,maxlflag,lflag
    integer(kind=4) :: maxlcubeid,maxlhistory
    character(len=24) :: str24  ! Max column length for these is 24
    class(cubedag_node_object_t), pointer :: obj
    !
    maxid = 0
    maxlfamily = 1
    maxlobs = 1
    maxlsour = 1
    maxlline = 1
    maxlflag = 1
    maxlcubeid = 1
    maxlhistory = 1
    !
    do ient=1,optx%n
      obj => cubedag_node_ptr(optx%list(ient)%p,error)
      if (error)  return
      if (obj%node%type.eq.code_type_node)  cycle
      ! Identifier
      maxid = max(maxid,obj%node%id)
      ! Family name length
      maxlfamily = max(maxlfamily,len_trim(obj%node%family))
      ! Observatory name length
      call obj%node%head%obs%tostr(str24,error)
      if (error)  return
      maxlobs = max(maxlobs,len_trim(str24))
      ! Source name length
      maxlsour = max(maxlsour,len_trim(obj%node%head%spatial_source))
      ! Line name length
      maxlline = max(maxlline,len_trim(obj%node%head%spectral_line))
      ! Flag name length
      call obj%node%flag%repr(lstrflag=lflag,error=error)
      if (error)  return
      maxlflag = max(maxlflag,lflag)
      ! CubeID name length
      maxlcubeid = max(maxlcubeid,len_trim(obj%node%family)+1+lflag)
      ! Command history
      call cubedag_history_tostr(obj%node%history,str24,error)
      if (error)  return
      maxlhistory = max(maxlhistory,len_trim(str24))
    enddo
    !
    col_width(col_id) = max(2,floor(log10(real(maxid,kind=8)))+1)
    write(col_hformat(col_id),'(A,I0,A)')  '(A',col_width(col_id),')'  ! Right-justified
    write(col_vformat(col_id),'(A,I0,A)')  '(I',col_width(col_id),')'
    !
    col_width(col_family) = maxlfamily
    col_hformat(col_family) = '(A)'
    write(col_vformat(col_family),'(A,I0,A)')  '(A',col_width(col_family),')'
    !
    col_width(col_observatory) = maxlobs
    col_hformat(col_observatory) = '(A)'
    write(col_vformat(col_observatory),'(A,I0,A)')  '(A',col_width(col_observatory),')'
    !
    col_width(col_source) = maxlsour
    col_hformat(col_source) = '(A)'
    write(col_vformat(col_source),'(A,I0,A)')  '(A',col_width(col_source),')'
    !
    col_width(col_line) = maxlline
    col_hformat(col_line) = '(A)'
    write(col_vformat(col_line),'(A,I0,A)')  '(A',col_width(col_line),')'
    !
    col_width(col_flag) = maxlflag
    col_hformat(col_flag) = '(A)'
    write(col_vformat(col_flag),'(A,I0,A)')  '(A',col_width(col_flag),')'
    !
    col_width(col_cubeid) = maxlcubeid
    col_hformat(col_cubeid) = '(A)'
    write(col_vformat(col_cubeid),'(A,I0,A)')  '(A',col_width(col_cubeid),')'
    !
    col_width(col_history) = maxlhistory
    col_hformat(col_history) = '(A)'
    write(col_vformat(col_history),'(A,I0,A)')  '(A',col_width(col_history),')'
  end subroutine cubedag_list_optx_widths
  !
  subroutine cubedag_list_link_widths(link,custom,error)
    !-------------------------------------------------------------------
    ! Compute the best width for columns supporting adaptative width,
    ! based on the link_t to be listed.
    ! This version with cubedag_link_t as argument
    !-------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: link       !
    integer(kind=4),      intent(in)    :: custom(:)  ! Columns to be listed
    logical,              intent(inout) :: error      !
    !
    call cubedag_list_optx_widths(link,custom,error)
    if (error)  return
  end subroutine cubedag_list_link_widths
  !
  subroutine cubedag_list_do(optx,name,custom,olun,page,error)
    use cubedag_node
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: optx       !
    character(len=*),     intent(in)    :: name       !
    integer(kind=4),      intent(in)    :: custom(:)  ! Columns to be listed
    integer(kind=4),      intent(in)    :: olun       ! Output logical unit
    logical,              intent(in)    :: page       ! Page or Scroll mode?
    logical,              intent(inout) :: error      !
    ! Local
    character(len=*), parameter :: rname='LIST'
    integer(kind=entr_k) :: ient
    integer(kind=4) :: tt_lines,iline
    character(len=message_length) :: mess
    class(cubedag_node_object_t), pointer :: obj
    !
    if (optx%n.le.0) then
      call cubedag_message(seve%w,rname,'No entry in '//trim(name)//' index')
      return
    endif
    if (custom(1).eq.col_none) then
      call cubedag_message(seve%e,rname,'Internal error: list of colums is empty')
      error = .true.
      return
    endif
    !
    tt_lines = sic_ttynlin()-1
    iline = 0
    !
    ! Print header
    call cubedag_list_one_custom_header(custom,mess,error)
    if (error)  return
    call cubedag_list_one_print(mess,olun,iline)
    !
    do ient=1,optx%n
      !
      obj => cubedag_node_ptr(optx%list(ient)%p,error)
      if (error)  return
      !
      ! Do not list pure-node object, which are irrelevant (no data provided)
      if (obj%node%type.eq.code_type_node)  cycle
      !
      if (olun.eq.stdout .and. page) then
        if (mod(iline,tt_lines).eq.0) then
          if (hlp_more().ne.0)  return
          ! Repeat header
          call cubedag_list_one_custom_header(custom,mess,error)
          if (error)  return
          call cubedag_list_one_print(mess,olun,iline)
        endif
      endif
      !
      call cubedag_list_node(obj,custom,olun,iline,error)
      if (error)  return
      !
    enddo
    !
    if (iline.gt.tt_lines .and. .not.page) then
      ! Long list in non-page mode: repeat header at last line
      call cubedag_list_one_custom_header(custom,mess,error)
      if (error)  return
      call cubedag_list_one_print(mess,olun,iline)
    endif
  end subroutine cubedag_list_do
  !
  subroutine cubedag_list_link(link,doheader,ucols,error)
    !-------------------------------------------------------------------
    ! List objects from a cubedag_link_t
    !-------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: link
    logical,              intent(in)    :: doheader
    character(len=*),     intent(in)    :: ucols(:)
    logical,              intent(inout) :: error
    ! Local
    integer(kind=entr_k) :: iobj
    integer(kind=code_k) :: ukeys(20)
    integer(kind=4) :: iline,custom(20)
    character(len=mess_l) :: mess
    class(cubedag_node_object_t), pointer :: dno
    !
    call cubedag_list_columns_parse(size(ucols),ucols,ukeys,error)
    if (error)  return
    call cubedag_list_columns_set(ukeys,custom,error)
    if (error)  return
    call cubedag_list_link_widths(link,custom,error)
    if (error)  return
    !
    iline = 0
    !
    if (doheader) then  ! Print header
      call cubedag_list_one_custom_header(custom,mess,error)
      if (error)  return
      call cubedag_list_one_print(mess,stdout,iline)
    endif
    !
    do iobj=1,link%n
      dno => cubedag_node_ptr(link%list(iobj)%p,error)
      if (error)  return
      call cubedag_list_node(dno,custom,stdout,iline,error)
      if (error)  return
    enddo
  end subroutine cubedag_list_link
  !
  function cubedag_list_shows_tuple(custom)
    !-------------------------------------------------------------------
    ! Return .true. if one of the tuple-related columns is to be shown
    !-------------------------------------------------------------------
    logical :: cubedag_list_shows_tuple
    integer(kind=4), intent(in) :: custom(:)
    !
    cubedag_list_shows_tuple = any(custom.eq.col_location) .or.  &
                               any(custom.eq.col_access)   .or.  &
                               any(custom.eq.col_disksize)
  end function cubedag_list_shows_tuple
  !
  subroutine cubedag_list_node(obj,custom,olun,iline,error)
    !-------------------------------------------------------------------
    ! List one node with custom columns
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj        !
    integer(kind=4),              intent(in)    :: custom(:)  ! Columns to be listed
    integer(kind=4),              intent(in)    :: olun       !
    integer(kind=4),              intent(inout) :: iline      ! Current line number
    logical,                      intent(inout) :: error      !
    ! Local
    integer(kind=4), parameter :: naccesses=6
    integer(kind=code_k), parameter :: accesses(naccesses) =  &
      (/ code_cube_imaset,code_cube_speset,code_cube_unkset,  &
         code_cube_imaset,code_cube_speset,code_cube_unkset /)
    integer(kind=code_k), parameter :: locations(naccesses) =  &
      (/ code_buffer_disk,  code_buffer_disk,  code_buffer_disk, &
         code_buffer_memory,code_buffer_memory,code_buffer_memory /)
    logical :: first
    character(len=message_length) :: mess
    integer(kind=4) :: icube
    !
    first = .true.
    if (cubedag_list_shows_tuple(custom)) then
      do icube=1,naccesses  ! Loop over the possible cubes in tuple
        if (obj%node%tuple%hascube(accesses(icube),locations(icube))) then
          call cubedag_list_one_custom(obj,custom,first,accesses(icube),locations(icube),mess,error)
          if (error)  return
          call cubedag_list_one_print(mess,olun,iline)
          if (first)  first = .false.
        endif
      enddo
    endif
    !
    if (first) then
      ! This can happen if:
      ! 1) no tuple-related column is to be shown
      ! 2) not a single cube was available. Might happen in case of error...
      call cubedag_list_one_custom(obj,custom,first,code_null,code_null,mess,error)
      if (error)  return
      call cubedag_list_one_print(mess,olun,iline)
    endif
  end subroutine cubedag_list_node
  !
  subroutine cubedag_list_one_custom(obj,custom,all,access,location,mess,error)
    class(cubedag_node_object_t), intent(in)    :: obj
    integer(kind=4),              intent(in)    :: custom(:)  !
    logical,                      intent(in)    :: all        !
    integer(kind=code_k),         intent(in)    :: access     !
    integer(kind=code_k),         intent(in)    :: location   !
    character(len=*),             intent(out)   :: mess       !
    logical,                      intent(inout) :: error      !
    !
    if (all) then
      call cubedag_list_one_custom_all(obj,custom,access,location,mess,error)
      if (error)  return
    else
      call cubedag_list_one_custom_tuple(obj,custom,access,location,mess,error)
      if (error)  return
    endif
  end subroutine cubedag_list_one_custom
  !
  subroutine cubedag_list_one_custom_header(custom,mess,error)
    integer(kind=4),  intent(in)    :: custom(:)  !
    character(len=*), intent(out)   :: mess       !
    logical,          intent(inout) :: error      !
    ! Local
    integer(kind=4) :: icol,nc
    !
    mess = ''
    nc = 0
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_entry)
        write(mess(nc+1:),'(A5)')   'Entry'
        nc = nc+6
      case (col_id)
        write(mess(nc+1:),col_hformat(col_id))   'Id'  ! Right-justified
        nc = nc+col_width(col_id)+1
      case (col_parents)
        write(mess(nc+1:),'(A20)')  'Parents             '
        nc = nc+21
      case (col_children)
        write(mess(nc+1:),'(A20)')  'Children            '
        nc = nc+21
      case (col_twins)
        write(mess(nc+1:),'(A20)')  'Twins               '
        nc = nc+21
      case (col_unit)
        write(mess(nc+1:),'(A12)')  'Unit        '
        nc = nc+13
      case (col_source)
        mess(nc+1:nc+col_width(col_source)) = 'Source'
        nc = nc+col_width(col_source)+1
      case (col_ptype)
        write(mess(nc+1:),'(A13)')  'ProjType     '
        nc = nc+14
      case (col_l0)
        write(mess(nc+1:),'(A11)')  'L0         '
        nc = nc+12
      case (col_m0)
        write(mess(nc+1:),'(A11)')  'M0         '
        nc = nc+12
      case (col_pang)
        write(mess(nc+1:),'(A5)')  'ProjA'
        nc = nc+6
      case (col_lres)
        write(mess(nc+1:),'(A7)')  'SpaLInc'
        nc = nc+8
      case (col_mres)
        write(mess(nc+1:),'(A7)')  'SpaMInc'
        nc = nc+8
      case (col_line)
        mess(nc+1:nc+col_width(col_line)) = 'Line'
        nc = nc+col_width(col_line)+1
      case (col_restf)
        write(mess(nc+1:),'(A10)')  'SpeFreqVal'
        nc = nc+11
      case (col_fres)
        write(mess(nc+1:),'(A7)')  'FreqInc'
        nc = nc+8
      case (col_vsys)
        write(mess(nc+1:),'(A6)')  'VeloVa'
        nc = nc+7
      case (col_rmaj)
        write(mess(nc+1:),'(A6)')  'BeaMaj'
        nc = nc+7
      case (col_rmin)
        write(mess(nc+1:),'(A6)')  'BeaMin'
        nc = nc+7
      case (col_rang)
        write(mess(nc+1:),'(A5)')  'BeaPA'
        nc = nc+6
      case (col_observatory)
        mess(nc+1:nc+col_width(col_observatory)) = 'Observatory'
        nc = nc+col_width(col_observatory)+1
      case (col_location)
        write(mess(nc+1:),'(A30)')  'Location                      '
        nc = nc+31
      case (col_access)
        write(mess(nc+1:),'(A14)')  'Access        '
        nc = nc+15
      case (col_origin)
        write(mess(nc+1:),'(A8)')  'Origin  '
        nc = nc+9
      case (col_family)
        mess(nc+1:nc+col_width(col_family)) = 'Family'
        nc = nc+col_width(col_family)+1
      case (col_flag)
        mess(nc+1:nc+col_width(col_flag)) = 'Flags'
        nc = nc+col_width(col_flag)+1
      case (col_cubeid)
        mess(nc+1:nc+col_width(col_cubeid)) = 'CubeID'
        nc = nc+col_width(col_cubeid)+1
      case (col_type)
        write(mess(nc+1:),'(A2)')  'Ty'
        nc = nc+3
      case (col_memsize)
        write(mess(nc+1:),'(A8)')  'MemSize '
        nc = nc+9
      case (col_disksize)
        write(mess(nc+1:),'(A8)')  'DiskSize'
        nc = nc+9
      case (col_datasize)
        write(mess(nc+1:),'(A8)')  'DataSize'
        nc = nc+9
      case (col_datatype)
        write(mess(nc+1:),'(A8)')  'DataType'
        nc = nc+9
      case (col_sicvar)
        write(mess(nc+1:),'(A24)')  'Variable                '
        nc = nc+25
      case (col_separ)
        write(mess(nc+1:),'(A1)')  '|'
        nc = nc+2
      case (col_history)
        mess(nc+1:nc+col_width(col_history)) = 'History'
        nc = nc+col_width(col_history)+1
      case (col_curr_lead,col_curr_trail)
        nc = nc+4  ! No header
      case (col_none)
        exit
      case default
        write(mess(nc+1:),'(A3)')   '???'
        nc = nc+4
      end select
    enddo
  end subroutine cubedag_list_one_custom_header
  !
  subroutine cubedag_list_one_custom_all(obj,custom,access,location,mess,error)
    use cubetools_format
    use cubesyntax_datatype_types
    class(cubedag_node_object_t), intent(in)    :: obj
    integer(kind=4),              intent(in)    :: custom(:)
    integer(kind=code_k),         intent(in)    :: access
    integer(kind=code_k),         intent(in)    :: location
    character(len=*),             intent(out)   :: mess
    logical,                      intent(inout) :: error
    ! Local
    integer(kind=4) :: icol,nc
    type(index_iterator_t) :: iter
    !
    mess = ''
    nc = 0
    !
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_entry)
        write(mess(nc+1:),'(I5)')   obj%node%ient
        nc = nc+6
      case (col_id)
        if (obj%node%id.lt.0) then  ! Null id
          mess(nc+1:nc+col_width(col_id)) = '--------------------'
        else
          write(mess(nc+1:),col_vformat(col_id))   obj%node%id
        endif
        nc = nc+col_width(col_id)+1
      case (col_parents)
        call obj%node%parents%repr('p=',mess(nc+1:nc+20))
        nc = nc+21
      case (col_children)
        call obj%node%children%repr('c=',mess(nc+1:nc+20))
        nc = nc+21
      case (col_twins)
        call obj%node%twins%repr('t=',mess(nc+1:nc+20))
        nc = nc+21
      case (col_unit)
        write(mess(nc+1:),'(A12)')  obj%node%head%array_unit
        nc = nc+13
      case (col_source)
        write(mess(nc+1:),col_vformat(col_source))  obj%node%head%spatial_source
        nc = nc+col_width(col_source)+1
      case (col_ptype)
        write(mess(nc+1:),'(A13)')  projnam(obj%node%head%spatial_projection_code)
        nc = nc+14
      case (col_l0)
        call sexag(mess(nc+1:nc+12),obj%node%head%spatial_projection_l0,24)
        mess(nc+12:nc+12) = ''
        nc = nc+12
      case (col_m0)
        call sexag(mess(nc+1:nc+12),obj%node%head%spatial_projection_m0,360)
        mess(nc+12:nc+12) = ''
        nc = nc+12
      case (col_pang)
        write(mess(nc+1:),'(F5.1)')  obj%node%head%spatial_projection_pa*deg_per_rad
        nc = nc+6
      case (col_lres)
        write(mess(nc+1:),'(F7.2)')  obj%node%head%axset_convert  &
          (code_inc,obj%node%head%axset_ix)*sec_per_rad
        nc = nc+8
      case (col_mres)
        write(mess(nc+1:),'(F7.2)')  obj%node%head%axset_convert  &
          (code_inc,obj%node%head%axset_iy)*sec_per_rad
        nc = nc+8
      case (col_line)
        write(mess(nc+1:),col_vformat(col_line))  obj%node%head%spectral_line
        nc = nc+col_width(col_line)+1
      case (col_restf)
        write(mess(nc+1:),'(F10.3)')  obj%node%head%spectral_signal_value
        nc = nc+11
      case (col_fres)
        write(mess(nc+1:),'(F7.3)')  obj%node%head%spectral_increment_value
        nc = nc+8
      case (col_vsys)
        write(mess(nc+1:),'(F6.2)')  obj%node%head%spectral_systemic_value
        nc = nc+7
      case (col_rmaj)
        write(mess(nc+1:),'(F6.2)')  obj%node%head%spatial_beam_major*sec_per_rad
        nc = nc+7
      case (col_rmin)
        write(mess(nc+1:),'(F6.2)')  obj%node%head%spatial_beam_minor*sec_per_rad
        nc = nc+7
      case (col_rang)
        write(mess(nc+1:),'(F5.1)')  obj%node%head%spatial_beam_pa*deg_per_rad
        nc = nc+6
      case (col_observatory)
        call obj%node%head%obs%tostr(mess(nc+1:nc+col_width(col_observatory)),error)
        nc = nc+col_width(col_observatory)+1
      case (col_location)
        call obj%node%tuple%location(access,location,mess(nc+1:nc+30))
        nc = nc+31
      case (col_access)
        call cubedag_list_access(access,mess(nc+1:nc+14),error)
        nc = nc+15
      case (col_origin)
        call cubedag_list_origin(obj%node%origin,mess(nc+1:nc+8),error)
        nc = nc+9
      case (col_family)
        write(mess(nc+1:),col_vformat(col_family))  obj%node%family
        nc = nc+col_width(col_family)+1
      case (col_flag)
        call obj%node%flag%repr(strflag=mess(nc+1:nc+col_width(col_flag)),error=error)
        nc = nc+col_width(col_flag)+1
      case (col_cubeid)
        write(mess(nc+1:),col_vformat(col_cubeid))  obj%node%cubeid(error)
        nc = nc+col_width(col_cubeid)+1
      case (col_type)
        mess(nc+1:nc+2) = obj%ltype()
        nc = nc+3
      case (col_memsize)
        mess(nc+1:nc+8) = cubetools_format_memsize(obj%memsize())
        nc = nc+9
      case (col_disksize)
        mess(nc+1:nc+8) = cubetools_format_memsize(obj%node%tuple%disksize(access,location))
        nc = nc+9
      case (col_datasize)
        mess(nc+1:nc+8) = cubetools_format_memsize(obj%datasize())
        nc = nc+9
      case (col_datatype)
        mess(nc+1:nc+8) = cubesyntax_datatype(obj%datatype())
        nc = nc+9
      case (col_sicvar)
        call cubedag_sicvar_tostr(obj%node%nsicvar,obj%node%sicvar,mess(nc+1:nc+24),error)
        nc = nc+25
      case (col_separ)
        write(mess(nc+1:),'(A1)')  '|'
        nc = nc+2
      case (col_history)
        call cubedag_history_tostr(obj%node%history,mess(nc+1:nc+col_width(col_history)),error)
        nc = nc+col_width(col_history)+1
      case (col_curr_lead)
        if (iter%is_current(obj%node%id))  mess(nc+1:nc+3) = '>>>'
        nc = nc+4
      case (col_curr_trail)
        if (iter%is_current(obj%node%id))  mess(nc+1:nc+3) = '<<<'
        nc = nc+4
      case (col_none)
        exit
      case default
        write(mess(nc+1:),'(A3)')   '???'
        nc = nc+4
      end select
    enddo
  end subroutine cubedag_list_one_custom_all
  !
  subroutine cubedag_list_one_custom_tuple(obj,custom,access,location,mess,error)
    use cubetools_format
    !-------------------------------------------------------------------
    ! Print only tuple-related columns. Others are replaced by blanks
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: obj
    integer(kind=4),              intent(in)    :: custom(:)
    integer(kind=code_k),         intent(in)    :: access
    integer(kind=code_k),         intent(in)    :: location
    character(len=*),             intent(out)   :: mess
    logical,                      intent(inout) :: error
    ! Local
    integer(kind=4) :: icol,nc
    !
    mess = ''
    nc = 0
    !
    do icol=1,size(custom)
      select case (custom(icol))
      case (col_entry)
        nc = nc+6
      case (col_id)
        nc = nc+col_width(col_id)+1
      case (col_parents)
        nc = nc+21
      case (col_children)
        nc = nc+21
      case (col_twins)
        nc = nc+21
      case (col_unit)
        nc = nc+13
      case (col_source)
        nc = nc+col_width(col_source)+1
      case (col_ptype)
        nc = nc+14
      case (col_l0)
        nc = nc+12
      case (col_m0)
        nc = nc+12
      case (col_pang)
        nc = nc+6
      case (col_lres)
        nc = nc+8
      case (col_mres)
        nc = nc+8
      case (col_line)
        nc = nc+col_width(col_line)+1
      case (col_restf)
        nc = nc+11
      case (col_fres)
        nc = nc+8
      case (col_vsys)
        nc = nc+7
      case (col_rmaj)
        nc = nc+7
      case (col_rmin)
        nc = nc+7
      case (col_rang)
        nc = nc+6
      case (col_observatory)
        nc = nc+col_width(col_observatory)+1
      case (col_location)
        call obj%node%tuple%location(access,location,mess(nc+1:nc+30))
        nc = nc+31
      case (col_access)
        call cubedag_list_access(access,mess(nc+1:nc+14),error)
        nc = nc+15
      case (col_origin)
        nc = nc+9
      case (col_family)
        nc = nc+col_width(col_family)+1
      case (col_flag)
        nc = nc+col_width(col_flag)+1
      case (col_cubeid)
        nc = nc+col_width(col_cubeid)+1
      case (col_type)
        nc = nc+3
      case (col_memsize,col_datasize)
        nc = nc+9
      case (col_disksize)
        mess(nc+1:nc+8) = cubetools_format_memsize(obj%node%tuple%disksize(access,location))
        nc = nc+9
      case (col_sicvar)
        nc = nc+25
      case (col_separ)
        write(mess(nc+1:),'(A1)')  '|'
        nc = nc+2
      case (col_history)
        nc = nc+col_width(col_history)+1
      case (col_curr_lead,col_curr_trail)
        nc = nc+4
      case (col_none)
        exit
      case default
        write(mess(nc+1:),'(A3)')   '???'
        nc = nc+4
      end select
    enddo
  end subroutine cubedag_list_one_custom_tuple
  !
  subroutine cubedag_list_access(access,straccess,error)
    !-------------------------------------------------------------------
    ! Return the list of available access modes
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: access
    character(len=*),     intent(out)   :: straccess
    logical,              intent(inout) :: error
    !
    select case (access)
    case (code_cube_speset)
      straccess = 'spectrum'
    case (code_cube_imaset)
      straccess = 'image'
    case (code_cube_unkset)
      straccess = 'unknown'
    case default
      straccess = '???'  ! Should not happen
    end select
  end subroutine cubedag_list_access
  !
  subroutine cubedag_list_origin(origin,strorigin,error)
    !-------------------------------------------------------------------
    ! Return the list of available access modes
    !-------------------------------------------------------------------
    integer(kind=code_k), intent(in)    :: origin
    character(len=*),     intent(out)   :: strorigin
    logical,              intent(inout) :: error
    !
    select case (origin)
    case (1:dag_norigins)
      strorigin = dag_origin_names(origin)
    case default
      strorigin = '???'
    end select
  end subroutine cubedag_list_origin
  !
  subroutine cubedag_list_one_print(message,olun,iline)
    !---------------------------------------------------------------------
    !  Send the message to the given Logical Unit. Quite generic, could
    ! be used in other contexts.
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: message
    integer(kind=4),  intent(in)    :: olun
    integer(kind=4),  intent(inout) :: iline  ! Current line number
    ! Local
    character(len=*), parameter :: rname='LIST'
    !
    iline = iline+1
    if (olun.eq.stdout) then
      call cubedag_message(seve%r,rname,message)
    else
      write(olun,'(A)') trim(message)
    endif
  end subroutine cubedag_list_one_print

  subroutine cubedag_sicvar_tostr(nsicvar,sicvar,strsicvar,error)
    use cubetools_string
    !-------------------------------------------------------------------
    ! Return the SIC variable(s) of the input list into a string
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: nsicvar
    character(len=*), intent(in)    :: sicvar(:)
    character(len=*), intent(out)   :: strsicvar
    logical,          intent(inout) :: error
    !
    call cubetools_string_concat(nsicvar,sicvar,',',strsicvar,error)
    if (error)  return
  end subroutine cubedag_sicvar_tostr

  !=======================================================================
  !
  subroutine cubedag_list_toc_comm(optx,user,olun,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    !   LIST [IN|CURRENT] /TOC [Key1] ... [KeyN]  [/VARIABLE VarName]
    ! Main entry point
    !---------------------------------------------------------------------
    type(cubedag_link_t),      intent(in)    :: optx   !
    type(cubedag_list_user_t), intent(in)    :: user   ! User input
    integer(kind=4),           intent(in)    :: olun   !
    logical,                   intent(inout) :: error  ! Logical error flag
    ! Local
    integer(kind=4) :: toc_keys(13)  ! Arbitrary number of args accepted in option /TOC
    !
    call cubedag_toc_init(mtoc,error)
    if (error)  return
    !
    ! Default (unchanged if no arguments)
    toc_keys(:) = toc_key_null
    toc_keys(1) = cubedag_toc_key_family
    toc_keys(2) = cubedag_toc_key_flags
    call toc_getkeys(user%line,user%iopttoc,mtoc,toc_keys,error)
    if (error)  return
    !
    call cubedag_list_toc(optx,toc_keys,user%tocvar,olun,error)
    if (error)  return
  end subroutine cubedag_list_toc_comm
  !
  subroutine cubedag_toc_init(toc,error)
    !---------------------------------------------------------------------
    ! Support routine for command LIST /TOC
    ! Initialization routine
    !---------------------------------------------------------------------
    type(toc_t), intent(inout) :: toc    !
    logical,     intent(inout) :: error  !
    ! Local
    character(len=*), parameter :: rname='TOC>INIT'
    integer(kind=4) :: ier
    !
    if (toc%initialized)  return
    !
    toc%nkey = 6
    allocate(toc%keys(toc%nkey),stat=ier)
    if (failed_allocate(rname,'keys array',ier,error)) return
    !
    toc%keys(1)%id            = cubedag_toc_key_source
    toc%keys(1)%keyword       = cubedag_list_toc_keys(1)
    toc%keys(1)%sic_var_name  = 'sour'
    toc%keys(1)%human_name    = 'SOURCE'
    toc%keys(1)%message       = 'Number of sources......'
    toc%keys(1)%ftype         = toc_ftype_c12_1d
    toc%keys(1)%ptype         = cubedag_ptype_null
    !
    toc%keys(2)%id            = cubedag_toc_key_line
    toc%keys(2)%keyword       = cubedag_list_toc_keys(2)
    toc%keys(2)%sic_var_name  = 'line'
    toc%keys(2)%human_name    = 'LINE'
    toc%keys(2)%message       = 'Number of lines........'
    toc%keys(2)%ftype         = toc_ftype_c12_1d
    toc%keys(2)%ptype         = cubedag_ptype_null
    !
    toc%keys(3)%id            = cubedag_toc_key_observatory
    toc%keys(3)%keyword       = cubedag_list_toc_keys(3)
    toc%keys(3)%sic_var_name  = 'obs'
    toc%keys(3)%human_name    = 'OBSERVATORY'
    toc%keys(3)%message       = 'Number of observatories'
    toc%keys(3)%ftype         = toc_ftype_c12_1d
    toc%keys(3)%ptype         = cubedag_ptype_null
    !
    toc%keys(4)%id            = cubedag_toc_key_origin
    toc%keys(4)%keyword       = cubedag_list_toc_keys(4)
    toc%keys(4)%sic_var_name  = 'origin'
    toc%keys(4)%human_name    = 'ORIGIN'
    toc%keys(4)%message       = 'Number of origins......'
    toc%keys(4)%ftype         = toc_ftype_i4_1d
    toc%keys(4)%ptype         = cubedag_ptype_origin
    !
    toc%keys(5)%id            = cubedag_toc_key_family
    toc%keys(5)%keyword       = cubedag_list_toc_keys(5)
    toc%keys(5)%sic_var_name  = 'family'
    toc%keys(5)%human_name    = 'FAMILY'
    toc%keys(5)%message       = 'Number of families.....'
    toc%keys(5)%ftype         = toc_ftype_c128_1d
    toc%keys(5)%ptype         = cubedag_ptype_null
    !
    toc%keys(6)%id            = cubedag_toc_key_flags
    toc%keys(6)%keyword       = cubedag_list_toc_keys(6)
    toc%keys(6)%sic_var_name  = 'flags'
    toc%keys(6)%human_name    = 'FLAGS'
    toc%keys(6)%message       = 'Number of flags........'
    toc%keys(6)%ftype         = toc_ftype_c128_1d
    toc%keys(6)%ptype         = cubedag_ptype_null
    !
    call toc_init_pointers(toc,error)
    if (error)  return
    !
    toc%initialized = .true.
  end subroutine cubedag_toc_init
  !
  subroutine cubedag_toc_clean(error)
    !---------------------------------------------------------------------
    ! Support routine for command MLIST /TOC
    ! Clean the global variable holding the TOC
    !---------------------------------------------------------------------
    logical, intent(inout) :: error  !
    !
    call toc_clean(mtoc,error)
    ! if (error)  continue
  end subroutine cubedag_toc_clean
  !
  subroutine cubedag_list_toc(optx,keywords,tocname,olun,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    !   LIST /TOC
    ! Processing routine
    !---------------------------------------------------------------------
    type(cubedag_link_t), intent(in)    :: optx         ! The optx whose TOC is desired
    integer(kind=4),      intent(in)    :: keywords(:)  ! Key identifiers
    character(len=*),     intent(in)    :: tocname      ! Structure name
    integer(kind=4),      intent(in)    :: olun         !
    logical,              intent(inout) :: error        ! Logical error flag
    ! Local
    character(len=*), parameter :: rname='LIST>TOC'
    !
    call cubedag_toc_datasetup(mtoc,optx,error)
    if (error)  return
    !
    call toc_main(rname,mtoc,optx%n,keywords,tocname,olun,cubedag_toc_format,error)
    if (error)  return
    !
    call cubedag_toc_datafree(error)
    if (error)  return
  end subroutine cubedag_list_toc
  !
  subroutine cubedag_toc_datasetup(toc,idx,error)
    use toc_types
    !---------------------------------------------------------------------
    ! support routine for command
    !   LIST /TOC
    ! Associate the TOC data pointers to the index whose TOC is desired
    !---------------------------------------------------------------------
    type(toc_t),          intent(inout)      :: toc
    type(cubedag_link_t), intent(in), target :: idx  ! The idx whose TOC is desired
    logical,              intent(inout)      :: error
    ! Local
    character(len=*), parameter :: rname='TOC>DATASETUP'
    integer(kind=4) :: ier
    integer(kind=entr_k) :: ient
    class(cubedag_node_object_t), pointer :: obj
    !
    ! Local copy because these elements are not contiguous in memory
    allocate(toc_origin(idx%n),stat=ier)
    if (failed_allocate(rname,'toc_origin',ier,error)) return
    allocate(toc_family(idx%n),stat=ier)
    if (failed_allocate(rname,'toc_family',ier,error)) return
    allocate(toc_source(idx%n),stat=ier)
    if (failed_allocate(rname,'toc_source',ier,error)) return
    allocate(toc_line(idx%n),stat=ier)
    if (failed_allocate(rname,'toc_line',ier,error)) return
    allocate(toc_flag(idx%n),stat=ier)
    if (failed_allocate(rname,'toc_flag',ier,error)) return
    allocate(toc_obs(idx%n),stat=ier)
    if (failed_allocate(rname,'toc_obs',ier,error)) return
    do ient=1,idx%n
      obj => cubedag_node_ptr(idx%list(ient)%p,error)
      if (error)  return
      toc_origin(ient) = obj%node%origin
      toc_family(ient) = obj%node%family
      toc_source(ient) = obj%node%head%spatial_source
      toc_line(ient)   = obj%node%head%spectral_line
      call obj%node%flag%repr(strflag=toc_flag(ient),error=error)
      if (error)  return
      if (obj%node%head%obs%ntel.ge.1) then
        toc_obs(ient)  = obj%node%head%obs%tel(1)%name ! ZZZ Only one...
      else
        toc_obs(ient)  = strg_unk
      endif
    enddo
    !
    toc%keys(1)%ptr%c12%data1  => toc_source
    toc%keys(2)%ptr%c12%data1  => toc_line
    toc%keys(3)%ptr%c12%data1  => toc_obs
    toc%keys(4)%ptr%i4%data1   => toc_origin
    toc%keys(5)%ptr%c128%data1 => toc_family
    toc%keys(6)%ptr%c128%data1 => toc_flag
  end subroutine cubedag_toc_datasetup
  !
  subroutine cubedag_toc_datafree(error)
    !---------------------------------------------------------------------
    ! Support routine for command MLIST /TOC
    ! Clean the global variable holding the TOC
    !---------------------------------------------------------------------
    logical, intent(inout) :: error  !
    !
    if (allocated(toc_origin))  deallocate(toc_origin)
    if (allocated(toc_family))  deallocate(toc_family)
    if (allocated(toc_source))  deallocate(toc_source)
    if (allocated(toc_line))    deallocate(toc_line)
    if (allocated(toc_flag))    deallocate(toc_flag)
    if (allocated(toc_obs))     deallocate(toc_obs)
  end subroutine cubedag_toc_datafree
  !
  subroutine cubedag_toc_format(key,ival,output)
    !---------------------------------------------------------------------
    ! support routine for command
    !   LIST /TOC
    ! Custom display routine (because there are custom types)
    !---------------------------------------------------------------------
    type(toc_descriptor_t), intent(in)  :: key     !
    integer(kind=entr_k),   intent(in)  :: ival    !
    character(len=*),       intent(out) :: output  !
    !
    select case(key%ftype)
    case(toc_ftype_c12_1d) ! string*12
      output = key%ptr%c12%data1(ival)
    case(toc_ftype_c128_1d) ! string*128
      output = key%ptr%c128%data1(ival)
    case(toc_ftype_i4_1d)  ! integer*4
      if (key%ptype.eq.cubedag_ptype_origin) then
        output = dag_origin_names(key%ptr%i4%data1(ival))
      else
        write(output,'(i12)') key%ptr%i4%data1(ival)
      endif
    case default
      output = '???'
    end select
  end subroutine cubedag_toc_format
end module cubedag_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_real_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_real_comm_t
  private
  !
  type value_real_comm_t
     type(standard_arg_t) :: value
     real(kind=real_k)    :: default
   contains
     procedure, public :: register => cubesyntax_value_real_comm_register
  end type value_real_comm_t
  !
contains
  !
  subroutine cubesyntax_value_real_comm_register(comm,name,default,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_real_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: name
    real(kind=real_k),        intent(in)    :: default
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VALUE>REAL>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    call comm%value%register(&
         'VALUE',&
         trim(name)//' value',&
         'Default to ???',&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubesyntax_value_real_comm_register
end module cubesyntax_value_real_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_dble_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_dble_comm_t
  private
  !
  type value_dble_comm_t
     type(standard_arg_t) :: value
     real(kind=dble_k)    :: default
   contains
     procedure, public :: register => cubesyntax_value_dble_comm_register
  end type value_dble_comm_t
  !
contains
  !
  subroutine cubesyntax_value_dble_comm_register(comm,name,default,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_dble_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: name
    real(kind=dble_k),        intent(in)    :: default
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VALUE>DBLE>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    call comm%value%register(&
         'VALUE',&
         trim(name)//' value',&
         'Default to ???',&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubesyntax_value_dble_comm_register
end module cubesyntax_value_dble_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_strg_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_strg_comm_t
  private
  !
  type value_strg_comm_t
     type(standard_arg_t)  :: value
     character(len=argu_l) :: default
   contains
     procedure, public :: register => cubesyntax_value_strg_comm_register
  end type value_strg_comm_t
  !
contains
  !
  subroutine cubesyntax_value_strg_comm_register(comm,name,default,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_strg_comm_t), intent(inout) :: comm
    character(len=*),         intent(in)    :: name
    character(len=*),         intent(in)    :: default
    logical,                  intent(inout) :: error
    !
    character(len=*), parameter :: rname='VALUE>STRG>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    call comm%value%register(&
         'VALUE',&
         trim(name)//' value',&
         'Default to '//trim(default),&
         code_arg_mandatory,&
         error)
    if (error) return
  end subroutine cubesyntax_value_strg_comm_register
end module cubesyntax_value_strg_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_value_keywordlist_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_messaging
  !
  public :: value_keywordlist_comm_t
  private
  !
  type value_keywordlist_comm_t
     type(keywordlist_comm_t), pointer :: value
     character(len=argu_l)             :: default
   contains
     procedure, public :: register => cubesyntax_value_keywordlist_comm_register
  end type value_keywordlist_comm_t
  !
contains
  !
  subroutine cubesyntax_value_keywordlist_comm_register(comm,name,default, &
    list,flexibl,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(value_keywordlist_comm_t), intent(inout) :: comm
    character(len=*),                intent(in)    :: name
    character(len=*),                intent(in)    :: default
    character(len=*),                intent(in)    :: list(:)
    logical,                         intent(in)    :: flexibl
    logical,                         intent(inout) :: error
    !
    type(keywordlist_comm_t) :: tool  ! Registering tool
    character(len=*), parameter :: rname='VALUE>KEYWORDLIST>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    comm%default = default
    call tool%register(&
         'KEYWORD',&
         trim(name)//' value',&
         'Default to '//trim(default),&
         code_arg_mandatory,&
         list,&
         flexibl,&
         comm%value,&  ! Pointer to the registered keywordlist_comm_t
         error)
    if (error) return
  end subroutine cubesyntax_value_keywordlist_comm_register
end module cubesyntax_value_keywordlist_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_get
  use cubetools_parameters
  use cubetools_structure
  use cubetools_userspace
  use cube_types
  use cubeedit_messaging
  use cubeedit_getdata
  use cubeedit_getheader
  !
  public :: get
  private
  !
  type :: get_comm_t
     type(option_t), pointer :: comm
     type(userspace_opt_t)   :: into
     type(getdata_comm_t)    :: data
     type(getheader_comm_t)  :: head
   contains
     procedure, public  :: register => cubeedit_get_register
     procedure, private :: parse    => cubeedit_get_parse
     procedure, private :: main     => cubeedit_get_main 
  end type get_comm_t
  type(get_comm_t) :: get
  !
  type :: get_user_t
     character(len=varn_l)  :: edid 
     type(userspace_user_t) :: userspace
     type(getdata_user_t)   :: data
     type(getheader_user_t) :: head
  end type get_user_t
  !
  character(len=*), parameter :: defname = 'EDITGET'
  !
contains
  !
  subroutine cubeedit_get_command(line,error)
    use cubeedit_cube_buffer
    !-------------------------------------------------------------------
    ! Support routine for command GET
    ! -------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(get_user_t) :: user
    character(len=*), parameter :: rname='GET>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call get%parse(line,user,error)
    if (error) return
    call get%main(user,error)
    if (error) return
  end subroutine cubeedit_get_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_get_register(get,error)
    !-------------------------------------------------------------------
    ! Register GO\GET command and its options
    !-------------------------------------------------------------------
    class(get_comm_t), intent(inout) :: get
    logical,           intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    logical, parameter :: iterator = .true.
    character(len=*), parameter :: comm_abstract = &
         'Get data or header information from a cube in editing mode'
    character(len=*), parameter :: comm_help = &
         'Values gotten onto variables are intended for information.&
         & To change the values in a opened cube command EDIT\PUT &
         & must be used. If option /INTO is not used the information&
         & gotten will be stored in a master structure called '//defname
    character(len=*), parameter :: rname='GET>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'GET','[newid]',&
         comm_abstract,&
         comm_help,&
         cubeedit_get_command,&
         get%comm,error)
    if (error) return
    call stdarg%register(&
         'NewId', &
         'Editing Identifier', &
         strg_id,&
         code_arg_optional, error)
    if (error) return
    !
    call get%into%register(error)
    if (error) return
    !
    call get%head%register(defname,get%into,error)
    if (error) return
    !
    call get%data%register(get%into,access_is_fixed,iterator,error)
    if (error) return
    !
  end subroutine cubeedit_get_register
  !
  subroutine cubeedit_get_parse(get,line,user,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(get_comm_t), intent(in)    :: get
    character(len=*),  intent(in)    :: line
    type(get_user_t),  intent(out)   :: user
    logical,           intent(inout) :: error
    !
    character(len=*), parameter :: rname='GET>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call get%into%parse(line,user%userspace,error)
    if (error) return
    user%edid = strg_star
    call cubetools_getarg(line,get%comm,1,user%edid,.not.mandatory,error)
    if (error) return
    !
    call get%head%parse(line,user%userspace,user%head,error)
    if (error) return
    call get%data%parse(line,user%userspace,user%data,error)
    if (error) return
  end subroutine cubeedit_get_parse
  !
  subroutine cubeedit_get_main(get,user,error)
    use cubeedit_cube_buffer
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(get_comm_t), intent(in)    :: get
    type(get_user_t),  intent(in)    :: user
    logical,           intent(inout) :: error
    !
    type(cube_t), pointer :: cube
    integer(kind=entr_k) :: ie
    character(len=*), parameter :: rname='GET>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (.not.user%head%do .and. .not.user%data%do) then
       call get%head%list(error)
       if (error) return
       call get%data%list(error)
       if (error) return
       return
    endif
    !
    call cubeedit_bufferlist_get_cube_pointer(user%edid,cube,error)
    if (error) return   
    if (user%head%do) then
       call get%head%get(user%head,cube,defname,user%data%do,error)
       if (error) return
    endif
    if (user%data%do) then
       call cubeedit_bufferlist_get_cube_entry(user%edid,ie,error)
       if (error) return   
       call get%data%get(user%data,cube,defname,user%head%do,ie,error)
       if (error) return
       call cubeedit_bufferlist_set_cube_entry(user%edid,ie,error)
       if (error) return   
    endif
  end subroutine cubeedit_get_main
  !
end module cubeedit_get
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeedit_split
  use cubetools_parameters
  use cube_types
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubeedit_messaging
  !
  public :: split
  private
  !
  integer(kind=chan_k), parameter :: one = 1
  !
  type :: split_comm_t
     type(option_t),     pointer :: comm
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube  ! Same for all
   contains
     procedure, public  :: register => cubeedit_split_register
     procedure, private :: parse    => cubeedit_split_parse
     procedure, private :: main     => cubeedit_split_main
  end type split_comm_t
  type(split_comm_t) :: split
  !
  type split_user_t
     type(cubeid_user_t)  :: cubeids
   contains
     procedure, private :: toprog => cubeedit_split_user_toprog
  end type split_user_t
  !
  type cube_p_t
     type(cube_t), pointer :: p
  end type cube_p_t
  type split_prog_t
     type(cube_t),   pointer     :: incube     ! Input cube
     type(cube_p_t), allocatable :: oucube(:)  ! Output cubes
     integer(kind=chan_k)        :: nc
   contains
     procedure, private :: header => cubeedit_split_prog_header
     procedure, private :: data   => cubeedit_split_prog_data
     procedure, private :: loop   => cubeedit_split_prog_loop
     procedure, private :: act    => cubeedit_split_prog_act
  end type split_prog_t
  !
contains
  !
  subroutine cubeedit_split_command(line,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(split_user_t) :: user
    character(len=*), parameter :: rname='SPLIT>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    call split%parse(line,user,error)
    if (error) return
    call split%main(user,error)
    if (error) return
  end subroutine cubeedit_split_command
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeedit_split_register(split,error)
    use cubedag_allflags
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_comm_t), intent(inout) :: split
    logical,             intent(inout) :: error
    !
    type(cubeid_arg_t) :: cubearg
    type(cube_prod_t) :: oucube
    !
    character(len=*), parameter :: comm_abstract = &
         'Split a cube into individual images'
    character(len=*), parameter :: comm_help = &
         'Split a cube in its frequency-velocity axis into individual&
         & images.'//strg_cr//strg_cr//&
         'WARNING: This command is a work around for complicated&
         & cases when complex set of images cannot be easily used&
         & in CUBE'
    character(len=*), parameter :: rname='SPLIT>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'SPLIT','[cube]',&
         comm_abstract,&
         comm_help,&
         cubeedit_split_command,&
         split%comm,error)
    if (error) return
    call cubearg%register( &
         'CUBE', &
         'Signal cube',  &
         strg_id,&
         code_arg_optional,  &
         [flag_cube], &
         code_read, &
         code_access_imaset, &
         split%incube, &
         error)
    if (error) return
    !
    ! Product (register only one)
    call oucube%register(&
         'IMAGE',&
         'The extracted images (as many as needed)',&
         strg_id,&
         [flag_image],&
         split%oucube,&
         error)
    if (error) return
  end subroutine cubeedit_split_register
  !
  subroutine cubeedit_split_parse(split,line,user,error)
    !-------------------------------------------------------------------
    ! SPLIT cubname
    ! /RANGE vfirst vlast
    ! /FREQUENCY newname newrestfreq [unit]
    ! /CENTER xcen ycen ! can be relative[arcsec] or absolute[RA,DEC or LII,BII]
    ! /SIZE sx [sy]
    !-------------------------------------------------------------------
    class(split_comm_t), intent(in)    :: split
    character(len=*),      intent(in)    :: line
    type(split_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPLIT>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,split%comm,user%cubeids,error)
    if (error) return
  end subroutine cubeedit_split_parse
  !
  subroutine cubeedit_split_main(split,user,error)
    use cubeadm_timing
    use cubeadm_get
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_comm_t), intent(in)    :: split
    type(split_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    type(split_prog_t) :: prog
    character(len=*), parameter :: rname='SPLIT>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call user%toprog(prog,error)
    if (error) return
    call prog%header(split,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubeedit_split_main
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeedit_split_user_toprog(user,prog,error)
    use cubetools_header_methods
    use cubeadm_get
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_user_t), intent(in)    :: user
    type(split_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPLIT>USER>TOPROG'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(split%incube,user%cubeids,  &
         prog%incube,error)
    if (error) return
    !
    call cubetools_header_get_nchan(prog%incube%head,prog%nc,error)
    if (error) return
    !
  end subroutine cubeedit_split_user_toprog
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeedit_split_prog_header(prog,comm,error)
    use gkernel_interfaces
    use cubetools_header_methods
    use cubeadm_clone
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_prog_t), intent(inout) :: prog
    type(split_comm_t),  intent(in)    :: comm
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ier
    integer(kind=chan_k) :: ic
    character(len=*), parameter :: rname='SPLIT>PROG>HEADER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    allocate(prog%oucube(prog%nc),stat=ier)
    if (failed_allocate(rname,'cube array',ier,error)) return
    do ic=1, prog%nc
       call cubeadm_clone_header(comm%oucube,prog%incube,prog%oucube(ic)%p,error)
       if (error) return
       call cubetools_header_put_nchan(one,prog%oucube(ic)%p%head,error)
       if (error) return
    enddo
  end subroutine cubeedit_split_prog_header
  !
  subroutine cubeedit_split_prog_data(prog,error)
    use cubeadm_opened
    use cubetools_header_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='SPLIT>PROG>DATA'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) then
          call prog%loop(iter,error)
       endif
       !$OMP END TASK
    enddo ! ie
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubeedit_split_prog_data
  !
  subroutine cubeedit_split_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_prog_t),      intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: image
    character(len=*), parameter :: rname='SPLIT>PROG>LOOP'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call image%associate('image',prog%incube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,image,error)
      if (error) return
    enddo ! ie
  end subroutine cubeedit_split_prog_loop
  !
  subroutine cubeedit_split_prog_act(prog,ie,image,error)
    use cubetools_nan
    use cubeadm_taskloop
    use cubeadm_image_types
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(split_prog_t),   intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t),         intent(inout) :: image
    logical,               intent(inout) :: error
    !
    integer(kind=entr_k), parameter :: one=1
    character(len=*), parameter :: rname='SPLIT>PROG>ACT'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    ! Get the ie-th image
    call image%get(ie,error)
    if (error) return
    ! Put it as first image in the ie-th cube
    call image%put_in(prog%oucube(ie)%p,one,error)
    if (error) return
  end subroutine cubeedit_split_prog_act
end module cubeedit_split
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gtemplate_dummy(line,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! Support routine for command DUMMY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Global
  integer, external :: sic_narg
  ! Local
  character(len=*), parameter :: rname='DUMMY'
  character(len=message_length) :: mess
  !
  call gtemplate_message(seve%i,rname,'Entering DUMMY command')
  !
  write(mess,'(I2,A)') sic_narg(0),' argument(s) passed to command'
  call gtemplate_message(seve%i,rname,mess)
  !
end subroutine gtemplate_dummy

module catalog_data
  use gkernel_types
  integer, save :: mmol=-1
  integer, save :: nmol, nsel
  real(8), allocatable :: molfreq(:)
  real(8), allocatable :: selfreq(:)
  integer, allocatable :: ip(:)
  character(len=32), allocatable :: mollong(:)
  character(len=32), allocatable :: molplot(:)
  character(len=16), allocatable :: molshort(:)
  character(len=32), allocatable :: sellong(:)
  character(len=32), allocatable :: selplot(:)
  character(len=16), allocatable :: selshort(:)
  character(len=filename_length) :: mofile
  logical, save :: isastro
  real, save :: eup_max=300
  integer, save :: nlinedb
end module catalog_data
!
subroutine catalog_init(imol,error)
  use gkernel_interfaces
  use catalog_data
  !
  integer, intent(inout) :: imol
  logical, intent(out) :: error
  !
  ! Print *,'MMOL ',imol    ! GCC 10 optimizer bug: it prints 0 if imol == -1 ...
  error = .false.
  if (imol.eq.-1) then  
    call sic_def_real('LINEDB%ENERGY',eup_max,0,0,.false.,error)
    if (error) return
    call sic_def_logi('LINEDB%ASTRO',isastro,.true.,error)
    if (error) return
    imol = 0
  endif
  !
  ! Delete ASTRO catalog if any
  call sic_delvariable('CATALOG',.false.,error)
end subroutine catalog_init
! 
subroutine catalog_comm(line,quiet,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, catalog_readastro
  use catalog_data
  !---------------------------------------------------------------------
  ! @ private
  ! IMAGER
  !
  !   List or define Spectral Line Data Base(s)
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(out) :: quiet
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='CATALOG'
  character(len=1), parameter :: question_mark='?'
  !
  character(len=filename_length) :: line_comm = ' '
  character(len=filename_length) :: chain, file
  real(8) :: r
  logical :: found
  character*16 :: check
  integer :: lt,i,j,narg,nc, iform
  integer(kind=index_length) :: dim(4)
  ! This duplicates the list in LINEDB Python code, but
  ! is unavoidable to check proper Data Base existence
  integer, parameter :: monline=4
  character*12 :: onlines(monline)
  data onlines /'voparis', 'cdms', 'jpl', 'splatalogue'/ !! cam-vamdc, cdms-vamdc
  !
  call catalog_init(mmol, error)
  nmol = 0
  error = .false.
  quiet = .true.
  !
  ! Normal code
  narg = sic_narg(0)
  chain = ' '
  call sic_ch(line,0,1,chain,nc,.false.,error)
  if (chain(1:1).eq.question_mark) then
    if (narg.gt.1) then
      call sic_ch(line,0,2,file,nc,.false.,error)
      call exec_program('@ catalog ? '//file)
    else
      call exec_program('@ catalog ? ')
    endif
    return
  endif
  !
  call sic_delvariable('LINES',.false.,error)
  error = .false.
  call sic_delvariable('LINEDB%DBIN',.false.,error)
  error = .false.
  nlinedb = 0
  !
  ! Note the LowerCase for the "in" argument
  line_comm = "LINEDB\USE in "
  lt = 15
  !
  do i=1,narg
    call sic_ch(line,0,i,chain,nc,.false.,error)
    !
    check = chain
    call sic_lower(check)
    found = .false.
    do j=1,monline
      if (check.eq.onlines(j)) then
        found = .true.
        exit
      endif
    enddo
    !
    if (found) then
      line_comm(lt:) = check
      lt = lt+len_trim(check)+2
    else
      ! If it is not one of the on-line databases, it can be a local
      ! file. Locate it
      found = sic_findfile(chain,file,' ','.linedb')
      !
      if (found) then
        !
        ! Verify if it can be an Astro catalog
        open(unit=1,file=file,status='OLD')               
        read(1,'(A)') check
        !
        if (check(1:7).eq.'SQLite ') then
          isastro = .false.
          iform = 1
        elseif (check(1:1).eq.'!') then
          isastro = .true.
          iform = 2
        else
          chain = 'partfunc.cat'
          inquire(file='parfunc.cat',exist=isastro)
          if (.not.isastro) inquire(file='partfunc.json',exist=isastro)
          if (isastro) then
            ! There is a partfunc file, so it could be Gildas JPL file format
            ! Gildas JPL file start by a Tag identifier followed by molecule NAME
            rewind(1)
            read(1,*) r
            if (nint(r).eq.r) then
              isastro = .false. ! Tag must be an integer
              iform = -1
            else
              ! Astro files would have frequencies in GHz instead, never integers,
              ! so they remain our best guess here...
              iform = 0
            endif
          else
            ! JPL data files format require "partfunc" file, so cannot be JPL
            isastro = .true.
            iform = 0
          endif
        endif
        close(unit=1)
        !
        if (isastro) then
          if (narg.eq.1) then
            call message_colour(-1)
            ! Read the ASTRO catalog
            call catalog_readastro (file,error)
            if (error) then
              call map_message(seve%e,rname,'File '//trim(file)//' is not a Line catalog',1)              
              return
            endif
            if (iform.ne.0) call map_message(seve%w,rname,   &
              & 'Astro catalog should start with a comment line (! sometext...)',1)
            call map_message(seve%i,rname,'File '//trim(file)//' is an Astro catalog',3)
            mofile = file
            dim(1) = 1
            call sic_def_charn('LINEDB%DBIN',mofile,1,1,.true.,error)
            isastro = .true.
            if (sic_varexist("all%catalog")) then
              line_comm = "LET all%catalog 'linedb%dbin'"
              call exec_command(line_comm,error)
            endif
            nlinedb = narg
            return
          else
            call map_message(seve%e,rname,'Astro catalogs are exclusive of any other',1)
            error = .true.
            return
          endif
        else if (iform.eq.1) then
          call map_message(seve%i,rname,'File '//trim(file)//' is a DBMS catalog')              
        else 
          call map_message(seve%w,rname,'File '//trim(file)//' may be a JPL data file',3)                      
        endif
        !
        chain  = '"'//trim(file)//'"'   ! Python "LINEDB\USE" does not parse anything else
        line_comm(lt:) = chain
        lt = lt+len_trim(chain)+2
      else
        call map_message(seve%w,rname,'No such line catalog '//trim(chain),3)
      endif
    endif
  enddo
  nlinedb = narg
  !
  ! Execute the "LINEDB\USE in" command if needed
  if (lt.gt.15) then
    call exec_command(line_comm,error)
    isastro = .false.
    quiet = .false.
    if (error) return
    !
    line_comm = "LET all%catalog 'linedb%dbin'"
  else
    line_comm = 'LET all%catalog "( none defined )"'
    call map_message(seve%w,rname,'No line catalog',3)
  endif
  ! Reset the all%catalog if needed
  if (sic_varexist("all%catalog")) call exec_command(line_comm,error)
  !
end subroutine catalog_comm    
!
subroutine catalog_find(line,error)
  use gildas_def
  use gkernel_interfaces
  use catalog_data
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command 
  !     FIND Fmin Fmax [/SPECIES Name]
  ! Returns in the LINES% structure the frequencies and names of lines
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line        ! Command line
  logical, intent(inout) :: error
  !
  character(len=128) :: cfmin, cfmax  ! Frequency ranges, formatted
  integer :: ni, nm
  character(len=512) :: line_comm
  real(8) :: fmin,fmax
  integer :: k, i
  integer(kind=index_length) :: dim(4)
  !
  integer, parameter :: o_species=1
  integer :: i_spec, l
  character(len=32) :: c_spec
  character(len=8) :: c_enrg
  !
  call sic_delvariable('LINES',.false.,error)
  error = .false.
  if (nlinedb.eq.0) then
    call map_message(seve%w,'FIND','No line catalog(s)',3)
    return
  endif
  !
  i_spec = sic_narg(o_species)
  if (i_spec.eq.1) then
    call sic_ch(line,1,o_species,c_spec,l,.true.,error)
    if (error) return
  endif
  !
  if (nmol.eq.0) then
    ! LINEDB version
    !
    call sic_ch(line,0,1,cfmin,ni,.true.,error)
    if (error) return
    call sic_ch(line,0,2,cfmax,nm,.true.,error)
    if (error) return
    !
    write(c_enrg,'(f6.0)') eup_max
    if (i_spec.eq.1) then
      line_comm = "LINEDB\SELECT /FREQ "//cfmin(1:ni)//' '//cfmax(1:nm)// &
      & " /ENERGY "//c_enrg//" /SORT aij /SPECIES "//'"'//trim(c_spec)//'"'
    else
      line_comm = "LINEDB\SELECT /FREQ "//cfmin(1:ni)//' '//cfmax(1:nm)// &
        & " /ENERGY "//c_enrg//" /SORT aij"
    endif
    !!Print *,trim(line_comm)
    call exec_program(line_comm)
    call exec_program('@ catalog_lines')
  else
    !
    ! ASTRO version - Catalog frequencies are in GHz
    call sic_r8(line,0,1,fmin,.true.,error)
    if (error) return
    call sic_r8(line,0,2,fmax,.true.,error)
    if (error) return
    fmin = fmin*1d-3
    fmax = fmax*1d-3
    !
    ! LINES%N will contain the number of lines
    k = 0
    do i=1,nmol
      if (molfreq(i).ge.fmin .and. molfreq(i).le.fmax) then
        k = k+1
        ip(k) = i
      endif
    enddo
    nsel = k
    l = 0
    do k=1,nsel
      i = ip(k)
      if (i_spec.eq.1) then
        if (molshort(i).ne.c_spec) cycle 
      endif
      l=l+1
      selfreq(l) = molfreq(i)*1d3
      sellong(l) = mollong(i)
      selplot(l) = molplot(i)
      selshort(l) = molshort(i)
    enddo
    nsel = l
    !
    call sic_defstructure('LINES',.true.,error)
    if (nsel.ne.0) then
      dim(1) = nsel
      call sic_def_dble('LINES%FREQUENCY',selfreq,1,dim,.true.,error)
      call sic_def_charn('LINES%LINES',sellong,1,dim,.true.,error)
      call sic_def_charn('LINES%PLOT',selplot,1,dim,.true.,error)
      call sic_def_charn('LINES%SPECIES',selshort,1,dim,.true.,error)
      nsel = -nsel
    endif
    call sic_def_inte('LINES%N',nsel,0,0,.true.,error)
  endif 
end subroutine catalog_find
!
subroutine catalog_readastro (molfile,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  use catalog_data
  !---------------------------------------------------------------------
  ! @ private
  !    IMAGER
  !  Read an Astro catalog
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: molfile        ! Catalog name
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CATALOG'
  character(len=256) :: chain
  character(len=32) :: aname,bname,aline
  real(kind=8) :: afreq
  integer(kind=4) :: i,k,lun,nv,ier,lt,ls
  integer(kind=4) :: icsv, iend, step
  logical :: skip, worry
  character(len=16) :: varname
  !
  error = .false.
  !
  varname = 'CATALOG'
  !
  ! Open file
  nmol = 0
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call map_message(seve%e,rname,'Cannot allocate LUN')
    error = .true.
    return
  endif
  open(unit=lun,file=molfile(1:len_trim(molfile)), status='OLD',iostat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot open file: '//trim(molfile))
    call sic_frelun(lun)
    error = .true.
    return
  endif
  !
  ! Read file - Two pass to properly dimension the Number of molecules
  !
  ! Verify if strictly ASTRO conformant or not...
  read(lun,'(A)') aname
  worry = (aname(1:1).ne.'!') 
  if (worry) worry = (index(aname,';').eq.0)
  rewind(lun)
  !
  nmol = 0
  do step = 1,2
    do 
      read(lun,'(A)',iostat=ier) chain
      if (ier.lt.0) exit
      !
      if (ier.ne.0 .or. lenc(chain).eq.0) cycle
      ! Comment line
      if (chain(1:1).eq.'!') cycle
      !
      icsv = index(chain,';')
      if (icsv.gt.1) then
        ! Comma separated value
        read(chain(1:icsv-1),*,iostat=ier) afreq
        if (ier.ne.0) cycle
        aname = chain(icsv+1:)
        iend = index(aname,';')
        aline = aname(iend+1:)
        aname(iend:) = ' '
        iend = index(aline,';')
        if (iend.ne.0) aline(iend:) = ' '
      else if (icsv.eq.1) then
        ! CSV comment line
        cycle
      else
        ! Historical ASTRO format
        ! Note that since Fortran-90, quotes are no longer required to delimit strings 
        ! in List-Directed format. They are only required when spaces should be in the
        ! strings.
        read(chain,*,iostat=ier) afreq, aname, aline
        if (ier.ne.0) then
          aline = ' '
          read(chain,*,iostat=ier) afreq, aname
          if (ier.ne.0) cycle
        endif
        ! If not strictly conformant, ignore values that are integers, as
        ! the likelihood to have spectral line EXACTLY a number of GHz is tiny...
        if (worry) then
          if (nint(afreq).eq.afreq) cycle
        endif
        if (len_trim(aname).ne.0) then
          bname = aname
          iend = 0
        else
          aname = bname ! Inherit last molecule name if not specified
          iend = 1
        endif 
      endif
      nmol = nmol + 1
      ! First step: just count
      if (step.eq.1) cycle
      !
      ! Second Step: fill array
      molfreq(nmol) = afreq
      !
      lt = len_trim(aname)
      ls = index(aname(1:lt),' ')
      if (ls.ne.0) then
        aline = aname(ls+1:lt)//aline
        lt = ls
      else
        lt = lt+1
      endif
      molplot(nmol) = aname(1:lt)//aline
      !
      k = 0
      skip = .false.
      do i=1,lt
        if (skip) then
          if (aname(i:i).ne."\") skip = .false.
        else
          if (aname(i:i).eq."\") then
            skip = .true.
          else
            k = k+1
            aname(k:k) = aname(i:i)
          endif
        endif
      enddo
      molshort(nmol) = aname(1:k)
      mollong(nmol) = aname(1:k)//aline
      if (nmol.ge.mmol) exit
    enddo
    !
    if (step.eq.1) then
      if (nmol.gt.mmol) then
        write(chain,'(A,I0,A)') 'Allocating space for ',nmol,' spectral lines'
        call map_message(seve%i,rname,chain)
        if (mmol.ne.0) deallocate(molfreq,selfreq,mollong,molplot,molshort,sellong,selplot,selshort,ip)
        mmol = nmol
        allocate(molfreq(mmol),selfreq(mmol),mollong(mmol),molplot(mmol),molshort(mmol), &
        & sellong(mmol),selplot(mmol),selshort(mmol),ip(mmol))
      endif  
      rewind(lun)
      nmol = 0
    endif
  enddo
  !
  close(unit=lun)
  call sic_frelun(lun)
  !
  if (nmol.eq.0) then
    error = .true.
    return
  endif
  !
  ! Create the SIC substructure 
  !
  call sic_defstructure(varname,.true.,error)
  if (error) return
  nv = len_trim(varname)
  call sic_def_inte(varname(1:nv)//'%N',nmol,0,0,.true.,error)
  call sic_def_dble(varname(1:nv)//'%FREQ',molfreq,1,nmol,.true.,error)
  call sic_def_charn(varname(1:nv)//'%NAME',mollong,1,nmol,.true.,error)
  call sic_def_charn(varname(1:nv)//'%SHORT',molshort,1,nmol,.true.,error)
  call sic_def_charn(varname(1:nv)//'%PLOT',molplot,1,nmol,.true.,error)
  if (error) return
  !
end subroutine catalog_readastro

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage MAPPING messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module map_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: map_message_id = gpack_global_id  ! Default value for startup message
  !
end module map_message_private
!
subroutine map_message_set_id(id)
  use map_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  map_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',map_message_id
  call gmessage_write(map_message_id,seve%d,'map_message_set_id',mess)
  !
end subroutine map_message_set_id
!
subroutine map_message(mkind,procname,message,colour)
  use gbl_ansicodes
  use gkernel_interfaces
  use map_message_private
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER
  !   Messaging facility for the current library. Calls the low-level
  !   (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  integer, intent(in), optional :: colour   ! Colour of message 
  !
  if (present(colour)) then
    call message_colour(colour)
    call gmessage_write(map_message_id,mkind,procname,message)
    write(*,'(A)',advance='NO') c_clear
  else
    call gmessage_write(map_message_id,mkind,procname,message)
  endif
  !
end subroutine map_message
!
subroutine map_iostat(mkind,procname,ier)
  use gkernel_interfaces
  use map_message_private
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Output system message corresponding to IO error code IER, and
  !   using the Message facility
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message severity
  character(len=*), intent(in) :: procname  ! Calling routine name
  integer,          intent(in) :: ier       ! IO error number
  ! Local
  character(len=message_length) :: msg
  !
  if (ier.eq.0) return
  call gag_iostat(msg,ier)
  call gmessage_write(map_message_id,mkind,procname,msg)
  !
end subroutine map_iostat
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine message_colour(colour)
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Change the colour
  !---------------------------------------------------------------------
  integer, intent(in) :: colour   !
  !
  character(len=12) :: chain
  !
  select case (colour)
    case(0)
      chain = c_bold//c_black
    case(1)
      chain = c_bold//c_red
    case(2)
      chain = c_bold//c_green
    case(3)
      chain = c_bold//c_blue
    case(4)
      chain = c_bold//c_cyan 
    case(5)
      chain = c_bold//c_yellow
    case(6)
      chain = c_bold//c_magenta
    case(7)
      chain = c_bold//c_white
    case default
      chain = c_clear
  end select
  write(*,'(A)',advance='NO') trim(chain)
  !
end subroutine message_colour
!
subroutine message_attribute(cattr)
  use gbl_ansicodes
  !
  character(len=*), intent(in) :: cattr
  !
  !
  write(*,'(A)',advance='NO') c_start//cattr//c_end
end subroutine message_attribute

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_setup_types
  use cubetools_parameters
  use cubetools_datasize
  !
  ! Support for SETUP\BLANKING
  type :: cube_setup_blanking_t
    integer(kind=4) :: rmode = code_patchblank_otf  ! Read mode
  end type cube_setup_blanking_t
  !
  ! Support for SETUP\BUFFER
  type :: cube_setup_buffer_t
    integer(kind=code_k) :: input  = code_buffer_memory
    integer(kind=code_k) :: output = code_buffer_memory
    real(kind=size_k)    :: limit  =  2.0*GiB  ! [Bytes]
    real(kind=size_k)    :: block  = 512.*MiB  ! [Bytes] Default block size (disk mode)
    real(kind=size_k)    :: task   = 256.*kiB  ! [Bytes] Default task size (1 plane of 250x250 pixels)
  end type cube_setup_buffer_t
  !
  ! Support for SETUP\OUTPUT (cubes customization)
  type :: cube_setup_output_t
    logical :: extrema = .true.  ! Compute and update the extrema section
    logical :: write = .true.    ! Write the file on disk?
  end type cube_setup_output_t
  !
  ! Support for SETUP\TIMING
  type :: cube_setup_timing_t
    logical :: io = .false.       ! IO timing feedback
    logical :: command = .false.  ! Command timing feedback
  end type cube_setup_timing_t
  !
  ! Support for SETUP\INDEX
  type :: cube_setup_index_t
    integer(kind=code_k) :: default=code_index_dag
  end type cube_setup_index_t
  !
  type :: cube_setup_t
    type(cube_setup_blanking_t) :: blanking
    type(cube_setup_buffer_t)   :: buff
    type(cube_setup_index_t)    :: index
    type(cube_setup_output_t)   :: output
    type(cube_setup_timing_t)   :: timing
  end type cube_setup_t
  !
end module cubetools_setup_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_useriter_types
  use cubetools_structure
  use cubetools_messaging
  !
  public :: useriter_t
  private
  !
  integer(kind=4), parameter :: izero=1
  integer(kind=4), parameter :: ifirst=2
  integer(kind=4), parameter :: ilast=3
  integer(kind=4), parameter :: iafterlast=4
  integer(kind=4), parameter :: iprevious=5
  integer(kind=4), parameter :: icurrent=6
  integer(kind=4), parameter :: inext=7
  integer(kind=4), parameter :: nkey = inext
  !
  character(len=*), parameter :: keys(nkey) = &
       ['ZERO     ','FIRST    ','LAST     ','AFTERLAST','PREVIOUS ','CURRENT  ','NEXT     ']
  !
  type useriter_opt_t
     integer(kind=4) :: n = nkey
     type(option_t)  :: opt(1:nkey)
   contains
     procedure, public :: register => cubetools_useriter_register
     procedure, public :: parse    => cubetools_useriter_parse
  end type useriter_opt_t
  !
contains
  !
  subroutine cubetools_useriter_opt_register(iter,preabs,postabs,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(useriter_opt_t), intent(inout) :: iter
    character(len=*),      intent(in)    :: preabs
    character(len=*),      intent(in)    :: postabs
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iopt
    character(len=*), parameter :: rname='USERITER>OPT>REGISTER'
    !
    call cubetools_message(edseve%trace,rname,'Welcome')
    !
    do iopt=1,opt%n
       call cubetools_register_option(&
            keys(iopt),'',&
            preabs//trim(keys(iopt))//postabs,&
            strg_id,&
            iter%opt(iopt),&
            error)
       if (error) return
    enddo ! iopt
  end subroutine cubetools_useriter_opt_register
  !
  subroutine cubetools_useriter_opt_parse(opt,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(useriter_opt_t), intent(inout) :: opt
    logical,               intent(inout) :: error
    !
    integer(kind=4) :: iopt
    character(len=*), parameter :: rname='USERITER>OPT>PARSE'
    !
    call cubetools_message(edseve%trace,rname,'Welcome')
    !
    do iopt=1,opt%n
       call iter%opt(iopt)%present(line,user%opt(iopt)%do,error)
       if (error) return
    enddo ! iopt
  end subroutine cubetools_useriter_opt_parse
end module cubetools_useriter_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  

subroutine mx_clean (map,huv,uvdata,uvp,uvv,   &
     &    method,hdirty,hbeam,hclean,hresid,hprim,   &
     &    w_grid,w_mapu,w_mapv,p_cct, dcct, smask, slist,   &
     &    sblock, cpu0, uvmax)
  use clean_def
  use image_def
  use gbl_message
  use imager_interfaces, except_this => mx_clean
  !----------------------------------------------------------------------
  ! @ private
  ! GILDAS: CLEAN Internal routine
  ! Implementation of MX CLEAN deconvolution algorithm.
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (uvmap_par), intent(inout) :: map
  type (gildas), intent(inout) :: huv
  type (gildas), intent(inout) :: hdirty
  type (gildas), intent(inout) :: hbeam
  type (gildas), intent(inout) :: hclean
  type (gildas), intent(inout) :: hresid
  type (gildas), intent(inout) :: hprim
  real, intent(inout) :: dcct(3,hclean%gil%dim(3),*)
  logical, intent(inout) :: smask(:,:)
  integer, intent(in) :: slist(*)
  integer, intent(in) :: sblock
  real, intent(inout) :: uvdata(huv%gil%dim(1),huv%gil%dim(2))
  real, intent(in) :: uvp(*)
  real, intent(in) :: uvv(*)
  real, intent(inout) :: w_grid(*)
  real, intent(inout) :: w_mapu(*)
  real, intent(inout) :: w_mapv(*)
  real, intent(in) :: cpu0
  real, intent(inout) :: uvmax
  type (cct_par), intent(out) :: p_cct(method%m_iter)
  !
  logical :: error
  integer nx,ny,nz,nf, mc,nclean, i, nu,nv
  real fhat
  real, allocatable :: mapx(:), mapy(:)
  real, pointer :: p_resid(:,:)
  real, pointer :: p_clean(:,:)
  real, pointer :: p_beam(:,:,:)
  real, pointer :: p_prim(:,:,:)   ! Primary beam
  real, pointer :: p_atten(:,:,:) ! Mosaic weight
  type(cct_par), allocatable :: p_comp(:)      ! Clean values
  complex, allocatable :: p_work(:,:)
  real, allocatable :: p_tfbeam(:,:,:)
  integer, allocatable :: p_niter(:)
  real, allocatable :: w_fft(:)
  real, dimension(1,1,1), target ::dummy3d
  integer ier,iplane
  character(len=message_length) :: chain
  character(len=*), parameter :: rname = 'MX'
  !
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  mc = method%m_iter
  !
  ! Get some memory
  allocate (p_work(nx,ny),p_tfbeam(nx,ny,1),stat=ier)
  nclean = nx*ny
  allocate (p_comp(nclean),stat=ier)
  allocate (mapx(nx),mapy(ny),stat=ier)
  allocate (w_fft(max(nx,ny)),stat=ier)
  !
  call loadxy (method,huv,hdirty,mapx,nx,mapy,ny)
  !
  ! Prepare beam parameters
  method%ibeam = 1             ! Test
  method%iplane = 1            ! Test
  error = .false.
  call get_clean (method,hbeam,hbeam%r3d,error)
  if (error) return
  call get_beam (method,hbeam,hresid,hprim,  &
     &    p_tfbeam,p_work,w_fft,fhat,error)
  if (error) return
  !
  ! Find components in all planes...
  nz = max(hdirty%gil%dim(3),1)
  allocate (p_niter(nz),stat=ier)
  nf = max(1,hprim%gil%dim(1))
  p_beam  => hbeam%r3d(:,:,1:1)
  if (method%mosaic) then
    p_prim => hprim%r3d
    p_atten=> method%atten
  else
    p_prim => dummy3d
    p_atten=> dummy3d
  endif
  !
  ! Loop here if needed
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi  ! not %dim(2)
  do iplane = method%first, method%last
    !
    method%iplane = iplane
    call beam_plane(method,hbeam,hdirty)
    write(chain,'(A,I6,I6)') 'Image & Beam planes ',   &
        &      method%iplane,method%ibeam
    !omp!$ chain = trim(chain)//cthread
    call map_message(seve%d,rname,chain)
    !
    method%iplane = iplane
    p_resid => hresid%r3d(:,:,iplane)
    p_clean => hclean%r3d(:,:,iplane)
    p_beam  => hbeam%r3d(:,:,method%ibeam:method%ibeam)
    !
    call get_clean (method, hbeam, p_beam, error)
    !
    call mx_major_cycle90 (map,uvdata,   &
     &      nu,nv,uvp,uvv,   &
     &      method,hdirty,   &
     &      p_clean,p_beam,p_resid,   &
     &      nx,ny,1,         &
     &      p_comp,nclean,   &
     &      p_cct, p_niter(iplane),   &
     &      slist, method%nlist,   &
     &      nf, p_prim, p_atten,   &
     &      w_grid, w_mapu, w_mapv, mapx, mapy,   &
     &      p_tfbeam, cpu0, uvmax)
    !
    ! Add clean components to clean map
    write(chain,1001) 'Restoring plane ',iplane
    call map_message(seve%d,rname,chain)
    ! Could be replaced by CLEAN_MAKE90... to be checked...
    if (p_niter(iplane).ne.0) then
      !! Print *,'adding residual '
      call clean_make90(method,hclean,p_clean,p_cct)
      p_clean = p_clean+p_resid
    else
      p_clean = p_resid
    endif
!
    do i=1,method%n_iter
       dcct(1,iplane,i) = (dble(p_cct(i)%ix) -   &
         &          hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
         &          hclean%gil%convert(2,1)
       dcct(2,iplane,i) = (dble(p_cct(i)%iy) -   &
         &          hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
         &          hclean%gil%convert(2,2)
       dcct(3,iplane,i) = p_cct(i)%value
    enddo
  enddo
  !
  ! Clean-up
  if (allocated(p_work)) deallocate(p_work)
  if (allocated(p_tfbeam)) deallocate(p_tfbeam)
  if (allocated(p_comp)) deallocate(p_comp)
  if (allocated(mapx)) deallocate(mapx)
  if (allocated(mapy)) deallocate(mapy)
  if (allocated(w_fft)) deallocate(w_fft)
  if (allocated(p_niter)) deallocate(p_niter)
  return
  !
  1001  format(a,i5,i5)
end subroutine mx_clean
!
subroutine loadxy (method,huv,head,mapx,nx,mapy,ny)
  use clean_def
  use image_def
  !--------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Load x,y coordinates
  !--------------------------------------------------
  type (clean_par), intent(in) :: method
  type (gildas), intent(in) :: huv,head
  integer, intent(in) :: nx
  integer, intent(in) :: ny
  real, intent(out) :: mapx(nx)
  real, intent(out) :: mapy(ny)
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  integer i
  real pidsur                  ! 2*pi*D/Lambda
  real(8) :: freq
  !
  freq = huv%gil%convert(2,1)+huv%gil%fres*   &
     &    ((method%first+method%last)*0.5-huv%gil%convert(1,1))
  pidsur = f_to_k * freq
  !
  do i=1,nx
    mapx(i) = pidsur*((i-head%gil%convert(1,1))*head%gil%convert(3,1)   &
     &      +head%gil%convert(2,1))
  enddo
  do i=1,ny
    mapy(i) = pidsur*((i-head%gil%convert(1,2))*head%gil%convert(3,2)   &
     &      +head%gil%convert(2,2))
  enddo
end subroutine loadxy

!
! Definitions used by UV_INVERT / UV_MAP
!
module uvmap_def
  type par_uvmap
     real taper(4)    ! UV taper
     character(len=4) mode  ! Weighting mode
     real field(2)     ! Field of view
     integer size(2)   ! Image size
     real xycell(2)    ! Image cell
     real uniform(2)   ! Robust weighting parameter
     real support(2)   ! Support size in meters
     real uvcell(2)    ! Cell size in meters
     integer channels(3)  ! First, Last and Weight channels
     integer ctype     ! Convolution type
     integer beam      ! One beam every N channels
     logical shift     ! Shift phase center
     logical blocked   ! Use blocking factor, or not (Debug)
     character(len=16) ra_c
     character(len=16) dec_c
     real(kind=8) new(3)     ! New position and angle of shift/rotation
     real(kind=8) off(3)     ! Offset and angle of shift/rotation
     real(kind=8) xy(2)      ! Phase rotation ! R*4 for SortUV
     real(kind=8) cs(2)      ! Angle offsets  ! R*4 for LoadUV
     real(kind=8) freq       ! Frequency for U,V values
     integer uvcode    ! UVT or TUV order ?
  end type
  !
  type gridding
     real ubias            ! Bias of U coordinates
     real ubuff(4096)      ! Grid of values of the convolution
     real vbias            ! Bias of V coordinates
     real vbuff(4096)      ! Grid of values of the convolution
  end type gridding
  integer, parameter :: code_uvt=1  ! This MUST NOT be changed
  integer, parameter :: code_tuv=2  ! This MUST NOT be changed
end module uvmap_def
!
! Used by Mapping CLEAN tools
!
module clean_def
  !------------------------------------------------------------------------------
  ! Parameters of CLEAN deconvolution.
  !------------------------------------------------------------------------------
  !
  type gridding
     real ubias            ! Bias of U coordinates
     real ubuff(4096)      ! Grid of values of the convolution
     real vbias            ! Bias of V coordinates
     real vbuff(4096)      ! Grid of values of the convolution
  end type gridding
  !
  type uvmap_par
    real taper(4)              ! UV Taper
    integer size(2)            ! Map size
    real xycell(2)             ! Map cell
    real uvcell(2)             ! UV cell
    real uniform(2)            ! Weighting parameters
    integer wcol               ! Weighting channel
    integer ctype              ! Convolution mode
    real support(2)            ! Support of gridding function
    integer beam               ! One beam every N channels
    real field(2)              ! Field of view in arcsecond
    real precis                ! Precision at map edges
    real truncate              ! Truncation level in %
    character mode*8           ! Weighting mode
    logical shift              ! Shift or rotate UV data
    character ra_c*16          ! Right ascension
    character dec_c*16         ! Declination
    real angle                 ! New position angle of UV data
    integer nfields            ! Number and type of fields (<0 = phase, >0 = pointing)
    real bsize                 ! Primary Beam size (for Mosaics)
    real, allocatable :: offxy(:,:)    ! Pointing or Phase offset values
    real(8), allocatable :: centers(:,:) ! Ra Dec absolute pointings
    ! real, pointer :: uvdata(:,:)       ! UV Data (not used)
  end type
  !-----
  type clean_par
    sequence
    integer first,last         ! First & Last plane
    integer nlist              ! List size
    integer iplane             ! Current image plane
    integer ibeam              ! Current beam plane
    integer imask              ! Current mask plane 
    !
    real thresh                ! Threshold for beam fit
    real gain                  ! Loop gain
    real fres                  ! Fractional residual
    real ares                  ! Absolute residual
    real ratio                 ! Smoothing ratio for MRC
    real spexp                 ! Speed up factor in Clark
    real phat                  ! Prussian hat
    real flux                  ! Cleaned Flux
    real smooth                ! Multi-Scale smoothing factor
    real search                ! Threshold for searching
    real restor                !           for restoration
    real trunca                ! Beam truncation value
    real worry                 ! Worry factor in MultiScale
    integer nker(3)            ! Kernel for Multi-Scale clean
    real gains(3)              ! Clean gains
    integer ninflate           ! Component "inflation" factor
    integer ngoal              ! Maximum number of minor cycle components
    integer converge           ! Convergence criterium: 0 = Infty
    integer m_iter             ! Maximum number of iterations
    integer n_iter             ! Current number of iterations
    integer p_iter             ! Positive number of iterations
    integer n_major            ! Maximum number of major cycle
    !
    real major                 ! Major axis
    real minor                 ! Minor axis
    real angle                 ! Clean beam angle
    real beam_min              ! Beam minimum
    real beam_max              ! Beam maximum
    real bgain                 ! Outer sidelobe
    !
    integer blc(2)             ! Bottom Left Corner
    integer trc(2)             ! Top Right Corner
    integer box(4)             ! Cleaning Box
    integer beam0(2)           ! Beam center X,Y
    integer patch(2)           ! Beam patch sizes
    integer bzone(4)           ! Beam patch
    integer bshift(3)          ! Beam shift
    integer residual        ! Add back the residual ?
    !
    logical mosaic             ! Mosaic flag
    logical pflux              ! Flux display
    logical pcycle             ! Residual display in cycle
    logical pmrc               ! MRC display in cycle
    logical qcycle             ! Query mode
    logical pclean             ! Clean display in cycle
    logical do_mask            ! Re-compute the mask ?
    logical verbose            ! Lots of printout ?
    character method*12        ! METHOD
    !
    real, pointer :: atten(:,:,:)   ! Mosaic weights (as function of freq)
!    integer, pointer :: list(:)    ! List of selected pixels
!    logical, pointer :: mask(:,:)  ! Selection mask
  end type
  !-----
  type cct_par                 ! Clean Component definition
    real influx                ! Current flux
    real value                 ! Component value
    integer ix                 ! X pixel
    integer iy                 ! Y pixel
    integer type               ! Component kernel number
  end type
end module clean_def
!
module mod_fitbeam
  integer :: nv                ! Number of values
  real :: par(6)  ! Fitted parameters
  real :: err(6)  ! Errorbars
  real :: spar(6) ! Last fitted values
  real :: sigbas  ! rms on baseline
  real :: sigrai  ! rms on line
  integer :: kpar(6)  ! Code for parameter
  real, allocatable :: ip_values(:)    ! Values
  real, allocatable :: ip_coords(:,:)  ! Coordinates
end module mod_fitbeam
!
!
module short_def
  integer, parameter :: code_short_old=0    ! Old method: one file per field
  integer, parameter :: code_short_phase=1  ! Mosaic UV table with phase offsets
  integer, parameter :: code_short_point=2  ! Mosaic UV table with pointing offsets
  integer, parameter :: code_short_auto=3   ! Automatic derivation of UV table offsets type
  !
  type short_spacings
    integer                           :: mode=3
    real                              :: sd_factor=0.0
    real                              :: minw=0.01
    real                              :: ptole=0.0
    real                              :: ftole=0.01
    real                              :: uv_minr=0.
    real                              :: uv_maxr=0.
    real                              :: sd_weight=0.
    integer                           :: xcol=0
    integer                           :: ycol=0
    integer                           :: wcol=0
    integer                           :: mcol(2)=[0,0]
    real                              :: sd_beam(3)=[0.,0.,0.]
    real                              :: sd_diam=0.
    real                              :: ip_beam=0.
    real                              :: ip_diam=0.
    logical                           :: do_single=.true.
    logical                           :: do_primary=.true.
    character(len=4)                  :: weight_mode='NATU' 
    character(len=16)                 :: chra=' '
    character(len=16)                 :: chde=' '
    integer                           :: nf=0
    real, allocatable    :: raoff(:)
    real, allocatable    :: deoff(:)
  end type 
  !
end module short_def

program p_uvcorrel
  use gkernel_interfaces
  use image_def
  use gbl_message
  !$ use omp_lib
  !
  ! Compute Frequency Cross-Correlation spectrum
  ! of two UV tables
  !
  character(len=256) cmod,cuv,cspec 
  logical error
  type (gildas) :: hmod,huv,hspec
  character(len=*), parameter :: rname='UV_CORRELATE'
  real, allocatable :: accum(:), accums(:,:), current(:)
  logical :: equal
  integer :: it, iv, nchan, i, ier, nker, nthread, ithread, nsize
  !
  call gildas_open
  call gildas_char('MODEL$',cmod)
  call gildas_char('UVDATA$',cuv)
  call gildas_char('SPECTRUM$',cspec)
  call gildas_close
  !
  call gildas_null(hmod,type='UVT')
  call gildas_null(huv,type='UVT')
  !
  call sic_parse_file(cmod,' ','.uvt',hmod%file)
  call sic_parse_file(cuv,' ','.uvt',huv%file)
  !
  call gdf_read_header(hmod,error)
  call gdf_read_header(huv,error)
  !
  nchan = hmod%gil%nchan
  nsize = hmod%gil%dim(1)
  !
  hmod%gil%dim(1) = huv%gil%dim(1) ! For tests so far
  hmod%gil%nchan  = huv%gil%nchan
  call gdf_compare_shape(huv,hmod,equal)  !
  if (.not.equal) then
    call gag_message(seve%e,rname,'MODEL and UVDATA UV tables do not match')
    call sysexi(fatale)
  endif
  hmod%gil%dim(1) = nsize ! restore values 
  hmod%gil%nchan  = nchan ! 
  !
  ! Will be done by Blocks later
  call gdf_allocate(hmod,error)
  call gdf_allocate(huv,error)
  call gdf_read_data(hmod,hmod%r2d,error)
  call gdf_read_data(huv,huv%r2d,error)
  !
  call gildas_null(hspec,type='TABLE')
  call sic_parse_file(cspec,' ','.tab',hspec%file)
  !
  ! This will be a Spectrum
  nker = min(huv%gil%nchan/4,hmod%gil%nchan)
  hspec%gil%ndim = 2
  hspec%gil%dim(1:2) = [huv%gil%nchan-nker,3]
  hspec%gil%nchan = hspec%gil%dim(1)
  call gdf_allocate(hspec,error)
  !
  do i=1,hspec%gil%dim(1)
    hspec%r2d(i,1) = (i-huv%gil%ref(1)+nker/2)*huv%gil%vres + huv%gil%voff
    hspec%r2d(i,2) = (i-huv%gil%ref(1)+nker/2)*huv%gil%fres + huv%gil%freq
  enddo
  !
  !!Print *,'SPEC Dim ',hspec%gil%dim,' Kernel size ',nker,' Channels ',huv%gil%nchan
  nchan = hspec%gil%dim(1)
  nthread = 1
  !$ nthread = omp_get_max_threads()
  allocate(accum(nchan),accums(nchan,nthread),current(nchan),stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Allocation error')
    call sysexi(fatale)
  endif
  !
  accums = 0.0
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP &  SHARED(huv,hmod,nker,accums) &
  !$OMP &  PRIVATE(iv,current,ithread)
  !
  !$ ithread = omp_get_thread_num()+1
  !$OMP DO
  do iv = 1, huv%gil%nvisi
    current = 0.0
    call uvcorrel(huv%r2d(:,iv),huv%gil%nchan, & 
      & hmod%r2d(:,iv),hmod%gil%nchan,nker,current)
    accums(:,ithread) = accums(:,ithread) + current
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  hspec%r2d(:,3) = 0.0
  do it =1,nthread
    hspec%r2d(:,3) = hspec%r2d(:,3) + accums(:,it)
  enddo
  call gdf_write_image(hspec,hspec%r2d,error)
  !
  contains
!
subroutine uvcorrel(uvdata,nc,kernel,mk,nk,current)
  use image_def
  use gkernel_interfaces
  !
  real, intent(in) :: uvdata(:)
  real, intent(in) :: kernel(:)
  integer, intent(in) :: nc, nk, mk
  real, intent(out) :: current(:)
  !
  ! Small automatic arrays
  real :: rdata(nc),idata(nc),wdata(nc),weight
  real :: rkernel(nk),ikernel(nk)
  complex :: cdata,ckernel(nk)
  integer :: ishift, ik, jc, icount, jk, hk
  real(8) :: r2, rp
  !
  weight = kernel(7+3*(mk/2))
  if (weight.le.0) return  ! Flagged visibility
  !
  rdata(:) = uvdata(8:5+3*nc:3)
  idata(:) = uvdata(9:6+3*nc:3)
  wdata(:) = uvdata(10:7+3*nc:3)
  !
  ! For the Kernel, we take NK channels out of MK
  ! So we start from NK/2-NK/2 
  jk = (mk/2)-nk/2 + 1
  hk = jk + nk - 1
  rkernel(:) = kernel(5+3*jk:5+3*hk:3)
  ikernel(:) = kernel(6+3*jk:6+3*hk:3)
  ckernel = cmplx(rkernel,ikernel)
!!
!! xc += np.correlate(data.VV[v], np.matmul(data.wgts[v]*R_inv, kernel[v]))
!!        # normalize the output such that real and imag noise powers are both 1 (hence factor of sqrt(2))
!!                kernel_noise_power += np.dot(kernel[v],np.matmul(data.wgts[v]*R_inv, kernel[v].conj()))
!!        xc = xc/np.sqrt(kernel_noise_power)*np.sqrt(2)  
!!
  ! Assume no correlation between channels
  do ik = 1,nc-nk
    r2 = 0.
    rp = 0. ! Noise power
    do jc=ik,ik+nk-1
      jk = jc-ik+1
      icount = icount+1
      if (wdata(jc).gt.0) then
        cdata = cmplx(rdata(jc),idata(jc))
        cdata = cdata*ckernel(jk)*weight
        r2 = r2 + real(cdata)
        rp = rp + ckernel(jk)*weight*conjg(ckernel(jk))
      endif
    enddo
    current(ik) = sqrt(2.)*r2/sqrt(rp)
  enddo
end subroutine uvcorrel
!
end program p_uvcorrel

        

module flux_module
  real, save :: date_interval=1.0 
  integer, save :: n_dates=0           ! number of dates
  integer, allocatable :: class(:)     ! List of Class dates
  integer, allocatable :: vgood(:)     ! Number of selected visibilities
  real, allocatable ::  fscale(:)      ! Flux scale factors
  real, allocatable ::  dscale(:)      ! Errors on scale factors
  real, save :: uvmin
  real, save :: uvmax
  character(len=76), allocatable :: chain(:)  ! Text string per date
  character(len=16) myvar
  real, allocatable :: myuv(:,:)
end module flux_module
!
!
! From clean_arrays (requiring clean_def), we use
!   huv, duv for the UV data set (by READ UV)
!   huvm, duvm  for the ModelUV data set (by READ MODEL, or produced
!        by command MODEL)
!
! From flux_variables
!   n_dates      ! number of dates
!   class(:)     ! List of Class dates
!   chain*70(:)  ! Text string per date
!   vscale(:)    ! Flux scale factors
!   dscale(:)    ! Errors on scale factors
!
! Operation
!  
!  READ UV DataSet
!      Read the UV data set
!  READ MODEL DataSet     or MODEL command
!      Read the Model data set
!  SCALE_FLUX FIND 
!      Define n_dates
!      load Class(n_dates)
!      compute Flux(n_dates)
!      define the associate SIC variable Flux[] and D_Flux
!  SCALE_FLUX APPLY MyVariable
!      Compute  Fij*ModelUV
!      put it in a SIC variable called MyVariable
!  SCALE_FLUX
!
! Then, if an iterative procedure is needed:
!  begin procedure my_proc
!    SCALE_FLUX APPLY MyVariable
!    let adj%res UV-MyVariable
!  end procedure my_proc
!  adjust UV "@ my_proc" /start /par flux[i] .. flux[j] /root adj
!  exa adj%fit
!  exa adj%err
!
subroutine flux_dispatch (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>flux_dispatch
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  ! Dispatching routine for command
  !  SCALE_FLUX FIND [DateInterval [MinBase MaxBase]]
  !  SCALE_FLUX APPLY OutputVariable
  !  SCALE_FLUX CALIBRATE
  !  SCALE_FLUX LIST
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  character(len=12) arg, argument
  integer, parameter :: mpar=5
  integer iarg
  character(12) cpar(mpar)
  data cpar /'CALIBRATE', 'APPLY', 'FIND', 'LIST', 'SOLVE'/ 
  !
  call sic_ke(line,0,1,arg,iarg,.true.,error)
  call sic_ambigs('SCALE_FLUX',arg,argument,iarg,cpar,mpar,error)
  select case (argument)
  case ('FIND')
    call flux_find (line,error)
  case ('APPLY')
    call flux_apply (line,error)
  case ('LIST') 
    call flux_list (line,error)
  case ('CALIBRATE') 
    call flux_calib (line,error)
  case ('SOLVE') 
    call flux_find(line,error)
    if (error) return
    call flux_list(line,error)
  case default
     call gagout(argument//' Not yet implemented')
     error = .true.
  end select
end subroutine flux_dispatch
!   
subroutine flux_apply  (line,error)
  use gkernel_interfaces
  use gildas_def
  use clean_arrays
  use flux_module
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command
  !   SCALE_FLUX APPLY OutputVariable
  !-----------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  integer ier
  integer nc,nv, iv,ic, ir,ii,iw,id,ie, ti
  real weight_fact, flux_fact
  !
  if (n_dates.eq.0) then
    call map_message(seve%e,'SCALE_FLUX','Dates not defined, use command SCALE_FLUX FIND before')
    error = .true.
    return
  endif
  !
  call sic_ch(line,0,2,myvar,ier,.true.,error)
  if (error) return
  call sic_delvariable(myvar,.false.,error)
  !
  if (allocated(myuv)) deallocate(myuv)
  allocate (myuv(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
  nv = huv%gil%nvisi ! not %dim(2)
  nc = huv%gil%nchan 
  id = 1
  !
  do iv=1,nv
    !
    ! Get the date
    ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
    if (ti.eq.0 .and. duv(6,iv).eq.0) cycle  ! Dummy
    if (abs(ti-class(id)).ge.date_interval) then
      do ie=1,n_dates 
        if (abs(ti-class(ie)).lt.date_interval) then
          id = ie
          exit
        endif
      enddo
    endif
    flux_fact =  fscale(id) 
    weight_fact = 1./flux_fact**2
    myuv(:,iv) = duvm(:,iv)
    do ic=1,nc
      ir = 5+3*ic
      ii = ir+1
      iw = ii+1
      !
      myuv(ir,iv) = myuv (ir,iv) * flux_fact 
      myuv(ii,iv) = myuv (ii,iv) * flux_fact 
      myuv(iw,iv) = myuv (iw,iv) * weight_fact 
    enddo
  enddo
  call sic_def_real(myvar,myuv,2,huv%gil%dim,.true.,error)
end subroutine flux_apply
!
subroutine flux_calib (line,error)
  use gildas_def
  use clean_arrays
  use flux_module
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  ! Support for command
  !  SCALE_FLUX CALIBRATE 
  !
  ! Apply the factors to the UV data set..
  !-----------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  integer ier
  integer nc,nv, iv,ic, ir,ii,iw,id,ie, ti
  real weight_fact, flux_fact
  !
  if (n_dates.eq.0) then
    call map_message(seve%e,'SCALE_FLUX','Dates not defined, use command SCALE_FLUX FIND before')
    error = .true.
    return
  endif
  !
  allocate (myuv(huv%gil%dim(1),huv%gil%dim(2)),stat=ier)
  nv = huv%gil%nvisi ! not %dim(2)
  nc = huv%gil%nchan 
  id = 1
  !
  do iv=1,nv
    !
    ! Get the date
    ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
    if (ti.eq.0 .and. duv(6,iv).eq.0) cycle  ! Dummy
    if (abs(ti-class(id)).ge.date_interval) then
      do ie=1,n_dates 
        if (abs(ti-class(ie)).lt.date_interval) then
          id = ie
          exit
        endif
      enddo
    endif
    flux_fact =  1./fscale(id) 
    weight_fact = flux_fact**2
    do ic=1,nc
      ir = 5+3*ic
      ii = ir+1
      iw = ii+1
      !
      duv(ir,iv) = duv (ir,iv) * flux_fact 
      duv(ii,iv) = duv (ii,iv) * flux_fact 
      duv(iw,iv) = duv (iw,iv) * weight_fact 
    enddo
  enddo
end subroutine flux_calib
!
subroutine flux_find (line,error)
  use gkernel_interfaces
  use gildas_def
  use clean_arrays
  use flux_module
  use gbl_message
  use imager_interfaces, only : flux_factor, map_message
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  ! Support routine for command
  !  SCALE_FLUX FIND [DateInterval [MinBase MaxBase]]
  !
  !  Scan the current UV table (obtained by READ UV) to determine
  !  how many independent dates exist
  !
  !  Compare it date by date with the model UV table (obtained by 
  !  READ MODEL or MODEl commands) and compute, through linear 
  !  regression, the best scaling factors to match the two tables
  !
  !  Return these flux factors as variables
  !  SCALE_FLUX and D_FLUX
  !-----------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  logical equal
  integer ier
  real uvmin2
  real uvmax2
  !
  date_interval = 1.0
  call sic_r4 (line,0,2,date_interval,.false.,error)
  if (error) return
  if (date_interval.le.0) then
    call map_message(seve%e,'SCALE_FLUX','Date tolerance must be > 0')
    error = .true.
    return
  endif  
  !
  uvmin = 0
  uvmax = 0
  call sic_r4(line,0,3,uvmin,.false.,error)
  call sic_r4(line,0,4,uvmax,.false.,error)
  uvmin2 = uvmin**2
  uvmax2 = uvmax**2
  !
  call gdf_compare_shape(huv,huvm,equal)
  if (.not.equal) then
    print *,'Data  ',huv%gil%dim
    print *,'Model ',huvm%gil%dim 
    call map_message(seve%e,'SCALE_FLUX','Data and Model are not comparable')
    error = .true.
    return
  endif
  if (n_dates.ne.0) then
    deallocate(class,fscale,dscale,chain,stat=ier)
    n_dates = 0
    call sic_delvariable('S_FLUX',.false.,error)
    call sic_delvariable('D_FLUX',.false.,error)
  endif
  call flux_factor (huv,duv,huvm,duvm,date_interval,uvmin2,uvmax2,error)
  if (error) return
  !
  call sic_def_real('S_FLUX',fscale,1,n_dates,.false.,error)
  call sic_def_real('D_FLUX',dscale,1,n_dates,.false.,error)
end subroutine flux_find
!
subroutine flux_list (line,error)
  use flux_module
  use gbl_message
  use imager_interfaces, only : flux_factor
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  ! Support routine for command
  !  SCALE_FLUX LIST 
  !
  !  Printout the latest results from SCALE_FLUX FIND
  !-----------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  integer id
  !
  if (n_dates.eq.0) then
    call map_message(seve%e,'SCALE_FLUX','Dates not defined, use command SCALE_FLUX FIND before')
    error = .true.
    return
  endif
  write(*,'(A)')  &
    &     ' Summary of observations              Baselines (m) '
  Print *,' Dates          Visibilities           Min   &  Max           Scale'
  write(*,'(A,I8,A,I8,A)')  &
    &     '              Total     In range   [',nint(uvmin),", ",nint(uvmax),']'
  do id=1,n_dates
    write(chain(id)(24:31),'(I8)') vgood(id)
    write(chain(id)(57:),'(F8.3,a,F6.3)') fscale(id),' +/-',dscale(id)
    print *,chain(id)
  enddo
end subroutine flux_list
!
subroutine flux_factor (hduv,duv,hcuv,cuv,date_spacing,uvmin2,uvmax2,error)
  use imager_interfaces, only : my_finddat, my_listdat
  use flux_module
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   SCALE_FLUX FIND or SOLVE
  ! Find the flux scale factors for the Observations
  !
  ! The observations are defined by  Obs = Factor * Model + noise
  ! so the calibration factor to apply is the inverse of this solution
  !-----------------------------------------------------------
  real(kind=4), intent(in) :: date_spacing
  type (gildas), intent(in) :: hduv
  type (gildas), intent(in) :: hcuv
  real(kind=4), intent(in) :: duv(hduv%gil%dim(1),hduv%gil%dim(2))
  real(kind=4), intent(in) :: cuv(hcuv%gil%dim(1),hcuv%gil%dim(2))
  real(kind=4), intent(in) :: uvmin2 ! Min baseline ^ 2
  real(kind=4), intent(in) :: uvmax2 ! Max baseline ^ 2
  logical, intent(out) :: error
  !
  real(kind=8), allocatable :: xy(:), xx(:), yy(:), xm(:)
  integer, allocatable :: im(:)
  real :: uv2
  integer :: nm,nv,nc,nd
  integer :: id, ie, iv, ic, ti, ier
  integer :: ii, ir, iw
  !
  ! 3) Build list of dates
  nm = hduv%gil%dim(1)
  nv = hduv%gil%nvisi ! Not %dim(2)
  nc = hduv%gil%nchan ! not (nm-7)/3
  !
  call my_finddat (nm,nv,duv,date_spacing,nd) 
  allocate(class(nd),fscale(nd),dscale(nd),chain(nd),vgood(nd),stat=ier)
  !
  call my_listdat (nm,nv,duv,nd,class,date_spacing,chain) 
  !
  ! 4) Linear fit of flux scale factor
  !
  ! A = Sum (X Y / sigma^2) / Sum (X^2/Sigma^2)
  ! A = Sum (X Y W) / Sum (X X W)
  !
  allocate (xy(nd),xx(nd),yy(nd),xm(nd),im(nd),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'UV_FLUX','Memory allocation error')
    error = .true.
    return
  endif
  xx = 0
  xy = 0
  yy = 0
  xm = 0
  im = 0
  id = 1
  !
  do iv=1,nv
    ! Avoid UV out of range
    if (uvmin2.ne.0 .or. uvmax2.ne.0) then
      uv2 = duv(1,iv)**2 + duv(2,iv)**2
      if (uv2.le.uvmin2) cycle
      if (uvmax.ne.0) then
        if (uv2.gt.uvmax2) cycle
      endif
    endif
    !
    ! Get the date
    ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
    if (ti.eq.0 .and.duv(6,iv).eq.0) cycle !! Dummy
    if (abs(ti-class(id)).ge.date_spacing) then
      id = 0
      do ie=1,nd 
        if (abs(ti-class(ie)).lt.date_spacing) then
          id = ie
          exit
        endif
      enddo
    endif
    !
    do ic=1,nc
      ir = 5+3*ic
      ii = ir+1
      iw = ii+1
      xm(id) = xm(id) + cuv(ir,iv) + cuv(ii,iv) ! needed later
      im(id) = im(id) + 1
      xx(id) = xx(id) + (cuv(ir,iv)**2 + cuv(ii,iv)**2) * cuv(iw,iv)**2
      xy(id) = xy(id) + (duv(ir,iv)*cuv(ir,iv) + duv(ii,iv)*cuv(ii,iv)) * cuv(iw,iv)**2
      yy(id) = yy(id) + (duv(ir,iv)**2 + duv(ii,iv)**2) * duv(iw,iv)**2
    enddo
  enddo
  if (any(im.lt.3)) then
    call map_message(seve%e,'SCALE_FLUX','Not enough visibilities in range')
    error = .true.
    return
  endif
  xm(:) = xm/im
  !
  !! factors = xy/yy  ! Not these ones
  fscale(:) = xy/xx   ! XX is the model
  !! Standard deviation, equal weights to have an idea
  !! sqrt [ Σ(yi – ŷi)^2 / (n – 2) ] / sqrt [ Σ(xi – x)^2 ].
  !!  with ŷi =0 and x=0 
  xx = 0
  yy = 0
  do iv=1,nv
    ! Avoid UV out of range
    if (uvmin2.ne.0 .or. uvmax2.ne.0) then
      uv2 = duv(1,iv)**2 + duv(2,iv)**2
      if (uv2.le.uvmin2) cycle
      if (uvmax2.ne.0) then
        if (uv2.gt.uvmax2) cycle
      endif
    endif
    !
    ! Get the date
    ti = int(duv(4,iv)+duv(5,iv)/86400.0d0)     
    if (ti.eq.0 .and.duv(6,iv).eq.0) cycle !! Dummy
    if (abs(ti-class(id)).ge.date_spacing) then
      do ie=1,nd 
        if (abs(ti-class(ie)).lt.date_spacing) then
          id = ie
          exit
        endif
      enddo
    endif
    !
    do ic=1,nc
      ir = 5+3*ic
      ii = ir+1
      iw = ii+1
      !
      xx(id) = xx(id) + (cuv(ir,ic)-xm(id))**2 + (cuv(ii,ic)-xm(id))**2
      yy(id) = yy(id) + (duv(ir,ic)-fscale(id)*cuv(ir,ic))**2 + &
          & (duv(ii,ic)-fscale(id)*cuv(ii,ic))**2
    enddo
  enddo
  vgood(:) = im
  dscale(:) = sqrt(yy/(vgood-2)/xx)  
  n_dates = nd
  error = .false.
end subroutine flux_factor
!
subroutine my_finddat(nc,nv,visi,rtol,nt) 
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Find how many dates
  !-----------------------------------------------------------
  integer, intent(in) :: nc  ! Visibility size 
  integer, intent(in) :: nv  ! Number of visibilities
  integer, intent(out) :: nt ! Number of time stamps
  real, intent(in) :: rtol  ! Tolerance to check dates 
  real, intent(in) :: visi(nc,nv)   ! Visibilities
  !
  integer iv
  integer ti,jt,j
  integer tf(nv)
  !
  nt = 0
  do iv=1,nv
    ti = int(visi(4,iv)+visi(5,iv)/86400.0d0)
    if (ti.eq.0 .and.visi(6,iv).eq.0) cycle !! Dummy
    jt = 0
    do j=1,nt
      if (abs(ti-tf(j)).lt.rtol) then
        jt = j
        exit
      endif
    enddo
    if (jt.eq.0) then
      nt = nt+1
      tf(nt) = ti
    endif
  enddo
end subroutine my_finddat
!
subroutine my_listdat(nc,nv,visi,nt,tf,rtol,chain) 
  use gkernel_interfaces
  !-----------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   List the different dates 
  !-----------------------------------------------------------
  integer, intent(in) :: nc  ! Visibility size 
  integer, intent(in) :: nv  ! Number of visibilities
  integer, intent(in) :: nt  ! Number of time stamps
  integer, intent(out) :: tf(nt)              ! Time stamp values
  character(len=*), intent(out) :: chain(nt)  ! Associated message
  real, intent(in) :: rtol  ! Tolerance to check dates 
  real, intent(in) :: visi(nc,nv)   ! Visibilities
   !
  character(len=14) ch
  logical error
  integer jt,ti,co,iv,i,j,k
  integer it
  integer count(nt)
  real bmin(nt), bmax(nt), bm, bp, base
  !
  it = 0
  tf = 0
  bmin = 1E20
  bmax = 0
  !
  !!Print *,'Date Tolerance ',itol
  !
  do iv=1,nv
    ti = int(visi(4,iv)+visi(5,iv)/86400.0d0)
    if (ti.eq.0 .and.visi(6,iv).eq.0) cycle !! Dummy
    jt = 0
    do j=1,nt
      if (abs(ti-tf(j)).lt.rtol) then
        jt = j
        exit
      endif
    enddo
    if (jt.eq.0) then
      if (it.gt.nt) then
        print *,'E-DATES,  more than ',nt,' dates'
        return
      endif
      it = it+1
      tf(it) = ti
      count(it) = 1
      jt = it
    else
      count(jt) = count(jt)+1
    endif
    !
    base = visi(1,iv)**2+visi(2,iv)**2
    if (base.ne.0) then
      bmin(jt) = min(base,bmin(jt))
      bmax(jt) = max(base,bmax(jt))
    endif
  enddo
  !
  ! Go to true baseline length
  bmin = sqrt(bmin)
  bmax = sqrt(bmax)
  !
  !
  ! A simple sort
  do j = nt-1,1,-1
    k = j
    do i = j+1,nt
      if (tf(j).le.tf(i)) exit 
      k = i
    enddo
    if (k.ne.j) then
      ti = tf(j)
      co = count(j)
      bp = bmax(j)
      bm = bmin(j)     
      do i = j+1,k
        tf(i-1) = tf(i)
        count(i-1) = count(i)
        bmax(i-1) = bmax(i)
        bmin(i-1) = bmin(i)
      enddo
      tf(k) = ti
      count(k) = co
      bmax(k) = bp
      bmin(k) = bm
    endif
  enddo
  !
  do i=1,nt
    call gag_todate(tf(i),ch,error)
    write(chain(i),100) ch,count(i),count(i),bmin(i),bmax(i)
  enddo
100 format (A,I8,1X,I8,3X,F9.1,1X,F9.1) 
end subroutine my_listdat

subroutine com_support(line,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, only : map_message, mask_clean
  use clean_default
  use clean_arrays
  use clean_support
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  
  !   Support routine for command
  !	  SUPPORT [/PLOT] [/CURSOR] [/RESET] [/MASK] [/VARIABLE]
  !           [/THRESHOLD  Raw Smooth [SmoothingLength]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Commandand line
  logical,          intent(out) :: error ! Logical error flag
  !
  ! Local variables
  character(len=*), parameter :: rname='SUPPORT'
  integer(kind=4), parameter :: o_name=0
  integer(kind=4), parameter :: o_curs=1
  integer(kind=4), parameter :: o_mask=2
  integer(kind=4), parameter :: o_plot=3
  integer(kind=4), parameter :: o_rese=4
  integer(kind=4), parameter :: o_thre=5
  integer(kind=4), parameter :: o_vari=6
  !
  logical :: fromfile, do_plot
  character(len=filename_length) :: file
  integer(kind=4) :: ier
  real(kind=4), allocatable, target :: imask(:,:)
  !
  do_plot = sic_present(o_plot,0)
  !
  if (sic_present(o_curs,0)) then  ! /CURSOR
    call map_message(seve%i,rname,'Use cursor to define polygon')
    user_method%do_mask = .true.
    file = ' '
    fromfile = .false.
    !
    ! It is actually not obvious that the MASK should be erased here...
    call sic_delvariable('MASK',.false.,error)
    hmask%loca%size = 0
    !
  else if (sic_present(o_rese,0)) then  ! /RESET
    if (allocated(dmask)) then
      deallocate(dmask,stat=ier)
    endif
    call greg_poly_reset(supportpol,supportvar,error)
    if (error)  return
    user_method%do_mask = .true.  ! The mask HAS changed...
    call sic_delvariable('MASK',.false.,error)
    support_type = support_none
    hmask%loca%size = 0
    ! Delete the "supportvar" structure
    call sic_delvariable(supportvar,.false.,error)
    return
    !
  else if (sic_present(o_mask,0)) then  ! /MASK
    if (allocated(dmask)) then
      call sic_delvariable('MASK',.false.,error)
      call sic_mapgildas ('MASK',hmask,error,dmask)
      !
      user_method%do_mask = .true.
      support_type = 1 ! First plane will be used by default
      !
      ! Show it if asked for by /PLOT option
      if (do_plot) then
        allocate (imask(hmask%gil%dim(1),hmask%gil%dim(2)),stat=ier)
        imask = 0.0
        where (dmask(:,:,1).ne.0) imask = 1.0
        call sic_def_real ('BITMAP_MASK',imask,hmask%gil%ndim,   &
         &        hmask%gil%dim,.true.,error)
        call gr_exec2('PLOT BITMAP_MASK /SCALING LIN -0.5 1.5')
        error = gr_error()
        call sic_delvariable('BITMAP_MASK',.false.,error)
        deallocate (imask,stat=ier)
      endif
    else
      call map_message(seve%e,rname,'No mask defined')
      error  = .true.
    endif
    return
  else if (sic_present(o_thre,0)) then
    ! This is obsolescent...
    !
    ! SUPPORT /THRESHOLD Raw Smooth [Length]
    !
    !  Raw      Thresholding (in Sigma) of the Clean image
    !  Smooth   Thresholding (in Sigma) after smoothing
    !  Length   Smoothing length: default is Clean beam major axis
    !
    call map_message(seve%e,rname,'/THRESHOLD option is Obsolete, use MASK THRESHOLD instead')
    error = .true.
    return
  else if (do_plot.and.sic_narg(o_name).eq.0) then  
    ! SUPPORT /PLOT 
    !
    ! Just plot
    if (support_type.eq.support_poly) then
      call greg_poly_plot(supportpol,error)
    else if (support_type.ne.support_none) then
      allocate (imask(hmask%gil%dim(1),hmask%gil%dim(2)),stat=ier)
      imask = 0.0
      where (dmask(:,:,1).ne.0) imask = 1.0
      call sic_def_real ('BITMAP_MASK',imask,hmask%gil%ndim,   &
       &        hmask%gil%dim,.true.,error)
      call gr_exec2('PLOT BITMAP_MASK /SCALING LIN -0.5 1.5')
      error = gr_error()
      call sic_delvariable('BITMAP_MASK',.false.,error)
      deallocate (imask,stat=ier)
      support_type = support_mask
    else
      call map_message(seve%w,rname,'No support defined')
      error  = .true.      
    endif
    return
  else
    !
    ! This also re-instate the Polygon as the Clean support
    user_method%do_mask = .true.
    if (sic_narg(o_name).ge.1) then
      call greg_poly_parsename(line,o_name,o_vari,fromfile,file,error)
      if (error) return
    else
      ! No argument, no /CURSOR option either: re-instate the
      ! current Polygon as a SUPPORT if any.
      if (supportpol%ngon.lt.3) then
        call map_message(seve%e,rname,'No current support defined')
        error = .true.
        return
      endif
      support_type = support_poly
      return
    endif
  endif
  !
  ! File, /VARIABLE or /CURSOR option
  !
  ! Define the polygon from file or cursor:
  call sic_delvariable(supportvar,.false.,error)
  call sic_defstructure(supportvar,.true.,error)
  !
  ! NO Reason to do this here --- ! hmask%loca%size = 0
  call greg_poly_define(rname,file,fromfile,supportpol,supportvar,error)
  if (error)  return
  support_type = support_poly
  !
  ! /PLOT if needed
  if (do_plot) call greg_poly_plot(supportpol,error)
  !
end subroutine com_support

module cubeedit_close
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_identifier
  use cubeedit_messaging
  !
  public :: close
  private
  !
  type :: close_comm_t
     type(option_t), pointer :: comm
     type(identifier_opt_t)  :: as
   contains
     procedure, public  :: register => cubeedit_close_register
     procedure, private :: parse    => cubeedit_close_parse
     procedure, private :: main     => cubeedit_close_main
  end type close_comm_t
  type(close_comm_t) :: close
  !
  type close_user_t
     character(len=varn_l)   :: edid
     type(identifier_user_t) :: identifier
  end type close_user_t
  !
contains
  !
  subroutine cubeedit_close_command(line,error)
    !-------------------------------------------------------------------
    ! Support routine for command CLOSE
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(close_user_t) :: user
    character(len=*), parameter :: rname='CLOSE>COMMAND'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call close%parse(line,user,error)
    if (error) return
    call close%main(user,error)
    if (error) return
  end subroutine cubeedit_close_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeedit_close_register(close,error)
    !-------------------------------------------------------------------
    ! Register EDIT\CLOSE and its options
    !-------------------------------------------------------------------
    class(close_comm_t), intent(inout) :: close
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: comm_abstract = &
         'Close a cube in editing mode'
    character(len=*), parameter :: comm_help = &
         'By default the family name of the output cube is the same as&
         & the Editing Id (newid) and its flags are "edited,cube" for&
         & cubes created from scratch (no /LIKE), or "edited" followed&
         & by the original flags for cubes created as a copy (/LIKE).&
         & This can be customized by using option /AS.'
    !
    type(standard_arg_t) :: stdarg
    character(len=*), parameter :: rname='CLOSE>REGISTER'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'CLOSE','[newid]',&
         comm_abstract,&
         comm_help,&
         cubeedit_close_command,&
         close%comm,error)
    if (error) return
    call stdarg%register(&
         'NewId', &
         'Editing Identifier', &
         strg_id,&
         code_arg_optional, error)
    if (error) return
    !
    call close%as%register(&
         'Define the identifier of the cube being closed',&
         changeflags,error)
    if (error) return
    !
  end subroutine cubeedit_close_register
  !
  subroutine cubeedit_close_parse(close,line,user,error)
    !-------------------------------------------------------------------
    ! Parse routine for command CLOSE
    !-------------------------------------------------------------------
    class(close_comm_t), intent(in)    :: close
    character(len=*),    intent(in)    :: line
    type(close_user_t),  intent(out)   :: user
    logical,             intent(inout) :: error
    !
    character(len=*), parameter :: rname='CLOSE>PARSE'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    user%edid = strg_star
    call cubetools_getarg(line,close%comm,1,user%edid,.not.mandatory,error)
    if (error) return
    !
    call close%as%parse(line,user%identifier,error)
    if (error) return
    !
  end subroutine cubeedit_close_parse
  !
  subroutine cubeedit_close_main(close,user,error)
    use cubeedit_cube_buffer
    !-------------------------------------------------------------------
    ! Main routine for command CLOSE
    !-------------------------------------------------------------------
    class(close_comm_t), intent(in)    :: close
    type(close_user_t),  intent(in)    :: user
    logical,             intent(inout) :: error
    !
    character(len=base_l) :: newname
    character(len=*), parameter :: rname='CLOSE>MAIN'
    !
    call cubeedit_message(edseve%trace,rname,'Welcome')
    !
    if (user%identifier%do) then
       newname = user%identifier%identifier
    else
       call cubeedit_bufferlist_get_buffer_name(user%edid,newname,error)
       if (error) return
    endif
    call cubeedit_bufferlist_close(user%edid,newname,error)
    if (error) return
  end subroutine cubeedit_close_main
end module cubeedit_close

subroutine remisajour (nxy,clean,resid,tfbeam,fcomp,   &
     &    wcl,ncl,nx,ny,wfft,   &
     &    np,primary,weight,wtrun)
  use gkernel_interfaces, only : fourt
  use clean_def
  use clean_default
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   CLEAN   Internal routine
  !   Subtract last major cycle components from residual map.
  !----------------------------------------------------------------------
  integer, intent(in) :: nxy      ! Problem size
  integer, intent(in) :: nx,ny    ! Problem size
  integer, intent(in) :: ncl      ! Number of clean components
  integer, intent(in) :: np       ! Number of primary beams
  type(cct_par), intent(in) :: wcl(ncl)   ! Clean component list
  real, intent(in) :: tfbeam(nx,ny,np)    ! TF of dirty beams
  complex, intent(inout) :: fcomp(nx,ny)  ! Work area
  real, intent(inout) :: clean(nx,ny)     ! Clean map
  real, intent(inout) :: resid(nx,ny)     ! Residual map
  real, intent(in) :: primary(np,nx,ny)   ! Primary beams
  real, intent(in) :: weight(nx,ny)       ! Flat field weights
  real, intent(in) :: wtrun               ! Truncation of mosaic
  real, intent(in) :: wfft(*)             ! work fft area
  !
  integer i,j,k,ndim,nn(2),ip
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  if (np.eq.1) then
    fcomp = 0.0
    do k = 1,ncl
      fcomp(wcl(k)%ix,wcl(k)%iy) = cmplx(wcl(k)%value,0.0)
    enddo
    call fourt(fcomp,nn,ndim,-1,0,wfft)
    fcomp = fcomp*tfbeam(:,:,1)
    call fourt(fcomp,nn,ndim,1,1,wfft)
    resid = resid-real(fcomp)
  else
    !
    ! Optimized by using CLEAN to store sum of components before multiplying
    ! by the weights to subtract from the Residuals
    clean = 0.0
    do ip=1,np
      fcomp = 0.0
      do k=1,ncl
        fcomp(wcl(k)%ix,wcl(k)%iy) = wcl(k)%value   &
     &          * primary(ip,wcl(k)%ix,wcl(k)%iy)
      enddo
      call fourt(fcomp,nn,ndim,-1,0,wfft)
      fcomp = fcomp*tfbeam(:,:,ip)
      call fourt(fcomp,nn,ndim,1,1,wfft)
      do j=1,ny
        do i=1,nx
          if (primary(ip,i,j).gt.wtrun) then
            clean(i,j) = clean(i,j) + real(fcomp(i,j))   &
     &              *primary(ip,i,j)
          endif
        enddo
      enddo
    enddo
    resid = resid - clean*weight
  endif
end subroutine remisajour
!
subroutine soustraire (wcl,ncl,        &
     &    dirty,nx,ny,ixbeam,iybeam,   &
     &    ixpatch,iypatch,kcl,gain,    &
     &    nf, primary, weight, wtrun)
  use clean_def
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER  
  !    CLEAN   Internal routine
  ! Subtract the clean component, convolved with dirty beam
  ! restricted to beam patch, from the list of selected points.
  ! Smaller beam patches yield faster speed, but somewhat larger errors and
  ! thus slower convergence.
  !
  ! Caution : points must be ordered according I and J. In the current
  !   IMAGER implementation, this is done by routine "choice"
  ! The code cannot be parallelized, since it uses explicitely the ordering
  ! of the I and J values to stop exploring beyond the beam patch.
  !----------------------------------------------------------------------
  integer, intent(in) :: nf                   ! Number of fields
  integer, intent(in) :: ncl                  ! nombre de points retenus
  integer, intent(in) :: nx,ny,ixbeam,iybeam  ! dimension et centre du beam
  real, intent(in) :: dirty(nx,ny,nf)         ! Dirty Beam
  integer, intent(in) :: ixpatch,iypatch      ! taille du centre BEAM retenu
  type(cct_par), intent(inout) :: wcl(ncl)
  integer, intent(in) :: kcl                  ! No de la composante introduite
  real, intent(in) :: gain                    ! gain de clean
  real, intent(in) :: primary (nf,nx,ny)      ! Primary beams
  real, intent(in) :: weight (nx,ny)          ! Effective weights on sky
  real, intent(in) :: wtrun
  !
  integer, external :: ompget_inner_threads
  logical, external :: ompget_debug_code
  !
  logical condi,condj,cond,go_on     ! pour les boucles de soustraction
  integer no                   ! No du point courrant
  real f                       ! coefficient a retrancher
  integer k,l
  ! dans la carte du beam translatee sur la composante
  integer l0,k0                ! translation * du beam % a la composante
  integer i0,j0, i,j, if, fo, lo, ithread, nthread
  !
  ! Subtract current component
  i0 = wcl(kcl)%ix
  j0 = wcl(kcl)%iy
  k0 = i0 - ixbeam
  l0 = j0 - iybeam
  f = gain * wcl(kcl)%influx
  wcl(kcl)%influx = wcl(kcl)%influx - f      ! This property is always true
  if (nf.gt.1) then
    f = f * weight(i0,j0)      ! Convert to Clean Component
  else
    f = f / dirty(ixbeam,iybeam,1)
  endif
  !
  lo = kcl + 1
  fo = kcl - 1
  go_on = .true.
  ! Subtract from current component to last valid.
  ! Loop CANNOT be parallelized
  do no = lo,ncl
    if (go_on) then
      i = wcl(no)%ix
      j = wcl(no)%iy
      k = i-k0
      l = j-l0
      condi = abs(k-ixbeam) .lt. ixpatch
      condj = abs(l-iybeam) .lt. iypatch
      cond  = condi .or. condj
      if (.not.cond) then
        go_on = .false.
      else
        !
        if ( (condi.and.condj) .and. (k.gt.0 .and. k.le.nx)   &
         &      .and. (l.gt.0 .and. l.le.ny) ) then
          if (nf.gt.1) then
            do if = 1,nf
              if (primary(if,i,j).gt.wtrun) then
                wcl(no)%influx = wcl(no)%influx - f*dirty(k,l,if)   &
         &              *primary(if,i0,j0)*primary(if,i,j)   &
         &              *weight(i,j)
              endif
            enddo
          else
            wcl(no)%influx = wcl(no)%influx - f*dirty(k,l,1)
          endif
        endif
      endif
    endif
  enddo
  !
  go_on = .true.
  ! Now subtract from first valid to current component
  do no = fo,1,-1
    if (go_on) then
      i = wcl(no)%ix
      j = wcl(no)%iy
      k = i-k0
      l = j-l0
      condi = abs(k-ixbeam) .lt. ixpatch
      condj = abs(l-iybeam) .lt. iypatch
      cond  = condi .or. condj
      if (.not.cond) then
        go_on = .false.
      else
        !
        if ( (condi.and.condj) .and. (k.gt.0 .and. k.le.nx)   &
         &      .and. (l.gt.0 .and. l.le.ny) ) then
          if (nf.gt.1) then
            do if = 1,nf
              if (primary(if,i,j).gt.wtrun) then
                wcl(no)%influx = wcl(no)%influx - f*dirty(k,l,if)   &
         &              *primary(if,i0,j0)*primary(if,i,j)   &
         &              *weight(i,j)
              endif
            enddo
          else
            wcl(no)%influx = wcl(no)%influx - f*dirty(k,l,1)
          endif
        endif
      endif
    endif
  enddo
end subroutine soustraire
!
subroutine comshi (beam,nx,ny,ix,iy,shift)
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Shift beam if needed
  !-----------------------------------------------------
  integer, intent(in) :: nx,ny     ! X,Y Size
  integer, intent(in) :: ix,iy     ! Position of maximum
  real, intent(in) :: beam(nx,ny)  ! Beam
  integer, intent(out) :: shift(3) ! Shift information
  !
  real tol
  !
  ! Attempt to find where is the true maximum of the (SYMMETRIC) beam
  ! based on a fit by a parabola in 9 points around maximum
  !
  tol = 1e-4*beam(ix,iy)
  shift(3) = 1
  if (abs(beam(ix-1,iy-1)-beam(ix+1,iy+1)).lt.tol) then
    shift(1) = 0
    shift(2) = 0
    shift(3) = 0
  elseif (abs(beam(ix+1,iy+1)-beam(ix,iy)).lt.tol) then
    shift(1) = 1
    shift(2) = 1
  elseif (abs(beam(ix-1,iy-1)-beam(ix,iy)).lt.tol) then
    shift(1) = -1
    shift(2) = -1
  elseif (abs(beam(ix+1,iy-1)-beam(ix,iy)).lt.tol) then
    shift(1) =  1
    shift(2) = -1
  elseif (abs(beam(ix-1,iy+1)-beam(ix,iy)).lt.tol) then
    shift(1) = -1
    shift(2) = 1
  elseif (abs(beam(ix+1,iy-1)-beam(ix,iy+1)).lt.tol) then
    shift(1) = 1
    shift(2) = 0
  elseif (abs(beam(ix-1,iy-1)-beam(ix,iy+1)).lt.tol) then
    shift(1) = -1
    shift(2) = 0
  elseif (abs(beam(ix-1,iy-1)-beam(ix+1,iy)).lt.tol) then
    shift(1) = 0
    shift(2) = -1
  elseif (abs(beam(ix-1,iy+1)-beam(ix+1,iy)).lt.tol) then
    shift(1) = 0
    shift(2) = 1
  else
    call map_message(seve%w,'SHIFT','Unknown beam symmetry')
    shift(1) = 0
    shift(2) = 0
    shift(3) = 0
  endif
end subroutine comshi
!
subroutine domima(a,rmi,rma,imi,ima,n)
  !----------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Compute minmax and location
  !----------------------------------------------------------
  integer, intent(in) :: n
  integer, intent(out) :: ima,imi
  real, intent(in) ::  a(n)
  real, intent(inout) :: rmi,rma
  !
  integer :: i
  !
  ima = 0
  imi = 0
  if (a(1).gt.rma) then
    rma = a(1)
    ima = 1
  endif
  if (a(1).lt.rmi) then
    rmi = a(1)
    imi = 1
  endif
  do i=2,n
    if (a(i).gt.rma) then
      rma = a(i)
      ima = i
    elseif (a(i).lt.rmi) then
      rmi = a(i)
      imi = i
    endif
  enddo
end subroutine domima
!
subroutine progress_report(action,iv,nv,mv,percentage_step)
  character(len=*), intent(in) :: action ! Action name
  integer, intent(in) :: iv    ! Current index
  integer, intent(in) :: nv    ! Number of values per block
  integer, intent(in) :: mv    ! Total number of values
  integer, intent(in) :: percentage_step ! Frequency of report
  !
  real, save :: next_percentage  ! Next report value
  integer, save :: next          ! Next report index
  integer :: nleft
  integer, save :: last_step     ! Current percentage step
  integer, save :: next_step     ! Next percentage step
  !
  if (iv.eq.1) then
    next_percentage = percentage_step
    next = nint((next_percentage*mv)/100.)
    next_step = percentage_step
    write(*,'(A)',ADVANCE="NO") trim(action)//' % '
  else
    last_step = next_step
    nleft = min(nv,mv-iv+1)
    !! Print *,'Iv ',iv,' Next ',next,' Nleft ',nleft 
    if (iv.lt.next.and.iv+nleft.ge.next) then
      if (last_step.eq.1) then
        if (next_percentage.ge.100.) then
          write(*,'(A)',ADVANCE="NO") ' 100.'
        else
          write(*,'(A)',ADVANCE="NO") '.'
        endif
      else
        write(*,'(F5.0)',ADVANCE="NO") next_percentage
      endif
      if (next_percentage.ge.95) then
        next_step = 1 
      else if (next_percentage.ge.90) then
        next_step = 5
      else
        next_step = percentage_step
      endif
      next_percentage = next_percentage+next_step 
      next = nint((next_percentage*mv)/100.)
    endif
  endif
end subroutine progress_report
!

subroutine uv_fields_comm(line,comm,error)
  use gildas_def
  use image_def
  use gkernel_types
  use gbl_message
  use clean_arrays
  !
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_fields_comm
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGE
  !   Support command for @ fits_to_uvt.ima,
  !   the UVFITS to UV Table conversion script.
  !
  !   UV_FIELDS RaVar DecVar [Unit] [/FILE FileIn FileOut]
  !       [/CENTER Ra Dec]
  !
  !     Replace fields ID by Fields offsets.
  !
  ! For files imported from UVFITS, the Fields offsets are found in 
  !   the AIPS SU Table which is not decoded by the FITS command, 
  !   but only through the DEFINE FITS command.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: comm
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(4), parameter :: rad_to_sec=180.*3600./pi
  integer, parameter :: o_center=1
  integer, parameter :: o_file=2
  character(len=*), parameter :: rname='UV_FIELDS'
  !
  character(len=filename_length) :: uvdata
  character(len=64) :: coff_x, coff_y
  character(len=16) :: chain
  integer :: nf, ier, i, n
  real(kind=8), allocatable :: raoff(:), deoff(:), rapos(:), depos(:)
  real(kind=8), allocatable :: offs(:,:)
  real(kind=4), allocatable :: tmp(:)
  logical :: found
  type(sic_descriptor_t) :: desc_x,desc_y
  !
  type(gildas) :: huvin
  real(kind=8) :: px, py
  character(len=32) :: cx, cy
  character(len=20) :: c20
  character(len=80) :: c80
  integer :: next
  type(projection_t) :: uv_proj
  type(c_ptr) :: cptr
  real(4), pointer :: r1ptr(:)
  real(8), pointer :: d1ptr(:)
  integer(kind=address_length) :: addrx, addry
  !
  ! Code:
  error = .false.
  !
  call sic_ch(line,0,1,coff_x,n,.true.,error)
  if (error) return
  call sic_descriptor(coff_x,desc_x,found)  
  if (.not.found) then
    call map_message(seve%e,rname,'X pointing variable '//trim(coff_x)//' does not exist')
    error = .true.
    return
  endif
  !
  call sic_ch(line,0,2,coff_y,n,.true.,error)
  if (error) return
  call sic_descriptor(coff_y,desc_y,found)  
  if (.not.found) then
    call map_message(seve%e,rname,'Y pointing variable '//trim(coff_y)//' does not exist')
    error = .true.
    return
  endif
  !
  ! Unit is either ABS or Angle Unit (R, D, M, S) - Not fully coded yet...
  if (desc_x%type.gt.0) then
    if (desc_y%type.gt.0) then
      chain = 'ABS'
    else
      call map_message(seve%e,rname,'Invalid mixture of X and Y pointing variable types')
      error = .true.
      return
    endif
  else
    chain = 'RAD'
  endif
  call sic_ke(line,0,3,chain,n,.false.,error)
  chain = chain(1:3)
  !
  if (any(desc_x%dims.ne.desc_y%dims)) then
    call map_message(seve%e,rname,'Pointing variables '//trim(coff_x)// &
      & ' and '// trim(coff_y)//' do not match')
    error = .true.
  else if (desc_x%ndim.ne.1) then
    call map_message(seve%e,rname,'Pointing variables '//trim(coff_x)// &
      & ' and '// trim(coff_y)//' must be of Rank 1')
    error = .true.
  endif
  if (error) return
  !
  nf = desc_x%dims(1)
  !
  allocate (raoff(nf),deoff(nf),offs(2,nf),rapos(nf),depos(nf),tmp(nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! We must read the HEADER for the /FILE stuff, in case there is an angle...
  call gildas_null (huvin, type = 'UVT')     ! Define a UVTable gildas header
  if (sic_present(o_file,0)) then
    call sic_ch(line,o_file,1,uvdata,n,.true.,error)
    if (error) return
    !
    call gdf_read_gildas (huvin, uvdata, '.uvt', error, data=.false.)
    if (error) then
      call map_message(seve%e,rname,'Cannot read input UV header')
      return
    endif
  else
    call gdf_copy_header(huv,huvin,error)
  endif
  !
  ! OK, get the Fields coordinates from the Variable Descriptors
  if (.not.sic_present(o_center,0)) then
    !
    ! no /CENTER option: these are offsets, as specified by user
    call adtoad(desc_x%addr,cptr,1)
    if (desc_x%type.eq.fmt_r4) then
      call c_f_pointer(cptr,r1ptr,[nf])
      raoff(:) = r1ptr
    else if (desc_x%type.eq.fmt_r8) then
      call c_f_pointer(cptr,d1ptr,[nf])
      raoff(:) = d1ptr
    else
      call map_message(seve%e,rname,'Offset Pointing variables must be Real or Double')
      error = .true.
      return
    endif
    !
    call adtoad(desc_y%addr,cptr,1)
    if (desc_x%type.eq.fmt_r4) then
      call c_f_pointer(cptr,r1ptr,[nf])
      deoff(:) = r1ptr
    else if (desc_x%type.eq.fmt_r8) then
      call c_f_pointer(cptr,d1ptr,[nf])
      deoff(:) = d1ptr
    else
      call map_message(seve%e,rname,'Offset Pointing variables must be Real or Double')
      error = .true.
      return
    endif
    !
    ! Scale with appropriate angular unit.
    select case (chain)
    case ('RAD')
      offs(1,:) = raoff
      offs(2,:) = deoff
    case ('DEG')
      offs(1,:) = raoff*pi/180.d0
      offs(2,:) = deoff*pi/180.d0
    case ('MIN')
      offs(1,:) = raoff*pi/180.d0/60.d0
      offs(2,:) = deoff*pi/180.d0/60.d0
    case ('SEC')
      offs(1,:) = raoff*pi/180.d0/3600.d0
      offs(2,:) = deoff*pi/180.d0/3600.d0
    case default
      call map_message(seve%e,rname,'Unknown offset units '//trim(chain))
      error = .true.
      return
    end select     
  else
    ! /CENTER option
    !   These are absolute coordinates, either as Characters
    !   or with the specified unit. 
    !
    ! The pointing center is specified, but the Angle is inherited
    !   from the UV data.
    !
    call sic_ch(line,o_center,1,cx,n,.true.,error)
    if (error) return
    call gwcs_sexa(cx,px,error)
    if (error) return
    px = px*pi/12.d0
    huvin%gil%a0 = px
    !
    call sic_ch(line,o_center,2,cy,n,.true.,error)
    if (error) return
    call gwcs_sexa(cy,py,error)
    if (error) return
    py = py*pi/180.d0
    huvin%gil%d0 = py
    !
    ! Set the Projection
    call gwcs_projec(huvin%gil%a0,huvin%gil%d0,huvin%gil%pang,huvin%gil%ptyp,uv_proj,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Centering Mosaic on R.A. '//trim(cx)//'   Dec. '//cy)
    !      
    if (desc_x%type.le.0 .or. desc_y%type.le.0) then
      !
      ! no ABSOLUTE keyword: these are centers, in the specified unit.
      call adtoad(desc_x%addr,cptr,1)
      if (desc_x%type.eq.fmt_r4) then
        call c_f_pointer(cptr,r1ptr,[nf])
        rapos(:) = r1ptr
      else if (desc_x%type.eq.fmt_r8) then
        call c_f_pointer(cptr,d1ptr,[nf])
        rapos(:) = d1ptr
      else
        call map_message(seve%e,rname,'Pointing variables must be Real or Double')
        error = .true.
        return
      endif
      !
      call adtoad(desc_y%addr,cptr,1)
      if (desc_y%type.eq.fmt_r4) then
        call c_f_pointer(cptr,r1ptr,[nf])
        depos(:) = r1ptr
      else if (desc_y%type.eq.fmt_r8) then
        call c_f_pointer(cptr,d1ptr,[nf])
        depos(:) = d1ptr
      else
        call map_message(seve%e,rname,'Pointing variables must be Real or Double')
        error = .true.
        return
      endif
      !
      select case (chain)
      case ('RAD')
        continue
      case ('DEG')
        rapos = rapos*pi/180.d0
        depos = depos*pi/180.d0
      case ('MIN')
        rapos = rapos*pi/180.d0/60.d0
        depos = depos*pi/180.d0/60.d0
      case ('SEC')
        rapos = rapos*pi/180.d0/60.d0
        depos = depos*pi/180.d0/60.d0
      case default
        call map_message(seve%e,rname,'Unknown pointing units '//trim(chain))
        error = .true.
        return
      end select     
      !
      ! Convert to Offsets
      call abs_to_rel(uv_proj,rapos,depos,raoff,deoff,nf)
      offs(1,:) = raoff
      offs(2,:) = deoff
    else
      ! Character case
      addrx = desc_x%addr
      addry = desc_y%addr
      do i=1,nf
        call destoc(desc_x%type,addrx,cx)
        addrx = addrx + desc_x%type
        call destoc(desc_y%type,addry,cy)
        addry = addry + desc_y%type
        call gwcs_sexa(cx,px,error)
        px = px*pi/12.d0
        call gwcs_sexa(cy,py,error)
        py = py*pi/180.d0
        !
        call abs_to_rel(uv_proj,px,py,offs(1,i),offs(2,i),1)
      enddo
    endif
    !
    ! List the Offsets
    call map_message(seve%i,rname,'Offsets : ')
    next = 1
    do i=1,nf
      write(c20,'(A,F8.2,A,F8.2,A)') "(",offs(1,i)*rad_to_sec,',',offs(2,i)*rad_to_sec,')'
      c80(next:) = c20
      next = next+20
      if (next.ge.80) then
        write(*,'(A)') c80
        next = 1
      endif
    enddo
    if (next.gt.1) write(*,'(A)') c80(1:next-1)
  endif
  !
  if (sic_present(o_file,0)) then
    !
    call sub_file_fields(huvin,nf,offs,error)
    if (error) return
  else
    call sub_memory_fields(huv,duv,nf,offs,error)
    if (error) return
    if (sic_present(o_center,0)) then
      huv%gil%a0 = huvin%gil%a0
      huv%gil%d0 = huvin%gil%d0
      huv%gil%ra = huvin%gil%a0
      huv%gil%dec = huvin%gil%d0
    endif
  endif
end subroutine uv_fields_comm
!
subroutine sub_file_fields (huvin, nf, offs, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for @ fits_to_uvt.map
  !     Replace fields ID by Fields offsets
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: huvin    ! Input Header
  integer, intent(in) :: nf                ! Number of fields
  real(kind=8), intent(in) :: offs(2,nf)   ! Offset values
  logical, intent(out) :: error            ! Error flag
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_FIELDS'
  character(len=80)  :: mess
  integer :: ier, nblock, ib, invisi, iv, ixoff, iyoff, isou, icode
  real :: rsou
  !
  ! Update the proper columns
  if (huvin%gil%column_size(code_uvt_id).ne.0) then
    call map_message(seve%i,rname,'Replacing Field numbers by PHASE offsets')
    ixoff = huvin%gil%column_pointer(code_uvt_id)
    iyoff = ixoff+1
    huvin%gil%column_pointer(code_uvt_loff) = ixoff
    huvin%gil%column_pointer(code_uvt_moff) = iyoff
    huvin%gil%column_size(code_uvt_loff) = 1
    huvin%gil%column_size(code_uvt_moff) = 1
    huvin%gil%column_pointer(code_uvt_id) = 0
    huvin%gil%column_size(code_uvt_id) = 0
    icode = 0
  else if (huvin%gil%column_size(code_uvt_loff).ne.0) then
    ixoff =     huvin%gil%column_pointer(code_uvt_loff)
    iyoff =     huvin%gil%column_pointer(code_uvt_moff)
    call map_message(seve%w,rname,'UV Table is already of type PHASE, checking Field numbers')
    icode = 1
  else if (huvin%gil%column_size(code_uvt_xoff).ne.0) then
    ixoff =     huvin%gil%column_pointer(code_uvt_xoff)
    iyoff =     huvin%gil%column_pointer(code_uvt_yoff)
    call map_message(seve%w,rname,'UV Table is already of type POINT, checking Field numbers')
    icode = -1
  else
    call map_message(seve%e,rname,'UV table is not a mosaic')
    error = .true.
    return
  endif
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,huvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,huvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (huvin%r2d(huvin%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',huvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop over line table by block
  huvin%blc = 0
  huvin%trc = 0
  !
  do ib = 1,huvin%gil%dim(2),nblock
    write(mess,*) ib,' / ',huvin%gil%dim(2),nblock
    call map_message(seve%i,rname,mess)
    huvin%blc(2) = ib
    huvin%trc(2) = min(huvin%gil%dim(2),ib-1+nblock)
    invisi = huvin%trc(2)-huvin%blc(2)+1
    call gdf_read_data(huvin,huvin%r2d,error)
    if (error) return
    !
    if (icode.eq.0) then
      do iv=1,invisi
        isou = huvin%r2D(ixoff,iv)
        if (isou.gt.0 .and. isou.le.nf) then
          huvin%r2d(ixoff,iv) = offs(1,isou)
          huvin%r2d(iyoff,iv) = offs(2,isou)
        else
          write(mess,'(A,I0,A,I0)') 'Invalid source ID ',isou,' for visibility ',iv
          call map_message(seve%w,rname,mess)
        endif
      enddo
    else
      do iv=1,invisi
        isou = huvin%r2D(ixoff,iv)
        rsou = isou
        if (rsou.ne.huvin%r2D(ixoff,iv)) then  
          mess = 'Non integer field number'
          error = .true.
        else if (isou.lt.1 .or. isou.gt.nf) then
          mess = 'Field number out of range'
          error = .true.
        endif
        if (error) then
          call map_message(seve%e,rname,mess)
          error = .true.
          return
        endif
        huvin%r2d(ixoff,iv) = offs(1,isou)
        huvin%r2d(iyoff,iv) = offs(2,isou)
      enddo
    endif
    !
    call gdf_write_data (huvin,huvin%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize the image
  call gdf_update_header(huvin,error)
  if (error) return
  call gdf_close_image(huvin,error)
end subroutine sub_file_fields

subroutine sub_memory_fields (huvin, duv, nf, offs, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for @ fits_to_uvt.map
  !     Replace fields ID by Fields offsets
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huvin     ! Input / Output file UV header
  real, intent(inout) :: duv(:,:)          ! UV data
  integer, intent(in) :: nf                ! Number of fields
  real(kind=8), intent(in) :: offs(2,nf)   ! Offset values
  logical, intent(out) :: error            ! Error flag
  !
  ! Local variables
  character(len=*), parameter :: rname='UV_FIELDS'
  character(len=80)  :: mess
  integer :: iv, ixoff, iyoff, isou, icode
  real :: rsou
  !
  if (huvin%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif  
  !
  ! Update the proper columns
  if (huvin%gil%column_size(code_uvt_id).ne.0) then
    call map_message(seve%i,rname,'Replacing Field numbers by PHASE offsets')
    ixoff = huvin%gil%column_pointer(code_uvt_id)
    iyoff = ixoff+1
    huvin%gil%column_pointer(code_uvt_loff) = ixoff
    huvin%gil%column_pointer(code_uvt_moff) = iyoff
    huvin%gil%column_size(code_uvt_loff) = 1
    huvin%gil%column_size(code_uvt_moff) = 1
    huvin%gil%column_pointer(code_uvt_id) = 0
    huvin%gil%column_size(code_uvt_id) = 0
    icode = 0
  else if (huvin%gil%column_size(code_uvt_loff).ne.0) then
    ixoff =     huvin%gil%column_pointer(code_uvt_loff)
    iyoff =     huvin%gil%column_pointer(code_uvt_moff)
    icode = 1
    call map_message(seve%e,rname,'UV Table is already of type PHASE') 
    error = .true.
  else if (huvin%gil%column_size(code_uvt_xoff).ne.0) then
    ixoff =     huvin%gil%column_pointer(code_uvt_xoff)
    iyoff =     huvin%gil%column_pointer(code_uvt_yoff)
    icode = -1
    call map_message(seve%e,rname,'UV Table is already of type POINT') 
    error = .true.
  else
    call map_message(seve%e,rname,'UV table is not a mosaic')
    error = .true.
  endif
  if (error) return
  !
  if (icode.eq.0) then
    do iv=1,huvin%gil%nvisi
      isou = duv(ixoff,iv)
      if (isou.gt.0 .and. isou.le.nf) then
        duv(ixoff,iv) = offs(1,isou)
        duv(iyoff,iv) = offs(2,isou)
      else
        write(mess,'(A,I0,A,I0)') 'Invalid source ID ',isou,' for visibility ',iv
        call map_message(seve%w,rname,mess)
        error = .true.
        return
      endif
    enddo
  else
    do iv=1,huvin%gil%nvisi
      isou = duv(ixoff,iv)
      rsou = isou
      if (rsou.ne.duv(ixoff,iv)) then  
        mess = 'Non integer field number'
        error = .true.
      else if (isou.lt.1 .or. isou.gt.nf) then
        mess = 'Field number out of range'
        error = .true.
      endif
      if (error) then
        call map_message(seve%e,rname,mess)
        return
      endif
      duv(ixoff,iv) = offs(1,isou)
      duv(iyoff,iv) = offs(2,isou)
    enddo
  endif
end subroutine sub_memory_fields

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! (re)allocation routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_chunk(ndata,chunk,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_interfaces, except_this=>reallocate_chunk
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! (Re)allocate a chunk so that it can describe n channels.
  !-------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: ndata
  type(chunk_t),    intent(inout) :: chunk
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>CHUNK'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ndata.le.0) then
    write(mess,'(A,I0,A)')  'Array size can not be zero nor negative (got ',ndata,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = .true.
  if (chunk%allocated.eq.code_pointer_associated) then
    call mrtcal_message(seve%e,rname,  &
      'Internal error: attempt to allocate an associated pointer')
    error = .true.
    return
  elseif (chunk%allocated.eq.code_pointer_allocated) then
     if (.not.associated(chunk%data1)) then
       ! How come!?!? chunk has code 'allocated' but its pointer is not
       ! associated? Something wrong, need fix.
       call mrtcal_message(seve%e,rname,  &
         'Internal error: CHUNK is expected to be associated but is not')
       error = .true.
       return
     endif
     if (chunk%ndata.eq.ndata) then
        write(mess,'(a,i0)')  &
          'CHUNK arrays already associated at the right size: ',ndata
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        call mrtcal_message(seve%d,rname,  &
          'CHUNKSET arrays already associated but with a different size => Freeing it first')
        call free_chunk(chunk,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(chunk%data1(ndata),chunk%dataw(ndata),stat=ier)
     if (failed_allocate(rname,'CHUNK',ier,error)) then
        call free_chunk(chunk,error)
        return
     endif
     chunk%allocated = code_pointer_allocated
     write(mess,'(a,i0)') 'Allocated CHUNK arrays of size: ',ndata
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  chunk%ndata = ndata
  !
end subroutine reallocate_chunk
!
subroutine reallocate_chunkset(n,chunkset,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_interfaces, except_this=>reallocate_chunkset
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! (Re)allocate a chunkset so that it can store n chunks.
  !
  ! Nothing is done for the chunks in the chunkset. The caller is free
  ! to allocate them or associate them depending on its need.
  !-------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: n
  type(chunkset_t), intent(inout) :: chunkset
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>CHUNKSET'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.le.0) then
    write(mess,'(A,I0,A)')  'Array size can not be zero nor negative (got ',n,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = .true.
  if (chunkset%allocated.eq.code_pointer_associated) then
    call mrtcal_message(seve%e,rname,  &
      'Internal error: attempt to allocate an associated pointer')
    error = .true.
    return
  elseif (chunkset%allocated.eq.code_pointer_allocated) then
     if (.not.associated(chunkset%chunks)) then
       ! How come!?!? chunkset has code 'allocated' but its pointer is not
       ! associated? Something wrong, need fix.
       call mrtcal_message(seve%e,rname,  &
         'Internal error: CHUNKSET is expected to be associated but is not')
       error = .true.
       return
     endif
     if (chunkset%n.eq.n) then
        write(mess,'(a,i0)')  &
          'CHUNKSET already associated at the right size: ',n
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        call mrtcal_message(seve%d,rname,  &
          'CHUNKSET pointer already associated but with a different size => Freeing it first')
        call free_chunkset(chunkset,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(chunkset%chunks(n),stat=ier)
     if (failed_allocate(rname,'CHUNKSET',ier,error)) then
        call free_chunkset(chunkset,error)
        return
     endif
     chunkset%allocated = code_pointer_allocated
     write(mess,'(a,i0)') 'Allocated CHUNKSET of size: ',n
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  chunkset%n = n
  !
end subroutine reallocate_chunkset
!
subroutine reallocate_chunkset_2d(nset,npix,ou2d,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_interfaces, except_this=>reallocate_chunkset_2d
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate a 2D array of chunksets of same dimension as another
  ! 2D array of chunksets
  !
  ! Nothing is done for the chunksets and for the chunks in the
  ! chunksets. The caller is free to allocate them or associate them
  ! depending on its need.
  !-------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: nset
  integer(kind=4),     intent(in)    :: npix
  type(chunkset_2d_t), intent(inout) :: ou2d
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>CHUNKSET>2D'
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Sanity check
  if (nset.lt.0) then
     write(mess,'(a,i0)') 'Chunkset nset is lower than 0: ',nset
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  if (npix.lt.0) then
     write(mess,'(a,i0)') 'Chunkset npix is lower than 0: ',npix
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  ! First the ou2d array
  alloc = nset.gt.0 .and. npix.gt.0
  if (ou2d%allocated.eq.code_pointer_associated) then
    ! Implicit nullification of previous association
    call nullify_chunkset_2d(ou2d,error)
    if (error)  return
  elseif (ou2d%nset.eq.nset .and. ou2d%npix.eq.npix) then
     write(mess,'(a,i0,a,i0)')  &
          'CHUNKSET 2D array already associated at an appropriate size: ',nset,' x ',npix
     call mrtcal_message(seve%d,rname,mess)
     alloc = .false.
  elseif (ou2d%nset.ne.0 .and. ou2d%npix.ne.0) then
     write(mess,'(a)')  &
          'CHUNKSET 2D array already associated but with a different size => Freeing it first'
     call mrtcal_message(seve%d,rname,mess)
     call free_chunkset_2d(ou2d,error)
     if (error)  return
  else
     call mrtcal_message(seve%d,rname,'CHUNKSET 2D first allocation')
  endif
  if (alloc) then
     allocate(ou2d%chunkset(nset,npix),stat=ier)
     if (failed_allocate(rname,'CHUNKSET 2D ARRAY',ier,error)) then
        call free_chunkset_2d(ou2d,error)
        return
     endif
     ou2d%allocated = code_pointer_allocated
     write(mess,'(a,i0,a,i0)')  &
          'Allocated chunkset array of size: ',nset,' x ',npix
     call mrtcal_message(seve%d,rname,mess)
  endif
  ou2d%nset = nset
  ou2d%npix = npix
  !
end subroutine reallocate_chunkset_2d
!
subroutine reallocate_chunkset_3d(nset,npix,ntime,ck3d,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_interfaces, except_this=>reallocate_chunkset_3d
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate a 3D array of chunksets.
  !
  ! Nothing is done for the chunksets and for the chunks in the
  ! chunksets. The caller is free to allocate them or associate them
  ! depending on its need.
  !-------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: nset
  integer(kind=4),     intent(in)    :: npix
  integer(kind=4),     intent(in)    :: ntime
  type(chunkset_3d_t), intent(inout) :: ck3d
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>CHUNKSET>3D'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (nset.lt.0 .or. npix.lt.0 .or. ntime.lt.0) then
    write(mess,'(A,3(I0,A))')  &
      'Array size can not be negative (got ',nset,'x',npix,'x',ntime,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = nset.gt.0 .and. npix.gt.0 .and. ntime.gt.0
  if (associated(ck3d%chunkset)) then
     if (ubound(ck3d%chunkset,1).eq.nset .and.  &  ! Strict equality
         ubound(ck3d%chunkset,2).eq.npix .and.  &  ! Strict equality
         ubound(ck3d%chunkset,3).ge.ntime) then    ! Greater or equal
        write(mess,'(a,i0,a,i0,a,i0)')  &
          'CHUNKSET array already associated at an appropriate size: ',nset,' x ',npix,' x ',ntime
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)')  &
          'CHUNKSET array already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call free_chunkset_3d(ck3d,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
    allocate(ck3d%chunkset(nset,npix,ntime),stat=ier)
    if (failed_allocate(rname,'CHUNKSET ARRAY',ier,error)) then
      call free_chunkset_3d(ck3d,error)
      return
    endif
    write(mess,'(a,i0,a,i0,a,i0)')  &
      'Allocated chunkset array of size: ',nset,' x ',npix,' x ',ntime
    call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ck3d%nset  = nset
  ck3d%npix  = npix
  ck3d%ntime = ntime
  !
end subroutine reallocate_chunkset_3d
!
subroutine reallocate_chopperset(chunkset_2d,chopperset,error)
  use gbl_message
  use gkernel_interfaces
  use chopper_definitions
  use mrtcal_interfaces, except_this=>reallocate_chopperset
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate chopperset with a size deduced from chunkset
  !-------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: chunkset_2d
  type(chopper_t),     pointer       :: chopperset(:,:) ! inout
  logical,             intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  integer(kind=4) :: iset,nset
  integer(kind=4) :: ipix,npix
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>CHOPPERSET'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Sanity checks
  nset = chunkset_2d%nset
  npix = chunkset_2d%npix
  if (nset.lt.0) then
    ! NB: zero-sized arrays are legal Fortran
     write(mess,'(a,i0)') 'NSET size is lower than 0: ',nset
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  if (npix.lt.0) then
    ! NB: zero-sized arrays are legal Fortran
     write(mess,'(a,i0)') 'NPIX size is lower than 0: ',npix
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  ! First the chopperset array
  alloc = .true.
  if (associated(chopperset)) then
     if (ubound(chopperset,1).eq.nset .and. &
         ubound(chopperset,2).eq.npix) then
        write(mess,'(a,i0,a,i0)') 'CHOPPERSET already associated with the appropriate size: ',nset,' x ',npix
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)')  &
          'CHOPPERSET already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call free_chopperset(chopperset,error)
        if (error)  return
     endif
  endif
  if (alloc) then
    allocate(chopperset(nset,npix),stat=ier)
    if (failed_allocate(rname,'CHOPPERSET',ier,error)) then
      call free_chopperset(chopperset,error)
      return
   endif
    write(mess,'(a,i0,a,i0)') 'Allocated CHOPPERSET of size: ',nset,' x ',npix
    call mrtcal_message(seve%d,rname,mess)
  endif
  ! Second the arrays inside each chopperset member
  do ipix=1,npix
     do iset=1,nset
        call telcal_reallocate_chopper(chunkset_2d%chunkset(iset,ipix)%n,chopperset(iset,ipix),error)
        if (error) return
     enddo ! iset
  enddo ! ipix
  !
end subroutine reallocate_chopperset
!
subroutine reallocate_calib_scan(n,calarray,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>reallocate_calib_scan
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate calibration arrays
  !-------------------------------------------------------------------
  integer(kind=4),    intent(in)    :: n
  type(calib_scan_t), intent(inout) :: calarray
  logical,            intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier,iarray
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>CALIB>SCAN'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
     write(mess,'(a,i0,a)') 'Array size can not negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  else if (n.eq.0) then
     write(mess,'(a)') 'Array size is zero'
     call mrtcal_message(seve%d,rname,mess)
     call free_calib_scan(calarray,error)
     if (error)  return
  else
     alloc = .true.
     if (associated(calarray%val)) then
        if (calarray%n.eq.n) then
           write(mess,'(a,i0)')  &
             'Calibration arrays already associated at the right size: ',n
           call mrtcal_message(seve%d,rname,mess)
           alloc = .false.
        else
           write(mess,'(a)') 'Calibration pointers already associated but with a different size => Freeing it first'
           call mrtcal_message(seve%d,rname,mess)
           call free_calib_scan(calarray,error)
           if (error)  return
        endif
     endif
     !
     if (alloc) then
        allocate(calarray%val(n),stat=ier)
        if (failed_allocate(rname,'calibration arrays',ier,error)) then
           call free_calib_scan(calarray,error)
           return
        endif
        ! Also initialize its contents
        do iarray=1,n
          call mrtindex_entry_zheader(calarray%val(iarray)%head,error)
          if (error)  return
        enddo
        write(mess,'(a,i0)') 'Allocated calibration arrays of size: ',n
        call mrtcal_message(seve%d,rname,mess)
     endif
  endif
  !
  ! Allocation success => Initialize
  calarray%n = n
  !
end subroutine reallocate_calib_scan
!
subroutine reallocate_science_scan(n,sciarray,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>reallocate_science_scan
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate science arrays
  !-------------------------------------------------------------------
  integer(kind=4),              intent(in)    :: n
  type(science_scan_t), target, intent(inout) :: sciarray
  logical,                      intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier,iarray
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SCIENCE>SCAN'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
     write(mess,'(a,i0,a)') 'Array size can not negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  else if (n.eq.0) then
     write(mess,'(a)') 'Array size is zero'
     call mrtcal_message(seve%d,rname,mess)
     call free_science_scan(sciarray,error)
     if (error)  return
  else
     alloc = .true.
     if (associated(sciarray%val)) then
        if (sciarray%n.eq.n) then
           write(mess,'(a,i0)')  &
             'Science arrays already associated at the right size: ',n
           call mrtcal_message(seve%d,rname,mess)
           alloc = .false.
        else
           write(mess,'(a)') 'Science pointers already associated but with a different size => Freeing it first'
           call mrtcal_message(seve%d,rname,mess)
           call free_science_scan(sciarray,error)
           if (error)  return
        endif
     endif
     !
     if (alloc) then
        allocate(sciarray%val(n),stat=ier)
        if (failed_allocate(rname,'science arrays',ier,error)) then
           call free_science_scan(sciarray,error)
           return
        endif
        ! Important initialization here!...
        do iarray=1,n
           call mrtindex_entry_zheader(sciarray%val(iarray)%head,error)
           if (error)  return
           sciarray%val(iarray)%off%prev => sciarray%val(iarray)%off%stack(1)
           sciarray%val(iarray)%off%next => sciarray%val(iarray)%off%stack(2)
        enddo ! iarray
        write(mess,'(a,i0)') 'Allocated science arrays of size: ',n
        call mrtcal_message(seve%d,rname,mess)
     endif
  endif
  !
  ! Allocation success => Initialize
  sciarray%n = n
  !
end subroutine reallocate_science_scan
!
subroutine reallocate_backend_list(n,backarray,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_backend_list
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate backend list arrays
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: n
  type(backend_list_t), intent(inout) :: backarray
  logical,              intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>BACKEND>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.lt.0) then
    write(mess,'(a,i0,a)') 'Array size can not be negative (got ',n,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  else if (n.eq.0) then
     write(mess,'(a)') 'Array size is zero'
     call mrtcal_message(seve%d,rname,mess)
     call free_backend_list(backarray,error)
     if (error) return
  else
     alloc = .true.
     if (associated(backarray%backcode)) then
        if (backarray%n.eq.n) then
           write(mess,'(a,i0)')  &
             'Backend list arrays already associated at the right size: ',n
           call mrtcal_message(seve%d,rname,mess)
           alloc = .false.
        else
           write(mess,'(a)') 'Backend list pointers already associated but with a different size => Freeing it first'
           call mrtcal_message(seve%d,rname,mess)
           call free_backend_list(backarray,error)
           if (error)  return
        endif
     endif
     !
     if (alloc) then
        allocate(backarray%backcode(n),backarray%file(n),stat=ier)
        if (failed_allocate(rname,'calibration arrays',ier,error)) then
           call free_backend_list(backarray,error)
           return
        endif
        write(mess,'(a,i0)') 'Allocated backend list arrays of size: ',n
        call mrtcal_message(seve%d,rname,mess)
     endif
  endif
  !
  ! Allocation success => Initialize
  backarray%n = n
  !
end subroutine reallocate_backend_list
!
subroutine reallocate_subscan_list(n,list,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_subscan_list
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate subscan list arrays
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: n
  type(subscan_list_t), intent(inout) :: list
  logical,              intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SUBSCAN>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.le.0) then
     write(mess,'(a,i0,a)') 'Array size can not be zero nor negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  alloc = .true.
  if (associated(list%mjd)) then
     if (list%nsub.eq.n) then
        write(mess,'(a,i0)')  &
             'SUBSCAN LIST arrays already associated at the right size: ',n
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'SUBSCAN LIST pointers already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call free_subscan_list(list,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(list%isub(n),list%mjd(n),list%time(n),list%empty(n),stat=ier)
     if (failed_allocate(rname,'SUBSCAN LIST arrays',ier,error)) then
        call free_subscan_list(list,error)
        return
     endif
     call reallocate_eclass_char(list%scanning,n,error)
     if (error)  return
     call reallocate_eclass_2dble1char(list%onoff,n,error)
     if (error)  return
     write(mess,'(a,i0)') 'Allocated SUBSCAN LIST arrays of size: ',n
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  list%nsub = n
  list%tracked = 0
  list%otf = 0
  list%on  = 0
  list%off = 0
  list%scanning%cnt(:) = 1 ! *** JP This default should be factorized in the reallocate_eclass routines
  list%onoff%cnt(:) = 1 ! *** JP This default should be factorized in the reallocate_eclass routines
  !
end subroutine reallocate_subscan_list
!
subroutine reallocate_switch_desc(noffset,nfront,desc,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_switch_desc
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate switch desc arrays
  !-------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: noffset
  integer(kind=4),     intent(in)    :: nfront
  type(switch_desc_t), intent(inout) :: desc
  logical,             intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SWITCH>DESC'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if ((noffset.le.0).or.(nfront.le.0)) then
     write(mess,'(a,i0,a,i0,a)') 'Array size can not be zero nor negative (got ',noffset,'x',nfront,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  alloc = .true.
  if (associated(desc%off)) then
     if ((desc%noffset.eq.noffset).and.(desc%nfront.eq.nfront)) then
        write(mess,'(a,i0,a,i0)')  &
             'switch desc arrays already associated at the right size: ',noffset,'x',nfront
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'switch desc pointers already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call free_switch_desc(desc,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(desc%off(noffset,nfront),desc%wei(nfront),stat=ier)
     if (failed_allocate(rname,'switch desc arrays',ier,error)) then
        call free_switch_desc(desc,error)
        return
     endif
     write(mess,'(a,i0,a,i0)') 'Allocated switch desc arrays of size: ',noffset,'x',nfront
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  desc%nfront = nfront
  desc%noffset = noffset
  !
end subroutine reallocate_switch_desc
!
subroutine reallocate_switch_on_or_off_index(n,idx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_switch_on_or_off_index
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate switch on or off index arrays
  !-------------------------------------------------------------------
  integer(kind=4),                intent(in)    :: n
  type(switch_on_or_off_index_t), intent(inout) :: idx
  logical,                        intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SWITCH>ON>OR>OFF>INDEX'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (n.le.0) then
     write(mess,'(a,i0,a)') 'Array size can not be zero nor negative (got ',n,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  if (idx%n.eq.n) then
     write(mess,'(a,i0)')  &
          'switch on or off index arrays already associated at the right size: ',n
     call mrtcal_message(seve%d,rname,mess)
     alloc = .false.
  else
     write(mess,'(a)') 'switch on or off index arrays already allocated but with a different size => Freeing it first'
     call mrtcal_message(seve%d,rname,mess)
     call free_switch_on_or_off_index(idx,error)
     if (error)  return
     alloc = .true.
  endif
  !
  if (alloc) then
     allocate(idx%i(n),stat=ier)
     if (failed_allocate(rname,'switch on or off index arrays',ier,error)) then
        return
     endif
     write(mess,'(a,i0)') 'Allocated switch on or off index arrays of size: ',n
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  idx%n = n
  !
end subroutine reallocate_switch_on_or_off_index
!
subroutine reallocate_switch_cycle(ndump,npha,non,noff,nfront,cycle,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>reallocate_switch_cycle
  !-------------------------------------------------------------------
  ! @ private
  ! (re)allocate cycle arrays
  !-------------------------------------------------------------------
  integer(kind=4),      intent(in)    :: ndump
  integer(kind=4),      intent(in)    :: npha
  integer(kind=4),      intent(in)    :: non
  integer(kind=4),      intent(in)    :: noff
  integer(kind=4),      intent(in)    :: nfront
  type(switch_cycle_t), intent(inout) :: cycle
  logical,              intent(inout) :: error
  ! Local
  logical :: alloc
  integer(kind=4) :: ier,ipha
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='REALLOCATE>SWITCH>CYCLE'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (npha.le.0) then
     write(mess,'(a,i0,a)') 'Array size can not be zero nor negative (got ',npha,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  if (npha.lt.ndump) then
     write(mess,'(a,i0,a,i0,a)')  &
       'Number of dumps (',ndump,') in cycle can not be lower than number of phases (',npha,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  if (npha.ne.non+noff) then
     write(mess,'(a,i0,a,i0,a,i0,a)')  &
       'Number of ON (',non,') + OFF (',noff,') in cycle must be equal to the number of phases (',npha,')'
     call mrtcal_message(seve%e,rname,mess)
     error = .true.
     return
  endif
  !
  alloc = .true.
  if (associated(cycle%data)) then
     if (cycle%npha.eq.npha) then
        write(mess,'(a,i0)')  &
             'CYCLE arrays already associated at the right size: ',npha
        call mrtcal_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'CYCLE pointers already associated but with a different size => Freeing it first'
        call mrtcal_message(seve%d,rname,mess)
        call free_switch_cycle(cycle,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(cycle%data(npha),cycle%desc(npha),stat=ier)
     if (failed_allocate(rname,'CYCLE arrays',ier,error)) then
        call free_switch_cycle(cycle,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated CYCLE arrays of size: ',npha
     call mrtcal_message(seve%d,rname,mess)
  endif
  !
  do ipha=1,npha
     call reallocate_switch_desc(npha,nfront,cycle%desc(ipha),error)
     if (error) return
  enddo ! ipha
  call reallocate_switch_on_or_off_index(non,cycle%on,error)
  if (error) return
  call reallocate_switch_on_or_off_index(noff,cycle%off,error)
  if (error) return
  !
  ! Allocation success => Initialize
  cycle%ndump = ndump
  cycle%npha  = npha
  !
end subroutine reallocate_switch_cycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Deallocation routines
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine free_chunk(chunk,error)
  use gbl_message
  use mrtcal_interfaces, except_this => free_chunk
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! Free a chunk
  !-------------------------------------------------------------------
  type(chunk_t), intent(inout) :: chunk
  logical,       intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>CHUNK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (chunk%allocated.eq.code_pointer_associated) then
    call nullify_chunk(chunk,error)
    if (error)  return
    !
  elseif (chunk%allocated.eq.code_pointer_allocated) then
     chunk%ndata = 0
     if (associated(chunk%data1)) deallocate(chunk%data1)
     if (associated(chunk%dataw)) deallocate(chunk%dataw)
     chunk%allocated = code_pointer_null
  endif
  !
  ! Here we should nullify the gen, pos and spe sections *** JP
  !
end subroutine free_chunk
!
subroutine free_chunkset(chunkset,error)
  use gbl_message
  use mrtcal_interfaces, except_this => free_chunkset
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! Free a chunkset
  !-------------------------------------------------------------------
  type(chunkset_t), intent(inout) :: chunkset
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>CHUNKSET'
  integer(kind=4) :: ichunk
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (chunkset%allocated.eq.code_pointer_associated) then
    call nullify_chunkset(chunkset,error)
    if (error)  return
    !
  elseif (chunkset%allocated.eq.code_pointer_allocated) then
    do ichunk=1,ubound(chunkset%chunks,1)
      call free_chunk(chunkset%chunks(ichunk),error)
      ! if (error) continue
    enddo ! ichunk
    chunkset%n = 0
    if (associated(chunkset%chunks))  deallocate(chunkset%chunks)
    chunkset%allocated = code_pointer_null
  endif
  !
end subroutine free_chunkset
!
subroutine free_chunkset_2d(ck2d,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>free_chunkset_2d
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  !  Free a chunkset_2d type:
  !   1) free all the elements in its 2D array of chunksets,
  !   2) free the array itself
  !-------------------------------------------------------------------
  type(chunkset_2d_t), intent(inout) :: ck2d
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>CHUNKSET>2D'
  integer(kind=4) :: i1,i2,ier
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ck2d%allocated.eq.code_pointer_allocated) then
    if (.not.associated(ck2d%chunkset)) then
      ! This is unexpected, since ck2d%allocated tells us the array is in use!
      call mrtcal_message(seve%e,rname,'Chunkset 2D array is not associated!')
      error = .true.
      return
    endif
    !
    do i1=1,ubound(ck2d%chunkset,1)
      do i2=1,ubound(ck2d%chunkset,2)
        call free_chunkset(ck2d%chunkset(i1,i2),error)
        ! if (error)  continue
      enddo
    enddo
    !
    deallocate(ck2d%chunkset,stat=ier)
    if (ier.ne.0) then
      call mrtcal_message(seve%e,rname,'Failed to deallocate ')
      error = .true.
      return
    endif
    !
    ck2d%npix = 0
    ck2d%nset = 0
    ck2d%allocated = code_pointer_null
    !
  elseif (ck2d%allocated.eq.code_pointer_associated) then
    call nullify_chunkset_2d(ck2d,error)
    if (error)  return
    !
  else  ! ck2d%allocated.eq.code_pointer_null
    if (associated(ck2d%chunkset)) then
      ! This is unexpected, since ck2d%allocated tells us the array is NOT in use!
      call mrtcal_message(seve%e,rname,  &
        'Internal error: unexpected association status')
      error = .true.
      return
    endif
    !
  endif
  !
end subroutine free_chunkset_2d
!
subroutine free_chunkset_3d(ck3d,error)
  use gbl_message
  use mrtcal_interfaces, except_this => free_chunkset_3d
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  !  Free a chunkset_3d type:
  !   1) free all the elements in its 3D array of chunksets,
  !   2) free the array itself
  !-------------------------------------------------------------------
  type(chunkset_3d_t), intent(inout) :: ck3d
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>CHUNKSET>3D'
  integer(kind=4) :: i1,i2,i3,ier
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (associated(ck3d%chunkset)) then
    do i1=1,ubound(ck3d%chunkset,1)
      do i2=1,ubound(ck3d%chunkset,2)
        do i3=1,ubound(ck3d%chunkset,3)
          call free_chunkset(ck3d%chunkset(i1,i2,i3),error)
          ! if (error)  continue
        enddo
      enddo
    enddo
    deallocate(ck3d%chunkset,stat=ier)
    if (ier.ne.0) then
      call mrtcal_message(seve%e,rname,'Failed to deallocate ck3d%chunkset')
      error = .true.
      return
    endif
  endif
   !
end subroutine free_chunkset_3d
!
subroutine free_chopperset(chopperset,error)
  use gbl_message
  use chopper_definitions
  use mrtcal_interfaces, except_this => free_chopperset
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  ! Free a 2D array of chopper type
  !-------------------------------------------------------------------
  type(chopper_t), pointer       :: chopperset(:,:)
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>CHOPPERSET'
  integer(kind=4) :: i1,i2
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(chopperset))  return
  ! First the choppersets inside each chopperset member
  do i1=1,ubound(chopperset,1)
     do i2=1,ubound(chopperset,2)
        call telcal_free_chopper(chopperset(i1,i2),error)
        if (error) return
     enddo !i2
  enddo ! i1
  ! Second the chopperset array
  deallocate(chopperset)
  !
end subroutine free_chopperset
!
subroutine free_calib_scan(calarray,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_calib_scan
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(calib_scan_t), intent(inout) :: calarray
  logical,            intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>CALIB>SCAN'
  integer(kind=4) :: iback
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(calarray%val))  return
  !
  ! The array components first
  do iback=1,size(calarray%val)
    call free_calib_backend(calarray%val(iback),error)
    if (error)  continue
  enddo
  !
  ! The array itself
  calarray%n = 0
  deallocate(calarray%val)
  !
end subroutine free_calib_scan
!
subroutine free_calib_backend(backcal,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>free_calib_backend
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(calib_backend_t), intent(inout) :: backcal  !
  logical,               intent(inout) :: error    !
  !
  call mrtindex_entry_fheader(backcal%head,error)
  call free_chunkset_2d(backcal%sky,error)
  call free_chunkset_2d(backcal%hot,error)
  call free_chunkset_2d(backcal%cold,error)
  call free_chunkset_2d(backcal%trec,error)
  call free_chunkset_2d(backcal%tcal,error)
  call free_chunkset_2d(backcal%tsys,error)
  call free_chunkset_2d(backcal%atsys,error)
  call free_chunkset_2d(backcal%water,error)
  call free_chunkset_2d(backcal%ztau,error)
  call free_chunkset_2d(backcal%flag,error)
  call free_chopperset(backcal%chopperset,error)
  call free_chunkset_2d(backcal%grid,error)
  call free_chunkset_2d(backcal%amppha,error)
  call free_chunkset_2d(backcal%sincos,error)
  !
  call imbfits_free_back_chunks(backcal%chunksetlist,error)
  !
  backcal%nset = 0
  backcal%npix = 0
  !
end subroutine free_calib_backend
!
subroutine free_science_scan(sciarray,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_science_scan
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(science_scan_t), intent(inout) :: sciarray
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>SCIENCE>SCAN'
  integer(kind=4) :: iback
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(sciarray%val))  return
  !
  ! The array components first
  do iback=1,size(sciarray%val)
    call free_science_backend(sciarray%val(iback),error)
    if (error)  continue
  enddo
  !
  ! The array itself
  sciarray%n = 0
  deallocate(sciarray%val)
  !
end subroutine free_science_scan
!
subroutine free_science_backend(backsci,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>free_science_backend
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t), intent(inout) :: backsci
  logical,                 intent(inout) :: error
  !
  call mrtindex_entry_fheader(backsci%head,error)
  call free_subscan_list(backsci%list,error)
  call free_switch_cycle(backsci%switch%cycle,error)
  call free_on_stack(backsci%on,error)
  call free_off_stack(backsci%off,error)
  call free_chunkset_3d(backsci%diff,error)
  call free_chunkset_3d(backsci%cumul,error)
  call free_chunkset_2d(backsci%tscale,error)
  call free_chunkset_2d(backsci%expatau,error)
  call free_obs_list(backsci%drift%indiv,error)
  call free_obs_list(backsci%drift%solved,error)
  !
  call imbfits_free_back_chunks(backsci%chunksetlist,error)
  !
end subroutine free_science_backend
!
subroutine free_on_stack(on,error)
  use mrtcal_interfaces, except_this=>free_on_stack
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(on_stack_t), intent(inout) :: on
  logical,          intent(inout) :: error
  !
  call free_chunkset_2d(on%curr,error)
  !
end subroutine free_on_stack
!
subroutine free_off_stack(off,error)
  use mrtcal_interfaces, except_this=>free_off_stack
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(off_stack_t), intent(inout) :: off
  logical,           intent(inout) :: error
  !
  call free_chunkset_2d(off%stack(1),error)
  call free_chunkset_2d(off%stack(2),error)
  call free_chunkset_2d(off%slope,error)
  call free_chunkset_2d(off%offset,error)
  call free_chunkset_2d(off%computed,error)
  !
end subroutine free_off_stack
!
subroutine free_backend_list(backarray,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_backend_list
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(backend_list_t), intent(inout) :: backarray
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>BACKEND>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  backarray%n = 0
  if (associated(backarray%backcode)) deallocate(backarray%backcode)
  if (associated(backarray%file))     deallocate(backarray%file)
  ! Nullification is implicit with deallocate
  !
end subroutine free_backend_list
!
subroutine free_subscan_list(list,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_subscan_list
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(subscan_list_t), intent(inout) :: list
  logical,              intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>SUBSCAN>LIST'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  list%nsub = 0
  if (associated(list%isub))   deallocate(list%isub)
  if (associated(list%time))   deallocate(list%time)
  if (associated(list%mjd))    deallocate(list%mjd)
  if (associated(list%empty))  deallocate(list%empty)
  call free_eclass_2dble1char(list%onoff,error)
  if (error) return
  call free_eclass_char(list%scanning,error)
  if (error) return
  ! Nullification is implicit with deallocate
  !
end subroutine free_subscan_list
!
subroutine free_switch_desc(desc,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_switch_desc
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(switch_desc_t), intent(inout) :: desc
  logical,             intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>SWITCH>DESC'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  desc%nfront = 0
  desc%noffset = 0
  if (associated(desc%wei)) deallocate(desc%wei)
  if (associated(desc%off)) deallocate(desc%off)
  ! Nullification is implicit with deallocate
  !
end subroutine free_switch_desc
!
subroutine free_switch_on_or_off_index(idx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_switch_on_or_off_index
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(switch_on_or_off_index_t), intent(inout) :: idx
  logical,                        intent(inout) :: error
  !
  character(len=*), parameter :: rname='FREE>SWITCH>ON>OR>OFF>INDEX'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  idx%n = 0
  if (allocated(idx%i)) deallocate(idx%i)
  !
end subroutine free_switch_on_or_off_index
!
subroutine free_switch_cycle(cycle,error)
  use gbl_message
  use gkernel_interfaces
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this => free_switch_cycle
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(switch_cycle_t), intent(inout) :: cycle
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>SWITCH>CYCLE'
  integer(kind=4) :: i
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  cycle%npha = 0
  cycle%ndump = 0
  cycle%ndata = 0
  if (associated(cycle%data)) then
    do i=1,size(cycle%data)
      call free_chunkset_2d(cycle%data(i),error)
      if (error)  return
    enddo
    deallocate(cycle%data)
  endif
  !
  if (associated(cycle%desc)) then
    do i=1,size(cycle%desc)
      call free_switch_desc(cycle%desc(i),error)
      if (error)  return
    enddo
    deallocate(cycle%desc)
  endif
  !
  call free_switch_on_or_off_index(cycle%on,error)
  if (error)  return
  call free_switch_on_or_off_index(cycle%off,error)
  if (error)  return
  !
end subroutine free_switch_cycle
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_dble_1d(r8,newndata,keep,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Reallocate a simple 1D REAL*8 pointer
  !---------------------------------------------------------------------
  real(kind=8),    pointer       :: r8(:)     !
  integer(kind=4), intent(in)    :: newndata  !
  logical,         intent(in)    :: keep      !
  logical,         intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>DBLE>1D'
  integer(kind=4) :: oldndata,ier
  real(kind=8), pointer :: tmp(:)
  !
  tmp => null()
  if (associated(r8)) then
    oldndata = size(r8)
    if (oldndata.ge.newndata) then
      ! Enough space, nothing to be done
      return
    endif
    if (keep) then
      allocate(tmp(oldndata),stat=ier)
      if (failed_allocate(rname,'tmp array',ier,error)) then
        error = .true.
        return
      endif
      tmp(:) = r8(:)
    endif
    deallocate(r8,stat=ier)
    if (failed_allocate(rname,'r8 array',ier,error)) then
      error = .true.
      return
    endif
  endif
  !
  allocate(r8(newndata),stat=ier)
  if (failed_allocate(rname,'r8 array',ier,error)) then
    error = .true.
    return
  endif
  if (keep .and. associated(tmp)) then
    r8(1:oldndata) = tmp(1:oldndata)
    deallocate(tmp)
  endif
  !
end subroutine reallocate_dble_1d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine uv_model_comm(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_default
  use clean_arrays
  use imager_interfaces, except_this => uv_model_comm
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !     MODEL [Args] [/MINVAL Value [Unit]] [/OUTPUT]
  !           [/MODE CCT|UV_FIT|IMAGE [Frequency]]
  !
  ! Dispatch to adequate routine as specified by /MODE option to   
  !  - Compute the UV_MODEL data set from the current CCT table
  ! or
  !  - Compute the UV_MODEL data set from the current UV_FIT results
  ! or
  !  - Compute the UV_MODEL data set from the specified IMAGE variable
  !
  !   If no /MODE option is specified, the operation depends on whether 
  ! CLEAN or UV_FIT was executed last.
  !
  !   The /OUTPUT option is dummy, being present only for compatibility
  ! with the UV_RESIDUAL command
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line        ! Command line
  logical, intent(inout) :: error             ! Error flag
  !
  character(len=*), parameter :: rname='MODEL'
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3  
  integer, parameter :: mmode=4
  integer :: imode
  character(len=12) argu,vocs(mmode),cmode
  data vocs/'CCT','COMPONENT','IMAGE','UV_FIT'/ 
  !
  if (sic_present(o_mode,0)) then
    call sic_ke(line,o_mode,1,argu,imode,.true.,error)
    if (error) return
    call sic_ambigs(rname,argu,cmode,imode,vocs,mmode,error)
    if (error) return
  else
    cmode = last_resid ! CCT or UV_FIT
  endif
  call sic_delvariable('UV_MODEL',.false.,error)
  Print *,'CMODE ',cmode
  !
  error = .false.
  !
  uv_model_updated = .true.
  select case (cmode)
  case ('UV_FIT')    
    call uvfit_residual_model(line,'MODEL',1,error)
    return
  case ('CCT','COMPONENT')
    call cct_fast_uvmodel(line,error)
  case default
    !!Print *,'Mode IMAGE '
    call map_fast_uvmodel(line,error)
  end select
  if (error) return
  !
  huvm%loca%size = huvm%gil%dim(1)*huvm%gil%dim(2)
  call sic_mapgildas('UV_MODEL',huvm,error,duvm)
  !
end subroutine uv_model_comm
!<FF>
subroutine map_fast_uvmodel(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use iso_c_binding
  use imager_interfaces, except_this => map_fast_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !     MODEL ImageName [/MINVAL Value [Unit]] /MODE IMAGE [Frequency]
  !
  ! Compute the UV_MODEL data set from the specified image 
  !
  ! Uses an intermediate FFT with further interpolation for 
  !    better speed than UV_CCT
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    ! Command line
  logical, intent(inout) :: error         ! Error flag
  !
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  ! Local
  character(len=filename_length) :: namex
  logical :: large
  type(gildas) :: hmap
  complex, allocatable :: fft(:,:,:)
  real, allocatable :: dmap(:,:,:)
  real, allocatable :: work(:)
  integer :: if,nf,nx,ny,mx,my,nt,nv,mt, ier, nc
  real :: cpu0, cpu1
  real :: factor
  real(8) :: xinc, yinc, area, jyperk
  character(len=8) :: cunit
  real(8) :: freq, vres
  real :: lambda, pixel_area
  logical :: is_image, is_clean, rdonly
  type(c_ptr) :: cptr
  real, pointer :: rptr(:,:,:)
  !
  large = sic_present(0,2) ! Test
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'DUV is not associated') 
    error = .true.
    return
  endif
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input data is the current UV Data  huv & duv
  !
  ! Input MAP is specified as first argument, or defaults to CLEAN
  call gildas_null(hmap)
  if (sic_present(0,1)) then
    call sic_ch(line,0,1,namex,nc,.true.,error)
    if (error) return
    is_clean = .false.
    is_image = .false.    ! Allow SIC variable or GILDAS Data file
    call sub_readhead (rname,namex,hmap,is_image,error,rdonly,fmt_r4)
  else
    ! Use the CLEAN image so far for a test...
    if (hclean%loca%size.eq.0) then
      call map_message(seve%w,rname,'No CLEAN image')
      error = .true.
      return
    endif
    call gdf_copy_header(hclean,hmap,error)
    is_clean = .true.
  endif
  !
  ! There must be some match of the Velocity axis (not the frequency axis)
  ! This match may imply a change of number of channels, i.e.
  ! we should be able to define the intersection of the two velocity
  ! axis.  For the time being, just assume they are identical,
  ! or take the Image axis if the UV data is just 1 channel.
  if (huv%gil%nchan.ne.1) then
    if (hmap%gil%dim(3).ne.huv%gil%nchan) then
      call map_message(seve%w,rname,'Velocity axis mis-match, using UV coverage only')
    endif
  endif
  nf = hmap%gil%dim(3) ! In all cases
  mx = hmap%gil%dim(1)
  my = hmap%gil%dim(2)
  !
  ! Then do the job as in the CCT case, except for the Scale factor...
  allocate (dmap(mx,my,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'MAP Allocation error')
    error = .true.
    return
  endif
  !
  ! We need a copy because we ignore edges
  if (is_clean) then
    !!Print *,'Using CLEAN'
    dmap(:,:,:) = dclean 
  else if (is_image) then
    !!Print *,'Using an IMAGE '
    call adtoad(hmap%loca%addr,cptr,1)
    call c_f_pointer(cptr,rptr,hmap%gil%dim(1:3))
    dmap(:,:,:) = rptr
  else
    !!Print *,'Reading a data file'
    call gdf_read_data(hmap,dmap,error)
    if (error) return
  endif
  !
  ! Define observing frequency
  vres = hmap%gil%vres
  xinc = hmap%gil%inc(1)
  yinc = hmap%gil%inc(2)
  !
  ! Prepare the UV output
  call gildas_null(huvm, type = 'UVT')
  !
  ! Do we want the same frequency  layout as the UV data or that of the MAP? 
  ! The UV data specifies the appropriate UV coverage, 
  ! but the MAP specifies the Spectroscopy by default
  ! Analysis of the /MODE option yields the choice
  call gdf_copy_header(huv,huvm,error) 
  !
  ! Retrieve minimum value and Frequency
  call mod_min_image (line,hmap,huv,freq,dmap,error)
  if (error) return
  !
  ! Avoid edges by default - Do not even bother to check for a mask
  ! or whatever - It is needed to avoid aliasing in any case
  do if=1,nf
    dmap(1:(mx/8),:,if) = 0
    dmap((7*mx)/8:mx,:,if) = 0
    dmap(:,1:(my/8),if) = 0
    dmap(:,(7*my)/8:my,if) = 0
  enddo
  !
  ! Define the image size
  call mod_fft_size(large,mx,my,nx,ny)
  call gag_cpu(cpu1)
  !
  ! Get Virtual Memory & compute the FFT
  allocate (fft(nx,ny,nf),work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT space allocation error')
    error = .true.
    return
  endif
  !
  ! See UV_RESTORE also for this code
  if (nx.eq.mx .and. ny.eq.my) then
    !!Print *,'NX = MX case'
    fft(:,:,:) = cmplx(dmap,0.0)
  else
    do if = 1,nf
      call plunge_real (dmap(:,:,if),mx,my,fft(:,:,if),nx,ny)
    enddo
  endif
  ! Free map - Note that we may use a Pointer for built-in buffers...
  deallocate (dmap,stat=ier)
  !
  ! Compute the FFT
  !!Print *,'NX NY NF ', nx,ny,nf
  call do_fft(nx,ny,nf,fft,work)
  call gag_cpu(cpu1)
  !
  huvm%gil%dim(1) = 7+3*nf
  huvm%gil%ref(1)  = hmap%gil%ref(3)
  huvm%gil%val(1)  = freq
  !
  ! Set the velocity resolution
  huvm%gil%vres = vres
  huvm%gil%fres = -vres*freq/299792.458d0  ! Velocity in km/s
  huvm%gil%inc(1)  = huvm%gil%fres 
  !
  huvm%gil%freq = freq
  huvm%char%line = hmap%char%line 
  huvm%gil%voff = hmap%gil%voff
  !
  ! Set the number of channels
  huvm%gil%nchan = nf
  huvm%gil%convert(:,1) = hmap%gil%convert(:,3)
  !
  ! Unit is according to Image characteristics
  !
  cunit = hmap%char%unit
  call sic_upper(cunit)
  jyperk = 1.0
  if (cunit.eq.'JY/BEAM') then
    ! Get the scale factor of the input data. We want
    ! a model image in K for the rest of the job.
    area = pi*hmap%gil%majo*hmap%gil%mino/4/log(2.0)
    if (area.ne.0) then
      jyperk = 2*1.38e3*area/(299792458d0/freq*1d-6)**2
    else
      call map_message(seve%w,rname,'No beam size, using arbitrary units')
    endif
  else if (cunit.eq.'K') then
    jyperk = 1.0
  endif
  !
  ! Define scaling factor from Brightness to Flux (2 k B^2 / l^2)
  lambda = 299792.458e3/(freq*1e6) ! in meter
  ! 1.38E3 is the Boltzmann constant times 10^26 to give result in Jy
  pixel_area = abs(xinc*yinc)   ! in radian
  factor = 2*1.38e3/lambda**2*pixel_area
  !! print *,'Factor ',factor,pixel_area
  !! if (factor.eq.0.0) factor = 1.0
  !
  factor = factor/jyperk  
  !
  huvm%gil%dim(1) = 7+3*nf
  !
  if (allocated(duvm)) deallocate(duvm)
  allocate (duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
    error = .true.
    return
  endif
  nt = huvm%gil%dim(1)
  nv = huvm%gil%dim(2)
  mt = huv%gil%dim(1)
  !
  ! At this stage, we just copy the DAPs and the weights.
  call copyuv (nt,nv,duvm,mt,duv)
  !
  ! Now compute the model
  call do_uvmodel(duvm, nt, nv, fft,nx,ny,nf,freq,xinc,yinc,factor)
  error = .false.
  call gag_cpu(cpu1)
  !
end subroutine map_fast_uvmodel
!<FF>
subroutine cct_fast_uvmodel(line,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use clean_arrays
  use imager_interfaces, except_this => cct_fast_uvmodel
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for command
  !     MODEL [MaxIter] [/MINVAL Value [Unit]] [/MODE CCT [Frequency]]
  !
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='MODEL'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_minval=1 ! 
  integer, parameter :: o_output=2 ! Must be 2 ...
  integer, parameter :: o_mode=3   
  ! Local
  integer :: nclean ! Number of clean components retained
  logical :: large
  !
  complex, allocatable :: fft(:,:,:)
  real, allocatable :: dmap(:,:,:)
  real, allocatable :: work(:)
  integer :: if,nf,nx,ny,mx,my,nt,nv,mt, ier
  real :: cpu0, cpu1
  real :: factor
  real(8) :: xinc, yinc, freq, vres
  !
  nclean = 0
  call sic_i4(line,0,1,nclean,.false.,error)
  if (error) return
  large = sic_present(0,2) ! Test
  !
  if (.not.associated(duv)) then
    call map_message(seve%e,rname,'DUV is not associated') 
    error = .true.
    return
  endif
  ! Code
  error = .false.
  call gag_cpu(cpu0)
  !
  ! Input data is the current UV Data  huv & duv
  !
  ! Input CCT is the current CCT Data (it should match the UV data)
  !
  ! Compact it into an image
  ! This depends on the CCT type, and is done in a subroutine
  !    First, define the sampling and image size 
  call cct_def_image (hcct,mx,my,nf,xinc,yinc,error)
  if (error) return
  !
  if (nf.ne.1) then
    if (nf.ne.huv%gil%nchan) then
      call map_message(seve%w,rname,'Velocity axis mis-match')
      error = .true.
      return
    endif
  endif
  !
  !    Then do the job
  allocate (dmap(mx,my,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'MAP Allocation error')
    error = .true.
    return
  endif
  call cct_set_image (hcct,dcct,mx,my,nclean,xinc,yinc,nf,dmap,error)
  !
  ! Do we want the same velocity layout as the UV data or that of the MAP? 
  ! The UV data specifies the appropriate UV coverage, 
  ! but the MAP specifies the Spectroscopy 
  call gildas_null(huvm, type = 'UVT')
  call gdf_copy_header(huv,huvm,error) ! Will work in all cases
  !
  ! Retrieve minimum value
  if (hclean%loca%size.ne.0) then
    call mod_min_image (line,hclean,huv,freq,dmap,error)
  else
    call mod_min_image (line,hcct,huv,freq,dmap,error)
  endif
  if (error) return
  !
  ! Define the image size
  call mod_fft_size(large,mx,my,nx,ny)
  call gag_cpu(cpu1)
  !
  ! Get Virtual Memory & compute the FFT
  allocate (fft(nx,ny,nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT space allocation error')
    error = .true.
    return
  endif
  !
  ! See UV_RESTORE also for this code
  if (nx.eq.mx .and. ny.eq.my) then
    fft(:,:,:) = cmplx(dmap,0.0)
  else
    do if = 1,nf
      call plunge_real (dmap(:,:,if),mx,my,fft(:,:,if),nx,ny)
    enddo
  endif
  ! Free map
  deallocate (dmap,stat=ier)
  allocate (work(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT work allocation error')
    error = .true.
    return
  endif
  !
  ! Compute the FFT
  call do_fft(nx,ny,nf,fft,work)
  call gag_cpu(cpu1)
  !
  !
  huvm%gil%dim(1) = 7+3*nf
  huvm%gil%ref(1)  = hcct%gil%ref(hcct%gil%faxi)
  huvm%gil%val(1)  = freq
  !
  ! Set the velocity resolution
  vres = hcct%gil%vres
  huvm%gil%vres = vres
  huvm%gil%fres = -vres*freq/299792.458d0  ! Velocity in km/s
  huvm%gil%inc(1)  = huvm%gil%fres 
  !
  huvm%gil%freq = freq
  huvm%char%line = hcct%char%line 
  huvm%gil%voff = hcct%gil%voff
  !
  ! Set the number of channels
  huvm%gil%nchan = nf
  huvm%gil%convert(:,1) = hcct%gil%convert(:,hcct%gil%faxi)
  ! 
  ! Define scaling factor to Flux: we are in Jy, so this is simple
  factor = 1.0
  !
  if (allocated(duvm)) deallocate(duvm)
  allocate (duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Model allocation error')
    error = .true.
    return
  endif
  nt = huvm%gil%dim(1)
  nv = huvm%gil%dim(2)
  mt = huv%gil%dim(1)
  !
  ! At this stage, copy the DAPs and Weights
  call copyuv (nt,nv,duvm,mt,duv)
  !
  ! Now compute the model
  call do_uvmodel(duvm, nt, nv, fft,nx,ny,nf,freq,xinc,yinc,factor)
  !
  call gag_cpu(cpu1)
  error = .false.
end subroutine cct_fast_uvmodel
!<FF>
subroutine mod_min_image(line,hmap,huv,freq,dmap,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! Support routine for command MODEL
  !   Define output frequency and truncate the data range if needed
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  type(gildas), intent(in) :: hmap      ! Header of input data set
  type(gildas), intent(in) :: huv       ! Header of input UV set
  real(8), intent(inout) :: freq        ! Frequency of output    
  real, intent(inout) :: dmap(:,:,:)    ! Image data
  logical, intent(inout) :: error
  !
  integer, parameter :: o_minval=1
  integer, parameter :: o_mode=3
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='MODEL'
  character(len=12), parameter :: cimage='IMAGE       '
  character(len=12), parameter :: cuv   ='UV_DATA     '
  
  !
  integer :: narg, nc
  real :: fmin, area, jyperk
  character(len=32) :: chain
  !
  ! Override output frequency if needed
  if (sic_present(o_mode,2)) then
    call sic_ke(line,o_mode,2,chain,nc,.true.,error)
    nc = min(nc,12)
    if (chain(1:nc).eq.cimage(1:nc)) then
      freq = hmap%gil%freq+hmap%gil%fres*((hmap%gil%dim(3)+1)*0.5-hmap%gil%ref(3))
    else if (chain(1:nc).eq.cuv(1:nc)) then
      freq = gdf_uv_frequency(huv)
    else
      call sic_r8(line,o_mode,2,freq,.false.,error)
      if (error) return
    endif
  else
    freq = hmap%gil%freq+hmap%gil%fres*((hmap%gil%dim(3)+1)*0.5-hmap%gil%ref(3))
  endif
  !
  narg = sic_narg(o_minval)  ! /MINVAL option
  if (narg.le.0) return
  !
  fmin = 0.
  call sic_r4(line,o_minval,1,fmin,.true.,error)
  if (error) return
  !
  if (narg.gt.1) then
    call sic_ch(line,o_minval,2,chain,nc,.true.,error)
    if (error) return
    if (chain(1:nc).eq.'sigma') then
      fmin = fmin * max(hmap%gil%noise,hmap%gil%rms)
    elseif (chain(1:nc).eq.'mJy') then
      fmin = 1e-3*fmin
    elseif (chain(1:nc).eq.'K') then
      if (hmap%gil%majo.ne.0) then
        area = pi*hmap%gil%majo*hmap%gil%mino/4/log(2.0)
        jyperk = 2*1.38e3*area/(299792458d0/freq*1d-6)**2
        fmin = fmin * jyperk 
      else
        call map_message(seve%e,rname,'Unit K unsupported in this context')
        error = .true.
        return
      endif      
    elseif (chain(1:nc).eq.'Jy') then
      fmin = fmin
    else
      call map_message(seve%e,rname,'Unrecognized unit '//chain(1:nc))
      error = .true.
      return
    endif
  endif
  where (dmap.lt.fmin)  dmap = 0.
end subroutine mod_min_image
!<FF>
subroutine do_uvmodel (visi,nc,nv,a,nx,ny,nf,   &
     &    freq,xinc,yinc,factor)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !
  ! Compute the MODEL UV data set from the current CCT table
  !
  !     Uses an intermediate FFT with further interpolation for
  !     better speed than UV_CCT
  ! CAUTION
  !     Frequency (and hence Lambda/D) is assumed constant 
  !---------------------------------------------------------------------
  !
  integer, intent(in) :: nc                     ! Size of visibility
  integer, intent(in) :: nv                     ! Number of visibilities
  real, intent(inout) :: visi(nc,nv)            ! Visibilities
  integer, intent(in) :: nx                     ! X Size of image
  integer, intent(in) :: ny                     ! Y Size of image
  integer, intent(in) :: nf                     ! Number of frequencies
  complex, intent(in) :: a(nx,ny,nf)            ! Clean Component Image
  real(8), intent(in) :: freq                   ! Reference frequency
  real(8), intent(in) :: xinc                   ! X Pixel increment
  real(8), intent(in) :: yinc                   ! Y Pixel increment
  real, intent(in) :: factor                    ! Flux scale factor
  ! Local
  real(kind=8), parameter :: clight=299792458d0
  real(kind=8) :: kwx,kwy,stepx,stepy,lambda,bfin(2),xr,yr
  complex(kind=8) :: aplus,amoin,azero,afin
  integer :: i,if,ia,ja
  logical :: inside
  equivalence (afin,bfin)
  !
  lambda = clight/(freq*1d6)
  stepx = 1.d0/(nx*xinc)*lambda
  stepy = 1.d0/(ny*yinc)*lambda
  !
  ! Loop on visibility
  do i = 1, nv
    kwx =  visi(1,i) / stepx + dble(nx/2 + 1)
    kwy =  visi(2,i) / stepy + dble(ny/2 + 1)
    ia = int(kwx)
    ja = int(kwy)
    inside = (ia.gt.1 .and. ia.lt.nx) .and.   &
        &      (ja.gt.1 .and. ja.lt.ny)
    if (inside) then
      xr = kwx - ia
      yr = kwy - ja
      do if=1,nf
        !
        ! Interpolate (X or Y first, does not matter in this case)
        aplus = ( (a(ia+1,ja+1,if)+a(ia-1,ja+1,if)   &
            &          - 2.d0*a(ia,ja+1,if) )*xr   &
            &          + a(ia+1,ja+1,if)-a(ia-1,ja+1,if) )*xr*0.5d0   &
            &          + a(ia,ja+1,if)
        azero = ( (a(ia+1,ja,if)+a(ia-1,ja,if)   &
            &          - 2.d0*a(ia,ja,if) )*xr   &
            &          + a(ia+1,ja,if)-a(ia-1,ja,if) )*xr*0.5d0   &
            &          + a(ia,ja,if)
        amoin = ( (a(ia+1,ja-1,if)+a(ia-1,ja-1,if)   &
            &          - 2.d0*a(ia,ja-1,if) )*xr   &
            &          + a(ia+1,ja-1,if)-a(ia-1,ja-1,if) )*xr*0.5d0   &
            &          + a(ia,ja-1,if)
        ! Then Y (or X)
        afin = ( (aplus+amoin-2.d0*azero)   &
            &          *yr + aplus-amoin )*yr*0.5d0 + azero
        !
        visi(5+3*if,i) =  bfin(1)*factor
        ! There was a - sign in the precedent version
        visi(6+3*if,i) =  bfin(2)*factor
      enddo
    else
      print *,'Error Visi ',i,ia,nx,ja,ny
    endif
  enddo
end subroutine do_uvmodel
!<FF>
subroutine do_fft (nx,ny,nf,fft,work)
  integer, intent(in)  :: nx                     !
  integer, intent(in)  :: ny                     !
  integer, intent(in)  :: nf                     !
  complex, intent(inout) :: fft(nx,ny,nf)
  real, intent(inout)  :: work(2*max(nx,ny))
  ! Local
  integer :: if,dim(2)
  !
  ! Loop on channels
  dim(1) = nx
  dim(2) = ny
  do if = 1, nf
    call fourt(fft(:,:,if),dim,2,1,1,work)
    call recent(nx,ny,fft(:,:,if))
  enddo
end subroutine do_fft
!<FF>
subroutine copyuv (nco,nv,out,nci,in)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !
  ! Copy structure of UV data, but not the (Real,Imag) columns
  !---------------------------------------------------------------------
  integer, intent(in)  :: nco                    ! Size of output visi.
  integer, intent(in)  :: nv                     ! Number of visibilities
  real, intent(out)  :: out(nco,nv)              ! Output Visibilities
  integer, intent(in) :: nci                     ! Size of input visi.
  real, intent(in)  :: in(nci,nv)                ! Input visibilities
  ! Local
  integer :: i,j
  !
  ! This does not handle extra columns
  do i=1,nv
    out(1:7,i) = in(1:7,i)
    do j=8,nco,3
      out(j,i) = 0
      out(j+1,i) = 0
      out(j+2,i) = in(10,i)
    enddo
  enddo
end subroutine copyuv
!
subroutine cct_def_image (hima,mx,my,nf,xinc,yinc,error)
  use image_def
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !
  ! Define Image size from CCT information.
  ! Supports both layouts of CCT tables.
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: hima ! Input CCT Table
  integer, intent(out) :: mx,my,nf  ! Ouput data cube size
  real(8), intent(out) :: xinc,yinc ! Pixel size
  logical, intent(out) :: error     ! Error flag
  !
  error = .false.
  if (hima%char%code(3).eq.'COMPONENT') then
    call map_message(seve%i,'UV_FCCT','Clean Components from IMAGER')
    nf = hima%gil%dim(2)  ! Number of channels
    mx = (hima%gil%ref(1)-1)*2
    xinc = hima%gil%inc(1)
    my = (hima%gil%ref(3)-1)*2
    yinc = hima%gil%inc(3)
  else
    call map_message(seve%w,'UV_FCCT','Clean Components from old CLEAN Task')
    nf = hima%gil%dim(3)
    mx = (hima%gil%ref(1)-1)*2
    xinc = hima%gil%inc(1)
    my = (hima%gil%ref(2)-1)*2
    yinc = hima%gil%inc(2)
  endif
end subroutine cct_def_image
!
subroutine cct_set_image (hcct,clean,mx,my,mc,xinc,yinc,nf,image,error)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !
  ! Fill an Image from the list of Clean Components 
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: hcct         ! CCT Table header
  real clean(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  integer, intent(in) :: mx,my,nf       ! Output data cube size
  integer, intent(in) :: mc             ! Max component number
  real(8), intent(in) :: xinc,yinc      ! Pixel size
  real, intent(out) :: image(mx,my,nf)  ! Output data
  logical, intent(out) :: error         ! Error flag
  !
  integer lc,nc,kc
  integer ic,jf
  integer ix,iy
  character(len=80) :: mess
  !
  image = 0
  if (hcct%char%code(3).eq.'COMPONENT') then
    lc = hcct%gil%dim(1)
    nc = hcct%gil%dim(2)  ! Number of channels
    if (nc.ne.nf) then
      write(mess,*) 'Channel mismatch ',nc,nf
      call map_message(seve%e,'MODEL',mess)
      error = .true.
      return
    endif
    if (mc.eq.0) then
      kc = hcct%gil%dim(3)  ! Number of components
    else
      kc = min(mc,hcct%gil%dim(3))
    endif
    !
    do jf = 1,nf
      do ic = 1,kc
        if (clean(3,jf,ic).ne.0) then
          ix = nint(clean(1,jf,ic)/xinc)+mx/2+1
          iy = nint(clean(2,jf,ic)/yinc)+my/2+1
          image(ix,iy,jf) = image(ix,iy,jf) + clean(3,jf,ic)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  else
    lc = hcct%gil%dim(1)
    if (mc.eq.0) then
      kc = hcct%gil%dim(2)  ! Number of components
    else
      kc = min(mc,hcct%gil%dim(2))
    endif
    nc = hcct%gil%dim(3)
    if (nc.ne.nf) then
      write(mess,*) 'Channel mismatch ',nc,nf
      call map_message(seve%e,'MODEL',mess)
      error = .true.
      return
    endif
    do jf = 1,nf
      do ic = 1,kc
        if (clean(1,ic,jf).ne.0) then
          ix = nint(clean(2,ic,jf))
          iy = nint(clean(3,ic,jf))
          image(ix,iy,jf) = image(ix,iy,jf) + clean(1,ic,jf)
        else
          exit ! No more components for this channel
        endif
      enddo
    enddo
  endif
end subroutine cct_set_image
!
subroutine mod_fft_size(large,mx,my,nx,ny)
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Define the intermediate FFT size - Make it square by default
  !---------------------------------------------------------------------
  logical, intent(in) :: large    ! Should size be enlarged ?
  integer, intent(in) :: mx,my    ! Input map size
  integer, intent(out) :: nx,ny   ! Output fft size
  !
  integer :: kxy, mxy
  real :: rxy
  !
  mxy = max(mx,my)
  rxy = log(float(mxy))/log(2.0)
  kxy = nint(rxy)
  if (kxy.lt.rxy) kxy = kxy+1
  nx = 2**kxy
  if (large) nx = max(mxy,min(4*nx,4096))
  ny = nx
end subroutine mod_fft_size

subroutine init_kernel(ker,mk,nk,smooth)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Support for MULTISCALE clean
  !   Initialize a smoothing Kernel by a Gaussian shape
  !-----------------------------------------------------------------------
  integer, intent(in) :: mk            ! Kernel size
  integer, intent(in) :: nk            ! Kernel size
  real(4), intent(inout) :: ker(mk,mk) ! Kernel, centered on (NK+1)/2
  real(4), intent(in) :: smooth
  !
  integer :: i,j
  real :: lk,r,s2,sker
  !
  if (nk.eq.1) then
    ker(1,1) = 1.
    return
  endif
  if (smooth.eq.0) then
    ker = 1.0/(nk*nk)
    return
  endif
  lk = (nk+1.0)/2.0
  s2 = 1.0/smooth**2
  sker = 0.0
  ker = 0.0
  do j=1,nk
    do i=1,nk
      r = (i-lk)**2 + (j-lk)**2
      r = r*s2
      ker(i,j) = exp(-r)
      sker = sker+ker(i,j)
    enddo
  enddo
  sker = 1.0/sker
  ker = ker * sker
  !! Print *,'Kernel ratio ',minval(ker)/maxval(ker)
end subroutine init_kernel
!
subroutine smooth_mask (mask,smask,nx,ny,nk)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Support for MULTISCALE clean
  !   Enlarge a mask using a kernel
  !   Only based on kernel size
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx             !
  integer, intent(in) :: ny             !
  logical, intent(in) :: mask(nx,ny)    ! Input array
  logical, intent(out) :: smask(nx,ny)  ! Smoothed array
  integer, intent(in) :: nk             !
  !
  integer i,j,lk,lj,li
  !
  if (nk.eq.1) then
    smask = mask
  else
    smask = mask
    lk = (nk+1)/2
    do j=lk,ny-lk+1
      do i=lk,nx-lk+1
        if (.not.smask(i,j)) then
          do lj=1,nk
            do li=1,nk
              if (mask(i-li+lk,j-lj+lk)) then
                smask(i,j) = .true.
              endif
            enddo
          enddo
        endif
      enddo
    enddo
  endif
end subroutine smooth_mask
!
subroutine smooth_kernel (beam,sbeam,nx,ny,mk,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Support for MULTISCALE clean
  !   Smooth an array using a kernel
  !
  ! Parallel programming is useful here
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx             !
  integer, intent(in) :: ny             !
  real, intent(in) :: beam(nx,ny)       ! Input array
  real, intent(out) :: sbeam(nx,ny)     ! Smoothed array
  integer, intent(in) :: nk             !
  integer, intent(in) :: mk             !
  real, intent(in) :: ker(mk,mk)        ! Smoothing kernel, centered on (nk+1)/2
  !
  integer, external :: ompget_inner_threads
  ! Local
  integer nthread
  integer i,j,lk,lj,li
  !
  if (nk.eq.1) then
    sbeam = beam
  else
    nthread = ompget_inner_threads()
    sbeam = 0.      ! Mandatory
    lk = (nk+1)/2
    !$OMP PARALLEL PRIVATE(lj,j,li,i) NUM_THREADS(nthread)
    !$OMP DO COLLAPSE(2)
    do j=lk,ny-lk+1
      do i=lk,nx-lk+1
        do lj=1,nk
          do li=1,nk
            sbeam(i,j) = sbeam(i,j)+ker(li,lj)   &
    &              *beam(i-li+lk,j-lj+lk)
          enddo
        enddo
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine smooth_kernel
!
subroutine smooth_masked (nx,ny,sbeam,beam,mask,mk,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Support for MULTISCALE
  !   Smooth an array using a kernel, but only in a mask
  !
  ! Parallel programming is useful here
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx             !
  integer, intent(in) :: ny             !
  real, intent(in) :: beam(nx,ny)       ! Input array
  real, intent(out) :: sbeam(nx,ny)     ! Smoothed array
  logical, intent(in) :: mask(nx,ny)    ! Valid area
  integer, intent(in) :: mk             !
  integer, intent(in) :: nk             !
  real, intent(in) :: ker(mk,mk)        ! Smoothing kernel, centered on (nk+1)/2
  !
  integer, external :: ompget_inner_threads
  !
  ! Local
  integer nthread
  integer i,j,lk,lj,li,ii,jj
  !
  if (nk.eq.1) then
    sbeam = beam
  else
    nthread = ompget_inner_threads()
    sbeam = 0.0  ! Mandatory
    !
    lk = (nk+1)/2
    !$OMP PARALLEL PRIVATE(i,j,lj,jj,li,ii) NUM_THREADS(nthread)
    !$OMP DO COLLAPSE(2)
    do j=lk,ny-lk+1
      do i=lk,nx-lk+1
        if (mask(i,j)) then
          do lj=1,nk
            jj = j-lj+lk
            do li=1,nk
              ii = i-li+lk
              sbeam(i,j) = sbeam(i,j)+ker(li,lj)*beam(ii,jj)
            enddo
          enddo
        endif
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine smooth_masked
!
subroutine add_kernel (clean,nx,ny,value,kx,ky,mk,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER 
  !   Support for MULTISCALE Clean
  !   Spread a value using a Kernel and add it to result
  ! 
  !   Parallel programming does not help here
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx           ! X Image size
  integer, intent(in) :: ny           ! Y Image size
  real, intent(inout) :: clean(nx,ny) ! Summed output array
  real, intent(in) :: value           ! Input value
  integer, intent(in) :: kx           ! X Center of value
  integer, intent(in) :: ky           ! Y Center of value
  integer, intent(in) :: mk           ! Kernel size
  integer, intent(in) :: nk           ! Kernel size
  real, intent(in) :: ker(mk,mk)      ! Smoothing kernel, centered on (nk+1)/2
  !
  integer, external :: ompget_inner_threads
  !
  ! Local
  integer nthread
  integer i,j,lk,li,lj
  !
  if (nk.eq.1) then
    clean(kx,ky) = clean(kx,ky) + value
  else
    nthread = ompget_inner_threads()
    lk = (nk-1)/2
    do j=ky-lk,ky+lk
      lj = j-ky+lk+1
      do i=kx-lk,kx+lk
        li = i-kx+lk+1
        clean(i,j) = clean(i,j) + ker (li,lj) * value
      enddo
    enddo
  endif
end subroutine add_kernel
!
subroutine amaxmask (a,mask,nx,ny,ix,iy)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !     Support for deconvolution
  !     Search the absolute maximum, in a masked region
  !
  ! Parallel programming does not help here.
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx           ! X size
  integer, intent(in) :: ny           ! Y size
  real, intent(in) :: a(nx,ny)        ! Values
  logical, intent(in) :: mask(nx,ny)  ! Mask
  integer, intent(out) :: ix          ! X position of max
  integer, intent(out) :: iy          ! Y position of max
  !
  ! Local
  real rmax
  integer i,j
  !
  rmax = -1.0
  ix = 1
  iy = 1
  do j=1,ny
    do i=1,nx
      if (mask(i,j)) then
        if (abs(a(i,j)).gt.rmax) then
          rmax = abs(a(i,j))
          ix = i
          iy = j
        endif
      endif
    enddo
  enddo  
end subroutine amaxmask
!
subroutine translate (in, nx, ny, trans, ix, iy)
  !-----------------------------------------------------------------------
  ! @ private
  !
  !     Translate the beam to new position IX, IY
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx          ! X size
  integer, intent(in) :: ny          ! Y size
  real, intent(in) :: in(nx,ny)      ! Input beam
  real, intent(out) :: trans(nx,ny)  ! Translated beam
  integer, intent(in) :: ix          ! X shift
  integer, intent(in) :: iy          ! Y shift
  !
  ! Local
  integer i,j
  !
  trans = 0.0  ! That seemed to have been forgotten until 23-Sep-2009
  ! but this was only a side effect, anyway
  !
  do j=max(1,iy+1),min(ny,ny+iy)
    do i=max(1,ix+1),min(nx,nx+ix)
      trans(i,j) = in(i-ix,j-iy)
    enddo
  enddo
end subroutine translate
!
!
subroutine spread_kernel (nx,ny,ip,nc,dcct,value,kx,ky,nk,ker)
  !-----------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER
  !   Support for MULTISCALE Clean
  !   Spread a value using a Kernel and add it to result
  !-----------------------------------------------------------------------
  integer, intent(in) :: nx           ! X Image size
  integer, intent(in) :: ny           ! Y Image size
  integer, intent(in) :: ip           ! Plane number 
  integer, intent(inout) :: nc        ! Number of clean components
  real, intent(out) :: dcct(:,:,:)    ! Expanded Clean Components 
  real, intent(in) :: value           ! Input value
  integer, intent(in) :: kx           ! X Center of value
  integer, intent(in) :: ky           ! Y Center of value
  integer, intent(in) :: nk           ! Actual Kernel size
  real, intent(in) :: ker(:,:)        ! Smoothing kernel, centered on (nk+1)/2
  !
  integer ix,iy,j,li,lj,lk
  !
  j = nc 
  if (nk.eq.1) then
    j = j+1
    dcct(1,ip,j) = kx
    dcct(2,ip,j) = ky
    dcct(3,ip,j) = value 
  else
    lk = (nk-1)/2
    do lj=-lk,lk
      iy = ky+lj
      if (iy.gt.0 .and. iy.le.ny) then
        do li=-lk,lk
          ix = kx+li
          if (ix.gt.0 .and. ix.le.nx) then
            j = j+1
            dcct(1,ip,j) = ix
            dcct(2,ip,j) = iy
            dcct(3,ip,j) = value * ker(li+(nk+1)/2,lj+(nk+1)/2)
          endif
        enddo
      endif
    enddo
  endif
  !
  nc = j
end subroutine spread_kernel

subroutine uv_line2cont(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_line2cont
  use clean_def
  use clean_default
  use clean_types
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  Support routine for command 
  !     UV_CONT [Step] [/RANGE Start End TYPE] /INDEX Alpha [Frequency]
  !
  ! Create a continuum UV table from a Line one
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out) :: error            ! Error flag
  !
  character(len=*), parameter :: rname='UV_CONT'
  integer, parameter :: o_naver=0
  integer, parameter :: o_index=1
  integer, parameter :: o_range=2
  !
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  integer :: nu, nv
  type (gildas) :: hcuv
  integer :: channels(3)
  !
  ! Define the Header
  call sub_uvcont_header(line,error,hcuv,channels,o_naver,o_index,o_range)
  if (error) return
  !
  ! Define the Data
  nu = hcuv%gil%dim(1)
  nv = hcuv%gil%dim(2)
  nullify (duv_previous, duv_next)
  call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
  if (error) return
  !
  hcuv%r2d => duv_next
  huv%r2d => duv_previous
  call sub_uvcont_data(line,hcuv,huv,channels,dchanflag,o_index,error)
  !
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Copy back to UV data set
  call gdf_copy_header(hcuv,huv,error)  
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true.)
end subroutine uv_line2cont
!
subroutine sub_uvcont_header(line,error,hcuv,channels,o_step,o_index,o_range)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uvcont_header
  use clean_def
  use clean_default
  use clean_types
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  Support routine for commands 
  !   UV_CONT [Step] /INDEX Alpha [Frequency] [/RANGE Min Max Type]
  ! and
  !   UV_MAP [Map Center Args] /CONT [Step] /INDEX Alpha [Frequency] [/RANGE Min Max Type]
  !
  ! Create a continuum UV table from the Line one
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out) :: error            ! Error flag
  type (gildas), intent(inout) :: hcuv     ! UV header
  integer, intent(out) :: channels(3)      ! Channels (first, last, step)
  integer, intent(in) :: o_step            ! Location of channel step
  integer, intent(in) :: o_index           ! Location of /INDEX option
  integer, intent(in) :: o_range           ! Location of /RANGE option
  !
  character(len=*), parameter :: rname='UV_CONT'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  integer :: nchan
  character(len=80) :: mess
  real :: uvmax, uvmin
  integer :: msize
  type (uvmap_par) :: map
  !
  real(8) :: drange(2), freq
  character(len=12) :: csort
  integer :: isort, n
  integer :: nc(2)
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort),mysort
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  !
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  if (huv%gil%nstokes.gt.1) then
    call map_message(seve%e,rname,'Only single polarization data supported',1)
    error = .true.
    return
  endif
  !
  channels = 0
  !
  msize = maxval(default_map%size)
  if (msize.eq.0) then
    map = default_map
    freq = gdf_uv_frequency(huv)
    call uvgmax (huv,duv,uvmax,uvmin)
    ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
    uvmax = uvmax*freq*f_to_k
    uvmin = uvmin*freq*f_to_k
    error = .false.
    call map_parameters(rname,map,huv,freq,uvmax,uvmin,error)
    if (error) return
    msize = maxval(map%size)
  endif
  channels = 0
  call t_channel_sampling (rname,huv,channels(3),msize)
  !
  if (sic_present(o_step,1)) then
    call sic_i4(line,o_step,1,channels(3),.false.,error)
  else
    write(mess,'(A,I0,A)') 'Averaging by ',channels(3),' original channels'
    call map_message(seve%i,rname,mess)
  endif
  !
  if (sic_present(o_range,0)) then
    ! Get channel range from /RANGE option
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,n,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs(rname,csort,mysort,isort,types,msort,error)
    if (error)  return    
    ! Define the input range
    call out_range(rname,mysort,drange,nc,huv,error)
    if (error) return
    channels(1:2) = nc
  else
    !
    nchan = huv%gil%nchan
    channels(1) = 1
    channels(2) = nchan
  endif
  !
  call uv_cont_header(rname,huv,hcuv,channels,error)
  !
end subroutine sub_uvcont_header
!
subroutine uv_cont_header(rname,hluv,hcuv,channels,error)
  use gbl_message
  use gkernel_interfaces
  use image_def
  use imager_interfaces, only : map_message
  !-----------------------------------------------------------------------------
  ! @ private
  !   Derive the Continuum UV header from the Line UV header
  !   once the channel range has been specified
  !-----------------------------------------------------------------------------
  character(len=*), intent(in) :: rname ! Caller name
  type(gildas), intent(in) :: hluv      ! Line UV header
  type(gildas), intent(inout) :: hcuv   ! Continuum UV header
  integer, intent(in) :: channels(3)    ! Channel range
  logical, intent(out) :: error
  !
  integer :: i, mc, nchan
  character(len=80) :: mess
  !
  nchan = channels(2)-channels(1)+1
  !
  ! Make sure things remain tractable for "random" Frequency axis...
  if (hluv%gil%nfreq.ne.0 .and. nchan.ne.1) then
    if (channels(3).ne.1) then
      !
      ! Ultimately, one may check here pseudo-linear axes...
      call map_message(seve%e,rname,'UV tables with random Frequency axis ' &
      & //' can only be converted with channel step = 1',1)
      error = .true.
      return
    endif
  endif
  !
  error = .false.
  call gildas_null(hcuv, type = 'UVT')
  call gdf_copy_header(hluv,hcuv,error)
  !
  mc = nchan/channels(3)
  if (mc*channels(3).ne.nchan) mc = mc+1
  write(mess,'(A,I0,A)') 'Generating visibilities for ',mc,' frequencies' 
  call map_message(seve%i,rname,mess)
  hcuv%gil%dim(2) = hluv%gil%dim(2)*mc
  hcuv%gil%dim(1) = 10+hluv%gil%ntrail
  hcuv%gil%nchan = 1
  hcuv%gil%nvisi = hcuv%gil%dim(2)
  hcuv%gil%inc(1) = hluv%gil%inc(1)*mc
  !
  ! The effective bandwidth does not account for blanked channels
  ! in the range
  hcuv%gil%fres = (channels(2)-channels(1)+1)*hcuv%gil%fres
  hcuv%gil%vres = (channels(2)-channels(1)+1)*hcuv%gil%vres
  !
  hcuv%gil%nfreq = 0 ! Reset this
  !
  ! Shift trailing columns to handle Mosaicing
  do i=1,code_uvt_last
    if (hluv%gil%column_pointer(i).gt.hluv%gil%lcol) then
      hcuv%gil%column_pointer(i) = hluv%gil%column_pointer(i)-hluv%gil%lcol+10
    endif
  enddo
  hcuv%gil%lcol = 10
  !
end subroutine uv_cont_header
!
subroutine sub_uvcont_data(line,hcuv,hiuv,channels,chflag,o_index,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uvcont_data
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  !   IMAGER
  !     Transform the Line UV data into a Continuum UV data
  !---------------------------------------------------------------------  
  character(len=*), intent(in) :: line
  type(gildas), intent(inout) :: hcuv
  type(gildas), intent(inout) :: hiuv
  integer, intent(in) :: channels(3)
  integer, intent(in) :: chflag(:)
  integer, intent(in) :: o_index
  logical, intent(inout) :: error
  !
  real :: alpha
  real(8) :: ofreq
  integer :: uvcode=1
  !
  if (sic_present(o_index,0)) then
    call sic_r4(line,o_index,1,alpha,.true.,error)
    if (error) return
    ofreq = 0.D0
    call sic_r8(line,o_index,2,ofreq,.false.,error)
    if (error) return
    call t_continuum(hiuv,hcuv,channels,chflag,uvcode,error,alpha,ofreq)
  else
    call t_continuum(hiuv,hcuv,channels,chflag,uvcode,error)
  endif
  !
end subroutine sub_uvcont_data
!
subroutine opt_filter_base(line,rname,error)
  use gkernel_interfaces
  use uvsplit_mod
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use gbl_message
  use imager_interfaces, except_this => opt_filter_base
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  support routine for
  !   UV_FILTER  /CHANNEL ListVariable [/ZERO]
  !   UV_FILTER  /FREQUENCIES ListFreq /WIDTH Width [UNIT]
  !   UV_FILTER  /VELOCITY ListVelo /WIDTH Width [UNIT]
  !   UV_FILTER  /RANGE Min Max [TYPE]
  !      [/FILE FileIn [FileOut]]
  !
  ! Parse the /FILE option
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  character(len=*), intent(in) :: rname    ! Command name
  logical, intent(out) :: error            ! Error flag
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  type(gildas) :: htmp
  real :: uvmax, uvmin
  real(8) :: freq
  integer :: msize, mc, nchan
  type (uvmap_par) :: map
  integer :: n
  integer :: channels(3)
  logical :: present, err
  !
  !
  if (sic_present(opt_file,0)) then
    call gildas_null(hiuv,type='UVT')
    call gildas_null(houv,type='UVT')
    call sic_ch(line,opt_file,1,in_file,n,.true.,error)
    if (error) return
    call sic_parse_file(in_file,' ','.uvt',hiuv%file)
    !
    ! Strip extension if present
    call sic_parsef(in_file,ou_file,' ','.uvt')
    ou_file = in_file
    !
    ! Line (continuum-Free) UV table
    if (sic_present(2,opt_file)) then
      call sic_ch(line,opt_file,2,ou_file,n,.true.,error)
    else
      ou_file = trim(in_file)//'-line'
    endif
    call sic_parse_file(ou_file,' ','.uvt',houv%file)
    !
    call gdf_read_header(hiuv,error)
    if (error) return
    !
    call gdf_copy_header(hiuv,houv,error)
    !
    call gdf_create_image(houv,error)
    if (error) return
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_IMAGER',hiuv,1)
    use_file = .true.
    !
    ! Continuum (line-Free) UV table
    if (rname.eq.'UV_SPLIT') then
      call gildas_null(hfuv,type='UVT')
      call gdf_copy_header(hiuv,hfuv,error)
      if (sic_present(3,opt_file)) then
        call sic_ch(line,opt_file,3,ou_file,n,.true.,error)
      else
        ou_file = trim(in_file)//'-cont'
      endif
      call sic_parse_file(ou_file,' ','.uvt',hfuv%file)
      !
      ! Define the compression factor
      channels = 0
      ncompr = 1
      !
      msize = maxval(default_map%size)
      present = .false.
      if (msize.eq.0) then
        map = default_map
        if (hfuv%gil%basemax.eq.0) then
          call map_message(seve%w,rname,'No Baseline extrema') 
          present = .true.
        else
          uvmax = hfuv%gil%basemax
          uvmin = hfuv%gil%basemin
          ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
          freq = gdf_uv_frequency(hfuv)
          !! Print *,'UVmax min freq ',uvmax, uvmin, freq
          uvmax = uvmax*freq*f_to_k
          uvmin = uvmin*freq*f_to_k
          error = .false.
          ! This works on HUV only unfortunately - The call sequence
          ! should be changed at some time
          call gildas_null(htmp,type='UVT')
          call gdf_copy_header(huv,htmp,err)
          call gdf_copy_header(hfuv,huv,err)
          call map_parameters(rname,map,huv,freq,uvmax,uvmin,error)
          call gdf_copy_header(htmp,huv,err)
          if (error) return
          msize = maxval(map%size)
        endif
      endif
      call t_channel_sampling (rname,hiuv,channels(3),msize)
      !
      call sic_i4(line,0,2,channels(3),present,error)
      if (error) return
      !
      ! Ignore these for the time being
      !!call sic_i4(line,0,3,channels(1),.false.,error)
      !!call sic_i4(line,0,4,channels(2),.false.,error)
      !
      nchan = hfuv%gil%nchan
      ! Use the <0 convention to start from the end
      if (channels(1).lt.0) then
         channels(1) = max(1,nchan+channels(1))
      else
         channels(1) = min(max(1,channels(1)),nchan)
      endif
      if (channels(2).lt.0) then
         channels(2) = max(channels(1),nchan+channels(2))
      else if (channels(2).eq.0) then
         channels(2) = nchan
      else
         channels(2) = max(channels(1),min(nchan,channels(2)))
      endif
      nchan = channels(2)-channels(1)+1
      !
      ncompr = channels(3)
      mc = nchan/ncompr 
      if (mc*ncompr.ne.nchan) mc = mc+1
      !
      ! Edge of channel 0.5
      ! - before
      !! fmin = (0.5-oldref)*hfuv%gil%inc(1) + hfuv%gil%val(1)
      ! - after
      !! fmin = (0.5-newref)*ncompr*hfuv%gil%inc(1) + huv%gil%val(1)
      ! so
      !  (0.5-newref)*ncompr*hfuv%gil%inc(1) = (0.5-hfuv%gil%ref(1))%hfuv%gil%inc(1)
      !  (0.5-newref)*ncompr = (0.5-oldref)
      ! newref = (oldref-0.5)/ncompr + 0.5
      hfuv%gil%ref(1) = (hfuv%gil%ref(1)-0.5d0)/ncompr + 0.5d0
      hfuv%gil%dim(1) = 7+3*mc+hfuv%gil%ntrail
      hfuv%gil%nchan = mc
      hfuv%gil%inc(1) = hfuv%gil%inc(1)*ncompr
      hfuv%gil%fres = ncompr*hfuv%gil%fres
      hfuv%gil%vres = ncompr*hfuv%gil%vres
      !
      call gdf_create_image(hfuv,error)
      if (error) return
    endif
  else
    call gildas_null(hiuv,type='UVT')
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    if (huv%gil%nstokes.gt.1) then
      call map_message(seve%e,rname,'Only single polarization data supported')
      error = .true.
      return
    endif
    call gdf_copy_header(huv,hiuv,error)
    !
    use_file = .false.
  endif
end subroutine opt_filter_base
!
subroutine uv_split_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : uv_filter_base, opt_filter_base, &
    & map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER support routine for commands
  !   UV_SPLIT [Degree] /CHANNEL ListVariable [/ZERO]
  !   UV_SPLIT [Degree] /FREQUENCIES ListFreq /WIDTH Width
  !   UV_SPLIT [Degree] /VELOCITIES ListVelo /WIDTH Width
  !   UV_SPLIT [Degree] /RANGE Min Max [TYPE]
  !      /FILE FileIn [FileLine [FileCont]
  !
  ! Subtract a continuum baseline, ignoring a list of channels
  ! in UV data set. Create two output UV tables from this:
  !   - a line free one
  !   - a continuum free one
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out) :: error            ! Error flag
  !
  character(len=*), parameter :: rname='UV_SPLIT'
  external :: t_split
  integer :: degree
  !
  degree = 0
  call sic_i4(line,0,1,degree,.false.,error)
  if (error) return
  if (degree.ne.0 .and. degree.ne.1) then
    call map_message(seve%e,rname,'Only degree 0 or 1 supported')
    error = .true.
    return
  endif
  !
  call opt_filter_base(line,rname,error)
  if (error) return
  call uv_filter_base (line,error,rname,t_split,degree)
end subroutine uv_split_comm
!
subroutine uv_baseline(line,error)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : uv_filter_base, opt_filter_base, &
    map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER support routine for commands
  !   UV_BASELINE [Degree] /CHANNEL ListVariable [/ZERO]
  !   UV_BASELINE [Degree] /FREQUENCIES ListFreq /WIDTH Width
  !   UV_BASELINE [Degree] /VELOCITIES ListVelo /WIDTH Width
  !   UV_BASELINE [Degree] /RANGE Min Max [TYPE]
  !      [/FILE FileIn [FileOut]]
  !
  ! Subtract a continuum baseline, ignoring a list of channels
  ! in the current UV data set.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out) :: error            ! Error flag
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  external :: t_baseline
  integer :: degree
  !
  degree = 0
  call sic_i4(line,0,1,degree,.false.,error)
  if (error) return
  if (degree.ne.0 .and. degree.ne.1) then
    call map_message(seve%e,rname,'Only degree 0 or 1 supported')
    error = .true.
    return
  endif
  !
  call opt_filter_base(line,rname,error)
  if (error) return
  call uv_filter_base (line,error,rname,t_baseline,degree)
end subroutine uv_baseline
!
subroutine uv_filter(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : uv_filter_base, map_message
  use gbl_message
  use uvsplit_mod
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  support routine for
  !   UV_FILTER  /CHANNEL ListVariable [/ZERO]
  !   UV_FILTER  /FREQUENCIES ListFreq /WIDTH Width [UNIT]
  !   UV_FILTER  /VELOCITY ListVelo /WIDTH Width [UNIT]
  !   UV_FILTER  /RANGE Min Max [TYPE]
  !      [/FILE FileIn [FileOut]]
  !
  ! "Filter", i.e. flag, a list of channels in the current UV
  ! data set. Flagging is reversible, unless the /ZERO option is
  ! present. With /ZERO, the "filtered" visibilities are set to zero.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out) :: error            ! Error flag
  !
  character(len=*), parameter :: rname='UV_FILTER'
  external :: t_filter
  !
  integer :: zero
  !
  if (sic_present(opt_zero,0)) then
    if (sic_present(opt_reset,0)) then
      call map_message(seve%e,rname,'Incompatible options /ZERO and /RESET')
      error = .true.
      return
    endif
    zero = 0
  else if (sic_present(opt_reset,0)) then
    zero = -1
  else
    zero = 1
  endif
  !
  call opt_filter_base(line,rname,error)
  if (error) return
  call uv_filter_base (line,error,rname,t_filter,zero)
end subroutine uv_filter
!
subroutine t_channel_sampling(rname,huv,nident,msize)
  use image_def
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER
  !   Check how many channels can share the same beam with a user
  !   specified accuracy
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname      ! Caller name
  type(gildas), intent(in) :: huv            ! UV data header
  integer, intent(out) :: nident             ! returned step
  integer, intent(in) :: msize               ! Current map_size
  !
  real :: df, dc, r
  integer :: q
  character(len=80) :: chain
  !
  !
  ! Allow Cell_Precis (default 10 %) pixel difference at map edge
  !
  ! Relative Delta Frequency per channel is
  df = abs(huv%gil%fres/huv%gil%freq)
  !
  ! so scale error at map edge is, in pixel units
  dc = df * msize / 2
  !
  ! so allowed number of channels with same beam is
  nident = max(nint(default_map%precis/dc),1)
  nident = min(nident,huv%gil%nchan)
  !
  write(chain,'(A,I6,A,F10.1)') 'Maximum number of channels '// &
    & 'for same beam ',nident,' Bandwidth ',abs(nident*huv%gil%fres)
  call map_message(seve%i,rname,chain)
  !
  ! With random Frequency axis, use only 1 channel
  if (huv%gil%nfreq.gt.1) nident = 1
  !
  ! Equalize the number of averaged channels to get channels of similar widths. 
  r = real(huv%gil%nchan)/real(nident)
  if (r.lt.10.0) then
    q = int(r)
    if (real(q).ne.r) q = q+1
    nident = int((huv%gil%nchan+q-1.)/real(q))
  endif
  !  
end subroutine t_channel_sampling
!
!
subroutine t_continuum(hluv,hcuv,channels,chflag,uvcode,error,spindex,ofreq)
  use gkernel_interfaces
  use gildas_def
  use image_def
  use uvmap_def
  use gbl_message
  use imager_interfaces, only : map_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !
  ! IMAGER
  !   Support routine for UV_CONTINUUM 
  !
  !   Create a continuum UV table from a Line one
  !---------------------------------------------------------------------
  !
  type (gildas), intent(in) :: hluv       ! Line UV header
  type (gildas), intent(inout) :: hcuv    ! Continuum UV header
  integer, intent(in) :: channels(3)      ! Channel selection
  integer, intent(in) :: chflag(:)        ! Channel Flags
  integer, intent(in) :: uvcode           ! Type of UV data
  logical, intent(out) :: error
  real, intent(in), optional :: spindex   ! Spectral index
  real(8), intent(in), optional :: ofreq  ! Reference Frequency
  !
  character(len=*), parameter :: rname='UV_CONT'
  character(len=80) :: mess
  real(8) :: freq,fval,scale_uv,scale_flux,scale_w
  real, allocatable :: are(:), aim(:), awe(:), adw(:)
  real :: re, im, we, dw, alpha
  integer :: ifi,ila,nv,ic,jc,kc,ier
  integer :: iv,ov,nt,ft
  integer :: othread, nthread, ov_num, env
  real(8), allocatable :: uv_scale(:)
  real(8), parameter :: clight_kms = 299792.458d0   ! [km/s] Light velocity
  !
  error = .false.
  !
  ! Define number of Visibilities and Channels...
  nv = hluv%gil%nvisi
  nt = hluv%gil%ntrail
  ft = hluv%gil%lcol+1
  !
  ov_num =  (channels(2)-channels(1))/channels(3)+1
  !
  allocate(uv_scale(channels(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! The problem is to define the effective "mean" frequency of the observation.  
  !
  !! fval = hluv%gil%val(hluv%gil%faxi)    ! This is not correct... 
  ! For linear sampling this is
  !! fval = fval + ((channels(1)+channels(2))*0.5d0-hluv%gil%ref(hluv%gil%faxi)) * hluv%gil%inc(hluv%gil%faxi)  
  ! or more precisely
  !! fval = gdf_uv_frequency(hluv, dble (channels(1)+channels(2))/2.d0 )
  !
  ! In general, including irregular sampling
  fval = 0d0
  do ic=channels(1),channels(2)
    fval = fval+gdf_uv_frequency(hluv, dble (ic))
  enddo
  fval = fval/dble(channels(2)-channels(1)+1)
  if (present(spindex)) then
    alpha = spindex    
    if (ofreq.ne.0D0) then
      if (abs(fval-ofreq)/fval.gt.0.3) then
        write (mess,'(A,F10.0,A)') 'Specified frequency is too far from mean frequency ',fval,' MHz'
        call map_message(seve%e,rname,mess,3)
        error = .true.
        return
      endif
      fval = ofreq
    endif
  else
    alpha = 0.
  endif
  !
  ! All these assume similar weights for all channels
  !
  do ic=channels(1),channels(2),channels(3)
    freq = gdf_uv_frequency(hluv, dble (2*ic+channels(3)-1)/2.d0 )
    !
    ! The angular scale goes as Lambda/B, i.e. 1/(B nu)
    ! so to preserve a constant angular scale, the "apparent"
    ! B must scale as \nu
    !
    ! so
    uv_scale(ic) = freq/fval ! This is the right formula...
    scale_uv = uv_scale(ic)
    !!Print *,'Scale UV ',ic, (ic+channels(3))/2.0, scale_uv, fval, freq
  enddo
  !  
  if (alpha.ne.0.) then
    !
    ! Spectral index code
    if (uvcode.eq.code_uvt) then  ! UVT order
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv, ov_num, uv_scale, hluv, hcuv, channels) &
      !$OMP   & SHARED(chflag, alpha, nt, ft) &
      !$OMP   & PRIVATE(iv,ov,fval,ic,freq,re,im,we,kc,jc,dw) &
      !$OMP   & PRIVATE(scale_uv,scale_flux,scale_w)
      !
      !$OMP DO
      do iv=1,nv
        ov = (iv-1)*ov_num+1
        !
        ! Fill in, channel after channel
        do ic=channels(1),channels(2),channels(3)
          scale_uv = uv_scale(ic)
          scale_flux = scale_uv**(-alpha)
          scale_w = scale_uv**(2*alpha)
          !
          hcuv%r2d(1:3,ov) = hluv%r2d(1:3,iv)*scale_uv
          hcuv%r2d(4:7,ov) = hluv%r2d(4:7,iv)
          !
          ! Compact the channels first
          if (channels(3).gt.1) then
            re = 0
            im = 0
            we = 0
            kc = 5+3*ic
            do jc = ic,min(ic+channels(3)-1,channels(2))
              if (chflag(jc).eq.1) then
                ! Here we use the Channel mask defined by UV_FILTER in addition
                ! to any previous flag.   UV_FILTER /RESET would then work in all cases
                dw = max(0.,hluv%r2d(kc+2,iv))
                !
                re = re + hluv%r2d(kc,iv)*dw
                kc = kc+1
                im = im + hluv%r2d(kc,iv)*dw
                we = we+dw
                kc = kc+2
              else
                kc = kc+3   ! Skip channel
              endif
            enddo
            if (we.ne.0.0) then
              re = re/we
              im = im/we
            end if
            hcuv%r2d(8,ov) = re*scale_flux
            hcuv%r2d(9,ov) = im*scale_flux
            hcuv%r2d(10,ov) = we
          else
            if (chflag(ic).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              hcuv%r2d(8:9,ov)  = hluv%r2d(5+3*ic:6+3*ic,iv)*scale_flux
              hcuv%r2d(10,ov)  = hluv%r2d(7+3*ic,iv)*scale_w
            else
              hcuv%r2d(8:10,ov) = 0.0
            endif
          endif
          if (nt.gt.0) then
            hcuv%r2d(11:,ov) = hluv%r2d(ft:,iv)
          endif
          ov = ov+1
        enddo
        if (ov.ne.iv*ov_num+1) print *,'Programming error ',iv,ov,ov_num
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !
    else if (uvcode.eq.code_tuv) then ! TUV order
      !
      Print *,'TUV order '
      if (channels(3).gt.1) then
        env = nv  ! Work arrays per visibility
      else
        env = 1   ! Dummies
      endif
      allocate (are(env),aim(env),awe(env),adw(env),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Channels allocation error')
        error = .true.
        return
      endif
      !
      ! Fill in, channel after channel
      othread = 1
      nthread = 1
      !$ othread = omp_get_max_threads()
      !$ nthread = min(othread,ov_num)
      !$ call omp_set_num_threads(nthread)
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv,uv_scale,hluv,hcuv,channels,alpha,nt,ft,chflag) &
      !$OMP   & PRIVATE(ic,ifi,ila,freq) &
      !$OMP   & PRIVATE(are,aim,awe,jc,adw) &
      !$OMP   & PRIVATE(scale_uv,scale_flux,scale_w)
      !
      !$OMP DO
      do ic=channels(1),channels(2),channels(3)
        ifi = (ic-1)*nv+1
        ila = ifi+nv-1
        scale_uv = uv_scale(ic)
        scale_flux = scale_uv**(-alpha)
        scale_w = scale_uv**(2*alpha)
        !
        hcuv%r2d(ifi:ila,1:3) = hluv%r2d(1:nv,1:3)*scale_uv
        hcuv%r2d(ifi:ila,4:7) = hluv%r2d(1:nv,4:7)
        !
        ! Compact the channels first
        if (channels(3).gt.1) then
          are = 0
          aim = 0
          awe = 0
          do jc = ic,min(ic+channels(3)-1,channels(2))
            if (chflag(jc).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              adw(:) = max(0.,hluv%r2d(1:nv,7+3*jc))
              are(:) = are + hluv%r2d(1:nv,5+3*jc)*adw
              aim(:) = aim + hluv%r2d(1:nv,6+3*jc)*adw
              awe(:) = awe+adw
            endif
          enddo
          where (awe.ne.0.)
            are(:) = are/awe
            aim(:) = aim/awe
          end where
          hcuv%r2d(ifi:ila,8) = are*scale_flux
          hcuv%r2d(ifi:ila,9) = aim*scale_flux
          hcuv%r2d(ifi:ila,10) = awe*scale_w
        else
          if (chflag(ic).eq.1) then
            hcuv%r2d(ifi:ila,8:9) = hluv%r2d(1:nv,5+3*ic:6+3*ic)*scale_flux
            ! Here we use the Channel mask defined by UV_FILTER in addition
            ! to any previous flag.   UV_FILTER /RESET would then work in all cases
            hcuv%r2d(ifi:ila,10) = hluv%r2d(1:nv,7+3*ic)*scale_w
          else
            hcuv%r2d(ifi:ila,8:10) = 0.
          endif
        endif
        if (nt.gt.0) then
          hcuv%r2d(ifi:ila,11:) = hluv%r2d(1:nv,ft:)
        endif
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !$ call omp_set_num_threads(othread)
      deallocate (are,aim,awe,stat=ier)
    endif
    !
  else
    ! Simple code with no spectral index
    if (uvcode.eq.code_uvt) then  ! UVT order
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv, ov_num, uv_scale, hluv, hcuv, channels, nt, ft, chflag) &
      !$OMP   & PRIVATE(iv,ov,fval,ic,freq,scale_uv,re,im,we,kc,jc,dw)
      !
      !$OMP DO
      do iv=1,nv
        ov = (iv-1)*ov_num+1
        !
        ! Fill in, channel after channel
        do ic=channels(1),channels(2),channels(3)
          scale_uv = uv_scale(ic)
          !
          hcuv%r2d(1:3,ov) = hluv%r2d(1:3,iv)*scale_uv
          hcuv%r2d(4:7,ov) = hluv%r2d(4:7,iv)
          !
          ! Compact the channels first
          if (channels(3).gt.1) then
            re = 0
            im = 0
            we = 0
            kc = 5+3*ic
            do jc = ic,min(ic+channels(3)-1,channels(2))
              if (chflag(jc).eq.1) then
                ! Here we use the Channel mask defined by UV_FILTER in addition
                ! to any previous flag.   UV_FILTER /RESET would then work in all cases
                dw = max(0.,hluv%r2d(kc+2,iv))
                re = re + hluv%r2d(kc,iv)*dw
                kc = kc+1
                im = im + hluv%r2d(kc,iv)*dw
                we = we+dw
                kc = kc+2
              else
                kc = kc+3
              endif
            enddo
            if (we.ne.0.0) then
              re = re/we
              im = im/we
            end if
            hcuv%r2d(8,ov) = re
            hcuv%r2d(9,ov) = im
            hcuv%r2d(10,ov) = we
          else
            if (chflag(ic).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              hcuv%r2d(8:10,ov)  = hluv%r2d(5+3*ic:7+3*ic,iv)
            else
              hcuv%r2d(8:10,ov)  = 0.
            endif            
          endif
          if (nt.gt.0) then
            hcuv%r2d(11:,ov) = hluv%r2d(ft:,iv)
          endif
          ov = ov+1
        enddo
        if (ov.ne.iv*ov_num+1) print *,'Programming error ',iv,ov,ov_num
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !
    else if (uvcode.eq.code_tuv) then ! TUV order
      Print *,'TUV order '
      if (channels(3).gt.1) then
        env = nv
      else 
        env = 1
      endif
      allocate (are(env),aim(env),awe(env),adw(env),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Channels allocation error')
        error = .true.
        return
      endif
      !
      ! Fill in, channel after channel
      othread = 1
      nthread = 1
      !$ othread = omp_get_max_threads()
      !$ nthread = min(othread,ov_num)
      !$ call omp_set_num_threads(nthread)
      !
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP   & SHARED(nv,uv_scale,hluv,hcuv,channels,nt,ft,chflag) &
      !$OMP   & PRIVATE(ic,ifi,ila,freq,scale_uv) &
      !$OMP   & PRIVATE(are,aim,awe,jc,adw)
      !
      !$OMP DO
      do ic=channels(1),channels(2),channels(3)
        ifi = (ic-1)*nv+1
        ila = ifi+nv-1
        scale_uv = uv_scale(ic)
        !
        hcuv%r2d(ifi:ila,1:3) = hluv%r2d(1:nv,1:3)*scale_uv
        hcuv%r2d(ifi:ila,4:7) = hluv%r2d(1:nv,4:7)
        !
        ! Compact the channels first
        if (channels(3).gt.1) then
          are = 0
          aim = 0
          awe = 0
          do jc = ic,min(ic+channels(3)-1,channels(2))
            if (chflag(jc).eq.1) then
              ! Here we use the Channel mask defined by UV_FILTER in addition
              ! to any previous flag.   UV_FILTER /RESET would then work in all cases
              adw(:) = max(0.,hluv%r2d(1:nv,7+3*jc))
              are(:) = are + hluv%r2d(1:nv,5+3*jc)*adw
              aim(:) = aim + hluv%r2d(1:nv,6+3*jc)*adw
              awe(:) = awe+adw
            endif
          enddo
          where (awe.ne.0.)
            are(:) = are/awe
            aim(:) = aim/awe
          end where
          hcuv%r2d(ifi:ila,8) = are
          hcuv%r2d(ifi:ila,9) = aim
          hcuv%r2d(ifi:ila,10) = awe
        else
          if (chflag(ic).eq.1) then
            ! Here we use the Channel mask defined by UV_FILTER in addition
            ! to any previous flag.   UV_FILTER /RESET would then work in all cases
            hcuv%r2d(ifi:ila,8:10) = hluv%r2d(1:nv,5+3*ic:7+3*ic)
          else
            hcuv%r2d(ifi:ila,8:10) = 0.
          endif
        endif
        if (nt.gt.0) then
          hcuv%r2d(ifi:ila,11:) = hluv%r2d(1:nv,ft:)
        endif
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      !$ call omp_set_num_threads(othread)
      deallocate (are,aim,awe,stat=ier)
    endif
    !
  endif
  !
  ! FVAL should be the new Rest Frequency
  fval = fval / (1.d0 + hcuv%gil%dopp - hcuv%gil%voff/clight_kms)
  call gdf_modify(hcuv,hcuv%gil%voff,fval,error=error)
  hcuv%gil%ref(1) = 1.D0 
  !
end subroutine t_continuum
!
subroutine uv_filter_base(line,error,rname,t_routine,zero)
  use gkernel_interfaces
  use gildas_def
  use gkernel_types
  use gbl_format
  use clean_types
  use clean_arrays
  use uvsplit_mod
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER  support for
  !   UV_FILTER or UV_BASELINE  /CHANNEL ListVariable [/ZERO]
  !   UV_FILTER or UV_BASELINE  /FREQUENCIES ListFreq /WIDTH Width [UNIT]
  !   UV_FILTER or UV_BASELINE  /VELOCITY ListVelo /WIDTH Width [UNIT]
  !   UV_FILTER or UV_BASELINE  /RANGE Min Max [TYPE]
  !      [/FILE FileIn [FileOut]]
  !
  ! "Filter", i.e. flag, a list of channels in the current UV
  ! data set. Flagging is reversible, using the /RESET option
  ! With /ZERO, the "filtered" visibilities are set to zero.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out) :: error            ! Error flag
  external :: t_routine
  character(len=*), intent(in) :: rname
  integer, intent(in) :: zero
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  real(8) :: drange(2)
  integer :: nn, nc(2)
  character(len=64) :: listname
  logical :: found
  type(sic_descriptor_t) :: desc
  integer :: nf, k, i, j, l, m, ichan, jchan, narg, ier
  real(8) :: freq, velo
  real(4) :: width
  type(c_ptr) :: cptr
  integer, pointer :: channels(:)
  integer :: na, nstyle
  integer, parameter :: mstyle=3
  character(len=12) :: vstyle(mstyle), astyle, argu
  data vstyle/'CHANNEL','FREQUENCY','VELOCITY'/
  !
  !
  if (sic_present(opt_chan,0)) then
    narg = sic_narg(opt_chan)
    if (narg.gt.0) then
      call sic_ke(line,opt_chan,1,listname,na,.true.,error)
    else
      listname = 'PREVIEW%CHANNELS'
      na = len_trim(listname)
    endif
    !
    call sic_ch(line,opt_chan,1,listname,na,.false.,error)
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
      desc%ndim = 1
      desc%dims(1) = 1
      desc%addr = locwrd(ichan)
      desc%type = fmt_i4
      if (narg.eq.0) then
        ichan = 0 
      else
        call sic_i4(line,opt_chan,1,ichan,.true.,error)
        if (error) then
          call map_message(seve%e,rname,'Variable '//trim(listname)//' does not exists')
          error = .true.
          return
        endif
      endif
    endif
    if (desc%type.ne.fmt_i4) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
      error = .true.
      return
    endif
    if (desc%ndim.ne.1) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
      error = .true.
      return
    endif
    call adtoad(desc%addr,cptr,1)
    nf = desc%dims(1)
    call c_f_pointer(cptr,channels,desc%dims(1:1))
    call t_routine (nf,channels,zero,error)
    !
  else if (sic_present(opt_freq,0)) then
    width = abs(hiuv%gil%fres)  ! In MHz
    call sic_r4(line,opt_width,1,width,.false.,error)
    if (sic_present(opt_width,2)) then
      call sic_ke(line,opt_width,2,argu,na,.true.,error)
      call sic_ambigs (rname,argu,astyle,nstyle,vstyle,mstyle,error)
      select case(astyle)
        case ('CHANNEL')
          width = width*abs(hiuv%gil%fres)
        case ('VELOCITY')
          width = width*abs(hiuv%gil%fres/hiuv%gil%vres)
      end select
    endif
    width = 0.5*width
    !
    narg = sic_narg(opt_freq)
    allocate(channels(hiuv%gil%nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Channels allocation error')
      error = .true.
      return
    endif
    k = 0
    !
    do i=1,narg
      call sic_r8(line,opt_freq,i,freq,.true.,error)
      if (error) return
      if (hiuv%gil%fres.gt.0) then
        ichan = (freq-hiuv%gil%freq-width)/hiuv%gil%fres + hiuv%gil%ref(1)
        jchan = (freq-hiuv%gil%freq+width)/hiuv%gil%fres + hiuv%gil%ref(1)
      else
        ichan = (freq-hiuv%gil%freq+width)/hiuv%gil%fres + hiuv%gil%ref(1)
        jchan = (freq-hiuv%gil%freq-width)/hiuv%gil%fres + hiuv%gil%ref(1)
      endif
      !
      ! Set channels only once...
      do j=ichan,jchan
        if (j.lt.0 .or. j.gt.hiuv%gil%nchan) then
          cycle
        else
          m = 0
          do l=1,k
            if (channels(l).eq.j) then
              m = l
              exit
            endif
          enddo
          if (m.eq.0) then
            k = k+1
            channels(k) = j
          endif
        endif
      enddo
    enddo
    call t_routine(k,channels,zero,error)
    deallocate(channels)
    !
  else if (sic_present(opt_velo,0)) then
    width = abs(hiuv%gil%vres)  ! In km/s
    call sic_r4(line,opt_width,1,width,.false.,error)
    if (sic_present(opt_width,2)) then
      call sic_ke(line,opt_width,2,argu,na,.true.,error)
      call sic_ambigs (rname,argu,astyle,nstyle,vstyle,mstyle,error)
      select case(astyle)
        case ('CHANNEL')
          width = width*abs(hiuv%gil%vres)
        case ('FREQUENCY')
          width = width*abs(hiuv%gil%vres/hiuv%gil%fres)
      end select
    endif
    width = 0.5*width
    !
    narg = sic_narg(opt_velo)
    allocate(channels(hiuv%gil%nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Channels allocation error')
      error = .true.
      return
    endif
    k = 0
    !
    do i=1,narg
      call sic_r8(line,opt_velo,i,velo,.true.,error)
      if (error) return
      if (hiuv%gil%vres.gt.0) then
        ichan = (velo-hiuv%gil%voff-width)/hiuv%gil%vres + hiuv%gil%ref(1)
        jchan = (velo-hiuv%gil%voff+width)/hiuv%gil%vres + hiuv%gil%ref(1)
      else
        ichan = (velo-hiuv%gil%voff+width)/hiuv%gil%vres + hiuv%gil%ref(1)
        jchan = (velo-hiuv%gil%voff-width)/hiuv%gil%vres + hiuv%gil%ref(1)
      endif
      !
      ! Set channels only once...
      do j=ichan,jchan
        if (j.lt.0 .or. j.gt.hiuv%gil%nchan) then
          cycle
        else
          m = 0
          do l=1,k
            if (channels(l).eq.j) then
              m = l
              exit
            endif
          enddo
          if (m.eq.0) then
            k = k+1
            channels(k) = j
          endif
        endif
      enddo
    enddo
    call t_routine(k,channels,zero,error)
    deallocate(channels)
    !
  else if (sic_present(opt_range,0)) then
    call sic_r8 (line,opt_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,opt_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,opt_range,3,argu,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs (rname,argu,astyle,nstyle,vstyle,mstyle,error)
    if (error)  return
    call out_range(rname,astyle,drange,nc,hiuv,error)
    if (error) return
    narg = nc(2)-nc(1)+1
    allocate(channels(narg),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Channels allocation error')
      error = .true.
      return
    endif
    do i=1,narg
      channels(i) = i+nc(1)-1
    enddo
    call t_routine (narg,channels,zero,error)
  else
    ! If no option, try as if /CHANNEL with no Arguments...
    listname = 'PREVIEW%CHANNELS'
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
      if (zero.eq.-1) then  
        ! Reset everything
        if (allocated(dchanflag)) dchanflag = 1
      else
        ! But to set it, we must have some information
        call map_message(seve%e,rname,'No PREVIEW and '// &
          &  ' missing option /CHANNEL, /FREQUENCY, /RANGE or /VELOCITY')
        error = .true.
      endif
      return
    endif
    if (desc%type.ne.fmt_i4) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must be Integer ')
      error = .true.
      return
    endif
    if (desc%ndim.ne.1) then
      call map_message(seve%e,rname,'Variable '//trim(listname)//' must have rank 1')
      error = .true.
      return
    endif
    call adtoad(desc%addr,cptr,1)
    nf = desc%dims(1)
    call c_f_pointer(cptr,channels,desc%dims(1:1))
    call t_routine (nf,channels,zero,error)
  endif
  !
  save_data(code_save_uv) = .true.
  !
  ! We do not use Buffers here - Need to play safe to force re-reading
  optimize(code_save_uv)%change = optimize(code_save_uv)%change+100
  !
end subroutine uv_filter_base
!
subroutine t_filter(mf,filter,zero,error)
  use gildas_def
  use image_def
  use clean_arrays
  use uvsplit_mod
  use gbl_message
  use imager_interfaces, only : filter_line, map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support routine for UV_FILTER
  !
  !   Filter / Flag a list of channels
  !---------------------------------------------------------------------
  integer, intent(in) :: mf          ! Number of values
  integer, intent(in) :: filter(mf)  ! Channel list
  integer, intent(in) :: zero        ! Zero or not
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_FILTER'
  !
  integer :: nf, nv, nc, i, ier
  integer, allocatable :: filtre(:)
  integer :: nvisi, mvisi, ib
  character(len=120) :: mess
  !
  nc = hiuv%gil%nchan
  !
  allocate(filtre(mf+nc/10),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  nf = 0
  do i=1,mf
    if (filter(i).gt.0 .and. filter(i).le.nc) then
      nf = nf+1
      filtre(nf) = filter(i)
    endif
  enddo
  !
  if (use_file) then
    !
    ! Drop EDGE_DROP at each edge
    do i=1,nint(edge_drop*nc)
      nf = nf+1
      filtre(nf) = i
    enddo
    do i=nint(nc*(1.0-edge_drop)),nc
      nf = nf+1
      filtre(nf) = i
    enddo
    !
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%dim(2),mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      call filter_line(nc,nf,nvisi,hiuv%r2d,filtre,0)
      if (error) return
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
      if (error) return
    enddo
    call gdf_close_image(houv,error)
    if (error) return
    !
    call gdf_close_image(hiuv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    error = .false.
    !
  else
    ! Just set the channel mask according to the "filtre" 
    ier = 0
    if (allocated(dchanflag)) then
      if (size(dchanflag).lt.nc) then
        deallocate(dchanflag)
        allocate(dchanflag(nc),stat=ier)
        if (ier.eq.0) dchanflag = 1
      endif
    else
      allocate(dchanflag(nc),stat=ier)
      if (ier.eq.0) dchanflag = 1
    endif
    !
    if (ier.eq.0) then
      !
      ! Just remember the status of each channel
      do i=1,nf
        dchanflag(filtre(i)) = -zero  ! -1,0,1 
      enddo
    else
      call map_message(seve%w,rname,'Channel Mask allocation error')
      !
      ! If we cannot, apply it here on the data
      nv = hiuv%gil%dim(2)
      call filter_line(nc,nf,nv,duv,filtre,zero)
    endif
  endif
  !
  deallocate (filtre)
end subroutine t_filter
!
subroutine filter_line(nc,nf,nv,duv,filtre,zero)
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Support routine for UV_FILTER 
  !
  !   Flag or set to Zero the line regions
  !---------------------------------------------------------------------
  integer, intent(in) :: nf ! Number of good channels
  integer, intent(in) :: nv ! Number of visibilities
  integer, intent(in) :: nc ! Number of channels
  integer, intent(in) :: zero  ! Set to zero or Flag ?
  integer, intent(in) :: filtre(nf)
  real, intent(inout) :: duv(:,:)
  !
  integer :: iv,i
  !
  select case (zero)
  case (1)
    !$OMP PARALLEL DEFAULT(none)  &
    !$OMP & SHARED(duv,nv,nf,filtre) &
    !$OMP & PRIVATE(iv,i)
    !$OMP DO
    do iv=1,nv
      do i=1,nf
        duv(7+3*filtre(i),iv) = -abs(duv(7+3*filtre(i),iv))
      enddo
    enddo  
    !$OMP END DO
    !$OMP END PARALLEL
  case (0)
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(duv,nv,nf,filtre) &
    !$OMP & PRIVATE(iv,i)
    !$OMP DO
    do iv=1,nv
      do i=1,nf
        duv(5+3*filtre(i):7+3*filtre(i),iv) = 0
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  case(-1)
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(duv,nv,nf,filtre) &
    !$OMP & PRIVATE(iv,i)
    !$OMP DO
    do iv=1,nv
      do i=1,nf
        duv(7+3*filtre(i),iv) =  abs(duv(7+3*filtre(i),iv))
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  end select
end subroutine filter_line
!
subroutine t_baseline(mf,filter,degree,error)
  use gildas_def
  use image_def
  use clean_arrays
  use uvsplit_mod
  use gbl_message
  use imager_interfaces, only : remove_base, map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !    Support routine for UV_BASELINE
  !
  !    Subtract a baseline with a list of channels to be ignored
  !---------------------------------------------------------------------
  integer, intent(in) :: mf          ! Number of values
  integer, intent(in) :: filter(mf)  ! Channel list
  integer, intent(in) :: degree      ! Polynomial degree
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  !
  integer :: nf, nv, nc, i, j, ier
  integer, allocatable :: filtre(:)
  integer :: nvisi, mvisi, ib, fc, lc
  character(len=120) :: mess
  !
  error = .false.
  nv = hiuv%gil%nvisi ! not %dim(2)
  nc = hiuv%gil%nchan
  !
  ! FILTER contains the ones to be ignored.
  ! We must build the list of valid continuum channels...
  allocate(filtre(nc),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  nf = 0
  if (use_file) then
    fc = edge_drop*nc
    lc = (1.0-edge_drop)*nc
  else
    fc = 1
    lc = nc
  endif
  do i=1,nc
    nf = nf+1
    filtre(nf) = i
    do j=1,mf
      if (filter(j).eq.i) then
        nf = nf-1
        exit
      endif
    enddo
  enddo
  !
  if (use_file) then
    !
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%nvisi,mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%nvisi,mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%nvisi,ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      ! From data file, normally no need to unflag anything
      call remove_base(nf,nvisi,nc,hiuv%r2d,degree,filtre,mf,filter,error)
      if (error) return
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
      if (error) return
    enddo
    call gdf_close_image(houv,error)
    if (error) return
    !
    call gdf_close_image(hiuv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    error = .false.
    !
  else
    call remove_base(nf,nv,nc,duv,degree,filtre,mf,filter,error)
  endif
  deallocate (filtre)
end subroutine t_baseline
!
subroutine remove_base(nf,nv,nc,duv,degree,filtre,nb,filter,error)
  !---------------------------------------------------------------------
  ! @ private-mandatory  
  !
  ! IMAGER
  !   Support routine for UV_BASELINE
  !
  !   Remove a baseline in a UV data
  !---------------------------------------------------------------------
  integer, intent(in) :: nf ! Number of good channels
  integer, intent(in) :: nv ! Number of visibilities
  integer, intent(in) :: nc ! Number of channels
  integer, intent(in) :: degree ! Degree of polynomial
  integer, intent(in) :: filtre(:)    ! The channels to be considered
  integer, intent(in) :: nb           ! Number of filtered channels
  integer, intent(in) :: filter(:)    ! The filtered channels
  real, intent(inout) :: duv(:,:)
  logical, intent(out) :: error
  !
  real, allocatable :: wreal(:), wimag(:), wx(:), wxx(:), wxy(:)
  integer :: iv,i,ier, enf
  real :: mreal, mimag, sx, sy, sxx, sxy, delta, a, b, w
  !
  error = .true.
  if (degree.eq.0) then
    enf = 1
  else
    enf = nf
  endif
  allocate(wreal(nf),wimag(nf),wx(enf),wxx(enf),wxy(enf),stat=ier)
  if (ier.ne.0) return
  !
  if (enf.eq.nf) then
    wx(:) = filtre(1:nf)
  endif
  error = .false.
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & SHARED(nv,nf,duv,degree,nc,nb,filtre,filter) &
  !$OMP & PRIVATE(iv,w,wreal,wimag,mreal,mimag,i) &
  !$OMP & PRIVATE(sx,sy,sxx,sxy,wx,wxx,wxy,delta,a,b)
  !$OMP DO
  do iv=1,nv
    w = 0
    do i=1,nf
      wreal(i) = duv(5+3*filtre(i),iv)
      wimag(i) = duv(6+3*filtre(i),iv)
      ! Reset the Weights to > 0 (un-flagged) if any channel is unflagged
      if (duv(7+3*i,iv).gt.0) w = 1
    enddo
    !
    ! Compute the fitting polynomials.
    ! Filtre(:) is the channel number which can be used as abscissa
    ! For the time being, only mean value...
    if (degree.eq.0) then
      mreal = sum(wreal)/nf
      mimag = sum(wimag)/nf
      !
      ! Subtract
      do i=1,nc
        duv(5+3*i,iv) = duv(5+3*i,iv)-mreal
        duv(6+3*i,iv) = duv(6+3*i,iv)-mimag
      enddo
    else if (degree.eq.1) then
      ! This code actually does a poor job. There is not enough
      ! Signal to noise ratio to fit a linear baseline per Visibility
      sx = sum(wx)
      sy = sum(wreal)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wreal
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        duv(5+3*i,iv) = duv(5+3*i,iv)-(a+b*i)
      enddo
      !
      sy = sum(wimag)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wimag 
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        duv(6+3*i,iv) = duv(6+3*i,iv)-(a+b*i)
      enddo
      !
    endif
    !
    ! Remove the filter
    if (w.gt.0) then
      do i=1,nb
        duv(7+3*filter(i),iv) = abs(duv(7+3*filter(i),iv))
      enddo
    endif      
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  if (degree.eq.0) then
    deallocate (wreal,wimag)
  else
    deallocate (wreal,wimag,wx,wxx,wxy)
  endif
  error = .false.
end subroutine remove_base
!
subroutine t_split(mf,filter,degree,error)
  use gildas_def
  use image_def
  use clean_arrays
  use gbl_message
  use uvsplit_mod
  use imager_interfaces, only : split_base_line, map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !    Support routine for UV_SPLIT
  !
  !    Subtract a baseline with a list of channels to be ignored
  !---------------------------------------------------------------------
  integer, intent(in) :: mf          ! Number of values
  integer, intent(in) :: filter(mf)  ! Channel list
  integer, intent(in) :: degree      ! Polynomial degree
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_SPLIT'
  !
  integer :: nf, nv, nc, i, j, ier
  integer, allocatable :: filtre(:)
  integer :: nvisi, mvisi, ib, fc, lc, mc
  character(len=120) :: mess
  !
  error = .false.
  nv = hiuv%gil%nvisi !! not %dim(2)
  nc = hiuv%gil%nchan
  mc = hfuv%gil%nchan
  !
  ! FILTER contains the ones to be ignored.
  ! We must build the list of valid continuum channels...
  allocate(filtre(nc),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  nf = 0
  if (use_file) then
    fc = edge_drop*nc
    lc = (1.0-edge_drop)*nc
  else
    fc = 1
    lc = nc
  endif
  do i=fc,lc
    nf = nf+1
    filtre(nf) = i
    do j=1,mf
      if (filter(j).eq.i) then
        nf = nf-1
        exit
      endif
    enddo
  enddo
  !
  if (use_file) then
    !
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),hfuv%r2d(hfuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%nvisi,mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%nvisi,mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%nvisi,ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      call split_base_line(nf,nvisi,nc,hiuv%r2d,mc,hfuv%r2d,degree,filtre,error)
      if (error) return
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
      if (error) return
      !
      hfuv%blc = hiuv%blc
      hfuv%trc = hiuv%trc
      call gdf_write_data (hfuv,hfuv%r2d,error)
    enddo
    call gdf_close_image(houv,error)
    if (error) return
    !
    call gdf_close_image(hiuv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    call map_message(seve%i,rname,'Created '//trim(hfuv%file))
    !
    deallocate(hiuv%r2d,hfuv%r2d)
  else
    call map_message(seve%e,rname,'Programming error: SPLIT only valid with files')
    error = .true.
  endif
  deallocate (filtre)
end subroutine t_split
!
subroutine split_base_line(nf,nv,nc,duv,mc,cuv,degree,filtre,error)
  use uvsplit_mod
  use imager_interfaces, except_this => split_base_line
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Support routine for UV_SPLIT
  !
  !   Remove a baseline in a UV data, and produce the
  !   Continuum free and Line free UV tables from it.
  !   The Spectral Windows can be indicated by the options, including
  !   the default one derived by UV_PREVIEW.
  !---------------------------------------------------------------------
  integer, intent(in) :: nf         ! Number of good channels
  integer, intent(in) :: nv         ! Number of visibilities
  integer, intent(in) :: nc         ! Number of line channels
  integer, intent(in) :: mc         ! Number of continuum channels
  integer, intent(in) :: degree     ! Degree of polynomial
  integer, intent(in) :: filtre(nf) ! Channels with line
  real, intent(inout) :: duv(:,:)   ! Input line + continuum, output line
  real, intent(out) :: cuv(:,:)     ! Output continuum
  logical, intent(out) :: error
  !
  real, allocatable :: wreal(:), wimag(:), wx(:), wxx(:), wxy(:)
  integer :: iv,i,ier, lc, lt, kt, nt, nstart, enf
  logical :: trail
  real :: mreal, mimag, sx, sy, sxx, sxy, delta, a, b
  real, allocatable :: xuv(:,:)
  !
  !
  lt = ubound(duv,1)
  kt = ubound(cuv,1)
  lc = 7+3*NC
  nt = lt-lc
  !!Print *,' IN LC ',lc,' LT ',lt,' NT ',nt
  !!Print *,' OUT MC ',mc,' LT ',kt,' NT ',nt
  trail = nt.ne.0
  !
  if (degree.eq.0) then
    enf = 1
  else
    enf = nf
  endif
  allocate(wreal(nf),wimag(nf),xuv(lt,1),wx(enf),wxx(enf),wxy(enf),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  if (enf.eq.nf) wx(1:nf) = filtre(1:nf)
  !
  !
  nstart = 1
  !
  do iv=1,nv
    !
    ! Copy  continuum and compress it if needed
    xuv = 0.0
    do i=1,nf
      wreal(i) = duv(5+3*filtre(i),iv)
      wimag(i) = duv(6+3*filtre(i),iv)
      xuv(5+3*filtre(i):7+3*filtre(i),1) = duv(5+3*filtre(i):7+3*filtre(i),iv)
    enddo
    if (trail) xuv(lc:,1) = duv(lc:,iv) 
    if (ncompr.eq.1) then
      cuv(1:7,iv) = duv(1:7,iv)
      cuv(8:,iv) = xuv(8:,1)
    else
      cuv(:,iv:iv) = 0.0
      call compress_uv(cuv(:,iv:iv), &
        & kt,     & ! Output visibility size
        & 1,      & ! Number of output visibilities
        & mc,     & ! Number of output channels
        & xuv,    & ! Input visibilities
        & lt,     & ! Input visibility size
        & ncompr, & ! Compression factor
        & nt)       ! Number of trailing columns
      cuv(1:7,iv) = duv(1:7,iv)
    endif
    !
    ! Compute the fitting polynomials.
    ! Filtre(:) is the channel number which can be used as abscissa
    if (degree.eq.0) then
      ! For the time being, only mean value...
      mreal = sum(wreal)/nf
      mimag = sum(wimag)/nf
      !
      ! Subtract
      do i=1,nc
        duv(5+3*i,iv) = duv(5+3*i,iv)-mreal
        duv(6+3*i,iv) = duv(6+3*i,iv)-mimag
      enddo
    else if (degree.eq.1) then
      ! This code actually does a poor job. There is not enough
      ! Signal to noise ratio to fit a linear baseline per Visibility
      sx = sum(wx)
      sy = sum(wreal)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wreal
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        duv(5+3*i,iv) = duv(5+3*i,iv)-(a+b*i)
      enddo
      !
      sy = sum(wimag)
      wxx(:) = wx**2
      sxx = sum(wxx)
      wxy(:) = wx*wimag 
      sxy = sum(wxy)
      delta = (nf*sxx-sx**2)
      a = (sxx*sy-sx*sxy)/delta
      b = (nf*sxy-sx*sy)/delta
      do i=1,nc
        duv(6+3*i,iv) = duv(6+3*i,iv)-(a+b*i)
      enddo
    endif
  enddo
  !
  if (degree.eq.0) then
    deallocate (wreal,wimag)
  else
    deallocate (wreal,wimag,wx,wxx,wxy)
  endif
  error = .false.
end subroutine split_base_line
!
function space_nitems(name,head,last)
  use image_def
  use gkernel_interfaces, only: gdf_nitems
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Returns the number of blocks in the last dimension
  !   according to the NAME logical name
  !--------------------------------------------------------------------- 
  character(len=*), intent(in) :: name
  integer ::space_nitems         ! intent(out) function value
  type(gildas), intent(in) :: head ! Input Gildas header
  integer, intent(in) :: last      ! Last blocked dimension
  !
  integer :: nblock, mblock, i 
  integer(kind=8) :: dims     ! Size of a "row"
  integer(kind=8) :: rows     ! Number of "rows"
  !
  dims = 1
  do i=1,min(last,head%gil%ndim)
    if (head%gil%dim(i).gt.0) dims =dims*head%gil%dim(i)
  enddo
  !
  rows = 1
  do i=last,head%gil%ndim 
    if (head%gil%dim(i).gt.0) rows = rows*head%gil%dim(i)
  enddo
  !
  call gdf_nitems(name,nblock,dims)  ! "Rows" at once
  nblock = min(nblock,rows)
  mblock = (head%gil%dim(2)+nblock-1)/nblock   ! Number of blocks
  nblock = (head%gil%dim(2)+mblock-1)/mblock   ! Uniform block size
  !
  space_nitems = nblock
end function space_nitems

subroutine mx_major_cycle90 (map,uvdata,nu,nv,   &
     &    w_weight,w_v,   &
     &    method,head,   &
     &    clean,beam,resid,nx,ny,nb,   &
     &    wcl,mcl,tcc,ncct,   &
     &    list, nl, nf, primary, weight,   &
     &    grid, mapu, mapv, mapx, mapy,   &
     &    wfft, cpu0, uvmax)
  use gkernel_interfaces
  use clean_def
  use image_def
  use gbl_message
  use imager_interfaces, except_this=>mx_major_cycle90
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for MX
  !   Major cycle loop according to B.Clark idea
  !   Treat only one "plane/channel" at a time
  !   Plane is specified by method%iplane
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (uvmap_par), intent(in) :: map
  type (gildas), intent(inout) :: head
  !
  integer, intent(in) :: nu                 ! Visibility size
  integer, intent(in) :: nv                 ! Number of visibilities
  integer, intent(in) :: nb                 ! Number of beams
  real, intent(inout) :: uvdata(nu,nv)      ! Visibilities (iterated residuals)
  real, intent(in) ::  w_weight(nv)         ! Weight array
  real, intent(in) ::  w_v(nv)              ! V values
  real, intent(in) ::  uvmax                ! Max baseline
  !
  integer, intent(in) ::  nx,ny             ! X,Y size
  real, intent(in) ::  mapx(nx),mapy(ny)    ! X,Y coordinates
  real, intent(out) ::  mapu(*),mapv(*)      ! U,V coordinates
  real, intent(in) ::  grid(nx,ny)          ! Grid correction
  !
  real, intent(inout) ::  clean(nx,ny)      ! Clean image
  real, intent(inout) ::  resid(nx,ny)      ! Residuals
  real, intent(in) ::     beam(nx,ny,nb)    ! Synthesized beams

  integer, intent(in)  ::  nl               ! Search list size
  integer, intent(in)  ::  mcl              ! Maximum number of clean components
  integer, intent(out) ::  ncct             ! Number of clean components / plane
  real, intent(inout)  ::  wfft(*)          ! Work space for FFT
  type (cct_par), intent(out) :: tcc(method%m_iter) ! Clean components array
  integer, intent(in)  ::  list(nx*ny)      ! List of valid pixels
  !
  integer, intent(in) ::  nf                ! Number of fields
  real, intent(inout) ::  primary(nf,nx,ny) ! Primary beams
  real, intent(inout) ::  weight (nx,ny)    ! Flat field
  !
  type(cct_par), intent(inout) :: wcl(mcl)  ! Work array for Clean Components
  !
  real    maxc,minc,maxabs     ! max and min of data, absolute max value
  integer imax,jmax,imin,jmin  ! coordinates of the Max and Min pixels
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real    clarkl               ! Clark worry limit
  real flux                    ! Total clean flux density
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer k, kcl
  character(len=message_length) :: chain
  character(len=32) :: str
  !
  complex, allocatable :: tfgrid(:,:,:)
  complex, allocatable :: ftbeam(:,:)
  !! real, allocatable :: my_resid(:,:)
  !
  real cpu1,cpu0
  integer nn(2),ndim,kz,ier
  ! Some leftover globals...
  real ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff
  integer lx, ly
  character(len=2) :: rname = 'MX'
  !
  call imager_tree('MX_MAJOR_CYCLE90 in mx_cycle.f90')
  !
  !!Print *,'Number of fields ',nf,'  Number of Beams ',nb
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
     &      ' Undersampling ratio ',   &
     &      float(ly)/float(ny)
    call map_message(seve%w,rname,chain,3)
    write(chain,*) 'UVMAX ',uvmax,map%support, map%uvcell
    call map_message(seve%w,rname,chain)
  endif
  ly = min(ly,ny)
  lx = min(lx,nx)
  call docoor (lx,-map%uvcell(1),mapu)
  call docoor (ly,map%uvcell(2),mapv)
  !
  kz = 1
!!  allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),my_resid(nx,ny),stat=ier)
  allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
  !
  nn(1) = nx
  nn(2) = ny
  ndim = 2
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  call gag_cpu(cpu0)
  !
  ! Find maximum residual
  call maxlst (resid,nx,ny,list,nl,   &
     &    maxc,imax,jmax,minc,imin,jmin)
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  method%n_iter= 0
  !
  !!Print *,'Weight ',w_weight(1:100)
  !!Print *,'V ',w_v
  !
  ! Major cycle
  k = 0
  flux = 0.0
  do while (.not.fini)
    !
    ! Define minor cycle limit
    k = k+1
    write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
    call map_message(seve%d,rname,chain)
    limite = max(maxabs*method%bgain,0.8*borne)
    clarkl = maxabs*method%bgain
    !
    kcl = mcl
    !
    ! Select points of maximum strength and load them in
    call choice (      &
     &      resid,     &      ! Current residuals
     &      nx,ny,     &      ! image size
     &      list, nl,  &      ! Search list
     &      limite,    &      ! Detection threshold
     &      kcl,       &      ! Maximum number of candidates
     &      wcl,       &      ! Selected candidate components
     &      ncl,       &      ! Selected Number of components
     &      maxabs, method%ngoal)
    !
    if (ncl.gt.0) then
      write(chain,100) 'Selected ',ncl,' points above ',limite
      call map_message(seve%d,rname,chain)
      !
      ! Make minor cycles
      call minor_cycle90 (method,   &
     &        wcl,    &     ! Selected candidate components
     &        ncl,   &         ! Number of candidates
     &        beam,nx,ny,   &  ! Dirty beams and Size
     &        method%beam0(1),method%beam0(2),   & ! Beam center
     &        method%patch(1),method%patch(2),   & ! Beam patch
     &        clarkl,limite,   &
     &        converge,   &    !
     &        tcc,   &         ! Cumulated components
     &        nf, primary, weight, method%trunca,   &
     &        flux,   &        ! Total Flux
     &        method%pflux, next_flux90)
      !
      ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
      !
      call mx_uvsub90 (nx,ny,mapx,mapy,   &
     &        wcl, ncl,   &
     &        nu,nv,uvdata,method%iplane)
      write (chain,101)  'Cleaned ',flux,' Jy with ',   &
     &        method%n_iter,' clean components'
      call map_message(seve%d,rname,chain)
      !
      ! Compute FFTs and loop again
      call gag_cpu(cpu1)
      write(chain,101) 'Start FFT back at ',cpu1-cpu0
      call map_message(seve%d,rname,chain)
      call dofft (nu,nv,   &   ! Size of visibility array
     &        uvdata,   &      ! Visibilities
     &        1,2,   &         ! U, V pointers
     &        method%iplane,   &   ! First channel to map
     &        1,lx,ly,   &     ! Cube size
     &        tfgrid,   &      ! FFT cube
     &        mapu,mapv,   &   ! U and V grid coordinates
     &        map%support,   &
     &        map%uvcell,map%taper,   &    ! Gridding parameters
     &        w_weight,w_v,   &    ! Weight & Visi arrays
     &        ubias,vbias,ubuff,vbuff,map%ctype)
      !
      ! Make maps with grid correction
      call extracs (1+1,nx,ny,1,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,wfft)
      call cmtore (ftbeam,resid,nx,ny)
      call docorr (resid,grid,nx*ny)
   !!   call cmtore (ftbeam,my_resid,nx,ny)
   !! Print *,'RESID 1',my_resid(:,ny/2)
   !! call docorr (my_resid,grid,nx*ny)
   !! Print *,'RESID 2',my_resid(:,ny/2)
   !! resid = my_resid
      call gag_cpu(cpu1)
      write(chain,101) 'Finished gridding again ',cpu1-cpu0
      call map_message(seve%d,rname,chain)
      !
      ! Find new extrema
      call maxlst (resid,nx,ny,list,nl,   &
     &        maxc,imax,jmax,minc,imin,jmin)
      if (method%n_iter.lt.method%p_iter) then
        maxabs=abs(maxc)
      elseif ( abs(maxc).lt.abs(minc) ) then
        maxabs=abs(minc)
      else
        maxabs=abs(maxc)
      endif
      !
      ! Check if converge
      fini = (maxabs.le.borne)   &
     &        .or. (method%m_iter.le.method%n_iter)   &
     &        .or. converge
    else
      ! No component found: finish...
      write(chain,101) 'No points selected above ',limite
      call map_message(seve%i,rname,chain)
      fini = .true.
    endif
    !
    converge = fini
    !
    ! Unclear here ...
    call major_plot90 (method,head,   &
     &      converge,method%n_iter,nx,ny,nf,   &
     &      tcc,clean,resid,weight)
    fini = converge
    !
    ! Get new list
!!!    if (.not.fini) then
!!!      call re_mask (method,head,nl,error)
!!!      nl = method%nlist
!!!      list = method%list
!!!    endif
  enddo
  ncct = method%n_iter
  !
  ! End
  if (maxabs.le.borne) then
    str = '(minimum flux density)'
  elseif (method%m_iter.le.method%n_iter) then
    str = '(maximum number of components)'
  elseif (method%n_major.le.k) then
    str = '(maximum number of cycles)'
  elseif (converge) then
    str = '(converged)'
  else
    str = '(unknown reason)'
  endif
  write(chain,'(a,i6,a,1pg10.3,a,i5,a)')  'Plane ',method%iplane,': ',flux,' Jy in ',   &
     &    method%n_iter,' clean components '//trim(str)
  call map_message(seve%i,rname,chain)
  !
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  !
  100   format (a,i6,a,1pg10.3,a)
  101   format (a,1pg10.3,a,i5,a)
end subroutine mx_major_cycle90
!
subroutine mx_uvsub90 (nx,ny,mapx,mapy,   &
     &    wcl,ncl,nu,nv,visi,ip)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for MX
  !   Subtract last major cycle components from UV table.
  !   Treats only one channel.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nx,ny             ! X,Y size
  real, intent(in) ::  mapx(nx),mapy(ny)    ! X,Y coordinates
  integer, intent(in) :: nu                 ! Visibility size
  integer, intent(in) :: nv                 ! Number of visibilities
  integer, intent(in) :: ncl                ! Number of clean components
  real, intent(inout) :: visi(nu,nv)        ! Visibilities
  integer, intent(in) :: ip                 ! Current "plane/channel"
  type(cct_par), intent(inout) :: wcl(ncl)  ! Clean comp. value
  !
  integer ncomp
  integer ic,iv,ir,ii
  real x,y,phase,rvis,ivis
  !
  ir = 5+3*ip  ! Real part
  ii = ir+1    ! Imaginary part
  !
  ! Compress clean component list
  ncomp = 0
  do ic=1,ncl
    if (wcl(ic)%value.ne.0.0) then
      ncomp = ncomp+1
      wcl(ncomp) = wcl(ic)
    endif
  enddo
  !
  ! Remove clean component from UV data set
  do iv = 1,nv
    do ic = 1,ncomp
      x = mapx(wcl(ic)%ix)
      y = mapy(wcl(ic)%iy)
      phase = visi(1,iv)*x+visi(2,iv)*y
      rvis = wcl(ic)%value*cos(phase)
      ivis = wcl(ic)%value*sin(phase)
      visi(ir,iv) = visi(ir,iv) - rvis
      visi(ii,iv) = visi(ii,iv) - ivis
    enddo
  enddo
end subroutine mx_uvsub90

module cubedag_history_types
  use gkernel_interfaces
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_link_type
  use cubedag_node_type
  !---------------------------------------------------------------------
  ! Support module for the history type
  !---------------------------------------------------------------------

  integer(kind=entr_k), parameter :: history_optimize_minalloc=100
  integer(kind=4), parameter :: command_length=16  ! ZZZ Duplicated from SIC

  type history_optimize_t
    integer(kind=entr_k) :: next=1  ! Number of commands in history index + 1
    integer(kind=iden_l),              allocatable :: id(:)
    character(len=command_length),     allocatable :: command(:)
    character(len=commandline_length), allocatable :: line(:)
    type(cubedag_link_t),              allocatable :: inputs(:)
    type(cubedag_link_t),              allocatable :: outputs(:)
  contains
    procedure, public  :: reallocate => cubedag_history_reallocate_expo
    procedure, public  :: add        => cubedag_history_add_fromargs
    procedure, public  :: list       => cubedag_history_list
    final              :: cubedag_history_final
  end type history_optimize_t

  public :: history_optimize_t
  private

contains

  subroutine cubedag_history_reallocate_expo(optx,mcomms,error)
    !---------------------------------------------------------------------
    !  Reallocate the 'optimize' type arrays. If current allocation is not
    ! enough, double the size of allocation. Since this reallocation
    ! routine is used in a context of adding more and more data, data
    ! is always preserved after reallocation.
    !---------------------------------------------------------------------
    class(history_optimize_t), intent(inout) :: optx    !
    integer(kind=entr_k),      intent(in)    :: mcomms  ! Requested size
    logical,                   intent(inout) :: error   ! Logical error flag
    ! Local
    integer(kind=entr_k) :: ncomms
    !
    if (allocated(optx%command)) then
      ncomms = size(optx%command,kind=8)
      if (ncomms.ge.mcomms)  return           ! Enough size yet
      ncomms = 2_8*ncomms                     ! Request twice more place than before
      if (ncomms.lt.mcomms)  ncomms = mcomms  ! Twice is not enough, use mcomms
    else
      ncomms = max(mcomms,history_optimize_minalloc)  ! No allocation yet, use mcomms
    endif
    !
    call cubedag_history_reallocate(optx,ncomms,.true.,error)
    if (error)  return
  end subroutine cubedag_history_reallocate_expo

  subroutine cubedag_history_reallocate(optx,mcomms,keep,error)
    !---------------------------------------------------------------------
    !  Allocate the 'optimize' type arrays. Enlarge the arrays to the
    ! requested size, if needed. No shrink possible. Keep data if
    ! requested.
    !---------------------------------------------------------------------
    type(history_optimize_t), intent(inout) :: optx    !
    integer(kind=entr_k),     intent(in)    :: mcomms  ! Requested size
    logical,                  intent(in)    :: keep    ! Keep previous data?
    logical,                  intent(inout) :: error   ! Logical error flag
    ! Local
    character(len=*), parameter :: rname='HISTORY>REALLOCATE'
    integer(kind=4) :: ier
    integer(kind=entr_k) :: ncomms,inode
    integer(kind=iden_l), allocatable :: bufid(:)
    character(len=command_length), allocatable :: bufcc(:)
    character(len=commandline_length), allocatable :: bufcl(:)
    type(cubedag_link_t), allocatable :: buflk(:)
    !
    if (allocated(optx%command)) then
      ncomms = size(optx%command,kind=8)  ! Size of allocation
      if (ncomms.ge.mcomms) then
        ! Index is already allocated with a larger size. Keep it like this.
        ! Shouldn't we deallocate huge allocations if user requests a small one?
        return
      endif
    elseif (mcomms.eq.0) then
      ! No problem: can occur when dealing with empty files (e.g. nothing
      ! was written in an output file)
      return
    elseif (mcomms.lt.0) then
      call cubedag_message(seve%e,rname,'Can not allocate empty indexes')
      error = .true.
      return
    endif
    !
    ncomms = min(ncomms,optx%next-1)  ! Used part of the arrays
    if (keep) then
      allocate(bufid(ncomms),stat=ier)
      allocate(bufcc(ncomms),stat=ier)
      allocate(bufcl(ncomms),stat=ier)
      allocate(buflk(ncomms),stat=ier)
      if (failed_allocate(rname,'buf arrays',ier,error)) then
        error = .true.
        return
      endif
    endif
    !
    call reallocate_optimize_id(rname,'id array',     optx%id,     mcomms,keep,bufid,error)
    if (error)  return
    call reallocate_optimize_ch(rname,'command array',optx%command,mcomms,keep,bufcc,error)
    if (error)  return
    call reallocate_optimize_ch(rname,'line array',   optx%line,   mcomms,keep,bufcl,error)
    if (error)  return
    call reallocate_optimize_lk(rname,'inputs array', optx%inputs, mcomms,keep,buflk,error)
    if (error)  return
    call reallocate_optimize_lk(rname,'outputs array',optx%outputs,mcomms,keep,buflk,error)
    if (error)  return
    !
    if (keep) then
      if (allocated(bufid))  deallocate(bufid)
      if (allocated(bufcc))  deallocate(bufcc)
      if (allocated(bufcl))  deallocate(bufcl)
      if (allocated(buflk))  deallocate(buflk)
    endif
    !
    ! Initialize the new components
    do inode=ncomms+1,mcomms
      call history_optimize_init(optx,inode,error)
      if (error)  return
    enddo
  end subroutine cubedag_history_reallocate
  !
  subroutine reallocate_optimize_id(rname,name,val,mcomms,keep,buf,error)
    character(len=*),     intent(in)    :: rname
    character(len=*),     intent(in)    :: name
    integer(kind=iden_l), allocatable   :: val(:)
    integer(kind=entr_k), intent(in)    :: mcomms
    logical,              intent(in)    :: keep
    integer(kind=iden_l), allocatable   :: buf(:)  ! Not allocated if keep is .false.
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    integer(kind=entr_k) :: ncomms
    !
    if (keep) then
      ncomms = size(buf)
      buf(:) = val(1:ncomms)
    endif
    if (allocated(val)) deallocate(val)
    allocate(val(mcomms),stat=ier)
    if (failed_allocate(rname,name,ier,error))  return
    if (keep) val(1:ncomms) = buf(:)
  end subroutine reallocate_optimize_id
  !
  subroutine reallocate_optimize_ch(rname,name,val,mcomms,keep,buf,error)
    character(len=*),     intent(in)    :: rname
    character(len=*),     intent(in)    :: name
    character(len=*),     allocatable   :: val(:)
    integer(kind=entr_k), intent(in)    :: mcomms
    logical,              intent(in)    :: keep
    character(len=*),     allocatable   :: buf(:)  ! Not allocated if keep is .false.
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    integer(kind=entr_k) :: ncomms
    !
    if (keep) then
      ncomms = size(buf)
      buf(:) = val(1:ncomms)
    endif
    if (allocated(val)) deallocate(val)
    allocate(val(mcomms),stat=ier)
    if (failed_allocate(rname,name,ier,error))  return
    if (keep) val(1:ncomms) = buf(:)
  end subroutine reallocate_optimize_ch
  !
  subroutine reallocate_optimize_lk(rname,name,val,mcomms,keep,buf,error)
    character(len=*),     intent(in)    :: rname
    character(len=*),     intent(in)    :: name
    type(cubedag_link_t), allocatable   :: val(:)
    integer(kind=entr_k), intent(in)    :: mcomms
    logical,              intent(in)    :: keep
    type(cubedag_link_t), allocatable   :: buf(:)  ! Not allocated if keep is .false.
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: ier
    integer(kind=entr_k) :: icomm,ncomms
    !
    if (keep) then
      ncomms = size(buf)
      do icomm=1,ncomms
        buf(icomm)%n    =  val(icomm)%n
        call move_alloc(from=val(icomm)%list,to=buf(icomm)%list)
        call move_alloc(from=val(icomm)%flag,to=buf(icomm)%flag)
      enddo
    endif
    if (allocated(val)) deallocate(val)
    allocate(val(mcomms),stat=ier)
    if (failed_allocate(rname,name,ier,error))  return
    if (keep) then
      do icomm=1,ncomms
        val(icomm)%n    =  buf(icomm)%n
        call move_alloc(from=buf(icomm)%list,to=val(icomm)%list)
        call move_alloc(from=buf(icomm)%flag,to=val(icomm)%flag)
      enddo
    endif
  end subroutine reallocate_optimize_lk

  subroutine cubedag_history_final(hoptx)
    type(history_optimize_t), intent(inout) :: hoptx
    ! Local
    integer(kind=entr_k) :: ient
    logical :: error
    !
    hoptx%next = 1
    if (allocated(hoptx%id))       deallocate(hoptx%id)
    if (allocated(hoptx%command))  deallocate(hoptx%command)
    if (allocated(hoptx%line))     deallocate(hoptx%line)
    !
    error = .false.
    if (allocated(hoptx%inputs)) then
      do ient=1,size(hoptx%inputs)
        call hoptx%inputs(ient)%final(error)
        if (error)  continue
      enddo
    endif
    if (allocated(hoptx%outputs)) then
      do ient=1,size(hoptx%outputs)
        call hoptx%outputs(ient)%final(error)
        if (error)  continue
      enddo
    endif
  end subroutine cubedag_history_final

  subroutine history_optimize_init(optx,i,error)
    !---------------------------------------------------------------------
    ! Initialize the i-th component in the index
    !---------------------------------------------------------------------
    type(history_optimize_t), intent(inout) :: optx
    integer(kind=entr_k),     intent(in)    :: i
    logical,                  intent(inout) :: error
    !
    optx%id(i)        = 0
    optx%command(i)   = strg_unk
    optx%line(i)      = strg_unk
    optx%inputs(i)%n  = 0
    optx%outputs(i)%n = 0
  end subroutine history_optimize_init

  subroutine cubedag_history_add_fromargs(hoptx,command,line,inputs,outputs,error)
    !-------------------------------------------------------------------
    ! Add a new command in the HISTORY index
    !-------------------------------------------------------------------
    class(history_optimize_t), intent(inout) :: hoptx
    character(len=*),          intent(in)    :: command
    character(len=*),          intent(in)    :: line
    type(cubedag_link_t),      intent(in)    :: inputs
    type(cubedag_link_t),      intent(in)    :: outputs
    logical,                   intent(inout) :: error
    ! Local
    integer(kind=entr_k) :: ient
    !
    ient = hoptx%next
    call hoptx%reallocate(ient,error)
    if (error)  return
    !
    hoptx%id(ient) = ient
    hoptx%command(ient) = command
    hoptx%line(ient) = line
    call inputs%copy(hoptx%inputs(ient),error)
    if (error)  return
    call outputs%copy(hoptx%outputs(ient),error)
    if (error)  return
    !
    hoptx%next = hoptx%next+1
  end subroutine cubedag_history_add_fromargs

  subroutine cubedag_history_list(hoptx,error)
    !-------------------------------------------------------------------
    ! List the history index
    !-------------------------------------------------------------------
    class(history_optimize_t), intent(in)    :: hoptx
    logical,                   intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='HISTORY>LIST'
    integer(kind=entr_k) :: ient
    character(len=10) :: tmpi,tmpo
    integer(kind=4) :: nd
    character(len=16) :: forma
    !
    if (hoptx%next.le.1) then
      call cubedag_message(seve%w,rname,'History index is empty')
      error = .true.
      return
    endif
    !
    nd = ceiling(log10(real(maxval(hoptx%id(1:hoptx%next-1))+1,kind=8)))
    write(forma,'(A,I0,A)') '(I',nd,',4(2X,A))'
    !
    do ient=1,hoptx%next-1
      call hoptx%inputs(ient)%repr('i=',tmpi)
      call hoptx%outputs(ient)%repr('o=',tmpo)
      write(*,forma)  hoptx%id(ient),hoptx%command(ient),tmpi,tmpo,trim(hoptx%line(ient))
    enddo
  end subroutine cubedag_history_list
  !
end module cubedag_history_types

module imager_interfaces_none
  interface
    subroutine imager_write_data(head,data,error)
      use image_def
      use gkernel_types
      use clean_types
      ! 
      type(gildas), intent(inout) :: head
      real, intent(in) :: data(*)
      logical, intent(inout) :: error
    end subroutine imager_write_data
  end interface
  !
  interface
    subroutine compact_data(error)
      use clean_def
      use clean_arrays
      use gbl_message
      logical error
    end subroutine compact_data
  end interface
  !
  interface
    subroutine new_dirty_beam
      use clean_def
      use clean_arrays
      use clean_beams
      !
      ! needed when a new dirty map is computed by command uv_map:
    end subroutine new_dirty_beam
  end interface
  !
  interface
    subroutine define_var (error)
      use gildas_def
      use clean_def
      use clean_arrays
      use clean_types
      use clean_default
      use clean_support
      use clean_beams
      use grid_control
      !
      logical :: error  ! Logical error flag
    end subroutine define_var
  end interface
  !
  interface
    subroutine big_wait(n,b)
      real, intent(inout) :: b
      integer, intent(in) :: n
    end subroutine big_wait
  end interface
  !
  interface
    subroutine map_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine map_message_set_id
  end interface
  !
  interface
    subroutine message_attribute(cattr)
      use gbl_ansicodes
      !
      character(len=*), intent(in) :: cattr
    end subroutine message_attribute
  end interface
  !
  interface
    subroutine cossin(phase,rcos,rsin)
      !-------------------------------------------------------
      ! Semi-Fast,  Semi-accurate Sin/Cos pair computation
      ! using (not yet clever) interpolation from a precise
      ! loop-up table
      !
      ! A solution using Taylor expansion and symmetries
      ! would be faster and more accurate
      !-------------------------------------------------------
      real(8), intent(inout) :: phase
      real(8), intent(out) :: rcos
      real(8), intent(out) :: rsin
    end subroutine cossin
  end interface
  !
  interface
    subroutine get_stopping(miter,ares,iplane)
      use clean_arrays
      !
      integer, intent(inout) :: miter
      real, intent(inout) :: ares
      integer, intent(in) :: iplane
    end subroutine get_stopping
  end interface
  !
  interface
    subroutine maxcmp(nx,ny,wl,a)
      integer, intent(in) :: nx,ny
      real, intent(in) :: wl(2,nx,ny)
      real, intent(out) :: a
    end subroutine maxcmp
  end interface
  !
  interface
    subroutine userc (nv,coords,xref,xval,xinc,yref,yval,yinc)
      integer, intent(in) :: nv                     !
      real(4), intent(out) :: coords(2,nv)          !
      real(8), intent(in) :: xref                   !
      real(8), intent(in) :: xval                   !
      real(8), intent(in) :: xinc                   !
      real(8), intent(in) :: yref                   !
      real(8), intent(in) :: yval                   !
      real(8), intent(in) :: yinc                   !
    end subroutine userc
  end interface
  !
  interface
    subroutine progress_report(action,iv,nv,mv,percentage_step)
      character(len=*), intent(in) :: action ! Action name
      integer, intent(in) :: iv    ! Current index
      integer, intent(in) :: nv    ! Number of values per block
      integer, intent(in) :: mv    ! Total number of values
      integer, intent(in) :: percentage_step ! Frequency of report
    end subroutine progress_report
  end interface
  !
  interface
    subroutine mos_primary (prim,primary,bsize)
      !
      ! Mosaic and Primary beam support
      ! Compute a Gaussian primary beam
      !
      use image_def
      use gkernel_types
      type(gildas), intent(in) :: prim         ! Primary beam header
      real, intent(inout) :: primary(prim%gil%dim(1),prim%gil%dim(2)) ! Values
      real, intent(in) :: bsize                ! Primary beam size in radian
    end subroutine mos_primary
  end interface
  !
  interface
    subroutine mos_inverse (n,weight,thre)
      integer, intent(in) :: n
      real, intent(inout) :: weight(n)
      real, intent(in) :: thre
    end subroutine mos_inverse
  end interface
  !
  interface
    subroutine mos_addsq (n,nf,weight,lobe)
      integer, intent(in) :: n                      ! Size of arrays
      integer, intent(in) :: nf                     ! Number of fields
      real, intent(inout) :: weight(n)              ! Total weight
      real, intent(in) :: lobe(nf,n)                ! Primary beam array
    end subroutine mos_addsq
  end interface
  !
  interface
    subroutine mrc_clear
    end subroutine mrc_clear
  end interface
  !
  interface
    subroutine douvext(jc,nv,visi,jx,jy,umin,umax,vmin,vmax)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Compute extrema of UV coverage. No assumption,
      !   but may return 0 is all negative or all Positive
      !---------------------------------------------------------------------
      integer, intent(in) :: nv  ! Size of a visibility
      integer, intent(in) :: jc  ! Number of visibilities
      integer, intent(in) :: jx  ! X coordinate pointer
      integer, intent(in) :: jy  ! Y coordinate pointer
      real, intent(in) :: visi(jc,nv)  ! Visibilities
      real, intent(out) :: umin,umax ! U extrema
      real, intent(out) :: vmin,vmax ! V extrema
    end subroutine douvext
  end interface
  !
  interface
    function minimum(n,a)
      integer n,i
      real a(*)
      real minimum
    end function minimum
  end interface
  !
  interface
    subroutine uv_free_buffers
      use clean_def
      use clean_arrays
      !---------------------------------------------------------------------
      ! IMAGER
      !   Deallocate all UV buffers.
      !---------------------------------------------------------------------
    end subroutine uv_free_buffers
  end interface
  !
  interface
    subroutine uv_buffer_finduv(code) 
      use clean_arrays
      character(len=1), intent(out) :: code
    end subroutine uv_buffer_finduv
  end interface
  !
  interface
    subroutine uv_buffer_resetuv(code) 
      use clean_arrays
      character(len=1), intent(in) :: code
    end subroutine uv_buffer_resetuv
  end interface
  !
  interface
    subroutine buffers_comm(line,error)
      use clean_types
      !
      character(len=*), intent(in) :: line    
      logical :: error
    end subroutine buffers_comm
  end interface
  !
  interface
    subroutine uvdata_select(comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      !
      character(len=*), intent(in):: comm
      logical, intent(inout) :: error
    end subroutine uvdata_select
  end interface
  !
  interface
    function continuum_emg(x, amp, mu, sig, lamb)
      real(4) :: continuum_emg ! intent(out)
      real(4), intent(in) :: x
      real(4), intent(in) :: amp ! Amplitude of function
      real(4), intent(in) :: mu  ! Position
      real(4), intent(in) :: sig ! Width
      real(4), intent(in) :: lamb ! Exponential factor
    end function continuum_emg
  end interface
  !
  interface
    function continuum_gauss(x, amp, mu, sig)
      real(4) :: continuum_gauss ! intent(out)
      real(4), intent(in) :: x
      real(4), intent(in) :: amp ! Amplitude of function
      real(4), intent(in) :: mu  ! Position
      real(4), intent(in) :: sig ! Width
    end function continuum_gauss
  end interface
  !
  interface
    subroutine parabola(x,y,a,b,c) 
      !----------------------------------------------------------------------
      !	Solve for Y = a + b*x() + c*x()^2
      !----------------------------------------------------------------------
      real, intent(in) :: x(3)
      real, intent(in) :: y(3)
      real, intent(out) :: a,b,c
    end subroutine parabola
  end interface
  !
  interface
    function zant(i,r)
      !
      ! Return the apparent number of Antenna #i when reference
      ! antenna is #r. Since #r is not in the list of antennas for
      ! which a solution is to be searched, this number
      ! is #i for #i < #r, and #i-1 for #i > #r
      !
      integer :: zant                   ! intent(out)
      integer, intent(in) :: i          !
      integer, intent(in) :: r          !
    end function zant
  end interface
  !
  interface
    subroutine mth_dpotrf (name, uplo, n, a, lda, error)
      character(len=*) :: name           !
      character(len=*) :: uplo           !
      integer :: n                       !
      integer :: lda                     !
      real(8) :: a(lda,*)                 !
      logical :: error                   !
    end subroutine mth_dpotrf
  end interface
  !
  interface
    subroutine mth_dpotrs (name,   &
         &    uplo, n, nrhs, a, lda, b, ldb, info )
      character(len=*) :: name           !
      character(len=*) :: uplo           !
      integer :: n                       !
      integer :: nrhs                    !
      integer :: lda                     !
      real(8) :: a(lda,*)                 !
      integer :: ldb                     !
      real(8) :: b(ldb,*)                 !
      ! Local
      integer :: info
      logical :: error
      !
      !  Purpose
      !  =======
      !
      !  DPOTRS solves a system of linear equations A*X = B with a symmetric
      !  positive definite matrix A using the Cholesky factorization
      !  A = U**T*U or A = L*L**T computed by DPOTRF.
      !
      !  Arguments
      !  =========
      !
      !  UPLO    (input) CHARACTER*1
      !          = 'U':  Upper triangle of A is stored;
      !          = 'L':  Lower triangle of A is stored.
      !
      !  N       (input) INTEGER
      !          The order of the matrix A.  N >= 0.
      !
      !  NRHS    (input) INTEGER
      !          The number of right hand sides, i.e., the number of columns
      !          of the matrix B.  NRHS >= 0.
      !
      !  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
      !          The triangular factor U or L from the Cholesky factorization
      !          A = U**T*U or A = L*L**T, as computed by DPOTRF.
      !
      !  LDA     (input) INTEGER
      !          The leading dimension of the array A.  LDA >= max(1,N).
      !
      !  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
      !          On entry, the right hand side matrix B.
      !          On exit, the solution matrix X.
      !
      !  LDB     (input) INTEGER
      !          The leading dimension of the array B.  LDB >= max(1,N).
      !
      !  INFO    (output) INTEGER
      !          = 0:  successful exit
      !          < 0:  if INFO = -i, the i-th argument had an illegal value
      !
      ! Call LAPACK routine
    end subroutine mth_dpotrs
  end interface
  !
  interface
    subroutine mth_dpbtrf (name, uplo, n, kd, ab, ldab, error)
      character(len=*) :: name             !
      character(len=*) :: uplo             !
      integer :: n                         !
      integer :: kd                        !
      integer :: ldab                      !
      real(8) :: ab(ldab,*)                 !
      logical :: error                     !
    end subroutine mth_dpbtrf
  end interface
  !
  interface
    subroutine mth_dpbtrs (name,   &
         &    uplo, n, kd, nrhs, ab, ldab, b, ldb, error)
      character(len=*) :: name             !
      character(len=*) :: uplo             !
      integer :: n                         !
      integer :: kd                        !
      integer :: nrhs                      !
      integer :: ldab                      !
      real(8) :: ab(ldab,*)                 !
      integer :: ldb                       !
      real(8) :: b(ldb,*)                   !
      logical :: error                     !
    end subroutine mth_dpbtrs
  end interface
  !
  interface
    subroutine mth_fail (fac,prog,ifail,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! Error handling routine
      !---------------------------------------------------------------------
      character(len=*) :: fac           !
      character(len=*) :: prog          !
      integer :: ifail                  !
      logical :: error                  !
    end subroutine mth_fail
  end interface
  !
  interface
    subroutine overlap(a,n,b,m,c,k)
      !
      ! Find the intersection of ensembles A and B
      !
      integer, intent(in) :: n
      integer, intent(in) :: a(n)
      integer, intent(in) :: m
      integer, intent(in) :: b(m)
      integer, intent(inout) :: k
      integer, intent(inout) ::c(*)
    end subroutine overlap
  end interface
  !
  interface
    subroutine union(a,n,b,m,c,k)
      !
      ! Find the Union of ensembles A and B
      !
      integer, intent(in) :: n
      integer, intent(in) :: a(n)
      integer, intent(in) :: m
      integer, intent(in) :: b(m)
      integer, intent(inout) :: k
      integer, intent(inout) ::c(*)
    end subroutine union
  end interface
  !
  interface
    subroutine do_fft (nx,ny,nf,fft,work)
      integer, intent(in)  :: nx                     !
      integer, intent(in)  :: ny                     !
      integer, intent(in)  :: nf                     !
      complex, intent(inout) :: fft(nx,ny,nf)
      real, intent(inout)  :: work(2*max(nx,ny))
    end subroutine do_fft
  end interface
  !
  interface
    subroutine uvshort_convol (du,dv,resu,conv)
      use clean_def
      !------------------------------------------------------------------------  
      !
      ! Compute convolving factor resu
      ! resu is the result of the multiplication of the convolution functions,
      ! for u and v axes, at point (du,dv)
      !
      ! Convolution function is defined in "conv"
      !------------------------------------------------------------------------  
      real, intent(out) :: resu
      real, intent(in) :: du,dv
      type(gridding), intent(in) :: conv
    end subroutine uvshort_convol
  end interface
  !
  interface
    subroutine uvshort_doconv (nd,np,visi,jx,jy,jo,we,gwe,&
      &   nc,nx,ny,map,mapx,mapy,sup,cell,maxw,conv)
      use clean_def
      !------------------------------------------------------------------------  
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Convolution of 'map' by function defined by "conv" 
      ! Used for gridding of Single Dish data.
      !------------------------------------------------------------------------  
      integer, intent(in) :: np              ! number of visibilities
      integer, intent(in) :: nd              ! visibility size
      integer, intent(in) :: nc              ! number of channels
      integer, intent(in) :: nx,ny           ! map size
      integer, intent(in) :: jx,jy           ! x coord, y coord location in visi
      real, intent(in) :: we(np)             ! weights
      integer, intent(in) :: jo              ! offset for data in visi
      real, intent(in) :: visi(nd,np)        ! values
      real, intent(out) :: gwe(nx,ny)        ! gridded weights
      real, intent(out) :: map(nc,nx,ny)     ! gridded values
      real, intent(in) :: mapx(nx),mapy(ny)  ! coordinates of grid
      real, intent(in) :: sup(2)             ! support of convolving function in user units
      real, intent(in) :: cell(2)            ! cell size in user units
      real, intent(out) :: maxw              ! maximum weight
      type(gridding), intent(in) :: conv
    end subroutine uvshort_doconv
  end interface
  !
  interface
    subroutine uvshort_dosmoo (raw,we,nc,nx,ny,map,mapx,mapy,sup,cell,conv)
      use clean_def
      !------------------------------------------------------------------------  
      ! Task UV_SHORT
      !   Internal routine
      !
      ! Smooth an input data cube raw in vlm along l and m by convolution
      ! by a gaussian function defined in "conv"
      !------------------------------------------------------------------------  
      integer, intent(in) :: nc,nx,ny          ! map size
      real, intent(in) :: we(nx,ny)            ! weights
      real, intent(in) :: raw(nc,nx,ny)        ! raw map
      real, intent(out) :: map(nc,nx,ny)       ! smoothed map
      real, intent(in) :: mapx(nx),mapy(ny)    ! coordinates of grid
      real, intent(in) :: sup(2)               ! support of convolving function in user units
      real, intent(in) :: cell(2)              ! cell size in user units
      type(gridding), intent(in) :: conv
    end subroutine uvshort_dosmoo
  end interface
  !
  interface
    subroutine uvshort_dowei (visi,nd,np,we,iw)
      !------------------------------------------------------------------------  
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Fill in weights array from the input table
      !------------------------------------------------------------------------  
      integer, intent(in) :: nd       ! Visibility size
      integer, intent(in) :: np       ! Number of visibilities
      integer, intent(in) :: iw       ! Weight column
      real, intent(in) :: visi(nd,np) ! Visibilities
      real, intent(out) :: we(np)     ! Weight values
    end subroutine uvshort_dowei
  end interface
  !
  interface
    subroutine uvshort_findr (nv,nc,ic,xx,xlim,nlim)
      !------------------------------------------------------------------------  
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Find nlim such as
      !   xx(ic,nlim-1) < xlim < xx(ic,nlim)
      ! for input data ordered, retrieved from memory
      ! assumes nlim already preset so that xx(ic,nlim-1) < xlim
      !
      !------------------------------------------------------------------------  
      integer, intent(in) :: nv       ! Number of visibilities
      integer, intent(in) :: nc       ! Size of a visibility
      integer, intent(in) :: ic       ! COlumn to be tested
      integer, intent(inout) :: nlim
      real, intent(in) ::  xx(nc,nv),xlim
    end subroutine uvshort_findr
  end interface
  !
  interface
    subroutine uvshort_finsiz (x,nd,np,ix,iy,we,xmin,xmax,ymin,ymax)
      !------------------------------------------------------------------------  
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Find extrema xmin, xmax in ix column values
      !          and ymin, ymax in iy column values,
      ! in table x(nd,np) for points where weight is not null
      ! taking in account that table x is ordered on iy column values.
      !
      !------------------------------------------------------------------------  
      integer, intent(in) :: nd,np    ! Table size
      integer, intent(in) :: ix,iy    ! X and Y column pointers
      real, intent(in) :: x(nd,np)    ! Table data
      real, intent(in) :: we(np)      ! Weights
      real, intent(out) :: xmin,xmax,ymin,ymax  ! Min-Max
    end subroutine uvshort_finsiz
  end interface
  !
  interface
    subroutine uvshort_dosor (rname,visi,nd,np,we,iy,error)
      use gildas_def
      use gbl_message
      !------------------------------------------------------------------------  
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Output Visi(nd,np) will contain Ycol column values in increasing order
      ! Uses procedure trione
      ! WE is used as work space only
      !------------------------------------------------------------------------  
      character(len=*), intent(in) :: rname
      integer, intent(in) :: nd,np,iy
      real, intent(inout) :: visi(nd,np)   ! Visibilities,we(nd)
      real, intent(inout) :: we(nd)        ! Work space for sorting
      logical, intent(out) :: error
    end subroutine uvshort_dosor
  end interface
  !
  interface
    subroutine uvshort_doapod (xmin,xmax,ymin,ymax,tole,beam,&
         nc,nx,ny,map,raw,mapx,mapy, weight,wmin)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Replace map edges and bad quality values of raw input data cube
      ! with smoothed values contains in mapx data cube.
      ! Map edges corresponding to the part of the map between
      ! max SD observations locations xmin,xmax,ymin,ymax, and map size nx,ny
      ! Bad quality values corresponding to weights < wmin
      !---------------------------------------------------------------------
      integer nc,nx,ny
      real mapx(nx),mapy(ny)
      real map(nc,nx,ny)
      real raw(nc,nx,ny)
      real beam,tole,xmin,xmax,ymin,ymax
      real weight(nx,ny),wmin
    end subroutine uvshort_doapod
  end interface
  !
  interface
    subroutine uvshort_dosdft(beam,diam,f,nx,ny,lmv)
      use image_def
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! computes inverse of ft of single-dish beam
      ! (uses a gaussian truncated at dish size)
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: lmv     ! LMV header
      integer, intent(in) ::  nx, ny      ! Problem size
      real, intent(out) ::  f(nx,ny)      ! (real part of the) TF of beam
      real, intent(in) ::  beam(3)        ! Beam size in radian
      real, intent(in) ::  diam           ! Antenna diameter in meter
    end subroutine uvshort_dosdft
  end interface
  !
  interface
    subroutine uvshort_dointft(beam,diam,f,nx,ny,fact,lmv)
      use image_def
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! computes ft of single-dish beam
      ! (uses a gaussian truncated at dish size)
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: lmv     ! LMV header
      integer, intent(in) ::  nx, ny      ! Problem size
      real, intent(out) ::  f(nx,ny)      ! (real part of the) TF of beam
      real, intent(in) ::  beam           ! Beam size in radian
      real, intent(in) ::  diam           ! Antenna diameter in meter
      real, intent(in) ::  fact           ! Scale factor
    end subroutine uvshort_dointft
  end interface
  !
  interface
    subroutine uvshort_shift(f,nx,ny,offra,offdec,lmv)
      use image_def
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Centered interferometer beam f(nx,ny) of a mosaic field
      ! on is right position : offra and offdec shifted in uv plane
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: lmv
      integer, intent(in) :: nx, ny
      complex, intent(inout) :: f(nx,ny)
      real, intent(in) :: offra, offdec
    end subroutine uvshort_shift
  end interface
  !
  interface
    subroutine uvshort_dotrans (a,b,n,m)
      !
      ! Output table "b" is table "a" transposed in line/column order
      !
      integer, intent(in) :: n,m
      real, intent(in) :: a(n,m)
      real, intent(out) ::  b(m,n)
    end subroutine uvshort_dotrans
  end interface
  !
  interface
    subroutine uvshort_prmult(z,f,nx,ny)
      !
      ! Update z(nx,ny) table with z*f, calculate in uv plane
      ! Used to multiply by interferometer primary beam
      !
      integer, intent(in) :: nx, ny         ! Problem size
      complex, intent(inout) :: z(nx, ny)   ! Complex values
      real, intent(in) :: f(nx,ny)          ! Multiplication function
    end subroutine uvshort_prmult
  end interface
  !
  interface
    subroutine uvshort_uvcount(nx,ny,nvis,dmax,dmin,lmv)
      use image_def
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Compute number of visibilities nvis sampled on
      ! a regular grid of steps dx,dy inside the dish defined by diam
      ! nx and ny needed because uvcount is working in Fourier plane
      !---------------------------------------------------------------------
      !
      type(gildas), intent(in) :: lmv   ! Input GILDAS image
      integer, intent(in) :: nx         ! X image size
      integer, intent(in) :: ny         ! Y image size
      integer, intent(out) :: nvis      ! Number of visibilities
      real, intent(in) :: dmax          ! Max baseline
      real, intent(in) :: dmin          ! Min baseline
    end subroutine uvshort_uvcount
  end interface
  !
  interface
    subroutine uvshort_uvtable(nx,ny,nd,nc,v,w,ww,nvis,dmax,dmin,wfactor,factor,lmv)
      use image_def
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Tabulate the visibilities
      !---------------------------------------------------------------------
      !
      integer, intent(in) :: nx   ! X Image size
      integer, intent(in) :: ny   ! Y Image size
      integer, intent(in) :: nc   ! Number of channels
      integer, intent(in) :: nd   ! Visibility size
      integer, intent(in) :: nvis ! Number of visibilities
      complex, intent(in) :: v(nx,ny,nc)  ! Gridded visibilities
      complex, intent(in) :: ww(nx,ny)    ! Complex weights
      real, intent(out) :: w(nd,nvis)     ! Resulting visibilities
      real, intent(in) :: dmax    ! Maximum baseline
      real, intent(in) :: dmin    ! Minimum baseline
      real, intent(in) :: wfactor ! Weight factor
      real, intent(in) :: factor  ! Intensity factor
      type(gildas), intent(in) :: lmv     ! Input image
    end subroutine uvshort_uvtable
  end interface
  !
  interface
    subroutine uvshort_dopoint(data,nd,np,xcol,ycol,old,new)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for command UV_SHORT
      !
      ! Recompute data(nd,np) xcol and ycol coordinates values
      ! in case of changing reference position a0 d0 from old to new
      !---------------------------------------------------------------------
      !
      integer, intent(in) :: nd         ! Size of a visibility
      integer, intent(in) :: np          ! Number of visibilities
      integer, intent(in) :: xcol        ! RA offset pointer
      integer, intent(in) :: ycol        ! Dec offset pointer
      real, intent(inout) :: data(nd,np) ! Visibilities
      real(8), intent(in) :: old(2)      ! Old RA and Dec center
      real(8), intent(in) :: new(2)      ! New Ra and Dec center
    end subroutine uvshort_dopoint
  end interface
  !
  interface
    subroutine uvfit_comm(line,error)
      use gbl_message
      use clean_default
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command UV_FIT [Func1 ... FuncN] [/QUIET] 
      !     [/WIDGET Nfunc] [/SAVE File] [/RESULT]
      !     [/UVRANGE Min [Max]]
      !---------------------------------------------------------------------
      !
      character(len=*), intent(inout) :: line
      logical, intent(inout) :: error
    end subroutine uvfit_comm
  end interface
  !
  interface
    subroutine diagonal(m,n,r,c)
      integer :: m                      !
      integer :: n                      !
      real(kind=8) :: r(m,n)                  !
      real(kind=8) :: c(n)                    !
    end subroutine diagonal
  end interface
  !
  interface
    subroutine fitfcn(iflag,m,nvpar,x,f,fjac,ljc)
      use gildas_def
      use uvfit_data
      use gbl_message
      !$ use omp_lib
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for UV_FIT
      ! FITFCN is called by DNLS1E
      !---------------------------------------------------------------------
      integer, intent(in) :: iflag          ! Code for print out
      integer, intent(in) :: m              ! Number of data points
      integer, intent(in) :: nvpar          ! Number of variables
      real(8), intent(in) :: x(nvpar)       ! Variable parameters
      real(8), intent(out) :: f(m)          ! Function value at each point
      integer, intent(in) :: ljc            ! First dimension of FJAC
      real(8), intent(out) :: fjac(ljc,nvpar) ! Partial derivatives
    end subroutine fitfcn
  end interface
  !
  interface
    subroutine getvisi(n,uvriw,k,u,v,r,i,w)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for UV_FIT
      !     Obtain U, V, and the visibility from the array UVRIW.
      !
      !     N      Integer     Number of visibilities     Input
      !     UVRIW  real(8)      Input array                Input
      !     K      Integer     Visibility number          Input
      !     U      real(8)      U coord.                   Output
      !     V      real(8)      V coord.                   Output
      !     R      real(8)      Real part                  Output
      !     I      real(8)      Imaginary part.            Output
      !     W      real(8)      Weight                     Output
      !---------------------------------------------------------------------
      integer, intent(in) :: n         ! Number of visibilities
      real, intent(in) :: uvriw(5,n)   ! Visibilities
      integer, intent(in) :: k         ! Desired visibility number
      real(8), intent(out) ::  u       ! U coordinate
      real(8), intent(out) ::  v       ! V coordinate
      real(8), intent(out) ::  r       ! Real part
      real(8), intent(out) ::  i       ! Imaginary part
      real(8), intent(out) ::  w       ! Weight
    end subroutine getvisi
  end interface
  !
  interface
    subroutine outpar(id,kfunc,pars,errs)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for UV_FIT
      ! Process fitted parameters to be saved, according to fitted functions
      !---------------------------------------------------------------------
      integer, intent(in) :: id    ! Function code
      integer, intent(in) :: kfunc ! Number of parameters
      real(8), intent(inout) :: pars(kfunc)  ! Parameters
      real(8), intent(inout) :: errs(kfunc)  ! Uncertainties
    end subroutine outpar
  end interface
  !
  interface
    subroutine  uvfit_model(ifunc,kfunc,uu,vv,x,y,dy)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support routine for UV_FIT
      ! Compute a model function.
      !---------------------------------------------------------------------
      integer, intent(in) :: ifunc       ! Fuction type
      integer, intent(in) :: kfunc       ! Number of parameters
      real(8), intent(in) :: uu          ! U coordinate in arcsec^-1
      real(8), intent(in) :: vv          ! V coordinate in arcsec^-1
      real(8), intent(in) :: x(kfunc)    ! Parameters
      real(8), intent(inout) :: y(2)        ! Function (real, imag.)
      real(8), intent(inout) :: dy(2,kfunc) ! Partial derivatives.
    end subroutine uvfit_model
  end interface
  !
  interface
    function z_exp(x)
      !---------------------------------------------------------------------
      ! protect again underflows in exp(x)
      !---------------------------------------------------------------------
      real(8) :: z_exp                   !
      real(8) :: x                       !
    end function z_exp
  end interface
  !
  interface
    subroutine sub_uvfit_results(line,error)
      use uvfit_data
      use gbl_message
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command 
      !     UV_FIT [Func1 ... FuncN] /RESULT
      ! Only works for
      !  - all functions
      !  - 1 channel only
      ! Test functionality only. May disappear at any time...
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine sub_uvfit_results
  end interface
  !
  interface
    subroutine get_uvfit_model(nvisi,uu,vv,rr,ii,error)
      use uvfit_data
      !$ use omp_lib
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command 
      !     UV_FIT [Func1 ... FuncN] /RESULT
      !---------------------------------------------------------------------
      integer, intent(in) :: nvisi    ! Number of visibilities
      real, intent(in) :: uu(nvisi)   ! U coordinates
      real, intent(in) :: vv(nvisi)   ! V coordinates
      real, intent(out) :: rr(nvisi)  ! Real part
      real, intent(out) :: ii(nvisi)  ! Imaginary part
      logical, intent(inout) :: error ! Error flag
    end subroutine get_uvfit_model
  end interface
  !
  interface
    subroutine moments_comm(line,error)
      use clean_arrays
      use moment_arrays
      use gbl_message
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command
      !       MOMENT  [SMOOTH]
      !         [/MASK]
      !         [/METHOD Mean Peak Parabolic]
      !         [/RANGE Min Max TYPE] [/THRESHOLD Min]
      ! or
      !         MOMENTS /CUTS Threshold [Regions]
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine moments_comm
  end interface
  !
  interface
    subroutine moments_cuts(line,error)
      use clean_arrays
      use moment_arrays
      use gbl_message
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command
      !       MOMENT /CUTS Threshold [Regions]
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine moments_cuts
  end interface
  !
  interface
    subroutine sub_moments(horigin,line,error)
      use clean_arrays
      use moment_arrays
      use gbl_message
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command
      !       MOMENT 
      !         [/MASK]
      !         [/METHOD Mean Peak Parabolic]
      !         [/RANGE Min Max TYPE] [/THRESHOLD Min]
      !
      !	A dedicated routine to compute the moment of an input data cube.
      !	Input: a LMV cube
      !	Output: any or all of 4 images
      !           1) the integrated intensity map
      !           2) the Peak brightness
      !           3) The mean velocity
      !           4) The line width
      !	Method:
      !     AREA      Integrated intensity in Velocity range
      !
      !     PEAK      Peak intensity in Velocity range
      !     VELOCITY  Velocity of peak  
      !     WIDTH     2nd moment: line width, using the Velocity
      !               assigned 
      ! The peak intensity is obtained either as a per-channel basis,
      ! or a parabolic fit around the maximum. The Velocity is obtained
      ! in a similar way, or intensity weighted.
      !     
      !       For each spectrum, make a gate in velocity and clip based on
      !       intensity. Sum up weighted velocity and mean intensity.
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: horigin ! Input image, CLEAN or SKY
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine sub_moments
  end interface
  !
  interface
    subroutine set_velo(nv,av,ref,val,inc)
      use gildas_def
      integer(kind=index_length), intent(in)  :: nv
      real(kind=4),               intent(out) :: av(nv)
      real(kind=8),               intent(in)  :: ref,val,inc
    end subroutine set_velo
  end interface
  !
  interface
    subroutine catalog_init(imol,error)
      !
      integer, intent(inout) :: imol
      logical, intent(out) :: error
    end subroutine catalog_init
  end interface
  !
  interface
    subroutine big_stupid_uvsort(uvdata,uvtri,type,error)
      use image_def
      use gbl_message
      !----------------------------------------------------------------------
      ! GILDAS
      !       Sort an input UV table
      !   All 
      !       Add CC code to implement precession
      !----------------------------------------------------------------------
      character(len=*), intent(in) :: type
      character(len=*), intent(in) :: uvdata,uvtri
      logical, intent(out) :: error
    end subroutine big_stupid_uvsort
  end interface
  !
  interface
    subroutine color_comm(line,error)
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command COLOR Span HueMin HueMax
      !
      !   calls "@ p_color.ima" to derive a lut
      !   with unsaturated colours up to Span around 0,
      !   and a Hue range between Min and Max 
      ! 
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line
      logical, intent(inout) :: error
    end subroutine color_comm
  end interface
  !
  interface
    subroutine howto_comm(line,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! IMAGER
      !   Support for command HOW_TO
      !   HOW_TO Keywords...
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line
      logical, intent(out) :: error
    end subroutine howto_comm
  end interface
  !
  interface
    subroutine extract_real (c,mx,my,r,nx,ny)  ! checked with cmtore ...
      !-----------------------------------------------------------------
      !     Extract a Real array from a larger Complex array
      !-----------------------------------------------------------------
      integer nx,ny                      ! size of input array
      real r(nx,ny)                      ! input real array
      integer mx,my                      ! size of output array
      complex c(mx,my)                   ! output complex array
    end subroutine extract_real
  end interface
  !
  interface
    subroutine scale_factor(nx,ny,cbig,chigh,rmask,fscale,flux) 
      integer, intent(in) :: nx,ny
      complex, intent(in) :: cbig(nx,ny)
      complex, intent(in) :: chigh(nx,ny)
      real, intent(in) :: rmask(nx,ny)
      real, intent(out) :: fscale, flux
    end subroutine scale_factor
  end interface
  !
  interface
    subroutine polar_order(nstok,astoke,cstoke,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------------------------------
      ! IMAGER
      !   Return the ordering of the Polarization / Stokes states described by array ASTOK
      !
      !   Supported Cases are 
      !   Nstoke = 2    the two parallel hand polarization, any order
      !   Nstoke = 4    all four cross-polarization, any order
      !---------------------------------------------------------------------------------------------
      integer, intent(in) :: nstok
      integer, intent(in) :: astoke(nstok)
      integer, intent(out) :: cstoke(5)
      logical, intent(out) :: error
    end subroutine polar_order
  end interface
  !
  interface
    subroutine init_display 
    end subroutine init_display
  end interface
  !
  interface
    subroutine imager_version
      use gbl_ansicodes
      use gkernel_types
      !
      ! Test last IMAGER usage
      !
    end subroutine imager_version
  end interface
  !
  interface
    subroutine end_message(comm,elapsed,quiet,error)
      use gbl_ansicodes
      use gbl_message
      !
      character(len=*), intent(in) :: comm ! Command line name
      logical, intent(in) :: error         ! Error flag
      logical, intent(in) :: quiet         ! Quiet flag
      real(8), intent(inout) :: elapsed    ! Elapsed time
    end subroutine end_message
  end interface
  !
  interface
    subroutine save_result(error)
      use gildas_def
      use clean_types
      use gbl_message
      logical error
    end subroutine save_result
  end interface
  !
  interface
    subroutine get_sys_code(in,out,sys_code,error)
      use gbl_format
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! Get old-system to new-system conversion code
      ! Trap illegal/impossible conversions.
      !
      ! Caution: ICRS not yet supported here
      !---------------------------------------------------------------------
      type(gildas),    intent(in)  :: in        ! Input header
      type(gildas),    intent(in)  :: out       ! Desired output header
      integer(kind=4), intent(out) :: sys_code  ! Conversion code
      logical,         intent(out) :: error
    end subroutine get_sys_code
  end interface
  !
  interface
    subroutine sub_combine(hx,hy,hz,n,m,dx,dy,dz,code,ay,ty,az,tz,c,error)
      use gkernel_types
      !----------------------------------------------------------------------
      !
      !   IMAGER  Support routine for command
      !
      ! COMBINE Out CODE In1 In2 /factor A1 A2 /THRESHOLD T1 T2 /BLANK Bval
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: code  ! Combination code
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      !
      type(gildas), intent(in) :: hx  ! Output header
      type(gildas), intent(in) :: hy  ! Input Cube header
      type(gildas), intent(in) :: hz  ! Input Cube or Plane header
      !
      real, intent(in) :: dx(n,m)     ! Output data
      real, intent(in) :: dy(n,m)     ! Input data
      real, intent(in) :: dz(n)       ! Input data
      real, intent(in) :: c           ! Offset
      real, intent(in) :: ay          ! Y Factor
      real, intent(in) :: ty          ! Y Threshold
      real, intent(in) :: az          ! Z Factor
      real, intent(in) :: tz          ! Z Threshold
      logical, intent(out) :: error
    end subroutine sub_combine
  end interface
  !
  interface
    subroutine add002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      ! GDF	Internal routine
      !	  Linear combination of input arrays
      !	X = Ay*Y + Az*Z + C
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      ! Plane array
      real :: y(n,m)                    ! Input Cube
      real :: x(n,m)                    ! Output Cube
      real :: bz                        ! Z Blanking value
      real :: ez                        ! Z Tolerance on blanking
      real :: az                        ! Z factor
      real :: tz                        ! Z threshold
      real :: by                        ! Y Blanking value
      real :: ey                        ! Y Tolerance on blanking
      real :: ay                        ! Y factor
      real :: ty                        ! Y Threshold
      real :: bx                        ! X Blanking
      real :: c                         ! Constant Offset
    end subroutine add002
  end interface
  !
  interface
    subroutine div002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      ! GDF	Internal routine
      !	  Division of 2 input arrays
      !	X = Ay*Y / Az*Z + C
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      ! Plane array
      real :: y(n,m)                    ! Input Cube
      real :: x(n,m)                    ! Output Cube
      real :: bz                        ! Z Blanking value
      real :: ez                        ! Z Tolerance on blanking
      real :: az                        ! Z factor
      real :: tz                        ! Z threshold
      real :: by                        ! Y Blanking value
      real :: ey                        ! Y Tolerance on blanking
      real :: ay                        ! Y factor
      real :: ty                        ! Y Threshold
      real :: bx                        ! X Blanking
      real :: c                         ! Constant Offset
    end subroutine div002
  end interface
  !
  interface
    subroutine mul002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      ! GDF	Internal routine
      !	Multiplication of input arrays
      !	  X = Ay*Y * Az*Z + C
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      ! Plane array
      real :: y(n,m)                    ! Input Cube
      real :: x(n,m)                    ! Output Cube
      real :: bz                        ! Z Blanking value
      real :: ez                        ! Z Tolerance on blanking
      real :: az                        ! Z factor
      real :: tz                        ! Z threshold
      real :: by                        ! Y Blanking value
      real :: ey                        ! Y Tolerance on blanking
      real :: ay                        ! Y factor
      real :: ty                        ! Y Threshold
      real :: bx                        ! X Blanking
      real :: c                         ! Constant Offset
    end subroutine mul002
  end interface
  !
  interface
    subroutine opt002(z,y,x,n,m,bz,ez,az,tz,by,ey,ay,ty,bx,c)
      !$ use omp_lib
      use gkernel_types
      !---------------------------------------------------------------------
      ! GDF	Internal routine
      !	Optical depth from input arrays
      !	X = - LOG ( Ay*Y / Az*Z + C )
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: n
      integer(kind=index_length), intent(in) :: m
      real :: z(n)                      ! Plane array
      real :: y(n,m)                    ! Input Cube
      real :: x(n,m)                    ! Output Cube
      real :: bz                        ! Z Blanking value
      real :: ez                        ! Z Tolerance on blanking
      real :: az                        ! Z factor
      real :: tz                        ! Z threshold
      real :: by                        ! Y Blanking value
      real :: ey                        ! Y Tolerance on blanking
      real :: ay                        ! Y factor
      real :: ty                        ! Y Threshold
      real :: bx                        ! X Blanking
      real :: c                         ! Constant Offset
    end subroutine opt002
  end interface
  !
  interface
    subroutine uv_shift_comm(line,comm,error)
      use clean_types
      use clean_arrays
      use gbl_message
      !-------------------------------------------------------------------
      !  IMAGER 
      !   Support routine for command
      !       UV_SHIFT [Xpos Ypos UNIT] [ANGLE [Angle]]  [/FILE FileIn]
      !   Dispatch according to option presenced
      !-------------------------------------------------------------------
      character(len=*), intent(in) :: line  ! Command line
      character(len=*), intent(in) :: comm  ! Command name 
      logical error                         ! Logical error flag
    end subroutine uv_shift_comm
  end interface
  !
  interface
    subroutine explore_comm(line,comm,error)
      use gkernel_types
      use clean_default
      use gbl_message
      !---------------------------------------------------------------------
      !
      ! EXPLORE [DataCube] [/ADD Ux Uy [Ibox]] [/NOWAIT]
      !
      !    Call the "explore" scripts that allow to display from a data cube
      ! - a 2-D image (channel or integrated area)
      ! - spectra at selected positions around it
      !
      ! The display is organized in a Keypad layout
      !     7 8 9
      !     4 5 6
      !     1 2 3
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: line
      character(len=*), intent(in) :: comm
      logical, intent(out) :: error
    end subroutine explore_comm
  end interface
  !
  interface
    subroutine sub_cct_collect(ncx,ncy,ncz,ny,nz,x,y,z)
      use gildas_def
      integer(kind=address_length), intent(in) :: ncx, ncy, ncz
      integer(kind=address_length), intent(in) :: ny
      integer(kind=address_length), intent(in) :: nz
      !
      real, intent(in) :: y(3,ncy,ny)
      real, intent(in) :: z(3,ncz,nz)
      real, intent(out) :: x(3,ncx,ny+nz)
    end subroutine sub_cct_collect
  end interface
  !
  interface
    subroutine uvmap_headers(huv,nx,ny,nb,ns,map,mcol,hbeam,hdirty,error)
      use clean_def
      use image_def
      !---------------------------------------------------------------------
      ! IMAGER
      !
      !   Define the Beam and Dirty image headers 
      !---------------------------------------------------------------------
      integer, intent(in) :: nx,ny   ! Map size
      integer, intent(in) :: ns      ! Number of channels per single beam
      integer, intent(in) :: nb      ! Number of beams
      integer, intent(in) :: mcol(2) ! Channel range
      type (uvmap_par), intent(in) :: map    ! Mapping parameters
      type(gildas), intent(in) :: huv        ! UV headers
      type(gildas), intent(inout) :: hbeam   ! Beam headers
      type(gildas), intent(inout) :: hdirty  ! Dirty image header
      logical, intent(inout) :: error
    end subroutine uvmap_headers
  end interface
  !
  interface
    function mth_bessj1 (x)
      !-------------------------------------------------------------------
      ! Compute Bessel function J1
      !-------------------------------------------------------------------
      real*8 :: mth_bessj1            !
      real*8 :: x                     !
    end function mth_bessj1
  end interface
  !
  interface
    subroutine imager_pack_set(pack)
      use gpack_def
      !
      type(gpack_info_t), intent(out) :: pack
    end subroutine imager_pack_set
  end interface
  !
  interface
    subroutine imager_pack_init(gpack_id,error)
      use sic_def
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine imager_pack_init
  end interface
  !
  interface
    subroutine imager_pack_on_exit(error)
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      logical :: error
    end subroutine imager_pack_on_exit
  end interface
  !
  interface
    subroutine omp_setup
      use omp_control
      !$ use omp_lib
      !
    end subroutine omp_setup
  end interface
  !
  interface
    subroutine astro_message(seve,comm,mess)
      integer :: seve
      character(len=*) :: comm
      character(len=*) :: mess
    end subroutine astro_message
  end interface
  !
end module imager_interfaces_none

module cubeadm_opened
  use cubetools_list
  use cubedag_parameters
  use cubedag_flag
  use cubedag_link_type
  use cubedag_node_type
  use cubedag_node
  use cubetuple_format
  use cubetopology_cuberegion_types
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubeadm_taskloop
  use cubeadm_messaging
  !---------------------------------------------------------------------
  ! Support module for registering and keep track of cubes opened by
  ! current command, up to the moment they are closed with
  ! 'cubeadm_finish_all'
  !---------------------------------------------------------------------
  !
  ! Keep a list of the parents and children currently 'opened'.
  ! At some point they are all 'flushed' in the DAG, with the proper
  ! cross-references.
  type(cubedag_link_t) :: pa  ! Parents list
  type(cubedag_link_t) :: ch  ! Children list
  !
  integer(kind=entr_k), parameter    :: min_alluser_alloc=16
  type(tools_list_t)                 :: allarg      ! Parents and children argument/product list
  character(len=argu_l), allocatable :: alluser(:)  ! Parents and children user inputs
  type(cubedag_link_t)               :: all         ! Parents and children cube list
  !
  integer(kind=code_k), parameter :: code_parent_noarg=1
  integer(kind=code_k), parameter :: code_parent=2
  integer(kind=code_k), parameter :: code_child=3
  integer(kind=code_k), parameter :: code_child_noprod=4
  !
  interface cubeadm_parents_add
    module procedure cubeadm_parents_add_noarg
    module procedure cubeadm_parents_add_witharg
  end interface cubeadm_parents_add
  !
  interface cubeadm_children_add
    module procedure cubeadm_children_add_noprod
    module procedure cubeadm_children_add_withprod
  end interface cubeadm_children_add
  !
  interface cubeadm_datainit_all
    module procedure cubeadm_datainit_allcubes_full
    module procedure cubeadm_datainit_allcubes_region
  end interface cubeadm_datainit_all
  !
  public :: cubeadm_parents_add,cubeadm_children_add
  public :: cubeadm_datainit_all,cubeadm_dataiterate_all
  public :: cubeadm_finish_one,cubeadm_finish_all
  public :: cubeadm_iterator_t  ! For convenience to users
  public :: cubeadm_parents_children_pop, cubeadm_opened_list_size
  private
  !
contains
  !
  subroutine cubeadm_parents_add_noarg(dno,action)
    !-------------------------------------------------------------------
    ! Add a parent cube as command input
    ! ---
    ! This version does not provide a cubeid_arg_t nor a
    ! cubeid_user_cube_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    !
    logical :: error,skip
    !
    error = .false.
    !
    ! Cube
    call cubeadm_parents_add_cube(dno,code_parent_noarg,action,skip,error)
    if (error)  return
    if (skip)  return
    !
    ! Argument/product => unknown with this API
    call allarg%realloc(allarg%n+1,error)
    if (error) return
    allarg%n = allarg%n+1
    call allarg%list(allarg%n)%nullify(error)
    if (error)  return
    !
    ! User input => unknown with this API
    call alluser_reallocate(allarg%n,error)
    if (error) return
    alluser(allarg%n) = ' '
  end subroutine cubeadm_parents_add_noarg
  !
  subroutine cubeadm_parents_add_witharg(arg,user,dno,action)
    !-------------------------------------------------------------------
    ! Add a parent cube as command input
    ! ---
    ! This version provides a cubeid_arg_t (for input cube expectations)
    ! and a cubeid_user_cube_t (for actual user inputs)
    !-------------------------------------------------------------------
    type(cubeid_arg_t),           intent(in) :: arg
    type(cubeid_user_cube_t),     intent(in) :: user
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    !
    logical :: error,skip
    !
    error = .false.
    !
    ! Cube
    call cubeadm_parents_add_cube(dno,code_parent,action,skip,error)
    if (error)  return
    if (skip)  return
    !
    ! Argument/product
    call allarg%realloc(allarg%n+1,error)
    if (error) return
    allarg%n = allarg%n+1
    call allarg%list(allarg%n)%associate(arg,error)
    if (error)  return
    !
    ! User input
    call alluser_reallocate(allarg%n,error)
    if (error) return
    alluser(allarg%n) = user%id  ! Keep only the non-parsed string
  end subroutine cubeadm_parents_add_witharg
  !
  subroutine cubeadm_parents_add_cube(dno,code,action,skip,error)
    !-------------------------------------------------------------------
    ! Add a parent cube in the lists
    ! ---
    ! Do not call directly, use cubeadm_parents_add generic entry point
    ! instead
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer       :: dno
    integer(kind=code_k),         intent(in)    :: code
    integer(kind=code_k),         intent(in)    :: action
    logical,                      intent(out)   :: skip
    logical,                      intent(inout) :: error
    !
    integer(kind=entr_k) :: ipa
    !
    ! Avoid double insertions. This can happen if a cube is re-accessed
    ! (cubeadm_access_header) during the command execution
    do ipa=1,pa%n
      if (associated(pa%list(pa%n)%p,dno)) then
        skip = .true.
        return
      endif
    enddo
    skip = .false.
    !
    ! Cube (in list of parents)
    call pa%reallocate(pa%n+1,error)
    pa%n = pa%n+1
    pa%list(pa%n)%p => dno
    pa%flag(pa%n) = action
    !
    ! Cube (in list of all cubes)
    call all%reallocate(all%n+1,error)
    all%n = all%n+1
    all%list(all%n)%p => dno
    all%flag(all%n) = code
  end subroutine cubeadm_parents_add_cube
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_children_add_noprod(dno,action)
    !-------------------------------------------------------------------
    ! Add a child cube as command output
    ! ---
    ! This version does not provide a cube_prod_t
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    logical :: error
    !
    error = .false.
    !
    ! Argument/product => unknown with this API
    call allarg%realloc(allarg%n+1,error)
    if (error) return
    allarg%n = allarg%n+1
    call allarg%list(allarg%n)%nullify(error)
    if (error)  return
    !
    ! User input => irrelevant
    call alluser_reallocate(allarg%n,error)
    if (error) return
    alluser(allarg%n) = ' '
    !
    ! Cube
    call cubeadm_children_add_cube(dno,code_child_noprod,action)
  end subroutine cubeadm_children_add_noprod
  !
  subroutine cubeadm_children_add_withprod(prod,dno,action)
    !-------------------------------------------------------------------
    ! Add a child cube as command output
    ! ---
    ! This version does not provide a cube_prod_t
    !-------------------------------------------------------------------
    type(cube_prod_t),            intent(in) :: prod
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: action
    logical :: error
    !
    error = .false.
    !
    ! Argument/product
    call allarg%realloc(allarg%n+1,error)
    if (error) return
    allarg%n = allarg%n+1
    call allarg%list(allarg%n)%associate(prod,error)
    if (error)  return
    !
    ! User input => irrelevant
    call alluser_reallocate(allarg%n,error)
    if (error) return
    alluser(allarg%n) = ' '
    !
    ! Cube
    call cubeadm_children_add_cube(dno,code_child,action)
  end subroutine cubeadm_children_add_withprod
  !
  subroutine cubeadm_children_add_cube(dno,code,action)
    !-------------------------------------------------------------------
    ! Add a child cube in the lists
    ! ---
    ! Do not call directly, use cubeadm_children_add generic entry point
    ! instead
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer    :: dno
    integer(kind=code_k),         intent(in) :: code
    integer(kind=code_k),         intent(in) :: action
    logical :: error
    !
    error = .false.
    !
    ! Cube (in list of children)
    call ch%reallocate(ch%n+1,error)
    ch%n = ch%n+1
    ch%list(ch%n)%p => dno
    ch%flag(ch%n) = action
    !
    ! Cube (in list of all cubes)
    call all%reallocate(all%n+1,error)
    all%n = all%n+1
    all%list(all%n)%p => dno
    all%flag(all%n) = code
  end subroutine cubeadm_children_add_cube
  !
  !---------------------------------------------------------------------
  !
  subroutine cubeadm_parents_children_pop(dno,error)
    use cubetools_list
    !-------------------------------------------------------------------
    ! Pop out the given node from the parents/children lists
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), pointer       :: dno
    logical,                      intent(inout) :: error
    !
    class(tools_object_t), pointer :: tot
    !
    tot => dno
    call pa%unlink(tot,error)
    call ch%unlink(tot,error)
    call all%unlink(tot,error)
    ! ZZZ For consistency these ones should be cleaned too (but they are
    ! only needed for feedback): allarg, alluser
  end subroutine cubeadm_parents_children_pop
  !
  subroutine cubeadm_parents_children_reset()
    logical :: error
    error = .false.
    call allarg%final(error)
    call pa%final(error)
    call ch%final(error)
    call all%final(error)
  end subroutine cubeadm_parents_children_reset
  !
  subroutine cubeadm_list_opened(error)
    use cubedag_list
    logical, intent(inout) :: error
    ! Local
    integer(kind=4) :: custom(20),larg,lflag,luser,nc
    character(len=mess_l) :: mess
    integer(kind=entr_k) :: icub
    integer(kind=code_k) :: status
    type(cubeid_arg_t), pointer :: arg
    type(cube_prod_t), pointer :: prod
    class(cubedag_node_object_t), pointer :: thiscube
    character(len=*), parameter :: cols(7) = &
         ['IDENTIFIER ','TYPE       ','CUBEID     ','OBSERVATORY',  &
          'SOURCE     ','LINE       ','DATASIZE   ']
    character(len=*), parameter :: rname='LIST>OPENED'
    !
    ! Set up trailing columns
    call cubeadm_opened_list_size(cols,custom,error)
    if (error) return
    !
    ! Automatic widths for leading columns
    larg = 1   ! Argument name width
    lflag = 1  ! Flag list width
    luser = 1  ! User input width
    do icub=1,all%n
      status = all%flag(icub)
      thiscube => cubedag_node_ptr(all%list(icub)%p,error)
      if (error) return
      select case (status)
      case (code_parent_noarg)  ! A parent with no associated cubeid_arg_t nor cubeid_user_cube_t
        ! Argument name size unchanged
        ! Flag column size unchanged
        ! User input column size unchanged
      case (code_parent)
        arg => cubeadm_cubeid_arg_ptr(allarg%list(icub)%p,error)
        if (error)  return
        ! Argument name size from command's cubeid_arg_t
        larg = max(larg,len_trim(arg%name))
        ! Flag column size from command's cubeid_arg_t
        call cubedag_flaglist_tostr(arg%flag,arg%nflag,lstrflag=nc,error=error)
        if (error) return
        lflag = max(lflag,nc)
        ! User input column size from user input
        luser = max(1,len_trim(alluser(icub)))
      case (code_child_noprod)
        ! Argument name size unchanged
        ! Flag column size from child cube itself
        call thiscube%node%flag%repr(lstrflag=nc,error=error)
        if (error) return
        lflag = max(lflag,nc)
        ! User input column size not changed (irrelevant)
      case (code_child)
        prod => cubeadm_cubeprod_ptr(allarg%list(icub)%p,error)
        if (error)  return
        ! Product name size from command's cube_prod_t
        larg = max(larg,len_trim(prod%name))
        ! Flag column size from command's cube_prod_t
        call cubedag_flaglist_tostr(prod%flag,prod%nflag,lstrflag=nc,error=error)
        if (error) return
        lflag = max(lflag,nc)
        ! User input column size not changed (irrelevant)
      case default
        call cubeadm_message(seve%w,rname,'Cube is neither parent nor child')
      end select
    enddo
    !
    ! Actual print
    do icub=1,all%n
      nc = 1
      status = all%flag(icub)
      thiscube => cubedag_node_ptr(all%list(icub)%p,error)
      if (error) return
      select case (status)
      case (code_parent_noarg)  ! A parent with no associated cubeid_arg_t nor cubeid_user_cube_t
        mess(nc:) = 'I'
        nc = nc+2
        mess(nc:) = ' '  ! No argument name
        nc = nc+larg+1
        mess(nc:) = ' '  ! No argument flags
        nc = nc+lflag+1
        mess(nc:) = ' '  ! No user input
        nc = nc+luser
      case (code_parent)
        arg => cubeadm_cubeid_arg_ptr(allarg%list(icub)%p,error)
        if (error)  return
        mess(nc:) = 'I'
        nc = nc+2
        mess(nc:) = arg%name
        nc = nc+larg+1
        call cubedag_flaglist_tostr(arg%flag,arg%nflag,strflag=mess(nc:),error=error)
        if (error) return
        nc = nc+lflag+1
        mess(nc:) = alluser(icub)
        nc = nc+luser
      case (code_child_noprod)
        mess(nc:) = 'O'
        nc = nc+2
        mess(nc:) = ' '  ! No argument name
        nc = nc+larg+1
        call thiscube%node%flag%repr(strflag=mess(nc:),error=error)
        if (error) return
        nc = nc+lflag+1
        mess(nc:) = alluser(icub)
        nc = nc+luser
      case (code_child)
        prod => cubeadm_cubeprod_ptr(allarg%list(icub)%p,error)
        if (error)  return
        mess(nc:) = 'O'
        nc = nc+2
        mess(nc:) = prod%name
        nc = nc+larg+1
        call cubedag_flaglist_tostr(prod%flag,prod%nflag,strflag=mess(nc:),error=error)
        if (error) return
        nc = nc+lflag+1
        mess(nc:) = alluser(icub)
        nc = nc+luser
      end select
      mess(nc:) = ' => '
      nc = nc+4
      call cubedag_list_one_custom(thiscube,custom,.true.,code_null,code_null,mess(nc:),error)
      if (error) return
      call cubeadm_message(seve%r,rname,mess)
    enddo
    !
  end subroutine cubeadm_list_opened
  !
  subroutine cubeadm_datainit_allcubes_full(iter,error,align)
    use cubetuple_iterator
    !-------------------------------------------------------------------
    ! Prepare the data IO for all the registered cubes
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t),       intent(out)   :: iter
    logical,                        intent(inout) :: error
    integer(kind=code_k), optional, intent(in)    :: align
    ! Local
    character(len=*), parameter :: rname='DATAINIT>ALLCUBES>FULLSET'
    type(cuberegion_prog_t), pointer :: region
    integer(kind=code_k) :: lalign
    !
    if (present(align)) then
      lalign = align
    else
      lalign = code_align_auto
    endif
    region => null()
    call cubeadm_datainit_allcubes_do(iter,lalign,region,error)
    if (error) return
    !
  end subroutine cubeadm_datainit_allcubes_full
  !
  subroutine cubeadm_datainit_allcubes_region(iter,region,error)
    use cubetuple_iterator
    !-------------------------------------------------------------------
    ! Prepare the data IO for all the registered cubes
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t),        intent(out)   :: iter
    type(cuberegion_prog_t), target, intent(in)    :: region
    logical,                         intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='DATAINIT>ALLCUBES>REGION'
    type(cuberegion_prog_t), pointer :: pregion
    !
    pregion => region
    call cubeadm_datainit_allcubes_do(iter,code_align_auto,pregion,error)
    if (error) return
  end subroutine cubeadm_datainit_allcubes_region
  !
  subroutine cubeadm_datainit_allcubes_do(iter,align,region,error)
    use cubetools_access_types
    use cubeadm_entryloop
    !-------------------------------------------------------------------
    ! Prepare the data IO for all the registered cubes
    !-------------------------------------------------------------------
    type(cubeadm_iterator_t), intent(inout) :: iter
    integer(kind=code_k),     intent(in)    :: align
    type(cuberegion_prog_t),  pointer       :: region
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='DATAINIT>ALLCUBES>DO'
    class(format_t), pointer :: incube,oucube
    integer(kind=entr_k) :: icube,refnum
    integer(kind=code_k) ::refaccess,reforder
    character(len=mess_l) :: mess
    class(cubedag_node_object_t), pointer :: dno
    !
    ! Loop on all the input cubes to check their consistency
    refnum = 0
    do icube=1,pa%n
      if (pa%flag(icube).eq.code_read_head)  cycle  ! No need for data consistency check
      dno => cubedag_node_ptr(pa%list(icube)%p,error)
      if (error) return
      incube => cubetuple_format_ptr(dno,error)
      if (error) return
      if (refnum.eq.0) then
        refnum = icube
        refaccess = incube%access()
        reforder = incube%order()
      else
        if (incube%order().ne.reforder .or. &
            incube%access().ne.refaccess) then
          call cubeadm_message(seve%e,rname,'Inconsistent cube accesses or orders:')
          write(mess,'(A,I0,4A)')  '  Cube #',refnum,  &
                                   ': access ',trim(cubetools_accessname(refaccess)),  &
                                   ', order ',cubetools_ordername(reforder)
          call cubeadm_message(seve%e,rname,mess)
          write(mess,'(A,I0,4A)')  '  Cube #',icube,  &
                                   ': access ',trim(cubetools_accessname(incube%access())),  &
                                   ', order ',cubetools_ordername(incube%order())
          call cubeadm_message(seve%e,rname,mess)
          error = .true.
          return
        endif
      endif
      call incube%tuple%elapsed_init(error)
      if (error)  return
    enddo
    !
    ! Loop on all the output cubes to prepare them for data access
    do icube=1,ch%n
      dno => cubedag_node_ptr(ch%list(icube)%p,error)
      if (error) return
      oucube => cubetuple_format_ptr(dno,error)
      if (error) return
      call cubeadm_datainit_one(oucube,error)
      if (error) return
    enddo
    !
    ! Taskloop iterator is set by taking all the input and output cubes
    ! into account
    call cubeadm_taskloop_init(pa,ch,align,region,iter,error)
    if (error) return
    ! Entryloop iterator
    call cubeadm_entryloop_init(iter%ne,error)
    if (error) return
    !
    ! Initialize processing
    do icube=1,ch%n
      dno => cubedag_node_ptr(ch%list(icube)%p,error)
      if (error) return
      oucube => cubetuple_format_ptr(dno,error)
      if (error) return
      call cubeadm_processinginit_one(oucube,iter%nt,error)
      if (error) return
      call oucube%tuple%elapsed_init(error)
      if (error)  return
    enddo
    !
    ! User feedback (after the output cubes have been prepared)
    call cubeadm_list_opened(error)
    if (error) return
  end subroutine cubeadm_datainit_allcubes_do
  !
  subroutine cubeadm_datainit_one(oucube,error)
    use cubeio_highlevel
    !-------------------------------------------------------------------
    ! Prepare the data IO for one cube
    !-------------------------------------------------------------------
    class(format_t), intent(inout) :: oucube
    logical,         intent(inout) :: error
    !
    ! Prepare HGDF and the descriptor (the later is needed between now
    ! and first data access)
    call cubeio_clone_header(oucube%user,oucube%prog,oucube,oucube%tuple%current,error)
    if (error) return
  end subroutine cubeadm_datainit_one
  !
  subroutine cubeadm_processinginit_one(oucube,ntasks,error)
    use cubetools_header_methods
    !-------------------------------------------------------------------
    ! Prepare the processing for one cube
    !-------------------------------------------------------------------
    class(format_t),      intent(inout) :: oucube
    integer(kind=entr_k), intent(in)    :: ntasks
    logical,              intent(inout) :: error
    !
    ! Re-initialize the extrema since they are about to be recomputed
    ! in the upcoming processing loop (OBSOLESCENT)
    ! BEWARE: ndat is also computed below
    call cubetools_header_extrema_init(oucube%head,error)
    if (error) return
    !
    ! Extrema are not recomputed if disabled or if complex. Leave them
    ! reinitialized on purpose.
    if (.not.oucube%user%output%extrema .or. oucube%iscplx())  return
    !
    ! Re-initialize the per-task extrema since they are about to be
    ! recomputed in the upcoming processing loop
    call oucube%proc%allocate_extrema(oucube%head,ntasks,error)
    if (error)  return
  end subroutine cubeadm_processinginit_one
  !
  function cubeadm_dataiterate_all(iter,error)
    !-------------------------------------------------------------------
    ! Iterate the iterator until all data is processed, and ensure all
    ! the registered cubes are ready to access their first to last
    ! entries.
    !-------------------------------------------------------------------
    logical :: cubeadm_dataiterate_all
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    ! Local
    integer(kind=entr_k) :: icube
    !
    ! Iteration
    cubeadm_dataiterate_all = cubeadm_taskloop_iterate(iter,error)
    if (error) return
    if (.not.cubeadm_dataiterate_all)   return  ! All done
    !
    ! Parents
    do icube=1,pa%n
      if (pa%flag(icube).eq.code_read .or.  &
          pa%flag(icube).eq.code_update) then  ! Skip parent which is code_read_head
        call cubeadm_dataiterate_one(pa%list(icube)%p,iter%prange,error)
        if (error) return
      endif
    enddo
    !
    ! Children
    do icube=1,ch%n
      call cubeadm_dataiterate_one(ch%list(icube)%p,iter%prange,error)
      if (error) return
    enddo
    !
  end function cubeadm_dataiterate_all
  !
  subroutine cubeadm_dataiterate_one(tot,refrange,error)
    use cubeadm_ioloop
    !-------------------------------------------------------------------
    ! Ensure the identified cube is ready to access its iter%first to
    ! iter%last entries.
    !-------------------------------------------------------------------
    class(tools_object_t), pointer       :: tot
    integer(kind=indx_k),  intent(in)    :: refrange(2)
    logical,               intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: dno
    class(format_t), pointer :: cube
    integer(kind=coor_k) :: thisrange(2)
    logical, parameter :: truncate=.true.
    character(len=*), parameter :: rname='DATAITERATE>ONE'
    !
    dno => cubedag_node_ptr(tot,error)
    if (error) return
    cube => cubetuple_format_ptr(dno,error)
    if (error)  return
    if (cube%access().eq.code_access_fullset) then
      call cube%iter%fullrange(thisrange,error)
      if (error)  return
    else
      call cube%iter%range(refrange,truncate,thisrange,error)
      if (error)  return
    endif
    call cubeadm_io_iterate_planes(thisrange(1),thisrange(2),cube,error)
    if (error) return
  end subroutine cubeadm_dataiterate_one
  !
  subroutine cubeadm_finish_all(comm,line,error)
    use cubedag_dag
    use cubedag_history
    !---------------------------------------------------------------------
    ! Finish all cubes currently opened in index.
    ! ---
    ! Beware this subroutine can be called in an error recovery context,
    ! i.e. with error = .true. on input
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: comm
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FINISH>ALL'
    integer(kind=entr_k) :: ient,hid
    logical :: lerror
    class(cubedag_node_object_t), pointer :: dno
    !
    lerror = .false.  ! Local error
    !
    ! Insert in history
    if (.not.error) then
      ! If you plan to put failed commands in the HISTORY list,
      ! you can not reference output cubes ('ch' list) which are
      ! not inserted in DAG but destroyed instead.
      call cubedag_history_add_tohx(comm,line,pa,ch,hid,lerror)
      if (lerror) continue
    endif
    !
    if (.not.error) then
      ! Update the links between parents and children, according to their read/write
      ! status. This is to be done before the cubes are freed (finalized)
      call cubedag_node_links(pa,ch,hid,lerror)
      if (lerror) continue
    endif
    !
    ! Deal with the input cubes (including cubes opened in UPDATE mode, needing
    ! to be written on disk).
    do ient=1,pa%n
      dno => cubedag_node_ptr(pa%list(ient)%p,lerror)
      if (lerror) exit
      call cubeadm_finish_one(dno,lerror)
      if (lerror) exit
    enddo
    !
    ! Deal with the output cubes
    do ient=1,ch%n
      dno => cubedag_node_ptr(ch%list(ient)%p,lerror)
      if (lerror) exit
      call cubeadm_finish_one(dno,lerror)
      if (lerror) exit
      if (error) then
        call cubedag_node_destroy(dno,lerror)
        if (lerror) exit
      else
        call cubedag_dag_attach(dno,lerror)
        if (lerror) exit
      endif
    enddo
    !
    ! Reset parents and children list
    call cubeadm_parents_children_reset()
    !
    ! Ensure the ID counter is up-to-date (in particular if an error
    ! occured, i.e. the output cubes were discarded)
    call cubedag_dag_updatecounter(lerror)
    if (lerror) continue
    !
    if (lerror) error = .true.
    !
  end subroutine cubeadm_finish_all
  !
  subroutine cubeadm_finish_one(format,error)
    use cubeadm_timing
    !-------------------------------------------------------------------
    ! Finish one cube given its id
    ! ---
    ! Beware this subroutine can be called in an error recovery context
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(inout) :: format
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FINISH>ONE'
    !
    if (error) return  ! Error recovery: we should probably do some cleaning below!
    !
    select type (format)
    class is (format_t)
      call format%finish(error)
      if (error) continue
      call format%dag_upsert(error)
      if (error) continue
      call cubeadm_timing_collect(format)
      ! Always free the GIO slot, which is a limited ressource. The other
      ! ressources are handled by the GC
      call format%close(error)
      if (error) return
    type is (cubedag_node_object_t)
      ! For the root object which is sometimes the parent node
      continue
    class default
      call cubeadm_message(seve%e,rname,'Object has wrong type')
      error = .true.
      return
    end select
  end subroutine cubeadm_finish_one
  !
  subroutine alluser_reallocate(nuser,error)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    integer(kind=list_k), intent(in)    :: nuser
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='ALLUSER>REALLOCATE'
    character(len=argu_l), allocatable :: tmp(:)
    integer(kind=entr_k) :: oldsize,newsize
    integer(kind=4) :: ier
    !
    if (allocated(alluser)) then
      oldsize = size(alluser)
      if (oldsize.ge.nuser)  return
      allocate(tmp(oldsize),stat=ier)
      if (failed_allocate(rname,'tmp',ier,error)) return
      tmp(:) = alluser(:)
      deallocate(alluser)
      newsize = max(min_alluser_alloc,2*oldsize)
    else
      newsize = min_alluser_alloc
    endif
    !
    allocate(alluser(newsize),stat=ier)
    if (failed_allocate(rname,'alluser',ier,error)) return
    if (allocated(tmp)) then
      alluser(1:oldsize) = tmp(:)
      deallocate(tmp)
    endif
  end subroutine alluser_reallocate
  !
  subroutine cubeadm_opened_list_size(ucols,custom,error)
    use cubedag_list
    !----------------------------------------------------------------------
    ! Defines de size and columns of a list from a list of columns
    ! based on the currently opened cubes
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: ucols(:)
    integer(kind=4),  intent(out)   :: custom(20)
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: ukeys(20),ncol
    character(len=*), parameter :: rname='OPENED>LIST>SIZE'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    ncol = size(ucols)
    call cubedag_list_columns_parse(ncol,ucols,ukeys,error)
    if (error) return
    call cubedag_list_columns_set(ukeys,custom,error)
    if (error) return
    call cubedag_list_link_widths(all,custom,error)
    if (error) return
  end subroutine cubeadm_opened_list_size
end module cubeadm_opened

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_tuple
  use gkernel_interfaces
  use cubetools_parameters
  use cubedag_messaging
  !
  public :: cubedag_tuple_t
  public :: cubedag_tuple_upsert,cubedag_tuple_setconsistent,  &
            cubedag_tuple_hasuptodatefile,cubedag_tuple_reset,  &
            cubedag_tuple_diskupdate,cubedag_tuple_rmmemo,cubedag_tuple_rmfiles
  private
  !
  integer(kind=4), parameter :: tuple_mdisk=4
  integer(kind=4), parameter :: tuple_mmemo=7
  !
  type :: cubedag_tuple_t
    integer(kind=code_k)  :: code(tuple_mmemo) = 0
    integer(kind=8)       :: tstamp(tuple_mmemo) = 0
    character(len=file_l) :: file(tuple_mmemo) = ''
    integer(kind=4)       :: hdu(tuple_mmemo) = 0
  contains
    procedure         :: list      => cubedag_tuple_list
    procedure         :: hascube   => cubedag_tuple_hascube
    procedure         :: filename  => cubedag_tuple_filename
    procedure         :: location  => cubedag_tuple_location
    procedure         :: debug     => cubedag_tuple_debug
    procedure         :: disksizes => cubedag_tuple_disksizes
    procedure         :: disksize  => cubedag_tuple_disksize
    procedure         :: contains  => cubedag_tuple_contains
    procedure, public :: write     => cubedag_tuple_write
    procedure, public :: read02    => cubedag_tuple_read02
    procedure, public :: read03    => cubedag_tuple_read03
    procedure, public :: read      => cubedag_tuple_read
    procedure, public :: to_struct => cubedag_tuple_to_struct
  end type cubedag_tuple_t
  !
  ! Formats in DAG file
  character(len=*), parameter :: form_tup02='(A,T26,I11,I20,3X,A)'        ! For version 0.2 and below
  character(len=*), parameter :: form_tup  ='(A,T26,I11,I20,1X,A,1X,I0)'  ! For version 0.3 and above
  !
contains
  !
  subroutine cubedag_tuple_reset(tuple)
    !---------------------------------------------------------------------
    ! Fully reset a tuple
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(out) :: tuple
    return
  end subroutine cubedag_tuple_reset
  !
  subroutine cubedag_tuple_read02(tup,lun,error)
    !---------------------------------------------------------------------
    ! Read tuple from disk for version 0.2 and earlier
    !---------------------------------------------------------------------
    class(cubedag_tuple_t), intent(out)   :: tup
    integer(kind=4),        intent(in)    :: lun
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ02'
    integer(kind=4) :: ier,access,pos,i
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    character(len=12) :: key
    !
    do i=1,tuple_mdisk
      read(lun,form_tup02,iostat=ier)  key,access,tstamp,file
      if (ier.lt.0)                exit  ! EOF
      if (ier.gt.0) then
        call putios('E-TUPLE>READ,  ',ier)
        error = .true.
        return
      endif
      pos = cubedag_tuple_position(access,code_buffer_disk)
      tup%code(pos) = access
      tup%tstamp(pos) = tstamp
      tup%file(pos) = file
      tup%hdu(pos) = 1  ! Default in version 0.2
    enddo
  end subroutine cubedag_tuple_read02
  !
  subroutine cubedag_tuple_read03(tup,lun,error)
    !---------------------------------------------------------------------
    ! Read tuple version 0.3
    ! In this version, file paths are relative to current working
    ! directory
    !---------------------------------------------------------------------
    class(cubedag_tuple_t), intent(out)   :: tup
    integer(kind=4),        intent(in)    :: lun
    logical,                intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ'
    integer(kind=4) :: ier,access,pos,i,hdu
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    character(len=12) :: key
    !
    do i=1,tuple_mdisk
      ! List-directed read allows for flexible file length
      read(lun,*,iostat=ier)  key,access,tstamp,file,hdu
      if (ier.lt.0)                exit  ! EOF
      if (ier.gt.0) then
        call putios('E-TUPLE>READ,  ',ier)
        error = .true.
        return
      endif
      pos = cubedag_tuple_position(access,code_buffer_disk)
      tup%code(pos) = access
      tup%tstamp(pos) = tstamp
      tup%file(pos) = file
      tup%hdu(pos) = hdu
    enddo
  end subroutine cubedag_tuple_read03
  !
  subroutine cubedag_tuple_read(tup,lun,dagdir,curdir,error)
    use cubetools_realpath
    !---------------------------------------------------------------------
    ! Read tuple from disk for latest versions
    !---------------------------------------------------------------------
    class(cubedag_tuple_t),     intent(out)   :: tup
    integer(kind=4),            intent(in)    :: lun
    character(len=*),           intent(in)    :: dagdir
    type(cubetools_realpath_t), intent(inout) :: curdir
    logical,                    intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>READ'
    integer(kind=4) :: ier,access,pos,i,hdu
    integer(kind=8) :: tstamp
    character(len=file_l) :: file
    character(len=12) :: key
    type(cubetools_realpath_t) :: path
    !
    do i=1,tuple_mdisk
      ! List-directed read allows for flexible file length
      read(lun,*,iostat=ier)  key,access,tstamp,file,hdu
      if (ier.lt.0)                exit  ! EOF
      if (ier.gt.0) then
        call putios('E-TUPLE>READ,  ',ier)
        error = .true.
        return
      endif
      pos = cubedag_tuple_position(access,code_buffer_disk)
      tup%code(pos) = access
      tup%tstamp(pos) = tstamp
      tup%hdu(pos) = hdu
      !
      if (file.ne.'') then
        ! File path was saved absolute, or relative to the directory of
        ! the DAG file
        call path%absolutefrom(file,dagdir)
        ! And now resolve file path relative to current directory
        tup%file(pos) = path%relativeto(curdir)
      endif
    enddo
  end subroutine cubedag_tuple_read
  !
  subroutine cubedag_tuple_write(tup,lun,dagpath,error)
    use cubetools_realpath
    !---------------------------------------------------------------------
    ! Write tuple to disk
    !---------------------------------------------------------------------
    class(cubedag_tuple_t),     intent(in)    :: tup
    integer(kind=4),            intent(in)    :: lun
    type(cubetools_realpath_t), intent(inout) :: dagpath
    logical,                    intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>WRITE'
    integer(kind=4) :: i
    character(len=file_l) :: relpath
    type(cubetools_realpath_t) :: path
    !
    do i=1,tuple_mdisk
      ! Compute path relative to the DAG file (cube.dag)
      call path%resolve(tup%file(i))
      relpath = path%relativeto(dagpath)
      !
      write(lun,form_tup)  'TUPLE',  &
                           tup%code(i),  &
                           tup%tstamp(i),  &
                           '"'//trim(relpath)//'"', &  ! Quotes to support partially or fully blank strings
                           tup%hdu(i)
    enddo
  end subroutine cubedag_tuple_write
  !
  subroutine cubedag_tuple_upsert(tup,access,location,onefile,hdu,error)
    !---------------------------------------------------------------------
    ! Insert (if the file is new) or update (if the file has changed) one
    ! file in the tuple file. Nothing done if file is already up-to-date.
    ! If file does not exist, its timestamp is set to 0.
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    integer(kind=code_k),  intent(in)    :: access
    integer(kind=code_k),  intent(in)    :: location
    character(len=*),      intent(in)    :: onefile
    integer(kind=4),       intent(in)    :: hdu
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>UPSERT'
    logical :: updated
    !
    updated = .false.
    call cubedag_tuple_upsert_one(tup,access,location,onefile,hdu,updated,error)
    if (error)  return
  end subroutine cubedag_tuple_upsert
  !
  subroutine cubedag_tuple_upsert_one(tup,access,location,onefile,hdu,updated,error)
    !---------------------------------------------------------------------
    ! Upsert one entry
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    integer(kind=code_k),  intent(in)    :: access
    integer(kind=code_k),  intent(in)    :: location
    character(len=*),      intent(in)    :: onefile
    integer(kind=4),       intent(in)    :: hdu
    logical,               intent(inout) :: updated
    logical,               intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,pos
    integer(kind=8) :: mtime
    logical :: update
    !
    pos = cubedag_tuple_position(access,location)
    !
    if (location.eq.code_buffer_disk) then
      if (gag_inquire(onefile,len_trim(onefile)).eq.0) then
        ! File exists or it disappeared
        ier = gag_mtime(onefile,mtime)
        ! ZZZ should trap error
        update = mtime.gt.tup%tstamp(pos)
      else
        mtime = 0
        update = .true.
      endif
    else
      mtime = 1
      update = .true.
    endif
    !
    if (update) then
      ! ZZZ Should we complain if file name has changed?
      tup%code(pos) = access
      tup%tstamp(pos) = mtime
      tup%file(pos) = onefile
      tup%hdu(pos) = hdu
      updated = .true.
    endif
  end subroutine cubedag_tuple_upsert_one
  !
  subroutine cubedag_tuple_diskupdate(tup,error)
    !-------------------------------------------------------------------
    ! Update the disk file timestamps of all the files ONLY IF THEY HAVE
    ! CHANGED. The consistency timestamp is left unchanged on purpose.
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    ! Local
    logical :: updated
    !
    updated = .false.
    call cubedag_tuple_diskupdate_one(tup,code_cube_imaset,code_buffer_disk,updated,error)
    if (error)  return
    call cubedag_tuple_diskupdate_one(tup,code_cube_speset,code_buffer_disk,updated,error)
    if (error)  return
  end subroutine cubedag_tuple_diskupdate
  !
  subroutine cubedag_tuple_diskupdate_one(tup,access,location,updated,error)
    !-------------------------------------------------------------------
    ! Update the timestamp of one file ONLY IF IT HAS CHANGED.
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    integer(kind=code_k),  intent(in)    :: access
    integer(kind=code_k),  intent(in)    :: location
    logical,               intent(inout) :: updated
    logical,               intent(inout) :: error
    ! Local
    integer(kind=4) :: pos,pos_cons
    character(len=*), parameter :: rname='TUPLE>DISKUPDATE>ONE'
    !
    if (location.eq.code_buffer_memory)  return  ! Only relevant for disk files
    pos = cubedag_tuple_position(access,location)
    if (tup%tstamp(pos).eq.0)  return  ! Nothing to update for this access
    !
    if (gag_inquire(tup%file(pos),len_trim(tup%file(pos))).ne.0) then
      ! File is referenced but it disappeared: discard it
      call cubedag_message(seve%w,rname,  &
        'File '//trim(tup%file(pos))//' does not exist anymore')
      tup%tstamp(pos) = 0
      tup%file(pos) = ''
      tup%hdu(pos) = 0
      ! For safety also disable the consistency flag
      pos_cons = cubedag_tuple_position(code_null,code_null)
      tup%tstamp(pos_cons) = 0
      tup%file(pos_cons) = ''
      tup%hdu(pos_cons) = 0
      updated = .true.
      return
    endif
    !
    ! File exists: update if needed
    call cubedag_tuple_upsert_one(tup,access,location,tup%file(pos),tup%hdu(pos),  &
      updated,error)
    if (error)  return
  end subroutine cubedag_tuple_diskupdate_one
  !
  subroutine cubedag_tuple_setconsistent(tup,error)
    !---------------------------------------------------------------------
    ! Insert or update the consistency flag. It is the responsibility of
    ! the caller to ensure the files are consistent at the time this
    ! subroutine is called.
    !---------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='TUPLE>SETCONSISTENCY'
    integer(kind=4) :: ier,pos
    integer(kind=8) :: time
    !
    if (tup%tstamp(cubedag_tuple_position(code_cube_imaset,code_buffer_disk)).le.0 .or.  &
        tup%tstamp(cubedag_tuple_position(code_cube_speset,code_buffer_disk)).le.0) then
      call cubedag_message(seve%e,rname,  &
        'Can not set consistency while the 2 cubes are not present in tuple')
      error = .true.
      return
    endif
    !
    ier = gag_time(time)
    pos = cubedag_tuple_position(code_null,code_null)
    tup%code(pos) = code_null
    tup%tstamp(pos) = time
    tup%file(pos) = 'consistency'
    tup%hdu(pos) = 0
  end subroutine cubedag_tuple_setconsistent
  !
  function cubedag_tuple_hasuptodatefile(tup,access,location,onefile,hdu,error)
    use cubetools_access_types
    !---------------------------------------------------------------------
    ! Get the file for the given access. The file is assumed "found" if
    ! 1) it is present in the tuple and
    ! 2 the tuple is consistent, or the tuple is inconsistent but the
    !   requested file is the newest.
    !---------------------------------------------------------------------
    logical :: cubedag_tuple_hasuptodatefile
    type(cubedag_tuple_t), intent(in)    :: tup
    integer(kind=code_k),  intent(in)    :: access  ! code_cube_*
    integer(kind=code_k),  intent(in)    :: location
    character(len=*),      intent(out)   :: onefile
    integer(kind=4),       intent(out)   :: hdu
    logical,               intent(inout) :: error
    ! Local
    integer(kind=4) :: pos
    integer(kind=8):: tstamp,ttstamp,ctstamp
    !
    cubedag_tuple_hasuptodatefile = .false.
    onefile = ''
    hdu = 0
    !
    pos = cubedag_tuple_position(access,location)
    if (pos.le.0) then
      error = .true.
      return
    endif
    !
    onefile = tup%file(pos)
    hdu     = tup%hdu(pos)
    tstamp  = tup%tstamp(pos)
    !
    if (access.eq.code_cube_unkset) then
      ! Consistency has no much meaning
      cubedag_tuple_hasuptodatefile = tstamp.gt.0
    else
      ! Check for consistent file between image set and spectrum set
      ttstamp = tup%tstamp(cubedag_tuple_position(cubetools_transpose_access(access),location))
      ctstamp = tup%tstamp(cubedag_tuple_position(code_null,code_null))
      if (tstamp.le.0) then
        ! File does not exist
        cubedag_tuple_hasuptodatefile = .false.
      elseif (ttstamp.le.0) then
        ! Transposed file does not exist: no consistency issue
        cubedag_tuple_hasuptodatefile = .true.
      elseif (tstamp.le.ctstamp .and. ttstamp.le.ctstamp) then
        ! Files are consistent
        cubedag_tuple_hasuptodatefile = .true.
      elseif (ttstamp.le.tstamp) then
        ! Files are not consistent, and the requested one is the newest
        cubedag_tuple_hasuptodatefile = .true.
      else
        ! Files are not consistent, and the transposed one is the newest
        cubedag_tuple_hasuptodatefile = .false.
      endif
    endif
  end function cubedag_tuple_hasuptodatefile
  !
  subroutine cubedag_tuple_list(tup,id,family,flag,error)
    use cubetools_format
    use cubedag_parameters
    use cubedag_flag
    !---------------------------------------------------------------------
    ! List the tuple contents
    !---------------------------------------------------------------------
    class(cubedag_tuple_t), intent(inout) :: tup
    integer(kind=iden_l),   intent(in)    :: id
    character(len=*),       intent(in)    :: family
    type(flag_list_t),      intent(in)    :: flag
    logical,                intent(inout) :: error
    ! Local
    logical :: consistent
    integer(kind=4) :: cpos,ipos,spos,upos,lstrflag
    character(len=128) :: strflag
    integer(kind=8) :: ctstamp,itstamp,ststamp,utstamp
    character(len=file_l) :: name
    character(len=50) :: shortname
    character(len=32) :: status
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='TUPLE>LIST'
    !
!!$ *** JP dagseve%trace is not (yet) defined
!!$    call cubedag_message(dagseve%trace,rname,'Welcome') 
    !
    ! *** JP Why a listing needs to update the content of the tuple? To be
    ! *** sure JP sur to be uptodate? If yes, this should be stated in the
    ! *** header of the subroutine.
    call cubedag_tuple_diskupdate(tup,error)
    if (error)  return
    !
    cpos = cubedag_tuple_position(code_null,code_null)
    spos = cubedag_tuple_position(code_cube_speset,code_buffer_disk)
    ipos = cubedag_tuple_position(code_cube_imaset,code_buffer_disk)
    upos = cubedag_tuple_position(code_cube_unkset,code_buffer_disk)
    ctstamp = tup%tstamp(cpos)
    ststamp = tup%tstamp(spos)
    itstamp = tup%tstamp(ipos)
    utstamp = tup%tstamp(upos)
    !
    ! Consistency
    consistent = .false.
    if (ststamp.le.0 .or. itstamp.le.0) then
       status = 'INCOMPLETE'
    elseif (ststamp.le.ctstamp .and. itstamp.le.ctstamp) then
       status = 'CONSISTENT'
       consistent = .true.
    else
       status = 'INCONSISTENT'
    endif
    !
    call flag%repr(strflag=strflag,lstrflag=lstrflag,error=error)
    if (error)  return
    write(name,'(i0,2x,3a)') id,trim(family),":",strflag(1:lstrflag)
    !
    mess = cubetools_format_stdkey_boldval('Identifier',name,60)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status',status,18)
    call cubedag_message(seve%r,rname,mess)
    !
    if (ststamp.le.0) then
       shortname = 'none'
       status = '---'
    else
       call cubedag_tuple_location(tup,code_cube_speset,code_buffer_disk,shortname)
       if (consistent) then
          status = 'UPTODATE'
       elseif (ststamp.gt.itstamp) then
          status = 'NEWER'
       else
          status = 'OUTDATED'
       endif
    endif
    mess = cubetools_format_stdkey_boldval('SpeSet',shortname,60)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status',status,18)
    call cubedag_message(seve%r,rname,mess)
    !
    if (itstamp.le.0) then
       shortname = 'none'
       status = '---'
    else
       call cubedag_tuple_location(tup,code_cube_imaset,code_buffer_disk,shortname)
       if (consistent) then
          status = 'UPTODATE'
       elseif (itstamp.gt.ststamp) then
          status = 'NEWER'
       else
          status = 'OUTDATED'
       endif
    endif
    mess = cubetools_format_stdkey_boldval('ImaSet',shortname,60)
    mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status',status,18)
    call cubedag_message(seve%r,rname,mess)
    !
    if (utstamp.gt.0) then
       call cubedag_tuple_location(tup,code_cube_unkset,code_buffer_disk,shortname)
       status = '---'
       mess = cubetools_format_stdkey_boldval('UnkSet',shortname,60)
       mess = trim(mess)//'  '//cubetools_format_stdkey_boldval('Status',status,18)
       call cubedag_message(seve%r,rname,mess)
    endif
    !
    call cubedag_message(seve%r,rname,'')
  end subroutine cubedag_tuple_list
  !
  function cubedag_tuple_position(access,location)
    !-------------------------------------------------------------------
    ! Convert an access code to the position in the cubedag_tuple_t
    !-------------------------------------------------------------------
    integer(kind=4) :: cubedag_tuple_position
    integer(kind=code_k), intent(in) :: access
    integer(kind=code_k), intent(in) :: location
    ! Local
    character(len=*), parameter :: rname='TUPLE>POSITION'
    !
    select case (access)
    case (code_null)
      cubedag_tuple_position = 1
    case (code_cube_speset)
      if (location.eq.code_buffer_disk) then
        cubedag_tuple_position = 2
      else
        cubedag_tuple_position = 5
      endif
    case (code_cube_imaset)
      if (location.eq.code_buffer_disk) then
        cubedag_tuple_position = 3
      else
        cubedag_tuple_position = 6
      endif
    case (code_cube_unkset)
      if (location.eq.code_buffer_disk) then
        cubedag_tuple_position = 4
      else
        cubedag_tuple_position = 7
      endif
    case default
      call cubedag_message(seve%e,rname,'Internal error: requesting unknown access')
      cubedag_tuple_position = 0
      return
    end select
  end function cubedag_tuple_position
  !
  function cubedag_tuple_hascube(tup,access,location)
    !-------------------------------------------------------------------
    ! Return true if the tuple provides the access+location cube
    !-------------------------------------------------------------------
    logical :: cubedag_tuple_hascube
    class(cubedag_tuple_t), intent(in) :: tup
    integer(kind=code_k),   intent(in) :: access
    integer(kind=code_k),   intent(in) :: location
    ! Local
    integer(kind=4) :: pos
    !
    pos = cubedag_tuple_position(access,location)
    cubedag_tuple_hascube = tup%tstamp(pos).gt.0
    !
  end function cubedag_tuple_hascube
  !
  function cubedag_tuple_filename(tup,access,location)
    !-------------------------------------------------------------------
    ! Return the file name for access+location cube
    !-------------------------------------------------------------------
    character(len=file_l) :: cubedag_tuple_filename
    class(cubedag_tuple_t), intent(in) :: tup
    integer(kind=code_k),   intent(in) :: access
    integer(kind=code_k),   intent(in) :: location
    ! Local
    integer(kind=4) :: pos
    !
    pos = cubedag_tuple_position(access,location)
    if (tup%tstamp(pos).le.0) then
      cubedag_tuple_filename = '<not-yet-defined>'
    else
      cubedag_tuple_filename = tup%file(pos)
    endif
    !
  end function cubedag_tuple_filename
  !
  subroutine cubedag_tuple_location(tup,access,location,shortloc)
    !-------------------------------------------------------------------
    ! Return the location of the cube referenced by the tuple,
    ! in a string suited for LIST (i.e. properly truncating it)
    !-------------------------------------------------------------------
    class(cubedag_tuple_t), intent(in)    :: tup
    integer(kind=code_k),   intent(in)    :: access
    integer(kind=code_k),   intent(in)    :: location
    character(len=*),       intent(out)   :: shortloc
    ! Local
    character(len=file_l) :: cubename
    integer(kind=4) :: nc,lmax,pos
    !
    cubename = tup%filename(access,location)
    nc = len_trim(cubename)
    !
    ! Append HDU number if relevant
    pos = cubedag_tuple_position(access,location)
    if (tup%hdu(pos).gt.1) then
      write(cubename(nc+1:),'(a1,i0,a1)') '[',tup%hdu(pos),']'
      nc = len_trim(cubename)
    endif
    !
    ! Truncate if needed
    lmax = len(shortloc)
    if (nc.gt.lmax) then
      shortloc = '...'//cubename(nc-(lmax-4):nc)
    else
      shortloc = cubename(1:nc)
    endif
  end subroutine cubedag_tuple_location

  subroutine cubedag_tuple_rmmemo(tup,error)
    !-------------------------------------------------------------------
    ! Unreference the memory buffers for all accesses
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    ! Local
    integer(kind=4) :: iaccess,pos
    integer(kind=code_k) :: accesses(3) =  &
      (/ code_cube_imaset,code_cube_speset,code_cube_unkset /)
    !
    do iaccess=1,3
      pos = cubedag_tuple_position(accesses(iaccess),code_buffer_memory)
      if (tup%tstamp(pos).gt.0) then
        tup%code(pos) = 0
        tup%file(pos) = ''
        tup%tstamp(pos) = 0
        tup%hdu(pos) = 0
      endif
    enddo
    !
  end subroutine cubedag_tuple_rmmemo

  subroutine cubedag_tuple_rmfiles(tup,error)
    !-------------------------------------------------------------------
    ! Remove all files on disk for the given tuple
    !-------------------------------------------------------------------
    type(cubedag_tuple_t), intent(inout) :: tup
    logical,               intent(inout) :: error
    ! Local
    integer(kind=4) :: iaccess,pos
    integer(kind=code_k) :: accesses(3) =  &
      (/ code_cube_imaset,code_cube_speset,code_cube_unkset /)
    !
    do iaccess=1,3
      pos = cubedag_tuple_position(accesses(iaccess),code_buffer_disk)
      if (tup%tstamp(pos).gt.0) then
        call gag_filrm(tup%file(pos))
        tup%code(pos) = 0
        tup%file(pos) = ''
        tup%tstamp(pos) = 0
        tup%tstamp(pos) = 0
      endif
    enddo
    !
  end subroutine cubedag_tuple_rmfiles

  subroutine cubedag_tuple_debug(tup)
    class(cubedag_tuple_t), intent(in) :: tup
    ! Local
    integer(kind=4) :: i
    do i=1,tuple_mmemo
      write(stdout,form_tup)  'TUPLE',tup%code(i),tup%tstamp(i),trim(tup%file(i)),tup%hdu(i)
    enddo
  end subroutine cubedag_tuple_debug

  function cubedag_tuple_disksizes(tup)
    !-------------------------------------------------------------------
    ! Return the disk footprint of ALL the files referenced by the tuple
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubedag_tuple_disksizes  ! [bytes]
    class(cubedag_tuple_t), intent(in) :: tup
    !
    cubedag_tuple_disksizes =  &
      tup%disksize(code_cube_imaset,code_buffer_disk) + &
      tup%disksize(code_cube_speset,code_buffer_disk) + &
      tup%disksize(code_cube_unkset,code_buffer_disk)
  end function cubedag_tuple_disksizes

  function cubedag_tuple_disksize(tup,access,location)
    !-------------------------------------------------------------------
    ! Return the disk footprint of one file in the tuple, if relevant
    !-------------------------------------------------------------------
    integer(kind=size_length) :: cubedag_tuple_disksize  ! [bytes]
    class(cubedag_tuple_t), intent(in) :: tup
    integer(kind=code_k),   intent(in) :: access
    integer(kind=code_k),   intent(in) :: location
    ! Local
    integer(kind=4) :: ier,nc
    integer(kind=8) :: onesize
    character(len=file_l) :: filename
    !
    cubedag_tuple_disksize = 0
    if (location.eq.code_buffer_memory)  return
    !
    filename = tup%filename(access,location)
    nc = len_trim(filename)
    if (gag_inquire(filename,nc).ne.0)  return
    !
    ! This is not what we want in case of several HDUs:
    ier = gag_filsize(filename(1:nc),onesize)
    if (ier.ne.0)  return
    !
    cubedag_tuple_disksize = onesize
  end function cubedag_tuple_disksize

  function cubedag_tuple_contains(tup,file,hdu)
    !-------------------------------------------------------------------
    ! Return .true. is the tuple references the named file
    !-------------------------------------------------------------------
    logical :: cubedag_tuple_contains
    class(cubedag_tuple_t), intent(in) :: tup
    character(len=*),       intent(in) :: file
    integer(kind=4),        intent(in) :: hdu
    !
    integer(kind=4) :: ipos,spos,upos
    logical :: isamefile,ssamefile,usamefile
    logical :: isamehdu,ssamehdu,usamehdu
    !
    ipos = cubedag_tuple_position(code_cube_imaset,code_buffer_disk)
    spos = cubedag_tuple_position(code_cube_speset,code_buffer_disk)
    upos = cubedag_tuple_position(code_cube_unkset,code_buffer_disk)
    !
    isamefile = gag_filsame(tup%filename(code_cube_imaset,code_buffer_disk),file)
    ssamefile = gag_filsame(tup%filename(code_cube_speset,code_buffer_disk),file)
    usamefile = gag_filsame(tup%filename(code_cube_unkset,code_buffer_disk),file)
    !
    isamehdu = tup%hdu(ipos).eq.hdu
    ssamehdu = tup%hdu(spos).eq.hdu
    usamehdu = tup%hdu(upos).eq.hdu
    !
    cubedag_tuple_contains = (isamefile.and.isamehdu) .or.  &
                             (ssamefile.and.ssamehdu) .or.  &
                             (usamefile.and.usamehdu)
  end function cubedag_tuple_contains

  subroutine cubedag_tuple_to_struct(tup,userspace,error)
    use cubetools_userspace
    use cubetools_userstruct
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(cubedag_tuple_t), intent(in)    :: tup
    class(userspace_t),     intent(inout) :: userspace
    logical,                intent(inout) :: error
    !
    character(len=file_l) :: filename
    logical :: memo
    type(userstruct_t), pointer :: struct
    type(userstruct_t) :: imastruct,spestruct
    character(len=*), parameter :: rname='TUPLE>TOSTRUCT'
    !
    call cubedag_message(seve%t,rname,'Welcome')
    !
    struct => cubetools_userstruct_ptr(userspace,error)
    if (error)  return
    call struct%def(error)
    if (error) return
    !
    ! Image set
    call struct%def_substruct('imaset',imastruct,error)
    if (error) return
    if (tup%hascube(code_cube_imaset,code_buffer_disk)) then
      call tup%location(code_cube_imaset,code_buffer_disk,filename)
    else
      filename = ''
    endif
    call imastruct%set_member('file',filename,error)
    if (error) return
    memo = tup%hascube(code_cube_imaset,code_buffer_memory)
    call imastruct%set_member('memory',memo,error)
    if (error) return
    !
    ! Spectrum set
    call struct%def_substruct('speset',spestruct,error)
    if (error) return
    if (tup%hascube(code_cube_speset,code_buffer_disk)) then
      call tup%location(code_cube_speset,code_buffer_disk,filename)
    else
      filename = ''
    endif
    call spestruct%set_member('file',filename,error)
    if (error) return
    memo = tup%hascube(code_cube_speset,code_buffer_memory)
    call spestruct%set_member('memory',memo,error)
    if (error) return
  end subroutine cubedag_tuple_to_struct

end module cubedag_tuple
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine get_gildas(rname,cinp,desc,hin,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! IMAGER
  ! @ public
  !   General tool to incarnate the SIC variable into a Gildas 
  !   derived type Fortran variable
  ! 
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname         ! Input caller name
  character(len=*), intent(in) :: cinp          ! Input variable name
  type(sic_descriptor_t), intent(out) :: desc   ! Descriptor
  type(gildas), intent(inout) :: hin            ! Gildas header 
  logical, intent(inout) :: error               ! Error flag 
  !
  logical :: found
  !
  ! Look at the SIC variable
  call sic_descriptor(cinp,desc,found)  
  if (.not.found) then
    call map_message(seve%e,rname,'No such SIC variable '//cinp)
    error = .true.
    return
  endif
  !
  ! If the descriptor is here, copy the Header in HIN
  if (.not.associated(desc%head)) then
    call map_message(seve%w,rname,  &
      'Variable '//trim(cinp)//' does not provide a header')
    call gildas_null(hin)
    ! This will be a simple Table
    hin%gil%form = desc%type              ! Variable type
    hin%gil%ndim = desc%ndim
    hin%gil%dim(1:desc%ndim) = desc%dims(1:desc%ndim)
  else
    !
    ! Locate the header - data area is given by desc%addr
    if (abs(desc%head%gil%type_gdf).eq.abs(code_gdf_uvt)) then
      call gildas_null(hin,type='UVT')
    else
      call gildas_null(hin)
    endif
    call gdf_copy_header(desc%head,hin,error)
  endif
end subroutine get_gildas
!
subroutine com_modify(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message 
  use phys_const
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER   Support for command
  !   SPECIFY KeyWord Value [/FOR ImageVariable] 
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  integer, parameter :: o_for=1
  character(len=*), parameter :: rname = 'SPECIFY'
  integer, parameter :: icode_uv=1, icode_dirty=2, icode_clean=3, icode_sky=4, icode_all=5
  !
  integer, parameter :: nterm=6
  integer, parameter :: ncode=5
  character(len=varname_length) :: arg
  character(len=12) :: term(nterm),chain,key,cline,clines(ncode)
  data term/'FREQUENCY', 'LINENAME', 'TELESCOPE', 'VELOCITY','BLANKING', 'FREQUENCIES'/
  integer :: i, iterm, narg, nc
  real(8) :: freq, freq_a,freq_b,value(3)
  real(4) :: velo, bval
  real(8) :: freqs(ncode)
  real(4) :: velos(ncode)
  logical :: do_freq, do_line, do_velo, do_freqs, do_blank, found, err
  logical :: do_uv, do_dirty, do_clean, do_sky, do_one, do_cont
  type(sic_descriptor_t) :: desc, descuv   ! Descriptor
  type(gildas) :: hin, hou
  integer :: iloop, nblock, new_nhb, ier
  real, allocatable :: din(:,:)
  !
  freq = 0.d0
  velo = -1.e9                     ! An impossible velocity
  do_freq = .false.
  do_line = .false.
  do_velo = .false.
  do_dirty = .false.
  do_clean = .false.
  do_sky = .false.
  do_uv = .false.
  do_one = .false.
  do_blank = .false.
  do_freqs = .false.
  do_cont = .false.  ! Continuum image
  !
  if (sic_present(o_for,0)) then
    ! /FOR option - Get variable name
    do_one = .true.
  else
    if (hcont%loca%size.ne.0) then
      do_cont = .true.
    endif
    if (hdirty%loca%size.ne.0) then
      freq = hdirty%gil%freq
      velo = hdirty%gil%voff
      cline = hdirty%char%line
      clines(icode_dirty) = hdirty%char%line
      freqs(icode_dirty) = freq
      velos(icode_dirty) = velo
      do_dirty = .true.
    endif
    if (hclean%loca%size.ne.0) then
      freq = hclean%gil%freq
      velo = hclean%gil%voff
      cline = hclean%char%line
      clines(icode_clean) = hclean%char%line
      freqs(icode_clean) = freq
      velos(icode_clean) = velo
      do_clean = .true.
    endif
    if (hsky%loca%size.ne.0) then
      freq = hsky%gil%freq
      velo = hsky%gil%voff
      cline = hsky%char%line
      clines(icode_sky) = hsky%char%line
      freqs(icode_sky) = freq
      velos(icode_sky) = velo
      do_sky = .true.
    endif
    !
    ! UV data must be last, to be pre-dominant in case a new UV
    ! table has been read, but Images are not yet recomputed.
    !
    ! Some warning should be given then
    if (huv%loca%size.ne.0) then
      if (freq.ne.0 .and. abs(freq-huv%gil%freq).gt.1.d0) then  ! MHz
        call map_message(seve%w,rname,'Images and UV data have different frequencies')
      endif
      freq = huv%gil%freq
      if (velo.ne.-1e9 .and. abs(velo-huv%gil%voff).gt.1.d-3) then ! km/s
        call map_message(seve%w,rname,'Images and UV data have different velocity frames')
      endif
      velo = huv%gil%voff
      cline = huv%char%line
      clines(icode_uv) = huv%char%line
      freqs(icode_uv) = freq
      velos(icode_uv) = velo
      do_uv = .true.
    endif
  endif
  !
  narg = sic_narg(0)
  do i = 1, narg, 2
    call sic_ke(line,0,i,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
    if (error) return
    !
    select case (key)
    case ('FREQUENCY')
      ! Modify velocity scale according to new rest frequency [MHz]
      call sic_r8(line,0,i+1,freq,.true.,error)
      do_freq = .true.
      !
    case ('VELOCITY')
      ! Modify Frequency scale according to new velocity (km/s)
      call sic_r4(line,0,i+1,velo,.true.,error)
      do_velo = .true.
      !
    case ('LINENAME')
      call sic_ch(line,0,i+1,cline,nc,.true.,error)
      do_line = .true.
      !
    case ('TELESCOPE')
      if (narg.gt.2) then
        call map_message(seve%e,rname,'TELESCOPE keyword is exclusive of other keywords')
        error = .true.
        return
      endif
      call sic_ke(line,0,i+1,chain,nc,.true.,error)
      if (error) return
      !
      if (do_one) then
        call sic_ch(line,o_for,1,arg,nc,.true.,error)
        if (error) return
        !
        ! Look at the SIC variable
        call sic_descriptor(arg,desc,found)  
        if (.not.found) then
          call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
          error = .true.
          return
        endif
        !
        ! There must be a Header in the descriptor... 
        if (.not.associated(desc%head)) then
          call map_message(seve%w,rname,  &
            'Variable '//arg(1:nc)//' does not provide a header')
          error = .true.
          return
        endif
        call gdf_setteles(desc%head,chain(1:nc),value,error)
      else
        !
        ! Update current UV and Initial UV data set if needed
        if (do_uv) then
          if (huv%gil%nteles.ge.1) then
            if (huv%gil%teles(1)%ctele .ne. chain(1:nc)) then
              call map_message(seve%i,rname,'Telescope ' &
              & //trim(huv%gil%teles(1)%ctele) &
              & //' in UV data overwritten by SPECIFY TELESCOPE '//chain(1:nc)) 
              ! Undefine the telescope so that all characteristics
              ! are re-defined by gdf_addteles after
              huv%gil%teles(1)%ctele = ' '
              huvi%gil%teles(1)%ctele = ' '
            endif
          endif
          call gdf_addteles(huv,'TELE',chain(1:nc),value,error)
          call gdf_addteles(huvi,'TELE',chain(1:nc),value,error)
        endif
        if (do_dirty) call gdf_setteles(hdirty,chain(1:nc),value,error)
        if (do_clean) call gdf_setteles(hclean,chain(1:nc),value,error)
        if (do_cont) call gdf_setteles(hcont,chain(1:nc),value,error)
        if (do_dirty) call gdf_setteles(hdirty,chain(1:nc),value,error)
      endif
      return
    case ('BLANKING') 
      call sic_r4(line,0,i+1,bval,.true.,error)
      do_blank = .true.
      !
    case ('FREQUENCIES') 
      if (sic_narg(0).ne.2) then
        call map_message(seve%e,rname,'SPECIFY FREQUENCIES is exclusive of other actions')
        error =.true.
        return
      endif
      call sic_ke(line,0,i+1,arg,nc,.true.,error)
      if (error) return
      do_freqs = .true.
    end select
    if (error) return
  enddo
  !
  ! FREQUENCIES case
  if (do_freqs) then
    ! 
    ! Look at the SIC variable holding the Frequencies
    call sic_descriptor(arg,desc,found)  
    if (.not.found) then
      call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
      error = .true.
      return
    endif
    if (desc%type.ne.fmt_r8) then
      call map_message(seve%e,rname,'SIC variable '//arg(1:nc)//' is not DOUBLE')
      error = .true.
      return
    endif
    !
    ! /FOR option
    if (do_one) then
      call sic_ch(line,o_for,1,arg,nc,.true.,error)
      if (error) return
      !
      if (index(arg,'.').ne.0) then
        ! It must be a file
        call gildas_null(hou,type='UVT')
        hou%file = arg
        !
        call gdf_read_header(hou,error)
        if (error)  return
        !
        ! Test if in-place work is possible
        new_nhb = 2 + (3*desc%dims(1)+ 2+10*hou%gil%nteles + 127)/128   ! Total number of HEADER blocks required...
        if (new_nhb.gt.hou%gil%nhb) then
          !
          ! A copy of the file is required - preceded or followed by renaming...
          call gdf_close_image(hou,error)
          !
          error = .false.    ! Indicate that Header Extension IS allowed
          call gdf_setfreqs(rname,desc,hou,error)
          if (error) return
          !
          call gildas_null(hin,type='UVT')
          hin%file = trim(arg)//'.old'
          ier = gag_filrename(hou%file,hin%file)
          !
          ! Read the header again (to get the proper NVB, actually)
          call gdf_read_header(hin,error)
          if (error) return
          !
          ! OK copy the whole stuff...
          call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
          nblock = min(nblock,hin%gil%dim(2))
          !
          allocate (din(hin%gil%dim(1),nblock),stat=ier)
          if (ier.ne.0) then
            call map_message(seve%e,rname,'Memory allocation error ')
            error = .true.
            return
          endif
          !
          hin%blc = 0
          hin%trc = 0
          hou%blc = 0
          hou%trc = 0
          call gdf_create_image(hou,error)
          if (error) return
          !
          call map_message(seve%i,rname,'Copying UV data ')
          do iloop = 1,hin%gil%dim(2),nblock
            hin%blc(2) = iloop
            hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
            hou%blc(2) = iloop
            hou%trc(2) = hin%trc(2)
            call gdf_read_data (hin,din,error)
            if (error) exit
            call gdf_write_data (hou,din, error)
            if (error) exit
          enddo
          err = .false.
          call gdf_close_image(hou,err)
          error = err.or.error
          !
          ! Remove the old file, or get back to it in case of failure
          if (error) then
            ier = gag_filrename(hin%file,hou%file)
          else
            call gag_filrm(hin%file)
          endif
        else
          !
          ! In place header update
          error = .true.    ! Indicate that Header Extension is NOT allowed
          call gdf_setfreqs(rname,desc,hou,error)
          if (.not.error) call gdf_update_header(hou,error)
          err = .false.
          call gdf_close_image(hou,err)
          error = err.or.error
        endif
      else
        !
        ! It must be a SIC variable
        call sic_descriptor(arg,descuv,found)  
        if (.not.found) then
          call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
          error = .true.
          return
        endif
        !
        ! There must be a Header in the descriptor... 
        if (.not.associated(descuv%head)) then
          call map_message(seve%w,rname,  &
            'Variable '//arg(1:nc)//' does not provide a header')
          error = .true.
          return
        endif
        error = .true.    ! Indicate that Header Extension is NOT allowed
        call gdf_setfreqs(rname,desc,descuv%head,error)
      endif
      !
    else
      !
      call sic_delvariable('UV',.false.,error)
      error = .false.    ! Indicate that Header Extension IS allowed
      call gdf_setfreqs(rname,desc,huv,error)
      err = .false.
      call sic_mapgildas('UV',huv,err,duv)
      error = err.or.error
    endif
    return
  endif
  !
  if (do_one) then
    call sic_ch(line,o_for,1,arg,nc,.true.,error)
    if (error) return
    !
    ! Look at the SIC variable
    call sic_descriptor(arg,desc,found)  
    if (.not.found) then
      call map_message(seve%e,rname,'No such SIC variable '//arg(1:nc))
      error = .true.
      return
    endif
    !
    ! There must be a Header in the descriptor... 
    if (.not.associated(desc%head)) then
      call map_message(seve%w,rname,  &
        'Variable '//arg(1:nc)//' does not provide a header')
      error = .true.
      return
    endif
    freq = desc%head%gil%freq
    velo = desc%head%gil%voff
    cline = desc%head%char%line
    clines(icode_all) = desc%head%char%line
    freqs(icode_all) = freq
    velos(icode_all) = velo
  endif
  !
  ! Syntax check
  if (do_blank.and..not.do_one) then
    call map_message(seve%e,rname,'Option /FOR required for SPECIFY BLANKING')
    error = .true.
    return
  endif
  !
  ! Now which ones ...
  if (do_freq) freqs = freq
  if (do_velo) velos = velo
  if (do_line) clines = cline
  !
  if (do_one) then
    call gdf_modify(desc%head,velos(icode_all),freqs(icode_all),error=error)
    desc%head%char%line = clines(icode_all)
    if (do_blank) then
      call modify_blanking(desc,bval,error)
      if (error) return
    endif
  else 
    if (do_uv) then  !!  if (huv%loca%size.ne.0) then
      freq_b = gdf_uv_frequency(huv,1.d0)
      call gdf_modify(huv,velos(icode_uv),freqs(icode_uv),error=error)
      freq_a = gdf_uv_frequency(huv,1.d0)
      if (abs(freq_a-freq_b).gt.10.0) then
        Print *,'Frequency Before ',freq_b
        Print *,'Frequency After ',freq_a
        Print *,'Frequency Difference ',freq_a-freq_b
      endif
      huv%char%line = clines(icode_uv)
    endif
    if (do_dirty) then
      call gdf_modify(hdirty,velos(icode_dirty),freqs(icode_dirty),error=error)
      hdirty%char%line = clines(icode_dirty)
    endif
    if (do_clean) then
      call gdf_modify(hclean,velos(icode_clean),freqs(icode_clean),error=error)
      hclean%char%line = clines(icode_clean)
    endif
    if (do_sky) then
      call gdf_modify(hsky,velos(icode_sky),freqs(icode_sky),error=error)
      hsky%char%line = clines(icode_sky)
    endif
  endif
  !
end subroutine com_modify
!
subroutine modify_blanking(desc,bval,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  ! 
  !   IMAGER
  !     Support routine for SPECIFY BLANKING
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(inout) :: desc
  real, intent(in) :: bval
  logical, intent(out) :: error
  !
  type(c_ptr) :: cptr
  real(4), pointer :: rdata(:)
  integer(kind=index_length) :: i
  !
  if (desc%head%gil%eval.lt.0) return
  !
  if (desc%head%gil%form.eq.fmt_r4) then
    call adtoad(desc%addr,cptr,1)
    call c_f_pointer(cptr,rdata,[desc%size])
    !
    do i=1,desc%size
      if (abs(rdata(i)-desc%head%gil%bval).le.desc%head%gil%eval) rdata(i) = bval
    enddo
    desc%head%gil%bval = bval
    desc%head%gil%eval = 0.0 
  else
    call map_message(seve%e,'SPECIFY','Unsupported data format for BLANKING')
    error = .true.
    return
  endif
end subroutine modify_blanking
!
subroutine gdf_setfreqs(rname,desc,huv,error)
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, only : map_message 
  use gbl_message
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER   Support for command
  !   SPECIFY FREQUENCIES Array [/FOR ImageVariable] 
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(sic_descriptor_t), intent(in) :: desc
  type(gildas), intent(inout) :: huv
  logical, intent(inout) :: error
  !
  integer :: stoke, new_nhb, ier
  type(c_ptr) :: cptr
  real(8), pointer :: dptr(:)
  !
  ! Verify match with number of channels of UV data
  if (desc%dims(1).ne.huv%gil%nchan) then
    call map_message(seve%e,rname,'Frequencies list does not match number of channels in UV data')
    error = .true.
    return
  endif
  !
  stoke = 0
  if (huv%gil%nstokes.eq.1) then
    if (associated(huv%gil%stokes)) stoke = huv%gil%stokes(1)
  else if (huv%gil%nstokes.ne.0) then
    call map_message(seve%e,rname,'FREQUENCIES only work for 1 Stokes')
    error = .true.
    return
  endif
  !
  if (huv%gil%nfreq.eq.0) then
    huv%gil%nfreq = desc%dims(1)
    allocate (huv%gil%freqs(huv%gil%nfreq),huv%gil%stokes(huv%gil%nfreq),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'FREQUENCIES allocation error')
      error = .true.
      return
    endif
    huv%gil%stokes = stoke
  endif
  !
  new_nhb = 2 + (3*huv%gil%nfreq + 2+10*huv%gil%nteles + 127)/128   ! Total number of HEADER blocks required...
  if (new_nhb.gt.huv%gil%nhb) then
    if (error) then
      call map_message(seve%e,rname,'Header cannot be extended in place')
      return
    endif
    call map_message(seve%w,rname,'Header is being extended')
  else
    call map_message(seve%d,rname,'Header is updated in place')
  endif
  !
  call adtoad(desc%addr,cptr,1)
  call c_f_pointer(cptr,dptr,[huv%gil%nfreq])
  huv%gil%freqs(:) = dptr
  call gdf_setuv(huv,error)
  !
end subroutine gdf_setfreqs
!
subroutine gdf_setteles(head,chain,value,error)
  use image_def
  use imager_interfaces, only : map_message
  use gbl_message
  ! @ private
  type(gildas), intent(inout) :: head
  character(len=*), intent(in) :: chain
  real(8), intent(in) :: value(*)
  logical, intent(inout) :: error
  !
  if (head%gil%nteles.ge.1) then
    if (head%gil%teles(1)%ctele .ne. chain) then
      if ( abs(head%gil%type_gdf).eq.abs(code_gdf_uvt) ) then        
          call map_message(seve%i,'SPECIFY','Telescope ' &
          & //trim(head%gil%teles(1)%ctele) &
          & //' in UV data overwritten by SPECIFY TELESCOPE '//chain) 
      endif
      ! Undefine the telescope so that all characteristics
      ! are re-defined by gdf_addteles after
      head%gil%teles(1)%ctele = ' '
    endif
  endif
  call gdf_addteles(head,'TELE',chain,value,error)
end subroutine gdf_setteles

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_ppv2xyv
  use cube_types 
  use cubetools_parameters
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetopology_cuberegion_types
  use cubehistogram_messaging
  !
  public :: ppv2xyv
  private
  !
  type :: ppv2xyv_comm_t
     type(option_t), pointer :: comm
!     type(cuberegion_comm_t) :: region
     type(cubeid_arg_t), pointer :: fromto
     type(cubeid_arg_t), pointer :: histo2d
     type(cubeid_arg_t), pointer :: ppv
     type(cube_prod_t),  pointer :: xyv
   contains
     procedure, public  :: register => cubehistogram_ppv2xyv_comm_register
     procedure, private :: parse    => cubehistogram_ppv2xyv_comm_parse
     procedure, private :: main     => cubehistogram_ppv2xyv_comm_main
  end type ppv2xyv_comm_t
  type(ppv2xyv_comm_t) :: ppv2xyv  
  !
  type ppv2xyv_user_t
     type(cubeid_user_t) :: cubeids
!     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubehistogram_ppv2xyv_user_toprog
  end type ppv2xyv_user_t
  !
  type ppv2xyv_prog_t
!     type(cuberegion_prog_t) :: region
     type(cube_t), pointer :: fromto
     type(cube_t), pointer :: histo2d
     type(cube_t), pointer :: ppv
     type(cube_t), pointer :: xyv
   contains
     procedure, private :: header => cubehistogram_ppv2xyv_prog_header
     procedure, private :: data   => cubehistogram_ppv2xyv_prog_data
     procedure, private :: loop   => cubehistogram_ppv2xyv_prog_loop
     procedure, private :: act    => cubehistogram_ppv2xyv_prog_act
  end type ppv2xyv_prog_t
  !
contains
  !
  subroutine cubehistogram_ppv2xyv_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(ppv2xyv_user_t) :: user
    character(len=*), parameter :: rname='PPV2XYV>COMMAND'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call ppv2xyv%parse(line,user,error)
    if (error) return
    call ppv2xyv%main(user,error)
    if (error) continue
  end subroutine cubehistogram_ppv2xyv_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(inout) :: comm
    logical,                 intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='PPV2XYV>COMM>REGISTER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'PPV2XYV','[ppvid fromtoid histo2did]',&
         'Stack spectra according to a 2D histogram',&
         strg_id,&
         cubehistogram_ppv2xyv_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'PPV',&
         'Position-Position-Velocity cube',&
         strg_id,&
         code_arg_optional,&
         !         [flag_ppv,flag_cube],&
         [flag_cube],&
         code_read,&
         code_access_imaset,&
         comm%ppv,&
         error)
    if (error) return
    call incube%register(&
         'FROMTO',&
         'From PP to XY',&
         'Image explaining how to go from a PP image to a bin of XY histo2d',&
         code_arg_optional,&
         [flag_histo2d,flag_pointer],&
         code_read,&
         code_access_imaset,&
         comm%fromto,&
         error)
    if (error) return
    call incube%register(&
         'HISTO2D',&
         '2D histogram',&
         strg_id,&
         code_arg_optional,&
         [flag_histo2d],&
         code_read_head,&
         code_access_imaset,&
         comm%histo2d,&
         error)
    if (error) return
!    call comm%region%register(error)
!    if (error) return
    !
    ! Products
    call oucube%register(&
         'XYV',&
         'X-Y-Velocity cube',&
         strg_id,&
         [flag_xyv,flag_cube],&
         comm%xyv,&
         error)
    if (error)  return
  end subroutine cubehistogram_ppv2xyv_comm_register
  !
  subroutine cubehistogram_ppv2xyv_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! PPV2XYV fromtoid ppvid
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(in)    :: comm
    character(len=*),      intent(in)    :: line
    type(ppv2xyv_user_t),  intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>COMM>PARSE'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
!!$    call comm%region%parse(line,user%region,error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_comm_parse
  !
  subroutine cubehistogram_ppv2xyv_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_comm_t), intent(in)    :: comm
    type(ppv2xyv_user_t),  intent(inout) :: user
    logical,               intent(inout) :: error
    !
    type(ppv2xyv_prog_t) :: prog
    character(len=*), parameter :: rname='PPV2XYV>MAIN'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubehistogram_ppv2xyv_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_user_t), intent(in)    :: user
    type(ppv2xyv_comm_t),  intent(in)    :: comm
    type(ppv2xyv_prog_t),  intent(out)   :: prog
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>USER>TOPROG'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_get_header(comm%ppv,user%cubeids,prog%ppv,error)
    if (error) return
    call cubeadm_get_header(comm%fromto,user%cubeids,prog%fromto,error)
    if (error) return
    call cubeadm_get_header(comm%histo2d,user%cubeids,prog%histo2d,error)
    if (error) return
!!$    call user%region%toprog(prog%fromto,prog%region,error)
!!$    if (error) return
!!$    ! User feedback about the interpretation of his command line
!!$    call prog%region%list(error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubehistogram_ppv2xyv_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    type(ppv2xyv_comm_t),  intent(in)    :: comm
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='PPV2XYV>PROG>HEADER'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_header(comm%xyv,prog%ppv,prog%xyv,error)
    if (error) return
    call cubetools_header_spatial_like(prog%histo2d%head,prog%xyv%head,error)
    if (error) return
!!$    call prog%region%header(prog%xyv,error)
!!$    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_header
  !
  subroutine cubehistogram_ppv2xyv_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    logical,               intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='PPV2XYV>PROG>DATA'
    !
    call cubehistogram_message(histogramseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubehistogram_ppv2xyv_prog_data
  !   
  subroutine cubehistogram_ppv2xyv_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t),    intent(inout) :: prog
    type(cubeadm_iterator_t), intent(inout) :: iter
    logical,                  intent(inout) :: error
    !
    type(image_t) :: fromto
    type(image_t) :: pp,xy
    type(dble_2d_t) :: sum
    type(long_2d_t) :: wei
    character(len=*), parameter :: rname='PPV2XYV>PROG>LOOP'
    !
    call fromto%associate('fromto',prog%fromto,iter,error)
    if (error) return
    call pp%associate('pp',prog%ppv,iter,error)
    if (error) return
    call xy%allocate('xy',prog%xyv,iter,error)
    if (error) return
    call sum%reallocate('sum',xy%nx,xy%ny,error)
    if (error) return
    call wei%reallocate('weight',xy%nx,xy%ny,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,fromto,pp,xy,sum,wei,error)
      if (error) return
    enddo ! ie
  end subroutine cubehistogram_ppv2xyv_prog_loop
  !
  subroutine cubehistogram_ppv2xyv_prog_act(prog,ie,fromto,pp,xy,sum,wei,error)
    use cubetools_nan
    use cubetools_array_types
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(ppv2xyv_prog_t), intent(inout) :: prog
    integer(kind=entr_k),  intent(in)    :: ie
    type(image_t),         intent(inout) :: fromto
    type(image_t),         intent(inout) :: pp
    type(image_t),         intent(inout) :: xy
    type(dble_2d_t),       intent(inout) :: sum
    type(long_2d_t),       intent(inout) :: wei
    logical,               intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    integer(kind=pixe_k) :: jx,jy
    integer(kind=indx_k) :: index
    integer(kind=long_k), parameter :: zero=0
    character(len=*), parameter :: rname='PPV2XYV>PROG>ACT'
    !
    call fromto%get(ie,error)
    if (error) return
    call pp%get(ie,error)
    if (error) return
    ! Initialize
    call wei%set(zero,error)
    if (error) return
    call sum%set(0d0,error)
    if (error) return
    ! Sum the input pixels using the fromto mask
    do iy=1,fromto%ny
       do ix=1,fromto%nx
          if (ieee_is_nan(fromto%val(ix,iy)).or.ieee_is_nan(pp%val(ix,iy))) cycle
          index = fromto%val(ix,iy)
          if (index.eq.0) cycle
          jx = 1+mod(index-1,xy%nx)
          jy = 1+(index-jx)/xy%nx
          ! The user can provide an inconsistent set of fromto and histo2d images!
          if ((1.le.jx).and.(jx.le.wei%nx).and.(1.le.jy).and.(jy.le.wei%ny)) then
             wei%val(jx,jy) = wei%val(jx,jy) + 1
             sum%val(jx,jy) = sum%val(jx,jy) + pp%val(ix,iy)
          else
             ! ***JP: Some shorter feedback to user? For instance counting
             ! ***JP: the number of points outside and stating it at the end?
             print *,jx,jy,wei%nx,wei%ny
          endif
       enddo ! ix
    enddo ! iy
    ! Compute xy
    do iy=1,xy%ny
       do ix=1,xy%nx
          if (wei%val(ix,iy).ne.zero) then
             xy%val(ix,iy) = sum%val(ix,iy)/wei%val(ix,iy)
          else
             xy%val(ix,iy) = gr4nan
          endif
       enddo ! ix
    enddo ! iy
    call xy%put(ie,error)
    if (error) return
  end subroutine cubehistogram_ppv2xyv_prog_act
end module cubehistogram_ppv2xyv
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubeadm_list
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubeadm_messaging
  use cubeadm_cubeid_types
  !
  public :: cubeadm_list_register
  private
  !
  type :: list_comm_t
     type(option_t),      pointer :: list        
     type(cubeid_arg_t),  pointer :: listarg
     type(option_t),      pointer :: index
     type(keywordlist_comm_t), pointer :: index_arg
     type(option_t),      pointer :: toc
     type(keywordlist_comm_t), pointer :: toctopic_arg
     type(option_t),      pointer :: page        
     type(option_t),      pointer :: columns     
     type(keywordlist_comm_t), pointer :: column_arg
     type(option_t),      pointer :: file
     type(option_t),      pointer :: variable    
  end type list_comm_t
  type(list_comm_t) :: comm
  !
  ! *** JP: Can't we use a generic interface mecanism to alias the definition?
  !
contains
  subroutine cubeadm_list_register(error)
    use cubetools_setup_types
    use cubedag_allflags
    use cubedag_list
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    logical,          intent(inout) :: error
    !
    type(cubeid_arg_t)   :: cubearg
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: comm_abstract = &
         'List the cubes in the default index or the given index'
    character(len=*), parameter :: comm_help = &
         'LIST is used for a quick look to cube headers, in a more or&
         & less detailed format. A medium-sized format is used by&
         & default, this can be changed with option /COLUMNS. If the&
         & list is too large it can be displayed page by page with&
         & option /PAGE. The list can be output to an ASCII file with&
         & option /FILE.'
    character(len=*), parameter :: rname='LIST>REGISTER'
    !
    call cubeadm_message(admseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'LIST','[cube]',&
         comm_abstract,&
         comm_help,&
         cubeadm_list_command,&
         comm%list,error)
    if (error) return
    call cubearg%register( &
         'CUBE', &
         'Cube identifier pattern',  &
         strg_id,&
         code_arg_optional,  &
         [flag_any], &
         code_read_none, &
         code_access_any,&
         comm%listarg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'INDEX','IndexName',&
         'Override the default index to be listed',&
         strg_id,&
         comm%index,error)
    if (error) return
    call keyarg%register( &
         'IndexName',  &
         'Name of the index to be listed', &
         strg_id,&
         code_arg_mandatory, &
         indexname, &
         .not.flexible, &
         comm%index_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'TOC','topic',&
         'Table Of Contents of the index',&
         'A summary of the different values of each topic is made&
         &, plus a final summary of all the combinations (setups).&
         By default, all topics are used. The table of contents is also&
         & saved in a SIC structure. The default name for the&
         & structure is TOC%, this can be changed by using the option&
         & /VARIABLE. The content of the structure is updated after&
         & each call to the command LIST /TOC. One must take care&
         & that subsequent calls to FIND can lead to values in TOC%&
         & that are inconsistent with the actual index.',&
         comm%toc,error)
    if (error) return
    call keyarg%register(&
         'topic', &
         'Topic(s) over which build TOC',&
         strg_id, &
         code_arg_unlimited,&
         cubedag_list_toc_keys, &
         .not.flexible, &
         comm%toctopic_arg,&
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'PAGE','',&
         'Page through the list',&
         strg_id,&
         comm%page,error)
    if (error) return
    !
    call cubetools_register_option(&
         'COLUMNS','col1 col2 ... coln',&
         'Define columns to be listed',&
         strg_id,&
         comm%columns,error)
    if (error) return
    call keyarg%register( &
         'column',  &
         'Column(s) to be listed', &
         strg_id,&
         code_arg_unlimited, &
         columns, &
         .not.flexible, &
         comm%column_arg, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'FILE','OutputFile',&
         'Define an output file for the list',&
         strg_id,&
         comm%file,error)
    if (error) return
    call stdarg%register( &
         'OutputFile',  &
         'Name of the file to store the list', &
         strg_id,&
         code_arg_mandatory, &
         error)
    if (error) return
    !
    call cubetools_register_option(&
         'VARIABLE','varname',&
         'Define the name of the SIC variable containing the TOC',&
         strg_id,&
         comm%variable,error)
    if (error) return
    call stdarg%register( &
         'varname',  &
         'Name of the SIC variable to store the TOC', &
         strg_id,&
         code_arg_mandatory, &
         error)
    if (error) return
  end subroutine cubeadm_list_register
  !
  subroutine cubeadm_list_command(line,error)
    use cubeadm_setup
    use cubedag_list
    !---------------------------------------------------------------------
    ! Support for command
    !  ADM\LIST
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(cubedag_list_user_t) :: user
    !
    call cubeadm_list_parse(cubset,line,user,error)
    if (error) return
    call cubedag_list_command(user,error)
    if (error) return
  end subroutine cubeadm_list_command
  !
  subroutine cubeadm_list_parse(cubset,line,user,error)
    use cubetools_setup_types
    use cubedag_list
    use cubetools_disambiguate
    use cubeadm_cubeid_types
    !---------------------------------------------------------------------
    ! Parsing for ADM\LIST
    !   LIST [CubeID]
    !     [/INDEX DAG|CURRENT]
    !     [/TOC]
    !     [/PAGE]
    !     [/COLUMNS List]
    !     [/FILE OutputFile]
    !     [/VARIABLE VarName]
    !---------------------------------------------------------------------
    type(cube_setup_t),        intent(in)    :: cubset
    character(len=*), target,  intent(in)    :: line
    type(cubedag_list_user_t), intent(out)   :: user
    logical,                   intent(inout) :: error
    !
    integer(kind=4) :: narg,ncol,iarg
    character(len=argu_l) :: argu,key
    type(cubeid_user_t) :: cubeid
    type(cubeid_arg_t) :: dummy
    character(len=*), parameter :: rname='LIST>PARSE'
    !
    ! Command argument. Build the user%find structure to restrict
    ! the search
    narg = comm%list%getnarg()
    if (narg.ge.1) then
      call cubeadm_cubeid_parse(line,comm%list,cubeid,error)
      if (error) return
      call cubeadm_cubeid_user2find(dummy,cubeid%cube(1),user%find,error)
      if (error) return
    else
      ! user%find => Keep defaults
    endif
    !
    ! /INDEX
    narg = comm%index%getnarg()
    if (narg.ge.1) then
       call cubetools_getarg(line,comm%index,1,argu,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(comm%index_arg,argu,user%index,key,error)
       if (error) return
    else
       user%index = cubset%index%default
    endif
    !
    ! /FILE
    call comm%file%present(line,user%dofile,error)
    if (error) return
    if (user%dofile) then
       call cubetools_getarg(line,comm%file,1,user%file,mandatory,error)
       if (error) return
    endif
    !
    ! /TOC
    call comm%toc%present(line,user%dotoc,error)
    if (error) return
    if (user%dotoc) then
       user%line => line
       user%iopttoc = comm%toc%inum
       call comm%variable%present(line,user%dovar,error)
       if (error) return
       if (user%dovar) then
          call cubetools_getarg(line,comm%variable,1,user%tocvar,mandatory,error)
          if (error) return
       else
          user%tocvar = 'TOC'
       endif
    else ! /COLUMN, /PAGE
       narg = comm%columns%getnarg()
       ncol = size(user%ucols)
       if (narg.gt.ncol) then
          call cubeadm_message(seve%w,rname,'/COLUMNS list too long, truncated')
       endif
       user%ncol = max(1,min(narg,ncol))
       do iarg = 1,user%ncol
          user%ucols(iarg) = 'DEFAULT'
          call cubetools_getarg(line,comm%columns,iarg,user%ucols(iarg),.not.mandatory,error)
          if (error) return
       enddo
       call comm%page%present(line,user%dopage,error)
       if (error) return
    endif
  end subroutine cubeadm_list_parse
end module cubeadm_list
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine clone_chunk(in,ou,doheader,error)
  use mrtcal_interfaces, except_this=>clone_chunk
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !  Clone a chunk structure.
  !
  !  Nothing is done for the data and headers (not copied, not
  ! initialized e.g. to 0).
  !---------------------------------------------------------------------
  type(chunk_t), intent(in)    :: in        !
  type(chunk_t), intent(inout) :: ou        !
  logical,       intent(in)    :: doheader  ! Also clone the headers?
  logical,       intent(inout) :: error     !
  !
  call reallocate_chunk(in%ndata,ou,error)
  if (error)  return
  !
  if (doheader) then
    call mrtcal_chunk_copy_header(in,ou,error)
    if (error)  return
  endif
  !
end subroutine clone_chunk
!
subroutine clone_chunkset(in,ou,doheader,error)
  use mrtcal_interfaces, except_this=>clone_chunkset
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !  Clone a chunkset structure.
  !
  !  The chunks in the chunkset are ALLOCATED so that the full structure
  ! clones exactly the input one.
  !  Nothing is done for the data and headers (not copied, not
  ! initialized e.g. to 0).
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: in        !
  type(chunkset_t), intent(inout) :: ou        !
  logical,          intent(in)    :: doheader  ! Also clone the headers?
  logical,          intent(inout) :: error     !
  ! Local
  integer(kind=4) :: ichunk
  !
  call reallocate_chunkset(in%n,ou,error)
  if (error) return
  !
  do ichunk=1,in%n
    call clone_chunk(in%chunks(ichunk),ou%chunks(ichunk),doheader,error)
    if (error) return
  enddo
  !
end subroutine clone_chunkset
!
subroutine clone_chunkset_2d_from_2d(in2d,ou2d,doheader,error)
  use mrtcal_interfaces, except_this=>clone_chunkset_2d_from_2d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic clone_chunkset_2d
  !  Clone a chunkset_2d structure.
  !
  !  The chunksets and chunks in the chunksets are ALLOCATED so that
  ! the full structure clones exactly in2d(:,:).
  !  Nothing is done for the data and headers (not copied, not
  ! initialized e.g. to 0).
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: in2d
  type(chunkset_2d_t), intent(inout) :: ou2d
  logical,             intent(in)    :: doheader  ! Also clone the headers?
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: iset,ipix
  !
  call reallocate_chunkset_2d(in2d%nset,in2d%npix,ou2d,error)
  if (error)  return
  !
  do ipix=1,in2d%npix
    do iset=1,in2d%nset
      call clone_chunkset(in2d%chunkset(iset,ipix),  &
                          ou2d%chunkset(iset,ipix),  &
                          doheader,error)
      if (error)  return
    enddo ! iset
  enddo ! ipix
  !
  if (doheader) then
    ! NB: npix and nset are copied at reallocation time, so that the
    !     structure remains consistent
    ou2d%mjd  = in2d%mjd
    ou2d%corr = in2d%corr
    ou2d%isub = in2d%isub
  endif
  !
end subroutine clone_chunkset_2d_from_2d
!
subroutine clone_chunkset_2d_from_3d(in3d,ou2d,doheader,error)
  use mrtcal_interfaces, except_this=>clone_chunkset_2d_from_3d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic clone_chunkset_2d
  !  Clone a chunkset_2d structure.
  !
  !  The chunksets and chunks in the chunksets are ALLOCATED so that
  ! the full structure clones exactly in3d(:,:,itime=1).
  !  Nothing is done for the data and headers (not copied, not
  ! initialized e.g. to 0).
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: in3d
  type(chunkset_2d_t), intent(inout) :: ou2d
  logical,             intent(in)    :: doheader  ! Also clone the headers?
  logical,             intent(inout) :: error
  ! Local
  type(chunkset_2d_t) :: in2d
  !
  ! Create a chunkset_2d_t pointer to 1st time dump (marginal cost), and
  ! build the output chunkset_2d from that pointer
  call reassociate_chunkset_2d(1,in3d,in2d,error)
  if (error)  return
  !
  call clone_chunkset_2d_from_2d(in2d,ou2d,doheader,error)
  if (error)  return
  !
end subroutine clone_chunkset_2d_from_3d
!
subroutine clone_chunkset_3d_from_3d(in3d,ou3d,doheader,error)
  use mrtcal_interfaces, except_this=>clone_chunkset_3d_from_3d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic clone_chunkset_3d
  !  Clone a chunkset_3d structure.
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: in3d
  type(chunkset_3d_t), intent(inout) :: ou3d
  logical,             intent(in)    :: doheader  ! Also clone the headers?
  logical,             intent(inout) :: error
  ! Local
  integer(kind=4) :: iset,ipix,itime
  !
  call reallocate_chunkset_3d(in3d%nset,in3d%npix,in3d%ntime,ou3d,error)
  if (error)  return
  !
  do itime=1,in3d%ntime
    do ipix=1,in3d%npix
      do iset=1,in3d%nset
        call clone_chunkset(in3d%chunkset(iset,ipix,itime),  &
                            ou3d%chunkset(iset,ipix,itime),  &
                            doheader,error)
        if (error)  return
      enddo ! iset
    enddo ! ipix
  enddo ! itime
  !
  if (doheader) then
    ! NB: ntime, npix and nset are copied at reallocation time, so that
    !     the structure remains consistent
    ou3d%kind = in3d%kind  ! ZZZ Unclear if this is generic
    ou3d%mjd  = in3d%mjd
    ou3d%corr = in3d%corr
    ou3d%isub = in3d%isub
  endif
  !
end subroutine clone_chunkset_3d_from_3d
!
subroutine clone_chunkset_3d_from_2d(in2d,ntime,ou3d,doheader,error)
  use mrtcal_interfaces, except_this=>clone_chunkset_3d_from_2d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic clone_chunkset_3d
  !  Create a chunkset_3d by cloning a chunkset_2d structure + extra
  ! "time" dimension.
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: in2d      !
  integer(kind=4),     intent(in)    :: ntime     ! Time dimension to be added
  type(chunkset_3d_t), intent(inout) :: ou3d      !
  logical,             intent(in)    :: doheader  ! Also clone the headers?
  logical,             intent(inout) :: error     !
  ! Local
  integer(kind=4) :: iset,ipix,itime
  !
  call reallocate_chunkset_3d(in2d%nset,in2d%npix,ntime,ou3d,error)
  if (error)  return
  !
  do itime=1,ntime
    do ipix=1,in2d%npix
      do iset=1,in2d%nset
        call clone_chunkset(in2d%chunkset(iset,ipix),        &
                            ou3d%chunkset(iset,ipix,itime),  &
                            doheader,error)
        if (error)  return
      enddo ! iset
    enddo ! ipix
  enddo ! itime
  !
  if (doheader) then
    ou3d%mjd  = in2d%mjd
    ou3d%corr = in2d%corr
    ou3d%isub = in2d%isub
  endif
  !
end subroutine clone_chunkset_3d_from_2d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtcal_pointing_create(chunkset_3d,drifts,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_create
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(chunkset_3d_t), intent(in)    :: chunkset_3d  !
  type(obs_list_t),    intent(inout) :: drifts       ! Output collection of drifts
  logical,             intent(inout) :: error        !
  ! Local
  integer(kind=4) :: ipix,iset
  character(len=*), parameter :: rname='SOLVE>AND>WRITE>POINTING'
  !
  ! Sanity
  if (chunkset_3d%kind.ne.ckind_onoff) then
    call mrtcal_message(seve%e,rname,'Unexpected chunkset kind')
    error = .true.
    return
  endif
  if (chunkset_3d%ntime.ne.1) then
    call mrtcal_message(seve%e,rname,'Unexpected time dimension')
    error = .true.
    return
  endif
  !
  do ipix=1,chunkset_3d%npix
    do iset=1,chunkset_3d%nset
      call mrtcal_pointing_create_from_chunkset(  &
        chunkset_3d%chunkset(iset,ipix,1),drifts,error)
      if (error)  return
    enddo
  enddo
  !
end subroutine mrtcal_pointing_create
!
subroutine mrtcal_pointing_create_from_chunkset(chunkset,drifts,error)
  use class_types
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_create_from_chunkset
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(chunkset_t), intent(in)    :: chunkset  !
  type(obs_list_t), intent(inout) :: drifts    ! Output collection of drifts
  logical,          intent(inout) :: error     !
  ! Local
  type(drift_book_t), pointer :: book  ! Unused
  type(observation), pointer :: obs
  !
  call obs_list_new(drifts,book,obs,error)
  if (error)  return
  call mrtcal_chunkset_to_obs_ry(chunkset,obs,error)
  if (error)  return
end subroutine mrtcal_pointing_create_from_chunkset
!
subroutine mrtcal_solve_and_write_obslist(drifts,out,ndrift,error)
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_solve_and_write_obslist
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(obs_list_t),            intent(inout) :: drifts  ! Collection of drifts
  type(mrtcal_setup_output_t), intent(in)    :: out     ! Output configuration
  integer(kind=4),             intent(inout) :: ndrift  ! Cumulative sum of drifts written
  logical,                     intent(inout) :: error   !
  !
  integer(kind=4) :: idrift
  !
  do idrift=1,drifts%n
    call mrtcal_solve_pointing_observation(drifts%obs(idrift),0,error)
    if (error)  return
    call mrtcal_pointing_associate_array(drifts%obs(idrift),error)
    if (error)  return
    if (out%toclass) then
      call mrtcal_obs_to_class(drifts%obs(idrift),error)
      if (error)  return
    endif
    ndrift = ndrift+1
  enddo
end subroutine mrtcal_solve_and_write_obslist
!
subroutine mrtcal_solve_pointing_observation(obs,debug,error)
  use phys_const
  use gbl_message
  use fit_definitions
  use class_types
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_observation
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  integer(kind=4),   intent(in)    :: debug  ! 0=no, 1=histo, 2=points
  logical,           intent(inout) :: error
  !
  logical, parameter :: quiet = .false.
  type(fit_fun) :: fun
  type(simple_1d) :: dat,sol
  integer(kind=4) :: ier
  character(len=16) :: str
  character(len=message_length) :: mess
  real(kind=4) :: vpeak,epeak
  character(len=*), parameter :: rname='SOLVE>POINTING>OBSERVATION'
  !
  dat%n = obs%head%dri%npoin
  allocate(dat%x(dat%n),dat%y(dat%n),dat%w(dat%n),stat=ier)
  if (failed_allocate(rname,'data buffers',ier,error)) return
  dat%x(:) = obs%datav(1:dat%n)*sec_per_rad  !
  dat%y(:) = obs%data1(1:dat%n)              ! R4 to R8
  dat%w(:) = obs%dataw(1:dat%n)
  !
  ! Initialization
  nullify(fun%par)
  call null_function(fun)
  ! Fitting method
  fun%method = 'SLATEC'
  fun%name = 'GAUSSIAN+BASE'
  fun%npar = 5
  allocate(fun%par(fun%npar),stat=ier)
  if (failed_allocate(rname,"function",ier,error))  goto 100
  !
  ! Names
  call null_parameter(fun%par(1))
  fun%par(1)%name = 'AREA1'
  call null_parameter(fun%par(2))
  fun%par(2)%name = 'POSITION1'
  call null_parameter(fun%par(3))
  fun%par(3)%name = 'WIDTH1'
  call null_parameter(fun%par(4))
  fun%par(4)%name = 'OFFSET'
  call null_parameter(fun%par(5))
  fun%par(5)%name = 'SLOPE'
  !
  ! Try not-so-clever guesses
  fun%par(1)%guess = 10.0                       ! [arcsec.K] Area: guess 30m beam size * 1K
  fun%par(2)%guess = 0.0                        ! [arcsec]   Position: guess is centered at 0
  fun%par(3)%guess = 10.0                       ! [arcsec]   Width: guess 30m beam size
  fun%par(4)%guess = (dat%y(dat%n)+dat%y(1))/2  ! [K]        Offset: guess from boundaries
  fun%par(5)%guess = 0.0                        ! [K/arcsec] Slope: guess is flat
  !
  ! All parameters are free
  fun%par(1:fun%npar)%fixed = .false.
  !
  ! Fitting
  call fit_1d(dat,fun,quiet)
  !
  ! Transfer to observation
  call mrtcal_fit_to_obs_poi(fun,obs,error)
  if (error)  return
  !
  ! --- Debugging ------------------------------------------------------
  if (debug.gt.0) then
    ! Allocate the solution structure
    sol%n = dat%n
    allocate(sol%x(sol%n),sol%y(sol%n),stat=ier)
    if (failed_allocate(rname,"solution",ier,error)) goto 100
    ! Compute the solution profile
    sol%x(:) = dat%x(:)
    call get_profile(fun,sol)
    !
    ! Feedback
    print *,"Values:   Area   Position   FWHM   Offset   Slope   Peak"  ! Order in fun%par(:)
    write(mess,'(a,5(1pg10.3))')  "Guesses: ",fun%par(1:5)%guess
    print *,trim(mess)
    call mrtcal_pointing_peak(obs%head%poi,vpeak,epeak,error)
    if (error)  return
    write(mess,'(a,6(1pg10.3))')  "Results: ",fun%par(1:5)%value,vpeak
    print *,trim(mess)
    write(mess,'(a,6(1pg10.3))')  "Errors:  ",fun%par(1:5)%error,epeak
    print *,trim(mess)
    write(mess,'(a,1(1pg10.3))')  "RMS:  ",fun%rms
    print *,trim(mess)
    !
    ! Plot
    call gr_execl('CLEAR')
    call gr_exec1('SET PLOT LANDSCAPE')
    write(mess,'(a,f0.3,a)') 'SET BLANKING ',obs%head%dri%bad,' 0.0'
    call gr_exec1(mess)
    call gr8_give('X',dat%n,dat%x)
    call gr8_give('Y',dat%n,dat%y)
    call gr_exec1('LIMITS')
    call gr_exec1('BOX')
    if (debug.eq.1) then
      call gr_exec1('HISTOGRAM')
    elseif (debug.eq.2) then
      call gr_exec1('SET MARKER 4 1 0.2 45')
      call gr_exec1('POINTS')
    endif
    call gr_exec1('PEN /COL RED')
    call gr8_give('X',sol%n,sol%x)
    call gr8_give('Y',sol%n,sol%y)
    if (debug.eq.1) then
      call gr_exec1('HISTOGRAM')
    elseif (debug.eq.2) then
      call gr_exec1('POINTS')
    endif
    call gr_exec1('PEN /COL FOREGROUND')
    call sic_wpr('Type C to continue ',str)
  endif
  !---------------------------------------------------------------------
  !
100 continue
  call null_function(fun)
  call null_simple_1d(dat)
  if (debug.gt.0)  call null_simple_1d(sol)
end subroutine mrtcal_solve_pointing_observation
!
subroutine mrtcal_pointing_peak(poi,vpeak,epeak,error)
  use phys_const
  use class_types
  use mrtindex_sec_pointing
  !---------------------------------------------------------------------
  ! @ private
  ! From a CLASS pointing section, return the peak value and its error.
  ! This information is redundant with the (area,position,fwhm) stored
  ! in the section.
  !---------------------------------------------------------------------
  type(class_pointing_t), intent(in)    :: poi
  real(kind=4),           intent(out)   :: vpeak  ! Peak value
  real(kind=4),           intent(out)   :: epeak  ! Peak error
  logical,                intent(inout) :: error
  !
  real(kind=4) :: fac
  real(kind=4) :: voffs,vslop,varea,vposi,vfwhm
  real(kind=4) :: eoffs,eslop,earea,eposi,efwhm
  !
  fac = 2*sqrt(log(2.)/pis)
  !
  voffs = poi%nfit(pointing_fit_offset)
  vslop = poi%nfit(pointing_fit_slope)
  varea = poi%nfit(pointing_fit_area1)
  vposi = poi%nfit(pointing_fit_posi1)
  vfwhm = poi%nfit(pointing_fit_fwhm1)
  vpeak = voffs+vslop*vposi + fac*varea/vfwhm
  !
  eoffs = poi%nerr(pointing_fit_offset)
  eslop = poi%nerr(pointing_fit_slope)
  earea = poi%nerr(pointing_fit_area1)
  eposi = poi%nerr(pointing_fit_posi1)
  efwhm = poi%nerr(pointing_fit_fwhm1)
  epeak = fac/vfwhm * sqrt(earea**2  + (varea*efwhm/vfwhm)**2)  ! ZZZ Missing the eoffs and eslope contribution
end subroutine mrtcal_pointing_peak
!
subroutine mrtcal_pointing_associate_array(obs,error)
  use class_types
  use mrtindex_sec_pointing
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_pointing_associate_array
  !---------------------------------------------------------------------
  ! @ private
  ! If the observation provides a pointing drift fit, it is modified so
  ! that:
  ! 1) RY provides the baselined pointing drift,
  ! 2) an associated array named XX provides the (original)
  !    non-baselined pointing drifts
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  !
  real(kind=4), pointer :: data1(:)
  integer(kind=4) :: ichan
  real(kind=4) :: y
  !
  if (.not.obs%head%presec(class_sec_poi_id))  return
  !
  ! Declare the reserved associated array and fetch a pointer to its
  ! data
  call class_assoc_add(obs,'POINTING',data1,error)
  if (error)  return
  data1(:) = obs%data1(:)
  !
  ! Replace original RY with its baselined version
  do ichan=1,obs%head%dri%npoin
    if (obs%data1(ichan).ne.obs%head%dri%bad) then
      y = obs%head%poi%nfit(pointing_fit_offset) +  &
          obs%head%poi%nfit(pointing_fit_slope) * obs%datav(ichan)
      obs%data1(ichan) = obs%data1(ichan) - y
    endif
  enddo
end subroutine mrtcal_pointing_associate_array
!
subroutine mrtcal_pointing_classify(mrtset,idrifts,sdrifts,error)
  use phys_const
  use gbl_message
  use toc_types
  use class_toc_parameters
  use mrtcal_dependencies_interfaces
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_interfaces, except_this=>mrtcal_pointing_classify
  !---------------------------------------------------------------------
  ! @ private
  ! Gtaher drifts by equivalence class and solve each class.
  !---------------------------------------------------------------------
  type(mrtcal_setup_t), intent(in)    :: mrtset   !
  type(obs_list_t),     intent(in)    :: idrifts  ! Collection of individual drifts
  type(obs_list_t),     intent(inout) :: sdrifts  ! Collection of averaged and solved drifts
  logical,              intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>AVERAGE'
  integer(kind=4) :: toc_keys(2)
  type(toc_selection_t) :: select
  integer(kind=entry_length) :: iequ
  type(drift_book_t), pointer :: book
  type(observation), pointer :: obs
  integer(kind=4) :: nkeys,ikey
  !
  select case (mrtset%sol%poimix)
  case (mixmode_entry)     ! Unique entry
                           ! i.e. no mixing
    nkeys = 1
    toc_keys(1) = class_toc_key_entry
  case (mixmode_drift)     ! Unique telescope and unique drift
                           ! i.e. mixed directions (e.g. 0+180)
    nkeys = 2
    toc_keys(1) = class_toc_key_telescope
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fesbdrift) ! Unique frontend, unique sideband and unique drift
                           ! i.e. mixed polarizations and mixed directions
    nkeys = 2
    toc_keys(1) = class_toc_key_fesb
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fesbdirec) ! Unique frontend, unique sideband and unique direction
                           ! i.e. mixed polarizations
    nkeys = 2
    toc_keys(1) = class_toc_key_fesb
    toc_keys(2) = class_toc_key_direction
  case (mixmode_fedrift)   ! Unique frontend and unique drift
                           ! i.e. mixed polarizations, sidebands, and directions
    nkeys = 2
    toc_keys(1) = class_toc_key_frontend
    toc_keys(2) = class_toc_key_drift
  case (mixmode_fedirec)   ! Unique frontend and unique direction
                           ! i.e. mixed polarizations and sidebands
    nkeys = 2
    toc_keys(1) = class_toc_key_frontend
    toc_keys(2) = class_toc_key_direction
  case default
    call mrtcal_message(seve%e,rname,'MSET SOLVE POINTING mode not implemented')
    error = .true.
    return
  end select
  !
  call obs_list_to_selection(idrifts,toc_keys(1:nkeys),select,error)
  if (error)  return
  !
  call free_obs_list(sdrifts,error)
  if (error)  return
  !
  ! Fill pseudo observations (only the relevant parts needed by
  ! mrtcal_solve_pointing_observation) and perform the minimizations
  do iequ=1,select%nequ
    ! Fetch a new observation from list
    call obs_list_new(sdrifts,book,obs,error)
    if (error)  return
    ! Bookkeeping for this class
    book%nkey = nkeys
    book%nobs = select%cnt(iequ)
    do ikey=1,nkeys
      book%keys(ikey)   = select%ids(ikey)
      book%values(ikey) = select%nam(iequ,ikey)
    enddo
    ! Gather this class in a single observation
    call mrtcal_solve_pointing_oneclass(idrifts,iequ,select%cnt(iequ),select%bak,obs,error)
    if (error)  return
  enddo
end subroutine mrtcal_pointing_classify
!
subroutine mrtcal_solve_pointing_oneclass(drifts,iequ,cnt,bak,obs,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_oneclass
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Produce the drift for one equivalence class
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts  ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: iequ    ! Eq. class identifier
  integer(kind=entry_length), intent(in)    :: cnt     ! Number of elements in this eq. class
  integer(kind=entry_length), intent(in)    :: bak(:)  ! Back pointer to original elements
  type(observation),          intent(inout) :: obs     !
  logical,                    intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>ONECLASS'
  integer(kind=entry_length) :: idrift,ilist,list(cnt)  ! Automatic array
  !
  ! Get the drift numbers which go in this eq. class
  ilist = 0
  do idrift=1,drifts%n
    if (bak(idrift).eq.iequ) then
      ilist = ilist+1
      list(ilist) = idrift
    endif
  enddo
  !
  if (cnt.eq.1) then
    ! Direct export (as is), i.e. leave it irregular
    call copy_obs(drifts%obs(list(1)),obs,error)
    if (error)  return
  else
    ! Resample and average in a single regular drift
    call mrtcal_solve_pointing_gather(drifts,list,obs,error)
    if (error)  return
  endif
  !
end subroutine mrtcal_solve_pointing_oneclass
!
subroutine mrtcal_solve_pointing_gather(drifts,list,obs,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Gather the drifts indentfies in the list and produce a single drift
  ! observation
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER'
  logical, parameter :: doregular=.true.
  !
  if (doregular) then
    ! Resample and average the drifts
    call mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
    if (error)  return
  else
    ! Concatenate and sort the data points
    call mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
    if (error)  return
  endif
end subroutine mrtcal_solve_pointing_gather
!
subroutine mrtcal_solve_pointing_gather_regular(drifts,list,obs,error)
  use gbl_message
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather_regular
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Resample each irregular drift to a common axis and average them.
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER>REGULAR'
  integer(kind=entry_length) :: ilist,idrift,ref
  type(resampling) :: axis
  type(observation) :: tmp
  real(kind=4) :: cbad,weight
  logical :: stele_c(12)
  logical, parameter :: contaminate=.true.
  logical, parameter :: weight_update=.true.
  !
  ! Use the first drift as reference. All drifts have a regular axis
  ! declared which is a good approximation of the irregular axis.
  ref = list(1)
  cbad = drifts%obs(ref)%head%dri%bad
  axis%nchan = drifts%obs(ref)%head%dri%npoin
  axis%ref   = drifts%obs(ref)%head%dri%rpoin
  axis%val   = drifts%obs(ref)%head%dri%aref
  axis%inc   = drifts%obs(ref)%head%dri%ares
  axis%unit  = 'A'
  axis%shape = ''   ! Only for FFT resampling
  axis%width = 1.0  ! Only for FFT resampling
  !
  ! Initialize output sum
  ! - Minimalist header (more to be done for a real drift in CLASS)
  call copy_header(drifts%obs(ref)%head,obs%head)
  stele_c(:) = .true.
  ! obs%head%dri%apos  = drifts%obs(ref)%head%dri%apos   ZZZ need specific mixing function i.e. 0,180 give 0
  ! - Data area
  call reallocate_obs(obs,axis%nchan,error)  ! Is this useful?
  if (error)  return
  obs%spectre(:) = 0.
  obs%dataw(:) = 0.
  !
  ! Initialize temporary observation
  call class_obs_init(tmp,error)
  if (error)  return
  !
  do ilist=1,size(list)
    idrift = list(ilist)
    ! --- Header update ---
    if (drifts%obs(idrift)%head%gen%subscan.ne.obs%head%gen%subscan)  &
      obs%head%gen%subscan = 0
    call sumlin_header_telescope(drifts%obs(idrift)%head%gen%teles,stele_c,obs%head%gen%teles)
    ! --- Data update ---
    call copy_obs(drifts%obs(idrift),tmp,error)
    if (error)  exit
    call obs_weight_time(rname,tmp,weight,error,verbose=.true.)
    if (error)  exit
    ! From irregular axis to regular: use CLASS RESAMPLE
    tmp%cbad = cbad
    tmp%datax = tmp%datav
    call class_resample_obs(tmp,axis,.false.,error)
    if (error)  exit
    ! Average in running sum
    tmp%dataw(:) = weight
    call simple_waverage(tmp%spectre,tmp%dataw,cbad,  &
                         obs%spectre,obs%dataw,cbad,  &
                         1,axis%nchan,contaminate,weight_update)
  enddo
  ! Recompute regularized X axis in DATAV (used for minimization)
  call abscissa_angl_r8(obs%head,obs%datav,1,obs%head%dri%npoin)
  !
  call class_obs_clean(tmp,error)
  if (error)  return
end subroutine mrtcal_solve_pointing_gather_regular
!
subroutine mrtcal_solve_pointing_gather_irregular(drifts,list,obs,error)
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_solve_pointing_gather_irregular
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  ! Gather the drifts identifies in the list and produce a single drift
  ! observation. Just concatenate and sort the (X,Y) data point, leave
  ! the observation irregular.
  ! This solution is well suited for minimization of the point cloud,
  ! but can not be extensively used in CLASS. In particular, such an
  ! irregular axis does not behave well with the RESAMPLE command.
  !---------------------------------------------------------------------
  type(obs_list_t),           intent(in)    :: drifts   ! Collection of drifts
  integer(kind=entry_length), intent(in)    :: list(:)  !
  type(observation),          intent(inout) :: obs      !
  logical,                    intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SOLVE>POINTING>GATHER'
  integer(kind=entry_length) :: ilist,idrift
  integer(kind=4) :: ndata,first,last,npoin,ref,ier
  real(kind=4), allocatable :: buf(:)
  integer(kind=4), allocatable :: key(:)
  !
  ref = list(1)  ! Select 1st obs in its class as reference
  !
  ! Precompute the number of points for this class
  ndata = 0
  do ilist=1,size(list)
    idrift = list(ilist)
    ndata = ndata+drifts%obs(idrift)%head%dri%npoin
  enddo
  call reallocate_obs(obs,ndata,error)
  if (error)  return
  !
  ! Minimalist header (more to be done for a real drift in CLASS)
  call copy_header(drifts%obs(ref)%head,obs%head)
  ! obs%head%gen%teles = drifts%obs(ref)%head%gen%teles  ZZZ need specific mixing function
  ! obs%head%dri%apos  = drifts%obs(ref)%head%dri%apos   ZZZ need specific mixing function i.e. 0,180 give 0
  !
  ! Collect points
  first = 1
  do ilist=1,size(list)
    idrift = list(ilist)
    npoin = drifts%obs(idrift)%head%dri%npoin
    last = first+npoin-1
    obs%datav(first:last) = drifts%obs(idrift)%datav(1:npoin)
    obs%data1(first:last) = drifts%obs(idrift)%data1(1:npoin)
    obs%dataw(first:last) = drifts%obs(idrift)%dataw(1:npoin)
    first = last+1
  enddo
  obs%head%dri%npoin = ndata  ! = last
  !
  ! Sort the points
  allocate(buf(ndata),key(ndata),stat=ier)
  if (failed_allocate(rname,"sorting buffers",ier,error))  return
  call gr8_trie(obs%datav,key,ndata,error)
  if (error)  return
  call gr4_sort(obs%data1,buf,key,ndata)
  if (error)  return
  call gr4_sort(obs%dataw,buf,key,ndata)
  if (error)  return
end subroutine mrtcal_solve_pointing_gather_irregular
!
!--------------------------------------------------------------------------
!
subroutine mrtcal_solve_pointing_user_feedback(backsci,setout,error)
  use gbl_message
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this => mrtcal_solve_pointing_user_feedback
  use mrtcal_buffers
  use mrtcal_calib_types
  use mrtcal_setup_types
  use mrtcal_user_feedback_tool
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(science_backend_t),     intent(in)    :: backsci
  type(mrtcal_setup_output_t), intent(in)    :: setout
  logical,                     intent(inout) :: error
  !
  type(user_feedback_t) :: user
  character(len=*), parameter :: rname='SOLVE>POINTING>USER>FEEDBACK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  call user_feedback_head(error)
  if (error) return
  call user%allocate_and_init(backsci%head%poi%nsol,error)
  if (error) return
  call user_feedback_perobs(backsci%head,error)
  if (error) return
  call user%sort_by_freq_direction_idfe(error)
  if (error) return
  call user%list(error)
  if (error) return
  if (setout%restable) then
     call user%tofile(backsci%head,error)
     if (error) return
  endif
  !
contains
  !
  subroutine user_feedback_perobs(head,error)
    use phys_const
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    type(mrtindex_header_t), intent(in)    :: head
    logical,                 intent(inout) :: error
    ! Local
    integer(kind=4) :: iobs,color
    real(kind=8) :: mfreq,mangle,mhpbw
    real(kind=8) :: varea,vposi,vfwhm,voffs,vslop ! Values
    real(kind=8) :: earea,eposi,efwhm,eoffs,eslop ! Errors
    character(len=8) :: mfrontend,mbackend
    character(len=message_length) :: result
    !
    do iobs=1,head%poi%nsol
!!$      call calibrate_user_feedback_compute_perpixel(gr8_compute,  &
!!$           backcal,ipix,                                          &
!!$           mfrontend,mfreq,mthot,mtcold,mtrec,mtsys,mtcal,mtau,mh2o,error)
!!$      if (error) return
       !
       mfrontend = head%poi%sol(iobs)%gen%teles(4:)
       mbackend = backends_mrtcal(head%key%backend)
       mfreq = head%poi%sol(iobs)%dri%freq/1d3
       mangle = head%poi%sol(iobs)%dri%apos*deg_per_rad
       mhpbw = iram_30m_beam(mfreq)
       !
       voffs = head%poi%sol(iobs)%poi%nfit(pointing_fit_offset)*1d3            ! [mK]
       vslop = head%poi%sol(iobs)%poi%nfit(pointing_fit_slope)/sec_per_rad*1d3 ! [mK/arcsec]
       varea = head%poi%sol(iobs)%poi%nfit(pointing_fit_area1)*sec_per_rad     ! [K.arcsec]
       vposi = head%poi%sol(iobs)%poi%nfit(pointing_fit_posi1)*sec_per_rad     ! [arcsec]
       vfwhm = head%poi%sol(iobs)%poi%nfit(pointing_fit_fwhm1)*sec_per_rad     ! [arcsec]
       !
       eoffs = head%poi%sol(iobs)%poi%nerr(pointing_fit_offset)*1d3            ! [mK]
       eslop = head%poi%sol(iobs)%poi%nerr(pointing_fit_slope)/sec_per_rad*1d3 ! [mK/arcsec]
       earea = head%poi%sol(iobs)%poi%nerr(pointing_fit_area1)*sec_per_rad     ! [K.arcsec]
       eposi = head%poi%sol(iobs)%poi%nerr(pointing_fit_posi1)*sec_per_rad     ! [arcsec]
       efwhm = head%poi%sol(iobs)%poi%nerr(pointing_fit_fwhm1)*sec_per_rad     ! [arcsec]
       !
       vfwhm = vfwhm/mhpbw
       efwhm = efwhm/mhpbw
       call user_feedback_oneline(&
            mfrontend,&
            mbackend,&
            mfreq,&
            mangle,&
            varea,earea,&
            vposi,eposi,&
            vfwhm,efwhm,&
            voffs,eoffs,&
            vslop,eslop,&
            result,color)
       call user%fill(iobs,mfrontend,mfreq,mangle,result,color)
    enddo ! iobs
  end subroutine user_feedback_perobs
  !
  subroutine user_feedback_oneline(frontend,backend,freq,angle,varea,earea,&
       vposi,eposi,vfwhm,efwhm,voffs,eoffs,vslop,eslop,oneline,color)
    !---------------------------------------------------------------------
    !---------------------------------------------------------------------
    character(len=*), intent(in)  :: frontend
    character(len=*), intent(in)  :: backend
    real(kind=8),     intent(in)  :: freq
    real(kind=8),     intent(in)  :: angle
    real(kind=8),     intent(in)  :: varea,earea
    real(kind=8),     intent(in)  :: vposi,eposi
    real(kind=8),     intent(in)  :: vfwhm,efwhm
    real(kind=8),     intent(in)  :: voffs,eoffs
    real(kind=8),     intent(in)  :: vslop,eslop
    character(len=*), intent(out) :: oneline
    integer(kind=4),  intent(out) :: color        ! Colorization code
    !
    real(kind=8) :: bad,snr
    !
    !    bad = ???
    snr = abs(varea/earea)
    write(oneline,100)  frontend,&
                        user_feedback_format_onedouble(5,'f5.1',freq,bad),&
                        backend,&
                        user_feedback_format_onedouble(6,'f6.1',angle,bad),&
                        user_feedback_format_onedouble(6,'f6.1',vposi,bad),&
                        user_feedback_format_onedouble(6,'f6.1',eposi,bad),&
                        user_feedback_format_onedouble(6,'f6.2',vfwhm,bad),&
                        user_feedback_format_onedouble(6,'f6.2',efwhm,bad),&
                        nint(snr),&
                        user_feedback_format_onedouble(6,'f6.1',varea,bad),&
                        user_feedback_format_onedouble(6,'f6.1',earea,bad),&
                        nint(voffs),&
                        nint(eoffs),&
                        user_feedback_format_onedouble(6,'f6.1',vslop,bad),&
                        user_feedback_format_onedouble(6,'f6.1',eslop,bad)
    !
    if (snr.lt.10) then
       color = code_color_red
    else if (snr.lt.20) then
       color = code_color_orange
    else
       color = code_color_green
    endif
    !
100 format(t1,a5,t7,a5,t13,a3,t18,a6,t25,a6,t31,a6,t39,a6,t45,a6,&
    t54,i4,t58,a6,t64,a6,t73,i6,t79,i6,t86,a6,t93,a6)
  end subroutine user_feedback_oneline
  !
  subroutine user_feedback_head(error)
    logical, intent(inout) :: error
    !
    character(len=message_length) :: mess
    !
    call mrtcal_separator(seve%r,rname,1,error)
    if (error) return
    write(mess,'(t1,a4,t7,a4,t13,a4,t18,a6,t26,a12,t40,a12,t54,a18,t75,a12,t88,a12)') &
         'idFe','freq','idBe','Angle','  Position  ', '    FWHM    ','       Area       ','   Offset   ','   Slope    '
    call mrtcal_message(seve%r,rname,mess)
    write(mess,'(t7,a5,t19,a5,t26,a12,t40,a12,t54,a18,t74,a12,t88,a12)') &
         '[GHz]','[deg]','--[arcsec]--','-[fraction]-','-[SNR]-[K.arcsec]-','----[mK]----','[ mK/arcsec]'
    call mrtcal_message(seve%r,rname,mess)
    write(mess,'(t1,a99)') &
         '---------------------------------------------------------------------------------------------------'
    call mrtcal_message(seve%r,rname,mess)
  end subroutine user_feedback_head
end subroutine mrtcal_solve_pointing_user_feedback
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine color_comm(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! IMAGER
  !   Support for command COLOR Span HueMin HueMax
  !
  !   calls "@ p_color.ima" to derive a lut
  !   with unsaturated colours up to Span around 0,
  !   and a Hue range between Min and Max 
  ! 
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  real :: colour
  logical :: do_insert
  !
  call sic_get_real('COLOR[3]',colour,error)
  call sic_r4(line,0,1,colour,.false.,error)
  call sic_let_real('COLOR[3]',colour,error)
  !
  call sic_get_real('COLOR[1]',colour,error)
  call sic_r4(line,0,2,colour,.false.,error)
  call sic_let_real('COLOR[1]',colour,error)
  !
  call sic_get_real('COLOR[2]',colour,error)
  call sic_r4(line,0,3,colour,.false.,error)
  call sic_let_real('COLOR[2]',colour,error)
  !
  do_insert = sic_lire().eq.0
  call exec_program('@ p_color')
  if (do_insert) call sic_insert_log(line)  
end subroutine color_comm

!
subroutine doself (model,resul,itype,self,weight)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !   Compute self calibraton factor
  !---------------------------------------------------------------------
  complex, intent(in) :: model   ! Model visibility
  complex, intent(in) :: resul   ! Actual observation
  integer, intent(in) :: itype   ! Type of self calibration
  complex, intent(out) :: self   ! Self calibration factor
  real, intent(out) :: weight    ! Weight scaling factor
  !
  self = model/resul
  weight = abs(self)
  if (itype.gt.0) then
    ! Phase Only
    self = self/weight
    weight = 1.0
  elseif (itype.lt.0) then
    ! Amplitude Only
    self = weight
    if (weight.gt.1.0) weight = 1.0/weight
  else
    ! Both
    if (weight.gt.1.0) weight = 1.0/weight
  endif
end subroutine doself
!
subroutine doscal (nc,visi,cosi,sinu,sreel,simag,weight)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !	  Apply the self-calibration factor to the current visibility
  !	  Set weight to zero if no self-cal factor
  !---------------------------------------------------------------------
  integer, intent(in) :: nc           !  Number of channels
  real, intent(inout) :: visi(*)      !  Visibility
  real, intent(in) :: sreel           !  Real part to subtract
  real, intent(in) :: simag           !  Imaginary part to subtract
  real, intent(in) :: cosi            !  Phase rotation cos
  real, intent(in) :: sinu            !  Phase rotation sin
  real, intent(in) :: weight          !  Scaling factor of weight
  ! Local
  integer :: i,ii,ir,iw
  real :: reel,imag
  !
  do i=3,3*nc,3
    ir = i+5
    ii = i+6
    iw = i+7
    reel = visi(ir)
    imag = visi(ii)
    visi(ir) =  cosi*reel-sinu*imag-sreel
    visi(ii) =  sinu*reel+cosi*imag-simag
    visi(iw) =  visi(iw)*weight
  enddo
end subroutine doscal
!
subroutine dosubt (nc,visi,sreel,simag)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !   Subtract a continuum value from a line visibility
  !---------------------------------------------------------------------
  integer, intent(in) :: nc           !  Number of channels
  real, intent(inout) :: visi(*)      !  Visibility
  real, intent(in) :: sreel           !  Real part
  real, intent(in) :: simag           !  Imaginary part
  ! Local
  integer :: i,ii,ir
  !
  do i=3,3*nc,3
    ir = i+5
    ii = i+6
    visi(ir) = visi(ir)-sreel
    visi(ii) = visi(ii)-simag
  enddo
end subroutine dosubt
!
subroutine doflag (nc,visi)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !   Flag (by zero) a line visibility
  !---------------------------------------------------------------------
  integer, intent(in) :: nc           !  Number of channels
  real, intent(inout) :: visi(*)      !  Visibility
  ! Local
  integer :: i
  !
  ! Set weight to zero if no self-cal data
  do i=10,7+3*nc,3
    visi(i) = 0.0
  enddo
end subroutine doflag
!
subroutine getiba (visi,stime,time,base,uv)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !   Get baseline and time information
  !---------------------------------------------------------------------
  real, intent(in)  :: visi(*)                   ! Visibility
  real(8), intent(in) :: stime                   ! Reference time
  real(8), intent(out) :: time                   ! Time offset
  real, intent(out)  :: base(2)                  ! First and Last antenna
  real, intent(out)  :: uv(2)                    ! U and V
  !
  uv(1) = visi(1)
  uv(2) = visi(2)
  time = nint(dble(visi(4))-stime)
  time = 86400.d0*time+dble(visi(5))
  base(1) = visi(6)
  base(2) = visi(7)
end subroutine getiba
!
subroutine dotime (mv,nv,visi,wtime,it,stime)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !	  Compute the observing times of the data, 
  !	  sort it and return sorting index
  !---------------------------------------------------------------------
  integer, intent(in) :: mv           ! Size of visibility
  integer, intent(in) :: nv           ! Number of visibilities
  real, intent(in) :: visi(mv,nv)     ! Visibilities
  real(8), intent(out) :: wtime(nv)   ! Sorted times
  integer, intent(inout) :: it(nv)    ! Sorting index
  real(8), intent(out) :: stime       ! Reference time
  ! Local
  logical :: error
  integer :: i
  real :: tmin,tmax
  !
  tmin = visi(4,1)
  tmax = visi(4,1)
  do i=2,nv
    if (visi(4,i).lt.tmin) then
      tmin = visi(4,i)
    elseif (visi(4,i).gt.tmax) then
      tmax = visi(4,i)
    endif
  enddo
  if (tmin.eq.tmax) then
    do i=1,nv
      wtime(i) = visi(5,i)
    enddo
  else
    do i=1,nv
      wtime(i) = 86400d0*nint(visi(4,i)-tmin)   &
     &        +dble(visi(5,i))
    enddo
  endif
  stime = tmin
  !
  ! Sort
  call gr8_trie(wtime,it,nv,error)
end subroutine dotime
!
subroutine geself (mv,nv,iw,visi,time,ftime,wtime,it,   &
     &    rbase,complx,uv)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !	  Compute the Observed Visibility of the "model source"
  !---------------------------------------------------------------------
  integer, intent(in) :: mv           ! Size of visibility
  integer, intent(in) :: nv           ! Number of visibilities
  real, intent(in) :: visi(mv,nv)     ! Visibilities
  real(8), intent(out) :: wtime(nv)   ! Sorted times
  integer, intent(in) :: iw(2)        ! First and Last channel
  real(8), intent(in) :: time         ! Time of observation
  real(8), intent(in) :: ftime        ! Tolerance on time +/-
  integer, intent(in) :: it(nv)       ! Ordering of visibilities
  real, intent(in) :: rbase(2)        ! Antennas
  real, intent(in) :: uv(2)           ! U and V
  complex, intent(out) :: complx      ! Result
  ! Local
  integer :: i,k,l,iv,jv,kv,jr,ji,jw
  real :: reel,imgi,weig
  !
  ! Locate the nearest time range by dichotomic search
  call findr (nv,wtime,time,iv)
  reel = 0.0
  imgi = 0.0
  weig = 0.0
  !
  ! Now find JV and KV corresponding to +/- FTIME
  i = iv
  do 
    if (i.eq.1) exit
    i = i-1
    if (wtime(i).lt.time-ftime) exit
  enddo
  jv  = i
  !
  i = iv
  do 
    if (i.eq.nv) exit
    i = i+1
    if (wtime(i).gt.time+ftime) exit
  enddo
  kv = i
  !
  ! Everything happens between JV and KV. Load the corresponding
  ! baseline data
  do i=jv,kv
    k = it(i)
    if (abs(wtime(i)-time).le.ftime) then
      if ( (visi(6,k).eq.rbase(1) .and.   &
     &        visi(7,k).eq.rbase(2)) .or. (visi(6,k).eq.rbase(2) .and.   &
     &        visi(7,k).eq.rbase(1)) ) then
       if ( (uv(2).gt.0 .and. visi(2,k).gt.0) .or.   &
     &          (uv(2).le.0 .and. visi(2,k).le.0) ) then
          do l = iw(1),iw(2)
            jr = 5+3*l
            ji = jr+1
            jw = ji+1
            reel = reel+visi(jr,k)*visi(jw,k)
            imgi = imgi+visi(ji,k)*visi(jw,k)
            weig = weig + visi(jw,k)
          enddo
        else
          !
          ! Change phase by 180 degree if baseline order is reversed
          do l = iw(1),iw(2)
            jr = 5+3*l
            ji = jr+1
            jw = ji+1
            reel = reel+visi(jr,k)*visi(jw,k)
            imgi = imgi-visi(ji,k)*visi(jw,k)
            weig = weig + visi(jw,k)
          enddo
        endif
      endif
    endif
  enddo
  if (weig.ne.0) then
    reel = reel/weig
    imgi = imgi/weig
    complx = cmplx(reel,imgi)
  else
    complx = 0.0
  endif
end subroutine geself
!
subroutine findr (np,x,xlim,nlim)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   UV Tools
  !	  Find NLIM such as
  !	 	    X(NLIM-1) < XLIM <= X(NLIM)
  !	  for input data ordered.
  !	  Use a dichotomic search for that
  !---------------------------------------------------------------------
  integer, intent(in) :: np          ! Number of data points
  real(8), intent(in) :: x(np)       ! Data values
  real(8), intent(in) :: xlim        ! Value to be localized
  integer, intent(out) :: nlim       ! Found position
  ! Local
  integer :: ninf, nsup, nmid
  !
  ! Check that XLIM is within the range of X
  if (x(1).gt.xlim) then
    nlim = 1
    return
  endif
  ninf = 1
  nsup = np
  !
  do while(nsup.gt.ninf+1)
    nmid = (nsup + ninf)/2
    if (x(nmid).lt.xlim) then
      ninf = nmid
    else
      nsup = nmid
    endif
  enddo
  nlim = nsup
end subroutine findr

module code_polar_gildas
  ! These codes should ideally match the Values of the code_stokes_ab's 
  ! integers (equal to abs(first code_stokes_ab..)) sequence to identify
  ! the coherent sets of Polarization.
  !   But the coding behind makes no assumption about this:
  ! Assumed values are only in "polar_order" routine
  integer, parameter :: code_polar_circular=1      ! R+L sky frame
  integer, parameter :: code_polar_linear=5        ! X+Y sky frame
  integer, parameter :: code_polar_horizon=13      ! V+H antenna frame
  integer, parameter :: code_polar_round=9         ! D+S antenna frame
end module code_polar_gildas
!
subroutine stokes_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use clean_arrays
  use imager_interfaces, except_this => stokes_comm
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command
  !
  ! STOKES Value [/FILE FileIn FileOut]
  !
  ! Extract a Polarization state from a UV table
  !
  !---------------------------------------------------------------------
  character(len=*) :: line
  logical error
  !
  character(len=*), parameter :: rname='STOKES'
  integer, parameter :: o_file=1
  !
  character(len=filename_length) :: nami,namo
  character(len=12) :: mystoke
  integer :: n, istoke
  type (gildas) :: hin
  logical :: err
  !
  error = .false.
  call sic_ke(line,0,1,mystoke,n,.true.,error)
  if (error) return
  !
  ! Scan the requested polarization code
  if (mystoke.eq.'NONE') then
    istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
    istoke = code_stokes_all
  else
    call gdf_stokes_code(mystoke,istoke,error)
    if (error) then 
      call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
      error = .true.
      return
    endif
  endif
  !
  if (sic_present(o_file,0)) then
    call sic_ch(line,o_file,1,nami,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,2,namo,n,.true.,error)
    if (error) return
    call sub_splitpolar (nami,namo,mystoke,hin,error)  
    call gdf_close_image(hin,err)
  else
    call sub_splitpolar_mem (mystoke,huv,error)
  endif
  !
end subroutine stokes_comm
!<FF>
subroutine sub_splitpolar(nami,namo,mystoke,hin,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use code_polar_gildas
  use imager_interfaces, except_this => sub_splitpolar
  !
  ! @ private
  !
  character(len=*), intent(inout) :: nami  ! Input file name
  character(len=*), intent(inout) :: namo  ! Output file name
  character(len=*), intent(in) :: mystoke  ! Desired Stoke parameter
  type (gildas), intent(inout) :: hin
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='STOKES'
  type (gildas) :: hou
  real(kind=4), allocatable :: din(:,:), dou(:,:)
  !
  character(len=message_length) :: mess
  !
  integer :: i, j, k, istoke, ivisi, is, iv, jv, ier, ipara
  integer :: astoke(4), ostoke(5)
  integer :: nstok, natom, nlead, nchan, next
  logical :: extract, doit
  integer :: intrail, ontrail, iend, oend
  integer :: kv, iloop, nblock, nvisi, mblock, multi
  integer :: isign=1    ! This should be the correct sign for Parallactic Angle
  integer :: iextract  
  !
  error = .false.
  !
  extract = .false.
  !
  ! Scan the requested polarization code
  if (mystoke.eq.'NONE') then
    istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
    istoke = code_stokes_all
  else
    call gdf_stokes_code(mystoke,istoke,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
      error = .true.
      return
    endif
  endif
  !
  ! Read Header of a sorted, UV table
  call gildas_null(hin, type= 'UVT')
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  !
  ipara = hin%gil%column_pointer(code_uvt_para)
  ! Test for debug
  call sic_get_inte('SIGN_PARA',isign,error)
  if (isign.ne.1) Print *,'Using ISIGN ',ISIGN
  !
  !
  call gildas_null(hou, type='UVT')
  call gdf_copy_header (hin, hou, error)
  call sic_parsef (namo,hou%file,'  ','.uvt')
  !
  ! Define the Output Stokes parameter value
  hou%gil%nstokes = 1
  hou%gil%order = istoke           ! Unless it is "ANY" - will be changed later
  !
  call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
  nblock = min(nblock,hin%gil%dim(2))
  !
  ! Check Random Frequency / Stokes axis
  if (hin%gil%nfreq.ne.0) then
    call map_message(seve%i,rname,'Random Frequency Axis case ')
    !
    nstok = 1
    astoke(1) = hin%gil%stokes(1)
    do i=2,hin%gil%nfreq
      k = 0
      do j=1,nstok
        if (astoke(j).eq.hin%gil%stokes(i)) then
          k = j
          exit
        endif
      enddo
      if (k.eq.0) then
        nstok = nstok+1
        astoke(nstok) = hin%gil%stokes(i)
      endif
    enddo
    !!Print *,'Found ',nstok,' Stokes of values ',astoke(1:nstok)
    !
    natom = hin%gil%natom
    nchan = hin%gil%nchan
    nlead = hin%gil%nlead
    intrail = hin%gil%ntrail
    ontrail = intrail
    iend = hin%gil%dim(1)
    !
    if (nstok.eq.1) then
      !
      ! Only 1 Stokes in input file, verify if the Stokes value ASTOKE(1) in the data
      ! file is an acceptable proxy of the desired Ouput Stokes values ISTOKE
      doit = .false.
      if (istoke.eq.astoke(1) .or. istoke.eq.0) then
        doit = .true.
      else if (istoke.ge.code_stokes_i .or. istoke.eq.code_stokes_none &
        .or. istoke.eq.code_stokes_all) then
        if ( (astoke(1).eq.code_stokes_hh) .or. (astoke(1).eq.code_stokes_vv) ) doit = .true.
        if ( (astoke(1).eq.code_stokes_ll) .or. (astoke(1).eq.code_stokes_rr) ) doit = .true.
        if ( (astoke(1).eq.code_stokes_xx) .or. (astoke(1).eq.code_stokes_yy) ) doit = .true.
        if ( (astoke(1).eq.code_stokes_i) ) doit = .true.
      endif
      !
      if (doit) then
        hou%gil%stokes(:) = istoke  ! Change the Stokes information
        !
        ! OK copy the whole stuff...
        allocate (din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error ')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        call map_message(seve%i,rname,'Replicating UV table ')
        do iloop = 1,hin%gil%dim(2),nblock
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          hou%blc(2) = iloop
          hou%trc(2) = hin%trc(2)
          call gdf_read_data (hin,din,error)
          if (error) return
          call gdf_write_data (hou, din, error)
          if (error) return
        enddo
        call gdf_close_image(hou,error)
      else
        call map_message(seve%i,rname,'Polar '//mystoke// &
        ' does not match '//gdf_stokes_name(astoke(1)) )
        error = .true.
      endif
      !
      return
    else if (nstok.ge.2) then
      !
      ! Two or more Stokes values in data file
      iextract = 0
      if (nstok.eq.2) then
        ! Two Stokes values ASTOKE(1:2)
        !
        ! Check first for simple Extraction of ISTOKE
        doit = .false.
        if (istoke.eq.astoke(1)) then
          iextract = 1
          doit = .true.
        else if (istoke.eq.astoke(2)) then
          iextract = 2
          doit = .true.
          ! Then for conversion
        else if (istoke.ge.code_stokes_i .or. istoke.eq.code_stokes_none &
          .or. istoke.eq.code_stokes_all) then
          call polar_order(nstok,astoke,ostoke,error)
          if (error) then
            call map_message(seve%i,rname,'Unsupported conversion from Stokes '//gdf_stokes_name(astoke(1))// &
              &' '//gdf_stokes_name(astoke(2))//' to Stokes '//gdf_stokes_name(istoke) )
            return
          endif
          iextract = 0
          call map_message(seve%i,rname,'Conversion from Stokes '//gdf_stokes_name(astoke(1))// &
            &' '//gdf_stokes_name(astoke(2))//' to Stokes '//gdf_stokes_name(istoke) )
        endif
      else if (nstok.eq.4) then
        !
        ! 4 Stokes values, there is always a solution
        doit = .true. !!! TEST
        iextract = 0
        call polar_order(nstok,astoke,ostoke,error)
        if (error) return
      endif
      if (iextract.ne.0) call map_message(seve%i,rname,'Extracting Stokes '//gdf_stokes_name(istoke) )
      !
      ! Re-allocate the Frequencies and Stokes axes
      hou%gil%nfreq = hin%gil%nfreq / nstok
      deallocate(hou%gil%stokes,hou%gil%freqs)
      allocate(hou%gil%stokes(hou%gil%nfreq),hou%gil%freqs(hou%gil%nfreq),stat=ier)
      hou%gil%stokes(:) = istoke
      hou%gil%nstokes = 1
      k = max(iextract,1)
      do i=1,hou%gil%nfreq
        hou%gil%freqs(i) = hin%gil%freqs(k)
        k = k+nstok
      enddo
      !
      ! Shift the trailing columns
      do i=1,code_uvt_last
        if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
          hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
            & hin%gil%natom * hin%gil%nchan
        endif
      enddo
      !
      ! Then, do the job
      hou%gil%dim(2) = hou%gil%nvisi
      hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom &
                     + ontrail-intrail
      oend = hou%gil%dim(1)+intrail-ontrail
      !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
      !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
      !!Print *,'OEND ',oend, intrail, ontrail
      if (istoke.eq.code_stokes_all) then
          PRINT *,'Invalid Stokes ALL code'
          error = .true.
          return
!!        hou%gil%column_pointer(code_uvt_stok) = hou%gil%dim(1)
      endif
      !
      ! Here, we make the loop
      allocate (dou(hou%gil%dim(1),nblock),din(hin%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      !
      hin%blc = 0
      hin%trc = 0
      hou%blc = 0
      hou%trc = 0
      !
!TEST!      call gdf_print_header(hou)
!TEST!      read(5,*) iextract
      !
      call gdf_create_image(hou,error)
      if (error) return
      !
      hou%blc(2) = 1
      do iloop = 1,hin%gil%dim(2),nblock
        write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
        call map_message(seve%d,rname,mess)
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        call gdf_read_data(hin,din,error)
        if (error) return
        nvisi = hin%trc(2)-hin%blc(2)+1
        !
        ! This must be Nstokes x Nchan channels order...
        !!Print *,'ISTOKE ',istoke,' ASTOKE ',astoke(1:nstok)
        call stokes_derive_stok (din,dou,nvisi,nlead,natom,nchan,nstok, &
        & intrail,istoke,astoke,ipara,isign,error, ostoke)
        if (error) return
        !
        hou%trc(2) = hou%blc(2)+nvisi-1
        call gdf_write_data(hou,dou,error)
        hou%blc(2) = hou%trc(2)+1
        !
      enddo ! By block
      !
      call gdf_close_image(hou,error)
      return
    endif
    !
    ! Failure Cases...
    call map_message(seve%e,rname,'Cannot yet handle Random Stokes / Frequency values')
    error = .true.
    return
  endif
  !
  ! Check it has more than 1 polarization
  if (hin%gil%nstokes.eq.1) then
    call map_message(seve%i,rname,'Already only 1 polar per visibility ')
    ! Here need to check if a Polar column is present, through the
    ! extra columns (code_uvt_stok)
    !
    is = hin%gil%column_pointer(code_uvt_stok)
    if (is.eq.0) then
      call map_message(seve%i,rname,'Already only 1 polar in total')
      nstok = 1
      astoke(nstok) = hin%gil%order
      if (istoke.eq.astoke(1) .or. istoke.eq.0) then
        !
        ! OK copy the whole stuff...
        allocate (din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error ')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        call map_message(seve%i,rname,'Replicating UV table ')
        do iloop = 1,hin%gil%dim(2),nblock
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          hou%blc(2) = iloop
          hou%trc(2) = hin%trc(2)
          call gdf_read_data (hin,din,error)
          if (error) return
          call gdf_write_data (hou, din, error)
          if (error) return
        enddo
        call gdf_close_image(hou,error)
      else
        call map_message(seve%i,rname,'Polar '//mystoke// &
        ' does not match '//gdf_stokes_name(astoke(1)) )
        error = .true.
      endif
      !
      return
    else
      call map_message(seve%i,rname,'Perhaps more than 1 polar, scanning...')
      allocate (din(hin%gil%dim(1),nblock),dou(hou%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%i,rname,'Memory allocation error ')
        error = .true.
        return
      endif
      !
      hin%blc = 0
      hin%trc = 0
      hou%blc = 0
      hou%trc = 0
      hou%blc(2) = 1
      jv = 0
      call gdf_create_image(hou,error)
      if (error) return
      !
      nstok = 0
      do iloop = 1,hin%gil%dim(2),nblock
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        kv = hin%trc(2)-hin%blc(2)+1
        call gdf_read_data (hin,din,error)
        if (error) return
        !
        jv = 0
        do iv = 1,kv
          if (din(is,iv).ne.istoke) cycle
          jv = jv+1
          dou(:,jv) = din(:,iv)
        enddo
        !
        if (jv.gt.0) then
          hou%trc(2) = hou%blc(2)+jv-1
          call gdf_write_data(hou,dou,error)
          hou%blc(2) = hou%trc(2)+1
        endif
      enddo
      !
      ! Finalize
      hou%gil%nvisi = hou%trc(2)
      hou%gil%dim(2) = hou%trc(2)
      call gdf_update_header(hou,error)
      call gdf_close_image(hou,error)
    endif
    !
  else
    !
    ! This means each Visi has Nstokes x Nchan or Nchan x Nstokes elements
    !
    if (hin%gil%order.eq.code_chan_stok) then
      ! Nchan X Nstokes channels
      !
      call map_message(seve%i,rname,'Input order: Nchan channels X Nstokes stokes')
    else if (hin%gil%order.eq.code_stok_chan) then
      call map_message(seve%i,rname,'Input order: Nstokes stokes X  Nchan channels')
      ! Nstokes x Nchan channels
    else
      call map_message(seve%e,rname,'Inconsistent UV table state for polarization')
      error = .true.
      return
    endif
    nstok = hin%gil%nstokes
    mess = 'Input Stokes: '
    next = 20
    do i=1,nstok
      mess(next:) = gdf_stokes_name(hin%gil%stokes(i))
      next = len_trim(mess)+3
    enddo
    call map_message(seve%i,rname,mess)
    call map_message(seve%i,rname,'Output Stokes:     '//gdf_stokes_name(istoke))
    !
    !!print *,'DIN ',(din(1:10,i),i=1,10)
    !
    astoke(1:nstok) = hin%gil%stokes(1:nstok)
    natom = hin%gil%natom
    nchan = hin%gil%nchan
    nlead = hin%gil%nlead
    intrail = hin%gil%ntrail
    ontrail = intrail
    iend = hin%gil%dim(1)
    !
    ! The useful cases are
    if (nstok.eq.2) then
      if (istoke.ge.code_stokes_i .or. istoke.eq.code_stokes_none &
        .or. istoke.eq.code_stokes_all) then
        ! Input: 2 Stokes, HH+VV or XX+YY or RR+LL, Output: I, NONE or ALL
        ! keep everything, make proper weighting
        call polar_order(nstok,astoke,ostoke,error)
        if (error) then
          call map_message(seve%i,rname,'Unsupported conversion from Stokes '//gdf_stokes_name(astoke(1))// &
            &' '//gdf_stokes_name(astoke(2))//' to Stokes '//gdf_stokes_name(istoke) )
          return
        endif
        !
        if (istoke.eq.code_stokes_all) then
          hou%gil%nvisi = 2*hin%gil%nvisi
          multi = 2
          ontrail = ontrail+1
        else
          multi = 1
          hou%gil%nvisi = hin%gil%nvisi
        endif
        call map_message(seve%i,rname,'Deriving '//mystoke// &
        ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & hin%gil%natom * hin%gil%nchan
          endif
        enddo
        !
        hou%gil%dim(2) = hou%gil%nvisi
        hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom &
                       + ontrail-intrail
        oend = hou%gil%dim(1)+intrail-ontrail
        !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
        !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
        !!Print *,'OEND ',oend, intrail, ontrail
        if (istoke.eq.code_stokes_all) then
          hou%gil%column_pointer(code_uvt_stok) = hou%gil%dim(1)
        endif
        !
        ! Here, we make the loop
        ! We make no assumption about the Stokes ordering, so allocate
        ! a block which may handle all input visibilities
        mblock = multi*nblock
        allocate (dou(hou%gil%dim(1),mblock),din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        hou%blc(2) = 1
        do iloop = 1,hin%gil%dim(2),nblock
          write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
          call map_message(seve%d,rname,mess)
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          call gdf_read_data(hin,din,error)
          if (error) return
          nvisi = hin%trc(2)-hin%blc(2)+1
          !
          if (hin%gil%order.eq.code_chan_stok) then
            ! Nchan X Nstokes channels  (ALL)
            !
            if (istoke.eq.code_stokes_all) then
              !
              jv = 0
              do iv = 1,nvisi
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1:nlead+natom*nchan,iv)
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(1)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
                !
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1+natom*nchan:nlead+2*natom*nchan,iv)
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(2)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
              enddo
            else
              call map_message(seve%e,rname, &
              & 'Nchan X Nstokes channel order only supported for code ALL')
              error = .true.
              return
            endif
          else
            !
            ! Nstokes x Nchan channels
            call stokes_derive_stok(din,dou,nvisi,nlead,natom,nchan,nstok, &
            & intrail,istoke,astoke,ipara,isign,error, ostoke)
            if (error) return
          endif
          hou%trc(2) = hou%blc(2)+multi*nvisi-1
          call gdf_write_data(hou,dou,error)
          hou%blc(2) = hou%trc(2)+1
          !
        enddo ! By block
      else
        ! Input: 2 Stokes, HH+VV or RR+LL, Output: one among these.
        ! keep only that one...
        if (istoke.eq.astoke(1)) then
          ivisi = 1
        else if (istoke.eq.astoke(2)) then
          ivisi = 2
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
          error = .true.
          return
        endif
        call map_message(seve%e,rname,'Extracting '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
        !
        hou%gil%dim(1) = hin%gil%dim(1)-hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
      !
    else if (nstok.eq.4) then
      !
      ! 4 Stokes, extract one of them, or derive the desired one from others
      ivisi = 0
      do i=1,nstok
        if (istoke.eq.astoke(i)) then
          ivisi = i
          exit
        endif
      enddo
      !
      if (ivisi.eq.0) then
        ! Cannot be extracted, must be Derived
        !
        if ( (istoke.eq.code_stokes_none) .or. & 
          & ((istoke.ge.code_stokes_i).and.(istoke.le.code_stokes_v)) )  then
          !
          call polar_order(nstok,astoke,ostoke,error)
          if (error) return
          !
          multi = 1   ! 1 output visibility per input Visibility      
          ! Shift the trailing columns
          do i=1,code_uvt_last
            if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
              hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
                & 3 * hin%gil%natom * hin%gil%nchan
            endif
          enddo
          !
          ! Figure out which case is to be compressed
          hou%gil%dim(2) = hou%gil%nvisi
          hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom &
                &        + ontrail-intrail
          oend = hou%gil%dim(1)+intrail-ontrail
          !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
          !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
          !!Print *,'OEND ',oend, intrail, ontrail
          !
          ! Here, we make the loop
          ! We make no assumption about the Stokes ordering, so allocate
          ! a block which may handle all input visibilities
          mblock = multi*nblock
          allocate (dou(hou%gil%dim(1),mblock),din(hin%gil%dim(1),nblock),stat=ier)
          if (ier.ne.0) then
            call map_message(seve%e,rname,'Memory allocation error')
            error = .true.
            return
          endif
          !
          hin%blc = 0
          hin%trc = 0
          hou%blc = 0
          hou%trc = 0
          call gdf_create_image(hou,error)
          if (error) return
          !
          hou%blc(2) = 1
          do iloop = 1,hin%gil%dim(2),nblock
            write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
            call map_message(seve%i,rname,mess)
            hin%blc(2) = iloop
            hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
            call gdf_read_data(hin,din,error)
            if (error) return
            nvisi = hin%trc(2)-hin%blc(2)+1
            !
            ! Nstokes x Nchan channels
            if (hin%gil%order.eq.code_chan_stok) then
              call stokes_derive_chan(din,dou,nvisi,nlead,natom,nchan,nstok, &
                & intrail,istoke,astoke,ipara,isign,error, ostoke)            
            else
            !
              call stokes_derive_stok(din,dou,nvisi,nlead,natom,nchan,nstok, &
                & intrail,istoke,astoke,ipara,isign,error, ostoke)
            endif
            if (error) return
            !
            hou%trc(2) = hou%blc(2)+multi*nvisi-1
            call gdf_write_data(hou,dou,error)
            hou%blc(2) = hou%trc(2)+1
          enddo ! Block
          !
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
            & ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))// &
            & gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)) )
          error = .true.
          return
        endif
      else
        ! Extraction among those already present
        call map_message(seve%i,rname,'Extracting '//mystoke// &
            & ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))// &
            & gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)) )
        !
        hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & 3 * hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
    endif
    !
    ! The extraction code makes no assumption about the Stokes order at all.
    if (extract) then
      !
      call gdf_create_image(hou,error)
      if (error) return
      !
      allocate (dou(hou%gil%dim(1),nblock),din(hin%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error ')
        error = .true.
        return
      endif
      hin%blc = 0
      hou%trc = 0
      !
      hou%blc(2) = 1
      do iloop = 1,hin%gil%dim(2),nblock
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        kv = hin%trc(2)-hin%blc(2)+1
        call gdf_read_data(hin,din,error)
        if (error) return
        !
        call stokes_extract(hin%gil%order,din,dou,kv,nlead,natom,nchan,nstok,intrail,ivisi)
        !
        hou%trc(2) = hou%blc(2)+kv-1
        call gdf_write_data(hou,dou,error)
        hou%blc(2) = hou%trc(2)+1
      enddo
    endif
    call gdf_close_image(hou,error)
  endif
  !
end subroutine sub_splitpolar
!
subroutine stokes_extract(inorder,din,dou,nvisi,nlead,natom,nchan,nstok, & 
  & ntrail,ivisi)
  use image_def
  use code_polar_gildas
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !
  ! Support routine for STOKES command: extract the relevant
  ! Stokes parameter from the input visibilities. 
  !---------------------------------------------------------------------  
  real(kind=4), intent(in) :: din(:,:)
  real(kind=4), intent(out) :: dou(:,:)
  integer, intent(in) :: inorder ! Code order
  integer, intent(in) :: nvisi  ! number of visibilities
  integer, intent(in) :: nlead  ! number of leading columns
  integer, intent(in) :: natom  ! Atomic length of a visibility (2 or 3)
  integer, intent(in) :: nchan  ! number of channels
  integer, intent(in) :: nstok  ! number of input Stokes
  integer, intent(in) :: ntrail ! number of trailing columns
  integer, intent(in) :: ivisi  ! Pointer into Stokes parameter
  !
  integer :: iv
  integer :: ic
  integer :: kin, kou
  !
  if (inorder.eq.code_chan_stok) then
    ! Nchan X Nstokes channels
    do iv = 1,nvisi
      dou(1:nlead,iv) = din(1:nlead,iv)
      dou(nlead+1:nlead+natom*nchan,iv) = &
      & din(nlead+1+(ivisi-1)*natom*nchan:nlead+ivisi*natom*nchan,iv)
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+nstok*natom*nchan:,iv)
    enddo
  else
    ! Nstokes x Nchan channels
    do iv = 1,nvisi 
      dou(1:nlead,iv) = din(1:nlead,iv)
      kin = nlead+(ivisi-1)*natom
      kou = nlead
      do ic=1,nchan
        dou(kou+1:kou+natom,iv) = din(kin+1:kin+natom,iv)
        kou = kou + natom
        kin = kin + nstok*natom
      enddo
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+nstok*natom*nchan:,iv)
    enddo
  endif
end subroutine stokes_extract
!
subroutine stokes_derive_stok(din,dou,nvisi,nlead,natom,nchan,nstok,ntrail, &
  & istoke,astoke,ipara,isign,error, cstoke)
  use image_def
  use gbl_message
  use code_polar_gildas
  use gkernel_interfaces, only : gdf_stokes_name
  use imager_interfaces, only : map_message, findloc
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !
  ! Support routine for STOKES command: Derive the relevant
  ! Stokes parameter from the input visibilities. This routine works
  ! for CODE_STOKE_CHAN order, and 2 or 4 input Stokes parameters.
  ! Not all combinations are allowed, however.
  !
  ! Stokes vary first,  Channel next
  !---------------------------------------------------------------------  
  real(kind=4), intent(in) :: din(:,:)
  real(kind=4), intent(out) :: dou(:,:)
  integer, intent(in) :: nvisi  ! Number of visibilities
  integer, intent(in) :: nlead  ! number of leading columns
  integer, intent(in) :: natom  ! Atomic length of a visibility (2 or 3)
  integer, intent(in) :: nchan  ! number of channels
  integer, intent(in) :: nstok  ! number of input Stokes
  integer, intent(in) :: ntrail ! number of trailing columns
  integer, intent(in) :: istoke ! desired Stokes parameter
  integer, intent(in) :: astoke(nstok)   ! Input Stokes parameters
  integer, intent(in) :: ipara  ! Parallactic angle column
  integer, intent(in) :: isign  ! test integer for PA angle
  logical, intent(out) :: error ! Error flag
  integer, intent(in) :: cstoke(5)
  !
  character(len=*), parameter :: rname='STOKES'
  !
  character(len=80) :: msg
  integer :: iv, jv         !   Pointer to visibilities
  integer :: kin, kou, kk   !   Pointer to channel in visibilities
  integer :: ic, ip, is, iext
  real :: re, im, we, da, db
  integer :: iend, oend, multi, jsign, kxy, kyx
  real :: hh(2), hv(2), vv(2), vh(2), aa(2), bb(2), xy(2), yx(2)
  real :: xr, xi, xw ! (real, imag, weight) for current visibility
  real :: xa, yb  ! Cos/Sin or vice versa or 0,1
  real :: rr(2), ll(2), rl(2), lr(2)
  logical :: debug
  logical :: good_order, circular
  !
  iend = ubound(din,1)
  oend = ubound(dou,1)
  !
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)  
  if (debug) then
    Print *, 'NVISI ', nvisi  ! Number of visibilities
    Print *, 'NLEAD ', nlead  ! number of leading columns
    Print *, 'NATOM ', natom  ! Atomic length of a visibility (2 or 3)
    Print *, 'NCHAN ', nchan  ! number of channels
    Print *, 'NSTOK ', nstok  ! number of input Stokes
    Print *, 'NTRAIL ', ntrail ! number of trailing columns
    Print *, 'ISTOKE ', istoke ! desired Stokes parameter
    Print *, 'ASTOKE ', astoke(1:nstok)   ! Input Stokes parameters
    Print *, 'IPARA ', ipara ! Parallactic angle column
    Print *,'Iend ',iend,' Oend ',oend
  endif
  error = .false.
  !
  if (istoke.eq.code_stokes_all) then
    multi = nstok
    oend = oend-1
  else
    multi = 1
  endif
  !
  jv = 0
  select case(istoke)
  !
  case (code_stokes_none)  
    ! Stokes NONE: Unpolarized case - optimize sensitivity
    jv = 0
    do iv = 1,nvisi
      jv = jv+1
      dou(1:nlead,jv) = din(1:nlead,iv)
      kin = nlead
      kou = nlead
      ! 
      do ic=1,nchan
        xr = din(kin+(cstoke(1)-1)*natom+1,iv)
        xi = din(kin+(cstoke(1)-1)*natom+2,iv)
        xw = din(kin+(cstoke(1)-1)*natom+natom,iv)
        if (xw.gt.0) then
          re = xr * xw
          im = xi * xw
          we = xw 
        else
          re = 0
          im = 0
          we = 0
        endif
        xr = din(kin+(cstoke(2)-1)*natom+1,iv)
        xi = din(kin+(cstoke(2)-1)*natom+2,iv)
        xw = din(kin+(cstoke(2)-1)*natom+natom,iv)
        if (xw.gt.0) then
          re = re + xr * xw
          im = im + xi * xw
          we = we + xw
        endif
        if (we.ne.0) then
          dou(kou+1:kou+1,jv) = re/we
          dou(kou+2:kou+2,jv) = im/we
          dou(kou+natom:kou+natom,jv) = we
        else
          dou(kou+1:kou+natom,jv) = 0
        endif
        !
        kou = kou + natom
        kin = kin + natom*nstok
      enddo
      !
      ! Fill trailing columns
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
           din(nlead+1+nstok*natom*nchan:iend,iv)
    enddo
  case (code_stokes_i)
    ! Stokes I
    ! Stokes I is strictly Stokes I, i.e.   (HH+VV)/2 or (LL+RR)/2, not
    ! an arbitray weighted combination.
    ! For unpolarized signals, to maximize sensitivity, use Stokes NONE
    do iv=1,nvisi
      jv = jv+1
      dou(1:nlead,jv) = din(1:nlead,iv)
      kin = nlead
      kou = nlead
      !
      do ic=1,nchan
        xr = din(kin+(cstoke(1)-1)*natom+1,iv)
        xi = din(kin+(cstoke(1)-1)*natom+2,iv)
        xw = din(kin+(cstoke(1)-1)*natom+natom,iv)
        if (xw.gt.0) then
          re = xr 
          im = xi
          we = xw 
          da = 1.0/xw
          ip = 1
        else
          re = 0
          im = 0
          ip = 0
          da = 0
        endif
        xr = din(kin+(cstoke(2)-1)*natom+1,iv)
        xi = din(kin+(cstoke(2)-1)*natom+2,iv)
        xw = din(kin+(cstoke(2)-1)*natom+natom,iv)
        if (xw.gt.0)  then
          re = re+xr
          im = im+xi
          db = 1.0/xw     ! Noise**2
          ip = ip+1
        else
          db = 0.0
        endif
        if (ip.eq.2) then
          dou(kou+1,jv) = re / ip 
          dou(kou+2,jv) = im / ip
          dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
        else
          dou(kou+natom,jv) = 0.0
        endif
        !
        ! Skip the input multi-Stokes visibility
        kin = kin + nstok*natom
        kou = kou + natom
      enddo
      !
      ! Fill trailing columns
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
           din(nlead+1+nstok*natom*nchan:iend,iv)
    enddo
    !
  case (code_stokes_V)
    ! Stokes V is -j(VH-HV)/2 or -j(XY-YX)/2 or (RR-LL)/2
    ! a proper test on ordering would be good.
    !
    ! Natom must be 3 in this case (we need complex numbers)
    if ((cstoke(5).eq.code_polar_linear).or.(cstoke(5).eq.code_polar_horizon)) then
      ! Initial Linear polarization
      !
      ! V = -j (XY-YX)/2  =  -j (VH-HV)/2
      !
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        do ic=1,nchan
          !
          kxy = kin+natom*(cstoke(3)-1)      ! XY or VH pointer 
          kyx = kin+natom*(cstoke(4)-1)      ! YX or HV pointer 
          !
          if (din(kxy+natom,iv).gt.0)  then
            XY(1:2) = din(kxy+1:kxy+natom-1,iv)  
            da = 1.0/din(kxy+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          if (din(kyx+natom,iv).gt.0)  then
            YX(1:2) = din(kyx+1:kyx+natom-1,iv)
            db = 1.0/din(kyx+natom,iv)  ! Noise**2
            ip = ip+1
          else
            db = 0.0
          endif
          if (ip.eq.2) then
            dou(kou+1:kou+1,jv) = +(xy(2)-yx(2))/2          
            dou(kou+2:kou+2,jv) = -(xy(1)-yx(1))/2
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + nstok*natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    else if (cstoke(5).eq.code_polar_circular) then
      !
      ! (RR - LL ) /2
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        !
        do ic=1,nchan
          !
          kxy = kin+natom*(cstoke(1)-1)      ! RR pointer 
          kyx = kin+natom*(cstoke(2)-1)      ! LL pointer 
          if (din(kxy+natom,iv).gt.0)  then
            RR(1:2) = din(kxy+1:kxy+natom-1,iv)  
            da = 1.0/din(kxy+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          if (din(kyx+natom,iv).gt.0)  then
            LL(1:2) = din(kyx+1:kin+natom-1,iv)
            db = 1.0/din(kyx+natom,iv)  ! Noise**2
            ip = ip+1
          else
            db = 0.0
          endif
          if (ip.eq.2) then
            dou(kou+1:kou+2,jv) = (rr-ll)/2
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom*nstok
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
    else
      write(msg,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported'
      call map_message(seve%e,rname,msg)
      error = .true.
      return
    endif    
    !  
    ! UPDATED up to this point
  case (code_stokes_Q,code_stokes_U)
    ! Stokes Q and U are more complex
    !
    ! From HH,VV etc..., they require the parallactic angle and HH,VV,HV,VH order
    ! From XX,YY etc..., they require XX,YY,XY,YX order, but no parallactic angle
    ! a proper test on ordering would be good.
    !
    ! Natom must be 3 in this case (we need complex numbers)
    good_order = .false.
    circular = .false. 
    if (cstoke(5).ge.code_polar_horizon) then      ! V and H
      if (ipara.eq.0) then
        call map_message(seve%e,rname,'No parallactic angle column ')
        error = .true.
        return
      endif
      jsign = isign ! Temporary, normally should be 1
      good_order = .true.
    else if (cstoke(5).eq.code_polar_circular) then ! R and L
      write(msg,'(A,4(1X,I0),A)') 'Ordering of R,L circular polarization not fully tested'
      call map_message(seve%w,rname,msg)
      good_order = .false.
      circular = .true.
    else if (cstoke(5).eq.code_polar_linear) then  ! X and Y
      jsign = 0
      good_order = .true.
    else
      write(msg,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported '
      call map_message(seve%e,rname,msg)
      error = .true.
      return
    endif    
    !
    if (good_order) then
      !
      ! compute aa = (VV-HH)/2   and bb = (VH+HV)/2 then
      !  Q = aa cos(2.phi) - bb sin(2.phi)
      !  U = aa sin(2.phi) + bb cos(2.phi)
      ! or
      ! compute aa = (XX-YY)/2   and bb = (XY+YX)/2 then
      !  Q = aa 
      !  U = bb
      !
      db = 0 ! to avoid initialization warnings.
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        if (istoke.eq.code_stokes_q) then
          if (jsign.ne.0) then
            xa =  cos(2*jsign*din(ipara,iv))
            yb = -sin(2*jsign*din(ipara,iv))
          else
            xa = 1.0
            yb = 0.0
          endif
        else
          if (jsign.ne.0) then
            xa = sin(2*jsign*din(ipara,iv))
            yb = cos(2*jsign*din(ipara,iv))
          else
            xa = 0.0
            yb = 1.0
          endif
        endif
        !
        ! Return order in CSTOKE is VV,HH,VH,HV or XX,YY,XY,YX
        do ic=1,nchan
          !
          kk = kin+(cstoke(1)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            VV(1:2) = din(kk+1:kk+natom-1,iv)  
            da = 1.0/din(kk+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kk = kin+(cstoke(2)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            HH(1:2) = din(kk+1:kk+natom-1,iv)
            db = 1.0/din(kk+natom,iv)  ! Noise**2
            ip = ip+1
          endif
          kk = kin+(cstoke(3)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            VH(1:2) = din(kk+1:kk+natom-1,iv)
            ip = ip+1
          endif
          kk = kin+(cstoke(4)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            HV(1:2) = din(kk+1:kk+natom-1,iv)
            ip = ip+1
          endif
          !
          aa = (VV-HH)/2
          bb = (VH+Hv)/2
          !
          if (ip.eq.4) then
            dou(kou+1:kou+2,jv) = xa*aa + yb*bb
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom * nstok
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    else if (circular) then
      !
      db = 0   ! Avoid initialization warning
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        do ic=1,nchan
          kk = kin+(cstoke(1)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            RR(1:2) = din(kk+1:kk+natom-1,iv)  
            da = 1.0/din(kk+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kk = kin+(cstoke(2)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            LL(1:2) = din(kk+1:kk+natom-1,iv)
            db = 1.0/din(kk+natom,iv)  ! Noise**2
            ip = ip+1
          endif
          kk = kin+(cstoke(3)-1)*natom
          if (din(kin+natom,iv).gt.0)  then
            RL(1:2) = din(kk+1:kk+natom-1,iv)
            ip = ip+1
          endif
          kk = kin+(cstoke(4)-1)*natom
          if (din(kk+natom,iv).gt.0)  then
            LR(1:2) = din(kk+1:kk+natom-1,iv)
            ip = ip+1
          endif
          !
          if (istoke.eq.code_stokes_q) then
            !  Q = (RL + LR)/2 
            bb = (RL+LR)/2
          else if (istoke.eq.code_stokes_u) then              
            !  U = -i (RL - LR)/2 
            aa = (RL-LR)/2
            bb(2) = -aa(1)
            bb(1) =  aa(2)
          endif
          !
          if (ip.eq.4) then
            dou(kou+1:kou+2,jv) = bb !! 
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom * nstok
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo    
    endif
    !  
  case (code_stokes_all)
    ! Stokes ALL : explodes the Stokes / Channel visibilities
    ! into one visibility per Stokes. Add the Stokes column at
    ! end of each Visibility.  
    do iv=1,nvisi
      do is=1,nstok
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        do ic=1,nchan
          dou(kou+1:kou+natom,jv) = din(kin+1:kin+natom,iv)
          kou = kou + natom
          kin = kin + nstok*natom
        enddo
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
        dou(oend+1,jv) = astoke(is)
      enddo
    enddo
  case default
    !
    ! It may be a simple extraction
    iext = findloc(astoke,istoke,1)
    if (iext.ne.0) then
      !
      ! Nstokes x Nchan channels
      do iv = 1,nvisi 
        dou(1:nlead,iv) = din(1:nlead,iv)
        kin = nlead+(iext-1)*natom
        kou = nlead
        do ic=1,nchan
          dou(kou+1:kou+natom,iv) = din(kin+1:kin+natom,iv)
          kou = kou + natom
          kin = kin + nstok*natom
        enddo
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+nstok*natom*nchan:,iv)
      enddo
      jv = nvisi
    else
      call map_message(seve%i,rname,'Case '//gdf_stokes_name(istoke)//' not supported in this context')
      error = .true.
      return
    endif
  end select
  !
  ! Sanity check
  if (jv.ne.multi*nvisi) then
    write(msg,'(A,I0,A,I0)') 'Expecting up to ',nvisi,' visibilities, found ',jv
    call map_message(seve%e,rname,msg)
  endif
end subroutine stokes_derive_stok
!
subroutine stokes_derive_chan(din,dou,nvisi,nlead,natom,nchan,nstok,ntrail, &
  & istoke,astoke,ipara,isign,error, cstoke)
  use image_def
  use code_polar_gildas
  use gbl_message
  use gkernel_interfaces, only : gdf_stokes_name
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !
  ! Support routine for STOKES command: Derive the relevant
  ! Stokes parameter from the input visibilities. This routine works
  ! for CODE_CHAN_STOKE order, and 2 or 4 input Stokes parameters.
  !
  ! CSTOKE handles the ordering of the Polarization states.
  !---------------------------------------------------------------------  
  real(kind=4), intent(in) :: din(:,:)
  real(kind=4), intent(out) :: dou(:,:)
  integer, intent(in) :: nvisi  ! Number of visibilities
  integer, intent(in) :: nlead  ! number of leading columns
  integer, intent(in) :: natom  ! Atomic length of a visibility (2 or 3)
  integer, intent(in) :: nchan  ! number of channels
  integer, intent(in) :: nstok  ! number of input Stokes
  integer, intent(in) :: ntrail ! number of trailing columns
  integer, intent(in) :: istoke ! desired Stokes parameter
  integer, intent(in) :: astoke(nstok)   ! Input Stokes parameters
  integer, intent(in) :: ipara  ! Parallactic angle column
  integer, intent(in) :: isign  ! test integer for PA angle
  logical, intent(out) :: error ! Error flag
  integer, intent(in) :: cstoke(5)  ! Order of Polarization components
  !
  ! HERE HERE
  !
  character(len=*), parameter :: rname='STOKES'
  !
  character(len=80) :: msg
  integer :: iv, jv
  integer :: kin, kou, kk
  integer :: ic, ip, is
  real :: re, im, we, da, db
  integer :: iend, oend, multi, jsign
  real :: hh(2), hv(2), vv(2), vh(2), aa(2), bb(2), xa, yb
  real :: rr(2), ll(2), rl(2), lr(2)
  logical :: debug
  logical :: circular
  !
  iend = ubound(din,1)
  oend = ubound(dou,1)
  !
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)  
  if (debug) then
    Print *, 'NVISI ', nvisi  ! Number of visibilities
    Print *, 'NLEAD ', nlead  ! number of leading columns
    Print *, 'NATOM ', natom  ! Atomic length of a visibility (2 or 3)
    Print *, 'NCHAN ', nchan  ! number of channels
    Print *, 'NSTOK ', nstok  ! number of input Stokes
    Print *, 'NTRAIL ', ntrail ! number of trailing columns
    Print *, 'ISTOKE ', istoke ! desired Stokes parameter
    Print *, 'ASTOKE ', astoke(1:nstok)   ! Input Stokes parameters
    Print *, 'IPARA ', ipara ! Parallactic angle column
    Print *,'Iend ',iend,' Oend ',oend
  endif
  error = .false.
  !
  if (istoke.eq.code_stokes_all) then
    multi = nstok
    oend = oend-1
  else
    multi = 1
  endif
  !
  jv = 0
  select case(istoke)
  !
  case (code_stokes_none)  
    ! Stokes NONE: Unpolarized case - optimize sensitivity
    ! Order HH,VV  or LL,RR, or XX,YY or vice-versa
    jv = 0
    do iv = 1,nvisi
      jv = jv+1
      dou(1:nlead,jv) = din(1:nlead,iv)
      kin = nlead
      kou = nlead
      ! 
      do ic=1,nchan
        if (natom.eq.3) then ! Real, Image, Weight
          if (din(kin+3,iv).gt.0) then
            re = din(kin+1,iv) * din(kin+3,iv)
            im = din(kin+2,iv) * din(kin+3,iv)
            we = din(kin+3,iv)
          else
            re = 0
            im = 0
            we = 0
          endif
          kin = kin+natom*nchan  ! Skip NCHAN channels
          if (din(kin+3,iv).gt.0) then
            re = re + din(kin+1,iv) * din(kin+3,iv)
            im = im + din(kin+2,iv) * din(kin+3,iv)
            we = we + din(kin+3,iv)
          endif
          if (we.ne.0) then
            dou(kou+1:kou+1,jv) = re/we
            dou(kou+2:kou+2,jv) = im/we
            dou(kou+3:kou+3,jv) = we
          else
            dou(kou+1:kou+3,jv) = 0
          endif
          !
        else if (natom.eq.2) then
          ! Only Real Weight
          if (din(kin+2,iv).gt.0) then
            re = din(kin+1,iv) * din(kin+2,iv)
            we = din(kin+2,iv)
          else
            re = 0
            we = 0
          endif
          kin = kin+natom*nchan
          if (din(kin+2,iv).gt.0) then
            re = re + din(kin+1,iv) * din(kin+2,iv)
            we = we + din(kin+2,iv)
          endif
          if (we.ne.0) then
            dou(kou+1:kou+1,jv) = re/we
            dou(kou+2:kou+2,jv) = we
          else
            dou(kou+1:kou+2,jv) = 0
          endif
        endif
        ! Skip the HV and VH or LR and RL values
        kin = kin - natom*nchan
        !
        ! Increment by 1 channel
        kou = kou + natom
        kin = kin + natom
      enddo
      !
      ! Fill trailing columns
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
           din(nlead+1+nstok*natom*nchan:iend,iv)
    enddo
  case (code_stokes_i)
    ! Stokes I
    ! Stokes I is strictly Stokes I, i.e.   (HH+VV)/2 or (LL+RR)/2, not
    ! an arbitray weighted combination.
    ! For unpolarized signals, to maximize sensitivity, use Stokes NONE
    do iv=1,nvisi
      jv = jv+1
      dou(1:nlead,jv) = din(1:nlead,iv)
      kin = nlead
      kou = nlead
      !
      do ic=1,nchan
        kk = kin+(cstoke(1)-1)*natom*nchan
        if (din(kk+natom,iv).gt.0)  then
          dou(kou+1:kou+natom-1,jv) = din(kk+1:kk+natom-1,iv)  ! Visib
          da = 1.0/din(kk+natom,iv) ! Noise**2
          ip = 1
        else
          da = 0.0
          ip = 0
        endif
        kk = kin+(cstoke(2)-1)*natom*nchan
        if (din(kk+natom,iv).gt.0)  then
          dou(kou+1:kou+natom-1,jv) = dou(kou+1:kou+natom-1,jv) + &
            din(kk+1:kk+natom-1,iv)
          db = 1.0/din(kk+natom,iv)  ! Noise**2
          ip = ip+1
        else
          db = 0.0
        endif
        if (ip.eq.2) then
          dou(kou+1:kou+natom-1,jv) = dou(kou+1:kou+natom-1,jv) / ip
          dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
        else
          dou(kou+natom,jv) = 0.0
        endif
        ! Next channel
        kou = kou + natom
        kin = kin + natom
      enddo
      !
      ! Fill trailing columns
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
           din(nlead+1+nstok*natom*nchan:iend,iv)
    enddo
    !
  case (code_stokes_V)
    ! Stokes V is -j(VH-HV)/2 or -j(XY-YX)/2 or (RR-LL)/2
    !
    ! Natom must be 3 in this case (we need complex numbers)
    if ((cstoke(5).eq.code_polar_linear).or.(cstoke(5).eq.code_polar_horizon)) then
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        do ic=1,nchan
          kk = kin+(cstoke(3)-1)*natom*nchan
          if (din(kk+natom,iv).gt.0)  then
            VH(1:2) = din(kk+1:kk+natom-1,iv)  
            da = 1.0/din(kk+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kk = kin+(cstoke(4)-1)*natom*nchan
          if (din(kk+natom,iv).gt.0)  then
            HV(1:2) = din(kk+1:kk+natom-1,iv)
            db = 1.0/din(kk+natom,iv)  ! Noise**2
            ip = ip+1
          else
            db = 0.0
          endif
          if (ip.eq.2) then
            dou(kou+1:kou+1,jv) = +(vh(2)-hv(2))/2          
            dou(kou+2:kou+2,jv) = -(vh(1)-hv(1))/2
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          ! Next channel
          kou = kou + natom
          kin = kin + natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    else if (cstoke(5).eq.code_polar_circular) then
      !
      ! (RR - LL ) /2
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        do ic=1,nchan
          kk = kin+(cstoke(1)-1)*natom*nchan
          if (din(kk+natom,iv).gt.0)  then
            RR(1:2) = din(kk+1:kk+natom-1,iv)  
            da = 1.0/din(kk+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kk = kin+(cstoke(2)-1)*natom*nchan
          if (din(kk+natom,iv).gt.0)  then
            LL(1:2) = din(kk+1:kk+natom-1,iv)
            db = 1.0/din(kk+natom,iv)  ! Noise**2
            ip = ip+1
          else
            db = 0.0
          endif
          if (ip.eq.2) then
            dou(kou+1:kou+2,jv) = (rr-ll)/2
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
    else
      write(msg,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported'
      call map_message(seve%e,rname,msg)
      error = .true.
      return
    endif    
    !  
  case (code_stokes_Q,code_stokes_U)
    ! Stokes Q and U are more complex
    !
    ! From HH,VV etc..., they require the parallactic angle 
    ! From XX,YY etc..., they do not
    !
    ! Natom must be 3 in this case (we need complex numbers)
    if (cstoke(5).eq.code_polar_horizon) then
      if (ipara.eq.0) then
        call map_message(seve%e,rname,'No parallactic angle column ')
        error = .true.
        return
      endif
      jsign = isign ! Temporary, normally should be 1
      circular = .false.
    else if (cstoke(5).eq.code_polar_linear) then
      jsign = 0
      circular = .false.
    else if (cstoke(5).eq.code_polar_circular) then
      write(msg,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not fully tested'
      call map_message(seve%w,rname,msg)
      circular = .true.
    else
      write(msg,'(A,4(1X,I0),A)') 'Ordering ',astoke,' not supported '
      call map_message(seve%e,rname,msg)
      error = .true.
      return
    endif    
    !
    if (.not.circular) then
      !
      ! compute aa = (VV-HH)/2   and bb = (VH+HV)/2 then
      !  Q = aa cos(2.phi) - bb sin(2.phi)
      !  U = aa sin(2.phi) + bb cos(2.phi)
      ! or
      ! compute aa = (XX-YY)/2   and bb = (XY+YX)/2 then
      !  Q = aa 
      !  U = bb
      !
      db = 0 ! to avoid initialization warnings.
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        if (istoke.eq.code_stokes_q) then
          if (jsign.ne.0) then
            xa =  cos(2*jsign*din(ipara,iv))
            yb = -sin(2*jsign*din(ipara,iv))
          else
            xa = 1.0
            yb = 0.0
          endif
        else
          if (jsign.ne.0) then
            xa = sin(2*jsign*din(ipara,iv))
            yb = cos(2*jsign*din(ipara,iv))
          else
            xa = 0.0
            yb = 1.0
          endif
        endif
        !
        do ic=1,nchan
          kk = kin+(cstoke(1)-1)*nchan*natom
          if (din(kk+natom,iv).gt.0)  then
            VV(1:2) = din(kk+1:kk+natom-1,iv)  
            da = 1.0/din(kk+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kk = kin+(cstoke(2)-1)*nchan*natom
          if (din(kin+natom,iv).gt.0)  then
            HH(1:2) = din(kk+1:kk+natom-1,iv)
            db = 1.0/din(kk+natom,iv)  ! Noise**2
            ip = ip+1
          endif
          kk = kin+(cstoke(3)-1)*nchan*natom
          if (din(kk+natom,iv).gt.0)  then
            VH(1:2) = din(kk+1:kk+natom-1,iv)
            ip = ip+1
          endif
          kk = kin+(cstoke(4)-1)*nchan*natom
          if (din(kk+natom,iv).gt.0)  then
            HV(1:2) = din(kk+1:kk+natom-1,iv)
            ip = ip+1
          endif
          !
          aa = (VV-HH)/2
          bb = (HV+VH)/2
          !
          if (ip.eq.4) then
            dou(kou+1:kou+2,jv) = xa*aa + yb*bb
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    else if (circular) then
      !
      db = 0   ! Avoid initialization warning
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        do ic=1,nchan
          if (din(kin+natom,iv).gt.0)  then
            RR(1:2) = din(kin+1:kin+natom-1,iv)  
            da = 1.0/din(kin+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kin = kin+natom*nchan
          if (din(kin+natom,iv).gt.0)  then
            LL(1:2) = din(kin+1:kin+natom-1,iv)
            db = 1.0/din(kin+natom,iv)  ! Noise**2
            ip = ip+1
          endif
          kin = kin+natom*nchan
          if (din(kin+natom,iv).gt.0)  then
            RL(1:2) = din(kin+1:kin+natom-1,iv)
            ip = ip+1
          endif
          kin = kin+natom*nchan
          if (din(kin+natom,iv).gt.0)  then
            LR(1:2) = din(kin+1:kin+natom-1,iv)
            ip = ip+1
          endif
          !
          if (istoke.eq.code_stokes_q) then
            !  Q = (RL + LR)/2 
            bb = (RL+LR)/2
          else if (istoke.eq.code_stokes_u) then              
            !  U = -i (RL - LR)/2 
            aa = (RL-LR)/2
            bb(2) = -aa(1)
            bb(1) =  aa(2)
          endif
          !
          if (ip.eq.4) then
            dou(kou+1:kou+2,jv) = bb !! 
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    endif
    !  
  case (code_stokes_all)
    ! Stokes ALL : explodes the Stokes / Channel visibilities
    ! into one visibility per Stokes. Add the Stokes column at
    ! end of each Visibility.  
    do iv=1,nvisi
      do is=1,nstok
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead+(is-1)*nchan
        kou = nlead
        dou(kou+1:kou*natom*nchan,jv) = din(kin+1:kin+natom*nchan,iv)
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
        dou(oend+1,jv) = astoke(is)
      enddo
    enddo
  case default
    call map_message(seve%i,rname,'Case '//gdf_stokes_name(istoke)//' not supported in this context')
    error = .true.
  end select
  !
  ! Sanity check
  if (jv.ne.multi*nvisi) then
    write(msg,'(A,I0,A,I0)') 'Expecting up to ',nvisi,' visibilities, found ',jv
    call map_message(seve%e,rname,msg)
  endif
end subroutine stokes_derive_chan
!
subroutine sub_splitpolar_mem(mystoke,huv,error)
  use image_def
  use clean_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => sub_splitpolar_mem
  !
  ! @ private
  !
  character(len=*), intent(in) :: mystoke  ! Desired Stoke parameter
  type (gildas), intent(inout) :: huv
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='STOKES'
  type (gildas) :: hin
  type (gildas) :: hou
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real(kind=4), pointer  :: din(:,:), dou(:,:)
  !
  character(len=message_length) :: mess
  !
  integer i, j, k, istoke, ivisi, is, iv, jv, ier, ipara
  integer :: astoke(4)  ! Data Polarization code values.
  integer nstok, natom, nlead, nchan, next
  logical extract, doit
  integer intrail, ontrail, iend, oend
  integer :: kv, nblock, nvisi, multi
  integer :: isign=1    ! This is the correct sign for Parallactic Angle
  integer :: iextract 
  integer :: nu ! 
  integer :: ostoke(5)  ! Pointers to desired Polar order, and initial Polar type
  !
  error = .false.
  !
  extract = .false.
  !
  ! Scan the requested polarization code
  if (mystoke.eq.'NONE') then
    istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
    istoke = code_stokes_all
  else
    call gdf_stokes_code(mystoke,istoke,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
      error = .true.
      return
    endif
  endif
  !
  ! We do not use Buffers here - Need to play safe to force re-reading
  ! even if in fact the processing is not done...
  save_data(code_save_uv) = .true.
  optimize(code_save_uv)%change = optimize(code_save_uv)%change+100
  !
  ! Read Header of a sorted, UV table
  call gildas_null(hin,type='UVT')
  call gdf_copy_header(huv,hin,error)
  !
  ipara = hin%gil%column_pointer(code_uvt_para)
  ! Test for debug
  call sic_get_inte('SIGN_PARA',isign,error)
  if (isign.ne.1) Print *,'Using ISIGN ',ISIGN
  !
  !
  call gildas_null(hou, type='UVT')
  call gdf_copy_header (hin, hou, error)
  !
  ! Define the Output Stokes parameter value
  hou%gil%nstokes = 1
  hou%gil%order = istoke           ! Unless it is "ANY" - will be changed later
  !
  call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
  nblock = min(nblock,hin%gil%dim(2))
  !
  ! Check Random Frequency / Stokes axis
  if (hin%gil%nfreq.ne.0) then
    !
    call map_message(seve%i,rname,'Random Frequency Axis case ')
    !
    nstok = 1
    astoke(1) = hin%gil%stokes(1)
    do i=2,hin%gil%nfreq
      k = 0
      do j=1,nstok
        if (astoke(j).eq.hin%gil%stokes(i)) then
          k = j
          exit
        endif
      enddo
      if (k.eq.0) then
        nstok = nstok+1
        astoke(nstok) = hin%gil%stokes(i)
      endif
    enddo
    if (nstok.ne.1 .and. istoke.eq.code_stokes_all) then
      call map_message(seve%e,rname,'Code ALL is not supported in this context')
      error = .true.
      return
    endif
    call polar_order(nstok,astoke,ostoke,error)
    if (error) return
    !
    natom = hin%gil%natom
    nchan = hin%gil%nchan
    nlead = hin%gil%nlead
    intrail = hin%gil%ntrail
    ontrail = intrail
    iend = hin%gil%dim(1)
    !
    if (nstok.eq.1) then
      doit = .false.
      if (istoke.eq.astoke(1) .or. istoke.eq.0) then
        ! Matching Polarization state
        doit = .true.
      else if (istoke.eq.code_stokes_none .or. istoke.eq.code_stokes_all) then
        ! Approximate matching. Strictly speaking, it does not apply to Stokes I
        if ( (astoke(1).eq.code_stokes_hh) .or. (astoke(1).eq.code_stokes_vv) ) doit = .true.
        if ( (astoke(1).eq.code_stokes_ll) .or. (astoke(1).eq.code_stokes_rr) ) doit = .true.
        if ( (astoke(1).eq.code_stokes_xx) .or. (astoke(1).eq.code_stokes_yy) ) doit = .true.
        if ( (astoke(1).eq.code_stokes_i) ) doit = .true.
      endif
      !
      if (doit) then
        hou%gil%stokes(:) = istoke  ! Change the Stokes information
      else
        call map_message(seve%i,rname,'Polar '//mystoke// &
        ' does not match '//gdf_stokes_name(astoke(1)) )
        error = .true.
      endif
      !
      return
    else if (nstok.ge.2) then
      !
      iextract = 0
      ! Check first for simple Extraction
      doit = .false.
      do i=1,nstok
        if (istoke.eq.astoke(i)) then
          iextract = 1
          doit = .true.
          exit
        endif
      enddo
      !
      ! Then check for derivation
      if (iextract.eq.0) then
        call polar_order(nstok,astoke,ostoke,error)
        if (error) then
          call map_message(seve%i,rname,'Unsupported conversion from Stokes '//gdf_stokes_name(astoke(1))// &
            &' '//gdf_stokes_name(astoke(2))//' to Stokes '//gdf_stokes_name(istoke) )
          return
        endif
        iextract = -1
        if (nstok.eq.2) then
          if (istoke.ge.code_stokes_i .or. istoke.eq.code_stokes_none &
            .or. istoke.eq.code_stokes_all) then
            iextract = 0
            doit = .true.
          endif
        else if (nstok.eq.4) then
          doit = .true. !!! TEST
          iextract = 0
        endif
        if (iextract.ne.0) then
          call map_message(seve%e,rname,'Cannot Extract Stokes '//gdf_stokes_name(istoke)//' from data file')
          error = .true.
          return
        endif
      else
        if (istoke.lt.0) then
          call map_message(seve%i,rname,'Extracting Polarization state '//gdf_stokes_name(istoke) )
        else
          call map_message(seve%i,rname,'Deriving Stokes parameter '//gdf_stokes_name(istoke) )
        endif
      endif
      !
      ! Re-allocate the Frequencies and Stokes axes
      hou%gil%nfreq = hin%gil%nfreq / nstok
      deallocate(hou%gil%stokes,hou%gil%freqs)
      allocate(hou%gil%stokes(hou%gil%nfreq),hou%gil%freqs(hou%gil%nfreq),stat=ier)
      hou%gil%stokes(:) = istoke
      hou%gil%nstokes = 1
      k = max(iextract,1)
      do i=1,hou%gil%nfreq
        hou%gil%freqs(i) = hin%gil%freqs(k)
        k = k+nstok
      enddo
      !
      ! Shift the trailing columns
      do i=1,code_uvt_last
        if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
          hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
            & hin%gil%natom * hin%gil%nchan
        endif
      enddo
      !
      ! Then, do the job
      hou%gil%dim(2) = hou%gil%nvisi
      hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom &
                     + ontrail-intrail
      oend = hou%gil%dim(1)+intrail-ontrail
      !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
      !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
      !!Print *,'OEND ',oend, intrail, ontrail
      !
      ! Allocate the buffers
      nu = hou%gil%dim(1)
      kv = hou%gil%dim(2)
      call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
      if (error) return
      !
      hin%blc = 0
      hin%trc = 0
      hou%blc = 0
      hou%trc = 0
      !
!TEST!      call gdf_print_header(hou)
!TEST!      read(5,*) iextract
      !
      nvisi = hin%gil%nvisi
      call stokes_derive_stok (duv_previous,duv_next,nvisi,nlead,natom,nchan,nstok, &
      & intrail,istoke,astoke,ipara,isign,error, ostoke)
      if (error) return
      !
      call uv_clean_buffers(duv_previous,duv_next,error)
      call gdf_copy_header(hou,huv,error)
      return
    endif
    !
    ! Failure Cases... No longer accessible
    call map_message(seve%e,rname,'Cannot yet handle Random Stokes / Frequency values')
    error = .true.
    return
  endif
  !
  ! From now on, this is the simple case with Stokes separate from Frequency
  !
  ! Check it has more than 1 polarization per visibility
  if (hin%gil%nstokes.eq.1) then
    call map_message(seve%i,rname,'Already only 1 polar per visibility ')
    !
    ! Here need to check if a Polar column is present, through the
    ! extra columns (code_uvt_stok)
    is = hin%gil%column_pointer(code_uvt_stok)
    if (is.eq.0) then
      ! Just the same polarization for all visibilities
      call map_message(seve%i,rname,'Already only 1 polar in total')
      nstok = 1
      astoke(nstok) = hin%gil%order
      if (istoke.eq.astoke(1) .or. istoke.eq.0) then
        !
        ! OK this is the right polarization (or a sufficient approximation...)
      else
        call map_message(seve%i,rname,'Polar '//mystoke// &
        ' does not match '//gdf_stokes_name(astoke(1)) )
        error = .true.
      endif
      !
      return
    else
      !
      ! A polarization Column is present, check if it contains different values
      call map_message(seve%i,rname,'Perhaps more than 1 polar, scanning...')
      nu = hou%gil%dim(1)
      kv = hou%gil%dim(2)
      call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
      !
      hin%blc = 0
      hin%trc = 0
      hou%blc = 0
      hou%trc = 0
      jv = 0
      nstok = 0
      jv = 0
      do iv = 1,kv
        if (duv_previous(is,iv).ne.istoke) cycle
        jv = jv+1
        duv_next(:,jv) = duv_previous(:,iv)
      enddo
      if (jv.eq.0) then
        call map_message(seve%i,rname,'No such polarization state in data')
        error = .true.
        return
      endif
      !
      ! Finalize
      hou%gil%nvisi = jv
      hou%gil%dim(2) = jv
    endif
    !
  else
    !
    ! This means each Visi has Nstokes x Nchan or Nchan x Nstokes elements
    !
    if (hin%gil%order.eq.code_chan_stok) then
      ! Nchan X Nstokes channels
      !
      call map_message(seve%i,rname,'Input order: Nchan channels X Nstokes stokes')
    else if (hin%gil%order.eq.code_stok_chan) then
      call map_message(seve%i,rname,'Input order: Nstokes stokes X  Nchan channels')
      ! Nstokes x Nchan channels
    else
      call map_message(seve%e,rname,'Inconsistent UV table state for polarization')
      error = .true.
      return
    endif
    nstok = hin%gil%nstokes
    mess = 'Input Stokes: '
    next = 20
    do i=1,nstok
      mess(next:) = gdf_stokes_name(hin%gil%stokes(i))
      next = len_trim(mess)+3
    enddo
    call map_message(seve%i,rname,mess)
    call map_message(seve%i,rname,'Output Stokes:     '//gdf_stokes_name(istoke))
    !
    !!print *,'DIN ',(din(1:10,i),i=1,10)
    !
    astoke(1:nstok) = hin%gil%stokes(1:nstok)
    natom = hin%gil%natom
    nchan = hin%gil%nchan
    nlead = hin%gil%nlead
    intrail = hin%gil%ntrail
    ontrail = intrail
    iend = hin%gil%dim(1)
    !
    ! The useful cases are
    if (nstok.eq.2) then
      if (istoke.ge.code_stokes_i .or. istoke.eq.code_stokes_none &
        .or. istoke.eq.code_stokes_all) then
        ! Input: 2 Stokes, HH+VV or XX+YY or RR+LL, Output: I, NONE or ALL
        ! keep everything, make proper weighting
        call polar_order(nstok,astoke,ostoke,error)
        if (error) then
          call map_message(seve%i,rname,'Unsupported conversion from Stokes '//gdf_stokes_name(astoke(1))// &
            &' '//gdf_stokes_name(astoke(2))//' to Stokes '//gdf_stokes_name(istoke) )
          return
        endif
        !
        if (istoke.eq.code_stokes_all) then
          hou%gil%nvisi = 2*hin%gil%nvisi
          multi = 2
          ontrail = ontrail+1
        else
          multi = 1
          hou%gil%nvisi = hin%gil%nvisi
        endif
        call map_message(seve%i,rname,'Deriving '//mystoke// &
        ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & hin%gil%natom * hin%gil%nchan
          endif
        enddo
        !
        hou%gil%dim(2) = hou%gil%nvisi
        hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom &
                       + ontrail-intrail
        oend = hou%gil%dim(1)+intrail-ontrail
        !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
        !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
        !!Print *,'OEND ',oend, intrail, ontrail
        if (istoke.eq.code_stokes_all) then
          hou%gil%column_pointer(code_uvt_stok) = hou%gil%dim(1)
        endif
        !
        nu = hou%gil%dim(1)
        kv = hou%gil%dim(2)
        call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
        dou => duv_next
        din => duv_previous
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        !
        nvisi = hin%gil%nvisi
        if (hin%gil%order.eq.code_chan_stok) then
          ! Nchan X Nstokes channels  (ALL)
          !
          if (istoke.eq.code_stokes_all) then
            !
            jv = 0
            do iv = 1,nvisi
              jv = jv+1
              dou(1:nlead,jv) = din(1:nlead,iv)
              dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1:nlead+natom*nchan,iv)
              if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(1)
              if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                   din(nlead+1+2*natom*nchan:iend,iv)
              !
              jv = jv+1
              dou(1:nlead,jv) = din(1:nlead,iv)
              dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1+natom*nchan:nlead+2*natom*nchan,iv)
              if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(2)
              if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                   din(nlead+1+2*natom*nchan:iend,iv)
            enddo
            !
            hou%gil%nvisi = jv
            hou%gil%dim(2) = jv
          else
            call map_message(seve%e,rname, &
            & 'Nchan X Nstokes channel order only supported for code ALL')
            error = .true.
            return
          endif
        else
          !
          ! Nstokes x Nchan channels
          call stokes_derive_stok(din,dou,nvisi,nlead,natom,nchan,nstok, &
          & intrail,istoke,astoke,ipara,isign,error, ostoke)
          if (error) return
        endif
      else
        ! Input: 2 Stokes, HH+VV, XX+YY or RR+LL, Output: one among these.
        ! keep only that one...
        if (istoke.eq.astoke(1)) then
          ivisi = 1
        else if (istoke.eq.astoke(2)) then
          ivisi = 2
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)),3)
          error = .true.
          return
        endif
        call map_message(seve%e,rname,'Extracting '//mystoke// &
          ' from '//gdf_stokes_name(astoke(1))//' and '//gdf_stokes_name(astoke(2)))
        !
        hou%gil%dim(1) = hin%gil%dim(1)-hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
      !
    else if (nstok.eq.4) then
      !
      ! 4 Stokes, extract one of them, or derive the desired one from others
      ivisi = 0
      do i=1,nstok
        if (istoke.eq.astoke(i)) then
          ivisi = i
          exit
        endif
      enddo
      !
      if (ivisi.eq.0) then
        ! Cannot be extracted, must be Derived
        if ( (istoke.eq.code_stokes_none) .or. & 
          & ((istoke.ge.code_stokes_i).and.(istoke.le.code_stokes_v)) )  then
          !
          ! Is derivation possible ?
          call polar_order(nstok,astoke,ostoke,error)
          if (error) then
            call map_message(seve%i,rname,'Unsupported conversion from Stokes '//gdf_stokes_name(astoke(1))// &
              &' '//gdf_stokes_name(astoke(2))//' to Stokes '//gdf_stokes_name(istoke) )
            return
          endif
          !
          multi = 1   ! 1 output visibility per input Visibility      
          ! Shift the trailing columns
          do i=1,code_uvt_last
            if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
              hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
                & 3 * hin%gil%natom * hin%gil%nchan
            endif
          enddo
          !
          ! Figure out which case is to be compressed
          hou%gil%dim(2) = hou%gil%nvisi
          hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom &
                &        + ontrail-intrail
          oend = hou%gil%dim(1)+intrail-ontrail
          !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
          !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
          !!Print *,'OEND ',oend, intrail, ontrail
          !
          nu = hou%gil%dim(1)
          kv = hou%gil%dim(2)
          call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
          dou => duv_next
          din => duv_previous
          !
          hin%blc = 0
          hin%trc = 0
          hou%blc = 0
          hou%trc = 0
          nvisi = hin%gil%nvisi 
          !
          ! Nstokes x Nchan channels
          if (hin%gil%order.eq.code_chan_stok) then
            call stokes_derive_chan(din,dou,nvisi,nlead,natom,nchan,nstok, &
              & intrail,istoke,astoke,ipara,isign,error, ostoke)            
          else
          !
            call stokes_derive_stok(din,dou,nvisi,nlead,natom,nchan,nstok, &
              & intrail,istoke,astoke,ipara,isign,error, ostoke)
          endif
          if (error) return
          !
        else
          ! No conversion between different polarization basis
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
            & ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))// &
            & gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)) )
          error = .true.
          return
        endif
      else
        ! Extraction among those already present
        call map_message(seve%i,rname,'Extracting '//mystoke// &
            & ' from '//gdf_stokes_name(astoke(1))//gdf_stokes_name(astoke(2))// &
            & gdf_stokes_name(astoke(3))//' and '//gdf_stokes_name(astoke(4)) )
        !
        hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & 3 * hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
    endif
    !
    ! The extraction code makes no assumption about the Stokes order at all.
    if (extract) then
      !
      nu = hou%gil%dim(1)
      kv = hou%gil%dim(2)
      call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
      dou => duv_next
      din => duv_previous
      !
      hin%blc = 0
      hou%trc = 0
      !
      call stokes_extract(hin%gil%order,din,dou,kv,nlead,natom,nchan,nstok,intrail,ivisi)
    endif
  endif
  !
  ! Finalize
  call uv_clean_buffers(duv_previous,duv_next,error)
  call gdf_copy_header(hou,huv,error)  
  !
end subroutine sub_splitpolar_mem
!
subroutine polar_order(nstok,astoke,cstoke,error)
  use image_def
  use code_polar_gildas
  use gbl_message
  use imager_interfaces, only : findloc
  !---------------------------------------------------------------------------------------------
  ! IMAGER
  !   Return the ordering of the Polarization / Stokes states described by array ASTOK
  !
  !   Supported Cases are 
  !   Nstoke = 2    the two parallel hand polarization, any order
  !   Nstoke = 4    all four cross-polarization, any order
  !---------------------------------------------------------------------------------------------
  integer, intent(in) :: nstok
  integer, intent(in) :: astoke(nstok)
  integer, intent(out) :: cstoke(5)
  logical, intent(out) :: error
  !
  integer :: pmin, pmax
  !
  pmin = -maxval(astoke)
  pmax = -minval(astoke)
  !
  error = .false.
  if (pmax-pmin.ne.nstok-1) then      ! Must have Nstok values
    error = .true.
  else if (mod(pmin,4).ne.1) then     ! Must start with XX,VV or RR
    error = .true.
  endif
  if (error) then
    call map_message(seve%e,'STOKES','Inconsistent polarization data codes')
    return
  endif
  !
  pmin = -pmin
  cstoke = 0
  if (pmin.eq.code_stokes_rr) then
    ! R,L case
    cstoke(1) = findloc(astoke,code_stokes_rr,1)
    cstoke(2) = findloc(astoke,code_stokes_ll,1)
    cstoke(3) = findloc(astoke,code_stokes_rl,1)
    cstoke(4) = findloc(astoke,code_stokes_lr,1)
    cstoke(5) = code_polar_circular
  else if (pmin.eq.code_stokes_xx) then
    ! X,Y case
    cstoke(1) = findloc(astoke,code_stokes_xx,1)
    cstoke(2) = findloc(astoke,code_stokes_yy,1)
    cstoke(3) = findloc(astoke,code_stokes_xy,1)
    cstoke(4) = findloc(astoke,code_stokes_yx,1)
    cstoke(5) = code_polar_linear
  else if (pmin.eq.code_stokes_hh) then
    ! H,V case - HH is first here in the Code list, not VV
    cstoke(1) = findloc(astoke,code_stokes_vv,1)
    cstoke(2) = findloc(astoke,code_stokes_hh,1)
    cstoke(3) = findloc(astoke,code_stokes_vh,1)
    cstoke(4) = findloc(astoke,code_stokes_hv,1)
    cstoke(5) = code_polar_horizon
  else
    error = .true.
    call map_message(seve%e,'POLAR_CODE','Unsupported polarization data codes')
    Print *,'ASTOKE ',astoke
  endif
end subroutine polar_order
!
function findloc(array,value,dim)
  ! @ private-mandatory
  integer :: findloc
  integer, intent(in) :: array(:)
  integer, intent(in) :: value
  integer, intent(in) :: dim
  !
  integer :: i,n,k
  !
  n = size(array)
  k = 0
  do i=1,n
    if (array(i).eq.value) then
      k = i
      exit
    endif
  enddo
  findloc = k
end function findloc

module cubedag_history
  use cubetools_list
  use cubedag_parameters
  use cubedag_messaging
  use cubedag_node_type
  use cubedag_link_type
  use cubedag_history_types
  !---------------------------------------------------------------------
  ! Support module for the history buffer, and subroutines to interact
  ! with it
  !---------------------------------------------------------------------

  type(history_optimize_t), target :: hx  ! History index

  public :: hx
  public :: cubedag_history_add_tohx
  public :: cubedag_history_add_fromhx
  public :: cubedag_history_entrynum
  public :: cubedag_history_list_hx
  public :: cubedag_history_tostr
  public :: cubedag_history_removenode,cubedag_history_removecommand
  public :: cubedag_history_destroy
  private

contains

  subroutine cubedag_history_add_tohx(command,line,inputs,outputs,hid,error)
    !-------------------------------------------------------------------
    ! Add a new command in the HISTORY index. Return the associated
    ! history identifier.
    !-------------------------------------------------------------------
    character(len=*),     intent(in)    :: command
    character(len=*),     intent(in)    :: line
    type(cubedag_link_t), intent(in)    :: inputs
    type(cubedag_link_t), intent(in)    :: outputs
    integer(kind=entr_k), intent(out)   :: hid
    logical,              intent(inout) :: error
    !
    if (outputs%n.le.0) then
      ! The commands which do not create an output cube are not
      ! registered in history
      hid = 0
      return
    endif
    !
    call hx%add(command,line,inputs,outputs,error)
    if (error)  return
    hid = hx%id(hx%next-1)
  end subroutine cubedag_history_add_tohx

  subroutine cubedag_history_add_fromhx(hoptx,hid,error)
    !-------------------------------------------------------------------
    ! Add a command in the given index, duplicating one command from
    ! the main history index
    !-------------------------------------------------------------------
    class(history_optimize_t), intent(inout) :: hoptx
    integer(kind=iden_l),      intent(in)    :: hid
    logical,                   intent(inout) :: error
    ! Local
    integer(kind=entr_k) :: ihist
    !
    ihist = cubedag_history_entrynum(hid,error)
    if (error)  return
    !
    call hoptx%add(  &
      hx%command(ihist),  &
      hx%line(ihist),  &
      hx%inputs(ihist),  &
      hx%outputs(ihist),  &
      error)
    if (error)  return
    !
    ! Beware the ID must be kept from the original index
    hoptx%id(hoptx%next-1) = hx%id(ihist)
  end subroutine cubedag_history_add_fromhx

  subroutine cubedag_history_list_hx(error)
    !-------------------------------------------------------------------
    ! List the history index
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call hx%list(error)
    if (error)  return
  end subroutine cubedag_history_list_hx

  function cubedag_history_entrynum(id,error)
    !-------------------------------------------------------------------
    ! Resolve the entry number corresponding to the given ID.
    ! - If ID>0, the entry is resolved by searching in all the history
    ! index. This resolution is based on two strong assumptions:
    !  1) the identifier is UNIQUE,
    !  2) the identifier list is SORTED
    ! - If ID<=0, the ID is assumed to be a position from the end
    ! (0=last, same as CubeID).
    !-------------------------------------------------------------------
    integer(kind=entr_k) :: cubedag_history_entrynum
    integer(kind=iden_l), intent(in)    :: id
    logical,              intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='HISTORY>ENTRYNUM'
    integer(kind=entr_k) :: inf,mid,sup
    character(len=mess_l) :: mess
    !
    if (id.le.0) then
      ! Search by position from the end
      if (-id.gt.hx%next-2) then
        write(mess,'(A,I0,A)')  'No such identifier ',id,' in command history index'
        call cubedag_message(seve%e,rname,mess)
        cubedag_history_entrynum = 0
        error = .true.
        return
      endif
      cubedag_history_entrynum = hx%next-1+id
      return
    endif
    !
    ! Dichotomic search
    if (hx%id(1).eq.id) then
      cubedag_history_entrynum = 1
      return
    endif
    !
    inf = 1
    sup = hx%next-1
    do while (sup.gt.inf+1)
      mid = (inf+sup)/2  ! Integer division
      if (hx%id(mid).lt.id) then
        inf = mid
      else
        sup = mid
      endif
    enddo
    !
    if (hx%id(sup).eq.id) then
      cubedag_history_entrynum = sup
    else
      write(mess,'(A,I0,A)')  'No such identifier ',id,' in command history index'
      call cubedag_message(seve%e,rname,mess)
      cubedag_history_entrynum = 0
      error = .true.
      return
    endif
    !
  end function cubedag_history_entrynum

  subroutine cubedag_history_tostr(hid,str,error)
    !-------------------------------------------------------------------
    ! Translate the history identifier to the form "ID (NAME)" (e.g.
    ! "12 (NOISE)"
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: hid
    character(len=*),     intent(out)   :: str
    logical,              intent(inout) :: error
    ! Local
    integer(kind=4) :: ni,nc
    integer(kind=entr_k) :: ient
    !
    if (hid.eq.code_history_notyetdefined) then
      str = '-- (NOT-YET-DEFINED)'
      return
    endif
    !
    ient = cubedag_history_entrynum(hid,error)
    if (error)  return
    !
    write(str,'(I0)') hid
    if (ient.le.0) then
      ! Valid: root has no history
      return
    elseif (ient.lt.hx%next) then
      ni = len_trim(str)
      nc = min(len_trim(hx%command(ient)),len(str)-ni-3)
      write(str(ni+1:),'(3A)')  ' (',hx%command(ient)(1:nc),')'
    else
      ni = len_trim(str)
      nc = min(7,len(str)-ni-3)
      write(str(ni+1:),'(3A)')  ' (','UNKNOWN',')'
    endif
    !
  end subroutine cubedag_history_tostr

  subroutine cubedag_history_removenode(id,error)
    use cubedag_dag
    !-------------------------------------------------------------------
    ! Properly remove a DAG node from the history.
    ! This might leave some commands without inputs or without outputs
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: id  ! Node identifier
    logical,              intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: object
    class(tools_object_t), pointer :: tot
    integer(kind=entr_k) :: ihist
    !
    call cubedag_dag_get_object(id,object,error)
    if (error)  return
    ihist = object%node%history
    tot => object
    !
    ! Remove from command which created it
    call hx%outputs(ihist)%unlink(tot,error)
    if (error)  return
    !
    ! Remove from commands which used it as input. As of today, there
    ! is no backpointer to these commands (is this really desired?).
    ! Loop inefficiently on all commands:
    do ihist=1,hx%next-1
      call hx%inputs(ihist)%unlink(tot,error)
      if (error)  return
    enddo
    !
  end subroutine cubedag_history_removenode

  subroutine cubedag_history_removecommand(hid,error)
    use cubedag_dag
    !-------------------------------------------------------------------
    ! Properly a command from the history.
    ! This might leave other commands without inputs and/or without
    ! outputs
    !-------------------------------------------------------------------
    integer(kind=iden_l), intent(in)    :: hid  ! History identifier
    logical,              intent(inout) :: error
    ! Local
    class(cubedag_node_object_t), pointer :: object
    class(tools_object_t), pointer :: tot
    integer(kind=entr_k) :: ihist,inode,jhist
    integer(kind=iden_l) :: nodeid
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='HISTORY>REMOVECOMMAND'
    !
    ihist = cubedag_history_entrynum(hid,error)
    if (error)  return
    write(mess,'(a,i0,3a)')  'Undo command #',ihist,' (',trim(hx%command(ihist)),')'
    call cubedag_message(seve%i,rname,mess)
    !
    do inode=1,hx%outputs(ihist)%n
      object => cubedag_node_ptr(hx%outputs(ihist)%list(inode)%p,error)
      if (error)  return
      nodeid = object%node%id
      call cubedag_dag_get_object(nodeid,object,error)
      if (error)  return
      tot => object
      !
      ! Remove from commands which used it as input. As of today, there
      ! is no backpointer to these commands (is this really desired?).
      ! Loop inefficiently on all commands:
      do jhist=1,hx%next-1
        call hx%inputs(jhist)%unlink(tot,error)
        if (error)  return
      enddo
      !
      ! Actually remove the node from DAG
      call cubedag_dag_removenode(nodeid,error)
      if (error)  return
    enddo
    !
    ! Now remove the command from history index
    call cubedag_history_removecommand_from(hx,ihist,error)
    if (error)  return
    !
  end subroutine cubedag_history_removecommand

  subroutine cubedag_history_removecommand_from(optx,ihist,error)
    !-------------------------------------------------------------------
    ! Properly remove a command from the history index
    !-------------------------------------------------------------------
    type(history_optimize_t), intent(inout) :: optx
    integer(kind=entr_k),     intent(in)    :: ihist
    logical,                  intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='HISTORY>REMOVE>COMMAND'
    integer(kind=entr_k) :: ient
    !
    call hx%inputs(ihist)%final(error)
    if (error)  return
    call hx%outputs(ihist)%final(error)
    if (error)  return
    !
    do ient=ihist+1,optx%next-1
      optx%id(ient-1)      = optx%id(ient)
      optx%command(ient-1) = optx%command(ient)
      optx%line(ient-1)    = optx%line(ient)
      call optx%inputs(ient)%copy(optx%inputs(ient-1),error)
      if (error)  return
      call optx%outputs(ient)%copy(optx%outputs(ient-1),error)
      if (error)  return
    enddo
    optx%next = optx%next-1
    !
  end subroutine cubedag_history_removecommand_from

  subroutine cubedag_history_destroy(error)
    !-------------------------------------------------------------------
    ! Brute-force destroy the whole HISTORY
    ! No care of the backpointer links to the cubes in the DAG
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call cubedag_history_final(hx)
  end subroutine cubedag_history_destroy

  subroutine cubedag_history_final(hoptx)
    !-------------------------------------------------------------------
    ! Finalize the history buffer
    !-------------------------------------------------------------------
    type(history_optimize_t), intent(out) :: hoptx  ! intent(out) invokes FINAL procedure
  end subroutine cubedag_history_final

end module cubedag_history

subroutine uv_reweight_comm(line,comm,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use image_def
  use clean_arrays
  use imager_interfaces, except_this => uv_reweight_comm
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !	  Derive the weights of the UV table from the noise
  !     statistics over many channels
  ! UV_REWEIGHT APPLY Value
  ! UV_REWEIGHT ESTIMATE [Tolerance] [PrintLevel]] [/RANGE Min Max Type] 
  ! UV_REWEIGHT DO [Tolerance] [PrintLevel]] [/RANGE Min Max Type] -
  !     [/FLAG Threshold] [/FILE FileIn FileOut]
  !---------------------------------------------------------------------
  ! Local
  character(len=*), intent(in) :: line
  character(len=*), intent(in) :: comm
  logical :: error
  !
  character(len=*), parameter :: rname='UV_REWEIGHT'
  integer, parameter :: o_file=2
  integer, parameter :: o_flag=1
  integer, parameter :: o_range=3
  integer, parameter :: mranges=10
  integer, parameter :: mmode=4
  character(len=12) :: smode(mmode), argum, mode
  data smode/'APPLY','DO','ESTIMATE','TIME'/
  real, save :: scale=1.0
  !
  type(gildas) :: hiuv, houv
  logical :: flag
  integer :: ishow, irange, n, i, nbad, ier
  integer :: ic, iv
  real, allocatable :: original(:), ratio(:)
  real :: dr, thre, fthre
  integer :: numchan, nc(mranges)
  character(len=256) :: uvchannels, mess
  character(len=24) :: chain
  character(len=12) :: ctype
  character(len=filename_length) :: filein, fileou
  integer :: do_file
  logical :: do_time
  real :: gscale, lscale, diam
  integer(kind=index_length) :: ib, mvisi, nvisi
  !
  ! Code:
  !
  ! Define the mode
  call sic_ke(line,0,1,argum,n,.true.,error)
  if (error) return
  call sic_ambigs (rname,argum,mode,n,smode,mmode,error)
  if (error) return
  !
  do_time = mode.eq.'TIME'
  !
  ! /FILE mode
  if (sic_present(o_file,0)) then
    if (do_time) then
      ! We should be able to do it only if the Output file is specified
      ! In this case, the output file would be Time-Baseline sorted
      ! and there may be memory issues if it uses more than 1/2 of the
      ! available memory - To be seen later
      call map_message(seve%e,rname,'TIME mode not available with /FILE')
      error = .true.
      return
    endif
    do_file = sic_narg(o_file)
    !
    call sic_ch(line,o_file,1,filein,n,.true.,error)
    if (error) return
    call gildas_null(hiuv,type='UVT')
    call sic_parsef (filein,hiuv%file,' ','.uvt')
    call gdf_read_header (hiuv,error)
    if (error) return
    if ((hiuv%gil%nchan.lt.17).and.(mode.ne.'APPLY')) then
      write(mess,'(A,I0,A)') 'UV data has only ',hiuv%gil%nchan, &
        & ' channels, noise estimate impossible'
      call map_message(seve%e,rname,mess,1)
      error = .true.
      return
    endif
    mvisi = space_nitems('SPACE_GILDAS',hiuv,1)
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    call gildas_null(houv,type='UVT')
    call gdf_copy_header(hiuv,houv,error)
    !
    if (do_file.gt.1) then
      do_file = 2
      call sic_ch(line,o_file,2,fileou,n,.true.,error)
      if (error) return
      !
      call sic_parsef (fileou,houv%file,' ','.uvt')
    endif
    !
    if (hiuv%gil%nteles.ne.0) then
      diam = hiuv%gil%teles(1)%diam/4
    else
      diam = 3
      call map_message(seve%w,rname,'No Telescope information, UV tolerance set to 3 m by default')
    endif
  else
    ! No /FILE option
    !
    ! Make sure UV data is present 
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data',1)
      error = .true.
      return
    endif
    !
    if (huv%gil%nteles.ne.0) then
      diam = huv%gil%teles(1)%diam/4
    else
      diam = 3
      call map_message(seve%w,rname,'No Telescope information, UV tolerance set to 3 m by default')
    endif
    !
    if (mode.eq.'DO' .or. mode.eq.'ESTIMATE') then
      ! Verify if enough channels are present
      if (huv%gil%nchan.lt.17) then
        ! Fall back on Baseline-Time sorted data, to use differences
        ! between adjacent visibilities 
        write(mess,'(A,I0,A)') 'UV data has only ',huv%gil%nchan, &
          & ' channels, falling back on TIME mode'
        call map_message(seve%w,rname,mess,3)
        do_time = .true.
      else if (huv%gil%nchan.lt.33) then
        write(mess,'(A,I0,A)') 'UV data has only ',huv%gil%nchan, &
          & ' channels, noise estimate may be inaccurate'
        call map_message(seve%w,rname,mess)        
      endif
    else if (mode.eq.'TIME') then
      do_time = .true.
    endif
    !
    if (do_time) then
      !
      call gildas_null(houv,type='UVT')
      call gdf_copy_header(huv,houv,error)
      allocate(houv%r2d(houv%gil%dim(1),houv%gil%dim(2)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      huv%r2d => duv
      error = .false.
      call uvsort_bt (huv,houv,error)
    endif
    if (error) return
    do_file = 0
  endif
  !
  if (mode.eq.'APPLY') then
    if (sic_present(o_flag,0) .or. sic_present(o_range,0)) then
      call map_message(seve%e,rname,'No option allowed for APPLY action')
      error = .true.
    endif
    call sic_ch(line,0,2,argum,n,.true.,error)
    if (error) return
    if (argum.ne.'*') then
      call sic_r4(line,0,2,scale,.true.,error)
      if (error) return
    endif
    if (scale.le.0) then
      call map_message(seve%e,rname,'Scale factor must be > 0')
      error = .true.
      return
    elseif (scale.eq.1.0) then
      call map_message(seve%w,rname,'Scale factor is 1, nothing to do')
      return
    else
      write(mess,*) "Applying scale factor ",scale
      call map_message(seve%i,rname,mess)
    endif
    !
    if (do_file.eq.0) then
      do iv=1,huv%gil%nvisi
        do ic=1,huv%gil%nchan
          duv(3*ic+huv%gil%fcol-1,iv) = scale * duv(3*ic+huv%gil%fcol-1,iv)
        enddo
      enddo
      do_weig = .true.
    else 
      if (do_file.eq.2) then
        call gdf_create_image(houv,error)
        if (error) return
      endif
      !
      ! Work by block. Read in HIUV, Write in HOUV
      do ib=1,hiuv%gil%dim(2),mvisi
        !
        ! Read the data
        write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
        call map_message(seve%i,rname,mess)
        hiuv%blc(2) = ib
        hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
        nvisi = hiuv%trc(2)-hiuv%blc(2)+1
        call gdf_read_data(hiuv,hiuv%r2d,error)
        if (error) return
        !
        do iv=1,nvisi
          do ic=1,huv%gil%nchan
            hiuv%r2d(3*ic+huv%gil%fcol-1,iv) = scale * hiuv%r2d(3*ic+huv%gil%fcol-1,iv)
          enddo
        enddo
        !
        houv%blc = hiuv%blc
        houv%trc = hiuv%trc
        call gdf_write_data (houv,hiuv%r2d,error)
        if (error) return
      enddo
      call gdf_close_image(hiuv,error)
      if (do_file.eq.2) call gdf_close_image(houv,error)
    endif
  else
    ! DO, ESTIMATE or TIME
    !
    ! Arguments with their default
    thre = 1.21
    call sic_r4(line,0,2,thre,.false.,error)
    if (error) return
    ishow = 0
    call sic_i4(line,0,3,ishow,.false.,error)
    if (error) return
    flag = sic_present(o_flag,0)
    if (flag) then
      if (mode.eq.'ESTIMATE' .or. mode.eq.'TIME') then
        call map_message(seve%e,rname,'/FLAG option not valid for ESTIMATE or TIME actions')
        error = .true.
        return
      else 
        fthre = 3.0
        call sic_r4(line,o_flag,1,fthre,.false.,error)
        if (error) return
        if (fthre.lt.1) then
          call map_message(seve%e,rname,'Invalid Threshold, must be > 1')
          error = .true.
          return
        endif
      endif
    endif
    !
    ! Get the selected channel range
    irange = sic_narg(o_range)
    ctype = 'CHANNEL'
    uvchannels = ' '
    if (irange.gt.1) then
      if (mod(irange,2).eq.1) then
        call sic_ke(line,o_range,irange,ctype,n,.true.,error)
        if (error) return
        irange = irange-1
      endif
      !
      irange = min(irange,mranges)
      !
      if (irange.eq.0) then
        uvchannels = ' '
      else
        do i=1,irange
          call sic_r4(line,o_range,i,dr,.true.,error)
          write(chain,*) dr
          uvchannels(n:) = adjustl(chain)
          n = len_trim(uvchannels)+2
        enddo
      endif
      numchan = irange/2
    else
      numchan = 0
    endif
    !
    ! Dispatch according to mode
    if (do_file.eq.0) then
      ! In MEMORY mode
      call get_uvranges(rname,uvchannels,ctype,mranges,numchan,nc,huv,error)
      if (error) return
      !
      allocate(original(huv%gil%nvisi),ratio(huv%gil%nvisi),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      !
      if (do_time) then
        ! Compute noise from differences between adjacent Visibilities
        call uv_time_reweight(houv,houv%r2d,huv%gil%nvisi,numchan,nc,diam,thre, &
          & original,ratio,scale, error)
      else
        ! Compute noise from statistics on channels
        call uv_get_reweight(huv,duv,huv%gil%nvisi,numchan,nc,ishow,thre, &
          & original,ratio,scale, error)
      endif
      !
      if (mode.eq.'DO') then
        nbad = 0
        write(mess,*) "Applying Median re-scale factor ",scale
        call map_message(seve%i,rname,mess)
        call uv_do_reweight(huv, duv, huv%gil%nvisi, flag, nbad, original, &
          & ratio, scale, fthre)
        do_weig = .true.
        if (nbad.gt.0) then
          write(mess,'(I0,A,I0,A)') nbad,' / ',huv%gil%nvisi, &
            & ' visibilities with non conformant weights'
          call map_message(seve%w,rname,mess)
          scale = 1.0
        endif
      else
        write(mess,*) "Computed Median re-scale factor is ",scale
        call map_message(seve%i,rname,mess)
      endif
    else
      ! on FILE mode
      call get_uvranges(rname,uvchannels,ctype,mranges,numchan,nc,hiuv,error)
      if (error) return
      !
      allocate(original(mvisi),ratio(mvisi),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      !
      ! Work by Block : scales will be by Block ? or we
      ! must compute the Mean of Medians to be sure ? 
      gscale = 0
      lscale = 0 
      do ib=1,hiuv%gil%nvisi,mvisi
        !
        ! Read the data
        write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
        call map_message(seve%i,rname,mess)
        hiuv%blc(2) = ib
        hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
        nvisi = hiuv%trc(2)-hiuv%blc(2)+1
        call gdf_read_data(hiuv,hiuv%r2d,error)
        if (error) return
        !
        call uv_get_reweight(hiuv,hiuv%r2d,nvisi,numchan,nc,ishow,thre, &
          & original,ratio, lscale, error)
        gscale = gscale + lscale*nvisi
      enddo
      ! Mean of Medians
      scale = gscale/hiuv%gil%nvisi
      !
      if (mode.eq.'DO') then
        ! Create Ouput file if needed
        if (do_file.eq.2) then
          call gdf_create_image(houv,error)
          if (error) return
        endif
        !
        nbad = 0
        write(mess,*) "Applying Median re-scale factor ",scale
        call map_message(seve%i,rname,mess)
        do ib=1,hiuv%gil%nvisi,mvisi
          !
          ! Read the data
          write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
          call map_message(seve%i,rname,mess)
          hiuv%blc(2) = ib
          hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
          nvisi = hiuv%trc(2)-hiuv%blc(2)+1
          call gdf_read_data(hiuv,hiuv%r2d,error)
          if (error) return
          !
          call uv_do_reweight(huv, duv, huv%gil%nvisi, flag, nbad, original, &
            & ratio, scale, fthre)
          houv%blc = hiuv%blc
          houv%trc = hiuv%trc
          call gdf_write_data (houv,hiuv%r2d,error)
          if (error) return
        enddo
        if (nbad.gt.0) then
          write(mess,'(I0,A,I0,A)') nbad,' / ',huv%gil%nvisi, &
            & ' visibilities with non conformant weights'
          call map_message(seve%w,rname,mess)
          scale = 1.0
        endif
        if (do_file.eq.2) call gdf_close_image(houv,error)
      else
        write(mess,*) "Median re-scale factor is ",scale
        call map_message(seve%i,rname,mess)
      endif
      call gdf_close_image(hiuv,error)
    endif ! do_file # 0
  endif   ! APPLY
  !
end subroutine uv_reweight_comm
!
subroutine uv_get_reweight (out,dout,nvisi,numchan,nc,ishow,thre, &
    & original,ratio,scale,error)
  use image_def
  use gkernel_interfaces, only : gr4_median
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !	  Support for 
  ! UV_REWEIGHT [PrintLevel] /RANGE  [/NOFLAG]
  !   Derive the weights of the UV table from the noise
  !   statistic over many channels
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: out       ! Visibility header
  real, intent(in) :: dout(:,:)          ! Visibilities
  integer(kind=size_length), intent(in) :: nvisi ! Number of visibilities
  integer, intent(in) :: numchan         ! Number of windows 
  integer, intent(in) :: nc(2*numchan)   ! Channel windows
  integer, intent(in) :: ishow           ! Show changes period
  real, intent(in) :: thre               ! Threshold for choice of noise estimate
  real, intent(out) :: original(nvisi)   ! Original weights
  real, intent(out) :: ratio(nvisi)      ! Ratio of weights
  real, intent(out) :: scale             ! Global scale factor
  logical, intent(out) :: error          ! Error flag
  ! Local
  integer :: i,j,k,l,fc,nd,nk, kk, ll
  real :: rms, rmsr, rmsi, reel, imag, arms, awei
  real :: xxr, xmr, xxi, xmi
  !
  nk = (nc(1)+nc(2))/2
  if (ishow.gt.0) then
    write(*,*) 'Visibility           New          Original       N_Valid_Channels '
  endif 
  fc = out%gil%fcol-1
  error = .false.
  k = 0
  kk = 0
  ll = 0
  !  
  do j=1,nvisi
    !
    ! Compute rms on "Good" channels
    xxr = 0.
    xxi = 0
    xmr = 0.
    xmi = 0.
    nd = 0
    do l=1,numchan
      do i=nc(2*l-1),nc(2*l)
        if (dout(fc+3*i,j).gt.0)  then
          reel = dout(fc+3*i-2,j)
          imag = dout(fc+3*i-1,j)
          xxr = xxr + reel**2
          xmr = xmr + reel
          xxi = xxi + imag**2
          xmi = xmi + imag
          nd = nd+1
        endif
      enddo
    enddo
    !
    if (nd.le.1) cycle
    !
    ! This is the weight on the REAL or IMAGinary part
    k = k+1
    rmsr = (xxr-xmr/nd)
    rmsi = (xxi-xmi/nd)
    rms = (rmsr+rmsi)*0.5
    if (rms.gt.thre*rmsi) then
      rms = thre*rmsi
      kk = kk+1
    else if (rms.gt.thre*rmsr) then
      rms = thre*rmsr
      ll = ll+1
    endif
    if (ishow.gt.0) then
      if (mod(k,ishow).eq.1) then
        arms = sqrt(rms/float(nd-1))
        awei = 1.0/sqrt(dout(fc+3*nk,j)*1e6) 
        write(6,*) j,arms,awei,nd ! +ivisi if in Loop
      endif
    endif
    original(j) = dout(fc+3*nk,j)
    ratio(j) = float(nd-1)/rms*1e-6
    ratio(j) = ratio(j)/original(j)
    !
  enddo
  !
  call gr4_median(ratio,nvisi,0.0,-1.0,scale,error)
end subroutine uv_get_reweight
!
subroutine uv_do_reweight(out, dout, nvisi, flag, nbad, original, & 
  & ratio, scale, fthre)
  use image_def
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !   Support routine for command
  ! UV_REWEIGHT DO [/FLAG Threshold]
  !
  ! Apply scaling factor which has been derived, and return the
  ! number of "anomalous" visibilities.
  !---------------------------------------------------------------------  
  type (gildas), intent(inout) :: out    ! Visibility header
  real, intent(inout) :: dout(:,:)       ! Visibilities
  integer(kind=size_length), intent(in) :: nvisi   ! Number of visibilities
  logical, intent(in) :: flag            ! Flag anomalous re-scale ?
  integer, intent(inout) :: nbad         ! Number of potentially "bad" visibilities
  real, intent(in) :: original(nvisi)    ! Original weights
  real, intent(in) :: ratio(nvisi)       ! Ratio of weights
  real, intent(in) :: scale              ! Global scale factor
  real, intent(in) :: fthre              ! Worry factor
  !
  integer(kind=index_length) :: j
  integer :: fc, ic
  real :: wei
  !
  fc = out%gil%fcol-1
  !
  do j=1,nvisi
    if (flag) then
      if ( (ratio(j).gt.fthre*scale).or.(ratio(j)*fthre.lt.scale) ) then
        wei = -abs(scale*original(j))
        nbad = nbad+1
      else
        wei = scale*original(j)
      endif
    else
      wei = scale*original(j)
    endif
    !
    do ic = 1,out%gil%nchan
      if (dout(fc+3*ic,j).gt.0) then
        dout(fc+3*ic,j) = wei
      else if (dout(fc+3*ic,j).lt.0) then
        dout(fc+3*ic,j) = -abs(wei)      
      endif
    enddo
  enddo 
end subroutine uv_do_reweight
!
subroutine get_uvranges(pname,uvchannel,ctype,mranges,numchan,nc,y,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !   Convert ranges defined in a String to (integer) Channel ranges
  !   for a UV data.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: pname     ! Caller name
  character(len=*), intent(in) :: uvchannel ! String to be decoded
  character(len=*), intent(inout) :: ctype  ! Type of values
  integer, intent(in) :: mranges            ! Maximum Number of ranges
  integer, intent(out) :: numchan           ! Actual number of ranges
  integer, intent(out) :: nc(mranges)       ! Channel ranges
  type(gildas), intent(in) :: y             ! Header of UV data
  logical, intent(out) :: error             ! Error flag
  !
  integer(4) :: ier, i, ntmp, nmin, nmax, inext
  real(8), parameter :: rnone=-1D9 ! Impossible velocity, frequency or channel number 
  real(kind=8) :: drange(mranges)
  character(len=256) :: chain
  integer(kind=4), parameter :: mtype=3
  integer :: itype
  character(len=12) :: types(mtype),mytype
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  call sic_upper(ctype)
  error = .false.
  call sic_ambigs(pname,ctype,mytype,itype,types,mtype,error)
  if (error)  return
  !
  drange = rnone    ! Impossible velocity, frequency or channel number 
  nc = 0            ! This initialization is essential...
  read (uvchannel,*,iostat=ier) drange
  if (ier.gt.0) then
    call map_message(seve%e,pname,'Error reading '//trim(uvchannel))
    error = .true.
    return
  endif
  ! 
  numchan = 0
  i = 2
  do while (i.lt.mranges)
    if (drange(i).ne.rnone.and.drange(i-1).ne.rnone) numchan = numchan+2
    i = i+2
  enddo
  !
  ! Convert to channels
  if (numchan.eq.0) then
    numchan = 2
    nc(1) = 1
    nc(2) = y%gil%nchan 
  else if (mytype.eq.'CHANNEL') then
    nc(1:numchan) = nint(drange(1:numchan))
    do i=1,numchan
      if (nc(i).lt.0) nc(i) = y%gil%nchan+nc(i)
    enddo
  else if (mytype.eq.'VELOCITY') then
    ! drange = nc - y%gil%ref(y%gil%faxi) ) * y%gil%vres + y%gil%voff 
    nc(1:numchan) = (drange(1:numchan) - y%gil%voff) / y%gil%vres + y%gil%ref(y%gil%faxi)
  else if (mytype.eq.'FREQUENCY') then
    ! drange = nc - y%gil%ref(y%gil%faxi) ) * y%gil%vres + y%gil%voff 
    nc(1:numchan) = (drange(1:numchan) - y%gil%freq) / y%gil%fres + y%gil%ref(y%gil%faxi)
  else
    call map_message(seve%e,pname,"Type of value '"//trim(mytype)//"' not supported")
    error = .true.
    return
  endif
  !
  ! Set channel order to have increasing values in each pair
  inext = 1
  do i=2,numchan,2
    if (nc(i).lt.nc(i-1)) then
      ntmp = nc(i)
      nc(i) = nc(i-1)
      nc(i-1) = ntmp
    endif    
    nmax = min(nc(i),y%gil%nchan)
    nmin = max(nc(i-1),1)
    !
    if (nmin.gt.nmax) then
      call map_message(seve%e,pname,"Range out of bounds")
      error = .true.
      return
    endif
    !
    nc(i-1) = nmin
    nc(i) = nmax
    write(chain(inext:),'(A,I0,A,I0,A)') '[',nmin,'-',nmax,']'
    inext = len_trim(chain)+3
  enddo
  !
  call map_message(seve%i,pname,'Using channel ranges '//chain)
  numchan = numchan/2     ! This must be the number of ranges
end subroutine get_uvranges
!
subroutine uv_time_reweight (out,dout,nvisi,numchan,nc,diam,thre, &
    & original,ratio,scale,error)
  use image_def
  use gkernel_interfaces, only : gr4_median
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !	  Support for 
  ! UV_REWEIGHT TIME [PrintLevel] /RANGE  [/NOFLAG]
  !   Derive the weights of the UV table from the noise
  !   statistic over many consecutive visibilities 
  !
  ! This assumes that Visibilities are sufficiently well sampled so
  ! that the differences between adjacent ones (in time) only differ
  ! by the noise, not by the source structure.
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: out       ! Visibility header
  real, intent(in) :: dout(:,:)          ! Visibilities
  integer(kind=size_length), intent(in) :: nvisi ! Number of visibilities
  integer, intent(in) :: numchan         ! Number of windows 
  integer, intent(in) :: nc(2*numchan)   ! Channel windows
  real, intent(in) :: diam               ! Tolerance radius in UV space
  real, intent(in) :: thre               ! Threshold for choice of noise estimate
  real, intent(out) :: original(nvisi)   ! Original weights
  real, intent(out) :: ratio(nvisi)      ! Ratio of weights
  real, intent(out) :: scale             ! Global scale factor
  logical, intent(out) :: error          ! Error flag
  ! Local
  integer :: i,k,l,fc,nd,nk, kk, ll
  integer(kind=size_length) :: jlast, j
  real :: rms, rmsr, rmsi, reel, imag, arms, awei
  real :: xxr, xmr, xxi, xmi, duvstep, deltauv, weight
  integer :: iant,jant,ibase,jbase, jmax
  !
  duvstep = diam**2   ! Nyquist sampling passed as argument...
  !
  nk = (nc(1)+nc(2))/2      ! An average channel
  fc = out%gil%fcol-1       ! First column
  error = .false.
  k = 0
  kk = 0
  ll = 0
  !
  iant = 6      ! Iant Pointer
  jant = 7      ! Jant Pointer
  !  
  ibase = 0
  xxr = 0.
  xxi = 0
  xmr = 0.
  xmi = 0.
  nd = 0
  nd = 0
  deltauv = 0.
  !
  original(1) = dout(fc+3*nk,1)
  jlast = 1
  j = 2     ! Start at the 2nd visibility
  do 
    !
    if (j.lt.nvisi) then
      jbase = 1024*dout(iant,j) + dout(jant,j)
    else
      jbase = 0
    endif
    deltauv = (dout(1,j)-dout(1,j-1))**2 + (dout(2,j)-dout(2,j-1))**2
    original(j) = dout(fc+3*nk,j)   ! Representative Weight
    !
    ! If UV track has changed, compute the statistic on the last UV track
    if ((ibase.ne.jbase).or.(deltauv.gt.duvstep)) then
      if (nd.gt.1) then
        !
        rmsr =  (xxr-xmr/nd)   ! Store the  noise level
        rmsi =  (xxi-xmi/nd)
        rms = (rmsr+rmsi)*0.5
        if (rms.gt.thre*rmsi) then
          rms = thre*rmsi
          kk = kk+1
        else if (rms.gt.thre*rmsr) then
          rms = thre*rmsr
          ll = ll+1
        endif
        ratio(jlast:j) = float(nd)/rms*1e-6
        jlast = j
        j = j+1 ! Skip 1 Visi
        if (j.gt.nvisi) exit
      endif        
      xxr = 0.
      xxi = 0
      xmr = 0.
      xmi = 0.
      nd = 0
      ibase = jbase
    endif
    !
    ! Accumulate Differences
    do i=nc(1),nc(2)  
      weight = max(0.,dout(fc+3*i,j))*max(0.,dout(fc+3*i,j-1))
      if (weight.gt.0) then
        weight = sqrt(weight)
        reel = dout(fc+3*i-2,j) - dout(fc+3*i-2,j-1)
        imag = dout(fc+3*i-1,j) - dout(fc+3*i-1,j-1)
        xxr = xxr + reel**2*weight
        xxi = xxi + imag**2*weight
        nd = nd+1
      endif
    enddo
    ! Next visibility
    j = j+1
    !
  enddo
  !
  call gr4_median(ratio,nvisi,0.0,-1.0,scale,error)
  scale = scale*2   ! We have evaluated the difference
end subroutine uv_time_reweight

module cubedag_walker
  use cubedag_messaging
  use cubedag_parameters
  use cubedag_node
  use cubedag_dag
  use cubedag_link_type
  use cubedag_node_type
  !
  integer(kind=4), parameter :: topomarker_null=0
  integer(kind=4), parameter :: topomarker_done=1
  type(cubedag_link_t) :: link
  integer(kind=entr_k) :: current
  !
  abstract interface
    subroutine callback_interface(par,chi,error)
      import cubedag_node_object_t
      class(cubedag_node_object_t), intent(in)    :: par
      class(cubedag_node_object_t), intent(in)    :: chi
      logical,                      intent(inout) :: error
    end subroutine callback_interface
    recursive subroutine getlink_interface(obj,callback,error)
      import cubedag_node_object_t,callback_interface
      class(cubedag_node_object_t), intent(in)    :: obj
      procedure(callback_interface)               :: callback
      logical,                      intent(inout) :: error
    end subroutine getlink_interface
  end interface
  !
  public :: cubedag_walker_null
  public :: cubedag_childwalker_reset,cubedag_childwalker_next
  public :: cubedag_parentwalker_reset,cubedag_parentwalker_next
  private
  !
contains
  !
  subroutine cubedag_childwalker_reset(start,callback,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: start
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='CHILDWALKER>RESET'
    !
    call cubedag_walker_reset(cubedag_walker_getchildren,start,callback,error)
  end subroutine cubedag_childwalker_reset
  !
  subroutine cubedag_parentwalker_reset(start,callback,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: start
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='PARENTWALKER>RESET'
    !
    call cubedag_walker_reset(cubedag_walker_getparent,start,callback,error)
  end subroutine cubedag_parentwalker_reset
  !
  subroutine cubedag_walker_reset(cubedag_walker_getlink,start,callback,error)
    !-------------------------------------------------------------------
    ! Set the current walker in memory to start from given commit
    ! The callback is called at load time, on each parent-child pair,
    ! with the signature:
    !    call callback(pid,cid,error)
    ! If the callback raises an error, the load stops and
    ! cubedag_walker_reset returns an error
    !-------------------------------------------------------------------
    procedure(getlink_interface)                     :: cubedag_walker_getlink
    procedure(callback_interface)                    :: callback
    class(cubedag_node_object_t), intent(in), target :: start
    logical,                      intent(inout)      :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>RESET'
    !
    ! ZZZ Unclear if collection should be done here or at first
    !     cubedag_walker_next
    !
    call link%reallocate(ix%n,error)
    if (error)  return
    !
    ! Prepare topomarkers
    ix%flag(1:ix%n) = topomarker_null
    !
    ! Insert start point
    link%n = 1
    link%list(link%n)%p => start
    !
    ! ZZZ Might implement several sorting modes (like git_revwalk_sorting)
    call cubedag_walker_getlink(start,callback,error)
    if (error)  return
    !
    current = 0
  end subroutine cubedag_walker_reset
  !
  recursive subroutine cubedag_walker_getchildren(par,callback,error)
    !---------------------------------------------------------------------
    ! Recursive childwalking
    !---------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: par       ! Starting point (already in list)
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>GETCHILDREN'
    integer(kind=entr_k) :: first,last,ilist,cent
    class(cubedag_node_object_t), pointer :: chi
    !
    first = link%n+1
    do ilist=1,par%node%children%n
      chi => cubedag_node_ptr(par%node%children%list(ilist)%p,error)
      if (error)  return
      !
      call callback(par,chi,error)
      if (error)  return
      !
      cent = chi%node%ient
      if (ix%flag(cent).eq.topomarker_done)  cycle  ! Do not store duplicate nodes
      if (link%n.ge.size(link%list)) then
        call cubedag_message(seve%e,rname,'Internal error: list exhausted')
        error = .true.
        return
      endif
      link%n = link%n+1
      link%list(link%n)%p => chi
      ix%flag(cent) = topomarker_done
    enddo
    last = link%n
    !
    do ilist=first,last
      chi => cubedag_node_ptr(link%list(ilist)%p,error)
      if (error)  return
      call cubedag_walker_getchildren(chi,callback,error)
      if (error)  return
    enddo
  end subroutine cubedag_walker_getchildren
  !
  recursive subroutine cubedag_walker_getparent(chi,callback,error)
    !---------------------------------------------------------------------
    ! Recursive parentwalking
    !---------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: chi       ! Starting point (already in list)
    procedure(callback_interface)               :: callback
    logical,                      intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='WALKER>GETPARENT'
    integer(kind=entr_k) :: first,last,ilist,pent
    class(cubedag_node_object_t), pointer :: par
    !
    first = link%n+1
    do ilist=1,chi%node%parents%n
      par => cubedag_node_ptr(chi%node%parents%list(ilist)%p,error)
      if (error)  return
      !
      call callback(par,chi,error)
      if (error)  return
      !
      pent = par%node%ient
      if (ix%flag(pent).eq.topomarker_done)  cycle  ! Do not store duplicate nodes
      if (link%n.ge.size(link%list)) then
        call cubedag_message(seve%e,rname,'Internal error: list exhausted')
        error = .true.
        return
      endif
      link%n = link%n+1
      link%list(link%n)%p => par
      ix%flag(pent) = topomarker_done
    enddo
    last = link%n
    !
    do ilist=first,last
      par => cubedag_node_ptr(link%list(ilist)%p,error)
      if (error)  return
      call cubedag_walker_getparent(par,callback,error)
      if (error)  return
    enddo
  end subroutine cubedag_walker_getparent
  !
  function cubedag_childwalker_next(next)
    !-------------------------------------------------------------------
    ! Get the next commit ID. Evaluate to .false. if all done.
    !-------------------------------------------------------------------
    logical :: cubedag_childwalker_next
    class(cubedag_node_object_t), pointer :: next
    cubedag_childwalker_next = cubedag_walker_next(next)
  end function cubedag_childwalker_next
  !
  function cubedag_parentwalker_next(next)
    !-------------------------------------------------------------------
    ! Get the next commit ID. Evaluate to .false. if all done.
    !-------------------------------------------------------------------
    logical :: cubedag_parentwalker_next
    class(cubedag_node_object_t), pointer :: next
    cubedag_parentwalker_next = cubedag_walker_next(next)
  end function cubedag_parentwalker_next
  !
  function cubedag_walker_next(next)
    !-------------------------------------------------------------------
    ! Get the next commit ID. Evaluate to .false. if all done.
    !-------------------------------------------------------------------
    logical :: cubedag_walker_next
    class(cubedag_node_object_t), pointer :: next
    ! Local
    logical :: error
    !
    if (current.ge.link%n) then
      cubedag_walker_next = .false.
      next => null()
      return
    endif
    cubedag_walker_next = .true.
    current = current+1
    error = .false.
    next => cubedag_node_ptr(link%list(current)%p,error)
  end function cubedag_walker_next
  !
  function cubedag_walker_contains(link,obj)
    !-------------------------------------------------------------------
    ! Return .true. if the list contains the named ID
    ! ZZZ This is inefficient (N^2)
    !-------------------------------------------------------------------
    logical :: cubedag_walker_contains
    type(cubedag_link_t),         intent(in) :: link
    class(cubedag_node_object_t), pointer    :: obj
    ! Local
    integer(kind=entr_k) :: ilist
    do ilist=1,link%n
      if (associated(link%list(ilist)%p,obj)) then
        cubedag_walker_contains = .true.
        return
      endif
    enddo
    cubedag_walker_contains = .false.
  end function cubedag_walker_contains
  !
  subroutine cubedag_walker_null(par,chi,error)
    !-------------------------------------------------------------------
    ! Does nothing
    !-------------------------------------------------------------------
    class(cubedag_node_object_t), intent(in)    :: par
    class(cubedag_node_object_t), intent(in)    :: chi
    logical,                      intent(inout) :: error
    !
    return
  end subroutine cubedag_walker_null
  !
end module cubedag_walker

subroutine get_cols(nchan,ucol,fcol,lcol,wcol)
  ! @ private
  integer, intent(in) :: ucol(2)
  integer, intent(inout) :: nchan
  integer, intent(out) :: fcol
  integer, intent(out) :: lcol
  integer, intent(out) :: wcol
  !
  integer :: mcol(2)
  !
  mcol = ucol
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nchan))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nchan
  else
    mcol(2) = max(1,min(mcol(2),nchan))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nchan)
  nchan = lcol-fcol+1
end subroutine get_cols
!
subroutine uv_residual_clean(line,task,iarg,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_residual_clean
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER   Support for routine UV_RESIDUAL [FIELDS List]
  !     Remove all Clean Components from a UV Table
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  !------------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  character(len=*), intent(in) :: task
  integer, intent(in) :: iarg
  logical, intent(out) :: error
  !
  integer, parameter :: o_field=1
  character(len=*), parameter :: rname='UV_RESIDUAL'
  !
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  logical :: do_clean  
  !
  error = .false.
  if (themap%nfields.ne.0) then
    call map_message(seve%w,rname,'UV data is a Mosaic - UNDER TESTS !!!')
    call uv_shift_mosaic(line,rname,error)
    if (error) return
  endif
  !
  call map_message(seve%i,rname,'Subtracting CLEAN components')
  nullify(duv_previous,duv_next)
  call sic_delvariable('UV_RESIDUAL',.false.,error)
  !
  ! Do the job. 
  uv_resid_updated = .true.
  ! do_clean = .false.  means do not re-image with Clean components added, 
  ! and thus, do not store in duv_next, but rather in DUVF 
  ! ("Fit" or "Residual" buffer)
  do_clean = .false. 
  if (.not.do_clean) duv_previous => duv   ! Start from current UV buffer
  call sub_uv_residual(task,line,iarg,duv_previous,duv_next,do_clean,error)
  if (error) return
  !
  call sic_mapgildas('UV_RESIDUAL',huvf,error,duvf)
  !  
end subroutine uv_residual_clean
!
subroutine sub_uv_residual(task,line,iarg,duv_previous,duv_next,do_clean,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uv_residual
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER   Support for routine UV_RESIDUAL
  !     Remove all Clean Components from a UV Table
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: task            ! Calling Command
  character(len=*), intent(inout) :: line         ! Command line
  integer, intent(in) :: iarg                     ! First useful argument
  real, pointer, intent(inout) :: duv_previous(:,:) ! Input buffer
  real, pointer, intent(inout) :: duv_next(:,:)   ! May not be defined here
  logical, intent(in) :: do_clean                 ! Re-image ?
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer, parameter :: o_field=1
  ! Minimum number of Visibilities to activate the FFT mode
  integer, parameter :: fft_mode=20000 
  !
  real(8) :: freq
  character(len=message_length) :: chain
  real :: cpu0, cpu1
  integer :: ier,nu,nv,mv,nchan,nx,ny
  !
  real, pointer :: duv_in(:,:), duv_out(:,:)
  real, allocatable, target :: ccou(:,:,:)
  real, pointer  :: fcou(:,:,:)
  integer, allocatable :: omic(:), nmic(:)
  integer :: maxic, ic,lc, icmax, oic, olc, iv
  integer :: nthread, ithread, np
  logical :: fft, debug
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  ! For mosaics
  type(clean_par) :: my_method
  type(projection_t) :: proj
  real(8) :: pos(2)
  real(8), parameter :: sec_to_rad=pi/3600.d0/180d0
  real(4) :: bsize
  integer :: ifield, jfield, nfields! Field number & Number of fields
  real, allocatable :: doff(:,:)    ! Field offsets
  integer, allocatable :: ivoff(:)  ! Input Visibility pointers
  integer, allocatable :: jvoff(:)  ! Output Visibility pointers
  integer :: ivstart, ivend, kvstart, kvend, it
  logical :: sorted, shift
  real(8) :: new(3)
  real(4) :: uvmin, uvmax
  logical :: omp_nested
  integer :: max_inner, nouter
  !
  integer :: fcol, lcol, wcol
  !
  call map_message(seve%d,task,'Calling SUB_UV_RESIDUAL',3)
  !
  ! Subtract all Clean Components
  if (.not.associated(duv)) then
    call map_message(seve%e,task,'DUV is NOT allocated')
    error = .true.
    return
  endif
  if (.not.allocated(dcct)) then
    call map_message(seve%e,task,'DCCT is NOT allocated')
    error = .true.
    return
  endif
  !
  if (allocated(doff)) then
    Print *,'DOFF is still allocated '
    deallocate(doff)
  endif
  if (allocated(ivoff)) then
    Print *,'IVOFF is still allocated '
    deallocate(ivoff)
  endif
  !
  ! Basic initializations
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi    ! not %dim(2)
  nchan = huv%gil%nchan ! Default value 
  !
  ! That only works for UV_RESTORE, not for UV_RESIDUAL
  call get_cols(nchan,saved_mcol,fcol,lcol,wcol)
  Print *,'Done GET_COLS ',fcol,lcol, ' NCHAN ',nchan
  !
  ithread = 1
  nthread = 1
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)
  error = .false.
  !
  ! Verify number of channels match
  if (hcct%gil%dim(2).ne.huv%gil%nchan) then
    if (hcct%gil%dim(2).eq.1) then
      call map_message(seve%w,task,'Subtracting a Continuum CCT from a Line data set')
    else
      write(chain,'(A,I0,A,I0,A)') 'Number of channels in CCT [', &
      & hcct%gil%dim(2),'] and in UV [',huv%gil%nchan,'] do not match'
      Print *,'SAVED_MCOL ',saved_mcol
      call map_message(seve%w,task,chain)
!      error = .true.
!      return
    endif
  endif  
  !
  maxic = hcct%gil%dim(3)
  if (iarg.gt.0) then
    call sic_i4(line,0,iarg,maxic,.false.,error)
    if (error) return
    if (maxic.lt.0) maxic = hcct%gil%dim(3)
    maxic = min(hcct%gil%dim(3),maxic)
    if (maxic.eq.0) return ! Nothing to do then...
  endif
  !
  allocate (omic(nchan),nmic(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Compact the Clean components first
  ic = fcol
  lc = lcol
  hcct%r3d => dcct
  call uv_clean_sizes(hcct,hcct%r3d,omic,ic-fcol+1,lc-fcol+1)
  icmax = maxval(omic)
  if (debug) Print *,'Max number of clean components ',icmax
  !
  ! Nothing to do if no Clean component
  if (icmax.eq.0) then
    call map_message(seve%w,task,'No valid Clean Component')
    return
  endif  
  !
  call gag_cpu(cpu0)
  !
  if ((themap%nfields.ne.0).and.(abs(themap%nfields).ne.1)) then
    !
    ! True Mosaic case
    nfields = abs(themap%nfields)
    allocate(doff(2,nfields),ivoff(nfields+1),jvoff(nfields+1),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
    shift = .false.
    sorted = .false.
    error = .false.
    if (debug) Print *,'Sorting Mosaic ',themap%nfields, &
      & huv%gil%column_pointer(code_uvt_xoff), &
      & huv%gil%column_pointer(code_uvt_yoff), &
      & nfields
    !
    new = 0.D0 ! No change of Phase center
    !
    call mosaic_sort (error,sorted,shift,new,uvmax,uvmin, &
      & huv%gil%column_pointer(code_uvt_xoff), &
      & huv%gil%column_pointer(code_uvt_yoff), &
      & nfields,doff,ivoff)
    if (error) return
    if (debug) Print *,'Nfields ',nfields
    !
    ! Shift offset coordinates to Phase center 
    call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
    if (debug) Print *,'Posangle ',huv%gil%pang
    ! POS is here the Offset of the Pointing center relative to the Phase center
    call abs_to_rel (proj,huv%gil%ra,huv%gil%dec,pos(1),pos(2),1)
    if (debug) Print *,'POS ',pos
    do ifield=1,nfields
      doff(:,ifield) = doff(:,ifield)+pos
      if (debug) Print *,doff(1,ifield)/sec_to_rad, doff(2,ifield)/sec_to_rad
    enddo
    !
    ! Get primary beam size
    bsize = 0
    !!Print *,'SUB_UVRESIDUAL get_bsize ',bsize
    call get_bsize(huv,task,' ',bsize,error)
    if (debug) Print *,'Primary beam size ',bsize/sec_to_rad,' " '
    !
    ! For tests per field - not useable in production
    if (task.eq.'UV_RESIDUAL'.and.sic_present(o_field,0)) then
      call select_fields(task,line,o_field,nfields,np,selected_fields,error)
      if (error) return
      selected_fieldsize = np
    endif
    !
    if (selected_fieldsize.ne.0) then
      if (.not.allocated(selected_fields)) then
        call map_message(seve%f,task, &
          & 'Programming error, Selected_Fields not allocated')
        error = .true.
        return
      endif
      if (debug) Print *,'Selected Fields ',selected_fields(1:selected_fieldsize) !!
      nv = 1
      mv = 0
      do jfield=1,selected_fieldsize
        ifield = selected_fields(jfield)
        jvoff(jfield) = nv
        mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
        nv = nv + ivoff(ifield+1)-ivoff(ifield)
        jvoff(jfield+1) = nv
      enddo
      nv = nv-1
      nfields = selected_fieldsize
    else
      jvoff(:) = ivoff
      mv = 0
      do ifield=1,nfields
        mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
      enddo
    endif
  else
    nfields = 1
    mv = nv
    allocate(doff(2,1),ivoff(2),jvoff(2),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
    doff = 0.0
    bsize = 0.
    ivoff(1) = 1
    ivoff(2) = nv+1
    jvoff(:) = ivoff
    !
    if (debug) Print *,'Single Field case'
  endif 
  !
  ! Select the FFT or DIRECT mode by default, according to the
  ! problem size. This may need to be tested in more details
  if (mv.lt.fft_mode) then
    fft = .false.
  else
    fft = .true.
  endif
  if (debug) Print *,'Default FFT ',fft, mv
  call sic_get_logi('FAST',fft,error)
  if (debug) Print *,'User set FFT ',fft, error
  error = .false.
  !
  ! Prepare appropriate array...
  if (do_clean) then 
    ! Allocate work arrays
    nullify (duv_previous, duv_next)
    call uv_find_buffers (task,nu,nv,duv_previous, duv_next,error)
    if (error) then
      call map_message(seve%e,task,'Cannot set buffer pointers')
      return
    endif
  else
    ! Assume DUV_PREVIOUS has been already set by caller
    ! Set DUV_NEXT to point to DUVF
    call gdf_copy_header(huv,huvf,error)
    huvf%gil%dim(2) = nu
    huvf%gil%dim(2) = nv
    huvf%gil%nvisi = nv
    !
    if (allocated(duvf)) deallocate(duvf) !NEW!
    allocate(duvf(nu,nv),stat=ier)   !NEW!
    if (ier.ne.0) then
      call map_message(seve%e,task,'MODEL Memory allocation failure')
      error = .true.
      return
    endif
    duv_next => duvf
  endif
  if (debug) Print *,'Found buffers',nu,nv
  !
  ! Redo that by block - At this stage NFIELDS is the actual number of selected fields.
  !
  oic = ic    ! This must be FCOL
  olc = lc    ! This must be LCOL
  Print *,'IC ',ic,' LC ',lc
  !
  ! Spatially compress the Clean Component List
  allocate(ccou(3,icmax,nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,'uv_squeeze_clean ',nchan,omic,ic,lc
  call uv_squeeze_clean(nchan,hcct%r3d,ccou, omic,ic,lc)
  if (debug) Print *,'Done uv_squeeze_clean' 
  ! 
  ! Remember the Full Clean Component List size
  nmic(:) = omic
  !
  if (bsize.ne.0) then
    maxic = maxval(omic)
    write(chain,'(A,I0,A,I0,A)') 'Compressing CCT from ',icmax,' to ',maxic,' components'
    call map_message(seve%i,task,chain)
    allocate(fcou(3,maxic,nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
  else
    fcou => ccou
  endif
  freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
  !
  if (debug) Print *,'LCOL ',huv%gil%lcol,' and DIM ',huv%gil%dim(1)
  !
  ! Simple sequential stuff - parallelism is inside the
  !   uv_remove_...  subroutines to avoid memory issues
  ! Unfortunately, this parallelism is only efficient if
  ! the number of visibilities is sufficient.
  !
  ! So a mode with per-field parallelism would be good.
  ! But one has to be careful about IC and LC
  !
  if (debug) Print *,'IC LC ',ic,lc,' OIC OLC ',oic,olc
  !
  !$ nouter = 1   ! Should be nfields if Outer parallel mode is activated
  !$ max_inner = omp_get_max_threads()
  !$ call ompset_thread_nesting(task, nouter, max_inner, omp_nested)
  !
  do jfield=1,nfields
    if (sic_ctrlc()) then
      call map_message(seve%w,task,'Aborted by user ^C')
      error = .true.
      return
    endif
    !
    ifield = jfield
    if (selected_fieldsize.ne.0) ifield = selected_fields(jfield)
    if (debug) Print *,'Field ',ifield,jfield
    !
    ! This looks tricky, but is working.
    ! It used to extract an arbitrary subset of all fields
    ! In input Ifield
    ivstart = ivoff(ifield)      ! Starting Visibility of field
    ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
    ! In output Jfield
    kvstart = jvoff(jfield)      ! Starting Visibility of field
    kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
    if (nfields.gt.1) then
      write(chain,'(A,I0,4(1X,I0),2F10.2)') 'Processing field # ',ifield, &
        & ivstart,ivend, kvstart, kvend, doff(1,ifield)/sec_to_rad, doff(2,ifield)/sec_to_rad
      call map_message(seve%i,task,chain)
    endif
    !
    nv = ivend-ivstart+1
    if (ivend.gt.ubound(duv,2)) then
      Print *,'Programming error IVEND',kvend,' > Bound ',ubound(duv,2)
    endif
    duv_in => duv_previous(:,ivstart:ivend) ! We now start from DUV_PREVIOUS
    if (kvend.gt.ubound(duv_next,2)) then   
      Print *,'Programming error KVEND',kvend,' > Bound ',ubound(duv_next,2)
    endif
    duv_out => duv_next(:,kvstart:kvend)    ! We put in DUV_NEXT
    !
    if (bsize.ne.0) then
      omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
      call attenuate_clean(nchan,ccou,doff(:,ifield),bsize,fcou,omic)
      if (debug) then
        do it=1,min(10,omic(1))
          Print *,it,ccou(1:3,it,1),fcou(1:3,it,1),omic(1),nmic(1)
        enddo
      endif
    endif
    !
    if (.not.fft) then
      if (debug) Print *,'Slow case IC ',ic,' LC ',lc,' OMIC ',omic
      call uv_removes_clean(nv,duv_in,duv_out,lc-ic+1,omic, &
        & fcou,freq,ic,lc)
      if (debug) Print *,'Done Slow ',ifield  
    else
      if (debug) Print *,'Fast case '
      call uv_removef_clean(hcct,duv_in,duv_out,lc-ic+1,omic, &
        & fcou,freq,ic,lc)
      if (debug) Print *,'Done Fast ',ifield  
    endif
    !
    ! Add leading and trailing data if any
    if (debug) Print *,'NV ',nv,' Bounds ',ubound(duv_in,2),ubound(duv_out,2)
    if (huv%gil%lcol.lt.huv%gil%dim(1)) then
      do iv=1,nv
        duv_out(1:7,iv) = duv_in(1:7,iv)
        duv_out(huv%gil%lcol+1:huv%gil%dim(1),iv) = &
          & duv_in(huv%gil%lcol+1:huv%gil%dim(1),iv)  
      enddo
    else
      if (debug) Print *,'WARNING no trailing column'
      do iv=1,nv
        duv_out(1:7,iv) = duv_in(1:7,iv)
      enddo
    endif
  enddo
  !
  ! Compute the CLEAN image
  if (do_clean) then
    call copy_method(method,my_method)
    my_method%method = 'UV_RESTORE'
    my_method%bshift = 0      ! This looks uninitialized
    if (debug) Print *,'Calling GENERATE_CLEAN ',my_method%method,my_method%bshift
    ! Use the Full Clean Component list size
    ! We need a Clean Beam size    
    !
    if (hsky%gil%majo.eq.0) then
      if (beam_defined) then
        my_method%major = beam_fitted(1) * sec_to_rad
        my_method%minor = beam_fitted(2) * sec_to_rad
        my_method%angle = beam_fitted(3)   ! Keep it Degree...
      else
        my_method%major = 0
        my_method%minor = 0
        my_method%angle = 0
        nx = hbeam%gil%dim(1)
        ny = hbeam%gil%dim(2)
        call fibeam (task,dbeam,nx,ny,   &
         &    my_method%patch(1),my_method%patch(2),my_method%thresh,   &
         &    my_method%major,my_method%minor,my_method%angle,   &
         &    hbeam%gil%convert,error)
!!        Print *,'Using Clean beam ',beam_fitted(1),' x ',beam_fitted(2),' at PA ',beam_fitted(3)
      endif
      !
      hsky%gil%majo = my_method%major
      hsky%gil%mino = my_method%minor
      hsky%gil%posa = my_method%angle*pi/180.
      hsky%gil%reso_words = 3
    else
      Print *,'Resolution was already defined ',hsky%gil%majo*180*3600/pi
    endif
    !
    call generate_clean(my_method,hsky,ic,lc,ccou,nmic)
  endif
  !
  call gag_cpu(cpu1)
  if (elapsed.eq.0) then
    write(chain,102) 'Finished Residual CPU ',cpu1-cpu0
  else
    write(chain,102) 'Finished Residual Elapsed ',elapsed,'; CPU ',cpu1-cpu0
  endif
  call map_message(seve%i,task,chain)
  !
  if (associated(fcou)) then
    if (.not.associated(fcou,ccou)) deallocate(fcou)
  endif
  if (allocated(ccou)) deallocate(ccou)
  !
  call map_message(seve%d,task,'Finished SUB_UV_RESIDUAL',3)
  !
102 format(a,f9.2,a,f9.2)
end subroutine sub_uv_residual
!
subroutine uv_clean_size(hcct,ccin, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compute the actual number of components
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  integer, intent(out) :: mic
  integer :: nc
  integer :: ni, ki, mi
  integer :: i,ic
  !
  nc = hcct%gil%dim(2)
  ni = hcct%gil%dim(3)
  !
  mi = 0
  do ic=1,nc
    ki = 0
    do i=1,ni
      if (ccin(3,ic,i).eq.0) then
        ki = i-1
        exit
      endif
    enddo
    !!!!Print *,'Channel ',ic,ki
    if (ki.ne.0) then
      mi = max(mi,ki)
    endif
  enddo
  if (mi.eq.0) mi = ni
  mic = mi
  !!!!Print *,'MIC ',mic
end subroutine uv_clean_size
!
subroutine uv_compact_clean(hcct,ccin,occt,ccou, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compact the component list by summing up all values at the
  !   same position
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  type(gildas), intent(in) :: occt  ! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  real, intent(out) :: ccou(occt%gil%dim(1),occt%gil%dim(2),occt%gil%dim(3))
  integer, intent(inout) :: mic
  !
  integer nc
  integer ni
  integer :: ii,jj,ic
  integer :: ki, mi ! Number of different components per channel
  logical doit
  !
  nc = hcct%gil%dim(2)
  ni = mic ! no longer !!! hcct%gil%dim(3)
  !
  mi = 0
  ccou = 0
  !
  do ic=1,nc
    ki = 0
    do ii=1,ni
      if (ccin(3,ic,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,ic,jj).eq.ccin(1,ic,ii)) then
            if (ccou(2,ic,jj).eq.ccin(2,ic,ii)) then
              doit = .false.
              !!!!Print *,'Component ',ii,' relocated at ',jj
              ccou(3,ic,jj) = ccou(3,ic,jj) + ccin(3,ic,ii)
              exit
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          !!!!Print *,'Component ',ii,' new at ',ki
          ccou(1:3,ic,ki) = ccin(1:3,ic,ii)
        endif
      endif
    enddo
    if (ki.ne.0) mi = max(mi,ki)
  enddo
  !
  mic = mi
end subroutine uv_compact_clean
!
subroutine generate_clean(amethod,hmap,first,last,ccou,mic)
  !$ use omp_lib
  use clean_def
  use image_def
  use imager_interfaces, only : clean_make90
  !
  ! @ private-mandatory
  !
  type(clean_par), intent(in) :: amethod
  type(gildas), intent(inout) :: hmap
  integer, intent(in) :: first
  integer, intent(in) :: last
  real, intent(in) :: ccou(:,:,:)  !  (x,y,Value),Component,Plane
  integer, intent(in) :: mic(:)    ! Niter per plane
  !
  type (cct_par), allocatable :: p_cct(:)
  type (clean_par) :: my_method 
  integer :: iplane, jplane, niter, miter, i, ier, nthread
  !
  miter = max(1,maxval(mic))
  allocate (p_cct(miter),stat=ier)
  !$ nthread = omp_get_max_threads()
  !  !$ Print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(),
  !$ nthread = min(nthread,last-first+1)
  !$OMP PARALLEL DEFAULT(NONE) NUM_THREADS(nthread) &
  !$OMP & SHARED(amethod, first, last, hmap, mic, ccou, nthread) &
  !$OMP & PRIVATE(my_method, iplane, jplane, p_cct, niter, i) 
  !
  !$OMP DO
  do iplane = first, last
    my_method = amethod
    !
    my_method%iplane = iplane
    !
    ! Recover the component list in pixels
    jplane = iplane-first+1
    niter = mic(jplane) 
    do i=1,niter
      if (ccou(3,i,jplane).eq.0) then
        p_cct(i)%value = 0 ! Required
        niter = i-1
        exit
      else
        !
        ! The NINT is required because of rounding errors
        p_cct(i)%ix = nint( (ccou(1,i,jplane)-hmap%gil%convert(2,1)) /  &
            &        hmap%gil%convert(3,1) + hmap%gil%convert(1,1))
        p_cct(i)%iy = nint( (ccou(2,i,jplane)-hmap%gil%convert(2,2)) /  &
            &        hmap%gil%convert(3,2) + hmap%gil%convert(1,2))
        p_cct(i)%value = ccou(3,i,jplane)
      endif
    enddo
    ! Stupid test
    if (niter.gt.0) then
      my_method%n_iter = niter
      call clean_make90(my_method,hmap, hmap%r3d(:,:,iplane),p_cct)
    else
      hmap%r3d(:,:,iplane) = 0
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  deallocate(p_cct)
end subroutine generate_clean
!
subroutine attenuate_clean(nchan,ccou,doff,bsize,fcou,mic)
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Apply primary beam attenuation to Clean Components
  ! at specified offset
  !   Input   CCOU(3,Nclean,Nchan)
  !   Output  FCOU(3,Ncomp,Nchan)
  ! Ncomp is lower than Nclean: Clean components at same position
  !   have been averaged first
  ! MIC(nchan) contains the number of effective Clean Components
  ! for this channel (after attenuation).
  !---------------------------------------------------------------------
  integer, intent(in) :: nchan      ! Number of channels
  real, intent(in) :: ccou(:,:,:)   ! Shape (3,Ncomp,Nplane)
  real, intent(out) :: fcou(:,:,:)  ! Same shape, but different sizes 
  real, intent(in) :: doff(2)       ! Offset value
  real, intent(in) :: bsize         ! Beam size
  integer, intent(inout) :: mic(nchan)  ! Effective number of Clean components
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=pi/3600.d0/180d0
  real :: beam_e, b2, fact
  integer :: ic,jc,kc
  !
  !!Print *,'Into ATTENUATE ',maxval(mic)
  !!Print *,'CCOU shape ',ubound(ccou)
  !!Print *,'FCOU shape ',ubound(fcou)
  !!Print *,'Doff ',doff(1)/sec_to_rad,doff(2)/sec_to_rad
  beam_e = bsize/(2.*sqrt(log(2.0)))
  b2 = (1.0/beam_e)**2
  !
  do ic=1,nchan
    kc = 0
    do jc=1,mic(ic)
      fact = ((ccou(1,jc,ic)-doff(1))**2+(ccou(2,jc,ic)-doff(2))**2)*b2
      if (fact.lt.32) then
        kc = kc+1
        fcou(3,kc,ic) = ccou(3,jc,ic)*exp(-fact)
        fcou(1:2,kc,ic) = ccou(1:2,jc,ic)
      endif
    enddo
    mic(ic) = kc
  enddo
  !
end subroutine attenuate_clean
